/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/labels","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],J=function($){for(var e=[],v=0,D=$.length;v<D;v++)e[v]=Q[$[v]];return e};define(Q[104],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(D,M){if(!D)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=v}),define(Q[46],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(r){return(I,d,f)=>{let y=null,E=null;if(typeof f.value=="function"?(y="value",E=f.value):typeof f.get=="function"&&(y="get",E=f.get),!E)throw new Error("not supported");f[y]=r(E,d)}}e.createDecorator=v;function D(r,I,d){let f=null,y=null;if(typeof d.value=="function"?(f="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(f="get",y=d.get),!y)throw new Error("not supported");const E=`$memoize$${I}`;d[f]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,m)}),this[E]}}e.memoize=D;function M(r,I,d){return v((f,y)=>{const E=`$debounce$${y}`,m=`$debounce$result$${y}`;return function(...p){this[m]||(this[m]=d?d():void 0),clearTimeout(this[E]),I&&(this[m]=I(this[m],...p),p=[this[m]]),this[E]=setTimeout(()=>{f.apply(this,p),this[m]=d?d():void 0},r)}})}e.debounce=M;function C(r,I,d){return v((f,y)=>{const E=`$throttle$timer$${y}`,m=`$throttle$result$${y}`,p=`$throttle$lastRun$${y}`,t=`$throttle$pending$${y}`;return function(...w){if(this[m]||(this[m]=d?d():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...w)),this[t])return;const b=this[p]+r;b<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0},b-Date.now()))}})}e.throttle=C}),define(Q[16],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(c=>{c(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=v,e.errorHandler=new v;function D(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=D;function M(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=M;function C(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=C;function r(l){if(l instanceof Error){let{name:s,message:c}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:s,message:c,stack:i}}return l}e.transformErrorForSerialization=r;const I="Canceled";function d(l){return l instanceof Error&&l.name===I&&l.message===I}e.isPromiseCanceledError=d;class f extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=f;function y(){const l=new Error(I);return l.name=l.message,l}e.canceled=y;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=m;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(l){const s=new Error(`${l} has been disposed`);return s.name="DISPOSED",s}e.disposed=t;function w(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=w;class b extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=b;class S extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=S;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function u(l){const s=l;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=u;function a(l,s=Object.create(null)){const c=new Error(l);return s.actions&&(c.actions=s.actions),c}e.createErrorWithActions=a}),define(Q[30],J([0,1,16]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(F,A=0){return F[F.length-(1+A)]}e.tail=D;function M(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=M;function C(F,A,W=(B,Y)=>B===Y){if(F===A)return!0;if(!F||!A||F.length!==A.length)return!1;for(let B=0,Y=F.length;B<Y;B++)if(!W(F[B],A[B]))return!1;return!0}e.equals=C;function r(F,A,W){let B=0,Y=F.length-1;for(;B<=Y;){const x=(B+Y)/2|0,z=W(F[x],A);if(z<0)B=x+1;else if(z>0)Y=x-1;else return x}return-(B+1)}e.binarySearch=r;function I(F,A){let W=0,B=F.length;if(B===0)return 0;for(;W<B;){const Y=Math.floor((W+B)/2);A(F[Y])?B=Y:W=Y+1}return W}e.findFirstInSorted=I;function d(F,A,W){if(F=F|0,F>=A.length)throw new TypeError("invalid index");let B=A[Math.floor(A.length*Math.random())],Y=[],x=[],z=[];for(let X of A){const ie=W(X,B);ie<0?Y.push(X):ie>0?x.push(X):z.push(X)}return F<Y.length?d(F,Y,W):F<Y.length+z.length?z[0]:d(F-(Y.length+z.length),x,W)}e.quickSelect=d;function f(F,A){const W=[];let B;for(const Y of F.slice(0).sort(A))!B||A(B[0],Y)!==0?(B=[Y],W.push(B)):B.push(Y);return W}e.groupBy=f;function y(F,A,W){const B=[];function Y(X,ie,re){if(ie===0&&re.length===0)return;const se=B[B.length-1];se&&se.start+se.deleteCount===X?(se.deleteCount+=ie,se.toInsert.push(...re)):B.push({start:X,deleteCount:ie,toInsert:re})}let x=0,z=0;for(;;){if(x===F.length){Y(x,0,A.slice(z));break}if(z===A.length){Y(x,F.length-x,[]);break}const X=F[x],ie=A[z],re=W(X,ie);re===0?(x+=1,z+=1):re<0?(Y(x,1,[]),x+=1):re>0&&(Y(x,0,[ie]),z+=1)}return B}e.sortedDiff=y;function E(F,A,W){const B=y(F,A,W),Y=[],x=[];for(const z of B)Y.push(...F.slice(z.start,z.start+z.deleteCount)),x.push(...z.toInsert);return{removed:Y,added:x}}e.delta=E;function m(F,A,W){if(W===0)return[];const B=F.slice(0,W).sort(A);return t(F,A,B,W,F.length),B}e.top=m;function p(F,A,W,B,Y){return W===0?Promise.resolve([]):new Promise((x,z)=>{(async()=>{const X=F.length,ie=F.slice(0,W).sort(A);for(let re=W,se=Math.min(W+B,X);re<X;re=se,se=Math.min(se+B,X)){if(re>W&&await new Promise(Z=>setTimeout(Z)),Y&&Y.isCancellationRequested)throw(0,v.canceled)();t(F,A,ie,re,se)}return ie})().then(x,z)})}e.topAsync=p;function t(F,A,W,B,Y){for(const x=W.length;B<Y;B++){const z=F[B];if(A(z,W[x-1])<0){W.pop();const X=I(W,ie=>A(z,ie)<0);W.splice(X,0,z)}}}function w(F){return F.filter(A=>!!A)}e.coalesce=w;function b(F){let A=0;for(let W=0;W<F.length;W++)F[W]&&(F[A]=F[W],A+=1);F.length=A}e.coalesceInPlace=b;function S(F,A,W){F.splice(W,0,F.splice(A,1)[0])}e.move=S;function P(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=P;function u(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=u;function a(F,A=W=>W){const W=new Set;return F.filter(B=>{const Y=A(B);return W.has(Y)?!1:(W.add(Y),!0)})}e.distinct=a;function l(F){const A=Object.create(null);return W=>{const B=F(W);return A[B]?!1:(A[B]=!0,!0)}}e.uniqueFilter=l;function s(F,A){const W=c(F,A);if(W!==-1)return F[W]}e.findLast=s;function c(F,A){for(let W=F.length-1;W>=0;W--){const B=F[W];if(A(B))return W}return-1}e.lastIndex=c;function i(F,A){return F.length>0?F[0]:A}e.firstOrDefault=i;function n(F,A,W=(B,Y)=>B===Y){let B=0;for(let Y=0,x=Math.min(F.length,A.length);Y<x&&W(F[Y],A[Y]);Y++)B++;return B}e.commonPrefixLength=n;function o(F){return[].concat(...F)}e.flatten=o;function h(F,A){let W=typeof A=="number"?F:0;typeof A=="number"?W=F:(W=0,A=F);const B=[];if(W<=A)for(let Y=W;Y<A;Y++)B.push(Y);else for(let Y=W;Y>A;Y--)B.push(Y);return B}e.range=h;function g(F,A,W){return F.reduce((B,Y)=>(B[A(Y)]=W?W(Y):Y,B),Object.create(null))}e.index=g;function k(F,A){return F.push(A),()=>L(F,A)}e.insert=k;function L(F,A){const W=F.indexOf(A);if(W>-1)return F.splice(W,1),A}e.remove=L;function R(F,A,W){const B=F.slice(0,A),Y=F.slice(A);return B.concat(W,Y)}e.arrayInsert=R;function O(F,A){let W;if(typeof A=="number"){let B=A;W=()=>{const Y=Math.sin(B++)*179426549;return Y-Math.floor(Y)}}else W=Math.random;for(let B=F.length-1;B>0;B-=1){const Y=Math.floor(W()*(B+1)),x=F[B];F[B]=F[Y],F[Y]=x}}e.shuffle=O;function V(F,A){const W=F.indexOf(A);W>-1&&(F.splice(W,1),F.unshift(A))}e.pushToStart=V;function ee(F,A){const W=F.indexOf(A);W>-1&&(F.splice(W,1),F.push(A))}e.pushToEnd=ee;function oe(F,A){return Array.isArray(F)?F.map(A):A(F)}e.mapArrayOrNot=oe;function ae(F){return Array.isArray(F)?F:[F]}e.asArray=ae;function K(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=K;function T(F,A){for(const W of F){const B=A(W);if(B!==void 0)return B}}e.mapFind=T;function N(F,A,W){const B=q(F,A),Y=F.length,x=W.length;F.length=Y+x;for(let z=Y-1;z>=B;z--)F[z+x]=F[z];for(let z=0;z<x;z++)F[z+B]=W[z]}e.insertInto=N;function G(F,A,W,B){const Y=q(F,A),x=F.splice(Y,W);return N(F,Y,B),x}e.splice=G;function q(F,A){return A<0?Math.max(A+F.length,0):Math.min(A,F.length)}function _(F,A){let W=Number.MAX_SAFE_INTEGER,B=0;return F.forEach((Y,x)=>{const z=A(Y);z<W&&(W=z,B=x)}),B}e.minIndex=_;function U(F,A){let W=Number.MIN_SAFE_INTEGER,B=0;return F.forEach((Y,x)=>{const z=A(Y);z>W&&(W=z,B=x)}),B}e.maxIndex=U;class j{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let W=this.firstIdx;for(;W<this.items.length&&A(this.items[W]);)W++;const B=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,B}takeFromEndWhile(A){let W=this.lastIdx;for(;W>=0&&A(this.items[W]);)W--;const B=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,B}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const W=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,W}}e.ArrayQueue=j}),define(Q[42],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(D){const M=this;let C=!1,r;return function(){return C||(C=!0,r=D.apply(M,arguments)),r}}e.once=v}),define(Q[69],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(D){function M(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}D.is=M;const C=Object.freeze([]);function r(){return C}D.empty=r;function*I(l){yield l}D.single=I;function d(l){return l||C}D.from=d;function f(l){return!l||l[Symbol.iterator]().next().done===!0}D.isEmpty=f;function y(l){return l[Symbol.iterator]().next().value}D.first=y;function E(l,s){for(const c of l)if(s(c))return!0;return!1}D.some=E;function m(l,s){for(const c of l)if(s(c))return c}D.find=m;function*p(l,s){for(const c of l)s(c)&&(yield c)}D.filter=p;function*t(l,s){let c=0;for(const i of l)yield s(i,c++)}D.map=t;function*w(...l){for(const s of l)for(const c of s)yield c}D.concat=w;function*b(l){for(const s of l)for(const c of s)yield c}D.concatNested=b;function S(l,s,c){let i=c;for(const n of l)i=s(i,n);return i}D.reduce=S;function*P(l,s,c=l.length){for(s<0&&(s+=l.length),c<0?c+=l.length:c>l.length&&(c=l.length);s<c;s++)yield l[s]}D.slice=P;function u(l,s=Number.POSITIVE_INFINITY){const c=[];if(s===0)return[c,l];const i=l[Symbol.iterator]();for(let n=0;n<s;n++){const o=i.next();if(o.done)return[c,D.empty()];c.push(o.value)}return[c,{[Symbol.iterator](){return i}}]}D.consume=u;function a(l,s,c=(i,n)=>i===n){const i=l[Symbol.iterator](),n=s[Symbol.iterator]();for(;;){const o=i.next(),h=n.next();if(o.done!==h.done)return!1;if(o.done)return!0;if(!c(o.value,h.value))return!1}}D.equals=a})(v=e.Iterable||(e.Iterable={}))}),define(Q[39],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(s){s.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function r(s,c=!1){let i=0,n=s.length,o="",h=0,g=16,k=0;function L(K){let T=0,N=0;for(;T<K;){const G=s.charCodeAt(i);if(G>=48&&G<=57)N=N*16+G-48;else if(G>=65&&G<=70)N=N*16+G-65+10;else if(G>=97&&G<=102)N=N*16+G-97+10;else break;i++,T++}return T<K&&(N=-1),N}function R(K){i=K,o="",h=0,g=16,k=0}function O(){const K=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&f(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&f(s.charCodeAt(i)))for(i++;i<s.length&&f(s.charCodeAt(i));)i++;else return k=3,s.substring(K,i);let T=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&f(s.charCodeAt(i))){for(i++;i<s.length&&f(s.charCodeAt(i));)i++;T=i}else k=3;return s.substring(K,T)}function V(){let K="",T=i;for(;;){if(i>=n){K+=s.substring(T,i),k=2;break}const N=s.charCodeAt(i);if(N===34){K+=s.substring(T,i),i++;break}if(N===92){if(K+=s.substring(T,i),i++,i>=n){k=2;break}switch(s.charCodeAt(i++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const q=L(4);q>=0?K+=String.fromCharCode(q):k=4;break;default:k=5}T=i;continue}if(N>=0&&N<=31)if(d(N)){K+=s.substring(T,i),k=2;break}else k=6;i++}return K}function ee(){if(o="",k=0,h=i,i>=n)return h=n,g=17;let K=s.charCodeAt(i);if(I(K)){do i++,o+=String.fromCharCode(K),K=s.charCodeAt(i);while(I(K));return g=15}if(d(K))return i++,o+=String.fromCharCode(K),K===13&&s.charCodeAt(i)===10&&(i++,o+=`
`),g=14;switch(K){case 123:return i++,g=1;case 125:return i++,g=2;case 91:return i++,g=3;case 93:return i++,g=4;case 58:return i++,g=6;case 44:return i++,g=5;case 34:return i++,o=V(),g=10;case 47:const T=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<n&&!d(s.charCodeAt(i));)i++;return o=s.substring(T,i),g=12}if(s.charCodeAt(i+1)===42){i+=2;const N=n-1;let G=!1;for(;i<N;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,k=1),o=s.substring(T,i),g=13}return o+=String.fromCharCode(K),i++,g=16;case 45:if(o+=String.fromCharCode(K),i++,i===n||!f(s.charCodeAt(i)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),g=11;default:for(;i<n&&oe(K);)i++,K=s.charCodeAt(i);if(h!==i){switch(o=s.substring(h,i),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(K),i++,g=16}}function oe(K){if(I(K)||d(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let K;do K=ee();while(K>=12&&K<=15);return K}return{setPosition:R,getPosition:()=>i,scan:c?ae:ee,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>i-h,getTokenError:()=>k}}e.createScanner=r;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function d(s){return s===10||s===13||s===8232||s===8233}function f(s){return s>=48&&s<=57}var y;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(y||(y={}));function E(s,c){const i=[],n=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function k(L,R,O,V){h.value=L,h.offset=R,h.length=O,h.type=V,h.colonOffset=void 0,o=h}try{u(s,{onObjectBegin:(L,R)=>{if(c<=L)throw n;o=void 0,g=c>L,i.push("")},onObjectProperty:(L,R,O)=>{if(c<R||(k(L,R,O,"property"),i[i.length-1]=L,c<=R+O))throw n},onObjectEnd:(L,R)=>{if(c<=L)throw n;o=void 0,i.pop()},onArrayBegin:(L,R)=>{if(c<=L)throw n;o=void 0,i.push(0)},onArrayEnd:(L,R)=>{if(c<=L)throw n;o=void 0,i.pop()},onLiteralValue:(L,R,O)=>{if(c<R||(k(L,R,O,l(L)),c<=R+O))throw n},onSeparator:(L,R,O)=>{if(c<=R)throw n;if(L===":"&&o&&o.type==="property")o.colonOffset=R,g=!1,o=void 0;else if(L===","){const V=i[i.length-1];typeof V=="number"?i[i.length-1]=V+1:(g=!0,i[i.length-1]=""),o=void 0}}})}catch(L){if(L!==n)throw L}return{path:i,previousNode:o,isAtPropertyKey:g,matches:L=>{let R=0;for(let O=0;R<L.length&&O<i.length;O++)if(L[R]===i[O]||L[R]==="*")R++;else if(L[R]!=="**")return!1;return R===L.length}}}e.getLocation=E;function m(s,c=[],i=C.DEFAULT){let n=null,o=[];const h=[];function g(L){Array.isArray(o)?o.push(L):n!==null&&(o[n]=L)}return u(s,{onObjectBegin:()=>{const L={};g(L),h.push(o),o=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const L=[];g(L),h.push(o),o=L,n=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:g,onError:(L,R,O)=>{c.push({error:L,offset:R,length:O})}},i),o[0]}e.parse=m;function p(s,c=[],i=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(L){n.type==="property"&&(n.length=L-n.offset,n=n.parent)}function h(L){return n.children.push(L),L}u(s,{onObjectBegin:L=>{n=h({type:"object",offset:L,length:-1,parent:n,children:[]})},onObjectProperty:(L,R,O)=>{n=h({type:"property",offset:R,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:L,offset:R,length:O,parent:n})},onObjectEnd:(L,R)=>{n.length=L+R-n.offset,n=n.parent,o(L+R)},onArrayBegin:(L,R)=>{n=h({type:"array",offset:L,length:-1,parent:n,children:[]})},onArrayEnd:(L,R)=>{n.length=L+R-n.offset,n=n.parent,o(L+R)},onLiteralValue:(L,R,O)=>{h({type:l(L),offset:R,length:O,parent:n,value:L}),o(R+O)},onSeparator:(L,R,O)=>{n.type==="property"&&(L===":"?n.colonOffset=R:L===","&&o(R))},onError:(L,R,O)=>{c.push({error:L,offset:R,length:O})}},i);const k=n.children[0];return k&&delete k.parent,k}e.parseTree=p;function t(s,c){if(!s)return;let i=s;for(let n of c)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const h of i.children)if(Array.isArray(h.children)&&h.children[0].value===n){i=h.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=t;function w(s){if(!s.parent||!s.parent.children)return[];const c=w(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;c.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&c.push(i)}return c}e.getNodePath=w;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":const c=Object.create(null);for(let i of s.children){const n=i.children[1];n&&(c[i.children[0].value]=b(n))}return c;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=b;function S(s,c,i=!1){return c>=s.offset&&c<s.offset+s.length||i&&c===s.offset+s.length}e.contains=S;function P(s,c,i=!1){if(S(s,c,i)){const n=s.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=c;o++){const h=P(n[o],c,i);if(h)return h}return s}}e.findNodeAtOffset=P;function u(s,c,i=C.DEFAULT){const n=r(s,!1);function o(W){return W?()=>W(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(W){return W?B=>W(B,n.getTokenOffset(),n.getTokenLength()):()=>!0}const g=o(c.onObjectBegin),k=h(c.onObjectProperty),L=o(c.onObjectEnd),R=o(c.onArrayBegin),O=o(c.onArrayEnd),V=h(c.onLiteralValue),ee=h(c.onSeparator),oe=o(c.onComment),ae=h(c.onError),K=i&&i.disallowComments,T=i&&i.allowTrailingComma;function N(){for(;;){const W=n.scan();switch(n.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:K||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(W){case 12:case 13:K?G(10):oe();break;case 16:G(1);break;case 15:case 14:break;default:return W}}}function G(W,B=[],Y=[]){if(ae(W),B.length+Y.length>0){let x=n.getToken();for(;x!==17;){if(B.indexOf(x)!==-1){N();break}else if(Y.indexOf(x)!==-1)break;x=N()}}}function q(W){const B=n.getTokenValue();return W?V(B):k(B),N(),!0}function _(){switch(n.getToken()){case 11:let W=0;try{W=JSON.parse(n.getTokenValue()),typeof W!="number"&&(G(2),W=0)}catch(B){G(2)}V(W);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return N(),!0}function U(){return n.getToken()!==10?(G(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(ee(":"),N(),A()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function j(){g(),N();let W=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(W||G(4,[],[]),ee(","),N(),n.getToken()===2&&T)break}else W&&G(6,[],[]);U()||G(4,[],[2,5]),W=!0}return L(),n.getToken()!==2?G(7,[2],[]):N(),!0}function F(){R(),N();let W=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(W||G(4,[],[]),ee(","),N(),n.getToken()===4&&T)break}else W&&G(6,[],[]);A()||G(4,[],[4,5]),W=!0}return O(),n.getToken()!==4?G(8,[4],[]):N(),!0}function A(){switch(n.getToken()){case 3:return F();case 1:return j();case 10:return q(!0);default:return _()}}return N(),n.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):A()?(n.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=u;function a(s,c){let i=r(s),n=[],o,h=0,g;do switch(g=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:h!==g&&n.push(s.substring(h,g)),c!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,c)),h=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=a;function l(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(Q[105],J([0,1,39]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(d,f,y){let E,m,p,t,w;if(f){for(t=f.offset,w=t+f.length,p=t;p>0&&!I(d,p-1);)p--;let h=w;for(;h<d.length&&!I(d,h);)h++;m=d.substring(p,h),E=C(m,y)}else m=d,E=0,p=0,t=0,w=d.length;const b=r(y,d);let S=!1,P=0,u;y.insertSpaces?u=M(" ",y.tabSize||4):u="	";const a=(0,v.createScanner)(m,!1);let l=!1;function s(){return b+M(u,E+P)}function c(){let h=a.scan();for(S=!1;h===15||h===14;)S=S||h===14,h=a.scan();return l=h===16||a.getTokenError()!==0,h}const i=[];function n(h,g,k){!l&&g<w&&k>t&&d.substring(g,k)!==h&&i.push({offset:g,length:k-g,content:h})}let o=c();if(o!==17){const h=a.getTokenOffset()+p,g=M(u,E);n(g,p,h)}for(;o!==17;){let h=a.getTokenOffset()+a.getTokenLength()+p,g=c(),k="";for(;!S&&(g===12||g===13);){const R=a.getTokenOffset()+p;n(" ",h,R),h=a.getTokenOffset()+a.getTokenLength()+p,k=g===12?s():"",g=c()}if(g===2)o!==1&&(P--,k=s());else if(g===4)o!==3&&(P--,k=s());else{switch(o){case 3:case 1:P++,k=s();break;case 5:case 12:k=s();break;case 13:S?k=s():k=" ";break;case 6:k=" ";break;case 10:if(g===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?k=" ":g!==5&&g!==17&&(l=!0);break;case 16:l=!0;break}S&&(g===12||g===13)&&(k=s())}const L=a.getTokenOffset()+p;n(k,h,L),o=g}return i}e.format=D;function M(d,f){let y="";for(let E=0;E<f;E++)y+=d;return y}function C(d,f){let y=0,E=0;const m=f.tabSize||4;for(;y<d.length;){const p=d.charAt(y);if(p===" ")E++;else if(p==="	")E+=m;else break;y++}return Math.floor(E/m)}function r(d,f){for(let y=0;y<f.length;y++){const E=f.charAt(y);if(E==="\r")return y+1<f.length&&f.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=r;function I(d,f){return`\r
`.indexOf(d.charAt(f))!==-1}e.isEOL=I}),define(Q[78],J([0,1,39,105]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(f,y,E){return C(f,y,void 0,E)}e.removeProperty=M;function C(f,y,E,m,p){const t=y.slice(),w=[],b=(0,v.parseTree)(f,w);let S,P;for(;t.length>0&&(P=t.pop(),S=(0,v.findNodeAtLocation)(b,t),S===void 0&&E!==void 0);)typeof P=="string"?E={[P]:E}:E=[E];if(S)if(S.type==="object"&&typeof P=="string"&&Array.isArray(S.children)){const u=(0,v.findNodeAtLocation)(S,[P]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const a=S.children.indexOf(u.parent);let l,s=u.parent.offset+u.parent.length;if(a>0){const c=S.children[a-1];l=c.offset+c.length}else l=S.offset+1,S.children.length>1&&(s=S.children[1].offset);return r(f,{offset:l,length:s-l,content:""},m)}else return r(f,{offset:u.offset,length:u.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(E)}`,l=p?p(S.children.map(c=>c.children[0].value)):S.children.length;let s;if(l>0){const c=S.children[l-1];s={offset:c.offset+c.length,length:0,content:","+a}}else S.children.length===0?s={offset:S.offset+1,length:0,content:a}:s={offset:S.offset+1,length:0,content:a+","};return r(f,s,m)}}else if(S.type==="array"&&typeof P=="number"&&Array.isArray(S.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let a;if(S.children.length===0||P===0)a={offset:S.offset+1,length:0,content:S.children.length===0?u:u+","};else{const l=P===-1||P>S.children.length?S.children.length:P,s=S.children[l-1];a={offset:s.offset+s.length,length:0,content:","+u}}return r(f,a,m)}else{const u=P,a=S.children[u];let l;if(S.children.length===1)l={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===u){const s=S.children[u-1],c=s.offset+s.length,i=S.offset+S.length;l={offset:c,length:i-2-c,content:""}}else l={offset:a.offset,length:S.children[u+1].offset-a.offset,content:""};return r(f,l,m)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${S.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return r(f,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},m)}}e.setProperty=C;function r(f,y,E){let m=I(f,y),p=y.offset,t=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;p>0&&!(0,D.isEOL)(m,p-1);)p--;for(;t<m.length&&!(0,D.isEOL)(m,t);)t++}const w=(0,D.format)(m,{offset:p,length:t-p},E);for(let S=w.length-1;S>=0;S--){const P=w[S];m=I(m,P),p=Math.min(p,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const b=f.length-(m.length-t)-p;return[{offset:p,length:b,content:m.substring(p,t)}]}e.withFormatting=r;function I(f,y){return f.substring(0,y.offset)+y.content+f.substring(y.offset+y.length)}e.applyEdit=I;function d(f,y){let E=y.slice(0).sort((p,t)=>{const w=p.offset-t.offset;return w===0?p.length-t.length:w}),m=f.length;for(let p=E.length-1;p>=0;p--){let t=E[p];if(t.offset+t.length<=m)f=I(f,t);else throw new Error("Overlapping edit");m=t.offset}return f}e.applyEdits=d}),define(Q[79],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var v;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(v=e.KeyCode||(e.KeyCode={}));var D;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(D=e.ScanCode||(e.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,b){this._keyCodeToStr[w]=b,this._strToKeyCode[b.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const C=new M,r=new M,I=new M;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],f=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>y[t]||0,toEnum:t=>f[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let b=[],S=[];for(const P of w){const[u,a,l,s,c,i,n,o,h,g]=P;if(S[l]||(S[l]=!0,d[l]=s,f[s]=l,y[s.toLowerCase()]=l,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=c,c!==0&&c!==3&&c!==5&&c!==4&&c!==6&&c!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[c]=l))),!b[c]){if(b[c]=!0,!i)throw new Error(`String representation missing for key code ${c} around scan code ${s}`);C.define(c,i),r.define(c,h||i),I.define(c,g||h||i)}n&&(e.EVENT_KEY_CODE_MAP[n]=c),o&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=c)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function w(l){return C.keyCodeToStr(l)}t.toString=w;function b(l){return C.strToKeyCode(l)}t.fromString=b;function S(l){return r.keyCodeToStr(l)}t.toUserSettingsUS=S;function P(l){return I.keyCodeToStr(l)}t.toUserSettingsGeneral=P;function u(l){return r.strToKeyCode(l)||I.strToKeyCode(l)}t.fromUserSettings=u;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(l)}t.toElectronAccelerator=a})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(m=e.KeyMod||(e.KeyMod={}));function p(t,w){const b=(w&65535)<<16>>>0;return(t|b)>>>0}e.KeyChord=p}),define(Q[59],J([0,1,16]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var D;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(D||(D={}));function M(E,m){if(E===0)return null;const p=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new I([C(p,m),C(t,m)]):new I([C(p,m)])}e.createKeybinding=M;function C(E,m){const p=!!(E&2048),t=!!(E&256),w=m===2?t:p,b=!!(E&1024),S=!!(E&512),P=m===2?p:t,u=E&255;return new r(w,b,S,P,u)}e.createSimpleKeybinding=C;class r{constructor(m,p,t,w,b){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.keyCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.keyCode===m.keyCode}getHashCode(){const m=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",w=this.metaKey?"1":"0";return`${m}${p}${t}${w}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=r;class I{constructor(m){if(m.length===0)throw(0,v.illegalArgument)("parts");this.parts=m}getHashCode(){let m="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(m+=";"),m+=this.parts[p].getHashCode();return m}equals(m){if(m===null||this.parts.length!==m.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(m.parts[p]))return!1;return!0}}e.ChordKeybinding=I;class d{constructor(m,p,t,w,b){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.scanCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.scanCode===m.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class f{constructor(m,p,t,w,b,S){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.keyLabel=b,this.keyAriaLabel=S}}e.ResolvedKeybindingPart=f;class y{}e.ResolvedKeybinding=y}),define(Q[106],J([0,1,79,59]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class M{static _readModifiers(r){r=r.toLowerCase().trim();let I=!1,d=!1,f=!1,y=!1,E;do E=!1,/^ctrl(\+|\-)/.test(r)&&(I=!0,r=r.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(r)&&(d=!0,r=r.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(r)&&(f=!0,r=r.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(r)&&(y=!0,r=r.substr("meta-".length),E=!0),/^win(\+|\-)/.test(r)&&(y=!0,r=r.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(r)&&(y=!0,r=r.substr("cmd-".length),E=!0);while(E);let m;const p=r.indexOf(" ");return p>0?(m=r.substring(0,p),r=r.substring(p)):(m=r,r=""),{remains:r,ctrl:I,shift:d,alt:f,meta:y,key:m}}static parseSimpleKeybinding(r){const I=this._readModifiers(r),d=v.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,d),I.remains]}static parseKeybinding(r,I){if(!r)return null;const d=[];let f;do[f,r]=this.parseSimpleKeybinding(r),d.push(f);while(r.length>0);return new D.ChordKeybinding(d)}static parseSimpleUserBinding(r){const I=this._readModifiers(r),d=I.key.match(/^\[([^\]]+)\]$/);if(d){const y=d[1],E=v.ScanCodeUtils.lowerCaseToEnum(y);return[new D.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,E),I.remains]}const f=v.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseUserBinding(r){if(!r)return[];const I=[];let d;for(;r.length>0;)[d,r]=this.parseSimpleUserBinding(r),I.push(d);return I}}e.KeybindingParser=M}),define(Q[2],J([0,1,42,69]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let C=null;function r(n){C=n}if(e.setDisposableTracker=r,M){const n="__is_disposable_tracked__";r(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[n]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==P.None)try{o[n]=!0}catch{}}markAsDisposed(o){if(o&&o!==P.None)try{o[n]=!0}catch{}}markAsSingleton(o){}})}function I(n){return C?.trackDisposable(n),n}function d(n){C?.markAsDisposed(n)}function f(n,o){C?.setParent(n,o)}function y(n,o){if(!!C)for(const h of n)C.setParent(h,o)}function E(n){return C?.markAsSingleton(n),n}e.markAsSingleton=E;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function p(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=p;function t(n){if(D.Iterable.is(n)){let o=[];for(const h of n)if(h)try{h.dispose()}catch(g){o.push(g)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=t;function w(...n){const o=b(()=>t(n));return y(n,o),o}e.combinedDisposable=w;function b(n){const o=I({dispose:(0,v.once)(()=>{d(o),n()})});return o}e.toDisposable=b;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return f(o,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new S,I(this),f(this._store,this)}dispose(){d(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&f(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&f(o,null),o}}e.MutableDisposable=u;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(o,...h){let g=this.references.get(o);g||(g={counter:0,object:this.createReferencedObject(o,...h)},this.references.set(o,g));const{object:k}=g,L=(0,v.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(o,g.object),this.references.delete(o))});return g.counter++,{object:k,dispose:L}}}e.ReferenceCollection=l;class s{constructor(o){this.referenceCollection=o}async acquire(o,...h){const g=this.referenceCollection.acquire(o,...h);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(k){throw g.dispose(),k}}}e.AsyncReferenceCollection=s;class c{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=c;function i(n){const o=new S;try{n(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(Q[107],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class D{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const r=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=r}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,r){const I=new v(C);if(this._first===v.Undefined)this._first=I,this._last=I;else if(r){const f=this._last;this._last=I,I.prev=f,f.next=I}else{const f=this._first;this._first=I,I.next=f,f.prev=I}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(I))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const r=C.prev;r.next=C.next,C.next.prev=r}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=D}),function(){function $(M){const C=[];typeof M=="number"&&C.push("code/timeOrigin",M);function r(d){C.push(d,Date.now())}function I(){const d=[];for(let f=0;f<C.length;f+=2)d.push({name:C[f],startTime:C[f+1]});return d}return{mark:r,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const r of performance.getEntriesByType("mark"))C.push({name:r.name,startTime:Math.round(M+r.startTime)});return C}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function v(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=v(D))}(),define(Q[3],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let D=!1,M=!1,C=!1,r=!1,I=!1,d=!1,f=!1,y,E=v,m,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const w=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=w&&t?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,D=p.indexOf("Windows")>=0,M=p.indexOf("Macintosh")>=0,f=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,d=!0,y=navigator.language,E=y;else if(typeof t=="object"){D=t.platform==="win32",M=t.platform==="darwin",C=t.platform==="linux",r=C&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,y=v,E=v;const i=t.env.VSCODE_NLS_CONFIG;if(i)try{const n=JSON.parse(i),o=n.availableLanguages["*"];y=n.locale,E=o||v,m=n._translationsConfigFile}catch(n){}I=!0}else console.error("Unable to resolve platform.");var b;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function S(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let P=0;M?P=1:D?P=3:C&&(P=2),e.isWindows=D,e.isMacintosh=M,e.isLinux=C,e.isLinuxSnap=r,e.isNative=I,e.isWeb=d,e.isIOS=f,e.platform=P,e.userAgent=p,e.language=E;var u;(function(i){function n(){return e.language}i.value=n;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=o;function h(){return e.language==="en"}i.isDefault=h})(u=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=m,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let i=[];e.globals.addEventListener("message",o=>{if(o.data&&o.data.vscodeScheduleAsyncWork)for(let h=0,g=i.length;h<g;h++){const k=i[h];if(k.id===o.data.vscodeScheduleAsyncWork){i.splice(h,1),k.callback();return}}});let n=0;return o=>{const h=++n;i.push({id:h,callback:o}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return i=>setTimeout(i)})(),e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts)return e.setTimeout0;if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const n=Promise.resolve();return o=>n.then(o)}();var a;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||f?2:D?1:3;let l=!0,s=!1;function c(){if(!s){s=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,l=new Uint16Array(i.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=c}),define(Q[34],J([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let D;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const M=v.globals.vscode.process;D={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()},nextTick(C){return(0,v.setImmediate)(C)}}}else typeof process!="undefined"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(M){return process.nextTick(M)}}:D={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(M){return(0,v.setImmediate)(M)},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick,e.arch=D.arch}),define(Q[8],J([0,1,34]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,M=97,C=90,r=122,I=46,d=47,f=92,y=58,E=63;class m extends Error{constructor(a,l,s){let c;typeof l=="string"&&l.indexOf("not ")===0?(c="must not be",l=l.replace(/^not /,"")):c="must be";const i=a.indexOf(".")!==-1?"property":"argument";let n=`The "${a}" ${i} ${c} of type ${l}`;n+=`. Received type ${typeof s}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,a){if(typeof u!="string")throw new m(a,"string",u)}function t(u){return u===d||u===f}function w(u){return u===d}function b(u){return u>=D&&u<=C||u>=M&&u<=r}function S(u,a,l,s){let c="",i=0,n=-1,o=0,h=0;for(let g=0;g<=u.length;++g){if(g<u.length)h=u.charCodeAt(g);else{if(s(h))break;h=d}if(s(h)){if(!(n===g-1||o===1))if(o===2){if(c.length<2||i!==2||c.charCodeAt(c.length-1)!==I||c.charCodeAt(c.length-2)!==I){if(c.length>2){const k=c.lastIndexOf(l);k===-1?(c="",i=0):(c=c.slice(0,k),i=c.length-1-c.lastIndexOf(l)),n=g,o=0;continue}else if(c.length!==0){c="",i=0,n=g,o=0;continue}}a&&(c+=c.length>0?`${l}..`:"..",i=2)}else c.length>0?c+=`${l}${u.slice(n+1,g)}`:c=u.slice(n+1,g),i=g-n-1;n=g,o=0}else h===I&&o!==-1?++o:o=-1}return c}function P(u,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const l=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${s}`:`${l}${u}${s}`:s}e.win32={resolve(...u){let a="",l="",s=!1;for(let c=u.length-1;c>=-1;c--){let i;if(c>=0){if(i=u[c],p(i,"path"),i.length===0)continue}else a.length===0?i=v.cwd():(i=v.env[`=${a}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===f)&&(i=`${a}\\`));const n=i.length;let o=0,h="",g=!1;const k=i.charCodeAt(0);if(n===1)t(k)&&(o=1,g=!0);else if(t(k))if(g=!0,t(i.charCodeAt(1))){let L=2,R=L;for(;L<n&&!t(i.charCodeAt(L));)L++;if(L<n&&L!==R){const O=i.slice(R,L);for(R=L;L<n&&t(i.charCodeAt(L));)L++;if(L<n&&L!==R){for(R=L;L<n&&!t(i.charCodeAt(L));)L++;(L===n||L!==R)&&(h=`\\\\${O}\\${i.slice(R,L)}`,o=L)}}}else o=1;else b(k)&&i.charCodeAt(1)===y&&(h=i.slice(0,2),o=2,n>2&&t(i.charCodeAt(2))&&(g=!0,o=3));if(h.length>0)if(a.length>0){if(h.toLowerCase()!==a.toLowerCase())continue}else a=h;if(s){if(a.length>0)break}else if(l=`${i.slice(o)}\\${l}`,s=g,g&&a.length>0)break}return l=S(l,!s,"\\",t),s?`${a}\\${l}`:`${a}${l}`||"."},normalize(u){p(u,"path");const a=u.length;if(a===0)return".";let l=0,s,c=!1;const i=u.charCodeAt(0);if(a===1)return w(i)?"\\":u;if(t(i))if(c=!0,t(u.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(u.charCodeAt(o));)o++;if(o<a&&o!==h){const g=u.slice(h,o);for(h=o;o<a&&t(u.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(u.charCodeAt(o));)o++;if(o===a)return`\\\\${g}\\${u.slice(h)}\\`;o!==h&&(s=`\\\\${g}\\${u.slice(h,o)}`,l=o)}}}else l=1;else b(i)&&u.charCodeAt(1)===y&&(s=u.slice(0,2),l=2,a>2&&t(u.charCodeAt(2))&&(c=!0,l=3));let n=l<a?S(u.slice(l),!c,"\\",t):"";return n.length===0&&!c&&(n="."),n.length>0&&t(u.charCodeAt(a-1))&&(n+="\\"),s===void 0?c?`\\${n}`:n:c?`${s}\\${n}`:`${s}${n}`},isAbsolute(u){p(u,"path");const a=u.length;if(a===0)return!1;const l=u.charCodeAt(0);return t(l)||a>2&&b(l)&&u.charCodeAt(1)===y&&t(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let a,l;for(let i=0;i<u.length;++i){const n=u[i];p(n,"path"),n.length>0&&(a===void 0?a=l=n:a+=`\\${n}`)}if(a===void 0)return".";let s=!0,c=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++c;const i=l.length;i>1&&t(l.charCodeAt(1))&&(++c,i>2&&(t(l.charCodeAt(2))?++c:s=!1))}if(s){for(;c<a.length&&t(a.charCodeAt(c));)c++;c>=2&&(a=`\\${a.slice(c)}`)}return e.win32.normalize(a)},relative(u,a){if(p(u,"from"),p(a,"to"),u===a)return"";const l=e.win32.resolve(u),s=e.win32.resolve(a);if(l===s||(u=l.toLowerCase(),a=s.toLowerCase(),u===a))return"";let c=0;for(;c<u.length&&u.charCodeAt(c)===f;)c++;let i=u.length;for(;i-1>c&&u.charCodeAt(i-1)===f;)i--;const n=i-c;let o=0;for(;o<a.length&&a.charCodeAt(o)===f;)o++;let h=a.length;for(;h-1>o&&a.charCodeAt(h-1)===f;)h--;const g=h-o,k=n<g?n:g;let L=-1,R=0;for(;R<k;R++){const V=u.charCodeAt(c+R);if(V!==a.charCodeAt(o+R))break;V===f&&(L=R)}if(R!==k){if(L===-1)return s}else{if(g>k){if(a.charCodeAt(o+R)===f)return s.slice(o+R+1);if(R===2)return s.slice(o+R)}n>k&&(u.charCodeAt(c+R)===f?L=R:R===2&&(L=3)),L===-1&&(L=0)}let O="";for(R=c+L+1;R<=i;++R)(R===i||u.charCodeAt(R)===f)&&(O+=O.length===0?"..":"\\..");return o+=L,O.length>0?`${O}${s.slice(o,h)}`:(s.charCodeAt(o)===f&&++o,s.slice(o,h))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const a=e.win32.resolve(u);if(a.length<=2)return u;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const l=a.charCodeAt(2);if(l!==E&&l!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===y&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return u},dirname(u){p(u,"path");const a=u.length;if(a===0)return".";let l=-1,s=0;const c=u.charCodeAt(0);if(a===1)return t(c)?u:".";if(t(c)){if(l=s=1,t(u.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(u.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&t(u.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(u.charCodeAt(o));)o++;if(o===a)return u;o!==h&&(l=s=o+1)}}}}else b(c)&&u.charCodeAt(1)===y&&(l=a>2&&t(u.charCodeAt(2))?3:2,s=l);let i=-1,n=!0;for(let o=a-1;o>=s;--o)if(t(u.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(l===-1)return".";i=l}return u.slice(0,i)},basename(u,a){a!==void 0&&p(a,"ext"),p(u,"path");let l=0,s=-1,c=!0,i;if(u.length>=2&&b(u.charCodeAt(0))&&u.charCodeAt(1)===y&&(l=2),a!==void 0&&a.length>0&&a.length<=u.length){if(a===u)return"";let n=a.length-1,o=-1;for(i=u.length-1;i>=l;--i){const h=u.charCodeAt(i);if(t(h)){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),n>=0&&(h===a.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return l===s?s=o:s===-1&&(s=u.length),u.slice(l,s)}for(i=u.length-1;i>=l;--i)if(t(u.charCodeAt(i))){if(!c){l=i+1;break}}else s===-1&&(c=!1,s=i+1);return s===-1?"":u.slice(l,s)},extname(u){p(u,"path");let a=0,l=-1,s=0,c=-1,i=!0,n=0;u.length>=2&&u.charCodeAt(1)===y&&b(u.charCodeAt(0))&&(a=s=2);for(let o=u.length-1;o>=a;--o){const h=u.charCodeAt(o);if(t(h)){if(!i){s=o+1;break}continue}c===-1&&(i=!1,c=o+1),h===I?l===-1?l=o:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||c===-1||n===0||n===1&&l===c-1&&l===s+1?"":u.slice(l,c)},format:P.bind(null,"\\"),parse(u){p(u,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return a;const l=u.length;let s=0,c=u.charCodeAt(0);if(l===1)return t(c)?(a.root=a.dir=u,a):(a.base=a.name=u,a);if(t(c)){if(s=1,t(u.charCodeAt(1))){let L=2,R=L;for(;L<l&&!t(u.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&t(u.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&!t(u.charCodeAt(L));)L++;L===l?s=L:L!==R&&(s=L+1)}}}}else if(b(c)&&u.charCodeAt(1)===y){if(l<=2)return a.root=a.dir=u,a;if(s=2,t(u.charCodeAt(2))){if(l===3)return a.root=a.dir=u,a;s=3}}s>0&&(a.root=u.slice(0,s));let i=-1,n=s,o=-1,h=!0,g=u.length-1,k=0;for(;g>=s;--g){if(c=u.charCodeAt(g),t(c)){if(!h){n=g+1;break}continue}o===-1&&(h=!1,o=g+1),c===I?i===-1?i=g:k!==1&&(k=1):i!==-1&&(k=-1)}return o!==-1&&(i===-1||k===0||k===1&&i===o-1&&i===n+1?a.base=a.name=u.slice(n,o):(a.name=u.slice(n,i),a.base=u.slice(n,o),a.ext=u.slice(i,o))),n>0&&n!==s?a.dir=u.slice(0,n-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let a="",l=!1;for(let s=u.length-1;s>=-1&&!l;s--){const c=s>=0?u[s]:v.cwd();p(c,"path"),c.length!==0&&(a=`${c}/${a}`,l=c.charCodeAt(0)===d)}return a=S(a,!l,"/",w),l?`/${a}`:a.length>0?a:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const a=u.charCodeAt(0)===d,l=u.charCodeAt(u.length-1)===d;return u=S(u,!a,"/",w),u.length===0?a?"/":l?"./":".":(l&&(u+="/"),a?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===d},join(...u){if(u.length===0)return".";let a;for(let l=0;l<u.length;++l){const s=u[l];p(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(u,a){if(p(u,"from"),p(a,"to"),u===a||(u=e.posix.resolve(u),a=e.posix.resolve(a),u===a))return"";const l=1,s=u.length,c=s-l,i=1,n=a.length-i,o=c<n?c:n;let h=-1,g=0;for(;g<o;g++){const L=u.charCodeAt(l+g);if(L!==a.charCodeAt(i+g))break;L===d&&(h=g)}if(g===o)if(n>o){if(a.charCodeAt(i+g)===d)return a.slice(i+g+1);if(g===0)return a.slice(i+g)}else c>o&&(u.charCodeAt(l+g)===d?h=g:g===0&&(h=0));let k="";for(g=l+h+1;g<=s;++g)(g===s||u.charCodeAt(g)===d)&&(k+=k.length===0?"..":"/..");return`${k}${a.slice(i+h)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const a=u.charCodeAt(0)===d;let l=-1,s=!0;for(let c=u.length-1;c>=1;--c)if(u.charCodeAt(c)===d){if(!s){l=c;break}}else s=!1;return l===-1?a?"/":".":a&&l===1?"//":u.slice(0,l)},basename(u,a){a!==void 0&&p(a,"ext"),p(u,"path");let l=0,s=-1,c=!0,i;if(a!==void 0&&a.length>0&&a.length<=u.length){if(a===u)return"";let n=a.length-1,o=-1;for(i=u.length-1;i>=0;--i){const h=u.charCodeAt(i);if(h===d){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),n>=0&&(h===a.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return l===s?s=o:s===-1&&(s=u.length),u.slice(l,s)}for(i=u.length-1;i>=0;--i)if(u.charCodeAt(i)===d){if(!c){l=i+1;break}}else s===-1&&(c=!1,s=i+1);return s===-1?"":u.slice(l,s)},extname(u){p(u,"path");let a=-1,l=0,s=-1,c=!0,i=0;for(let n=u.length-1;n>=0;--n){const o=u.charCodeAt(n);if(o===d){if(!c){l=n+1;break}continue}s===-1&&(c=!1,s=n+1),o===I?a===-1?a=n:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||s===-1||i===0||i===1&&a===s-1&&a===l+1?"":u.slice(a,s)},format:P.bind(null,"/"),parse(u){p(u,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return a;const l=u.charCodeAt(0)===d;let s;l?(a.root="/",s=1):s=0;let c=-1,i=0,n=-1,o=!0,h=u.length-1,g=0;for(;h>=s;--h){const k=u.charCodeAt(h);if(k===d){if(!o){i=h+1;break}continue}n===-1&&(o=!1,n=h+1),k===I?c===-1?c=h:g!==1&&(g=1):c!==-1&&(g=-1)}if(n!==-1){const k=i===0&&l?1:i;c===-1||g===0||g===1&&c===n-1&&c===i+1?a.base=a.name=u.slice(k,n):(a.name=u.slice(k,c),a.base=u.slice(k,n),a.ext=u.slice(c,n))}return i>0?a.dir=u.slice(0,i-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[80],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var D;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(C,...r){const I=r.reduce((y,E)=>(y[E]=!0,y),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(y=>!I[y]).forEach(y=>{for(let E=0;E<d.length;E++)if(y.search(d[E])!==-1){delete C[y];break}})}e.sanitizeProcessEnvironment=M}),define(Q[108],J([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=v.globals.performance&&typeof v.globals.performance.now=="function";class M{constructor(r){this._highResolution=D&&r,this._startTime=this._now(),this._stopTime=-1}static create(r=!0){return new M(r)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=M}),define(Q[4],J([0,1,16,42,2,107,108]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>M.Disposable.None;function l(T){return(N,G=null,q)=>{let _=!1,U;return U=T(j=>{if(!_)return U?U.dispose():_=!0,N.call(G,j)},null,q),_&&U.dispose(),U}}a.once=l;function s(T,N){return g((G,q=null,_)=>T(U=>G.call(q,N(U)),null,_))}a.map=s;function c(T,N){return g((G,q=null,_)=>T(U=>{N(U),G.call(q,U)},null,_))}a.forEach=c;function i(T,N){return g((G,q=null,_)=>T(U=>N(U)&&G.call(q,U),null,_))}a.filter=i;function n(T){return T}a.signal=n;function o(...T){return(N,G=null,q)=>(0,M.combinedDisposable)(...T.map(_=>_(U=>N.call(G,U),null,q)))}a.any=o;function h(T,N,G){let q=G;return s(T,_=>(q=N(q,_),q))}a.reduce=h;function g(T){let N;const G=new m({onFirstListenerAdd(){N=T(G.fire,G)},onLastListenerRemove(){N.dispose()}});return G.event}function k(T,N,G=100,q=!1,_){let U,j,F,A=0;const W=new m({leakWarningThreshold:_,onFirstListenerAdd(){U=T(B=>{A++,j=N(j,B),q&&!F&&(W.fire(j),j=void 0),clearTimeout(F),F=setTimeout(()=>{const Y=j;j=void 0,F=void 0,(!q||A>1)&&W.fire(Y),A=0},G)})},onLastListenerRemove(){U.dispose()}});return W.event}a.debounce=k;function L(T,N=(G,q)=>G===q){let G=!0,q;return i(T,_=>{const U=G||!N(_,q);return G=!1,q=_,U})}a.latch=L;function R(T,N){return[a.filter(T,N),a.filter(T,G=>!N(G))]}a.split=R;function O(T,N=!1,G=[]){let q=G.slice(),_=T(F=>{q?q.push(F):j.fire(F)});const U=()=>{q&&q.forEach(F=>j.fire(F)),q=null},j=new m({onFirstListenerAdd(){_||(_=T(F=>j.fire(F)))},onFirstListenerDidAdd(){q&&(N?setTimeout(U):U())},onLastListenerRemove(){_&&_.dispose(),_=null}});return j.event}a.buffer=O;class V{constructor(N){this.event=N}map(N){return new V(s(this.event,N))}forEach(N){return new V(c(this.event,N))}filter(N){return new V(i(this.event,N))}reduce(N,G){return new V(h(this.event,N,G))}latch(){return new V(L(this.event))}debounce(N,G=100,q=!1,_){return new V(k(this.event,N,G,q,_))}on(N,G,q){return this.event(N,G,q)}once(N,G,q){return l(this.event)(N,G,q)}}function ee(T){return new V(T)}a.chain=ee;function oe(T,N,G=q=>q){const q=(...F)=>j.fire(G(...F)),_=()=>T.on(N,q),U=()=>T.removeListener(N,q),j=new m({onFirstListenerAdd:_,onLastListenerRemove:U});return j.event}a.fromNodeEventEmitter=oe;function ae(T,N,G=q=>q){const q=(...F)=>j.fire(G(...F)),_=()=>T.addEventListener(N,q),U=()=>T.removeEventListener(N,q),j=new m({onFirstListenerAdd:_,onLastListenerRemove:U});return j.event}a.fromDOMEventEmitter=ae;function K(T){return new Promise(N=>l(T)(N))}a.toPromise=K})(I=e.Event||(e.Event={}));class d{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${d._idPool++}`}start(l){this._stopWatch=new r.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let f=-1;function y(a){const l=f;return f=a,{dispose(){f=l}}}e.setGlobalLeakWarningThreshold=y;class E{constructor(l,s=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let s=f;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||l<s)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(c)||0;if(this._stacks.set(c,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let n,o=0;for(const[h,g]of this._stacks)(!n||o<g)&&(n=h,o=g);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(n)}return()=>{const n=this._stacks.get(c)||0;this._stacks.set(c,n-1)}}}class m{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=f>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(l,s,c)=>{this._listeners||(this._listeners=new C.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(s?[l,s]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,s);const o=this._leakageMon?.check(this._listeners.size),h=(0,M.toDisposable)(()=>{o&&o(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return c instanceof M.DisposableStore?c.add(h):Array.isArray(c)&&c.push(h),h}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,c]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(i){(0,v.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class p extends m{async fireAsync(l,s,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[i,n]=this._asyncDeliveryQueue.shift(),o=[],h={...n,waitUntil:g=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");c&&(g=c(g,typeof i=="function"?i:i[0])),o.push(g)}};try{typeof i=="function"?i.call(void 0,h):i[0].call(i[1],h)}catch(g){(0,v.onUnexpectedError)(g);continue}Object.freeze(o),await Promise.allSettled(o).then(g=>{for(const k of g)k.status==="rejected"&&(0,v.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=p;class t extends m{constructor(l){super(l);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=t;class w extends t{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=w;class b extends m{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const s={event:l,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const c=()=>{this.hasListeners&&this.unhook(s);const i=this.events.indexOf(s);this.events.splice(i,1)};return(0,M.toDisposable)((0,D.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(s=>this.emitter.fire(s))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class P{constructor(){this.buffers=[]}wrapEvent(l){return(s,c,i)=>l(n=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>s.call(c,n)):s.call(c,n)},void 0,i)}bufferEvents(l){const s=[];this.buffers.push(s);const c=l();return this.buffers.pop(),s.forEach(i=>i()),c}}e.EventBufferer=P;class u{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=M.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(Q[23],J([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(I,d){const f=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(f)}}});var M;(function(I){function d(f){return f===I.None||f===I.Cancelled||f instanceof C?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(M=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class r{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=M.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=r}),define(Q[109],J([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(y){const E=this._icons.get(y.id);E?y.description?E.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const M=new D;e.iconRegistry=M;function C(f){return f?f.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=C;class r{constructor(y,E,m){this.id=y,this.definition=E,this.description=m,M.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=r,r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function I(f,y){const E=["codicon","codicon-"+f];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=I;var d;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function E(t){if(t instanceof r)return["codicon","codicon-"+t.id];const w=y.exec(t.id);if(!w)return E(r.error);let[,b,S]=w;const P=["codicon","codicon-"+b];return S&&P.push("codicon-modifier-"+S.substr(1)),P}f.asClassNameArray=E;function m(t){return E(t).join(" ")}f.asClassName=m;function p(t){return"."+E(t).join(".")}f.asCSSSelector=p})(d=e.CSSIcon||(e.CSSIcon={}))}),define(Q[60],J([0,1,16,2]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function M(u){const a=u;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=M;function C(u){const a=u;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function r(u,a){return new I(u,a)}e.newWriteableStream=r;class I{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let s;switch(a){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const c=s.indexOf(l);c>=0&&s.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(u,a){const l=[];let s;for(;(s=u.read())!==null;)l.push(s);return a(l)}e.consumeReadable=d;function f(u,a,l){const s=[];let c;for(;(c=u.read())!==null&&s.length<l;)s.push(c);return c===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof c!="undefined"){const i=c;return c=void 0,i}return u.read()}}}e.peekReadable=f;function y(u,a){return new Promise((l,s)=>{const c=[];E(u,{onData:i=>{a&&c.push(i)},onError:i=>{a?s(i):l(void 0)},onEnd:()=>{l(a?a(c):void 0)}})})}e.consumeStream=y;function E(u,a){u.on("error",l=>a.onError(l)),u.on("end",()=>a.onEnd()),u.on("data",l=>a.onData(l))}e.listenStream=E;function m(u,a){return new Promise((l,s)=>{const c=new D.DisposableStore,i=[],n=g=>{if(i.push(g),i.length>a)return c.dispose(),u.pause(),l({stream:u,buffer:i,ended:!1})},o=g=>s(g),h=()=>l({stream:u,buffer:i,ended:!0});c.add((0,D.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),c.add((0,D.toDisposable)(()=>u.removeListener("end",h))),u.on("end",h),c.add((0,D.toDisposable)(()=>u.removeListener("data",n))),u.on("data",n)})}e.peekStream=m;function p(u,a){const l=r(a);return l.end(u),l}e.toStream=p;function t(){const u=r(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function w(u){let a=!1;return{read:()=>a?null:(a=!0,u)}}e.toReadable=w;function b(u,a,l){const s=r(l);return E(u,{onData:c=>s.write(a.data(c)),onError:c=>s.error(a.error?a.error(c):c),onEnd:()=>s.end()}),s}e.transform=b;function S(u,a,l){let s=!1;return{read:()=>{const c=a.read();return s?c:(s=!0,c!==null?l([u,c]):u)}}}e.prefixedReadable=S;function P(u,a,l){let s=!1;const c=r(l);return E(a,{onData:i=>s?c.write(i):(s=!0,c.write(l([u,i]))),onError:i=>c.error(i),onEnd:()=>{s||(s=!0,c.write(u)),c.end()}}),c}e.prefixedStream=P}),define(Q[17],J([0,1,60]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined";let M,C;class r{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return D?new r(Buffer.allocUnsafe(n)):new r(new Uint8Array(n))}static wrap(n){return D&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new r(n)}static fromString(n,o){return!(o?.dontUseNodeBuffer||!1)&&D?new r(Buffer.from(n)):(M||(M=new TextEncoder),new r(M.encode(n)))}static concat(n,o){if(typeof o=="undefined"){o=0;for(let k=0,L=n.length;k<L;k++)o+=n[k].byteLength}const h=r.alloc(o);let g=0;for(let k=0,L=n.length;k<L;k++){const R=n[k];h.set(R,g),g+=R.byteLength}return h}toString(){return D?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(n,o){return new r(this.buffer.subarray(n,o))}set(n,o){n instanceof r?this.buffer.set(n.buffer,o):this.buffer.set(n,o)}readUInt32BE(n){return f(this.buffer,n)}writeUInt32BE(n,o){y(this.buffer,n,o)}readUInt32LE(n){return E(this.buffer,n)}writeUInt32LE(n,o){m(this.buffer,n,o)}readUInt8(n){return p(this.buffer,n)}writeUInt8(n,o){t(this.buffer,n,o)}}e.VSBuffer=r;function I(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}e.readUInt16LE=I;function d(i,n,o){i[o+0]=n&255,n=n>>>8,i[o+1]=n&255}e.writeUInt16LE=d;function f(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}e.readUInt32BE=f;function y(i,n,o){i[o+3]=n,n=n>>>8,i[o+2]=n,n=n>>>8,i[o+1]=n,n=n>>>8,i[o]=n}e.writeUInt32BE=y;function E(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}e.readUInt32LE=E;function m(i,n,o){i[o+0]=n&255,n=n>>>8,i[o+1]=n&255,n=n>>>8,i[o+2]=n&255,n=n>>>8,i[o+3]=n&255}e.writeUInt32LE=m;function p(i,n){return i[n]}e.readUInt8=p;function t(i,n,o){i[o]=n}e.writeUInt8=t;function w(i){return v.consumeReadable(i,n=>r.concat(n))}e.readableToBuffer=w;function b(i){return v.toReadable(i)}e.bufferToReadable=b;function S(i){return v.consumeStream(i,n=>r.concat(n))}e.streamToBuffer=S;async function P(i){return i.ended?r.concat(i.buffer):r.concat([...i.buffer,await S(i.stream)])}e.bufferedStreamToBuffer=P;function u(i){return v.toStream(i,n=>r.concat(n))}e.bufferToStream=u;function a(i){return v.transform(i,{data:n=>typeof n=="string"?r.fromString(n):r.wrap(n)},n=>r.concat(n))}e.streamToBufferReadableStream=a;function l(i){return v.newWriteableStream(n=>r.concat(n),i)}e.newWriteableBufferStream=l;function s(i,n){return v.prefixedReadable(i,n,o=>r.concat(o))}e.prefixedBufferReadable=s;function c(i,n){return v.prefixedStream(i,n,o=>r.concat(o))}e.prefixedBufferStream=c}),define(Q[25],J([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=D;const M=/{(\d+)}/g;function C(H,...ne){return ne.length===0?H:H.replace(M,function(ue,pe){const Ie=parseInt(pe,10);return isNaN(Ie)||Ie<0||Ie>=ne.length?ue:ne[Ie]})}e.format=C;const r=/{([^}]+)}/g;function I(H,ne){return H.replace(r,(ue,pe)=>ne[pe]??ue)}e.format2=I;function d(H){return H.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=d;function f(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function y(H,ne){let ue=0;const pe=ne.charCodeAt(0);for(let Ie=H.length-1;Ie>=0;Ie--)H.charCodeAt(Ie)===pe&&ue++;return ue}e.count=y;function E(H,ne,ue="\u2026"){return H.length<=ne?H:`${H.substr(0,ne)}${ue}`}e.truncate=E;function m(H,ne=" "){const ue=p(H,ne);return t(ue,ne)}e.trim=m;function p(H,ne){if(!H||!ne)return H;const ue=ne.length;if(ue===0||H.length===0)return H;let pe=0;for(;H.indexOf(ne,pe)===pe;)pe=pe+ue;return H.substring(pe)}e.ltrim=p;function t(H,ne){if(!H||!ne)return H;const ue=ne.length,pe=H.length;if(ue===0||pe===0)return H;let Ie=pe,Me=-1;for(;Me=H.lastIndexOf(ne,Ie-1),!(Me===-1||Me+ue!==Ie);){if(Me===0)return"";Ie=Me}return H.substring(0,Ie)}e.rtrim=t;function w(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function b(H){return H.replace(/\*/g,"")}e.stripWildcards=b;function S(H,ne,ue={}){if(!H)throw new Error("Cannot create regex from empty string");ne||(H=f(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let pe="";return ue.global&&(pe+="g"),ue.matchCase||(pe+="i"),ue.multiline&&(pe+="m"),ue.unicode&&(pe+="u"),new RegExp(H,pe)}e.createRegExp=S;function P(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function u(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function a(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=a;function l(H){return H.split(/\r\n|\r|\n/)}e.splitLines=l;function s(H){for(let ne=0,ue=H.length;ne<ue;ne++){const pe=H.charCodeAt(ne);if(pe!==32&&pe!==9)return ne}return-1}e.firstNonWhitespaceIndex=s;function c(H,ne=0,ue=H.length){for(let pe=ne;pe<ue;pe++){const Ie=H.charCodeAt(pe);if(Ie!==32&&Ie!==9)return H.substring(ne,pe)}return H.substring(ne,ue)}e.getLeadingWhitespace=c;function i(H,ne=H.length-1){for(let ue=ne;ue>=0;ue--){const pe=H.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.lastNonWhitespaceIndex=i;function n(H,ne){return H<ne?-1:H>ne?1:0}e.compare=n;function o(H,ne,ue=0,pe=H.length,Ie=0,Me=ne.length){for(;ue<pe&&Ie<Me;ue++,Ie++){let Oe=H.charCodeAt(ue),Ne=ne.charCodeAt(Ie);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Te=pe-ue,Fe=Me-Ie;return Te<Fe?-1:Te>Fe?1:0}e.compareSubstring=o;function h(H,ne){return g(H,ne,0,H.length,0,ne.length)}e.compareIgnoreCase=h;function g(H,ne,ue=0,pe=H.length,Ie=0,Me=ne.length){for(;ue<pe&&Ie<Me;ue++,Ie++){let Oe=H.charCodeAt(ue),Ne=ne.charCodeAt(Ie);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return o(H.toLowerCase(),ne.toLowerCase(),ue,pe,Ie,Me);k(Oe)&&(Oe-=32),k(Ne)&&(Ne-=32);const je=Oe-Ne;if(je!==0)return je}const Te=pe-ue,Fe=Me-Ie;return Te<Fe?-1:Te>Fe?1:0}e.compareSubstringIgnoreCase=g;function k(H){return H>=97&&H<=122}e.isLowerAsciiLetter=k;function L(H){return H>=65&&H<=90}e.isUpperAsciiLetter=L;function R(H,ne){return H.length===ne.length&&g(H,ne)===0}e.equalsIgnoreCase=R;function O(H,ne){const ue=ne.length;return ne.length>H.length?!1:g(H,ne,0,ue)===0}e.startsWithIgnoreCase=O;function V(H,ne){let ue,pe=Math.min(H.length,ne.length);for(ue=0;ue<pe;ue++)if(H.charCodeAt(ue)!==ne.charCodeAt(ue))return ue;return pe}e.commonPrefixLength=V;function ee(H,ne){let ue,pe=Math.min(H.length,ne.length);const Ie=H.length-1,Me=ne.length-1;for(ue=0;ue<pe;ue++)if(H.charCodeAt(Ie-ue)!==ne.charCodeAt(Me-ue))return ue;return pe}e.commonSuffixLength=ee;function oe(H){return 55296<=H&&H<=56319}e.isHighSurrogate=oe;function ae(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ae;function K(H,ne){return(H-55296<<10)+(ne-56320)+65536}e.computeCodePoint=K;function T(H,ne,ue){const pe=H.charCodeAt(ue);if(oe(pe)&&ue+1<ne){const Ie=H.charCodeAt(ue+1);if(ae(Ie))return K(pe,Ie)}return pe}e.getNextCodePoint=T;function N(H,ne){const ue=H.charCodeAt(ne-1);if(ae(ue)&&ne>1){const pe=H.charCodeAt(ne-2);if(oe(pe))return K(pe,ue)}return ue}function G(H,ne){const ue=ze.getInstance(),pe=ne,Ie=H.length,Me=T(H,Ie,ne);ne+=Me>=65536?2:1;let Te=ue.getGraphemeBreakType(Me);for(;ne<Ie;){const Fe=T(H,Ie,ne),Oe=ue.getGraphemeBreakType(Fe);if(We(Te,Oe))break;ne+=Fe>=65536?2:1,Te=Oe}return ne-pe}e.nextCharLength=G;function q(H,ne){const ue=ze.getInstance(),pe=ne,Ie=N(H,ne);ne-=Ie>=65536?2:1;let Me=ue.getGraphemeBreakType(Ie);for(;ne>0;){const Te=N(H,ne),Fe=ue.getGraphemeBreakType(Te);if(We(Fe,Me))break;ne-=Te>=65536?2:1,Me=Fe}return pe-ne}e.prevCharLength=q;function _(H,ne){const ue=ze.getInstance(),pe=H.length,Ie=ne,Me=T(H,pe,ne),Te=ue.getGraphemeBreakType(Me);ne+=Me>=65536?2:1;let Fe=Te;for(;ne<pe;){const Ne=T(H,pe,ne),je=ue.getGraphemeBreakType(Ne);if(We(Fe,je))break;ne+=Ne>=65536?2:1,Fe=je}const Oe=ne;for(ne=Ie,Fe=Te;ne>0;){const Ne=N(H,ne),je=ue.getGraphemeBreakType(Ne);if(We(je,Fe))break;ne-=Ne>=65536?2:1,Fe=je}return[ne,Oe]}function U(H,ne){return ne>0&&ae(H.charCodeAt(ne))?_(H,ne-1):_(H,ne)}e.getCharContainingOffset=U;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(H){return j.test(H)}e.containsRTL=F;const A=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function W(H){return A.test(H)}e.containsEmoji=W;const B=/^[\t\n\r\x20-\x7E]*$/;function Y(H){return B.test(H)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=x;function z(H){for(let ne=0,ue=H.length;ne<ue;ne++)if(X(H.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=z;function X(H){return H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=X;function ie(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129008||H>=129280&&H<=129535||H>=129648&&H<=129782}e.isEmojiImprecise=ie;function re(H,ne){if(H.length<ne)return H;const ue=/\b/g;let pe=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<ne);)pe=ue.lastIndex,ue.lastIndex+=1;return H.substring(pe).replace(/^\s/,"")}e.lcut=re;const se=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(H){return H&&(H=H.replace(se,""),H=H.replace(Z,""),H=H.replace(ce,"")),H}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function me(H){return he(H)?H.substr(1):H}e.stripUTF8BOM=me;function be(H,ne){if(!H||!ne||H.length<ne.length)return!1;const ue=ne.length,pe=H.toLowerCase();let Ie=0,Me=-1;for(;Ie<ue;){const Te=pe.indexOf(ne[Ie],Me+1);if(Te<0)return!1;Me=Te,Ie++}return!0}e.fuzzyContains=be;function de(H,ne=!1){return H?(ne&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=de;function fe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=fe;function Se(H,ne=1){if(ne===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),ne--;while(ne>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=Se;function Ce(H){const ne=90-65+1;return H=H%(2*ne),H<ne?String.fromCharCode(97+H):String.fromCharCode(65+H-ne)}e.singleLetterHash=Ce;function Re(H){return ze.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=Re;function We(H,ne){return H===0?ne!==5&&ne!==7:H===2&&ne===3?!1:H===4||H===2||H===3||ne===4||ne===2||ne===3?!0:!(H===8&&(ne===8||ne===9||ne===11||ne===12)||(H===11||H===9)&&(ne===9||ne===10)||(H===12||H===10)&&ne===10||ne===5||ne===13||ne===7||H===1||H===13&&ne===14||H===6&&ne===6)}e.breakBetweenGraphemeBreakType=We;var $e;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Qe()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ue=this._data,pe=ue.length/3;let Ie=1;for(;Ie<=pe;)if(ne<ue[3*Ie])Ie=2*Ie;else if(ne>ue[3*Ie+1])Ie=2*Ie+1;else return ue[3*Ie+2];return 0}}ze._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(H,ne){if(H===0)return 0;const ue=gt(H,ne);if(ue!==void 0)return ue;const pe=N(ne,H);return H-=Je(pe),H}e.getLeftDeleteOffset=Ge;function gt(H,ne){let ue=N(ne,H);for(H-=Je(ue);at(ue)||ue===65039||ue===8419;){if(H===0)return;ue=N(ne,H),H-=Je(ue)}if(!!ie(ue)){if(H>=0){const pe=N(ne,H);pe===8205&&(H-=Je(pe))}return H}}function Je(H){return H>=65536?2:1}function at(H){return 127995<=H&&H<=127999}var ct;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Ve{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ve.map){let pe=function(Te){const Fe=new Map;for(let Oe=0;Oe<Te.length;Oe+=2)Fe.set(Te[Oe],Te[Oe+1]);return Fe};const ne=Ve.getData();let ue=v.locale;(!ue||!(ue in ne))&&(ue=v.language),(!ue||!(ue in ne))&&(ue="_default");const Ie=pe(ne._common),Me=pe(ne[ue]);for(const[Te,Fe]of Me)Ie.set(Te,Fe);Ve.map=Ie}return Ve.map}static isAmbiguous(ne){return Ve.getConfusablesForCurrentLocale().has(ne)}static getPrimaryConfusable(ne){return Ve.getConfusablesForCurrentLocale().get(ne)}static getPrimaryConfusableCodePoints(){return new Set(Ve.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ve;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(ne){return He.getData().has(ne)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(Q[81],J([0,1,25]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(S){return M(S,0)}e.hash=D;function M(S,P){switch(typeof S){case"object":return S===null?C(349,P):Array.isArray(S)?d(S,P):f(S,P);case"string":return I(S,P);case"boolean":return r(S,P);case"number":return C(S,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=M;function C(S,P){return(P<<5)-P+S|0}e.numberHash=C;function r(S,P){return C(S?433:863,P)}function I(S,P){P=C(149417,P);for(let u=0,a=S.length;u<a;u++)P=C(S.charCodeAt(u),P);return P}e.stringHash=I;function d(S,P){return P=C(104579,P),S.reduce((u,a)=>M(a,u),P)}function f(S,P){return P=C(181387,P),Object.keys(S).sort().reduce((u,a)=>(u=I(a,u),M(S[a],u)),P)}class y{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=M(P,this._value),this._value}}e.Hasher=y;var E;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(S,P,u=32){const a=u-P,l=~((1<<a)-1);return(S<<P|(l&S)>>>a)>>>0}function p(S,P=0,u=S.byteLength,a=0){for(let l=0;l<u;l++)S[P+l]=a}function t(S,P,u="0"){for(;S.length<P;)S=u+S;return S}function w(S,P=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(u=>u.toString(16).padStart(2,"0")).join(""):t((S>>>0).toString(16),P/4)}e.toHexString=w;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const u=P.length;if(u===0)return;const a=this._buff;let l=this._buffLen,s=this._leftoverHighSurrogate,c,i;for(s!==0?(c=s,i=-1,s=0):(c=P.charCodeAt(0),i=0);;){let n=c;if(v.isHighSurrogate(c))if(i+1<u){const o=P.charCodeAt(i+1);v.isLowSurrogate(o)?(i++,n=v.computeCodePoint(c,o)):n=65533}else{s=c;break}else v.isLowSurrogate(c)&&(n=65533);if(l=this._push(a,l,n),i++,i<u)c=P.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=s}_push(P,u,a){return a<128?P[u++]=a:a<2048?(P[u++]=192|(a&1984)>>>6,P[u++]=128|(a&63)>>>0):a<65536?(P[u++]=224|(a&61440)>>>12,P[u++]=128|(a&4032)>>>6,P[u++]=128|(a&63)>>>0):(P[u++]=240|(a&1835008)>>>18,P[u++]=128|(a&258048)>>>12,P[u++]=128|(a&4032)>>>6,P[u++]=128|(a&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,u=this._buffDV;for(let g=0;g<64;g+=4)P.setUint32(g,u.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)P.setUint32(g,m(P.getUint32(g-12,!1)^P.getUint32(g-32,!1)^P.getUint32(g-56,!1)^P.getUint32(g-64,!1),1),!1);let a=this._h0,l=this._h1,s=this._h2,c=this._h3,i=this._h4,n,o,h;for(let g=0;g<80;g++)g<20?(n=l&s|~l&c,o=1518500249):g<40?(n=l^s^c,o=1859775393):g<60?(n=l&s|l&c|s&c,o=2400959708):(n=l^s^c,o=3395469782),h=m(a,5)+n+i+o+P.getUint32(g*4,!1)&4294967295,i=c,c=s,s=m(l,30),l=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function($,e,v,D,M){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?$!==e||!M:!e.has($))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?M.call($,v):M?M.value=v:e.set($,v),v},Ke=this&&this.__classPrivateFieldGet||function($,e,v,D){if(v==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?$!==e||!D:!e.has($))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?D:v==="a"?D.call($):D?D.value:e.get($)};define(Q[40],J([0,1,30,25]),function($,e,v,D){"use strict";var M,C,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(i,n,o){let h=i.get(n);return h===void 0&&(h=o,i.set(n,h)),h}e.getOrSet=I;function d(i){const n=[];return i.forEach((o,h)=>{n.push(`${h} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=d;function f(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=f;class y{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),h=this._value.charCodeAt(this._pos);return o-h}value(){return this._value[this._pos]}}e.StringIterator=y;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,D.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,D.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var p;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,D.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(b||(b={}));class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new t(n))}static forPaths(){return new S(new m)}static forStrings(){return new S(new y)}static forConfigKeys(){return new S(new E)}clear(){this._root=void 0}fill(n,o){if(o){const h=o.slice(0);(0,v.shuffle)(h);for(let g of h)this.set(g,n)}else{const h=n.slice(0);(0,v.shuffle)(h);for(let g of h)this.set(g[0],g[1])}}set(n,o){const h=this._iter.reset(n);let g;this._root||(this._root=new w,this._root.segment=h.value());const k=[];for(g=this._root;;){const R=h.cmp(g.segment);if(R>0)g.left||(g.left=new w,g.left.segment=h.value()),k.push([-1,g]),g=g.left;else if(R<0)g.right||(g.right=new w,g.right.segment=h.value()),k.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new w,g.mid.segment=h.value()),k.push([0,g]),g=g.mid;else break}const L=g.value;g.value=o,g.key=n;for(let R=k.length-1;R>=0;R--){const O=k[R][1];O.updateHeight();const V=O.balanceFactor();if(V<-1||V>1){const ee=k[R][0],oe=k[R+1][0];if(ee===1&&oe===1)k[R][1]=O.rotateLeft();else if(ee===-1&&oe===-1)k[R][1]=O.rotateRight();else if(ee===1&&oe===-1)O.right=k[R+1][1]=k[R+1][1].rotateRight(),k[R][1]=O.rotateLeft();else if(ee===-1&&oe===1)O.left=k[R+1][1]=k[R+1][1].rotateLeft(),k[R][1]=O.rotateRight();else throw new Error;if(R>0)switch(k[R-1][0]){case-1:k[R-1][1].left=k[R][1];break;case 1:k[R-1][1].right=k[R][1];break;case 0:k[R-1][1].mid=k[R][1];break}else this._root=k[0][1]}}return L}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let h=this._root;for(;h;){const g=o.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else break}return h}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const h=this._iter.reset(n),g=[];let k=this._root;for(;k;){const L=h.cmp(k.segment);if(L>0)g.push([-1,k]),k=k.left;else if(L<0)g.push([1,k]),k=k.right;else if(h.hasNext())h.next(),g.push([0,k]),k=k.mid;else break}if(!!k){if(o?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const L=this._min(k.right),{key:R,value:O,segment:V}=L;this._delete(L.key,!1),k.key=R,k.value=O,k.segment=V}else{const L=k.left??k.right;if(g.length>0){const[R,O]=g[g.length-1];switch(R){case-1:O.left=L;break;case 0:O.mid=L;break;case 1:O.right=L;break}}else this._root=L}for(let L=g.length-1;L>=0;L--){const R=g[L][1];R.updateHeight();const O=R.balanceFactor();if(O>1?(R.right.balanceFactor()>=0||(R.right=g[L+1][1]=g[L+1][1].rotateRight()),g[L][1]=R.rotateLeft()):O<-1&&(R.left.balanceFactor()<=0||(R.left=g[L+1][1]=g[L+1][1].rotateLeft()),g[L][1]=R.rotateRight()),L>0)switch(g[L-1][0]){case-1:g[L-1][1].left=g[L][1];break;case 1:g[L-1][1].right=g[L][1];break;case 0:g[L-1][1].mid=g[L][1];break}else this._root=g[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let h=this._root,g;for(;h;){const k=o.cmp(h.segment);if(k>0)h=h.left;else if(k<0)h=h.right;else if(o.hasNext())o.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(n){const o=this._iter.reset(n);let h=this._root;for(;h;){const g=o.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(n){for(const[o,h]of this)n(h,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=o=>{if(!o)return!0;const h=o.balanceFactor();return h<-1||h>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=S;class P{constructor(n,o){this.uri=n,this.value=o}}class u{constructor(n,o){this[M]="ResourceMap",n instanceof u?(this.map=new Map(n.map),this.toKey=o??u.defaultToKey):(this.map=new Map,this.toKey=n??u.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new P(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[h,g]of this.map)n(g.value,g.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=u,u.defaultToKey=i=>i.toString();var a;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const h=this._map.get(n);if(!!h)return o!==0&&this.touch(h,o),h.value}set(n,o,h=0){let g=this._map.get(n);if(g)g.value=o,h!==0&&this.touch(g,h);else{switch(g={key:n,value:o,next:void 0,previous:void 0},h){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(n,g),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const h=this._state;let g=this._head;for(;g;){if(o?n.bind(o)(g.value,g.key,this):n(g.value,g.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const n=this,o=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.key,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return g}values(){const n=this,o=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.value,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return g}entries(){const n=this,o=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:[h.key,h.value],done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return g}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,h=this.size;for(;o&&h>n;)this._map.delete(o.key),o=o.next,h--;this._head=o,this._size=h,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,h=n.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const h=n.next,g=n.previous;n===this._tail?(g.next=void 0,this._tail=g):(h.previous=g,g.next=h),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const h=n.next,g=n.previous;n===this._head?(h.previous=void 0,this._head=h):(h.previous=g,g.next=h),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,h)=>{n.push([h,o])}),n}fromJSON(n){this.clear();for(const[o,h]of n)this.set(o,h)}}e.LinkedMap=l;class s extends l{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class c{constructor(n){r.set(this,void 0),kt(this,r,n,"f")}get size(){return Ke(this,r,"f").size}forEach(n,o){Ke(this,r,"f").forEach(n,o)}get(n){return Ke(this,r,"f").get(n)}has(n){return Ke(this,r,"f").has(n)}entries(){return Ke(this,r,"f").entries()}keys(){return Ke(this,r,"f").keys()}values(){return Ke(this,r,"f").values()}[(r=new WeakMap,Symbol.iterator)](){return Ke(this,r,"f").entries()}}e.ReadonlyMapView=c}),define(Q[70],J([0,1,40]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const D=new v.LRUCache(1e4);function M(f){return d(f,"NFC",D)}e.normalizeNFC=M;const C=new v.LRUCache(1e4);function r(f){return d(f,"NFD",C)}e.normalizeNFD=r;const I=/[^\u0000-\u0080]/;function d(f,y,E){if(!f)return f;const m=E.get(f);if(m)return m;let p;return I.test(f)?p=f.normalize(y):p=f,E.set(f,p),p}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(y){return r(y).replace(f,"")}}()}),define(Q[13],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(k){return Array.isArray(k)}e.isArray=v;function D(k){return typeof k=="string"}e.isString=D;function M(k){return Array.isArray(k)&&k.every(L=>D(L))}e.isStringArray=M;function C(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=C;function r(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=r;function I(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=I;function d(k){return k===!0||k===!1}e.isBoolean=d;function f(k){return typeof k=="undefined"}e.isUndefined=f;function y(k){return!E(k)}e.isDefined=y;function E(k){return f(k)||k===null}e.isUndefinedOrNull=E;function m(k,L){if(!k)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=m;function p(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=p;function t(...k){const L=[];for(let R=0;R<k.length;R++){const O=k[R];if(E(O))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);L.push(O)}return L}e.assertAllDefined=t;const w=Object.prototype.hasOwnProperty;function b(k){if(!C(k))return!1;for(let L in k)if(w.call(k,L))return!1;return!0}e.isEmptyObject=b;function S(k){return typeof k=="function"}e.isFunction=S;function P(...k){return k.length>0&&k.every(S)}e.areFunctions=P;function u(k,L){const R=Math.min(k.length,L.length);for(let O=0;O<R;O++)a(k[O],L[O])}e.validateConstraints=u;function a(k,L){if(D(L)){if(typeof k!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(S(L)){try{if(k instanceof L)return}catch{}if(!E(k)&&k.constructor===L||L.length===1&&L.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(k){let L=[],R=Object.getPrototypeOf(k);for(;Object.prototype!==R;)L=L.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return L}e.getAllPropertyNames=l;function s(k){const L=[];for(const R of l(k))typeof k[R]=="function"&&L.push(R);return L}e.getAllMethodNames=s;function c(k,L){const R=V=>function(){const ee=Array.prototype.slice.call(arguments,0);return L(V,ee)};let O={};for(const V of k)O[V]=R(V);return O}e.createProxyObject=c;function i(k){return k===null?void 0:k}e.withNullAsUndefined=i;function n(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=n;function o(k){return class{constructor(){return new Proxy({},{get(L,R){if(L[R])return L[R];throw new Error(`Not Implemented: ${k}->${String(R)}`)}})}}}e.NotImplementedProxy=o;function h(k,L="Unreachable"){throw new Error(L)}e.assertNever=h;function g(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=g}),define(Q[32],J([0,1,8,3,25,13]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(i){return i===47||i===92}e.isPathSeparator=r;function I(i){return i.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=I;function d(i){return i.indexOf("/")===-1&&(i=I(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=d;function f(i,n=v.posix.sep){if(!i)return"";const o=i.length,h=i.charCodeAt(0);if(r(h)){if(r(i.charCodeAt(1))&&!r(i.charCodeAt(2))){let k=3;const L=k;for(;k<o&&!r(i.charCodeAt(k));k++);if(L!==k&&!r(i.charCodeAt(k+1))){for(k+=1;k<o;k++)if(r(i.charCodeAt(k)))return i.slice(0,k+1).replace(/[\\/]/g,n)}}return n}else if(S(h)&&i.charCodeAt(1)===58)return r(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let g=i.indexOf("://");if(g!==-1){for(g+=3;g<o;g++)if(r(i.charCodeAt(g)))return i.slice(0,g+1)}return""}e.getRoot=f;function y(i){if(!D.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let o=2;const h=o;for(;o<i.length&&(n=i.charCodeAt(o),n!==92);o++);return!(h===o||(n=i.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=y;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(i,n=D.isWindows){const o=n?E:m;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||n&&p.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=t;function w(i,n,o){const h=i===n;return!o||h?h:!i||!n?!1:(0,M.equalsIgnoreCase)(i,n)}e.isEqual=w;function b(i,n,o,h=v.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(o){if(!(0,M.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let k=n.length;return n.charAt(n.length-1)===h&&k--,i.charAt(k)===h}return n.charAt(n.length-1)!==h&&(n+=h),i.indexOf(n)===0}e.isEqualOrParent=b;function S(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=S;function P(i,n){return D.isWindows&&i.endsWith(":")&&(i+=v.sep),(0,v.isAbsolute)(i)||(i=(0,v.join)(n,i)),i=(0,v.normalize)(i),D.isWindows?(i=(0,M.rtrim)(i,v.sep),i.endsWith(":")&&(i+=v.sep)):(i=(0,M.rtrim)(i,v.sep),i||(i=v.sep)),i}e.sanitizeFilePath=P;function u(i){const n=(0,v.normalize)(i);return D.isWindows?i.length>3?!1:a(n)&&(i.length===2||n.charCodeAt(2)===92):n===v.posix.sep}e.isRootOrDriveLetter=u;function a(i,n){return(n!==void 0?n:D.isWindows)?S(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(i){return a(i)?i[0]:void 0}e.getDriveLetter=l;function s(i,n,o){return n.length>i.length?-1:i===n?0:(o&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=s;function c(i){const n=i.split(":");let o,h,g;if(n.forEach(k=>{const L=Number(k);(0,C.isNumber)(L)?h===void 0?h=L:g===void 0&&(g=L):o=o?[o,k].join(":"):k}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c}),define(Q[47],J([0,1,13]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const b=Array.isArray(w)?[]:{};return Object.keys(w).forEach(S=>{w[S]&&typeof w[S]=="object"?b[S]=D(w[S]):b[S]=w[S]}),b}e.deepClone=D;function M(w){if(!w||typeof w!="object")return w;const b=[w];for(;b.length>0;){const S=b.shift();Object.freeze(S);for(const P in S)if(C.call(S,P)){const u=S[P];typeof u=="object"&&!Object.isFrozen(u)&&b.push(u)}}return w}e.deepFreeze=M;const C=Object.prototype.hasOwnProperty;function r(w,b){return I(w,b,new Set)}e.cloneAndChange=r;function I(w,b,S){if((0,v.isUndefinedOrNull)(w))return w;const P=b(w);if(typeof P!="undefined")return P;if((0,v.isArray)(w)){const u=[];for(const a of w)u.push(I(a,b,S));return u}if((0,v.isObject)(w)){if(S.has(w))throw new Error("Cannot clone recursive data-structure");S.add(w);const u={};for(let a in w)C.call(w,a)&&(u[a]=I(w[a],b,S));return S.delete(w),u}return w}function d(w,b,S=!0){return(0,v.isObject)(w)?((0,v.isObject)(b)&&Object.keys(b).forEach(P=>{P in w?S&&((0,v.isObject)(w[P])&&(0,v.isObject)(b[P])?d(w[P],b[P],S):w[P]=b[P]):w[P]=b[P]}),w):b}e.mixin=d;function f(w,b){if(w===b)return!0;if(w==null||b===null||b===void 0||typeof w!=typeof b||typeof w!="object"||Array.isArray(w)!==Array.isArray(b))return!1;let S,P;if(Array.isArray(w)){if(w.length!==b.length)return!1;for(S=0;S<w.length;S++)if(!f(w[S],b[S]))return!1}else{const u=[];for(P in w)u.push(P);u.sort();const a=[];for(P in b)a.push(P);if(a.sort(),!f(u,a))return!1;for(S=0;S<u.length;S++)if(!f(w[u[S]],b[u[S]]))return!1}return!0}e.equals=f;function y(w){const b=new Set;return JSON.stringify(w,(S,P)=>{if((0,v.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=y;function E(w,b,S){const P=b(w);return typeof P=="undefined"?S:P}e.getOrDefault=E;function m(w,b){const S=Object.create(null);return!w||!b||Object.keys(b).forEach(u=>{const a=w[u],l=b[u];f(a,l)||(S[u]=l)}),S}e.distinct=m;function p(w,b){const S=b.toLowerCase(),P=Object.keys(w).find(u=>u.toLowerCase()===S);return P?w[P]:w[b]}e.getCaseInsensitive=p;function t(w,b){const S=Object.create(null);for(const[P,u]of Object.entries(w))b(P,u)&&(S[P]=u);return S}e.filter=t}),define(Q[7],J([0,1,8,3]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,C=/^\//,r=/^\/\//;function I(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!M.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(r.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,n){return!i&&!n?"file":i}function f(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const y="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,o,h,g,k,L=!1){typeof n=="object"?(this.scheme=n.scheme||y,this.authority=n.authority||y,this.path=n.path||y,this.query=n.query||y,this.fragment=n.fragment||y):(this.scheme=d(n,L),this.authority=o||y,this.path=f(this.scheme,h||y),this.query=g||y,this.fragment=k||y,I(this,L))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return u(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:h,path:g,query:k,fragment:L}=n;return o===void 0?o=this.scheme:o===null&&(o=y),h===void 0?h=this.authority:h===null&&(h=y),g===void 0?g=this.path:g===null&&(g=y),k===void 0?k=this.query:k===null&&(k=y),L===void 0?L=this.fragment:L===null&&(L=y),o===this.scheme&&h===this.authority&&g===this.path&&k===this.query&&L===this.fragment?this:new w(o,h,g,k,L)}static parse(n,o=!1){const h=m.exec(n);return h?new w(h[2]||y,c(h[4]||y),c(h[5]||y),c(h[7]||y),c(h[9]||y),o):new w(y,y,y,y,y)}static file(n){let o=y;if(D.isWindows&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const h=n.indexOf(E,2);h===-1?(o=n.substring(2),n=E):(o=n.substring(2,h),n=n.substring(h)||E)}return new w("file",o,n,y,y)}static from(n){const o=new w(n.scheme,n.authority,n.path,n.query,n.fragment);return I(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return D.isWindows&&n.scheme==="file"?h=p.file(v.win32.join(u(n,!0),...o)).path:h=v.posix.join(n.path,...o),n.with({path:h})}toString(n=!1){return a(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const o=new w(n);return o._formatted=n.external,o._fsPath=n._sep===t?n.fsPath:null,o}}else return n}}e.URI=p;const t=D.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(n=!1){return n?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=t),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(i,n){let o,h=-1;for(let g=0;g<i.length;g++){const k=i.charCodeAt(g);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47)h!==-1&&(o+=encodeURIComponent(i.substring(h,g)),h=-1),o!==void 0&&(o+=i.charAt(g));else{o===void 0&&(o=i.substr(0,g));const L=b[k];L!==void 0?(h!==-1&&(o+=encodeURIComponent(i.substring(h,g)),h=-1),o+=L):h===-1&&(h=g)}}return h!==-1&&(o+=encodeURIComponent(i.substring(h))),o!==void 0?o:i}function P(i){let n;for(let o=0;o<i.length;o++){const h=i.charCodeAt(o);h===35||h===63?(n===void 0&&(n=i.substr(0,o)),n+=b[h]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function u(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,D.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function a(i,n){const o=n?P:S;let h="",{scheme:g,authority:k,path:L,query:R,fragment:O}=i;if(g&&(h+=g,h+=":"),(k||g==="file")&&(h+=E,h+=E),k){let V=k.indexOf("@");if(V!==-1){const ee=k.substr(0,V);k=k.substr(V+1),V=ee.indexOf(":"),V===-1?h+=o(ee,!1):(h+=o(ee.substr(0,V),!1),h+=":",h+=o(ee.substr(V+1),!1)),h+="@"}k=k.toLowerCase(),V=k.indexOf(":"),V===-1?h+=o(k,!1):(h+=o(k.substr(0,V),!1),h+=k.substr(V))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const V=L.charCodeAt(1);V>=65&&V<=90&&(L=`/${String.fromCharCode(V+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const V=L.charCodeAt(0);V>=65&&V<=90&&(L=`${String.fromCharCode(V+32)}:${L.substr(2)}`)}h+=o(L,!0)}return R&&(h+="?",h+=o(R,!1)),O&&(h+="#",h+=n?O:S(O,!1)),h}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(s)?i.replace(s,n=>l(n)):i}}),define(Q[110],J([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(f){const y=f;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=D;function M(f){const y=[];let E;try{const m=JSON.parse(f.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),E=p.__$stack),y.push(...m)}catch(m){y.push("Unable to log remote console arguments",f.arguments)}return{args:y,stack:E}}e.parse=M;function C(f){if(typeof f!="string")return C(M(f).stack);const y=f;if(y){const E=r(y),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:v.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=C;function r(f){if(!f)return f;const y=f.indexOf(`
`);return y===-1?f:f.substring(0,y)}function I(f,y){const{args:E,stack:m}=M(f),p=typeof E[0]=="string"&&E.length===1;let t=r(m);t&&(t=`(${t.trim()})`);let w=[];if(typeof E[0]=="string"?t&&p?w=[`%c[${y}] %c${E[0]} %c${t}`,d("blue"),d(""),d("grey")]:w=[`%c[${y}] %c${E[0]}`,d("blue"),d(""),...E.slice(1)]:w=[`%c[${y}]%`,d("blue"),...E],t&&!p&&w.push(t),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,w)}e.log=I;function d(f){return`color: ${f}`}}),define(Q[111],J([0,1,17,25,7]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(y){return JSON.stringify(y,d)}e.stringify=C;function r(y){let E=JSON.parse(y);return E=f(E),E}e.parse=r;var I;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function d(y,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,D.regExpFlags)(E)}:E}function f(y,E=0){if(!y||E>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return M.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof v.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let m=0;m<y.length;++m)y[m]=f(y[m],E+1);else for(const m in y)Object.hasOwnProperty.call(y,m)&&(y[m]=f(y[m],E+1))}return y}e.revive=f}),define(Q[10],J([0,1,3,7]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var M;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(M=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,f,y){this._hosts[d]=f,this._ports[d]=y}setConnectionToken(d,f){this._connectionTokens[d]=f}rewrite(d){if(this._delegate)return this._delegate(d);const f=d.authority;let y=this._hosts[f];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const E=this._ports[f],m=this._connectionTokens[f];let p=`path=${encodeURIComponent(d.path)}`;return typeof m=="string"&&(p+=`&tkn=${encodeURIComponent(m)}`),D.URI.from({scheme:v.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${y}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new C;class r{asBrowserUri(d,f){const y=this.toUri(d,f);return y.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===M.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${M.vscodeFileResource}://${r.FALLBACK_AUTHORITY}`)?y.with({scheme:M.vscodeFileResource,authority:y.authority||r.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(d,f){const y=this.toUri(d,f);return y.scheme===M.vscodeFileResource?y.with({scheme:M.file,authority:y.authority!==r.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(d,f){return D.URI.isUri(d)?d:D.URI.parse(f.toUrl(d))}}r.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new r}),define(Q[15],J([0,1,32,10,8,3,25,7]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(p){return(0,I.uriToFsPath)(p,!0)}e.originalFSPath=d;class f{constructor(t){this._ignorePathCasing=t}compare(t,w,b=!1){return t===w?0:(0,r.compare)(this.getComparisonKey(t,b),this.getComparisonKey(w,b))}isEqual(t,w,b=!1){return t===w?!0:!t||!w?!1:this.getComparisonKey(t,b)===this.getComparisonKey(w,b)}getComparisonKey(t,w=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,w,b=!1){if(t.scheme===w.scheme){if(t.scheme===D.Schemas.file)return v.isEqualOrParent(d(t),d(w),this._ignorePathCasing(t))&&t.query===w.query&&(b||t.fragment===w.fragment);if((0,e.isEqualAuthority)(t.authority,w.authority))return v.isEqualOrParent(t.path,w.path,this._ignorePathCasing(t),"/")&&t.query===w.query&&(b||t.fragment===w.fragment)}return!1}joinPath(t,...w){return I.URI.joinPath(t,...w)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return M.posix.basename(t.path)}extname(t){return M.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let w;return t.scheme===D.Schemas.file?w=I.URI.file(M.dirname(d(t))).path:(w=M.posix.dirname(t.path),t.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),w="/")),t.with({path:w})}normalizePath(t){if(!t.path.length)return t;let w;return t.scheme===D.Schemas.file?w=I.URI.file(M.normalize(d(t))).path:w=M.posix.normalize(t.path),t.with({path:w})}relativePath(t,w){if(t.scheme!==w.scheme||!(0,e.isEqualAuthority)(t.authority,w.authority))return;if(t.scheme===D.Schemas.file){const P=M.relative(d(t),d(w));return C.isWindows?v.toSlashes(P):P}let b=t.path||"/",S=w.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const u=Math.min(b.length,S.length);P<u&&!(b.charCodeAt(P)!==S.charCodeAt(P)&&b.charAt(P).toLowerCase()!==S.charAt(P).toLowerCase());P++);b=S.substr(0,P)+b.substr(P)}return M.posix.relative(b,S)}resolvePath(t,w){if(t.scheme===D.Schemas.file){const b=I.URI.file(M.resolve(d(t),w));return t.with({authority:b.authority,path:b.path})}return w=v.toPosixPath(w),t.with({path:M.posix.resolve(t.path,w)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,w){return t===w||t!==void 0&&w!==void 0&&(0,r.equalsIgnoreCase)(t,w)}hasTrailingPathSeparator(t,w=M.sep){if(t.scheme===D.Schemas.file){const b=d(t);return b.length>v.getRoot(b).length&&b[b.length-1]===w}else{const b=t.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,w=M.sep){return(0,e.hasTrailingPathSeparator)(t,w)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,w=M.sep){let b=!1;if(t.scheme===D.Schemas.file){const S=d(t);b=S!==void 0&&S.length===v.getRoot(S).length&&S[S.length-1]===w}else{w="/";const S=t.path;b=S.length===1&&S.charCodeAt(S.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(t,w)?t.with({path:t.path+"/"}):t}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(p=>p.scheme===D.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new f(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(p,t){const w=[];for(let b=0;b<p.length;b++){const S=t(p[b]);p.some((P,u)=>u===b?!1:(0,e.isEqualOrParent)(S,t(P)))||w.push(p[b])}return w}e.distinctParents=y;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(w){const b=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(u=>{const[a,l]=u.split(":");a&&l&&b.set(a,l)});const P=w.path.substring(0,w.path.indexOf(";"));return P&&b.set(p.META_DATA_MIME,P),b}p.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function m(p,t,w){if(t){let b=p.path;return b&&b[0]!==M.posix.sep&&(b=M.posix.sep+b),p.with({scheme:w,authority:t,path:b})}return p.with({scheme:w})}e.toLocalResource=m}),define(Q[9],J([0,1,23,16,4,2,15,3]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(q){return!!q&&typeof q.then=="function"}e.isThenable=d;function f(q){const _=new v.CancellationTokenSource,U=q(_.token),j=new Promise((F,A)=>{const W=_.token.onCancellationRequested(()=>{W.dispose(),_.dispose(),A((0,D.canceled)())});Promise.resolve(U).then(B=>{W.dispose(),_.dispose(),F(B)},B=>{W.dispose(),_.dispose(),A(B)})});return new class{cancel(){_.cancel()}then(F,A){return j.then(F,A)}catch(F){return this.then(void 0,F)}finally(F){return j.finally(F)}}}e.createCancelablePromise=f;function y(q,_,U){return Promise.race([q,new Promise(j=>_.onCancellationRequested(()=>j(U)))])}e.raceCancellation=y;async function E(q){let _=-1;const U=q.map((F,A)=>F.then(W=>(_=A,W))),j=await Promise.race(U);return q.forEach((F,A)=>{A!==_&&F.cancel()}),j}e.raceCancellablePromises=E;function m(q,_,U){let j;const F=setTimeout(()=>{j?.(void 0),U?.()},_);return Promise.race([q.finally(()=>clearTimeout(F)),new Promise(A=>j=A)])}e.raceTimeout=m;function p(q){return new Promise((_,U)=>{const j=q();d(j)?j.then(_,U):_(j)})}e.asPromise=p;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(U,U).then(j)})}return new Promise((U,j)=>{this.queuedPromise.then(U,j)})}return this.activePromise=_(),new Promise((U,j)=>{this.activePromise.then(F=>{this.activePromise=null,U(F)},F=>{this.activePromise=null,j(F)})})}}e.Throttler=t;class w{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=w;class b{constructor(){this.promiseMap=new Map}queue(_,U){const F=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(_)===F&&this.promiseMap.delete(_)});return this.promiseMap.set(_,F),F}}e.SequencerByKey=b;class S{constructor(_){this.defaultDelay=_,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,U=this.defaultDelay){return this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,F)=>{this.doResolve=j,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class P{constructor(_){this.delayer=new S(_),this.throttler=new t}trigger(_,U){return this.delayer.trigger(()=>this.throttler.queue(_),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class u{constructor(){this._isOpen=!1,this._promise=new Promise((_,U)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class a extends u{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(q,_){return _?new Promise((U,j)=>{const F=setTimeout(()=>{A.dispose(),U()},q),A=_.onCancellationRequested(()=>{clearTimeout(F),A.dispose(),j((0,D.canceled)())})}):f(U=>l(q,U))}e.timeout=l;function s(q,_=0){const U=setTimeout(q,_);return(0,C.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=s;function c(q){const _=[];let U=0;const j=q.length;function F(){return U<j?q[U++]():null}function A(W){W!=null&&_.push(W);const B=F();return B?B.then(A):Promise.resolve(_)}return Promise.resolve(null).then(A)}e.sequence=c;function i(q,_=j=>!!j,U=null){let j=0;const F=q.length,A=()=>{if(j>=F)return Promise.resolve(U);const W=q[j++];return Promise.resolve(W()).then(Y=>_(Y)?Promise.resolve(Y):A())};return A()}e.first=i;function n(q,_=j=>!!j,U=null){if(q.length===0)return Promise.resolve(U);let j=q.length;const F=()=>{j=-1;for(const A of q)A.cancel?.()};return new Promise((A,W)=>{for(const B of q)B.then(Y=>{--j>=0&&_(Y)?(F(),A(Y)):j===0&&A(U)}).catch(Y=>{--j>=0&&(F(),W(Y))})})}e.firstParallel=n;class o{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(_){return this._size++,new Promise((U,j)=>{this.outstandingPromises.push({factory:_,c:U,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const U=_.factory();U.then(_.c,_.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class h extends o{constructor(){super(1)}}e.Queue=h;class g{constructor(){this.queues=new Map}queueFor(_,U=r.extUri){const j=U.getComparisonKey(_);let F=this.queues.get(j);return F||(F=new h,M.Event.once(F.onFinished)(()=>{F?.dispose(),this.queues.delete(j)}),this.queues.set(j,F)),F}dispose(){this.queues.forEach(_=>_.dispose()),this.queues.clear()}}e.ResourceQueue=g;class k{constructor(_,U){this._token=-1,typeof _=="function"&&typeof U=="number"&&this.setIfNotSet(_,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},U)}setIfNotSet(_,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},U))}}e.TimeoutTimer=k;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setInterval(()=>{_()},U)}}e.IntervalTimer=L;class R{constructor(_,U){this.timeoutToken=-1,this.runner=_,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class O{constructor(_,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=O;class V extends R{constructor(_,U){super(_,U);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner&&this.runner(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=V;class ee extends C.Disposable{constructor(_,U,j,F){super();this.maxWorkChunkSize=_,this.maxPendingWork=U,this.throttleDelay=j,this.handler=F,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.maxPendingWork)return!1}else if(this.pending+_.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ee,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,I.setTimeout0)(()=>{if(_)return;const U=Date.now()+3;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(q,_)=>{const U=requestIdleCallback(q,typeof _=="number"?{timeout:_}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(U))}}}}();class oe{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=oe;async function ae(q,_,U){let j;for(let F=0;F<U;F++)try{return await q()}catch(A){j=A,await l(_)}throw j}e.retry=ae;class K{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(_,U,j){return this._pending={taskId:_,cancel:()=>j?.(),promise:U},U.then(()=>this.donePending(_),()=>this.donePending(_)),U}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let U,j;const F=new Promise((A,W)=>{U=A,j=W});this._next={run:_,promise:F,promiseResolve:U,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=K;class T{constructor(_){this.interval=_,this.lastIncrementTime=0,this.value=0}increment(){const _=Date.now();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=T;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,U)=>{this.completeCallback=_,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(U=>{this.completeCallback(_),this.resolved=!0,U()})}error(_){return new Promise(U=>{this.errorCallback(_),this.rejected=!0,U()})}cancel(){new Promise(_=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,_()})}}e.DeferredPromise=N;var G;(function(q){async function _(j){let F;const A=await Promise.all(j.map(W=>W.then(B=>B,B=>{F||(F=B)})));if(typeof F!="undefined")throw F;return A}q.settled=_;function U(j){return new Promise(async(F,A)=>{try{await j(F,A)}catch(W){A(W)}})}q.withAsyncBody=U})(G=e.Promises||(e.Promises={}))}),define(Q[33],J([0,1,32,10,8,3,15,25,7]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(n,o,h){if(typeof n=="string"&&(n=d.URI.file(n)),h){const k=h.getWorkspaceFolder(n);if(k){const L=h.getWorkspace().folders.length>1;let R;if((0,r.isEqual)(k.uri,n)?R="":R=(0,r.relativePath)(k.uri,n),L){const O=k.name?k.name:(0,r.basename)(k.uri);R=R?O+" \u2022 "+R:O}return R}}if(n.scheme!==D.Schemas.file&&n.scheme!==D.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(n.fsPath))return(0,M.normalize)(E(n.fsPath));let g=(0,M.normalize)(n.fsPath);return!C.isWindows&&o?.userHome&&(g=p(g,o.userHome.fsPath)),g}e.getPathLabel=f;function y(n){if(!n)return;typeof n=="string"&&(n=d.URI.file(n));const o=(0,r.basename)(n)||(n.scheme===D.Schemas.file?n.fsPath:n.path);return C.isWindows&&(0,v.isRootOrDriveLetter)(o)?E(o):o}e.getBaseLabel=y;function E(n,o){return(0,v.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=E;let m=Object.create(null);function p(n,o){if(C.isWindows||!n||!o)return n;let h=m.original===o?m.normalized:void 0;return h||(h=`${(0,I.rtrim)(o,M.posix.sep)}${M.posix.sep}`,m={original:o,normalized:h}),(C.isLinux?n.startsWith(h):(0,I.startsWithIgnoreCase)(n,h))&&(n=`~/${n.substr(h.length)}`),n}e.tildify=p;function t(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=t;const w="\u2026",b="\\\\",S="~";function P(n,o=M.sep){const h=new Array(n.length);let g=!1;for(let k=0;k<n.length;k++){let L=n[k];if(L===""){h[k]=`.${o}`;continue}if(!L){h[k]=L;continue}g=!0;let R="";L.indexOf(b)===0?(R=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(o)===0?(R=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(S)===0&&(R=L.substr(0,L.indexOf(S)+S.length),L=L.substr(L.indexOf(S)+S.length));const O=L.split(o);for(let V=1;g&&V<=O.length;V++)for(let ee=O.length-V;g&&ee>=0;ee--){g=!1;let oe=O.slice(ee,ee+V).join(o);for(let ae=0;!g&&ae<n.length;ae++)if(ae!==k&&n[ae]&&n[ae].indexOf(oe)>-1){const K=ee+V===O.length,T=ee>0&&n[ae].indexOf(o)>-1?o+oe:oe,N=n[ae].endsWith(T);g=!K||N}if(!g){let ae="";(O[0].endsWith(":")||R!=="")&&(ee===1&&(ee=0,V++,oe=O[0]+o+oe),ee>0&&(ae=O[0]+o),ae=R+ae),ee>0&&(ae=ae+w+o),ae=ae+oe,ee+V<O.length&&(ae=ae+o+w),h[k]=ae}}g&&(h[k]=L)}return h}e.shorten=P;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function a(n,o=Object.create(null)){const h=[];let g=!1,k="";for(const L of n)if(L==="$"||g&&L==="{")k&&h.push({value:k,type:u.TEXT}),k="",g=!0;else if(L==="}"&&g){const R=o[k];if(typeof R=="string")R.length&&h.push({value:R,type:u.VARIABLE});else if(R){const O=h[h.length-1];(!O||O.type!==u.SEPARATOR)&&h.push({value:R.label,type:u.SEPARATOR})}k="",g=!1}else k+=L;return k&&!g&&h.push({value:k,type:u.TEXT}),h.filter((L,R)=>{if(L.type===u.SEPARATOR){const O=h[R-1],V=h[R+1];return[O,V].every(ee=>ee&&(ee.type===u.VARIABLE||ee.type===u.TEXT)&&ee.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function l(n,o){return C.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function s(n,o){return C.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function c(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=c;function i(n){const o=n.indexOf("/")!==-1?M.posix:M.win32,h=o.basename(n),g=o.dirname(n);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}e.splitName=i}),define(Q[112],J([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(y){return y.toJSON()}class M{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:D(v.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:D(v.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:v.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,E,m){if(!y||m>200)return null;if(typeof y=="object"){if(y instanceof v.URI)return E.transformOutgoing(y);for(let p in y)if(Object.hasOwnProperty.call(y,p)){const t=C(y[p],E,m+1);t!==null&&(y[p]=t)}}return null}function r(y,E){const m=C(y,E,0);return m===null?y:m}e.transformOutgoingURIs=r;function I(y,E,m,p){if(!y||p>200)return null;if(typeof y=="object"){if(y.$mid===1)return m?v.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);for(let t in y)if(Object.hasOwnProperty.call(y,t)){const w=I(y[t],E,m,p+1);w!==null&&(y[t]=w)}}return null}function d(y,E){const m=I(y,E,!1,0);return m===null?y:m}e.transformIncomingURIs=d;function f(y,E){const m=I(y,E,!0,0);return m===null?y:m}e.transformAndReviveIncomingURIs=f}),define(Q[31],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(d){return v.test(d)}e.isUUID=D;const M=new Uint8Array(16),C=[];for(let d=0;d<256;d++)C.push(d.toString(16).padStart(2,"0"));let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(d){for(let f=0;f<d.length;f++)d[f]=Math.floor(Math.random()*256);return d};function I(){r(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,f="";return f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f}e.generateUuid=I}),define(Q[113],J([0,1,16,4,2,3,13,25]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let f=!1;function y(i){!C.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(i.message))}e.logOnceWebWorkerWarning=y;var E;(function(i){i[i.Request=0]="Request",i[i.Reply=1]="Reply",i[i.SubscribeEvent=2]="SubscribeEvent",i[i.Event=3]="Event",i[i.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class m{constructor(n,o,h,g){this.vsWorker=n,this.req=o,this.method=h,this.args=g,this.type=0}}class p{constructor(n,o,h,g){this.vsWorker=n,this.seq=o,this.res=h,this.err=g,this.type=1}}class t{constructor(n,o,h,g){this.vsWorker=n,this.req=o,this.eventName=h,this.arg=g,this.type=2}}class w{constructor(n,o,h){this.vsWorker=n,this.req=o,this.event=h,this.type=3}}class b{constructor(n,o){this.vsWorker=n,this.req=o,this.type=4}}class S{constructor(n){this._workerId=-1,this._handler=n,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(n){this._workerId=n}sendMessage(n,o){const h=String(++this._lastSentReq);return new Promise((g,k)=>{this._pendingReplies[h]={resolve:g,reject:k},this._send(new m(this._workerId,h,n,o))})}listen(n,o){let h=null;const g=new D.Emitter({onFirstListenerAdd:()=>{h=String(++this._lastSentReq),this._pendingEmitters.set(h,g),this._send(new t(this._workerId,h,n,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(h),this._send(new b(this._workerId,h)),h=null}});return g.event}handleMessage(n){!n||!n.vsWorker||this._workerId!==-1&&n.vsWorker!==this._workerId||this._handleMessage(n)}_handleMessage(n){switch(n.type){case 1:return this._handleReplyMessage(n);case 0:return this._handleRequestMessage(n);case 2:return this._handleSubscribeEventMessage(n);case 3:return this._handleEventMessage(n);case 4:return this._handleUnsubscribeEventMessage(n)}}_handleReplyMessage(n){if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let h=n.err;n.err.$isError&&(h=new Error,h.name=n.err.name,h.message=n.err.message,h.stack=n.err.stack),o.reject(h);return}o.resolve(n.res)}_handleRequestMessage(n){let o=n.req;this._handler.handleMessage(n.method,n.args).then(g=>{this._send(new p(this._workerId,o,g,void 0))},g=>{g.detail instanceof Error&&(g.detail=(0,v.transformErrorForSerialization)(g.detail)),this._send(new p(this._workerId,o,void 0,(0,v.transformErrorForSerialization)(g)))})}_handleSubscribeEventMessage(n){const o=n.req,h=this._handler.handleEvent(n.eventName,n.arg)(g=>{this._send(new w(this._workerId,o,g))});this._pendingEvents.set(o,h)}_handleEventMessage(n){if(!this._pendingEmitters.has(n.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(n.req).fire(n.event)}_handleUnsubscribeEventMessage(n){if(!this._pendingEvents.has(n.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(n.req).dispose(),this._pendingEvents.delete(n.req)}_send(n){let o=[];if(n.type===0)for(let h=0;h<n.args.length;h++)n.args[h]instanceof ArrayBuffer&&o.push(n.args[h]);else n.type===1&&n.res instanceof ArrayBuffer&&o.push(n.res);this._handler.sendMessage(n,o)}}class P extends M.Disposable{constructor(n,o,h){super();let g=null;this._worker=this._register(n.create("vs/base/common/worker/simpleWorker",V=>{this._protocol.handleMessage(V)},V=>{g&&g(V)})),this._protocol=new S({sendMessage:(V,ee)=>{this._worker.postMessage(V,ee)},handleMessage:(V,ee)=>{if(typeof h[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(h[V].apply(h,ee))}catch(oe){return Promise.reject(oe)}},handleEvent:(V,ee)=>{if(a(V)){const oe=h[V].call(h,ee);if(typeof oe!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return oe}if(u(V)){const oe=h[V];if(typeof oe!="function")throw new Error(`Missing event ${V} on main thread host.`);return oe}throw new Error(`Malformed event name ${V}`)}}),this._protocol.setWorkerId(this._worker.getId());let k=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?k=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(k=C.globals.requirejs.s.contexts._.config);const L=r.getAllMethodNames(h);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(k)),o,L]);const R=(V,ee)=>this._request(V,ee),O=(V,ee)=>this._protocol.listen(V,ee);this._lazyProxy=new Promise((V,ee)=>{g=ee,this._onModuleLoaded.then(oe=>{V(l(oe,R,O))},oe=>{ee(oe),this._onError("Worker failed to load "+o,oe)})})}getProxyObject(){return this._lazyProxy}_request(n,o){return new Promise((h,g)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(n,o).then(h,g)},g)})}_onError(n,o){console.error(n),console.info(o)}}e.SimpleWorkerClient=P;function u(i){return i[0]==="o"&&i[1]==="n"&&I.isUpperAsciiLetter(i.charCodeAt(2))}function a(i){return/^onDynamic/.test(i)&&I.isUpperAsciiLetter(i.charCodeAt(9))}function l(i,n,o){const h=L=>function(){const R=Array.prototype.slice.call(arguments,0);return n(L,R)},g=L=>function(R){return o(L,R)};let k={};for(const L of i){if(a(L)){k[L]=g(L);continue}if(u(L)){k[L]=o(L,void 0);continue}k[L]=h(L)}return k}class s{constructor(n,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new S({sendMessage:(h,g)=>{n(h,g)},handleMessage:(h,g)=>this._handleMessage(h,g),handleEvent:(h,g)=>this._handleEvent(h,g)})}onmessage(n){this._protocol.handleMessage(n)}_handleMessage(n,o){if(n===d)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this._requestHandler[n].apply(this._requestHandler,o))}catch(h){return Promise.reject(h)}}_handleEvent(n,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(n)){const h=this._requestHandler[n].call(this._requestHandler,o);if(typeof h!="function")throw new Error(`Missing dynamic event ${n} on request handler.`);return h}if(u(n)){const h=this._requestHandler[n];if(typeof h!="function")throw new Error(`Missing event ${n} on request handler.`);return h}throw new Error(`Malformed event name ${n}`)}initialize(n,o,h,g){this._protocol.setWorkerId(n);const R=l(g,(O,V)=>this._protocol.sendMessage(O,V),(O,V)=>this._protocol.listen(O,V));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(r.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,C.globals.require.config(o)),new Promise((O,V)=>{(C.globals.require||$)([h],oe=>{if(this._requestHandler=oe.create(R),!this._requestHandler){V(new Error("No RequestHandler!"));return}O(r.getAllMethodNames(this._requestHandler))},V)}))}}e.SimpleWorkerServer=s;function c(i){return new s(i,null)}e.create=c}),define(Q[114],J([0,1,61,28,42]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(r,I){if(await new Promise((y,E)=>{const m=D.createReadStream(r),p=v.createHash("sha1");m.pipe(p);const t=(0,M.once)((w,b)=>{m.removeAllListeners(),p.removeAllListeners(),w?E(w):y(b)});m.once("error",t),m.once("end",t),p.once("error",t),p.once("data",w=>t(void 0,w.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=C}),define(Q[115],J([0,1,245]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(C="utf8"){this.stringDecoder=new v.StringDecoder(C),this.remaining=null}write(C){const r=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return r;let d=0,f,y=d;for(;y<I.length;)if(f=I.charCodeAt(y),f===13||f===10){if(r.push(I.substring(d,y)),y++,y<I.length){const E=f;f=I.charCodeAt(y),(E===13&&f===10||E===10&&f===13)&&y++}d=y}else y++;return this.remaining=d<I.length?I.substr(d):null,r}end(){return this.remaining}}e.LineDecoder=D}),define(Q[116],J([0,1,26]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(r){const I=r.replace(/\-/g,":").toLowerCase();return!D.has(I)}function C(){const r=(0,v.networkInterfaces)();for(let I in r){const d=r[I];if(d){for(const{mac:f}of d)if(M(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(Q[71],J([0,1,26,16,40,31,116]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,E=0;const m=(0,v.networkInterfaces)();for(let p in m){const t=m[p];if(t)for(const{mac:w,internal:b}of t)b||(E+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(y+=1))}this._value=E>0?y/E:0}return this._value}};let I;async function d(){return I||(I=(async()=>await f()||C.generateUuid())()),I}e.getMachineId=d;async function f(){try{const y=await new Promise((m,p)=>{$(["crypto"],m,p)}),E=(0,r.getMac)();return y.createHash("sha256").update(E,"utf8").digest("hex")}catch(y){D.onUnexpectedError(y);return}}}),define(Q[21],J([0,1,28,26,117,9,32,70,8,3,15,7,31]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function t(T,N=p.UNLINK){if((0,r.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");return N===p.UNLINK?b(T):w(T)}async function w(T){try{const N=(0,d.join)((0,D.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(T,N)}catch(G){return b(T)}b(N).catch(G=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function b(T){return e.Promises.rmdir(T,{recursive:!0,maxRetries:3})}function S(T){if((0,r.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(T,{recursive:!0})}e.rimrafSync=S;async function P(T,N){return l(await(N?u(T):(0,M.promisify)(v.readdir)(T)))}async function u(T){try{return await(0,M.promisify)(v.readdir)(T,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const N=[],G=await P(T);for(const q of G){let _=!1,U=!1,j=!1;try{const F=await e.Promises.lstat((0,d.join)(T,q));_=F.isFile(),U=F.isDirectory(),j=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}N.push({name:q,isFile:()=>_,isDirectory:()=>U,isSymbolicLink:()=>j})}return N}function a(T){return l(v.readdirSync(T))}e.readdirSync=a;function l(T){return T.map(N=>typeof N=="string"?f.isMacintosh?(0,I.normalizeNFC)(N):N:(N.name=f.isMacintosh?(0,I.normalizeNFC)(N.name):N.name,N))}async function s(T){const N=await P(T),G=[];for(const q of N)await i.existsDirectory((0,d.join)(T,q))&&G.push(q);return G}function c(T,N=1e3){return new Promise(G=>{let q=!1;const _=setInterval(()=>{q||(q=!0,v.access(T,U=>{q=!1,U&&(clearInterval(_),G(void 0))}))},N)})}e.whenDeleted=c;var i;(function(T){async function N(_){let U;try{if(U=await e.Promises.lstat(_),!U.isSymbolicLink())return{stat:U}}catch(j){}try{return{stat:await e.Promises.stat(_),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(f.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw F}throw j}}T.stat=N;async function G(_){try{const{stat:U,symbolicLink:j}=await T.stat(_);return U.isFile()&&j?.dangling!==!0}catch(U){}return!1}T.existsFile=G;async function q(_){try{const{stat:U,symbolicLink:j}=await T.stat(_);return U.isDirectory()&&j?.dangling!==!0}catch(U){}return!1}T.existsDirectory=q})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new C.ResourceQueue;function o(T,N,G){return n.queueFor(E.URI.file(T),y.extUriBiasedIgnorePathCase).queue(()=>{const q=L(G);return new Promise((_,U)=>g(T,N,q,j=>j?U(j):_()))})}let h=!0;function g(T,N,G,q){if(!h)return v.writeFile(T,N,{mode:G.mode,flag:G.flag},q);v.open(T,G.flag,G.mode,(_,U)=>{if(_)return q(_);v.writeFile(U,N,j=>{if(j)return v.close(U,()=>q(j));v.fdatasync(U,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),h=!1),v.close(U,A=>q(A))))})})}function k(T,N,G){const q=L(G);if(!h)return v.writeFileSync(T,N,{mode:q.mode,flag:q.flag});const _=v.openSync(T,q.flag,q.mode);try{v.writeFileSync(_,N);try{v.fdatasyncSync(_)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),h=!1}}finally{v.closeSync(_)}}e.writeFileSync=k;function L(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function R(T,N){if(T===N)return;async function G(q){try{const _=await e.Promises.lstat(q);if(_.isDirectory()||_.isSymbolicLink())return;await e.Promises.utimes(q,_.atime,new Date)}catch(_){}}try{await e.Promises.rename(T,N),await G(N)}catch(q){if(T.toLowerCase()!==N.toLowerCase()&&q.code==="EXDEV"||T.endsWith("."))await O(T,N,{preserveSymlinks:!1}),await t(T,p.MOVE),await G(N);else throw q}}async function O(T,N,G){return ee(T,N,{root:{source:T,target:N},options:G,handledSourcePaths:new Set})}const V=511;async function ee(T,N,G){if(G.handledSourcePaths.has(T))return;G.handledSourcePaths.add(T);const{stat:q,symbolicLink:_}=await i.stat(T);if(_){if(G.options.preserveSymlinks)try{return await K(T,N,G)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(_.dangling)return}return q.isDirectory()?oe(T,N,q.mode&V,G):ae(T,N,q.mode&V)}async function oe(T,N,G,q){await e.Promises.mkdir(N,{recursive:!0,mode:G});const _=await P(T);for(const U of _)await ee((0,d.join)(T,U),(0,d.join)(N,U),q)}async function ae(T,N,G){await e.Promises.copyFile(T,N),await e.Promises.chmod(N,G)}async function K(T,N,G){let q=await e.Promises.readlink(T);(0,r.isEqualOrParent)(q,G.root.source,!f.isLinux)&&(q=(0,d.join)(G.root.target,q.substr(G.root.source.length+1))),await e.Promises.symlink(q,N)}e.Promises=new class{get access(){return(0,M.promisify)(v.access)}get stat(){return(0,M.promisify)(v.stat)}get lstat(){return(0,M.promisify)(v.lstat)}get utimes(){return(0,M.promisify)(v.utimes)}get read(){return(0,M.promisify)(v.read)}get readFile(){return(0,M.promisify)(v.readFile)}get write(){return(0,M.promisify)(v.write)}get appendFile(){return(0,M.promisify)(v.appendFile)}get fdatasync(){return(0,M.promisify)(v.fdatasync)}get truncate(){return(0,M.promisify)(v.truncate)}get rename(){return(0,M.promisify)(v.rename)}get copyFile(){return(0,M.promisify)(v.copyFile)}get open(){return(0,M.promisify)(v.open)}get close(){return(0,M.promisify)(v.close)}get symlink(){return(0,M.promisify)(v.symlink)}get readlink(){return(0,M.promisify)(v.readlink)}get chmod(){return(0,M.promisify)(v.chmod)}get mkdir(){return(0,M.promisify)(v.mkdir)}get unlink(){return(0,M.promisify)(v.unlink)}get rmdir(){return(0,M.promisify)(v.rmdir)}get realpath(){return(0,M.promisify)(v.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return s}get writeFile(){return o}get rm(){return t}get move(){return R}get copy(){return O}}}),define(Q[82],J([0,1,28,8,25,21]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function r(y){const E=(0,D.dirname)(y);if(y===E)return y;const m=((0,D.basename)(y)||y).toLowerCase();try{const t=(0,C.readdirSync)(E).filter(w=>w.toLowerCase()===m);if(t.length===1){const w=r(E);if(w)return(0,D.join)(w,t[0])}else if(t.length>1){const w=t.indexOf(m);if(w>=0){const b=r(E);if(b)return(0,D.join)(b,t[w])}}}catch(p){}return null}e.realcaseSync=r;async function I(y){try{return await C.Promises.realpath(y)}catch(E){const m=f(y);return await C.Promises.access(m,v.constants.R_OK),m}}e.realpath=I;function d(y){try{return v.realpathSync(y)}catch(E){const m=f(y);return v.accessSync(m,v.constants.R_OK),m}}e.realpathSync=d;function f(y){return(0,M.rtrim)((0,D.normalize)(y),D.sep)}}),define(Q[118],J([0,1,62]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function D(I,d,f,y=1){let E=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!E)return E=!0,m(0)},f);M(I,d,y,t=>{if(!E)return E=!0,clearTimeout(p),m(t)})})}e.findFreePort=D;function M(I,d,f,y){if(d===0)return y(0);const E=new v.Socket;E.once("connect",()=>(r(E),M(I+f,d-1,f,y))),E.once("data",()=>{}),E.once("error",m=>(r(E),m.code!=="ECONNREFUSED"?M(I+f,d-1,f,y):y(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,d,f){let y=!1,E,m=1;const p=v.createServer({pauseOnConnect:!0});function t(w,b){y||(y=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),b(w))}return new Promise(w=>{E=setTimeout(()=>{t(0,w)},f),p.on("listening",()=>{t(I,w)}),p.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&m<d?(I++,m++,p.listen(I,"127.0.0.1")):t(0,w)}),p.on("close",()=>{t(0,w)}),p.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function r(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(Q[119],J([0,1,26,8,21]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,r=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(l,s,c){this.exePath=l,this.displayName=s,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:a=!1,findPreview:l=!1}={}){const s=m({useAlternateBitness:a});if(!s)return null;const c=D.join(s,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(c))return null;let i=-1,n=null;for(const g of await M.Promises.readdir(c)){let k=-1;if(l){const R=g.indexOf("-");if(R<0)continue;const O=g.substring(0,R);if(!C.test(O)||g.substring(R+1)!=="preview")continue;k=parseInt(O,10)}else{if(!C.test(g))continue;k=parseInt(g,10)}if(k<=i)continue;const L=D.join(c,g,"pwsh.exe");!await M.SymlinkSupport.existsFile(L)||(n=L,i=k)}if(!n)return null;const o=s.includes("x86")?" (x86)":"",h=l?" Preview":"";return new E(n,`PowerShell${h}${o}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:s,pwshMsixName:c}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:r,pwshMsixName:"PowerShell (Store)"};for(const i of await M.Promises.readdir(l))if(s.test(i)){const n=D.join(l,i,"pwsh.exe");return new E(n,c)}return null}function w(){const a=D.join(v.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function b(){const a=D.join(process.env.windir,f===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*S(){let a=await p();a&&(yield a),a=await p({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=w(),a&&(yield a),a=await p({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await p({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=b(),a&&(yield a)}async function*P(){for await(const a of S())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function u(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=u}),define(Q[83],J([0,1,43,10]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(r){return new Promise((I,d)=>{let f;const y=new Map;function E(p,t,w,b,S){const P=y.get(t);if(p===r||P){const u={name:m(w),cmd:w,pid:p,ppid:t,load:b,mem:S};y.set(p,u),p===r&&(f=u),P&&(P.children||(P.children=[]),P.children.push(u),P.children.length>1&&(P.children=P.children.sort((a,l)=>a.pid-l.pid)))}}function m(p){const t=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,S=/--utility-sub-type=network/,P=/--crashes-directory/,u=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(P.exec(p))return"electron-crash-reporter";if(u.exec(p))return"winpty-process";if(a.exec(p))return"console-window-host (Windows internal process)";let s=l.exec(p);if(s&&s.length===2)return s[1]==="renderer"?t.exec(p)?"shared-process":w.exec(p)?"issue-reporter":b.exec(p)?"process-explorer":"window":s[1]==="utility"&&S.exec(p)?"utility-network-service":s[1];const c=/[a-zA-Z-]+\.js/g;let i="";do s=c.exec(p),s&&(i+=s+" ");while(s);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,w)=>{$(["windows-process-tree"],t,w)}).then(t=>{t.getProcessList(r,w=>{t.getProcessCpuUsage(w,b=>{const S=new Map;b.forEach(P=>{const u=p(P.commandLine||"");S.set(P.pid,{name:m(u),cmd:u,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),f=S.get(r),f?(S.forEach(P=>{const u=S.get(P.ppid);u&&(u.children||(u.children=[]),u.children.push(P))}),S.forEach(P=>{P.children&&(P.children=P.children.sort((u,a)=>u.pid-a.pid))}),I(f)):d(new Error(`Root process ${r} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[f];const w=[];for(;t.length;){const S=t.shift();S&&(w.push(S.pid),S.children&&(t=t.concat(S.children)))}let b=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);b+=" "+w.join(" "),(0,v.exec)(b,{},(S,P,u)=>{if(S||u)d(S||new Error(u.toString()));else{const a=P.toString().split(`
`);for(let l=0;l<w.length;l++){const s=y.get(w[l]);s.load=parseFloat(a[l])}if(!f){d(new Error(`Root process ${r} not found`));return}I(f)}})};(0,v.exec)("which ps",{},(t,w,b)=>{if(t||b)if(process.platform!=="linux")d(t||new Error(b.toString()));else{const S=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);(0,v.exec)(S,{},(P,u,a)=>{P||a?d(P||new Error(a.toString())):(C(u,E),p())})}else{const S=w.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${S} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,a,l)=>{u||l&&!l.includes("screen size is bogus")?d(u||new Error(l.toString())):(C(a,E),process.platform==="linux"?p():f?I(f):d(new Error(`Root process ${r} not found`)))})}})}})}e.listProcesses=M;function C(r,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=r.toString().split(`
`);for(const y of f){const E=d.exec(y.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Q[120],J([0,1,28,23,32,2,70,8,3,21]),function($,e,v,D,M,C,r,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(t,w,b){return m({path:t,isDirectory:!1},w,b)}e.watchFile=y;function E(t,w,b){return m({path:t,isDirectory:!0},w,b)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function m(t,w,b){if(d.isMacintosh&&(0,M.isEqualOrParent)(t.path,"/Volumes/"))return b(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const S=(0,I.basename)(t.path),P=new Map;let u=!1,a=[(0,C.toDisposable)(()=>{P.forEach(l=>(0,C.dispose)(l)),P.clear()})];try{const l=(0,v.watch)(t.path);a.push((0,C.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const s=new Set;t.isDirectory&&f.Promises.readdir(t.path).then(c=>c.forEach(i=>s.add(i))),l.on("error",(c,i)=>{u||b(`Failed to watch ${t.path} for changes using fs.watch() (${c}, ${i})`)}),l.on("change",(c,i)=>{if(u)return;let n="";if(i&&(n=i.toString(),d.isMacintosh&&(n=(0,r.normalizeNFC)(n))),!n||c!=="change"&&c!=="rename")return;const o=t.isDirectory?(0,I.join)(t.path,n):t.path;if(t.isDirectory)if(c==="rename"){const h=P.get(o);h&&(0,C.dispose)(h);const g=setTimeout(async()=>{P.delete(o);const k=await f.Promises.exists(o);if(u)return;let L;k?s.has(n)?L="changed":(L="added",s.add(n)):(s.delete(n),L="deleted"),w(L,o)},e.CHANGE_BUFFER_DELAY);P.set(o,(0,C.toDisposable)(()=>clearTimeout(g)))}else{let h;s.has(n)?h="changed":(h="added",s.add(n)),w(h,o)}else if(c==="rename"||n!==S){const h=setTimeout(async()=>{const g=await f.Promises.exists(o);u||(g?(w("changed",o),a=[m(t,w,b)]):w("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,C.dispose)(a),a=[(0,C.toDisposable)(()=>clearTimeout(h))]}else w("changed",o)})}catch(l){f.Promises.exists(t.path).then(s=>{s&&!u&&b(`Failed to watch ${t.path} for changes using fs.watch() (${l.toString()})`)})}return(0,C.toDisposable)(()=>{u=!0,a=(0,C.dispose)(a)})}async function p(t,w,b,S=512){const P=await f.Promises.open(t,"r"),u=Buffer.allocUnsafe(S),a=new D.CancellationTokenSource(b);let l,s=!1;const c=y(t,async i=>{if(i==="changed"){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:n}=await f.Promises.read(P,u,0,S,null);if(!n||a.token.isCancellationRequested)break;w(u.slice(0,n))}}catch(n){l=new Error(n),a.dispose(!0)}finally{s=!1}}},i=>{l=new Error(i),a.dispose(!0)});return new Promise((i,n)=>{a.token.onCancellationRequested(async()=>{c.dispose(),await f.Promises.close(P),l?n(l):i()})})}e.watchFileContents=p}),define(Q[121],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[122],J([0,1,14,13,121]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){v.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(I,d,f,y,E)=>{const m=r(I,y,f);m.popup({window:(0,D.withNullAsUndefined)(v.BrowserWindow.fromWebContents(I.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{m&&I.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=C;function r(I,d,f){const y=new v.Menu;return f.forEach(E=>{let m;E.type==="separator"?m=new v.MenuItem({type:E.type}):Array.isArray(E.submenu)?m=new v.MenuItem({submenu:r(I,d,E.submenu),label:E.label}):m=new v.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(p,t,w)=>I.sender.send(d,E.id,w)}),y.append(m)}),y}});var ge=this&&this.__decorate||function($,e,v,D){var M=arguments.length,C=M<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,v):D,r;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate($,e,v,D);else for(var I=$.length-1;I>=0;I--)(r=$[I])&&(C=(M<3?r(C):M>3?r(e,v,C):r(e,v))||C);return M>3&&C&&Object.defineProperty(e,v,C),C};define(Q[35],J([0,1,30,9,17,23,46,16,4,2,111,25,13]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function b(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(S||(S={}));class P{constructor(U){this.buffer=U,this.pos=0}read(U){const j=this.buffer.slice(this.pos,this.pos+U);return this.pos+=j.byteLength,j}}class u{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var a;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(a||(a={}));function l(_){const U=M.VSBuffer.alloc(4);return U.writeUInt32BE(_,0),U}function s(_){return _.read(4).readUInt32BE(0)}function c(_){const U=M.VSBuffer.alloc(1);return U.writeUInt8(_,0),U}const i={Undefined:c(a.Undefined),String:c(a.String),Buffer:c(a.Buffer),VSBuffer:c(a.VSBuffer),Array:c(a.Array),Object:c(a.Object)},n=typeof Buffer!="undefined";function o(_,U){if(typeof U=="undefined")_.write(i.Undefined);else if(typeof U=="string"){const j=M.VSBuffer.fromString(U);_.write(i.String),_.write(l(j.byteLength)),_.write(j)}else if(n&&Buffer.isBuffer(U)){const j=M.VSBuffer.wrap(U);_.write(i.Buffer),_.write(l(j.byteLength)),_.write(j)}else if(U instanceof M.VSBuffer)_.write(i.VSBuffer),_.write(l(U.byteLength)),_.write(U);else if(Array.isArray(U)){_.write(i.Array),_.write(l(U.length));for(const j of U)o(_,j)}else{const j=M.VSBuffer.fromString(JSON.stringify(U));_.write(i.Object),_.write(l(j.byteLength)),_.write(j)}}function h(_){switch(_.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return _.read(s(_)).toString();case a.Buffer:return _.read(s(_)).buffer;case a.VSBuffer:return _.read(s(_));case a.Array:{const j=s(_),F=[];for(let A=0;A<j;A++)F.push(h(_));return F}case a.Object:return JSON.parse(_.read(s(_)).toString())}}class g{constructor(U,j,F=null,A=1e3){this.protocol=U,this.ctx=j,this.logger=F,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(U,j){this.channels.set(U,j),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const j=this.send([U.type]);this.logger&&this.logger.logOutgoing(j,0,1,b(U.type));return}case 201:case 202:case 204:case 203:{const j=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(j,U.id,1,b(U.type),U.data);return}}}send(U,j=void 0){const F=new u;return o(F,U),o(F,j),this.sendBuffer(F.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(j){return 0}}onRawMessage(U){const j=new P(U),F=h(j),A=h(j),W=F[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${t(W)}: ${F[2]}.${F[3]}`,A),this.onPromise({type:W,id:F[1],channelName:F[2],name:F[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${t(W)}: ${F[2]}.${F[3]}`,A),this.onEventListen({type:W,id:F[1],channelName:F[2],name:F[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:F[1]})}}onPromise(U){const j=this.channels.get(U.channelName);if(!j){this.collectPendingRequest(U);return}const F=new C.CancellationTokenSource;let A;try{A=j.call(this.ctx,U.name,U.arg,F.token)}catch(Y){A=Promise.reject(Y)}const W=U.id;A.then(Y=>{this.sendResponse({id:W,data:Y,type:201}),this.activeRequests.delete(U.id)},Y=>{Y instanceof Error?this.sendResponse({id:W,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:W,data:Y,type:203}),this.activeRequests.delete(U.id)});const B=(0,f.toDisposable)(()=>F.cancel());this.activeRequests.set(U.id,B)}onEventListen(U){const j=this.channels.get(U.channelName);if(!j){this.collectPendingRequest(U);return}const F=U.id,W=j.listen(this.ctx,U.name,U.arg)(B=>this.sendResponse({id:F,data:B,type:204}));this.activeRequests.set(U.id,W)}disposeActiveRequest(U){const j=this.activeRequests.get(U.id);j&&(j.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let j=this.pendingRequests.get(U.channelName);j||(j=[],this.pendingRequests.set(U.channelName,j));const F=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:U,timeoutTimer:F})}flushPendingRequests(U){const j=this.pendingRequests.get(U);if(j){for(const F of j)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var k;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(U,j=null){this.protocol=U,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=j}getChannel(U){const j=this;return{call(F,A,W){return j.isDisposed?Promise.reject(I.canceled()):j.requestPromise(U,F,A,W)},listen(F,A){return j.isDisposed?Promise.reject(I.canceled()):j.requestEvent(U,F,A)}}}requestPromise(U,j,F,A=C.CancellationToken.None){const W=this.lastRequestId++,Y={id:W,type:100,channelName:U,name:j,arg:F};if(A.isCancellationRequested)return Promise.reject(I.canceled());let x;return new Promise((X,ie)=>{if(A.isCancellationRequested)return ie(I.canceled());const re=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete(W),X(he.data);break;case 202:this.handlers.delete(W);const me=new Error(he.data.message);me.stack=he.data.stack,me.name=he.data.name,ie(me);break;case 203:this.handlers.delete(W),ie(he.data);break}};this.handlers.set(W,le),this.sendRequest(Y)};let se=null;this.state===S.Idle?re():(se=(0,D.createCancelablePromise)(le=>this.whenInitialized()),se.then(()=>{se=null,re()}));const Z=()=>{se?(se.cancel(),se=null):this.sendRequest({id:W,type:101}),ie(I.canceled())},ce=A.onCancellationRequested(Z);x=(0,f.combinedDisposable)((0,f.toDisposable)(Z),ce),this.activeRequests.add(x)}).finally(()=>{this.activeRequests.delete(x)})}requestEvent(U,j,F){const A=this.lastRequestId++,B={id:A,type:102,channelName:U,name:j,arg:F};let Y=null;const x=new d.Emitter({onFirstListenerAdd:()=>{Y=(0,D.createCancelablePromise)(X=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(x),this.sendRequest(B)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(x),this.sendRequest({id:A,type:103}))}}),z=X=>x.fire(X.data);return this.handlers.set(A,z),x.event}sendRequest(U){switch(U.type){case 100:case 102:{const j=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(j,U.id,0,`${t(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const j=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(j,U.id,0,t(U.type));return}}}send(U,j=void 0){const F=new u;return o(F,U),o(F,j),this.sendBuffer(F.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(j){return 0}}onBuffer(U){const j=new P(U),F=h(j),A=h(j),W=F[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,b(W)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],0,b(W),A),this.onResponse({type:F[0],id:F[1],data:A})}}onResponse(U){if(U.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(U.id);j&&j(U)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}ge([r.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class R{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:j,onDidClientDisconnect:F})=>{d.Event.once(j.onMessage)(W=>{const B=new P(W),Y=h(B),x=new g(j,Y),z=new L(j);this.channels.forEach((ie,re)=>x.registerChannel(re,ie));const X={channelServer:x,channelClient:z,ctx:Y};this._connections.add(X),this._onDidAddConnection.fire(X),F(()=>{x.dispose(),z.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const U=[];return this._connections.forEach(j=>U.push(j)),U}getChannel(U,j){const F=this;return{call(A,W,B){let Y;if((0,m.isFunction)(j)){let z=(0,v.getRandomElement)(F.connections.filter(j));Y=z?Promise.resolve(z):d.Event.toPromise(d.Event.filter(F.onDidAddConnection,j))}else Y=j.routeCall(F,A,W);const x=Y.then(z=>z.channelClient.getChannel(U));return V(x).call(A,W,B)},listen(A,W){if((0,m.isFunction)(j))return F.getMulticastEvent(U,j,A,W);const B=j.routeEvent(F,A,W).then(Y=>Y.channelClient.getChannel(U));return V(B).listen(A,W)}}}getMulticastEvent(U,j,F,A){const W=this;let B=new f.DisposableStore;const Y=new d.Emitter({onFirstListenerAdd:()=>{B=new f.DisposableStore;const x=new d.EventMultiplexer,z=new Map,X=re=>{const Z=re.channelClient.getChannel(U).listen(F,A),ce=x.add(Z);z.set(re,ce)},ie=re=>{const se=z.get(re);!se||(se.dispose(),z.delete(re))};W.connections.filter(j).forEach(X),d.Event.filter(W.onDidAddConnection,j)(X,void 0,B),W.onDidRemoveConnection(ie,void 0,B),x.event(Y.fire,Y,B),B.add(x)},onLastListenerRemove:()=>{B.dispose()}});return Y.event}registerChannel(U,j){this.channels.set(U,j),this._connections.forEach(F=>{F.channelServer.registerChannel(U,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class O{constructor(U,j,F=null){const A=new u;o(A,j),U.send(A.buffer),this.channelClient=new L(U,F),this.channelServer=new g(U,j,F)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,j){this.channelServer.registerChannel(U,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function V(_){return{call(U,j,F){return _.then(A=>A.call(U,j,F))},listen(U,j){const F=new d.Relay;return _.then(A=>F.input=A.listen(U,j)),F.event}}}e.getDelayedChannel=V;function ee(_){let U=!1;return{call(j,F,A){return U?_.call(j,F,A):(0,D.timeout)(0).then(()=>U=!0).then(()=>_.call(j,F,A))},listen(j,F){if(U)return _.listen(j,F);const A=new d.Relay;return(0,D.timeout)(0).then(()=>U=!0).then(()=>A.input=_.listen(j,F)),A.event}}}e.getNextTickChannel=ee;class oe{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const j of U.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await d.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=oe;var ae;(function(_){function U(W,B){const Y=W,x=B&&B.disableMarshalling,z=new Map;for(const X in Y)F(X)&&z.set(X,d.Event.buffer(Y[X],!0));return new class{listen(X,ie,re){const se=z.get(ie);if(se)return se;if(A(ie)){const Z=Y[ie];if(typeof Z=="function")return Z.call(Y,re)}throw new Error(`Event not found: ${ie}`)}call(X,ie,re){const se=Y[ie];if(typeof se=="function"){if(!x&&Array.isArray(re))for(let Z=0;Z<re.length;Z++)re[Z]=(0,y.revive)(re[Z]);return se.apply(Y,re)}throw new Error(`Method not found: ${ie}`)}}}_.fromService=U;function j(W,B){const Y=B&&B.disableMarshalling;return new Proxy({},{get(x,z){if(typeof z=="string")return B?.properties?.has(z)?B.properties.get(z):A(z)?function(X){return W.listen(z,X)}:F(z)?W.listen(z):async function(...X){let ie;B&&!(0,m.isUndefinedOrNull)(B.context)?ie=[B.context,...X]:ie=X;const re=await W.call(z,ie);return Y?re:(0,y.revive)(re)};throw new Error(`Property not found: ${String(z)}`)}})}_.toService=j;function F(W){return W[0]==="o"&&W[1]==="n"&&E.isUpperAsciiLetter(W.charCodeAt(2))}function A(W){return/^onDynamic/.test(W)&&E.isUpperAsciiLetter(W.charCodeAt(9))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let U=_.toString();if(U!=="[object Object]")return U}return _}function N(_){return Array.isArray(_)?_.map(T):T(_)}function G(_,U,j,F,A,W,B){B=N(B);const Y=K[A],x=Y[F%Y.length];let z=[`%c[${_}]%c[${String(U).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${x}`];/\($/.test(W)?(z=z.concat(B),z.push(")")):z.push(B),console.log.apply(console,z)}e.logWithColors=G;class q{constructor(U,j){this._outgoingPrefix=U,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,j,F,A,W){this._totalOutgoing+=U,G(this._outgoingPrefix,this._totalOutgoing,U,j,F,A,W)}logIncoming(U,j,F,A,W){this._totalIncoming+=U,G(this._incomingPrefix,this._totalIncoming,U,j,F,A,W)}}e.IPCLogger=q}),define(Q[123],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(M,C){this.sender=M,this.onMessage=C}send(M){try{this.sender.send("vscode:message",M.buffer)}catch(C){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Q[124],J([0,1,17,4,35]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(d){this.port=d,this.onMessage=D.Event.fromDOMEventEmitter(this.port,"message",f=>v.VSBuffer.wrap(f.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class r extends M.IPCClient{constructor(d,f){const y=new C(d);super(y,f);this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=r}),define(Q[84],J([0,1,17,4,2,3,35]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var I;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let d=null;function f(){return d||(d=v.VSBuffer.alloc(0)),d}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,n){if(i===0)return f();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const k=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=i),k}if(this._chunks[0].byteLength>i){const k=this._chunks[0].slice(0,i);return n&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),k}let o=v.VSBuffer.alloc(i),h=0,g=0;for(;i>0;){const k=this._chunks[g];if(k.byteLength>i){const L=k.slice(0,i);o.set(L,h),h+=i,n&&(this._chunks[g]=k.slice(i),this._totalLength-=i),i-=i}else o.set(k,h),h+=k.byteLength,n?(this._chunks.shift(),this._totalLength-=k.byteLength):g++,i-=k.byteLength}return o}}e.ChunkStream=y;var E;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.KeepAlive=4]="KeepAlive",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest"})(E||(E={}));var m;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",c[c.KeepAliveTime=5e3]="KeepAliveTime",c[c.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(i,n,o,h){this.type=i,this.id=n,this.ack=o,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class t extends M.Disposable{constructor(i){super();this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5);else{const o=this._state.messageType,h=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(o,h,g,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=v.VSBuffer.alloc(13);n.writeUInt8(i.type,0),n.writeUInt32BE(i.id,1),n.writeUInt32BE(i.ack,5),n.writeUInt32BE(i.data.byteLength,9),this._writeSoon(n,i.data)}_bufferAdd(i,n){const o=this._totalLength===0;return this._data.push(i,n),this._totalLength+=i.byteLength+n.byteLength,o}_bufferTake(){const i=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,n){this._bufferAdd(i,n)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends M.Disposable{constructor(i){super();this._onMessage=new D.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new t(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new p(1,0,0,i))}}e.Protocol=b;class S extends r.IPCClient{constructor(i,n,o=null){super(i,n,o);this.protocol=i}static fromSocket(i,n){return new S(new b(i),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=S;class P{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new D.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=P;class u{constructor(i){this.data=i,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],n=0,o=this._first;for(;o;)i[n++]=o.data,o=o.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const n=new u(i);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class l{constructor(){this.lastRuns=[];const i=Date.now();for(let n=0;n<l._HISTORY_LENGTH;n++)this.lastRuns[n]=i-1e3*n;setInterval(()=>{for(let n=l._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const i=Date.now(),n=(1+l._HISTORY_LENGTH)*1e3;let o=0;for(let h=0;h<l._HISTORY_LENGTH;h++)i-this.lastRuns[h]<=n&&o++;return 1-o/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class s{constructor(i,n=null,o=l.getInstance()){this._onControlMessage=new P,this.onControlMessage=this._onControlMessage.event,this._onMessage=new P,this.onMessage=this._onMessage.event,this._onDidDispose=new P,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new P,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new P,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new t(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),n&&this._socketReader.acceptChunk(n),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new p(5,0,0,f());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const n=new p(4,0,0,f());this._socketWriter.write(n),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,n){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new t(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let n=0,o=i.length;n<o;n++)this._socketWriter.write(i[n]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new p(6,0,0,f())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const n=this._outgoingUnackMsg.toArray();for(let o=0,h=n.length;o<h;o++)this._socketWriter.write(n[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,n,this._incomingAckId,i);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(i){const n=new p(2,0,0,i);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),n=Date.now()-i.writtenTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-n,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new p(3,0,this._incomingAckId,f());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(Q[125],J([0,1,14,17,4,2,35,123]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(y,E){const m=M.Event.fromNodeEventEmitter(v.ipcMain,E,(t,w)=>({event:t,message:w})),p=M.Event.filter(m,({event:t})=>t.sender.id===y);return M.Event.map(p,({message:t})=>t&&D.VSBuffer.wrap(t))}class f extends r.IPCServer{constructor(){super(f.getOnDidClientConnect())}static getOnDidClientConnect(){const E=M.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:m})=>m);return M.Event.map(E,m=>{const p=m.id,t=f.Clients.get(p);t&&t.dispose();const w=new M.Emitter;f.Clients.set(p,(0,C.toDisposable)(()=>w.fire()));const b=d(p,"vscode:message"),S=M.Event.any(M.Event.signal(d(p,"vscode:disconnect")),w.event);return{protocol:new I.Protocol(m,b),onDidClientDisconnect:S}})}}e.Server=f,f.Clients=new Map}),define(Q[85],J([0,1,14,4,31,124]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class r extends C.Client{constructor(f,y){super({addEventListener:(E,m)=>f.addListener(E,m),removeEventListener:(E,m)=>f.removeListener(E,m),postMessage:E=>f.postMessage(E),start:()=>f.start(),close:()=>f.close()},y)}}e.Client=r;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,M.generateUuid)();d.webContents.send("vscode:createMessageChannel",f);const y=D.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(m,p)=>({nonce:p,port:m.ports[0]})),{port:E}=await D.Event.toPromise(D.Event.once(D.Event.filter(y,m=>m.nonce===f)));return E}e.connect=I}),define(Q[86],J([0,1,9,4,2,13]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var r;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(r=e.StorageHint||(e.StorageHint={}));function I(E){const m=E;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(d||(d={}));class f extends M.Disposable{constructor(m,p=Object.create(null)){super();this.database=m,this.options=p,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((p,t)=>this.accept(t,p)),m.deleted?.forEach(p=>this.accept(p,void 0))}accept(m,p){if(this.state===d.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(p)?t=this.cache.delete(m):this.cache.get(m)!==p&&(this.cache.set(m,p),t=!0),t&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==r.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,p){const t=this.cache.get(m);return(0,C.isUndefinedOrNull)(t)?p:t}getBoolean(m,p){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?p:t==="true"}getNumber(m,p){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(m,p){if(this.state===d.Closed)return;if((0,C.isUndefinedOrNull)(p))return this.delete(m);const t=String(p);if(this.cache.get(m)!==t)return this.cache.set(m,t),this.pendingInserts.set(m,t),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===d.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((p,t)=>this.items.set(t,p)),m.delete&&m.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=y}),define(Q[126],J([0,1,9,4,40,8,21]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(y,E=Object.create(null)){this.path=y,this.options=E,this.name=(0,C.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return D.Event.None}async getItems(){const y=await this.whenConnected,E=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(p=>E.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(y){const E=await this.whenConnected;return this.doUpdateItems(E,y)}doUpdateItems(y,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,M.mapToString)(E.insert):"0"}), delete(${E.delete?(0,M.setToString)(E.delete):"0"})`),this.transaction(y,()=>{const m=E.insert,p=E.delete;if(m&&m.size>0){const t=[];t.push([]);let w=0;m.forEach((b,S)=>{let P=t[w];P.length>I.MAX_HOST_PARAMETERS&&(w++,P=[],t.push(P)),P.push(S,b)}),t.forEach(b=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,S=>S.run(b),()=>{const S=[];let P=0;return m.forEach((u,a)=>{S.push(a),P+=u.length}),`Keys: ${S.join(", ")} Length: ${P}`})})}if(p&&p.size){const t=[];t.push([]);let w=0;p.forEach(b=>{let S=t[w];S.length>I.MAX_HOST_PARAMETERS&&(w++,S=[],t.push(S)),S.push(b)}),t.forEach(b=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,S=>S.run(b),()=>{const S=[];return p.forEach(P=>{S.push(P)}),`Keys: ${S.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,y)}doClose(y,E){return new Promise((m,p)=>{y.db.close(t=>(t&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?m():!y.isErroneous&&!y.isInMemory?this.backup().then(m,w=>(this.logger.error(`[storage ${this.name}] backup(): ${w}`),m())):typeof E=="function"?r.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(w=>{const b=()=>this.doClose(w,void 0);return this.doUpdateItems(w,{insert:E()}).then(()=>b(),S=>(b(),Promise.reject(S)))})).then(m,p):p(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return r.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const E=await this.whenConnected,m=await this.get(E,y?"PRAGMA integrity_check":"PRAGMA quick_check"),p=y?m.integrity_check:m.quick_check;return E.isErroneous?`${p} (last error: ${E.lastError})`:E.isInMemory?`${p} (in-memory!)`:p}async connect(y,E=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${E})`);try{return await this.doConnect(y)}catch(m){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${m}`),m.code==="SQLITE_BUSY"&&E)return await(0,v.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await r.Promises.unlink(y);try{await r.Promises.rename(this.toBackupPath(y),y)}catch(p){}return await this.doConnect(y)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,E){y.isErroneous=!0,y.lastError=E,this.logger.error(E)}doConnect(y){return new Promise((E,m)=>{new Promise((p,t)=>{$(["@vscode/sqlite3"],p,t)}).then(p=>{const t={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(y,w=>w?t.db?t.db.close(()=>m(w)):m(w):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(t),b=>t.db.close(()=>m(b)))),isInMemory:y===I.IN_MEMORY_PATH};t.db.on("error",w=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${w}`)),this.logger.isTracing&&t.db.on("trace",w=>this.logger.trace(`[storage ${this.name}] Trace (event): ${w}`))},m)})}exec(y,E){return new Promise((m,p)=>{y.db.exec(E,t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${t}`),p(t)):m())})}get(y,E){return new Promise((m,p)=>{y.db.get(E,(t,w)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${t}`),p(t)):m(w))})}all(y,E){return new Promise((m,p)=>{y.db.all(E,(t,w)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${t}`),p(t)):m(w))})}transaction(y,E){return new Promise((m,p)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),E(),y.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${t}`),p(t)):m())})})}prepare(y,E,m,p){const t=y.db.prepare(E),w=b=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${b} (${E}). Details: ${p()}`)};t.on("error",w),m(t),t.finalize(b=>{b&&w(b),t.removeListener("error",w)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class d{constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[127],J([12,11]),function($,e){return $.create("vs/base/common/date",e)}),define(Q[128],J([0,1,127]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,M=D*60,C=M*24,r=C*7,I=C*30,d=C*365;function f(E,m){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,v.localize)(0,null,f(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let t;return p<D?(t=p,m?t===1?(0,v.localize)(2,null,t):(0,v.localize)(3,null,t):t===1?(0,v.localize)(4,null,t):(0,v.localize)(5,null,t)):p<M?(t=Math.floor(p/D),m?t===1?(0,v.localize)(6,null,t):(0,v.localize)(7,null,t):t===1?(0,v.localize)(8,null,t):(0,v.localize)(9,null,t)):p<C?(t=Math.floor(p/M),m?t===1?(0,v.localize)(10,null,t):(0,v.localize)(11,null,t):t===1?(0,v.localize)(12,null,t):(0,v.localize)(13,null,t)):p<r?(t=Math.floor(p/C),m?t===1?(0,v.localize)(14,null,t):(0,v.localize)(15,null,t):t===1?(0,v.localize)(16,null,t):(0,v.localize)(17,null,t)):p<I?(t=Math.floor(p/r),m?t===1?(0,v.localize)(18,null,t):(0,v.localize)(19,null,t):t===1?(0,v.localize)(20,null,t):(0,v.localize)(21,null,t)):p<d?(t=Math.floor(p/I),m?t===1?(0,v.localize)(22,null,t):(0,v.localize)(23,null,t):t===1?(0,v.localize)(24,null,t):(0,v.localize)(25,null,t)):(t=Math.floor(p/d),m?t===1?(0,v.localize)(26,null,t):(0,v.localize)(27,null,t):t===1?(0,v.localize)(28,null,t):(0,v.localize)(29,null,t))}e.fromNow=f;function y(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Q[129],J([12,11]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Q[44],J([0,1,30,13,129]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(f,y){return y&&(f.stack||f.stacktrace)?M.localize(0,null,I(f),r(f.stack)||r(f.stacktrace)):I(f)}function r(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?M.localize(1,null,f.message):f.message||M.localize(2,null)}function d(f=null,y=!1){if(!f)return M.localize(3,null);if(Array.isArray(f)){const E=v.coalesce(f),m=d(E[0],y);return E.length>1?M.localize(4,null,m,E.length):m}if(D.isString(f))return f;if(f.detail){const E=f.detail;if(E.error)return C(E.error,y);if(E.exception)return C(E.exception,y)}return f.stack?C(f,y):f.message?f.message:M.localize(5,null)}e.toErrorMessage=d}),define(Q[130],J([12,11]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(Q[131],J([0,1,130]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class D{constructor(r,I,d=I){this.modifierLabels=[null],this.modifierLabels[2]=r,this.modifierLabels[1]=I,this.modifierLabels[3]=d}toLabel(r,I,d){if(I.length===0)return null;const f=[];for(let y=0,E=I.length;y<E;y++){const m=I[y],p=d(m);if(p===null)return null;f[y]=M(m,p,this.modifierLabels[r])}return f.join(" ")}}e.ModifierLabelProvider=D,e.UILabelProvider=new D({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new D({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new D({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new D({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function M(C,r,I){if(r===null)return"";const d=[];return C.ctrlKey&&d.push(I.ctrlKey),C.shiftKey&&d.push(I.shiftKey),C.altKey&&d.push(I.altKey),C.metaKey&&d.push(I.metaKey),r!==""&&d.push(r),d.join(I.separator)}}),define(Q[132],J([12,11]),function($,e){return $.create("vs/base/node/processes",e)}),define(Q[72],J([0,1,43,32,10,47,8,3,34,80,13,115,21,132]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function t(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(s,c){if(I.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const n=v.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(o=>{n.once("error",h=>{o({success:!1,error:h})}),n.once("exit",(h,g)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?t(i.status):1})}else if(I.isLinux||I.isMacintosh)try{const i=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{v.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,h,g)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function b(s){!s||(delete s.DEBUG,I.isMacintosh&&delete s.DYLD_LIBRARY_PATH,I.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function S(s=d.env){return s.comspec||"cmd.exe"}e.getWindowsShell=S;class P{constructor(c,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=c,this.args=i,this.shell=n,this.options=o;else{const h=c;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(d.env).forEach(g=>{h[g]=d.env[g]}),Object.keys(this.options.env).forEach(g=>{h[g]=this.options.env[g]}),this.options.env=h}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(r.sep);return i!==-1&&(c=c.substring(i+1)),P.WellKnowCommands[c]?c:"other"}start(c){return I.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(d.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(i=>{let n,o;const h=new Promise((g,k)=>{n=g,o=k});if(i){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=v.exec(g,this.options,(k,L,R)=>{this.childProcess=null;const O=k;O&&O.killed?o({killed:this.terminateRequested,stdout:L.toString(),stderr:R.toString()}):this.handleExec(n,c,k,L,R)})}else{let g=null;const k=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,n,c,o);const R={terminated:this.terminateRequested};y.isNumber(L)&&(R.cmdCode=L),n(R)};if(this.shell&&I.isWindows){const L=C.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let R=!1,O=!1;const V=[];let ee=this.ensureQuotes(this.cmd);V.push(ee.value),R=ee.quoted,this.args&&this.args.forEach(ae=>{ee=this.ensureQuotes(ae),V.push(ee.value),O=O&&ee.quoted});const oe=["/s","/c"];R?O?oe.push('"'+V.join(" ")+'"'):V.length>1?oe.push('"'+V[0]+'" '+V.slice(1).join(" ")):oe.push('"'+V[0]+'"'):oe.push(V.join(" ")),g=v.spawn(S(),oe,L)}else this.cmd&&(g=v.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(y.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",L=>{this.childProcess=null,o({terminated:this.terminateRequested,error:L})}),g.pid&&(this.childProcess.on("close",k),this.handleSpawn(g,n,c,o,!0)))}return h})}handleClose(c,i,n,o){}ensureQuotes(c){return P.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,w(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!I.isWindows)return c(!1);const i=v.spawn(S(),["/s","/c"]);i.on("error",n=>c(!0)),i.on("exit",n=>c(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class u extends P{constructor(c,i,n,o){super(c,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,n,o,h){[o,h].forEach((g,k)=>{const L=new E.LineDecoder;L.write(g).forEach(V=>{i({line:V,source:k===0?0:1})});const O=L.end();O&&i({line:O,source:k===0?0:1})}),c({terminated:this.terminateRequested,error:n})}handleSpawn(c,i,n,o,h){const g=new E.LineDecoder,k=new E.LineDecoder;c.stdout.on("data",L=>{g.write(L).forEach(O=>n({line:O,source:0}))}),c.stderr.on("data",L=>{k.write(L).forEach(O=>n({line:O,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=k}handleClose(c,i,n,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&n({line:h,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&n({line:g,source:1})}}e.LineProcess=u;function a(s){let c=[],i=!1;const n=function(o){if(i){c.push(o);return}(!s.send(o,g=>{if(g&&console.error(g),i=!1,c.length>0){const k=c.slice(0);c=[],k.forEach(L=>n(L))}})||I.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=a;var l;(function(s){async function c(i,n,o){if(r.isAbsolute(i))return i;if(n===void 0&&(n=d.cwd()),r.dirname(i)!=="."||(o===void 0&&y.isString(d.env.PATH)&&(o=d.env.PATH.split(r.delimiter)),o===void 0||o.length===0))return r.join(n,i);async function g(k){if(await m.Promises.exists(k)){let L;try{L=await m.Promises.stat(k)}catch(R){R.message.startsWith("EACCES")&&(L=await m.Promises.lstat(k))}return L?!L.isDirectory():!1}return!1}for(let k of o){let L;if(r.isAbsolute(k)?L=r.join(k,i):L=r.join(n,k,i),await g(L))return L;let R=L+".com";if(await g(R)||(R=L+".exe",await g(R)))return R}return r.join(n,i)}s.findExecutable=c})(l=e.win32||(e.win32={}))}),define(Q[133],J([0,1,26,3,119,72]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function r(p,t){return p===1?D.isWindows?E():C.getWindowsShell(t):f(p,t)}e.getSystemShell=r;function I(p,t){return p===1?D.isWindows?m(t):C.getWindowsShell(t):f(p,t)}e.getSystemShellSync=I;let d=null;function f(p,t){if(D.isLinux&&p===2||D.isMacintosh&&p===3)return"/bin/bash";if(!d){let w;if(D.isWindows)w="/bin/bash";else{if(w=t.SHELL,!w)try{w=(0,v.userInfo)().shell}catch(b){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}d=w}return d}let y=null;async function E(){return y||(y=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),y}function m(p){if(y)return y;const t=D.isWindows&&parseFloat((0,v.release)())>=10,w=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${p.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?b:C.getWindowsShell(p)}}),define(Q[87],J([0,1,43,9,17,23,110,16,4,2,47,72,35]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends m.ChannelServer{constructor(b){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch(P){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",S=>M.VSBuffer.wrap(Buffer.from(S,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(b,S){this.modulePath=b,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new D.Delayer(P),this.child=null,this._client=null}getChannel(b){const S=this;return{call(P,u,a){return S.requestPromise(b,P,u,a)},listen(P,u){return S.requestEvent(b,P,u)}}}requestPromise(b,S,P,u=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),l=(0,D.createCancelablePromise)(i=>a.call(S,P,i)),s=u.onCancellationRequested(()=>l.cancel()),c=(0,f.toDisposable)(()=>l.cancel());return this.activeRequests.add(c),l.finally(()=>{s.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(b,S,P){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let u;const a=new d.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(b).listen(S,P)(a.fire,a),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,E.removeDangerousEnvVariables)(S.env),this.child=(0,v.fork)(this.modulePath,b,S);const P=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,r.isRemoteConsoleLog)(n)){(0,r.log)(n,`IPC Library: ${this.options.serverName}`);return}P.fire(M.VSBuffer.wrap(Buffer.from(n,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=n=>this.child&&this.child.connected&&a.send(n.buffer.toString("base64")),s=P.event,c={send:l,onMessage:s};this._client=new m.ChannelClient(c);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(h=>(0,f.dispose)(h)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(b){let S=this.channels.get(b);return S||(S=this.client.getChannel(b),this.channels.set(b,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Q[134],J([12,11]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(Q[135],J([12,11]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[136],J([12,11]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[137],J([12,11]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(Q[138],J([12,11]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(Q[139],J([12,11]),function($,e){return $.create("vs/platform/environment/node/shellEnv",e)}),define(Q[140],J([12,11]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[141],J([12,11]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[142],J([12,11]),function($,e){return $.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[143],J([12,11]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Q[144],J([12,11]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(Q[145],J([12,11]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Q[146],J([12,11]),function($,e){return $.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Q[147],J([12,11]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[148],J([12,11]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[149],J([12,11]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[150],J([12,11]),function($,e){return $.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[151],J([12,11]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Q[152],J([12,11]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[153],J([12,11]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[154],J([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(Q[155],J([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[156],J([12,11]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[157],J([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[158],J([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[159],J([0,1,4,2]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(I,d,f){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(I,d,f){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class C extends D.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,d,f){this.channel.call("attach",[I,d,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,d){this.channel.call("terminate",[I,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.channel.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=C}),define(Q[160],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(r){this.driver=r}listen(r,I){throw new Error(`No event found: ${I}`)}call(r,I,d){switch(I){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=v;class D{constructor(r){this.channel=r}click(r,I,d){return this.channel.call("click",[r,I,d])}doubleClick(r){return this.channel.call("doubleClick",r)}setValue(r,I){return this.channel.call("setValue",[r,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(r){return this.channel.call("isActiveElement",r)}getElements(r,I){return this.channel.call("getElements",[r,I])}getElementXY(r,I,d){return this.channel.call("getElementXY",[r,I,d])}typeInEditor(r,I){return this.channel.call("typeInEditor",[r,I])}getTerminalBuffer(r){return this.channel.call("getTerminalBuffer",r)}writeInTerminal(r,I){return this.channel.call("writeInTerminal",[r,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=D;class M{constructor(r){this.channel=r}registerWindowDriver(r){return this.channel.call("registerWindowDriver",r)}reloadWindowDriver(r){return this.channel.call("reloadWindowDriver",r)}}e.WindowDriverRegistryChannelClient=M}),define(Q[161],J([0,1,128,46,10,8,34,15,7]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(w,b,S){this._args=w,this.paths=b,this.productService=S}get appRoot(){return(0,C.dirname)(M.FileAccess.asFileUri("",$).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=r.env.VSCODE_PORTABLE;return w?d.URI.file((0,C.join)(w,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,C.resolve)(w):(0,C.normalize)((0,C.join)(M.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,C.resolve)(w):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,C.resolve)(w);const b=r.env.VSCODE_EXTENSIONS;if(b)return b;const S=r.env.VSCODE_PORTABLE;return S?(0,C.join)(S,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(b=>/^[^:/?#]+?:\/\//.test(b)?d.URI.parse(b):d.URI.file((0,C.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?d.URI.parse(w):d.URI.file((0,C.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!r.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([D.memoize],f.prototype,"appRoot",null),ge([D.memoize],f.prototype,"userHome",null),ge([D.memoize],f.prototype,"userDataPath",null),ge([D.memoize],f.prototype,"appSettingsHome",null),ge([D.memoize],f.prototype,"tmpDir",null),ge([D.memoize],f.prototype,"userRoamingDataHome",null),ge([D.memoize],f.prototype,"settingsResource",null),ge([D.memoize],f.prototype,"userDataSyncHome",null),ge([D.memoize],f.prototype,"userDataSyncLogResource",null),ge([D.memoize],f.prototype,"sync",null),ge([D.memoize],f.prototype,"machineSettingsResource",null),ge([D.memoize],f.prototype,"globalStorageHome",null),ge([D.memoize],f.prototype,"workspaceStorageHome",null),ge([D.memoize],f.prototype,"keybindingsResource",null),ge([D.memoize],f.prototype,"keyboardLayoutResource",null),ge([D.memoize],f.prototype,"argvResource",null),ge([D.memoize],f.prototype,"snippetsHome",null),ge([D.memoize],f.prototype,"isExtensionDevelopment",null),ge([D.memoize],f.prototype,"untitledWorkspacesHome",null),ge([D.memoize],f.prototype,"installSourcePath",null),ge([D.memoize],f.prototype,"builtinExtensionsPath",null),ge([D.memoize],f.prototype,"extensionsPath",null),ge([D.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ge([D.memoize],f.prototype,"extensionDevelopmentKind",null),ge([D.memoize],f.prototype,"extensionTestsLocationURI",null),ge([D.memoize],f.prototype,"debugExtensionHost",null),ge([D.memoize],f.prototype,"serviceMachineIdResource",null),ge([D.memoize],f.prototype,"telemetryLogResource",null),ge([D.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function y(t,w){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,w,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=y;function E(t,w){return p(t["inspect-search"],t["inspect-brk-search"],5876,w,t.extensionEnvironment)}e.parseSearchPort=E;function m(t,w){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,w,t.extensionEnvironment)}e.parsePtyHostPort=m;function p(t,w,b,S,P,u){const l=Number(w||t)||(S?null:b),s=l?Boolean(!!w):!1;let c;if(u)try{c=JSON.parse(u)}catch{}return{port:l,break:s,debugId:P,env:c}}}),define(Q[88],J([0,1,246,3,137]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const r={onUnknownOption:()=>{},onMultipleValues:()=>{}};function I(t,w,b=r){const S={},P=[],u=[];for(let c in w){const i=w[c];i.alias&&(S[c]=i.alias),i.type==="string"||i.type==="string[]"?(P.push(c),i.deprecates&&P.push(i.deprecates)):i.type==="boolean"&&(u.push(c),i.deprecates&&u.push(i.deprecates))}const a=v(t,{string:P,boolean:u,alias:S}),l={},s=a;l._=a._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(let c in w){const i=w[c];i.alias&&delete s[i.alias];let n=s[c];i.deprecates&&s.hasOwnProperty(i.deprecates)&&(n||(n=s[i.deprecates]),delete s[i.deprecates]),typeof n!="undefined"&&(i.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):i.type==="string"&&Array.isArray(n)&&(n=n.pop(),b.onMultipleValues(c,n)),l[c]=n),delete s[c]}for(let c in s)b.onUnknownOption(c);return l}e.parseArgs=I;function d(t,w){let b="";return w.args&&(Array.isArray(w.args)?b=` <${w.args.join("> <")}>`:b=` <${w.args}>`),w.alias?`-${w.alias} --${t}${b}`:`--${t}${b}`}function f(t,w){let b=0,S=[];for(const l in t){const s=t[l],c=d(l,s);b=Math.max(b,c.length),S.push([c,s.description])}let P=b+2+1;if(w-P<25)return S.reduce((l,s)=>l.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let u=w-P-1,a=[];for(const l of S){let s=l[0],c=E(l[1],u),i=y(P-s.length-2);a.push("  "+s+i+c[0]);for(let n=1;n<c.length;n++)a.push(y(P)+c[n])}return a}e.formatOptions=f;function y(t){return" ".repeat(t)}function E(t,w){let b=[];for(;t.length;){let S=t.length<w?t.length:t.lastIndexOf(" ",w),P=t.slice(0,S).trim();t=t.slice(S),b.push(P)}return b}function m(t,w,b,S,P){const u=process.stdout.isTTY&&process.stdout.columns||80,a=P?.noInputFiles!==!0?`[${(0,M.localize)(32,null)}...]`:"",l=[`${t} ${b}`];l.push(""),l.push(`${(0,M.localize)(33,null)}: ${w} [${(0,M.localize)(34,null)}]${a}`),l.push(""),P?.noPipe!==!0&&(D.isWindows?l.push((0,M.localize)(35,null,w)):l.push((0,M.localize)(36,null,w)),l.push(""));const s={};for(const c in S){const i=S[c];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[c]=i}}for(let c in s){const i=c;let n=s[i];n&&(l.push(C[i]),l.push(...f(n,u)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=m;function p(t,w){return`${t||(0,M.localize)(37,null)}
${w||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Q[162],J([0,1,62,159,88]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends D.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,d,f){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(f[0],f[1]):super.call(I,d,f)}async openExtensionDevelopmentHostWindow(I,d){const f=(0,M.parseArgs)(I,M.OPTIONS);f.debugRenderer=d;const y=f.extensionDevelopmentPath;if(!y)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:f});if(!d)return{success:!0};const m=E.win;if(!m)return{success:!0};const p=m.webContents.debugger;let t=p.isAttached()?Infinity:0;const w=(0,v.createServer)(b=>{t++==0&&p.attach();let S=!1;const P=l=>{S||b.write(JSON.stringify(l)+"\0")},u=(l,s,c,i)=>P({method:s,params:c,sessionId:i});m.on("close",()=>{p.removeListener("message",u),b.end(),S=!0}),p.addListener("message",u);let a=Buffer.alloc(0);b.on("data",l=>{a=Buffer.concat([a,l]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let c;try{const i=a.slice(0,s).toString("utf8");a=a.slice(s+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}p.sendCommand(c.method,c.params,c.sessionId).then(i=>P({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>P({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),b.on("error",l=>{console.error("error on cdp pipe:",l)}),b.on("close",()=>{S=!0,--t==0&&p.detach()})});return await new Promise(b=>w.listen(0,b)),m.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function $(e,v,D,M){function C(I){const d=r(I),f=[d];return e.isAbsolute(d)||f.unshift(M),e.resolve(...f)}function r(I){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,D);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(E,"AppData","Roaming")}break;case"darwin":f=e.join(v.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,D)}return{getUserDataPath:C}}if(typeof define=="function")define(Q[163],J([0,247,26,10,15,34]),function(e,v,D,M,C,r){const I=C.dirname(M.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(C.joinPath(I,"package.json").fsPath);return $(v,D,d.name,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),D=require("os");module.exports=$(v,D,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[164],J([0,1,26,161,163]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends D.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,M.getUserDataPath)(I)},d)}}e.NativeEnvironmentService=C}),define(Q[165],J([0,1,28,26,8]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(r){const I=(0,M.join)((0,D.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(I,""),r&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){r&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=C}),define(Q[166],J([0,1,141]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function C(m){return m=m.trim(),m==="*"||D.test(m)}e.isValidVersionStr=C;function r(m){if(!C(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=m.match(D);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=r;function I(m){if(!m)return null;let p=m.majorBase,t=m.majorMustEqual,w=m.minorBase,b=m.minorMustEqual,S=m.patchBase,P=m.patchMustEqual;m.hasCaret&&(p===0||(b=!1),P=!1);let u=0;if(m.preRelease){const a=M.exec(m.preRelease);if(a){const[,l,s,c]=a;u=Date.UTC(Number(l),Number(s)-1,Number(c))}}return{majorBase:p,majorMustEqual:t,minorBase:w,minorMustEqual:b,patchBase:S,patchMustEqual:P,isMinimum:m.hasGreaterEquals,notBefore:u}}e.normalizeVersion=I;function d(m,p,t){let w;typeof m=="string"?w=I(r(m)):w=m;let b;p instanceof Date?b=p.getTime():typeof p=="string"&&(b=new Date(p).getTime());let S;if(typeof t=="string"?S=I(r(t)):S=t,!w||!S)return!1;let P=w.majorBase,u=w.minorBase,a=w.patchBase,l=S.majorBase,s=S.minorBase,c=S.patchBase,i=S.notBefore,n=S.majorMustEqual,o=S.minorMustEqual,h=S.patchMustEqual;return S.isMinimum?P>l?!0:P<l?!1:u>s?!0:u<s||b&&b<i?!1:a>=c:(P===1&&l===0&&(!n||!o||!h)&&(l=1,s=0,c=0,n=!0,o=!1,h=!1),P<l?!1:P>l?!n:u<s?!1:u>s?!o:a<c?!1:a>c?!h:!(b&&b<i))}e.isValidVersion=d;function f(m,p,t,w){return t.isBuiltin||typeof t.main=="undefined"?!0:E(m,p,t.engines.vscode,w)}e.isValidExtensionVersion=f;function y(m,p,t){return m==="*"||E(p,t,m)}e.isEngineValid=y;function E(m,p,t,w=[]){let b=I(r(t));if(!b)return w.push(v.localize(0,null,t)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return w.push(v.localize(1,null,t)),!1}else if(!b.majorMustEqual)return w.push(v.localize(2,null,t)),!1;return d(m,p,b)?!0:(w.push(v.localize(3,null,m,t)),!1)}}),define(Q[167],J([0,1,4,2,17,60,23]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends D.Disposable{constructor(f,y){super();this.provider=f,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,y,E){const m=this.getUriTransformer(f);switch(y){case"stat":return this.stat(m,E[0]);case"readdir":return this.readdir(m,E[0]);case"open":return this.open(m,E[0],E[1]);case"close":return this.close(E[0]);case"read":return this.read(E[0],E[1],E[2]);case"readFile":return this.readFile(m,E[0]);case"write":return this.write(E[0],E[1],E[2],E[3],E[4]);case"writeFile":return this.writeFile(m,E[0],E[1],E[2]);case"rename":return this.rename(m,E[0],E[1],E[2]);case"copy":return this.copy(m,E[0],E[1],E[2]);case"mkdir":return this.mkdir(m,E[0]);case"delete":return this.delete(m,E[0],E[1]);case"watch":return this.watch(m,E[0],E[1],E[2],E[3]);case"unwatch":return this.unwatch(E[0],E[1])}throw new Error(`IPC Command ${y} not found`)}listen(f,y,E){const m=this.getUriTransformer(f);switch(y){case"fileChange":return this.onFileChange(m,E[0]);case"readFileStream":return this.onReadFileStream(m,E[0],E[1])}throw new Error(`Unknown event ${y}`)}stat(f,y){const E=this.transformIncoming(f,y,!0);return this.provider.stat(E)}readdir(f,y){const E=this.transformIncoming(f,y);return this.provider.readdir(E)}async readFile(f,y){const E=this.transformIncoming(f,y,!0),m=await this.provider.readFile(E);return M.VSBuffer.wrap(m)}onReadFileStream(f,y,E){const m=this.transformIncoming(f,y,!0),p=new r.CancellationTokenSource,t=new v.Emitter({onLastListenerRemove:()=>{p.cancel()}}),w=this.provider.readFileStream(m,E,p.token);return(0,C.listenStream)(w,{onData:b=>t.fire(M.VSBuffer.wrap(b)),onError:b=>t.fire(b),onEnd:()=>{t.fire("end"),t.dispose(),p.dispose()}}),t.event}writeFile(f,y,E,m){const p=this.transformIncoming(f,y);return this.provider.writeFile(p,E.buffer,m)}open(f,y,E){const m=this.transformIncoming(f,y,!0);return this.provider.open(m,E)}close(f){return this.provider.close(f)}async read(f,y,E){const m=M.VSBuffer.alloc(E),p=0,t=await this.provider.read(f,y,m.buffer,p,E);return[m,t]}write(f,y,E,m,p){return this.provider.write(f,y,E.buffer,m,p)}mkdir(f,y){const E=this.transformIncoming(f,y);return this.provider.mkdir(E)}delete(f,y,E){const m=this.transformIncoming(f,y);return this.provider.delete(m,E)}rename(f,y,E,m){const p=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.rename(p,t,m)}copy(f,y,E,m){const p=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.copy(p,t,m)}onFileChange(f,y){const E=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(f,E))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return E.event}async watch(f,y,E,m,p){const t=this.sessionToWatcher.get(y);if(t){const w=this.transformIncoming(f,m),b=t.watch(E,w,p);this.watchRequests.set(y+E,b)}}async unwatch(f,y){const E=f+y,m=this.watchRequests.get(E);m&&((0,D.dispose)(m),this.watchRequests.delete(E))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,D.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,D.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(Q[73],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(M,C=[],r=!1){this.ctor=M,this.staticArguments=C,this.supportsDelayedInstantiation=r}}e.SyncDescriptor=v}),define(Q[168],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=v;class D{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let r of this._nodes.values())r.outgoing.size===0&&C.push(r);return C}insertEdge(C,r){const I=this.lookupOrInsertNode(C),d=this.lookupOrInsertNode(r);I.outgoing.set(this._hashFn(r),d),d.incoming.set(this._hashFn(C),I)}removeNode(C){const r=this._hashFn(C);this._nodes.delete(r);for(let I of this._nodes.values())I.outgoing.delete(r),I.incoming.delete(r)}lookupOrInsertNode(C){const r=this._hashFn(C);let I=this._nodes.get(r);return I||(I=new v(C),this._nodes.set(r,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[r,I]of this._nodes)C.push(`${r}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,r]of this._nodes){const I=new Set([C]),d=this._findCycle(r,I);if(d)return d}}_findCycle(C,r){for(let[I,d]of C.outgoing){if(r.has(I))return[...r,I].join(" -> ");r.add(I);const f=this._findCycle(d,r);if(f)return f;r.delete(I)}}}e.Graph=D}),define(Q[5],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=I})(v=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function D(r,I,d,f){I[v.DI_TARGET]===I?I[v.DI_DEPENDENCIES].push({id:r,index:d,optional:f}):(I[v.DI_DEPENDENCIES]=[{id:r,index:d,optional:f}],I[v.DI_TARGET]=I)}function M(r){if(v.serviceIds.has(r))return v.serviceIds.get(r);const I=function(d,f,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(I,d,y,!1)};return I.toString=()=>r,v.serviceIds.set(r,I),I}e.createDecorator=M;function C(r){return r}e.refineServiceDecorator=C}),define(Q[74],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function D(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=D}),define(Q[89],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class D{constructor(C){this.machineId=C}encryption(){return new Promise((C,r)=>$(["vscode-encrypt"],C,r))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch(r){return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch(r){return C}}}e.EncryptionMainService=D}),define(Q[48],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[169],J([0,1,10,140,5]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function r(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function I(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function d(u,a){switch(u){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function f(u,a){return a==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function y(u,a,l){return f(a,l)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===l?!0:E(l).includes(u)}e.isTargetPlatformCompatible=y;function E(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function m(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=m;var p;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var t;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var w;(function(u){u.Install="install",u.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var b;(function(u){u[u.None=0]="None",u[u.Install=1]="Install",u[u.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var S;(function(u){u.Unsupported="Unsupported",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(Q[170],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Q[171],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Q[90],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Q[172],J([0,1,43,10,8,3,80,21,72,142,90]),function($,e,v,D,M,C,r,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=f.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends m{openTerminal(a,l){return this.spawnTerminal(v,a,d.getWindowsShell(),l)}spawnTerminal(a,l,s,c){const i=l.windowsExec||p.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const n=M.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return a.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((h,g)=>{const k=b(process),L=a.spawn(s,o,{cwd:c,env:k});L.on("error",g),L.on("exit",()=>h())})}runInTerminal(a,l,s,c,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:p.getDefaultTerminalWindows();return new Promise((o,h)=>{const g=`"${l} - ${E}"`,k=`""${s.join('" "')}" & pause"`,L=["/c","start",g,"/wait",n,"/c",k],R=Object.assign({},b(process),c);Object.keys(R).filter(ee=>R[ee]===null).forEach(ee=>delete R[ee]);const O={cwd:l,env:R,windowsVerbatimArguments:!0};v.spawn(p.CMD,L,O).on("error",ee=>{h(S(ee))}),o(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends m{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,s,c,i){const n=i.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((o,h)=>{if(n===y.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const g=n===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${g}.scpt`,$).fsPath,"-t",a||E,"-w",l];for(let V of s)L.push("-a"),L.push(V);if(c){const V=Object.assign({},b(process),c);for(let ee in V){const oe=V[ee];oe===null?(L.push("-u"),L.push(ee)):(L.push("-e"),L.push(`${ee}=${oe}`))}}let R="";const O=v.spawn(t.OSASCRIPT,L);O.on("error",V=>{h(S(V))}),O.stderr.on("data",V=>{R+=V.toString()}),O.on("exit",V=>{if(V===0)o(void 0);else if(R){const ee=R.split(`
`,1);h(new Error(ee[0]))}else h(new Error(f.localize(1,null,g,V)))})}else h(new Error(f.localize(2,null,n)))})}spawnTerminal(a,l,s){const c=l.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",c];s&&o.push(s);const h=b(process),g=a.spawn("/usr/bin/open",o,{cwd:s,env:h});g.on("error",n),g.on("exit",()=>i())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class w extends m{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,s,c,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{let g=[];n.then(k=>{k.indexOf("gnome-terminal")>=0?g.push("-x"):g.push("-e"),g.push("bash"),g.push("-c");const L=`${P(s)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;g.push(`''${L}''`);const R=Object.assign({},b(process),c);Object.keys(R).filter(oe=>R[oe]===null).forEach(oe=>delete R[oe]);const O={cwd:l,env:R};let V="";const ee=v.spawn(k,g,O);ee.on("error",oe=>{h(S(oe))}),ee.stderr.on("data",oe=>{V+=oe.toString()}),ee.on("exit",oe=>{if(oe===0)o(void 0);else if(V){const ae=V.split(`
`,1);h(new Error(ae[0]))}else h(new Error(f.localize(4,null,k,oe)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{a?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,s){const c=l.linuxExec?Promise.resolve(l.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{c.then(o=>{const h=b(process),g=a.spawn(o,[],{cwd:s,env:h});g.on("error",n),g.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=f.localize(3,null);function b(u){const a={...u.env};return(0,r.sanitizeProcessEnvironment)(a),a}function S(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(f.localize(5,null,u.path)):u}function P(u){let a="";for(let l of u)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(Q[18],J([0,1,40,8,25,13,7,144,5]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function f(T){return T.create===!0}e.isFileOpenForWriteOptions=f;var y;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var E;(function(T){T[T.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function(T){T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=p;function t(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=t;function w(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function b(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=b;var S;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(N,G){super(N);this.code=G}}e.FileSystemProviderError=P;function u(T,N){const G=new P(T.toString(),N);return l(G,N),G}e.createFileSystemProviderError=u;function a(T){return T||u((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=a;function l(T,N){return T.name=N?`${N} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=l;function s(T){if(!T)return S.Unknown;if(T instanceof P)return T.code;const N=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!N)return S.Unknown;switch(N[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=s;function c(T){if(T instanceof k)return T.fileOperationResult;switch(s(T)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var i;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(N,G,q){this.resource=N,this.operation=G,this.target=q}isOperation(N){return this.operation===N}}e.FileOperationEvent=n;var o;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class h{constructor(N,G){this.added=void 0,this.updated=void 0,this.deleted=void 0;const q=new Map;for(const _ of N){const U=q.get(_.type);U?U.push([_.resource,_]):q.set(_.type,[[_.resource,_]])}for(const[_,U]of q)switch(_){case 1:this.added=v.TernarySearchTree.forUris(()=>G),this.added.fill(U);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>G),this.updated.fill(U);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>G),this.deleted.fill(U);break}}contains(N,...G){return this.doContains(N,{includeChildren:!1},...G)}affects(N,...G){return this.doContains(N,{includeChildren:!0},...G)}doContains(N,G,...q){if(!N)return!1;const _=q.length>0;return!!((!_||q.includes(1))&&(this.added?.get(N)||G.includeChildren&&this.added?.findSuperstr(N))||(!_||q.includes(0))&&(this.updated?.get(N)||G.includeChildren&&this.updated?.findSuperstr(N))||(!_||q.includes(2))&&(this.deleted?.findSubstr(N)||G.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function g(T,N,G){return!T||!N||T===N||N.length>T.length?!1:(N.charAt(N.length-1)!==D.sep&&(N+=D.sep),G?(0,M.startsWithIgnoreCase)(T,N):T.indexOf(N)===0)}e.isParent=g;class k extends Error{constructor(N,G,q){super(N);this.fileOperationResult=G,this.options=q}}e.FileOperationError=k;class L extends k{constructor(N,G,q){super(N,2,q);this.stat=G}}e.NotModifiedSinceFileOperationError=L;var R;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=V;async function ee(T,N){if(!N.hasProvider(r.URI.from({scheme:T.scheme})))return new Promise(G=>{const q=N.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===T.scheme&&_.added&&(q.dispose(),G())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(N){return(0,C.isNumber)(N)||(N=0),N<oe.KB?(0,I.localize)(1,null,N.toFixed(0)):N<oe.MB?(0,I.localize)(2,null,(N/oe.KB).toFixed(2)):N<oe.GB?(0,I.localize)(3,null,(N/oe.MB).toFixed(2)):N<oe.TB?(0,I.localize)(4,null,(N/oe.GB).toFixed(2)):(0,I.localize)(5,null,(N/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var ae;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function K(T){return{maxFileSize:T===0?300*oe.MB:16*oe.GB,maxHeapSize:T===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=K}),define(Q[54],J([0,1,248,138,88,18]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function r(m,p){const t={onUnknownOption:b=>{console.warn((0,D.localize)(0,null,b))},onMultipleValues:(b,S)=>{console.warn((0,D.localize)(1,null,b,S))}},w=(0,M.parseArgs)(m,M.OPTIONS,p?t:void 0);return w.goto&&w._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,D.localize)(2,null))),w["max-memory"]&&v(parseInt(w["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function I(m){const p=m.findIndex(t=>!/^-/.test(t));if(p>-1)return[...m.slice(0,p),...m.slice(p+1)]}function d(m){let[,...p]=m;process.env.VSCODE_DEV&&(p=I(p)||[]);const t=!E(process.env);return r(p,t)}e.parseMainProcessArgv=d;function f(m){const[,,...p]=m;return r(p,!0)}e.parseCLIProcessArgv=f;function y(m,...p){const t=m.indexOf("--");return t===-1?m.push(...p):m.splice(t,0,...p),m}e.addArg=y;function E(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(Q[91],J([0,1,43,8,139,23,44,16,3,31,133,54,9]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let t;async function w(S,P,u){return P["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(u)&&!P["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(u)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=m.Promises.withAsyncBody(async(a,l)=>{const s=new C.CancellationTokenSource,c=setTimeout(()=>{s.dispose(!0),l(new Error((0,M.localize)(0,null)))},p);try{a(await b(S,s.token))}catch(i){!(0,I.isPromiseCanceledError)(i)&&!s.token.isCancellationRequested?l(new Error((0,M.localize)(1,null,(0,r.toErrorMessage)(i)))):a({})}finally{clearTimeout(c),s.dispose()}})),t)}e.resolveShellEnv=w;async function b(S,P){const u=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",u);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",a);const l=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(l+"(.*)"+l),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};S.trace("getUnixShellEnvironment#env",c);const i=await(0,y.getSystemShell)(d.OS,c);return S.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(P.isCancellationRequested)return o((0,I.canceled)());const h=(0,D.basename)(i);let g,k;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(g=`& '${process.execPath}' ${L} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,k=["-Login","-Command"]):(g=`'${process.execPath}' ${L} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,h==="tcsh"?k=["-ic"]:k=["-ilc"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),g);const R=(0,v.spawn)(i,[...k,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});P.onCancellationRequested(()=>(R.kill(),o((0,I.canceled)()))),R.on("error",ee=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,r.toErrorMessage)(ee)),o(ee)});const O=[];R.stdout.on("data",ee=>O.push(ee));const V=[];R.stderr.on("data",ee=>V.push(ee)),R.on("close",(ee,oe)=>{const ae=Buffer.concat(O).toString("utf8");S.trace("getUnixShellEnvironment#raw",ae);const K=Buffer.concat(V).toString("utf8");if(K.trim()&&S.trace("getUnixShellEnvironment#stderr",K),ee||oe)return o(new Error((0,M.localize)(2,null,ee,oe)));const T=s.exec(ae),N=T?T[1]:"{}";try{const G=JSON.parse(N);u?G.ELECTRON_RUN_AS_NODE=u:delete G.ELECTRON_RUN_AS_NODE,a?G.ELECTRON_NO_ATTACH_CONSOLE=a:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",G),n(G)}catch(G){S.error("getUnixShellEnvironment#errorCaught",(0,r.toErrorMessage)(G)),o(G)}})})}}),define(Q[92],J([0,1,17,16,145,18]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(y,E,m,p,t,w){let b;try{await I(y,E,m,p,t,w)}catch(S){b=S}finally{b&&t.errorTransformer&&(b=t.errorTransformer(b)),typeof b!="undefined"&&m.error(b),m.end()}}e.readFileIntoStream=r;async function I(y,E,m,p,t,w){d(w);const b=await y.open(E,{create:!1});try{d(w);let S=0,P=0,u=t&&typeof t.length=="number"?t.length:void 0,a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,s=0;do P=await y.read(b,l,a.buffer,s,a.byteLength-s),l+=P,s+=P,S+=P,typeof u=="number"&&(u-=P),s===a.byteLength&&(await m.write(p(a)),a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),s=0);while(P>0&&(typeof u!="number"||u>0)&&d(w)&&f(S,t));if(s>0){let c=s;typeof u=="number"&&(c=Math.min(s,u)),m.write(p(a.slice(0,c)))}}catch(S){throw(0,C.ensureFileSystemProviderError)(S)}finally{await y.close(b)}}function d(y){if(y.isCancellationRequested)throw(0,D.canceled)();return!0}function f(y,E){if(E?.limits){if(typeof E.limits.memory=="number"&&y>E.limits.memory)throw(0,C.createFileSystemProviderError)((0,M.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&y>E.limits.size)throw(0,C.createFileSystemProviderError)((0,M.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[55],J([0,1,2,3,7,18]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class r extends v.Disposable{constructor(m,p,t){super();this.onFileChanges=m,this.onLogMessage=p,this.verboseLogging=t,this.serviceDisposables=this._register(new v.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new v.DisposableStore;this.serviceDisposables.value=m,this.service=this.createService(m),this.service.setVerboseLogging(this.verboseLogging),m.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),m.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),m.add(this.service.onDidError(p=>this.onError(p)))}onError(m){this.restartCounter<r.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.service?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.service?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${m}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=r,r.MAX_RESTARTS=5;class I extends v.Disposable{}e.WatcherService=I;function d(E){return E.map(m=>({type:m.type,resource:M.URI.file(m.path)}))}e.toFileChanges=d;function f(E){const m=new y;for(const p of E)m.processEvent(p);return m.coalesce()}e.coalesceEvents=f;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return D.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const p=this.mapPathToChange.get(this.toKey(m));let t=!1;if(p){const w=p.type,b=m.type;p.path!==m.path&&m.type===2?t=!0:w===1&&b===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(p)):w===2&&b===1?p.type=0:w===1&&b===0||(p.type=b)}else t=!0;t&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],p=[];return Array.from(this.coalesced).filter(t=>t.type!==2?(m.push(t),!1):!0).sort((t,w)=>t.path.length-w.path.length).filter(t=>p.some(w=>(0,C.isParent)(t.path,w,!D.isLinux))?!1:(p.push(t.path),!0)).concat(m)}}}),define(Q[93],J([0,1,9,2,8,82,21,120,55]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class f extends D.Disposable{constructor(E,m,p,t){super();this.path=E,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=t,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:m}=await r.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(m)try{p=await(0,C.realpath)(p)}catch(t){if(this.onError(t),m.dangling)return}E.isDirectory()?this._register((0,I.watchFolder)(p,(t,w)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,M.join)(this.path,(0,M.basename)(w))})},t=>this.onError(t))):this._register((0,I.watchFile)(p,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,d.coalesceEvents)(m);if(this.verboseLogging)for(const t of p)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=f}),define(Q[173],J([0,1,10,35,87,55]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class r extends C.WatcherService{constructor(d,f,y){super();this.onDidFilesChange=d,this.onLogMessage=f,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const d=this._register(new M.Client(v.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f)))}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}async watch(d){this.isDisposed||await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=r}),define(Q[174],J([0,1,10,35,87,55]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class r extends C.AbstractWatcherService{constructor(d,f,y){super(d,f,y);this.init()}createService(d){const f=d.add(new M.Client(v.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(f.onDidProcessExit(({code:y,signal:E})=>this.onError(`terminated by itself with code ${y}, signal: ${E}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(f.getChannel("watcher")))}}e.FileWatcher=r}),define(Q[75],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...M){this._entries=new Map;for(let[C,r]of M)this.set(C,r)}set(M,C){const r=this._entries.get(M);return this._entries.set(M,C),r}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=v}),define(Q[175],J([0,1,9,16,73,168,5,75]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class f extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class y{constructor(t=new I.ServiceCollection,w=!1,b){this._activeInstantiations=new Set,this._services=t,this._strict=w,this._parent=b,this._services.set(r.IInstantiationService,this)}createChild(t){return new y(t,this._strict,this)}invokeFunction(t,...w){let b=m.traceInvocation(t),S=!1;try{return t({get:u=>{if(S)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(u,b);if(!a)throw new Error(`[invokeFunction] unknown service '${u}'`);return a}},...w)}finally{S=!0,b.stop()}}createInstance(t,...w){let b,S;return t instanceof M.SyncDescriptor?(b=m.traceCreation(t.ctor),S=this._createInstance(t.ctor,t.staticArguments.concat(w),b)):(b=m.traceCreation(t),S=this._createInstance(t,w,b)),b.stop(),S}_createInstance(t,w=[],b){let S=r._util.getServiceDependencies(t).sort((a,l)=>a.index-l.index),P=[];for(const a of S){let l=this._getOrCreateServiceInstance(a.id,b);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(l)}let u=S.length>0?S[0].index:w.length;if(w.length!==u){console.warn(`[createInstance] First service dependency of ${t.name} at position ${u+1} conflicts with ${w.length} static arguments`);let a=u-w.length;a>0?w=w.concat(new Array(a)):w=w.slice(0,u)}return new t(...[...w,...P])}_setServiceInstance(t,w){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,w);else if(this._parent)this._parent._setServiceInstance(t,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let w=this._services.get(t);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):w}_getOrCreateServiceInstance(t,w){let b=this._getServiceInstanceOrDescriptor(t);return b instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,b,w.branch(t,!0)):(w.branch(t,!1),b)}_safeCreateAndCacheServiceInstance(t,w,b){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,w,b)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,w,b){const S=new C.Graph(a=>a.id.toString());let P=0;const u=[{id:t,desc:w,_trace:b}];for(;u.length;){const a=u.pop();if(S.lookupOrInsertNode(a),P++>1e3)throw new f(S);for(let l of r._util.getServiceDependencies(a.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(l.id);if(!s&&!l.optional&&console.warn(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`),s instanceof M.SyncDescriptor){const c={id:l.id,desc:s,_trace:a._trace.branch(l.id,!0)};S.insertEdge(a,c),u.push(c)}}}for(;;){const a=S.roots();if(a.length===0){if(!S.isEmpty())throw new f(S);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof M.SyncDescriptor){const c=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,c)}S.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,w,b=[],S,P){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(w,b,S,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,w,b,S,P);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(t,w=[],b,S){if(b){const P=new v.IdleValue(()=>this._createInstance(t,w,S));return new Proxy(Object.create(null),{get(u,a){if(a in u)return u[a];let l=P.value,s=l[a];return typeof s!="function"||(s=s.bind(l),u[a]=s),s},set(u,a,l){return P.value[a]=l,!0}})}else return this._createInstance(t,w,S)}}e.InstantiationService=y;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class m{constructor(t,w){this.type=t,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new m(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(t){return d?new m(0,t.name):m._None}branch(t,w){let b=new m(2,t.toString());return this._dep.push([t,w,b]),b}stop(){let t=Date.now()-this._start;m._totals+=t;let w=!1;function b(P,u){let a=[],l=new Array(P+1).join("	");for(const[s,c,i]of u._dep)if(c&&i){w=!0,a.push(`${l}CREATES -> ${s}`);let n=b(P+1,i);n&&a.push(n)}else a.push(`${l}uses -> ${s}`);return a.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(t>2||w)&&console.log(S.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Q[176],J([0,1,16,131,59]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends M.ResolvedKeybinding{constructor(I,d){super();if(d.length===0)throw(0,v.illegalArgument)("parts");this._os=I,this._parts=d}getLabel(){return D.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return D.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:D.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return D.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new M.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=C}),define(Q[177],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(C,r,I,d,f,y,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?D(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=D(C.getSingleModifierDispatchParts())),this.bubble=r?r.charCodeAt(0)===94:!1,this.command=this.bubble?r.substr(1):r,this.commandArgs=I,this.when=d,this.isDefault=f,this.extensionId=y,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=v;function D(M){let C=[];for(let r=0,I=M.length;r<I;r++){const d=M[r];if(!d)return C;C.push(d)}return C}e.removeElementsAfterNulls=D}),define(Q[178],J([0,1,79,59,176,177]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class r extends M.BaseResolvedKeybinding{constructor(d,f){super(f,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return v.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const f=v.KeyCodeUtils.toUserSettingsUS(d.keyCode);return f&&f.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return r.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let f="";return d.ctrlKey&&(f+="ctrl+"),d.shiftKey&&(f+="shift+"),d.altKey&&(f+="alt+"),d.metaKey&&(f+="meta+"),f+=v.KeyCodeUtils.toString(d.keyCode),f}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const f=v.IMMUTABLE_CODE_TO_KEY_CODE[d];if(f!==-1)return f;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof D.SimpleKeybinding)return d;const f=this._scanCodeToKeyCode(d.scanCode);return f===0?null:new D.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,f)}static resolveUserBinding(d,f){const y=(0,C.removeElementsAfterNulls)(d.map(E=>this._resolveSimpleUserBinding(E)));return y.length>0?[new r(new D.ChordKeybinding(y),f)]:[]}}e.USLayoutResolvedKeybinding=r}),define(Q[179],J([0,1,9]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function D(M,C){if(M.length===0)return Promise.resolve(!1);const r=[];let I=!1;for(let d of M){if(d===!0)return Promise.resolve(!0);(0,v.isThenable)(d)&&r.push(d.then(f=>{f&&(I=!0)},f=>{C(f),I=!0}))}return v.Promises.settled(r).then(()=>I)}e.handleVetos=D}),define(Q[6],J([0,1,44,4,2,3,5]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,r.createDecorator)("logService"),e.ILoggerService=(0,r.createDecorator)("loggerService");function I(){return new Date().toISOString()}var d;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function f(c,i,n){switch(i){case d.Trace:c.trace(n);break;case d.Debug:c.debug(n);break;case d.Info:c.info(n);break;case d.Warning:c.warn(n);break;case d.Error:c.error(n);break;case d.Critical:c.critical(n);break;default:throw new Error("Invalid log level")}}e.log=f;function y(c){let i="";for(let n=0;n<c.length;n++){let o=c[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}i+=(n>0?" ":"")+o}return i}e.format=y;class E extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(d.Trace)&&this.log(d.Trace,y([i,...n]))}debug(i,...n){this.checkLogLevel(d.Debug)&&this.log(d.Debug,y([i,...n]))}info(i,...n){this.checkLogLevel(d.Info)&&this.log(d.Info,y([i,...n]))}warn(i,...n){this.checkLogLevel(d.Warning)&&this.log(d.Warning,y([i,...n]))}error(i,...n){if(this.checkLogLevel(d.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(d.Error,y(o))}else this.log(d.Error,y([i,...n]))}critical(i,...n){this.checkLogLevel(d.Critical)&&this.log(d.Critical,y([i,...n]))}flush(){}}e.AbstractMessageLogger=m;class p extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...n){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...n):console.log(`[main ${I()}]`,i,...n))}debug(i,...n){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...n):console.log(`[main ${I()}]`,i,...n))}info(i,...n){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...n):console.log(`[main ${I()}]`,i,...n))}warn(i,...n){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...n):console.warn(`[main ${I()}]`,i,...n))}error(i,...n){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...n):console.error(`[main ${I()}]`,i,...n))}critical(i,...n){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...n):console.error(`[main ${I()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class t extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=t;class w extends E{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class b extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=b;class S extends M.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=S;class P extends M.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?d.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class u{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(i){}getLevel(){return d.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=u;function a(c){if(c.verbose)return d.Trace;if(typeof c.logLevel=="string"){const i=l(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(c){switch(c){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=l;function s(c){switch(c){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=s});var te=this&&this.__param||function($,e){return function(v,D){e(v,D,$)}};define(Q[180],J([0,1,9,17,39,78,48,18,5,6]),function($,e,v,D,M,C,r,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var y;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(y=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(p,t,w){this.environmentService=p,this.fileService=t,this.logService=w,this.queue=new v.Queue}async updateSettings(p,t){return this.queue.queue(()=>this.doWrite(p,t))}async doWrite(p,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:w,mtime:b,etag:S}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=w.toString();const u=[];if((0,M.parse)(P,u,{allowTrailingComma:!0,allowEmptyContent:!0}),u.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(p,P,t)[0];if(a){P=P.substring(0,a.offset)+a.content+P.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(P),{etag:S,mtime:b})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,t)})}getEdits({value:p,path:t},w,b){return t.length?(0,C.setProperty)(w,t,p,b):[{content:JSON.stringify(p,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:w.length,offset:0}]}};E=ge([te(0,r.IEnvironmentService),te(1,I.IFileService),te(2,f.ILogService)],E),e.UserConfigurationFileService=E}),define(Q[181],J([0,1,30,9,16,4,2,8,55,6]),function($,e,v,D,M,C,r,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends r.Disposable{constructor(m){super();this.logService=m,this._onDidErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(m,p){return p.recursive?this.watchRecursive(m,p):this.watchNonRecursive(m)}watchRecursive(m,p){const t={path:this.toFilePath(m),excludes:p.excludes},w=(0,v.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,r.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,M.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,p){return m.watch(p)}watchNonRecursive(m){const p=this.createNonRecursiveWatcher(this.toFilePath(m),w=>this._onDidChangeFile.fire((0,d.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===f.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,r.combinedDisposable)(p,t)}onWatcherLogMessage(m){m.type==="error"&&this._onDidErrorOccur.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Q[182],J([0,1,30,9,17,23,4,69,2,40,10,63,15,60,143,18,92,6]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ye extends d.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new r.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new r.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new r.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new r.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new r.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new r.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new w.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new w.FileChangesEvent(l,!0)))),this.watchedResources=f.TernarySearchTree.forUris(l=>{const s=this.getProvider(l.scheme);return s?!this.isPathCaseSensitive(s):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const s=new d.DisposableStore;return s.add(l.onDidChangeFile(c=>this.onDidChangeFile(c,this.isPathCaseSensitive(l)))),s.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&s.add(l.onDidErrorOccur(c=>this._onError.fire(new Error(c)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,d.dispose)(s)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(s){l.push(s)}}),!this.provider.has(a)&&await D.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const s=this.provider.get(a.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return I.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,m.isAbsolutePath)(a))throw new w.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const s=new Error;throw s.name="ENOPRO",s.message=(0,t.localize)(1,null,a.toString()),s}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasReadWriteCapability)(l)||(0,w.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(s){throw(0,w.toFileSystemProviderErrorCode)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,w.ensureFileSystemProviderError)(s)}}async doResolveFile(a,l){const s=await this.withProvider(a),c=this.isPathCaseSensitive(s),i=l?.resolveTo,n=l?.resolveSingleChildDescendants,o=l?.resolveMetadata,h=await s.stat(a);let g;return this.toFileStat(s,a,h,void 0,!!o,(k,L)=>(g||(g=f.TernarySearchTree.forUris(()=>!c),g.set(a,!0),i&&g.fill(!0,i)),g.get(k.resource)||g.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&n?L===1:!1))}async toFileStat(a,l,s,c,i,n){const{providerExtUri:o}=this.getExtUri(a),h={resource:l,name:o.basename(l),isFile:(s.type&w.FileType.File)!=0,isDirectory:(s.type&w.FileType.Directory)!=0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&w.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,w.etag)({mtime:s.mtime,size:s.size})};if(h.isDirectory&&n(h,c)){try{const g=await a.readdir(l),k=await D.Promises.settled(g.map(async([L,R])=>{try{const O=o.joinPath(l,L),V=i?await a.stat(O):{type:R};return await this.toFileStat(a,O,V,g.length,i,n)}catch(O){return this.logService.trace(O),null}}));h.children=(0,v.coalesce)(k)}catch(g){this.logService.trace(g),h.children=[]}return h}return h}async resolveAll(a){return D.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(s){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(s){return s}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new w.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=M.VSBuffer.fromString(""),s){await this.doValidateCreateFile(a,s);const c=await this.writeFile(a,l);return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,c)),c}async writeFile(a,l,s){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(c);try{await this.validateWriteFile(c,a,s)||await this.mkdirp(c,i.dirname(a));let o;if((0,w.hasReadWriteCapability)(c)&&!(l instanceof M.VSBuffer))if((0,p.isReadableStream)(l)){const h=await(0,p.peekStream)(l,3);h.ended?o=M.VSBuffer.concat(h.buffer):o=h}else o=(0,p.peekReadable)(l,h=>M.VSBuffer.concat(h),3);else o=l;!(0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasReadWriteCapability)(c)&&o instanceof M.VSBuffer?await this.doWriteUnbuffered(c,a,s,o):await this.doWriteBuffered(c,a,s,o instanceof M.VSBuffer?(0,M.bufferToReadable)(o):o)}catch(n){throw new w.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,w.ensureFileSystemProviderError)(n).toString()),(0,w.toFileOperationResult)(n),s)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,s){if(!!s?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(l)));let i;try{i=await a.stat(l)}catch(n){return}if((i.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,t.localize)(6,null,this.resourceForError(l)),0,s);if(this.throwIfFileIsReadonly(l,i),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&s.mtime<i.mtime&&s.etag!==(0,w.etag)({mtime:s.mtime,size:i.size}))throw new w.FileOperationError((0,t.localize)(7,null),3,s);return i}async readFile(a,l){const s=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(s,a,l):this.doReadFile(s,a,l)}async doReadFileAtomic(a,l,s){return new Promise((c,i)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(a,l,s);c(n)}catch(n){i(n)}})})}async doReadFile(a,l,s){const c=await this.doReadFileStream(a,l,{...s,preferUnbuffered:!0});return{...c,value:await(0,M.streamToBuffer)(c.value)}}async readFileStream(a,l){const s=await this.withReadProvider(a);return this.doReadFileStream(s,a,l)}async doReadFileStream(a,l,s){const c=new C.CancellationTokenSource,i=this.validateReadFile(l,s).then(o=>o,o=>{throw c.cancel(),o});let n;try{return typeof s?.etag=="string"&&s.etag!==w.ETAG_DISABLED&&await i,!((0,w.hasOpenReadWriteCloseCapability)(a)||(0,w.hasFileReadStreamCapability)(a))||(0,w.hasReadWriteCapability)(a)&&s?.preferUnbuffered?n=this.readFileUnbuffered(a,l,s):(0,w.hasFileReadStreamCapability)(a)?n=this.readFileStreamed(a,l,c.token,s):n=this.readFileBuffered(a,l,c.token,s),{...await i,value:n}}catch(o){n&&await(0,p.consumeStream)(n);const h=(0,t.localize)(8,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(h,o.stat,s):new w.FileOperationError(h,(0,w.toFileOperationResult)(o),s)}}readFileStreamed(a,l,s,c=Object.create(null)){const i=a.readFileStream(l,c,s);return(0,p.transform)(i,{data:n=>n instanceof M.VSBuffer?n:M.VSBuffer.wrap(n),error:n=>new w.FileOperationError((0,t.localize)(9,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(n).toString()),(0,w.toFileOperationResult)(n),c)},n=>M.VSBuffer.concat(n))}readFileBuffered(a,l,s,c=Object.create(null)){const i=(0,M.newWriteableBufferStream)();return(0,b.readFileIntoStream)(a,l,i,n=>n,{...c,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new w.FileOperationError((0,t.localize)(10,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(n).toString()),(0,w.toFileOperationResult)(n),c)},s),i}readFileUnbuffered(a,l,s){const c=(0,p.newWriteableStream)(i=>M.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(l);typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.validateReadFileLimits(l,i.byteLength,s),c.end(M.VSBuffer.wrap(i))}catch(i){c.error(i),c.end()}})(),c}async validateReadFile(a,l){const s=await this.resolve(a,{resolveMetadata:!0});if(s.isDirectory)throw new w.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==w.ETAG_DISABLED&&l.etag===s.etag)throw new w.NotModifiedSinceFileOperationError((0,t.localize)(12,null),s,l);return this.validateReadFileLimits(a,s.size,l),s}validateReadFileLimits(a,l,s){if(s?.limits){let c;if(typeof s.limits.memory=="number"&&l>s.limits.memory&&(c=9),typeof s.limits.size=="number"&&l>s.limits.size&&(c=7),typeof c=="number")throw new w.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),c)}}async canMove(a,l,s){return this.doCanMoveCopy(a,l,"move",s)}async canCopy(a,l,s){return this.doCanMoveCopy(a,l,"copy",s)}async doCanMoveCopy(a,l,s,c){if(a.toString()!==l.toString())try{const i=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(i,a,n,l,s,c)}catch(i){return i}return!0}async move(a,l,s){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=await this.doMoveCopy(c,a,i,l,"move",!!s),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,n==="move"?2:3,o)),o}async copy(a,l,s){const c=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=await this.doMoveCopy(c,a,i,l,"copy",!!s),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,n==="copy"?3:2,o)),o}async doMoveCopy(a,l,s,c,i,n){if(l.toString()===c.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(a,l,s,c,i,n);if(o&&!h&&n&&await this.del(c,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(c)),i==="copy"){if(a===s&&(0,w.hasFileFolderCopyCapability)(a))await a.copy(l,c,{overwrite:n});else{const g=await this.resolve(l);g.isDirectory?await this.doCopyFolder(a,g,s,c):await this.doCopyFile(a,l,s,c)}return i}else return a===s?(await a.rename(l,c,{overwrite:n}),i):(await this.doMoveCopy(a,l,s,c,"copy",n),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,s,c){if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(a,l,s,c);if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(a,l,s,c);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(a,l,s,c);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasReadWriteCapability)(s))return this.doPipeUnbuffered(a,l,s,c)}async doCopyFolder(a,l,s,c){await s.mkdir(c),Array.isArray(l.children)&&await D.Promises.settled(l.children.map(async i=>{const n=this.getExtUri(s).providerExtUri.joinPath(c,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),s,n):this.doCopyFile(a,i.resource,s,n)}))}async doValidateMoveCopy(a,l,s,c,i,n){let o=!1;if(a===s){const{providerExtUri:g,isPathCaseSensitive:k}=this.getExtUri(a);if(k||(o=g.isEqual(l,c)),o&&i==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(l),this.resourceForError(c)));if(!o&&g.isEqualOrParent(c,l))throw new Error((0,t.localize)(15,null,this.resourceForError(l),this.resourceForError(c)))}const h=await this.exists(c);if(h&&!o){if(!n)throw new w.FileOperationError((0,t.localize)(16,null,this.resourceForError(l),this.resourceForError(c)),4);if(a===s){const{providerExtUri:g}=this.getExtUri(a);if(g.isEqualOrParent(l,c))throw new Error((0,t.localize)(17,null,this.resourceForError(l),this.resourceForError(c)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,s)),s}async mkdirp(a,l){const s=[],{providerExtUri:c}=this.getExtUri(a);for(;!c.isEqual(l,c.dirname(l));)try{if(((await a.stat(l)).type&w.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(l)));break}catch(i){if((0,w.toFileSystemProviderErrorCode)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(c.basename(l)),l=c.dirname(l)}for(let i=s.length-1;i>=0;i--){l=c.joinPath(l,s[i]);try{await a.mkdir(l)}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(s){return s}return!0}async doValidateDelete(a,l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(s.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let i;try{i=await s.stat(a)}catch(o){}if(i)this.throwIfFileIsReadonly(a,i);else throw new w.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return s}async del(a,l){const s=await this.doValidateDelete(a,l),c=!!l?.useTrash,i=!!l?.recursive;await s.delete(a,{recursive:i,useTrash:c}),this._onDidRunOperation.fire(new w.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let s,c;{for(const i of a)this.watchedResources.has(i.resource)?(s||(s=[]),s.push(i)):(c||(c=[]),c.push(i));s&&this._onDidFilesChange.fire(new w.FileChangesEvent(s,!l))}if(c){const i=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(c)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${c[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const s=new d.DisposableStore;let c=!1,i=()=>{c=!0};return s.add((0,d.toDisposable)(()=>i())),this.doWatch(a,l).then(n=>{c?(0,d.dispose)(n):i=()=>(0,d.dispose)(n)},n=>this.logService.error(n)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),s.add((0,d.toDisposable)(()=>{const n=this.watchedResources.get(a);typeof n=="number"&&(n<=1?this.watchedResources.delete(a):this.watchedResources.set(a,n-1))}))),s}async doWatch(a,l){const s=await this.withProvider(a),c=this.toWatchKey(s,a,l);let i=this.activeWatchers.get(c);return i||(i={count:0,disposable:s.watch(a,l)},this.activeWatchers.set(c,i)),i.count+=1,(0,d.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,d.dispose)(i.disposable),this.activeWatchers.delete(c)))})}toWatchKey(a,l,s){const{providerExtUri:c}=this.getExtUri(a);return[c.getComparisonKey(l),String(s.recursive),s.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,d.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,s,c){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const i=await a.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,p.isReadableStream)(c)||(0,p.isReadableBufferedStream)(c)?await this.doWriteStreamBufferedQueued(a,i,c):await this.doWriteReadableBufferedQueued(a,i,c)}catch(n){throw(0,w.ensureFileSystemProviderError)(n)}finally{await a.close(i)}})}async doWriteStreamBufferedQueued(a,l,s){let c=0,i;if((0,p.isReadableBufferedStream)(s)){if(s.buffer.length>0){const n=M.VSBuffer.concat(s.buffer);await this.doWriteBuffer(a,l,n,n.byteLength,c,0),c+=n.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((n,o)=>{(0,p.listenStream)(i,{onData:async h=>{i.pause();try{await this.doWriteBuffer(a,l,h,h.byteLength,c,0)}catch(g){return o(g)}c+=h.byteLength,setTimeout(()=>i.resume())},onError:h=>o(h),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(a,l,s){let c=0,i;for(;(i=s.read())!==null;)await this.doWriteBuffer(a,l,i,i.byteLength,c,0),c+=i.byteLength}async doWriteBuffer(a,l,s,c,i,n){let o=0;for(;o<c;)o+=await a.write(l,i+o,s.buffer,n+o,c-o)}async doWriteUnbuffered(a,l,s,c){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,s,c))}async doWriteUnbufferedQueued(a,l,s,c){let i;c instanceof M.VSBuffer?i=c:(0,p.isReadableStream)(c)?i=await(0,M.streamToBuffer)(c):(0,p.isReadableBufferedStream)(c)?i=await(0,M.bufferedStreamToBuffer)(c):i=(0,M.readableToBuffer)(c),await a.writeFile(l,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(a,l,s,c){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,s,c))}async doPipeBufferedQueued(a,l,s,c){let i,n;try{i=await a.open(l,{create:!1}),n=await s.open(c,{create:!0,unlock:!1});const o=M.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,g=0,k=0;do k=await a.read(i,h,o.buffer,g,o.byteLength-g),await this.doWriteBuffer(s,n,o,k,h,g),h+=k,g+=k,g===o.byteLength&&(g=0);while(k>0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await D.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof n=="number"?s.close(n):Promise.resolve()])}}async doPipeUnbuffered(a,l,s,c){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,s,c))}async doPipeUnbufferedQueued(a,l,s,c){return s.writeFile(c,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,s,c){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,s,c))}async doPipeUnbufferedToBufferedQueued(a,l,s,c){const i=await s.open(c,{create:!0,unlock:!1});try{const n=await a.readFile(l);await this.doWriteBuffer(s,i,M.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,w.ensureFileSystemProviderError)(n)}finally{await s.close(i)}}async doPipeBufferedToUnbuffered(a,l,s,c){const i=await(0,M.streamToBuffer)(this.readFileBuffered(a,l,C.CancellationToken.None));await this.doWriteUnbuffered(s,c,void 0,i)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new w.FileOperationError((0,t.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=ge([te(0,S.ILogService)],P),e.FileService=P}),define(Q[183],J([0,1,14,146,3,7,18,93,8,2,55,6,167,112]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends m.AbstractDiskFileSystemProviderChannel{constructor(S,P){super(S,P)}getUriTransformer(S){return p.DefaultURITransformer}transformIncoming(S,P){return C.URI.revive(P)}async delete(S,P,u){if(!u.useTrash)return super.delete(S,P,u);const a=this.transformIncoming(S,P),l=(0,d.normalize)(a.fsPath);try{await v.shell.trashItem(l)}catch(s){throw(0,r.createFileSystemProviderError)(M.isWindows?(0,D.localize)(0,null,(0,d.basename)(l)):(0,D.localize)(1,null,(0,d.basename)(l)),r.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(S,P){return new w(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class w extends f.Disposable{constructor(S,P){super();this.sessionEmitter=S,this.logService=P,this.watcherRequests=new Map}watch(S,P,u){if(u.recursive)throw(0,r.createFileSystemProviderError)("Recursive watcher is not supported from main process",r.FileSystemProviderErrorCode.Unavailable);const a=new f.DisposableStore;this.watcherRequests.set(S,a),a.add((0,f.toDisposable)(()=>this.watcherRequests.delete(S)));const l=a.add(new I.FileWatcher((0,d.normalize)(P.fsPath),s=>this.sessionEmitter.fire((0,y.toFileChanges)(s)),s=>this.onWatcherLogMessage(s),this.logService.getLevel()===E.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),a}onWatcherLogMessage(S){S.type==="error"&&this.sessionEmitter.fire(S.message),this.logService[S.type](S.message)}dispose(){super.dispose(),this.watcherRequests.forEach(S=>(0,f.dispose)(S)),this.watcherRequests.clear()}}}),define(Q[94],J([0,1,28,249,9,17,4,32,8,3,15,60,21,147,18,92,93,173,174,181,44]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(v)}catch(s){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(s)}`)}})();class l extends u.AbstractDiskFileSystemProvider{constructor(c,i){super(c);this.options=i,this.onDidChangeCapabilities=r.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(c){try{const{stat:i,symbolicLink:n}=await m.SymlinkSupport.stat(this.toFilePath(c));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(c){try{const i=await m.Promises.readdir(this.toFilePath(c),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,y.joinPath)(c,o.name))).type:h=this.toType(o),n.push([o.name,h])}catch(h){this.logService.trace(h)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(c,i){let n;return i?.dangling?n=t.FileType.Unknown:c.isFile()?n=t.FileType.File:c.isDirectory()?n=t.FileType.Directory:n=t.FileType.Unknown,i&&(n|=t.FileType.SymbolicLink),n}async readFile(c){try{const i=this.toFilePath(c);return await m.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}}readFileStream(c,i,n){const o=(0,E.newWriteableStream)(h=>C.VSBuffer.concat(h.map(g=>C.VSBuffer.wrap(g))).buffer);return(0,w.readFileIntoStream)(this,c,o,h=>h.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(c,i,n){let o;try{const h=this.toFilePath(c);if(!n.create||!n.overwrite){if(await m.Promises.exists(h)){if(!n.overwrite)throw(0,t.createFileSystemProviderError)((0,p.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,t.createFileSystemProviderError)((0,p.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(c,{create:!0,unlock:n.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(c,h)}finally{typeof o=="number"&&await this.close(o)}}async open(c,i){try{const n=this.toFilePath(c);if((0,t.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:g}=await m.SymlinkSupport.stat(n);g.mode&128||await m.Promises.chmod(n,g.mode|128)}catch(g){this.logService.trace(g)}let o;if((0,t.isFileOpenForWriteOptions)(i)){if(f.isWindows)try{await m.Promises.truncate(n,0),o="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}o||(o="w")}else o="r";const h=await m.Promises.open(n,o);return this.mapHandleToPos.set(h,0),(0,t.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(h,c),h}catch(n){throw(0,t.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(c,n):this.toFileSystemProviderError(n)}}async close(c){try{if(this.mapHandleToPos.delete(c),this.writeHandles.delete(c)&&this.canFlush)try{await m.Promises.fdatasync(c)}catch(i){this.canFlush=!1,this.logService.error(i)}return await m.Promises.close(c)}catch(i){throw this.toFileSystemProviderError(i)}}async read(c,i,n,o,h){const g=this.normalizePos(c,i);let k=null;try{const L=await m.Promises.read(c,n,o,h,g);return typeof L=="number"?k=L:k=L.bytesRead,k}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(c,g,k)}}normalizePos(c,i){return i===this.mapHandleToPos.get(c)?null:i}updatePos(c,i,n){const o=this.mapHandleToPos.get(c);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(c,o+n):this.mapHandleToPos.delete(c)))}async write(c,i,n,o,h){return(0,M.retry)(()=>this.doWrite(c,i,n,o,h),100,3)}async doWrite(c,i,n,o,h){const g=this.normalizePos(c,i);let k=null;try{const L=await m.Promises.write(c,n,o,h,g);return typeof L=="number"?k=L:k=L.bytesWritten,k}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(c),L)}finally{this.updatePos(c,g,k)}}async mkdir(c){try{await m.Promises.mkdir(this.toFilePath(c))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(c,i){try{const n=this.toFilePath(c);await this.doDelete(n,i)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(c,i){i.recursive?await m.Promises.rm(c,m.RimRafMode.MOVE):await m.Promises.unlink(c)}async rename(c,i,n){const o=this.toFilePath(c),h=this.toFilePath(i);if(o!==h)try{await this.validateTargetDeleted(c,i,"move",n.overwrite),await m.Promises.move(o,h)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(2,null,(0,d.basename)(o),(0,d.basename)((0,d.dirname)(h)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(c,i,n){const o=this.toFilePath(c),h=this.toFilePath(i);if(o!==h)try{await this.validateTargetDeleted(c,i,"copy",n.overwrite),await m.Promises.copy(o,h,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(3,null,(0,d.basename)(o),(0,d.basename)((0,d.dirname)(h)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(c,i,n,o){const h=this.toFilePath(c),g=this.toFilePath(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,I.isEqual)(h,g,!0)),k&&n==="copy")throw(0,t.createFileSystemProviderError)((0,p.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!k&&await m.Promises.exists(g)){if(!o)throw(0,t.createFileSystemProviderError)((0,p.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(c,i,n){let o,h=!1;return this.options?.watcher?.usePolling?h=!1:h=this.options?.legacyWatcher==="on",h?o=S.FileWatcher:o=P.FileWatcher,new o(g=>c(g),g=>i(g),n,this.options?.watcher)}doWatch(c,i){const n=this.options?.watcher?.usePolling;if(n===!0)for(const o of i)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const o of i)n.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(c,i)}createNonRecursiveWatcher(c,i,n,o){return new b.FileWatcher(c,h=>i(h),h=>n(h),o)}toFileSystemProviderError(c){if(c instanceof t.FileSystemProviderError)return c;let i;switch(c.code){case"ENOENT":i=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=t.FileSystemProviderErrorCode.NoPermissions;break;default:i=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(c,i)}async toFileSystemProviderWriteError(c,i){let n=this.toFileSystemProviderError(i);if(c&&n.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await m.SymlinkSupport.stat(this.toFilePath(c));o.mode&128||(n=(0,t.createFileSystemProviderError)(i,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}e.DiskFileSystemProvider=l}),define(Q[95],J([0,1,6]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function D(C,r){switch(r){case v.LogLevel.Trace:return C.trace;case v.LogLevel.Debug:return C.debug;case v.LogLevel.Info:return C.info;case v.LogLevel.Warning:return C.warn;case v.LogLevel.Error:return C.error;case v.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class M extends v.AbstractLogger{constructor(r=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(r),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(r){this._logger=r;for(const{level:I,args:d}of this.buffer)D(r,I).apply(r,d);this.buffer=[]}_log(r,...I){this._logger?D(this._logger,r).apply(this._logger,I):this.getLevel()<=r&&this.buffer.push({level:r,args:I})}trace(r,...I){this._log(v.LogLevel.Trace,r,...I)}debug(r,...I){this._log(v.LogLevel.Debug,r,...I)}info(r,...I){this._log(v.LogLevel.Info,r,...I)}warn(r,...I){this._log(v.LogLevel.Warning,r,...I)}error(r,...I){this._log(v.LogLevel.Error,r,...I)}critical(r,...I){this._log(v.LogLevel.Critical,r,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=M}),define(Q[184],J([0,1,9,17,15,18,5,95,6]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const f=5*C.ByteSize.MB;let y=class extends d.AbstractLogger{constructor(p,t,w,b,S){super();this.name=p,this.resource=t,this.donotUseFormatters=b,this.fileService=S,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>f&&(await this.fileService.writeFile(this.getBackupResource(),D.VSBuffer.fromString(w)),w=""),this.donotUseFormatters?w+=t:w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,D.VSBuffer.fromString(w))})}getCurrentTimestamp(){const p=b=>b<10?`0${b}`:b,t=b=>b<10?`00${b}`:b<100?`0${b}`:b,w=new Date;return`${w.getFullYear()}-${p(w.getMonth()+1)}-${p(w.getDate())} ${p(w.getHours())}:${p(w.getMinutes())}:${p(w.getSeconds())}.${t(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};y=ge([te(4,C.IFileService)],y),e.FileLogger=y;let E=class extends d.AbstractLoggerService{constructor(p,t,w){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=w}doCreateLogger(p,t,w){const b=new I.BufferLogService(t);return(0,C.whenProviderRegistered)(p,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(y,w?.name||(0,M.basename)(p),p,b.getLevel(),!!w?.donotUseFormatters)),b}};E=ge([te(0,d.ILogService),te(1,r.IInstantiationService),te(2,C.IFileService)],E),e.FileLoggerService=E}),define(Q[185],J([0,1,4,7,6]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(m){this.service=m,this.onDidChangeLogLevel=v.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=C;class r{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){r.setLevel(this.channel,m)}static setLevel(m,p){return m.call("setLevel",p)}}e.LogLevelChannelClient=r;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,p){throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"createLogger":this.createLogger(D.URI.revive(t[0]),t[1]);return;case"log":return this.log(D.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(m,p){this.loggers.set(m.toString(),this.loggerService.createLogger(m,p))}consoleLog(m,p){let t=console.log;switch(m){case M.LogLevel.Error:t=console.error;break;case M.LogLevel.Warning:t=console.warn;break;case M.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(m,p){const t=this.loggers.get(m.toString());if(!t)throw new Error("Create the logger before logging");for(const[w,b]of p)(0,M.log)(t,w,b)}}e.LoggerChannel=I;class d extends M.AbstractLoggerService{constructor(m,p,t){super(m,p);this.channel=t}createConsoleMainLogger(){return new M.AdapterLogger({log:(m,p)=>{this.channel.call("consoleLog",[m,p])}})}doCreateLogger(m,p,t){return new f(this.channel,m,p,t)}}e.LoggerChannelClient=d;class f extends M.AbstractMessageLogger{constructor(m,p,t,w){super(w?.always);this.channel=m,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,p){const t=[[m,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(m){this.channel.call("log",[this.file,m])}}class y extends M.LogService{constructor(m,p){super(p);this.parent=m,this._register(m.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=y}),define(Q[96],J([0,1,18,6]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function M(I,d,f,y,E){try{const m=await new Promise((t,w)=>{$(["spdlog"],t,w)});m.setFlushOn(D.LogLevel.Trace);const p=await m.createAsyncRotatingLogger(I,d,f,y);return E&&p.clearFormatters(),p}catch(m){console.error(m)}return null}function C(I,d,f){switch(d){case D.LogLevel.Trace:I.trace(f);break;case D.LogLevel.Debug:I.debug(f);break;case D.LogLevel.Info:I.info(f);break;case D.LogLevel.Warning:I.warn(f);break;case D.LogLevel.Error:I.error(f);break;case D.LogLevel.Critical:I.critical(f);break;default:throw new Error("Invalid log level")}}class r extends D.AbstractMessageLogger{constructor(d,f,y,E,m){super();this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(d,f,y,E),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}async _createSpdLogLogger(d,f,y,E){const m=y?6:1,p=30/m*v.ByteSize.MB,t=await M(d,f,p,m,E);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:w,message:b}of this.buffer)C(this._logger,w,b);this.buffer=[]}}log(d,f){this._logger?C(this._logger,d,f):this.getLevel()<=d&&this.buffer.push({level:d,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(Q[186],J([0,1,10,15,31,18,184,6,96]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(E,m){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=m}doCreateLogger(E,m,p){return E.scheme===v.Schemas.file?new d.SpdLogLogger(p?.name||(0,M.generateUuid)(),E.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,m):new r.FileLogger(p?.name??(0,D.basename)(E),E,m,!!p?.donotUseFormatters,this.fileService)}};f=ge([te(0,I.ILogService),te(1,C.IFileService)],f),e.LoggerService=f}),define(Q[187],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(r){return r.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function D(r){return r.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=D;function M(r){return r.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function C(r){return!v(r)&&!D(r)&&!M(r)}e.isMenubarMenuItemAction=C}),define(Q[56],J([0,1,10,3,34,15]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.context!="undefined"){const I=D.globals.vscode.context.configuration();if(I)r=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof $?.__$__nodeRequire=="function"){const I=(0,C.dirname)(v.FileAccess.asFileUri("",$));r=$.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const d=$.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`}),Object.assign(r,{version:d.version})}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=r}),define(Q[22],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[188],J([0,1,61,6,22]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(I,d){this.productService=I,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(d);if(!f)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,y,E]=f;let m=this.trustedExtensionUrlPublicKeys.get(I);if(!m){if(m=this.productService.trustedExtensionUrlPublicKeys[I],!m||m.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...m])}const p=Buffer.from(decodeURIComponent(E),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=p.slice(0,6),w=p.readUIntBE(0,6),b=Date.now()-w;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const S=p.slice(6),P=v.createVerify("SHA256");P.write(t),P.write(Buffer.from(y)),P.end();for(let u=0;u<m.length;u++){let a=m[u];if(a!==null){if(typeof a=="string")try{a=v.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),m[u]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${I}:`,l),m[u]=null;continue}if(P.verify(a,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};C=ge([te(0,M.IProductService),te(1,D.ILogService)],C),e.ExtensionUrlTrustService=C}),define(Q[57],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Q[189],J([0,1,14,2,40,10,3,15,7,31,48,6]),function($,e,v,D,M,C,r,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends D.Disposable{constructor(t,w){super();this.logService=w,this.validRoots=M.TernarySearchTree.forUris(()=>!r.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=v.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(w,b)=>this.handleResourceRequest(w,b)),t.protocol.interceptFileProtocol(C.Schemas.file,(w,b)=>this.handleFileRequest(w,b)),this._register((0,D.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?D.Disposable.None:(this.validRoots.set(t,!0),(0,D.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,w){const b=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),w({error:-3})}handleResourceRequest(t,w){const b=d.URI.parse(t.url),S=C.FileAccess.asFileUri(b);return this.validRoots.findSubstr(S)?w({path:S.fsPath}):this.validExtensions.has((0,I.extname)(S))?w({path:S.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),w({error:-3}))}createIPCObjectUrl(){let t;const w=d.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),b=w.toString(),S=async()=>t;return v.ipcMain.handle(b,S),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:w,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),v.ipcMain.removeHandler(b)}}}};m=ge([te(0,y.INativeEnvironmentService),te(1,E.ILogService)],m),e.ProtocolMainService=m}),define(Q[37],J([0,1,104,13]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(r,I){v.ok(D.isString(r)),v.ok(D.isObject(I)),v.ok(!this.data.has(r),"There is already an extension with this id"),this.data.set(r,I)}knows(r){return this.data.has(r)}as(r){return this.data.get(r)||null}}e.Registry=new M}),define(Q[190],J([0,1,4,37]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[M(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const r=new C;D.Registry.add(e.Extensions.JSONContribution,r)}),define(Q[49],J([0,1,30,4,13,135,190,37]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=I.Registry.as(r.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,s=!0){this.registerConfigurations([l],s)}registerConfigurations(l,s=!0){const c=this.doRegisterConfigurations(l,s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(l){const s=this.doDeregisterConfigurations(l);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:l,remove:s}){const c=[];c.push(...this.doDeregisterConfigurations(s)),c.push(...this.doRegisterConfigurations(l,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,v.distinct)(c))}registerDefaultConfigurations(l){const s=[],c=[];for(const i of l)for(const n in i)if(s.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){this.defaultValues[n]={...this.defaultValues[n]||{},...i[n]};const o={type:"object",default:this.defaultValues[n],description:C.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId};c.push(...t(n)),this.configurationProperties[n]=o,this.defaultLanguageConfigurationOverridesNode.properties[n]=o}else{this.defaultValues[n]=i[n];const o=this.configurationProperties[n];o&&(this.updatePropertyDefaultValue(n,o),this.updateSchema(n,o))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(l){const s=[];for(const c of l)for(const i in c)if(s.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const s of l)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,s){const c=[];return l.forEach(i=>{c.push(...this.validateAndRegisterProperties(i,s,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),c}doDeregisterConfigurations(l){const s=[],c=i=>{if(i.properties)for(const n in i.properties)s.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n]);i.allOf&&i.allOf.forEach(n=>c(n))};for(const i of l){c(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}return s}validateAndRegisterProperties(l,s=!0,c,i=3){i=M.isUndefinedOrNull(l.scope)?i:l.scope;let n=[],o=l.properties;if(o)for(let g in o){if(s&&P(g)){delete o[g];continue}const k=o[g];if(this.updatePropertyDefaultValue(g,k),e.OVERRIDE_PROPERTY_REGEX.test(g)?k.scope=void 0:(k.scope=M.isUndefinedOrNull(k.scope)?i:k.scope,k.restricted=M.isUndefinedOrNull(k.restricted)?!!c?.restrictedConfigurations?.includes(g):k.restricted),o[g].hasOwnProperty("included")&&!o[g].included){this.excludedConfigurationProperties[g]=o[g],delete o[g];continue}else this.configurationProperties[g]=o[g];!o[g].deprecationMessage&&o[g].markdownDeprecationMessage&&(o[g].deprecationMessage=o[g].markdownDeprecationMessage),n.push(g)}let h=l.allOf;if(h)for(let g of h)n.push(...this.validateAndRegisterProperties(g,s,c,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const s=c=>{let i=c.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let n=c.allOf;n&&n.forEach(s)};s(l)}updateSchema(l,s){switch(e.allSettings.properties[l]=s,s.scope){case 1:e.applicationSettings.properties[l]=s;break;case 2:e.machineSettings.properties[l]=s;break;case 6:e.machineOverridableSettings.properties[l]=s;break;case 3:e.windowSettings.properties[l]=s;break;case 4:e.resourceSettings.properties[l]=s;break;case 5:e.resourceSettings.properties[l]=s,this.resourceLanguageSettingsSchema.properties[l]=s;break}}removeFromSchema(l,s){switch(delete e.allSettings.properties[l],s.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const s=`[${l}]`,c={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,c),e.allSettings.properties[s]=c,e.applicationSettings.properties[s]=c,e.machineSettings.properties[s]=c,e.machineOverridableSettings.properties[s]=c,e.windowSettings.properties[s]=c,e.resourceSettings.properties[s]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,s){let c=this.defaultValues[l];M.isUndefined(c)&&(c=s.default),M.isUndefined(c)&&(c=b(s.type)),s.default=c}}const m="\\[([^\\]]+)\\]",p=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let s=p.exec(a);for(;s?.length;){const c=s[1].trim();c&&l.push(c),s=p.exec(a)}}return(0,v.distinct)(l)}e.overrideIdentifiersFromKey=t;function w(a){return a.reduce((l,s)=>`${l}[${s}]`,"")}e.keyFromOverrideIdentifiers=w;function b(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const S=new E;I.Registry.add(e.Extensions.Configuration,S);function P(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?C.localize(7,null,a):S.getConfigurationProperties()[a]!==void 0?C.localize(8,null,a):null:C.localize(6,null)}e.validateProperty=P;function u(){const a=[],l=S.getConfigurationProperties();for(const s of Object.keys(l))a.push([s,l[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=u}),define(Q[19],J([0,1,13,7,49,5,37]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function I(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationOverrides=I;function d(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||v.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=d;var f;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(f=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function E(a,l){const s=Object.create(null);for(let c in a)m(s,c,a[c],l);return s}e.toValuesTree=E;function m(a,l,s,c){const i=l.split("."),n=i.pop();let o=a;for(let h=0;h<i.length;h++){let g=i[h],k=o[g];switch(typeof k){case"undefined":k=o[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${l} as ${i.slice(0,h+1).join(".")} is ${JSON.stringify(k)}`);return}o=k}if(typeof o=="object"&&o!==null)try{o[n]=s}catch(h){c(`Ignoring ${l} as ${i.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${l} as ${i.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=m;function p(a,l){const s=l.split(".");t(a,s)}e.removeFromValueTree=p;function t(a,l){const s=l.shift();if(l.length===0){delete a[s];return}if(Object.keys(a).indexOf(s)!==-1){const c=a[s];typeof c=="object"&&!Array.isArray(c)&&(t(c,l),Object.keys(c).length===0&&delete a[s])}}function w(a,l,s){function c(o,h){let g=o;for(const k of h){if(typeof g!="object"||g===null)return;g=g[k]}return g}const i=l.split("."),n=c(a,i);return typeof n=="undefined"?s:n}e.getConfigurationValue=w;function b(a,l,s){Object.keys(l).forEach(c=>{c!=="__proto__"&&(c in a?v.isObject(a[c])&&v.isObject(l[c])?b(a[c],l[c],s):s&&(a[c]=l[c]):a[c]=l[c])})}e.merge=b;function S(){const a=r.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=S;function P(){const a=Object.create(null),l=r.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let s in l){let c=l[s].default;m(a,s,c,i=>console.error(`Conflict in default settings: ${i}`))}return a}e.getDefaultValues=P;function u(a,l,s){const c=a.inspect(l),i=a.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:c.defaultValue}e.getMigratedSettingValue=u}),define(Q[191],J([0,1,30,4,39,2,40,47,13,7,19,49,37]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},n=[],o=[]){this._contents=i,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,y.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const o=this.getContentsForOverrideIdentifer(n);return o?i?(0,y.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return v.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return v.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=I.deepClone(this.contents),o=I.deepClone(this.overrides),h=[...this.keys];for(const g of i){this.mergeContents(n,g.contents);for(const k of g.overrides){const[L]=o.filter(R=>v.equals(R.identifiers,k.identifiers));L?(this.mergeContents(L.contents,k.contents),L.keys.push(...k.keys),L.keys=v.distinct(L.keys)):o.push(I.deepClone(k))}for(const k of g.keys)h.indexOf(k)===-1&&h.push(k)}return new p(n,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const h of v.distinct([...Object.keys(this.contents),...Object.keys(n)])){let g=this.contents[h],k=n[h];k&&(typeof g=="object"&&typeof k=="object"?(g=I.deepClone(g),this.mergeContents(g,k)):g=k),o[h]=g}return new p(o,this.keys,this.overrides)}mergeContents(i,n){for(const o of Object.keys(n)){if(o in i&&d.isObject(i[o])&&d.isObject(n[o])){this.mergeContents(i[o],n[o]);continue}i[o]=I.deepClone(n[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,o=null;const h=g=>{g&&(o?this.mergeContents(o,g):o=I.deepClone(g))};for(const g of this.overrides)v.equals(g.identifiers,[i])?n=g.contents:g.identifiers.includes(i)&&h(g.contents);return h(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,y.addToValueTree)(this.contents,i,n,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,y.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let o=0;o<n;o++)i.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(){const i=(0,y.getDefaultValues)(),n=(0,y.getConfigurationKeys)(),o=[];for(const h of Object.keys(i))E.OVERRIDE_PROPERTY_REGEX.test(h)&&o.push({identifiers:(0,E.overrideIdentifiersFromKey)(h),keys:Object.keys(i[h]),contents:(0,y.toValuesTree)(i[h],g=>console.error(`Conflict in default settings file: ${g}`))});super(i,n,o)}}e.DefaultConfigurationModel=t;class w{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!d.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:o,keys:h,overrides:g,restricted:k}=this.doParseRaw(i,n);this._configurationModel=new p(o,h,g),this._restrictedConfigurations=k||[]}doParseContent(i){let n={},o=null,h=[],g=[],k=[];function L(O){Array.isArray(h)?h.push(O):o!==null&&(h[o]=O)}let R={onObjectBegin:()=>{let O={};L(O),g.push(h),h=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{let O=[];L(O),g.push(h),h=O,o=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:L,onError:(O,V,ee)=>{k.push({error:O,offset:V,length:ee})}};if(i)try{M.visit(i,R),n=h[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(i,n){const o=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),h=this.filter(i,o,!0,n);i=h.raw;const g=(0,y.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),k=Object.keys(i),L=this.toOverrides(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:g,keys:k,overrides:L,restricted:h.restricted}}filter(i,n,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:i,restricted:[]};const g={},k=[];for(let L in i)if(E.OVERRIDE_PROPERTY_REGEX.test(L)&&o){const R=this.filter(i[L],n,!1,h);g[L]=R.raw,k.push(...R.restricted)}else{const R=n[L],O=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&k.push(L),(O===void 0||h.scopes===void 0||h.scopes.includes(O))&&(h.skipRestricted&&R?.restricted||(g[L]=i[L]))}return{raw:g,restricted:k}}toOverrides(i,n){const o=[];for(const h of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(h)){const g={};for(const k in i[h])g[k]=i[h][k];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(h),keys:Object.keys(g),contents:(0,y.toValuesTree)(g,n)})}return o}}e.ConfigurationModelParser=w;class b extends C.Disposable{constructor(i,n,o,h){super();this.userSettingsResource=i,this.scopes=n,this.fileService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class S{constructor(i,n,o=new p,h=new p,g=new r.ResourceMap,k=new p,L=new r.ResourceMap,R=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=g,this._memoryConfiguration=k,this._memoryConfigurationByResource=L,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new r.ResourceMap,this._userConfiguration=null}getValue(i,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(i)}updateValue(i,n,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new p,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,n===void 0?h.removeValue(i):h.setValue(i,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,o){const h=this.getConsolidateConfigurationModel(n,o),g=this.getFolderConfigurationModelForResource(n.resource,o),k=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,L=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),R=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),O=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),V=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),ee=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,oe=g?n.overrideIdentifier?g.freeze().override(n.overrideIdentifier).getValue(i):g.freeze().getValue(i):void 0,ae=n.overrideIdentifier?k.override(n.overrideIdentifier).getValue(i):k.getValue(i),K=h.getValue(i),T=v.distinct(v.flatten(h.overrides.map(N=>N.identifiers))).filter(N=>h.getOverrideValue(i,N)!==void 0);return{defaultValue:L,userValue:R,userLocalValue:O,userRemoteValue:V,workspaceValue:ee,workspaceFolderValue:oe,memoryValue:ae,value:K,default:L!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:V!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:oe!==void 0?{value:g?.freeze().getValue(i),override:n.overrideIdentifier?g?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:ae!==void 0?{value:k.getValue(i),override:n.overrideIdentifier?k.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:T.length?T:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];for(const h of n)for(const g of(0,E.overrideIdentifiersFromKey)(h)){const k=this._defaultConfiguration.getKeysForOverrideIdentifier(g),L=i.getKeysForOverrideIdentifier(g),R=[...L.filter(O=>k.indexOf(O)===-1),...k.filter(O=>L.indexOf(O)===-1),...k.filter(O=>!I.equals(this._defaultConfiguration.override(g).getValue(O),i.override(g).getValue(O)))];o.push([g,R])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:h,overrides:g}=l(this.localUserConfiguration,i),k=[...n,...o,...h];return k.length&&this.updateLocalUserConfiguration(i),{keys:k,overrides:g}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:h,overrides:g}=l(this.remoteUserConfiguration,i);let k=[...n,...o,...h];return k.length&&this.updateRemoteUserConfiguration(i),{keys:k,overrides:g}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:h,overrides:g}=l(this.workspaceConfiguration,i);let k=[...n,...o,...h];return k.length&&this.updateWorkspaceConfiguration(i),{keys:k,overrides:g}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:h,updated:g,removed:k,overrides:L}=l(o,n);let R=[...h,...g,...k];return(R.length||!o)&&this.updateFolderConfiguration(i,n),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:h,removed:g,overrides:k}=l(n,void 0);return{keys:[...o,...h,...g],overrides:k}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const h=n.getFolder(i);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const g=this._memoryConfigurationByResource.get(i);g&&(o=o.merge(g))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(i);h?(n=o.merge(h),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=o}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:o,overrides:h,keys:g}=this._folderConfigurations.get(n);return i.push([n,{contents:o,overrides:h,keys:g}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(h=>n.add(h))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),h=this.parseConfigurationModel(i.workspace),g=i.folders.reduce((k,L)=>(k.set(f.URI.revive(L[0]),this.parseConfigurationModel(L[1])),k),new r.ResourceMap);return new S(n,o,new p,h,g,new p,new r.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function P(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,n=new Map;for(const h of c)h.keys.forEach(g=>i.add(g)),h.overrides.forEach(([g,k])=>{const L=(0,r.getOrSet)(n,g,new Set);k.forEach(R=>L.add(R))});const o=[];return n.forEach((h,g)=>o.push([g,[...h.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=P;class u{constructor(i,n,o,h){this.change=i,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const g=new Set;i.keys.forEach(L=>g.add(L)),i.overrides.forEach(([,L])=>L.forEach(R=>g.add(R))),this.affectedKeys=[...g.values()];const k=new p;this.affectedKeys.forEach(L=>k.setValue(L,{})),this.affectedKeysTree=k.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!I.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let o=(0,y.toValuesTree)({[n]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(i=i[h],!i)return!1;o=o[h]}return!0}}e.ConfigurationChangeEvent=u;class a extends u{constructor(i,n,o,h){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=o,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=a;function l(c,i){const{added:n,removed:o,updated:h}=s(i,c),g=[],k=c?.getAllOverrideIdentifiers()||[],L=i?.getAllOverrideIdentifiers()||[];if(i){const R=L.filter(O=>!k.includes(O));for(const O of R)g.push([O,i.getKeysForOverrideIdentifier(O)])}if(c){const R=k.filter(O=>!L.includes(O));for(const O of R)g.push([O,c.getKeysForOverrideIdentifier(O)])}if(i&&c){for(const R of k)if(L.includes(R)){const O=s({contents:c.getOverrideValue(void 0,R)||{},keys:c.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});g.push([R,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:o,updated:h,overrides:g}}function s(c,i){const n=c?i?c.keys.filter(g=>i.keys.indexOf(g)===-1):[...c.keys]:[],o=i?c?i.keys.filter(g=>c.keys.indexOf(g)===-1):[...i.keys]:[],h=[];if(c&&i){for(const g of i.keys)if(c.keys.indexOf(g)!==-1){const k=(0,y.getConfigurationValue)(i.contents,g),L=(0,y.getConfigurationValue)(c.contents,g);I.equals(k,L)||h.push(g)}}return{added:n,removed:o,updated:h}}}),define(Q[192],J([0,1,9,4,2,15,19,191,49,37]),function($,e,v,D,M,C,r,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends M.Disposable{constructor(m,p){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,p)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,p){const t=typeof m=="string"?m:void 0,w=(0,r.isConfigurationOverrides)(m)?m:(0,r.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,w,void 0)}updateValue(m,p,t,w){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,p,1)}onDidDefaultConfigurationChange(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,m);this.trigger(t,p,6)}trigger(m,p,t){const w=new I.ConfigurationChangeEvent(m,{data:p},this.configuration);w.source=t,w.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Q[193],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var D;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends Error{constructor(r,I=D.Unknown,d){super(r);this._message=r,this._code=I,this._detail=d,this.isHandled=I===D.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(r){return r instanceof M&&r._code===D.TemporarilyNotAvailable}static isNoResolverFound(r){return r instanceof M&&r._code===D.NoResolverFound}static isHandled(r){return r instanceof M&&r.isHandled}}e.RemoteAuthorityResolverError=M}),define(Q[194],J([0,1,9,17,23,16,4,2,31,84,193]),function($,e,v,D,M,C,r,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var m;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(F){const A=new M.CancellationTokenSource;return setTimeout(()=>A.cancel(),F),A.token}function w(F,A){if(F.isCancellationRequested||A.isCancellationRequested)return M.CancellationToken.Cancelled;const W=new M.CancellationTokenSource;return F.onCancellationRequested(()=>W.cancel()),A.onCancellationRequested(()=>W.cancel()),W.token}class b{constructor(A){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((W,B)=>{this._resolvePromise=W,this._rejectPromise=B}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function S(F,A){const W=new b(A);return W.registerDisposable(F.onControlMessage(B=>{const Y=JSON.parse(B.toString()),x=G(Y);x?W.reject(x):W.resolve(Y)})),W.promise}function P(F,A,W,B,Y,x){const z=new b(x);return A.connect(W,B,Y,(X,ie)=>{z.didTimeout?(X&&F.error(X),ie?.dispose()):X||!ie?z.reject(X):z.resolve(ie)}),z.promise}function u(F,A){const W=new b(A);return F.then(B=>{W.didTimeout||W.resolve(B)},B=>{W.didTimeout||W.reject(B)}),W.promise}async function a(F,A,W,B){const Y=U(F,A);F.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let x;try{x=await P(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,B)}catch(se){throw F.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),F.logService.error(se),se}F.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let z,X;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(x,null),z=F.reconnectionProtocol,X=!1):(z=new f.PersistentProtocol(x,null),X=!0),F.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const ie=await u(F.signService.createNewMessage((0,d.generateUuid)()),B),re={type:"auth",auth:F.connectionToken||"00000000000000000000",data:ie.data};z.sendControl(D.VSBuffer.fromString(JSON.stringify(re)));try{const se=await S(z,w(B,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(F.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await u(F.signService.validate(ie,se.signedData),B)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await u(F.signService.sign(se.data),B),le={type:"connectionType",commit:F.commit,signedData:ce,desiredConnectionType:A};return W&&(le.args=W),F.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(D.VSBuffer.fromString(JSON.stringify(le))),{protocol:z,ownsProtocol:X}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(F.logService.error(`${Y} the handshake timed out. Error:`),F.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${Y} received error control message when negotiating connection. Error:`),F.logService.error(se)),X&&N(z),se}}async function l(F,A,W,B){const Y=Date.now(),x=U(F,A),{protocol:z,ownsProtocol:X}=await a(F,A,W,B),ie=new b(B);return ie.registerDisposable(z.onControlMessage(re=>{const se=JSON.parse(re.toString()),Z=G(se);Z?(F.logService.error(`${x} received error control message when negotiating connection. Error:`),F.logService.error(Z),X&&N(z),ie.reject(Z)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${j(Y)}!`),ie.resolve({protocol:z,firstMessage:se}))})),ie.promise}async function s(F,A){const{protocol:W}=await l(F,1,void 0,A);return{protocol:W}}async function c(F,A,W){const{protocol:B,firstMessage:Y}=await l(F,2,A,W),x=Y&&Y.debugPort;return{protocol:B,debugPort:x}}async function i(F,A,W){const B=Date.now(),Y=U(F,3),{protocol:x}=await a(F,3,A,W);return F.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${j(B)}!`),x}async function n(F,A,W){const{host:B,port:Y,connectionToken:x}=await F.addressProvider.getAddress();return{commit:F.commit,host:B,port:Y,connectionToken:x,reconnectionToken:A,reconnectionProtocol:W,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function o(F,A,W){try{const B=(0,d.generateUuid)(),Y=await n(F,B,null),{protocol:x}=await s(Y,M.CancellationToken.None);return new K(F,A,W,B,x)}catch(B){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(B),ae.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentManagement=o;async function h(F,A){try{const W=(0,d.generateUuid)(),B=await n(F,W,null),{protocol:Y,debugPort:x}=await c(B,A,M.CancellationToken.None);return new T(F,A,W,Y,x)}catch(W){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(W),ae.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=h;async function g(F,A,W){const B=await n(F,(0,d.generateUuid)(),null);return await i(B,{host:A,port:W},M.CancellationToken.None)}e.connectRemoteAgentTunnel=g;function k(F){return(0,v.createCancelablePromise)(A=>new Promise((W,B)=>{const Y=setTimeout(W,F*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),W()})}))}var L;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(A,W){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=R;class O{constructor(A,W,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.durationSeconds=B,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class V{constructor(A,W,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=V;class ee{constructor(A,W,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=B,this.type=4}}e.ConnectionGainEvent=ee;class oe{constructor(A,W,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=B,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class ae extends I.Disposable{constructor(A,W,B,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new r.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=B,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(x=>{const z=_(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const x=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${x} received socket timeout event.`),this._beginReconnecting()})),ae._instances.push(this),ae._permanentFailure&&this._gotoPermanentFailure(ae._permanentFailureMillisSinceLastIncomingData,ae._permanentFailureAttempt,ae._permanentFailureHandled)}static triggerPermanentFailure(A,W,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=W,this._permanentFailureHandled=B,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(ae._permanentFailure)return;const A=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const Y=B<W.length?W[B]:W[W.length-1];try{if(Y>0){const z=k(Y);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,z)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await z}catch{}}if(ae._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${A} resolving connection...`);const x=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${x.host}:${x.port}...`),await this._reconnect(x,t(E)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,C.isPromiseCanceledError)(x)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,y.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!ae._permanentFailure)}_gotoPermanentFailure(A,W,B){this._onDidStateChange.fire(new oe(this.reconnectionToken,A,W,B)),N(this.protocol)}}ae._permanentFailure=!1,ae._permanentFailureMillisSinceLastIncomingData=0,ae._permanentFailureAttempt=0,ae._permanentFailureHandled=!1,ae._instances=[];class K extends ae{constructor(A,W,B,Y,x){super(1,A,Y,x);this.client=this._register(new f.Client(x,{remoteAuthority:W,clientId:B},A.ipcLogger))}async _reconnect(A,W){await s(A,W)}}e.ManagementPersistentConnection=K;class T extends ae{constructor(A,W,B,Y,x){super(2,A,B,Y);this._startArguments=W,this.debugPort=x}async _reconnect(A,W){await c(A,this._startArguments,W)}}e.ExtensionHostPersistentConnection=T;function N(F){try{F.acceptDisconnect();const A=F.getSocket();F.dispose(),A.dispose()}catch(A){(0,C.onUnexpectedError)(A)}}function G(F){if(F&&F.type==="error"){const A=new Error(`Connection error: ${F.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function q(F,A){for(;F.length<A;)F+=" ";return F}function _(F,A,W){return`[remote-connection][${q(p(F),13)}][${A.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function U(F,A){return`${_(A,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function j(F){return`${Date.now()-F} ms`}}),define(Q[64],J([0,1,10]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function D(f){return f.scheme===v.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=D;function M(f){if(!f)return;const y=f.indexOf("+");return y<0?f:f.substr(0,y)}e.getRemoteName=M;function C(f){return f.scheme!==v.Schemas.file&&f.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=C;function r(f){if(f.folders.length)return f.folders.every(y=>C(y.uri))?f.folders[0].uri:void 0;if(f.configuration&&C(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=r;function I(f){return r(f)?.scheme}e.getVirtualWorkspaceScheme=I;function d(f){return r(f)!==void 0}e.isVirtualWorkspace=d}),define(Q[195],J([0,1,25,5,64]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=C;function r(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=r,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class d{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,t){if(typeof p=="undefined"||p===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof p=="string"||typeof t=="string"){let w=typeof p=="string"?p:p.value,b=typeof t=="string"?t:t.value;return v.equalsIgnoreCase(w,b)}return p._lower===t._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=d;function f(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function E(m,p){if(p){const t=`onResolveRemoteAuthority:${(0,M.getRemoteName)(p)}`;return m.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[196],J([0,1,25,195]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function M(t,w){return t.uuid&&w.uuid?t.uuid===w.uuid:t.id===w.id?!0:(0,v.compareIgnoreCase)(t.id,w.id)===0}e.areSameExtensions=M;class C{constructor(w,b){this.version=b,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof C?M(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=C;function r(t,w){return`${t}.${w}`}e.getExtensionId=r;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function d(t,w){return I(r(t,w))}e.getGalleryExtensionId=d;function f(t,w){const b=[],S=P=>{for(const u of b)if(u.some(a=>M(w(a),w(P))))return u;return null};for(const P of t){const u=S(P);u?u.push(P):b.push([P])}return b}e.groupByExtension=f;function y(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function E(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function m(t){const w=new Set;for(const b of t)b.malicious&&w.add(b.id.id);return w}e.getMaliciousExtensionsSet=m;function p(t,w){const b=[],S=w.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const P=S.shift();if(P&&b.every(u=>!M(u.identifier,{id:P}))){const u=t.filter(a=>M(a.identifier,{id:P}));u.length===1&&(b.push(u[0]),S.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=p}),define(Q[97],J([0,1,4,3,5,6]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,M.createDecorator)("sharedTunnelsService");var r;(function(t){t.Http="http",t.Https="https"})(r=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function m(t,w){return w?w!==1&&t<1024:!D.isWindows&&t<1024}e.isPortPrivileged=m;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,b){return this._tunnelProvider=w,w?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],b=Array.from(this._tunnels.values());for(let S of b){const P=Array.from(S.values());for(let u of P){const a=await u.value;a&&w.push(a)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:b}of w.values())await b.then(S=>S?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,b,S,P,u=!1,a=I.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${S} on local port ${P}.`),!w)return;b||(b="localhost");const s=this.retainOrCreateTunnel(w,b,S,P,u,a,l);return s?s.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(c);return(c.tunnelRemoteHost!==b||c.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const b=this._tunnels.get(w.tunnelRemoteHost);if(b){const S=b.get(w.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,S))}}}}async tryDisposeTunnel(w,b,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${b}.`);const P=S.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(b),P}}async closeTunnel(w,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${b} `);const S=this._tunnels.get(w);if(S&&S.has(b)){const P=S.get(b);P.refcount=0,await this.tryDisposeTunnel(w,b,P)}}addTunnelToMap(w,b,S){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(b,{refcount:1,value:S})}async removeEmptyTunnelFromMap(w,b){const S=this._tunnels.get(w);S&&(await S.get(b)||S.delete(b),S.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,b){let S=[w];y(w)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const P=S.map(u=>this._tunnels.get(u));for(const u of P){const a=u?.get(b);if(a)return a}}canTunnel(w){return!!f(w)}createWithProvider(w,b,S,P,u,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${S} on local port ${P}.`);const c={elevationRequired:u?m(P===void 0?S:P):!1},i={remoteAddress:{host:b,port:S},localAddressPort:P,privacy:a,public:a!==I.Private,protocol:l},n=w.forwardPort(i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(b,S,n),n}};p=ge([te(0,C.ILogService)],p),e.AbstractTunnelService=p}),define(Q[50],J([0,1,17,151,49,5,37]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function d(t){return t.res.statusCode===204}async function f(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,v.streamToBuffer)(t.stream)).toString()}e.asText=f;async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const b=(await(0,v.streamToBuffer)(t.stream)).toString();try{return JSON.parse(b)}catch(S){throw S.message+=`:
`+b,S}}e.asJson=y;function E(t){p(t)}e.updateProxyConfigurationsScope=E;let m;function p(t){const w=r.Registry.as(M.Extensions.Configuration),b=m;m={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[m],remove:b?[b]:[]})}p(2)}),define(Q[197],J([0,1,198,13]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(r,I){return r.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:r.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(r,I,d={}){const f=(0,v.parse)(r),y=d.proxyUrl||M(f,I);if(!y)return null;const E=(0,v.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const m={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,D.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((p,t)=>{$(["http-proxy-agent"],p,t)}))(m):new(await new Promise((p,t)=>{$(["https-proxy-agent"],p,t)}))(m)}e.getProxyAgent=C}),define(Q[199],J([0,1,17,31]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(C,r,I){let d=I&&I.get("storage.serviceMachineId",0)||null;if(d)return d;try{const y=(await r.readFile(C.serviceMachineIdResource)).value.toString();d=(0,D.isUUID)(y)?y:null}catch(f){d=null}if(!d){d=(0,D.generateUuid)();try{await r.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(d))}catch(f){}}return I&&I.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=M}),define(Q[76],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[200],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((M,C)=>$(["vsda"],M,C))}async createNewMessage(M){try{const C=await this.vsda(),r=new C.validator;if(r){const I=String(v._nextId++);return this.validators.set(I,r),{id:I,data:r.createNewMessage(M)}}}catch(C){}return{id:"",data:M}}async validate(M,C){if(!M.id)return!0;const r=this.validators.get(M.id);if(!r)return!1;this.validators.delete(M.id);try{return r.validate(C)==="ok"}catch(I){return!1}}async sign(M){try{const C=await this.vsda(),r=new C.signer;if(r)return r.sign(M)}catch(C){}return M}}e.SignService=v,v._nextId=1}),define(Q[38],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Q[20],J([0,1,14,9,4,2,3,34,13,5,179,6,38]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var p;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class dt extends C.Disposable{constructor(b,S){super();this.logService=b,this.stateMainService=S,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new M.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),r.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};v.app.addListener("before-quit",b);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!r.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",S),v.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",b),v.app.removeListener("window-all-closed",S),v.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(S){b.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(b)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let S=this.phaseWhen.get(b);S||(S=new D.Barrier,this.phaseWhen.set(b,S)),await S.wait()}registerWindow(b){const S=new C.DisposableStore;this.windowCounter++,S.add(b.onWillLoad(u=>this._onWillLoadWindow.fire({window:b,workspace:u.workspace,reason:u.reason})));const P=(0,d.assertIsDefined)(b.win);P.on("close",u=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),u.preventDefault(),this.unload(b,1).then(l=>{if(l){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!r.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(b,S){await this.unload(b,3)||b.reload(S)}async unload(b,S){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const P=this._quitRequested?2:S;let u=await this.onBeforeUnloadWindowInRenderer(b,P);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(u)):(u=await this.onBeforeUnloadWindowInMain(b,P),u?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(u)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,P),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,S){return new Promise(P=>{const u=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${u}`,l=`vscode:cancel${u}`;v.ipcMain.once(a,()=>{P(!1)}),v.ipcMain.once(l,()=>{P(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:l,reason:S})})}onBeforeUnloadWindowInMain(b,S){const P=[];return this._onBeforeUnloadWindow.fire({reason:S,window:b,veto(u){P.push(u)}}),(0,y.handleVetos)(P,u=>this.logService.error(u))}onWillUnloadWindowInRenderer(b,S){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(a,()=>P()),b.send("vscode:onWillUnload",{replyChannel:a,reason:S})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(b?.addArgs&&S.push(...b.addArgs),b?.removeArgs)for(const a of b.removeArgs){const l=S.indexOf(a);l>=0&&S.splice(l,1)}const P=()=>{try{if(r.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:S})};v.app.once("quit",P),await this.quit(!0)&&v.app.removeListener("quit",P)}async kill(b){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const S of v.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let P;S.webContents&&!S.webContents.isDestroyed()?P=new Promise(u=>S.once("closed",u)):P=Promise.resolve(),S.destroy(),await P}})()]),v.app.exit(b)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ge([te(0,E.ILogService),te(1,m.IStateMainService)],t),e.LifecycleMainService=t}),define(Q[201],J([0,1,4,2,5,20]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let r=class extends D.Disposable{constructor(f){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((y,E)=>{$(["native-keymap"],y,E)});this._keyboardLayoutData=I(f),f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};r=ge([te(0,C.ILifecycleMainService)],r),e.KeyboardLayoutMainService=r;function I(d){const f=d.getKeyMap(),y=d.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:y}}}),define(Q[98],J([0,1,9,4,2,63,13,86,5]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var y;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(b){b[b.GLOBAL=0]="GLOBAL",b[b.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var m;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class p extends M.Disposable{constructor(S={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,P){P===f?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:P,target:this.getKeyTargets(S)[P]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,P,u){return this.getStorage(P)?.get(S,u)}getBoolean(S,P,u){return this.getStorage(P)?.getBoolean(S,u)}getNumber(S,P,u){return this.getStorage(P)?.getNumber(S,u)}store(S,P,u,a){if((0,r.isUndefinedOrNull)(P)){this.remove(S,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,u,a),this.getStorage(u)?.set(S,P)})}remove(S,P){this.withPausedEmitters(()=>{this.updateKeyTarget(S,P,void 0),this.getStorage(P)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,P){const u=[],a=this.getKeyTargets(S);for(const l of Object.keys(a))a[l]===P&&u.push(l);return u}updateKeyTarget(S,P,u){const a=this.getKeyTargets(P);typeof u=="number"?a[S]!==u&&(a[S]=u,this.getStorage(P)?.set(f,JSON.stringify(a))):typeof a[S]=="number"&&(delete a[S],this.getStorage(P)?.set(f,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const P=this.get(f,S);if(P)try{return JSON.parse(P)}catch(u){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=y.NONE){this._onWillSaveState.fire({reason:S});const P=this.getStorage(0),u=this.getStorage(1);switch(S){case y.NONE:await v.Promises.settled([P?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await v.Promises.settled([P?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const S=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return w(S,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=t;async function w(b,S,P,u){const a=h=>{try{return JSON.parse(h)}catch(g){return h}},l=new Map,s=new Map;b.forEach((h,g)=>{l.set(g,h),s.set(g,a(h))});const c=new Map,i=new Map;S.forEach((h,g)=>{c.set(g,h),i.set(g,a(h))}),console.group(`Storage: Global (path: ${P})`);let n=[];l.forEach((h,g)=>{n.push({key:g,value:h})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${u})`);let o=[];c.forEach((h,g)=>{o.push({key:g,value:h})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=w}),define(Q[202],J([0,1,3,34,7,31]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function r(f){if(v.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function I(f,y,E,m,p,t,w,b,S,P){const u=Object.create(null);u["common.machineId"]=w,u.sessionID=(0,C.generateUuid)()+Date.now(),u.commitHash=p,u.version=t,u["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,v.PlatformToString)(v.platform),u["common.nodePlatform"]=D.platform,u["common.nodeArch"]=m,u["common.product"]=P||"desktop";const a=d(b||[]);a&&(u["common.msftInternal"]=a);let l=0;const s=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(u["common.snap"]="true");const c=r(E);c&&(u["common.platformDetail"]=c);try{const i=await f.readFile(M.URI.file(S));u["common.source"]=i.value.toString().slice(0,30)}catch(i){}return u}e.resolveCommonProperties=I;function d(f){const y=D.env.USERDNSDOMAIN;if(!y)return!1;const E=y.toLowerCase();return f.some(m=>E===m)}e.verifyMicrosoftInternalDomain=d}),define(Q[29],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[203],J([0,1,26,69,9,39,10,8,3,7,71,21,83,74,18,22,29]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(s,c){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,o=new Map,h=2e4;function g(R,O,V,ee){const oe=O.substring(R.length+1);return M.Promises.withAsyncBody(async ae=>{let K;try{K=await E.Promises.readdir(O,{withFileTypes:!0})}catch(G){ae();return}if(ee.count>=h){ee.count+=K.length,ee.maxReached=!0,ae();return}let T=K.length;if(T===0){ae();return}let N=K;ee.count+K.length>h&&(ee.maxReached=!0,T=h-ee.count,N=K.slice(0,T)),ee.count+=K.length;for(const G of N)if(G.isDirectory()){if(V.includes(G.name)||await g(R,(0,I.join)(O,G.name),V,ee),--T==0){ae();return}}else{const q=G.name.lastIndexOf(".");if(q>=0){const _=G.name.substring(q+1);_&&n.set(_,(n.get(_)??0)+1)}for(const _ of i)_.relativePathPattern?.test(oe)!==!1&&_.filePattern.test(G.name)&&o.set(_.tag,(o.get(_.tag)??0)+1);if(--T==0){ae();return}}})}const k={count:0,maxReached:!1};await g(s,s,c,k);const L=await a(s);return{configFiles:P(o),fileTypes:P(n),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=S;function P(s){return[...D.Iterable.map(s.entries(),([c,i])=>({name:c,count:i}))].sort((c,i)=>i.count-c.count)}function u(){const s={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},c=v.cpus();return c&&c.length>0&&(s.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),s}e.getMachineInfo=u;async function a(s){try{const c=new Map,i=(0,I.join)(s,".vscode","launch.json"),n=await E.Promises.readFile(i),o=[],h=(0,C.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(h)==="object"&&h.configurations)for(const g of h.configurations){const k=g.type;k&&(c.has(k)?c.set(k,c.get(k)+1):c.set(k,1))}return P(c)}catch(c){return[]}}e.collectLaunchConfigs=a;let l=class{constructor(c,i){this.telemetryService=c,this.productService=i}formatMachineInfo(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}formatEnvironment(c){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const n=v.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||i.push(`Load (avg):       ${v.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,m.listProcesses)(c.mainPID),this.formatWorkspaceMetadata(c)]).then(async n=>{let[o,h]=n,g=this.formatProcessList(c,o);return i.forEach(k=>{if((0,p.isRemoteDiagnosticError)(k))g+=`
${k.errorMessage}`,h+=`
${k.errorMessage}`;else if(g+=`

Remote: ${k.hostName}`,k.processes&&(g+=`
${this.formatProcessList(c,k.processes)}`),k.workspaceMetadata){h+=`
|  Remote: ${k.hostName}`;for(const L of Object.keys(k.workspaceMetadata)){const R=k.workspaceMetadata[L];let O=`${R.fileCount} files`;R.maxFilesReached&&(O=`more than ${O}`),h+=`|    Folder (${L}): ${O}`,h+=this.formatWorkspaceStats(R)}}}),{processInfo:g,workspaceInfo:h}})}async getSystemInfo(c,i){const{memory:n,vmHint:o,os:h,cpus:g}=u(),k={os:h,memory:n,cpus:g,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return d.isWindows||(k.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),d.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(c,i){const n=[];return(0,m.listProcesses)(c.mainPID).then(async o=>(n.push(""),n.push(this.formatEnvironment(c)),n.push(""),n.push(this.formatProcessList(c,o)),c.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(c))),i.forEach(h=>{if((0,p.isRemoteDiagnosticError)(h))n.push(`
${h.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${h.hostName}`),n.push(this.formatMachineInfo(h.machineInfo)),h.processes&&n.push(this.formatProcessList(c,h.processes)),h.workspaceMetadata)for(const g of Object.keys(h.workspaceMetadata)){const k=h.workspaceMetadata[g];let L=`${k.fileCount} files`;k.maxFilesReached&&(L=`more than ${L}`),n.push(`Folder (${g}): ${L}`),n.push(this.formatWorkspaceStats(k))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(c){const i=[],n=60;let o=0;const h=(R,O)=>{const V=` ${R}(${O})`;o+V.length>n?(i.push(g),g="|                 ",o=g.length):o+=V.length,g+=V};let g="|      File types:";const k=10;let L=c.fileTypes.length>k?k:c.fileTypes.length;for(let R=0;R<L;R++){const O=c.fileTypes[R];h(O.name,O.count)}if(i.push(g),c.configFiles.length>=0&&(g="|      Conf files:",o=0,c.configFiles.forEach(R=>{h(R.name,R.count)}),i.push(g)),c.launchConfigFiles.length>0){let R="|      Launch Configs:";c.launchConfigFiles.forEach(O=>{R+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(R)}return i.join(`
`)}expandGPUFeatures(c){const i=Math.max(...Object.keys(c).map(n=>n.length));return Object.keys(c).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${c[n]}`).join(`
                  `)}formatWorkspaceMetadata(c){const i=[],n=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const g=f.URI.revive(h);if(g.scheme===r.Schemas.file){const k=g.fsPath;n.push(S(k,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),i.push(`|    Folder (${(0,I.basename)(k)}): ${R}`),i.push(this.formatWorkspaceStats(L))}).catch(L=>{i.push(`|      Error: Unable to collect workspace stats for folder ${k} (${L.toString()})`)}))}else i.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(c,i){const n=new Map;c.windows.forEach(h=>n.set(h.pid,h.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(c.mainPID,n,o,i,0),o.join(`
`)}formatProcessItem(c,i,n,o,h){const g=h===0;let k;g?k=o.pid===c?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(h)} ${o.name}`,o.name==="window"&&(k=`${k} (${i.get(o.pid)})`));const L=process.platform==="win32"?o.mem:v.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(o.children)&&o.children.forEach(R=>this.formatProcessItem(c,i,n,R,h+1))}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const n=f.URI.revive(i);if(n.scheme!==r.Schemas.file)continue;const o=n.fsPath;try{const h=await S(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),h.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})}),h.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})}),h.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};l=ge([te(0,b.ITelemetryService),te(1,w.IProductService)],l),e.DiagnosticsService=l}),define(Q[204],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(C){this.appenders=C}listen(C,r){throw new Error(`Event not found: ${r}`)}call(C,r,{eventName:I,data:d}){return this.appenders.forEach(f=>f.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class D{constructor(C){this.channel=C}log(C,r){return this.channel.call("log",{eventName:C,data:r}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=D}),define(Q[65],J([0,1,47,13,19,29]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class r{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(S,P){return Promise.resolve(void 0)}publicLog2(S,P){return this.publicLog(S,P)}publicLogError(S,P){return Promise.resolve(void 0)}publicLogError2(S,P){return this.publicLogError(S,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=r,e.NullTelemetryService=new r;class I{async publicLog(S,P,u){}async publicLogError(S,P,u){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(b,S){return S.onDidChangeConfiguration(P=>{P.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=d;function f(b,S){return!(S.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=f;function y(b){const S=b.getValue(C.TELEMETRY_SETTING_ID),P=b.getValue("telemetry.enableCrashReporter");if(b.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(S??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function E(b){const S=Object.create(null),P=Object.create(null),u=Object.create(null);p(b,u);for(let a in u){a=a.length>150?a.substr(a.length-149):a;const l=u[a];typeof l=="number"?P[a]=l:typeof l=="boolean"?P[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),S[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(S[a]=l)}return{properties:S,measurements:P}}e.validateTelemetryData=E;function m(b){if(!b)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{b.indexOf(`${u}+`)===0&&(S=u)}),S}e.cleanRemoteAuthority=m;function p(b,S,P=0,u){if(!!b)for(let a of Object.getOwnPropertyNames(b)){const l=b[a],s=u?u+a:a;Array.isArray(l)?S[s]=(0,v.safeStringify)(l):l instanceof Date?S[s]=l.toISOString():(0,D.isObject)(l)?P<2?p(l,S,P+1,s+"."):S[s]=(0,v.safeStringify)(l):S[s]=l}}function t(b){if(!b)return[];const S=[];return w(S,"",b),S}function w(b,S,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(u=>w(b,S?`${S}.${u}`:u,P[u])):b.push(S)}}),define(Q[205],J([0,1,30,23,16,47,3,34,13,7,19,48,169,196,166,18,6,22,50,199,98,29,65]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=r.isWeb?"web":(0,m.getTargetPlatform)(r.platform,I.arch);var i;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...z){return String(z.reduce((X,ie)=>X|ie,0))}var o;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class R{constructor(X=L){this.state=X}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(X,ie=this.state.pageSize){return new R({...this.state,pageNumber:X,pageSize:ie})}withFilter(X,...ie){const re=[...this.state.criteria,...ie.length?ie.map(se=>({filterType:X,value:se})):[{filterType:X}]];return new R({...this.state,criteria:re})}withSortBy(X){return new R({...this.state,sortBy:X})}withSortOrder(X){return new R({...this.state,sortOrder:X})}withFlags(...X){return new R({...this.state,flags:X.reduce((ie,re)=>ie|re,0)})}withAssetTypes(...X){return new R({...this.state,assetTypes:X})}get raw(){const{criteria:X,pageNumber:ie,pageSize:re,sortBy:se,sortOrder:Z,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:X,pageNumber:ie,pageSize:re,sortBy:se,sortOrder:Z}],assetTypes:le,flags:ce}}get searchText(){const X=this.state.criteria.filter(ie=>ie.filterType===o.SearchText)[0];return X&&X.value?X.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(X=>String(X.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(z,X){const ie=(z||[]).filter(re=>re.statisticName===X)[0];return ie?ie.value:0}function V(z){const X="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(re=>re.assetType.indexOf(X)===0).reduce((re,se)=>{const Z=K(z,se.assetType);return Z&&re.push([se.assetType.substring(X.length),Z]),re},[])}function ee(z){if(z.properties){const X=z.properties.filter(se=>se.key===h.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=X.filter(se=>ie.test(se.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return K(z,h.Repository)}function oe(z){return{uri:`${z.fallbackAssetUri}/${h.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${h.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function ae(z){const X=K(z,h.Icon);if(X)return X;const ie=m.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function K(z,X){return z.files.filter(re=>re.assetType===X)[0]?{uri:`${z.assetUri}/${X}`,fallbackUri:`${z.fallbackAssetUri}/${X}`}:null}function T(z,X){const ie=z.properties?z.properties.filter(se=>se.key===X):[],re=ie.length>0&&ie[0].value;return re?re.split(",").map(se=>(0,p.adoptToGalleryExtensionId)(se)):[]}function N(z){const X=z.properties?z.properties.filter(ie=>ie.key===g.Engine):[];return X.length>0&&X[0].value||""}function G(z){const X=z.properties?z.properties.filter(ie=>ie.key===g.PreRelease):[];return X.length>0&&X[0].value==="true"}function q(z){const X=z.properties?z.properties.filter(re=>re.key===g.LocalizedLanguages):[],ie=X.length>0&&X[0].value||"";return ie?ie.split(","):[]}function _(z){return z.indexOf("preview")!==-1}function U(z){return z.targetPlatform?(0,m.toTargetPlatform)(z.targetPlatform):"undefined"}function j(z){const X=(0,v.distinct)(z.versions.map(U)),ie=!!z.tags?.includes(m.WEB_EXTENSION_TAG),re=X.indexOf("web");return ie?re===-1&&X.push("web"):re!==-1&&X.splice(re,1),X}function F(z,X){const ie=(0,m.getFallbackTargetPlarforms)(X);for(let re=0;re<z.length;re++){const se=z[re];if(se.version===z[re-1]?.version){let Z=re;const ce=U(se);if(ce===X)for(;Z>0&&z[Z-1].version===se.version;)Z--;else if(ie.includes(ce))for(;Z>0&&z[Z-1].version===se.version&&U(z[Z-1])!==X;)Z--;Z!==re&&(z.splice(re,1),z.splice(Z,0,se))}}return z}e.sortExtensionVersions=F;function A(z,X,ie,re){const se=z.versions[0],Z={manifest:K(X,h.Manifest),readme:K(X,h.Details),changelog:K(X,h.Changelog),license:K(X,h.License),repository:ee(X),download:oe(X),icon:ae(X),coreTranslations:V(X)};return{identifier:{id:(0,p.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:X.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:O(z.statistics,"install"),rating:O(z.statistics,"averagerating"),ratingCount:O(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:ie,assets:Z,properties:{dependencies:T(X,g.Dependency),extensionPack:T(X,g.ExtensionPack),engine:N(X),localizedLanguages:q(X),targetPlatform:U(X),isPreReleaseVersion:G(X)},hasPreReleaseVersion:G(se),preview:_(z.flags),telemetryData:re}}let W=class{constructor(X,ie,re,se,Z,ce,le,he){this.requestService=ie,this.logService=re,this.environmentService=se,this.telemetryService=Z,this.fileService=ce,this.productService=le,this.configurationService=he;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=x(le.version,le,this.environmentService,this.configurationService,this.fileService,X)}api(X=""){return`${this.extensionsGalleryUrl}${X}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(X,ie,re){const se=(0,d.isBoolean)(ie)?ie:!1,Z=(0,d.isBoolean)(ie)?re:ie;let ce=new R().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,X.length).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionName,...X.map(({id:me})=>me.toLowerCase()));X.every(me=>!me.version)&&(ce=ce.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,c,D.CancellationToken.None),he=le.map(me=>{const be=(0,p.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName);return{rawGalleryExtension:me,version:X.find(de=>(0,p.areSameExtensions)(de,{id:be}))?.version}});return this.converToGalleryExtensions(he,se,c,()=>{},Z)}async getCompatibleExtension(X,ie,re){const se=(0,m.isIExtensionIdentifier)(X)?null:X;if(se){if((0,m.isNotWebExtensionInWebTargetPlatform)(se.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(se,ie,re))return se}const{id:Z,uuid:ce}=se?se.identifier:X;let le=new R().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");ce?le=le.withFilter(o.ExtensionId,ce):le=le.withFilter(o.ExtensionName,Z);const{galleryExtensions:he}=await this.queryGallery(le,re,D.CancellationToken.None),[me]=he;if(!me||!me.versions.length)return null;const be=j(me);if((0,m.isNotWebExtensionInWebTargetPlatform)(be,re))return null;for(let de of me.versions){if(!N(de)){const fe=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:g.Engine,value:fe}]}}if(await this.isRawExtensionVersionCompatible(de,ie,be,re))return A(me,de,be)}return null}async isExtensionCompatible(X,ie,re){if(!(0,m.isTargetPlatformCompatible)(X.properties.targetPlatform,X.allTargetPlatforms,re)||!ie&&X.properties.isPreReleaseVersion)return!1;let se=X.properties.engine;if(!se){const Z=await this.getManifest(X,D.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");se=Z.engines.vscode}return(0,t.isEngineValid)(se,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(X,ie,re,se){if(!(0,m.isTargetPlatformCompatible)(U(X),re,se)||!ie&&G(X))return!1;const Z=await this.getEngine(X);return(0,t.isEngineValid)(Z,this.productService.version,this.productService.date)}async query(X,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let re=X.text||"";const se=(0,C.getOrDefault)(X,de=>de.pageSize,50);let Z=new R().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(o.Target,"Microsoft.VisualStudio.Code");re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,Se)=>(Z=Z.withFilter(o.Category,Se||fe),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,Se)=>(Z=Z.withFilter(o.Tag,Se||fe),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(o.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),Z=Z.withFilter(o.SearchText,re)),Z=Z.withSortBy(0)):X.ids?Z=Z.withFilter(o.ExtensionId,...X.ids):X.names?Z=Z.withFilter(o.ExtensionName,...X.names):Z=Z.withSortBy(4),typeof X.sortBy=="number"&&(Z=Z.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(Z=Z.withSortOrder(X.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(Z,c,ie),he=de=>({index:(Z.pageNumber-1)*Z.pageSize+de,querySource:X.source}),me=await this.converToGalleryExtensions(ce.map(de=>({rawGalleryExtension:de})),!!X.includePreRelease,c,he,ie),be=async(de,fe)=>{if(fe.isCancellationRequested)throw(0,M.canceled)();const Se=Z.withPage(de+1),{galleryExtensions:Ce}=await this.queryGallery(Se,c,fe);return await this.converToGalleryExtensions(Ce.map(Re=>({rawGalleryExtension:Re})),!!X.includePreRelease,c,he,ie)};return{firstPage:me,total:le,pageSize:Z.pageSize,getPage:be}}async converToGalleryExtensions(X,ie,re,se,Z){const ce=(me,be)=>{const de=j(me);let fe=me.versions[0];return fe=me.versions.find(Se=>Se.version===fe.version&&(0,m.isTargetPlatformCompatible)(U(Se),de,re))||fe,!ie&&G(fe)&&(fe=me.versions.find(Se=>Se.version!==fe.version&&!G(Se))||fe),A(me,fe,de,se(be))},le=[],he=new Map;for(let me=0;me<X.length;me++){const{rawGalleryExtension:be,version:de}=X[me];if(de){const fe=be.versions.find(Se=>Se.version===de);fe&&le.push([me,A(be,fe,j(be))])}else{const fe=ce(be,me);fe.properties.isPreReleaseVersion&&!ie?he.set(fe.identifier.uuid,me):le.push([me,fe])}}if(he.size){const me=new R().withFlags(i.IncludeVersions,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,he.size).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionId,...he.keys()),{galleryExtensions:be}=await this.queryGallery(me,re,Z);if(be.length!==he.size)throw new Error("Not all extensions with latest versions are returned");for(const de of be){const fe=he.get(de.extensionId),Se=ce(de,fe);le.push([fe,Se])}}return le.sort((me,be)=>me[0]-be[0]).map(([,me])=>me)}async queryGallery(X,ie,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");X=X.withFlags(X.flags,i.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,n(i.Unpublished));const se=await this.commonHeadersPromise,Z=JSON.stringify(X.raw),ce={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new Date().getTime();let he,me,be=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:ce},re),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:be};const de=await(0,P.asJson)(he);if(de){const fe=de.results[0],Se=fe.extensions;Se.forEach(Re=>F(Re.versions,ie));const Ce=fe.resultMetadata&&fe.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return be=Ce&&Ce.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:be}}return{galleryExtensions:[],total:be}}catch(de){throw me=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...X.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-le,success:!!he&&(0,P.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:me?(0,M.isPromiseCanceledError)(me)?"canceled":(0,M.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(be)})}}async reportStatistic(X,ie,re,se){if(!this.isEnabled())return;const Z=r.isWeb?this.api(`/itemName/${X}.${ie}/version/${re}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${X}/extensions/${ie}/${re}/stats?statType=${se}`),ce=r.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:Z,headers:he},D.CancellationToken.None)}catch(me){}}async download(X,ie,re){this.logService.trace("ExtensionGalleryService#download",X.identifier.id);const se=(0,p.getGalleryExtensionTelemetryData)(X),Z=new Date().getTime(),ce=be=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:be}),le=re===1?"install":re===2?"update":"",he=le?{uri:`${X.assets.download.uri}${f.URI.parse(X.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${X.assets.download.fallbackUri}${f.URI.parse(X.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:X.assets.download,me=await this.getAsset(he);await this.fileService.writeFile(ie,me.stream),ce(new Date().getTime()-Z)}async getReadme(X,ie){if(X.assets.readme){const re=await this.getAsset(X.assets.readme,{},ie);return await(0,P.asText)(re)||""}return""}async getManifest(X,ie){if(X.assets.manifest){const re=await this.getAsset(X.assets.manifest,{},ie),se=await(0,P.asText)(re);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(X,ie){const re=K(X,h.Manifest);if(!re)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},Z=await this.getAsset(re,{headers:se});return await(0,P.asJson)(Z)}async getCoreTranslation(X,ie){const re=X.assets.coreTranslations.filter(se=>se[0]===ie.toUpperCase())[0];if(re){const se=await this.getAsset(re[1]),Z=await(0,P.asText)(se);return Z?JSON.parse(Z):null}return null}async getChangelog(X,ie){if(X.assets.changelog){const re=await this.getAsset(X.assets.changelog,{},ie);return await(0,P.asText)(re)||""}return""}async getAllCompatibleVersions(X,ie,re){let se=new R().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");X.identifier.uuid?se=se.withFilter(o.ExtensionId,X.identifier.uuid):se=se.withFilter(o.ExtensionName,X.identifier.id);const{galleryExtensions:Z}=await this.queryGallery(se,re,D.CancellationToken.None);if(!Z.length)return[];const ce=j(Z[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(ce,re))return[];const le=[];for(const he of Z[0].versions)try{le[le.length-1]?.version!==he.version&&await this.isRawExtensionVersionCompatible(he,ie,ce,re)&&le.push({version:he.version,date:he.lastUpdated})}catch(me){}return le}async getAsset(X,ie={},re=D.CancellationToken.None){const se=await this.commonHeadersPromise,Z={type:"GET"},ce={...se,...ie.headers||{}};ie={...ie,...Z,headers:ce};const le=X.uri,he=X.fallbackUri,me={...ie,url:le};try{const be=await this.requestService.request(me,re);if(be.res.statusCode===200)return be;const de=await(0,P.asText)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${de}`)}catch(be){if((0,M.isPromiseCanceledError)(be))throw be;const de=(0,M.getErrorMessage)(be);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:de});const fe={...ie,url:he};return this.requestService.request(fe,re)}}async getEngine(X){let ie=N(X);if(!ie){const re=await this.getManifestFromRawExtensionVersion(X,D.CancellationToken.None);if(!re)throw new Error("Manifest was not found");ie=re.engines.vscode}return ie}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const X=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(X.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,P.asJson)(X),re=new Map;if(ie)for(const se of ie.malicious){const Z=re.get(se)||{id:{id:se},malicious:!0,slow:!1};Z.malicious=!0,re.set(se,Z)}return[...re.values()]}};W=ge([te(1,P.IRequestService),te(2,b.ILogService),te(3,E.IEnvironmentService),te(4,l.ITelemetryService),te(5,w.IFileService),te(6,S.IProductService),te(7,y.IConfigurationService)],W);let B=class extends W{constructor(X,ie,re,se,Z,ce,le,he){super(X,ie,re,se,Z,ce,le,he)}};B=ge([te(0,a.IStorageService),te(1,P.IRequestService),te(2,b.ILogService),te(3,E.IEnvironmentService),te(4,l.ITelemetryService),te(5,w.IFileService),te(6,S.IProductService),te(7,y.IConfigurationService)],B),e.ExtensionGalleryService=B;let Y=class extends W{constructor(X,ie,re,se,Z,ce,le){super(void 0,X,ie,re,se,Z,ce,le)}};Y=ge([te(0,P.IRequestService),te(1,b.ILogService),te(2,E.IEnvironmentService),te(3,l.ITelemetryService),te(4,w.IFileService),te(5,S.IProductService),te(6,y.IConfigurationService)],Y),e.ExtensionGalleryServiceWithNoStorageService=Y;async function x(z,X,ie,re,se,Z){const ce={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z}`},le=await(0,u.getServiceMachineId)(ie,se,Z);return(0,s.supportsTelemetry)(X,ie)&&(0,s.getTelemetryLevel)(re)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=x}),define(Q[206],J([0,1,2,47,3,25,152,19,49,56,37,29,65]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(b,S){this._configurationService=S,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const u=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(b,S){this._experimentProperties[b]=S}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let S=b.sessionID,P=b["common.machineId"],u=b["common.firstSessionDate"],a=b["common.msftInternal"];return{sessionId:S,machineId:P,firstSessionDate:u,msftInternal:a}}dispose(){this._disposables.dispose()}_log(b,S,P,u){return this.telemetryLevel<S?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,D.mixin)(P,a),P=(0,D.mixin)(P,this._experimentProperties),P=(0,D.cloneAndChange)(P,l=>{if(typeof l=="string")return this._cleanupInfo(l,u)}),this._appenders.forEach(l=>l.log(b,P))},a=>{console.error(a)})}publicLog(b,S,P){return this._log(b,3,S,P)}publicLog2(b,S,P){return this.publicLog(b,S,P)}publicLogError(b,S){return this.sendErrorTelemetry?this._log(b,2,S,!0):Promise.resolve(void 0)}publicLogError2(b,S){return this.publicLogError(b,S)}_anonymizeFilePaths(b){let S=b;const P=[];for(let s of this._cleanupPatterns)for(;;){const c=s.exec(b);if(!c)break;P.push([c.index,s.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(S="";;){const s=a.exec(b);if(!s)break;!u.test(s[0])&&P.every(([c,i])=>s.index<c||s.index>=i)&&(S+=b.substring(l,s.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<b.length&&(S+=b.substr(l)),S}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const S=b.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(S)?"<REDACTED: secret>":P.test(S)?"<REDACTED: email>":b}_cleanupInfo(b,S){let P=b;S&&(P=this._anonymizeFilePaths(P));for(let u of this._cleanupPatterns)P=P.replace(u,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ge([te(1,I.IConfigurationService)],p),e.TelemetryService=p;function t(){const w=(0,r.localize)(0,null,f.default.nameLong),b=f.default.privacyStatementUrl?(0,r.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,r.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=M.isWeb?"":(0,r.localize)(3,null),P=(0,r.localize)(4,null),u=(0,r.localize)(5,null),a=(0,r.localize)(6,null),l=(0,r.localize)(7,null),s=`
|       | ${P} | ${u} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,r.localize)(8,null);return`
${w} ${b} ${S}

&nbsp;

${l}
${s}

&nbsp;

${c}
`}y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,r.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,r.localize)(10,null),(0,r.localize)(11,null),(0,r.localize)(12,null),(0,r.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,r.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,r.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,r.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,r.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[207],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Q[208],J([0,1,109,4,2,5,37,207]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var d;(function(b){function S(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=S})(d=e.ThemeColor||(e.ThemeColor={}));function f(b){return{id:b}}e.themeColorFromId=f;var y;(function(b){function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||d.isThemeColor(i.color))}b.isThemeIcon=S;const P=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const n=P.exec(i);if(!n)return;let[,o]=n;return{id:o}}b.fromString=u;function a(i,n){let o=i.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),n&&(o=`${o}~${n}`),{id:o}}b.modify=a;function l(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}b.getModifier=l;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}b.isEqual=s;function c(i,n){return{id:i.id,color:n?f(n):void 0}}b.asThemeIcon=c,b.asClassNameArray=v.CSSIcon.asClassNameArray,b.asClassName=v.CSSIcon.asClassName,b.asCSSSelector=v.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function E(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,M.toDisposable)(()=>{const P=this.themingParticipants.indexOf(S);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new m;r.Registry.add(e.Extensions.ThemingContribution,p);function t(b){return p.onColorThemeChange(b)}e.registerThemingParticipant=t;class w extends M.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,P){let u=this.theme.getColor(S);return u&&P&&(u=P(u,this.theme)),u?u.toString():null}}e.Themable=w}),define(Q[66],J([0,1,14,3,5,38]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const r="#FFFFFF",I="#1E1E1E",d="#000000",f="theme",y="themeBackground",E="windowSplash";e.IThemeMainService=(0,M.createDecorator)("themeMainService");let m=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((D.isWindows||D.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(y,null);if(!t){let w;(D.isWindows||D.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?w="hc-black":w=this.stateMainService.getItem(f,"vs-dark").split(" ")[0],t=w==="hc-black"?d:w==="vs"?r:I}return D.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,w){this.stateMainService.setItems([{key:f,data:w.baseTheme},{key:y,data:w.colorInfo.background},{key:E,data:w}]),typeof t=="number"&&this.updateBackgroundColor(t,w)}updateBackgroundColor(t,w){for(const b of v.BrowserWindow.getAllWindows())if(b.id===t){b.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};m=ge([te(0,C.IStateMainService)],m),e.ThemeMainService=m}),define(Q[41],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var D;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(D=e.StateType||(e.StateType={}));var M;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,r)=>({type:"idle",updateType:C,error:r}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Q[209],J([0,1,3,153,49,37]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[210],J([0,1,4,41]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(I){this.service=I}listen(I,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"checkForUpdates":return this.service.checkForUpdates(f);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=M;class C{constructor(I){this.channel=I,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=D.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(Q[99],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Q[211],J([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class D{constructor(I){this.handler=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"handleURL":return this.handler.handleURL(v.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=D;class M{constructor(I){this.channel=I}handleURL(I,d){return this.channel.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=M;class C{constructor(I){this.next=I}async routeCall(I,d,f,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(f){const E=v.URI.revive(f);if(E&&E.query){const m=/\bwindowId=(\d+)/.exec(E.query);if(m){const p=m[1],t=new RegExp(`window:${p}`),w=I.connections.find(b=>t.test(b.ctx));if(w)return w}}}return this.next.routeCall(I,d,f,y)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=C}),define(Q[212],J([0,1,9,2,7,22]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class r extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(f,y){const E=[...this.handlers.values()];return(0,v.first)(E.map(m=>()=>m.handleURL(f,y)),void 0,!1).then(m=>m||!1)}registerHandler(f){return this.handlers.add(f),(0,D.toDisposable)(()=>this.handlers.delete(f))}}e.AbstractURLService=r;let I=class extends r{constructor(f){super();this.productService=f}create(f){let{authority:y,path:E,query:m,fragment:p}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&E&&E.indexOf("/")!==0&&(E=`/${E}`),M.URI.from({scheme:this.productService.urlProtocol,authority:y,path:E,query:m,fragment:p})}};I=ge([te(0,C.IProductService)],I),e.NativeURLService=I}),define(Q[213],J([0,1,14,9,4,2,3,7]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(y){try{return I.URI.parse(y)}catch(E){return null}}class f{constructor(E,m,p,t,w){if(this.urlService=m,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=E,r.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),v.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,P)}const b=M.Event.map(M.Event.fromNodeEventEmitter(v.app,"open-url",(P,u)=>({event:P,url:u})),({event:P,url:u})=>(P.preventDefault(),u));this.disposables.add(b(P=>{const u=d(P);!u||this.urlService.open(u,{originalUrl:P})})),p.getWindows().filter(P=>P.isReady).length>0?this.flush():M.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.url})||E.push(m);E.length!==0&&(this.uris=E,this.flushDisposable=(0,D.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(Q[214],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Q[215],J([0,1,14,2,10,7]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class r extends D.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(M.Schemas.vscodeWebview,d)}handleWebviewRequest(d,f){try{const y=C.URI.parse(d.url),E=r.validWebviewFilePaths.get(y.path);if(typeof E=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${E}`,p=M.FileAccess.asFileUri(m,$);return f(decodeURIComponent(p.fsPath))}else return f({error:-10})}catch{}return f({error:-2})}}e.WebviewProtocolProvider=r,r.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[67],J([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(f){return!!f.workspaceUri}e.isWorkspaceToOpen=D;function M(f){return!!f.folderUri}e.isFolderToOpen=M;function C(f){return!!f.fileUri}e.isFileToOpen=C;function r(f){const y=I(f),E=f.getValue("window.menuBarVisibility");return E==="default"||y==="native"&&E==="compact"||v.isMacintosh&&v.isNative?"classic":E}e.getMenuBarVisibility=r;function I(f){if(v.isWeb)return"custom";const y=f.getValue("window");if(y){if(v.isMacintosh&&y.nativeTabs===!0||v.isMacintosh&&y.nativeFullScreen===!1)return"native";const p=f.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=y.titleBarStyle;if(t==="native"||t==="custom")return t}return v.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(f=0){return Math.pow(1.2,f)}e.zoomLevelToZoomFactor=d}),define(Q[36],J([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var D;(function(f){f[f.INITIAL=1]="INITIAL",f[f.LOAD=2]="LOAD",f[f.RELOAD=3]="RELOAD"})(D=e.LoadReason||(e.LoadReason={}));var M;(function(f){f[f.CLOSE=1]="CLOSE",f[f.QUIT=2]="QUIT",f[f.RELOAD=3]="RELOAD",f[f.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));var C;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const r=function(f=1){return{width:1024,height:768,mode:f}};e.defaultWindowState=r;var I;(function(f){f[f.Maximized=0]="Maximized",f[f.Normal=1]="Normal",f[f.Minimized=2]="Minimized",f[f.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var d;(function(f){f[f.UNRESPONSIVE=1]="UNRESPONSIVE",f[f.CRASHED=2]="CRASHED",f[f.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Q[216],J([0,1,14,4,2,215,36]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends M.Disposable{constructor(f){super();this.windowsMainService=f,this._onFoundInFrame=this._register(new D.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,y){let E;if(typeof f.windowId=="number"){const{windowId:m}=f,p=this.windowsMainService.getWindowById(m);if(!p?.win)throw new Error(`Invalid windowId: ${m}`);E=p.win.webContents}else{const{webContentsId:m}=f;if(E=v.webContents.fromId(m),!E)throw new Error(`Invalid webContentsId: ${m}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(y)}async findInFrame(f,y,E,m){const p=this.getFrameByName(f,y),t=p;if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:m.findNext,forward:m.forward});const w=(b,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),p.removeListener("found-in-frame",w))};p.on("found-in-frame",w)}}async stopFindInFrame(f,y,E){const p=this.getFrameByName(f,y);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(f,y){const E=this.windowsMainService.getWindowById(f.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${f}`);const m=E.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===y);if(!m)throw new Error(`Unknown frame: ${y}`);return m}};I=ge([te(0,r.IWindowsMainService)],I),e.WebviewMainService=I}),define(Q[217],J([0,1,9,4,2]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends M.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:f}){super();this.disposables=this._register(new M.DisposableStore),D.Event.latch(D.Event.any(I,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>f()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(Q[218],J([0,1,40,15,7,5]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var r;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(r=e.WorkbenchState||(e.WorkbenchState={}));function I(m){const p=m;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=I;function d(m){const p=m;return!!(p&&typeof p=="object"&&M.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(p,t,w,b,S){this._id=p,this._transient=w,this._configuration=b,this._ignorePathCasing=S,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(p,t){this.raw=t,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,D.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function E(m){return new y({uri:m,index:0,name:(0,D.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=E}),define(Q[27],J([0,1,32,39,78,33,10,8,3,15,7,156,5,64,218]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(T){return(typeof T=="string"?(0,I.extname)(T):(0,f.extname)(T))===w}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function S(T){return T.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function P(T){return T.hasOwnProperty("folderUri")}e.isRecentFolder=P;function u(T){return T.hasOwnProperty("fileUri")}e.isRecentFile=u;function a(T){const N=T;return typeof N?.id=="string"&&y.URI.isUri(N.uri)}e.isSingleFolderWorkspaceIdentifier=a;function l(T){if(T.configuration)return{id:T.id,configPath:T.configuration};if(T.folders.length===1)return{id:T.id,uri:T.folders[0].uri}}e.toWorkspaceIdentifier=l;function s(T){const N=T;return typeof N?.id=="string"&&y.URI.isUri(N.configPath)}e.isWorkspaceIdentifier=s;function c(T){const N=T;if(N?.uri)return{id:N.id,uri:y.URI.revive(N.uri)};const G=T;if(G?.configPath)return{id:G.id,configPath:y.URI.revive(G.configPath)};if(T?.id)return{id:T.id}}e.reviveIdentifier=c;function i(T,N){return f.extUriBiasedIgnorePathCase.isEqualOrParent(T,N.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function n(T){return o(T)||h(T)}e.isStoredWorkspaceFolder=n;function o(T){const N=T;return typeof N?.path=="string"&&(!N.name||typeof N.name=="string")}e.isRawFileWorkspaceFolder=o;function h(T){const N=T;return typeof N?.uri=="string"&&(!N.name||typeof N.name=="string")}e.isRawUriWorkspaceFolder=h;function g(T,N,G,q,_=!d.isWindows,U){if(T.scheme!==q.scheme)return{name:G,uri:T.toString(!0)};let j=N?void 0:U.relativePath(q,T);if(j!==void 0)j.length===0?j=".":d.isWindows&&T.scheme===r.Schemas.file&&!_&&(j=j.replace(/\//g,"\\"));else if(T.scheme===r.Schemas.file)j=T.fsPath,d.isWindows&&(j=(0,C.normalizeDriveLetter)(j),_&&(j=(0,v.toSlashes)(j)));else{if(!U.isEqualAuthority(T.authority,q.authority))return{name:G,uri:T.toString(!0)};j=T.path}return{name:G,path:j}}e.getStoredWorkspaceFolder=g;function k(T,N,G){let q=[],_=new Set;const U=G.dirname(N);for(let j of T){let F;if(o(j))j.path&&(F=G.resolvePath(U,j.path));else if(h(j))try{F=y.URI.parse(j.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(A){console.warn(A)}if(F){let A=G.getComparisonKey(F);if(!_.has(A)){_.add(A);const W=j.name||G.basenameOrAuthority(F);q.push(new t.WorkspaceFolder({uri:F,name:W,index:q.length},j))}}}return q}e.toWorkspaceFolders=k;function L(T,N,G,q,_){let U=R(N,T);const j=_.dirname(N),F=_.dirname(q),A=[],W=O(U.folders);for(const z of U.folders){const X=o(z)?_.resolvePath(j,z.path):y.URI.parse(z.uri);let ie;G?ie=!1:ie=!o(z)||(0,I.isAbsolute)(z.path),A.push(g(X,ie,z.name,F,W,_))}const B={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},Y=M.setProperty(T,["folders"],A,B);let x=M.applyEdits(T,Y);return(0,f.isEqualAuthority)(U.remoteAuthority,(0,p.getRemoteAuthority)(q))&&(x=M.applyEdits(x,M.removeProperty(x,["remoteAuthority"],B))),x}e.rewriteWorkspaceFileForNewLocation=L;function R(T,N){let G=D.parse(N);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(q=>n(q));else throw new Error(`${T} looks like an invalid workspace file.`);return G}function O(T){return d.isWindows?T.some(N=>o(N)&&N.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function V(T){return T.workspace&&typeof T.workspace=="object"&&typeof T.workspace.id=="string"&&typeof T.workspace.configPath=="string"}function ee(T){return typeof T.folderUri=="string"}function oe(T){return typeof T.fileUri=="string"}function ae(T,N){const G={workspaces:[],files:[]};if(T){const q=function(U,j){for(let F=0;F<U.length;F++)try{j(U[F],F)}catch(A){N.warn(`Error restoring recent entry ${JSON.stringify(U[F])}: ${A.toString()}. Skip entry.`)}},_=T;if(Array.isArray(_.entries))q(_.entries,U=>{const j=U.label,F=U.remoteAuthority;V(U)?G.workspaces.push({label:j,remoteAuthority:F,workspace:{id:U.workspace.id,configPath:y.URI.parse(U.workspace.configPath)}}):ee(U)?G.workspaces.push({label:j,remoteAuthority:F,folderUri:y.URI.parse(U.folderUri)}):oe(U)&&G.files.push({label:j,remoteAuthority:F,fileUri:y.URI.parse(U.fileUri)})});else{const U=T;Array.isArray(U.workspaces3)&&q(U.workspaces3,(j,F)=>{const A=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[F]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?G.workspaces.push({label:A,workspace:{id:j.id,configPath:y.URI.parse(j.configURIPath)}}):typeof j=="string"&&G.workspaces.push({label:A,folderUri:y.URI.parse(j)})}),Array.isArray(U.files2)&&q(U.files2,(j,F)=>{const A=Array.isArray(U.fileLabels)&&U.fileLabels[F]||void 0;typeof j=="string"&&G.files.push({label:A,fileUri:y.URI.parse(j)})})}}return G}e.restoreRecentlyOpened=ae;function K(T){const N={entries:[]};for(const G of T.workspaces)P(G)?N.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):N.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of T.files)N.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return N}e.toStoreData=K}),define(Q[51],J([0,1,5,27]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function M(C){const r=C;return r&&(0,D.isWorkspaceIdentifier)(r.workspace)}e.isWorkspaceBackupInfo=M}),define(Q[52],J([0,1,14,9,81,33,2,70,8,3,13,21,136,5,6,38,27]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let S=class vt{constructor(u,a){this.stateMainService=u,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(u,a){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},a)}pickFolder(u,a){return this.doPick({...u,pickFolders:!0,title:(0,m.localize)(1,null)},a)}pickFile(u,a){return this.doPick({...u,pickFiles:!0,title:(0,m.localize)(2,null)},a)}pickWorkspace(u,a){const l=(0,m.localize)(3,null),s=(0,C.mnemonicButtonLabel)((0,m.localize)(4,null)),c=b.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:l,filters:c,buttonLabel:s},a)}async doPick(u,a){const l={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};l.defaultPath=u.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(l.properties=void 0,u.pickFiles&&u.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&l.properties.push("treatPackageAsDirectory");const s=a||v.BrowserWindow.getFocusedWindow(),c=await this.showOpenDialog(l,(0,y.withNullAsUndefined)(s));if(c&&c.filePaths&&c.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,d.dirname)(c.filePaths[0])),c.filePaths}getWindowDialogQueue(u){if(u){let a=this.windowDialogQueues.get(u.id);return a||(a=new D.Queue,this.windowDialogQueues.set(u.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(u,a){return this.getWindowDialogQueue(a).queue(async()=>a?v.dialog.showMessageBox(a,u):v.dialog.showMessageBox(u))}async showSaveDialog(u,a){const l=this.acquireFileDialogLock(u,a);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await v.dialog.showSaveDialog(a,u):s=await v.dialog.showSaveDialog(u),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,r.dispose)(l)}}normalizePath(u){return u&&f.isMacintosh&&(u=(0,I.normalizeNFC)(u)),u}normalizePaths(u){return u.map(a=>this.normalizePath(a))}async showOpenDialog(u,a){u.defaultPath&&(await E.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const l=this.acquireFileDialogLock(u,a);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await v.dialog.showOpenDialog(a,u):s=await v.dialog.showOpenDialog(u),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,r.dispose)(l)}}acquireFileDialogLock(u,a){if(!a)return r.Disposable.None;let l=this.windowFileDialogLocks.get(a.id);l||(l=new Set,this.windowFileDialogLocks.set(a.id,l));const s=(0,M.hash)(u);if(!l.has(s))return l.add(s),(0,r.toDisposable)(()=>{l?.delete(s),l?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=ge([te(0,w.IStateMainService),te(1,t.ILogService)],S),e.DialogMainService=S}),define(Q[219],J([0,1,4,2,27]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends D.Disposable{constructor(I,d){super();this.logService=I,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,d)=>(I?I.push(d):I=[d],I),C.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const d=new Map,f=new Set;return I.forEach(y=>{const E=this.storageMainService.globalStorage.get(y.key);typeof E=="string"?d.set(y.key,E):f.add(y.key)}),{changed:Array.from(d.entries()),deleted:Array.from(f.values())}}listen(I,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(I,d,f){const y=(0,M.reviveIdentifier)(f.workspace),E=await this.withStorageInitialized(y);switch(d){case"getItems":return Array.from(E.items.entries());case"updateItems":{const m=f;if(m.insert)for(const[p,t]of m.insert)E.set(p,t);m.delete&&m.delete.forEach(p=>E.delete(p));break}case"close":{if(y)return E.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(I){const d=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await d.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${f}`)}return d}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[220],J([0,1,4,2,8,21,86,126,6,98,29,27]),function($,e,v,D,M,C,r,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class m extends D.Disposable{constructor(b){super();this.logService=b,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new r.Storage(new r.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const b=await this.doCreate();this.storage.dispose(),this.storage=b,this._register(b.onDidChangeStorage(P=>this._onDidChangeStorage.fire({key:P}))),await this.doInit(b);const S=b.getBoolean(f.IS_NEW_KEY);S===void 0?b.set(f.IS_NEW_KEY,!0):S&&b.set(f.IS_NEW_KEY,!1)}catch(b){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${b}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===d.LogLevel.Trace?b=>this.logService.trace(b):void 0,logError:b=>this.logService.error(b)}}doInit(b){return b.init()}get items(){return this.storage.items}get(b,S){return this.storage.get(b,S)}set(b,S){return this.storage.set(b,S)}delete(b){return this.storage.delete(b)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class p extends m{constructor(b,S,P){super(S);this.options=b,this.environmentService=P}async doCreate(){let b;return this.options.useInMemoryStorage?b=I.SQLiteStorageDatabase.IN_MEMORY_PATH:b=(0,M.join)(this.environmentService.globalStorageHome.fsPath,p.STORAGE_NAME),new r.Storage(new I.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}))}async doInit(b){await super.doInit(b),this.updateTelemetryState(b)}updateTelemetryState(b){b.get(y.firstSessionDateStorageKey,void 0)===void 0&&b.set(y.firstSessionDateStorageKey,new Date().toUTCString());const P=b.get(y.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();b.set(y.lastSessionDateStorageKey,typeof P=="undefined"?null:P),b.set(y.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=p,p.STORAGE_NAME="state.vscdb";class t extends m{constructor(b,S,P,u){super(P);this.workspace=b,this.options=S,this.environmentService=u}async doCreate(){const{storageFilePath:b,wasCreated:S}=await this.prepareWorkspaceStorageFolder();return new r.Storage(new I.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}),{hint:S?r.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const b=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),S=(0,M.join)(b,t.WORKSPACE_STORAGE_NAME);return await C.Promises.exists(b)?{storageFilePath:S,wasCreated:!1}:(await C.Promises.mkdir(b,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(b),{storageFilePath:S,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(b){let S;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?S={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(S={workspace:this.workspace.configPath.toString()}),S)try{const P=(0,M.join)(b,t.WORKSPACE_META_NAME);await C.Promises.exists(P)||await C.Promises.writeFile(P,JSON.stringify(S,void 0,2))}catch(P){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${P}`)}}}e.WorkspaceStorageMain=t,t.WORKSPACE_STORAGE_NAME="state.vscdb",t.WORKSPACE_META_NAME="workspace.json"}),define(Q[100],J([0,1,42,2,48,5,20,6,220]),function($,e,v,D,M,C,r,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let f=class extends D.Disposable{constructor(E,m,p){super();this.logService=E,this.environmentService=m,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,m]of this.mapWorkspaceToStorage)E.join(m.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new d.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let m=this.mapWorkspaceToStorage.get(E.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),m=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,m),(0,v.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),m}};f=ge([te(0,I.ILogService),te(1,M.IEnvironmentService),te(2,r.ILifecycleMainService)],f),e.StorageMainService=f}),define(Q[101],J([0,1,15,7,27]),function($,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(d,f,y){for(const m of d){const p=m.openedWorkspace;if((0,M.isWorkspaceIdentifier)(p)){const t=y(p);if(t){if(t.folders.some(w=>v.extUriBiasedIgnorePathCase.isEqualOrParent(f,w.uri)))return m}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(f,p.configPath))return m}}const E=d.filter(m=>(0,M.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(f,m.openedWorkspace.uri));if(E.length)return E.sort((m,p)=>-(m.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function r(d,f){for(const y of d)if((0,M.isWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,f)||(0,M.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,f))return y}e.findWindowOnWorkspaceOrFolder=r;function I(d,f){const y=E=>f.some(m=>v.extUriBiasedIgnorePathCase.isEqual(D.URI.file(m),D.URI.file(E)));for(const E of d)if(E.config?.extensionDevelopmentPath?.some(m=>y(m)))return E}e.findWindowOnExtensionDevelopmentPath=I}),define(Q[221],J([0,1,14,2,3,15,7,19,20,6,38,36,27]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class yt extends D.Disposable{constructor(u,a,l,s,c){super();this.windowsMainService=u,this.stateMainService=a,this.lifecycleMainService=l,this.logService=s,this.configurationService=c,this._state=t(this.stateMainService.getItem(yt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let s=this.windowsMainService.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.windowsMainService.getWindows().find(c=>!c.isExtensionDevelopmentHost)),s&&(u.lastActiveWindow=this.toWindowState(s))}const a=this.windowsMainService.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);a&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>this.toWindowState(s)));const l=b(u);this.stateMainService.setItem(yt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(l=>{const s=(0,m.isWorkspaceIdentifier)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,c=(0,m.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&l.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(l.folderUri,u.openedWorkspace.uri);(s||c)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(u){return{workspace:(0,m.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const a=this.doGetNewWindowState(u),l=this.configurationService.getValue("window");let s;return a.hasDefaultState?s=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(s=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),s&&M.isMacintosh&&this.windowsMainService.getWindows().some(c=>c.isFullScreen)&&(s=!1)),a.mode===3&&!s&&(a.mode=1),a}doGetNewWindowState(u){const a=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=u.workspace;if((0,m.isWorkspaceIdentifier)(o)){const g=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===o.id).map(k=>k.uiState);if(g.length)return g[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(o)){const g=this.state.openedWindows.filter(k=>k.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(k.folderUri,o.uri)).map(k=>k.uiState);if(g.length)return g[0]}else if(u.backupPath){const g=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(g.length)return g[0]}const h=this.lastClosedState||this.state.lastActiveWindow;if(!a&&h)return h.uiState}let l;const s=v.screen.getAllDisplays();if(s.length===1)l=s[0];else{if(M.isMacintosh){const o=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(o)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||s[0])}let c=(0,E.defaultWindowState)();c.x=Math.round(l.bounds.x+l.bounds.width/2-c.width/2),c.y=Math.round(l.bounds.y+l.bounds.height/2-c.height/2);const i=this.configurationService.getValue("window");let n=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")c.mode=0,n=!1;else if(i.newWindowDimensions==="fullscreen")c.mode=3,n=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?c.mode=3:c=o,n=c.mode!==3&&i.newWindowDimensions==="offset"}}return n&&(c=this.ensureNoOverlap(c)),c.hasDefaultState=!0,c}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};p.windowsStateStorageKey="windowsState",p=ge([te(0,E.IWindowsMainService),te(1,y.IStateMainService),te(2,d.ILifecycleMainService),te(3,f.ILogService),te(4,I.IConfigurationService)],p),e.WindowsStateHandler=p;function t(P){const u={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(u.lastActiveWindow=w(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=w(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(u.openedWindows=a.openedWindows.map(l=>w(l))),u}e.restoreWindowsState=t;function w(P){const u={uiState:P.uiState};return P.backupPath&&(u.backupPath=P.backupPath),P.remoteAuthority&&(u.remoteAuthority=P.remoteAuthority),P.folder&&(u.folderUri=r.URI.parse(P.folder)),P.workspaceIdentifier&&(u.workspace={id:P.workspaceIdentifier.id,configPath:r.URI.parse(P.workspaceIdentifier.configURIPath)}),u}function b(P){return{lastActiveWindow:P.lastActiveWindow&&S(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&S(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(u=>S(u))}}e.getWindowsStateStoreData=b;function S(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Q[102],J([0,1,61,28,10,3,15]),function($,e,v,D,M,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(f){function y(){let E=f.scheme===M.Schemas.file?(0,r.originalFSPath)(f):f.toString();return C.isLinux||(E=E.toLowerCase()),(0,v.createHash)("md5").update(E).digest("hex")}return{id:y(),configPath:f}}e.getWorkspaceIdentifier=I;function d(f,y){function E(){if(f.scheme!==M.Schemas.file)return(0,v.createHash)("md5").update(f.toString()).digest("hex");if(!y)try{y=(0,D.statSync)(f.fsPath)}catch(t){return}let p;return C.isLinux?p=y.ino:C.isMacintosh?p=y.birthtime.getTime():C.isWindows&&(typeof y.birthtimeMs=="number"?p=Math.floor(y.birthtimeMs):p=y.birthtime.getTime()),(0,v.createHash)("md5").update(f.fsPath).update(p?String(p):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:f}}e.getSingleFolderWorkspaceIdentifier=d}),define(Q[222],J([0,1,16,10,6,250,113,20]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class d{constructor(m,p){this._worker=new C.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",$).fsPath),this._worker.on("message",m),this._worker.on("error",p)}getId(){return 1}postMessage(m,p){this._worker.postMessage(m,p)}dispose(){this._worker.terminate()}}let f=class{constructor(m){this._logService=m}async logInfo(m){this._logService.info(m)}};f=ge([te(0,M.ILogService)],f);let y=class{constructor(m,p){this._logService=m,this._shutdown=!1,this._proxy=null;const t={create:(w,b,S)=>{const P=new d(b,S);return P.postMessage(w,[]),P}};this._worker=new r.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new f(this._logService)),this._initialize(),p.onWillShutdown(w=>{this._shutdown=!0,this._proxy&&w.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(m){return this._proxy.onDynamicStdout(m)}onDynamicStderr(m){return this._proxy.onDynamicStderr(m)}onDynamicMessage(m){return this._proxy.onDynamicMessage(m)}onDynamicError(m){return this._proxy.onDynamicError(m)}onDynamicExit(m){return this._proxy.onDynamicExit(m)}async createExtensionHost(){const m=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return m.createExtensionHost()}async start(m,p){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return t.start(m,p)}async enableInspectPort(m){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.enableInspectPort(m)}async kill(m){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.kill(m)}};y=ge([te(0,M.ILogService),te(1,I.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(Q[58],J([0,1,61,62,26,17,16,4,2,8,3,31,35,84,223]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(g){this.socket=g,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,r.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const k=L=>g(C.VSBuffer.wrap(L));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(g){const k=L=>{g({type:0,hadError:L,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,r.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,r.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((g,k)=>{if(this.socket.bufferSize===0){g();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),g()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=w;var b;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var S;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(S||(S={}));class P extends d.Disposable{constructor(g,k,L,R){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=R,k?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,r.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,r.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(C.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,k){let L=2;g.byteLength<126?L+=0:g.byteLength<2**16?L+=2:L+=8;const R=C.VSBuffer.alloc(L);if(k?R.writeUInt8(194,0):R.writeUInt8(130,0),g.byteLength<126)R.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){R.writeUInt8(126,1);let O=1;R.writeUInt8(g.byteLength>>>8&255,++O),R.writeUInt8(g.byteLength>>>0&255,++O)}else{R.writeUInt8(127,1);let O=1;R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(g.byteLength>>>24&255,++O),R.writeUInt8(g.byteLength>>>16&255,++O),R.writeUInt8(g.byteLength>>>8&255,++O),R.writeUInt8(g.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=R.byteLength+g.byteLength,this.socket.write(C.VSBuffer.concat([R,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),L=k.readUInt8(0),R=(L&128)>>>7,O=(L&64)>>>6,V=k.readUInt8(1),ee=(V&128)>>>7,oe=V&127;this._state.state=2,this._state.readLen=2+(ee?4:0)+(oe===126?2:0)+(oe===127?8:0),this._state.fin=R,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(R),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),L=k.readUInt8(1),R=(L&128)>>>7;let O=L&127,V=1;O===126?O=k.readUInt8(++V)*2**8+k.readUInt8(++V):O===127&&(O=k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V));let ee=0;R&&(ee=k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V)),this._state.state=3,this._state.readLen=O,this._state.mask=ee}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);u(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(C.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function u(h,g){if(g===0)return;let k=h.byteLength>>>2;for(let oe=0;oe<k;oe++){const ae=h.readUInt32BE(oe*4);h.writeUInt32BE(ae^g,oe*4)}let L=k*4,R=h.byteLength-L;const O=g>>>24&255,V=g>>>16&255,ee=g>>>8&255;R>=1&&h.writeUInt8(h.readUInt8(L)^O,L),R>=2&&h.writeUInt8(h.readUInt8(L+1)^V,L+1),R>=3&&h.writeUInt8(h.readUInt8(L+2)^ee,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const h=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):g=(0,f.join)((0,M.tmpdir)(),`vscode-ipc-${h}.sock`),c(g),g}e.createRandomIPCHandle=l;function s(h,g,k){const L=(0,v.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${k}-${g}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${k}-${g}.sock`):R=(0,f.join)(h,`${k}-${g}.sock`),c(R),R}e.createStaticIPCHandle=s;function c(h){const g=a[y.platform];typeof g=="number"&&h.length>=g&&console.warn(`WARNING: IPC handle "${h}" is longer than ${g} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{constructor(g){super(i.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const k=I.Event.fromNodeEventEmitter(g,"connection");return I.Event.map(k,L=>({protocol:new p.Protocol(new w(L)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(h){return new Promise((g,k)=>{const L=(0,D.createServer)();L.on("error",k),L.listen(h,()=>{L.removeListener("error",k),g(new i(L))})})}e.serve=n;function o(h,g){return new Promise((k,L)=>{const R=(0,D.createConnection)(h,()=>{R.removeListener("error",L),k(p.Client.fromSocket(new w(R),g))});R.once("error",L)})}e.connect=o}),define(Q[224],J([0,1,58]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class D{constructor(d){this.driver=d}listen(d,f){throw new Error("No event found")}call(d,f,y){switch(f){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(y);case"reloadWindow":return this.driver.reloadWindow(y);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(y[0],y[1]);case"click":return this.driver.click(y[0],y[1],y[2],y[3]);case"doubleClick":return this.driver.doubleClick(y[0],y[1]);case"setValue":return this.driver.setValue(y[0],y[1],y[2]);case"getTitle":return this.driver.getTitle(y[0]);case"isActiveElement":return this.driver.isActiveElement(y[0],y[1]);case"getElements":return this.driver.getElements(y[0],y[1],y[2]);case"getElementXY":return this.driver.getElementXY(y[0],y[1],y[2]);case"typeInEditor":return this.driver.typeInEditor(y[0],y[1],y[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(y[0],y[1]);case"writeInTerminal":return this.driver.writeInTerminal(y[0],y[1],y[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(y);case"getLocalizedStrings":return this.driver.getLocalizedStrings(y)}throw new Error(`Call not found: ${f}`)}}e.DriverChannel=D;class M{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,f){return this.channel.call("dispatchKeybinding",[d,f])}click(d,f,y,E){return this.channel.call("click",[d,f,y,E])}doubleClick(d,f){return this.channel.call("doubleClick",[d,f])}setValue(d,f,y){return this.channel.call("setValue",[d,f,y])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,f){return this.channel.call("isActiveElement",[d,f])}getElements(d,f,y){return this.channel.call("getElements",[d,f,y])}getElementXY(d,f,y,E){return this.channel.call("getElementXY",[d,f,y,E])}typeInEditor(d,f,y){return this.channel.call("typeInEditor",[d,f,y])}getTerminalBuffer(d,f){return this.channel.call("getTerminalBuffer",[d,f])}writeInTerminal(d,f,y){return this.channel.call("writeInTerminal",[d,f,y])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=M;class C{constructor(d){this.registry=d}listen(d,f){throw new Error(`Event not found: ${f}`)}call(d,f,y){switch(f){case"registerWindowDriver":return this.registry.registerWindowDriver(y);case"reloadWindowDriver":return this.registry.reloadWindowDriver(y)}throw new Error(`Call not found: ${f}`)}}e.WindowDriverRegistryChannel=C;async function r(I){const d=await(0,v.connect)(I,"driverClient"),f=d.getChannel("driver"),y=new M(f);return{client:d,driver:y}}e.connect=r}),define(Q[225],J([0,1,9,4,106,59,2,3,35,58,160,224,178,20,36]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function w(P){return P<21}let b=class{constructor(u,a,l,s){this.windowServer=u,this.options=a,this.windowsMainService=l,this.lifecycleMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new D.Emitter}async registerWindowDriver(u){return this.registeredWindowIds.add(u),this.reloadingWindowIds.delete(u),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(u){this.reloadingWindowIds.add(u)}async getWindowIds(){return this.windowsMainService.getWindows().map(u=>u.id).filter(u=>this.registeredWindowIds.has(u)&&!this.reloadingWindowIds.has(u))}async capturePage(u){await this.whenUnfrozen(u);const a=this.windowsMainService.getWindowById(u);if(!a?.win)throw new Error("Invalid window");return(await a.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(u){await this.whenUnfrozen(u);const a=this.windowsMainService.getWindowById(u);if(!a)throw new Error("Invalid window");this.reloadingWindowIds.add(u),this.lifecycleMainService.reload(a)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(u,a){await this.whenUnfrozen(u);const l=M.KeybindingParser.parseUserBinding(a);for(let s of l)await this._dispatchKeybinding(u,s)}async _dispatchKeybinding(u,a){if(a instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const l=this.windowsMainService.getWindowById(u);if(!l?.win)throw new Error("Invalid window");const s=l.win.webContents,c=new C.SimpleKeybinding(!1,!1,!1,!1,a.keyCode),n=new m.USLayoutResolvedKeybinding(c.toChord(),I.OS).getElectronAccelerator(),o=[];a.ctrlKey&&o.push("ctrl"),a.metaKey&&o.push("meta"),a.shiftKey&&o.push("shift"),a.altKey&&o.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:n,modifiers:o}),w(a.keyCode)||s.sendInputEvent({type:"char",keyCode:n,modifiers:o}),s.sendInputEvent({type:"keyUp",keyCode:n,modifiers:o}),await(0,v.timeout)(100)}async click(u,a,l,s){await(await this.getWindowDriver(u)).click(a,l,s)}async doubleClick(u,a){await(await this.getWindowDriver(u)).doubleClick(a)}async setValue(u,a,l){await(await this.getWindowDriver(u)).setValue(a,l)}async getTitle(u){return await(await this.getWindowDriver(u)).getTitle()}async isActiveElement(u,a){return await(await this.getWindowDriver(u)).isActiveElement(a)}async getElements(u,a,l){return await(await this.getWindowDriver(u)).getElements(a,l)}async getElementXY(u,a,l,s){return await(await this.getWindowDriver(u)).getElementXY(a,l,s)}async typeInEditor(u,a,l){await(await this.getWindowDriver(u)).typeInEditor(a,l)}async getTerminalBuffer(u,a){return await(await this.getWindowDriver(u)).getTerminalBuffer(a)}async writeInTerminal(u,a,l){await(await this.getWindowDriver(u)).writeInTerminal(a,l)}async getLocaleInfo(u){return await(await this.getWindowDriver(u)).getLocaleInfo()}async getLocalizedStrings(u){return await(await this.getWindowDriver(u)).getLocalizedStrings()}async getWindowDriver(u){await this.whenUnfrozen(u);const a=`window:${u}`,l=new d.StaticRouter(c=>c===a),s=this.windowServer.getChannel("windowDriver",l);return new y.WindowDriverChannelClient(s)}async whenUnfrozen(u){for(;this.reloadingWindowIds.has(u);)await D.Event.toPromise(this.onDidReloadingChange.event)}};b=ge([te(2,t.IWindowsMainService),te(3,p.ILifecycleMainService)],b),e.Driver=b;async function S(P,u,a,l){const s=a.driverVerbose,c=l.createInstance(b,P,{verbose:s}),i=new E.WindowDriverRegistryChannel(c);P.registerChannel("windowDriverRegistry",i);const n=await(0,f.serve)(u),o=new E.DriverChannel(c);return n.registerChannel("driver",o),(0,r.combinedDisposable)(n,P)}e.serve=S}),define(Q[24],J([0,1,46,8,58,48,164,5]),function($,e,v,D,M,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class d extends r.NativeEnvironmentService{get cachedLanguagesPath(){return(0,D.join)(this.userDataPath,"clp")}get backupHome(){return(0,D.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,D.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,D.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ge([v.memoize],d.prototype,"cachedLanguagesPath",null),ge([v.memoize],d.prototype,"backupHome",null),ge([v.memoize],d.prototype,"backupWorkspacesPath",null),ge([v.memoize],d.prototype,"mainIPCHandle",null),ge([v.memoize],d.prototype,"mainLockfile",null),ge([v.memoize],d.prototype,"sandbox",null),ge([v.memoize],d.prototype,"driverVerbose",null),ge([v.memoize],d.prototype,"disableUpdates",null),ge([v.memoize],d.prototype,"disableKeytar",null),ge([v.memoize],d.prototype,"codeCachePath",null),ge([v.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Q[226],J([0,1,61,28,32,10,8,3,15,7,21,51,19,24,18,6,27]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(u,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,c)=>(0,M.isEqual)(s,c,!I.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await y.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(s){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let a=[];try{Array.isArray(u.rootURIWorkspaces)&&(a=u.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:f.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch(s){}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(u.folderURIWorkspaces)&&(l=u.folderURIWorkspaces.map(s=>f.URI.parse(s)))}catch(s){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,a){this.workspaces.some(s=>u.workspace.id===s.workspace.id)||(this.workspaces.push(u),this.saveSync());const l=this.getBackupPath(u.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(u,a){if(D.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),D.existsSync(a))try{D.renameSync(a,u)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(u){const a=u.id,l=this.workspaces.findIndex(s=>s.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(a=>this.backupUriComparer.isEqual(u,a))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(u,l));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(u,a){const l=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(u){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,u));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(u){return(0,r.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const a=new Set,l=[];for(let s of u){const c=s.workspace;if(!(0,b.isWorkspaceIdentifier)(c))return[];if(!a.has(c.id)){a.add(c.id);const i=this.getBackupPath(c.id);await this.doHasBackups(i)?c.configPath.scheme!==C.Schemas.file||await y.Promises.exists(c.configPath.fsPath)?l.push(s):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return l}async validateFolders(u){if(!Array.isArray(u))return[];const a=[],l=new Set;for(let s of u){const c=this.backupUriComparer.getComparisonKey(s);if(!l.has(c)){l.add(c);const i=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(i)?s.scheme!==C.Schemas.file||await y.Promises.exists(s.fsPath)?a.push(s):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const a=[],l=new Set;for(let s of u){const c=s.backupFolder;if(typeof c!="string")return[];if(!l.has(c)){l.add(c);const i=this.getBackupPath(c);await this.doHasBackups(i)?a.push(s):await this.deleteStaleBackup(i)}}return a}async deleteStaleBackup(u){try{await y.Promises.exists(u)&&await y.Promises.rm(u,y.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(u){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await y.Promises.rename(u,l)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(u){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{D.renameSync(u,l)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const u=[];for(const a of this.workspaces)await this.hasBackups(a)&&u.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&u.push(a);return u}hasBackups(u){let a;return f.URI.isUri(u)?a=this.getBackupPath(this.getFolderHash(u)):(0,E.isWorkspaceBackupInfo)(u)?a=this.getBackupPath(u.workspace.id):a=u.backupFolder,this.doHasBackups(a)}async doHasBackups(u){try{const a=await y.Promises.readdir(u);for(const l of a)try{if((await y.Promises.readdir((0,r.join)(u,l))).length>0)return!0}catch(s){}}catch(a){}return!1}saveSync(){try{(0,y.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await y.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let a;return u.scheme===C.Schemas.file?a=I.isLinux?u.fsPath:u.fsPath.toLowerCase():a=u.toString().toLowerCase(),(0,v.createHash)("md5").update(a).digest("hex")}};S=ge([te(0,p.IEnvironmentMainService),te(1,m.IConfigurationService),te(2,w.ILogService)],S),e.BackupMainService=S}),define(Q[227],J([0,1,62,58]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,C,r,I){const d=y=>I(y,void 0),f=v.createConnection({host:M,port:C},()=>{f.removeListener("error",d);const y=Buffer.alloc(16);for(let t=0;t<16;t++)y[t]=Math.round(Math.random()*256);const E=y.toString("base64");let m=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${C}/?${r}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];f.write(m.join(`\r
`)+`\r
\r
`);const p=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(f.off("data",p),I(void 0,new D.NodeSocket(f)))};f.on("data",p)});f.once("error",d)}}}),define(Q[228],J([0,1,62,118,227,9,2,19,6,22,194,97,76]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(P,u,a,l,s){let c;for(let i=3;i&&(c&&c.dispose(),c=await new t(P,u,a,l,s).waitForReady(),!(s&&D.BROWSER_RESTRICTED_PORTS[s]||!D.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));i--);return c}class t extends r.Disposable{constructor(u,a,l,s,c){super();this.defaultTunnelHost=a,this.suggestedLocalPort=c,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=v.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let u=await(0,D.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(u){u.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,y.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),s=l.getSocket().socket,c=l.readEntireBuffer();l.dispose(),c.byteLength>0&&u.write(c.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),s.end()}),u.on("close",()=>s.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),s.destroy()}),s.on("end",()=>u.end()),s.on("close",()=>u.end()),s.on("error",()=>{u.destroy()}),u.pipe(s),s.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),s.end()})}}let w=class extends E.AbstractTunnelService{constructor(u,a,l,s,c){super(a);this.socketFactory=u,this.signService=l,this.productService=s,this.configurationService=c}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,a,l,s,c,i,n){const o=this.getTunnelFromMap(a,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,s,c,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${s}.`);const h={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},g=p(h,this.defaultTunnelHost,a,l,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,g),g}}};w=ge([te(1,d.ILogService),te(2,m.ISignService),te(3,f.IProductService),te(4,I.IConfigurationService)],w),e.BaseTunnelService=w;let b=class extends w{constructor(u,a,l,s){super(M.nodeSocketFactory,u,a,l,s)}};b=ge([te(0,d.ILogService),te(1,m.ISignService),te(2,f.IProductService),te(3,I.IConfigurationService)],b),e.TunnelService=b;let S=class extends r.Disposable{constructor(u,a,l,s){super();this.logService=u,this.productService=a,this.signService=l,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(u,a,l,s,c,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${s} on local port ${c}.`),!this._tunnelServices.has(u)){const h=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(h),this._tunnelServices.set(u,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(a,l,s,c,i,n,o)}};S=ge([te(0,d.ILogService),te(1,f.IProductService),te(2,m.ISignService),te(3,I.IConfigurationService)],S),e.SharedTunnelsService=S}),define(Q[229],J([0,1,198,9,17,16,2,13,19,48,91,6,197,223]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends r.Disposable{constructor(b,S,P){super();this.environmentService=S,this.logService=P,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,S){this.logService.trace("RequestService#request",b.url);const{proxyUrl:P,strictSSL:u}=this;let a;try{a=await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(c){this.logService.error("RequestService#request resolving shell environment failed",c)}const l={...process.env,...a},s=b.agent?b.agent:await(0,m.getProxyAgent)(b.url||"",l,{proxyUrl:P,strictSSL:u});return b.agent=s,b.strictSSL=u,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization}),this._request(b,S)}async getNodeRequest(b){return((0,v.parse)(b.url).protocol==="https:"?await new Promise((u,a)=>{$(["https"],u,a)}):await new Promise((u,a)=>{$(["http"],u,a)})).request}_request(b,S){return D.Promises.withAsyncBody(async(P,u)=>{let a;const l=(0,v.parse)(b.url),s=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),c={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,I.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(c.auth=b.user+":"+b.password),a=s(c,i=>{const n=(0,I.isNumber)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...b,url:i.headers.location,followRedirects:n-1},S).then(P,u);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,p.createGunzip)())),P({res:i,stream:(0,M.streamToBufferReadableStream)(o)})}}),a.on("error",u),b.timeout&&a.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&a.write(b.data),a.end(),S.onCancellationRequested(()=>{a.abort(),u((0,C.canceled)())})})}async resolveProxy(b){}};t=ge([te(0,d.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,E.ILogService)],t),e.RequestService=t}),define(Q[230],J([0,1,14,229]),function($,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(r){return v.net.request}class C extends D.RequestService{request(I,d){return super.request({...I||{},getRawRequest:M},d)}}e.RequestMainService=C}),define(Q[231],J([0,1,14,9,4,2,10,13,85,24,20,6,56,57,66,44]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends C.Disposable{constructor(P,u,a,l,s,c,i){super();this.machineId=P,this.userEnv=u,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=s,this.themeMainService=c,this.protocolMainService=i,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,u)=>this.onWindowConnection(P,u)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,u)=>this.onWorkerConnection(P,u)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[a])}onWorkerConnection(P,u){this.logService.trace("SharedProcess: onWorkerConnection",u);const a=new C.DisposableStore,l=c=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${c}')`,u),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",u))},s=v.BrowserWindow.fromId(u.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!u.reply.channel){l("unavailable");return}a.add(M.Event.filter(this.lifecycleMainService.onWillLoadWindow,c=>c.window.win===s)(()=>l("load"))),a.add(M.Event.fromNodeEventEmitter(s,"closed")(()=>l("closed"))),s.webContents.postMessage(u.reply.channel,u.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(u){}this.window=void 0},0))}send(P,...u){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...u)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,w.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:r.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(r.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,u,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:u}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,d.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};b=ge([te(2,f.IEnvironmentMainService),te(3,y.ILifecycleMainService),te(4,E.ILogService),te(5,t.IThemeMainService),te(6,p.IProtocolMainService)],b),e.SharedProcess=b}),define(Q[232],J([0,1,9,17,8,13,7,24,18,6]),function($,e,v,D,M,C,r,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class y{constructor(p,t,w){this.storagePath=p,this.logService=t,this.fileService=w,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const w=this.storage[p];return(0,C.isUndefinedOrNull)(w)?t:w}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:w,data:b}of p)this.storage[w]!==b&&((0,C.isUndefinedOrNull)(b)?(0,C.isUndefined)(this.storage[w])||(this.storage[w]=void 0,t=!0):(this.storage[w]=b,t=!0));t&&this.save()}removeItem(p){(0,C.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let E=class It{constructor(p,t,w){this.fileStorage=new y(r.URI.file((0,M.join)(p.userDataPath,It.STATE_FILE)),t,w)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=ge([te(0,I.IEnvironmentMainService),te(1,f.ILogService),te(2,d.IFileService)],E),e.StateMainService=E}),define(Q[77],J([0,1,9,23,4,19,24,20,6,22,50,41]),function($,e,v,D,M,C,r,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function m(t,w,b){return`${b.updateUrl}/api/update/${t}/${w}/${b.commit}`}e.createUpdateURL=m;let p=class{constructor(w,b,S,P,u,a){this.lifecycleMainService=w,this.configurationService=b,this.environmentMainService=S,this.requestService=P,this.logService=u,this.productService=a,this._state=E.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.getUpdateMode(),b=this.getProductQuality(w);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,v.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},D.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=ge([te(0,I.ILifecycleMainService),te(1,C.IConfigurationService),te(2,r.IEnvironmentMainService),te(3,y.IRequestService),te(4,d.ILogService),te(5,f.IProductService)],p),e.AbstractUpdateService=p}),define(Q[233],J([0,1,14,46,4,2,19,24,20,6,22,50,29,41,77]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends t.AbstractUpdateService{constructor(S,P,u,a,l,s,c){super(S,P,a,l,s,c);this.telemetryService=u,this.disposables=new C.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"error",(S,P)=>P)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(S,P,u)=>({url:P,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(S,P,u,a)=>({releaseNotes:P,version:u,productVersion:u,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(p.State.Idle(1,u))}buildUpdateFeedUrl(S){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,t.createUpdateURL)(P,S,this.productService);try{v.autoUpdater.setFeedURL({url:u})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return u}doCheckForUpdates(S){this.setState(p.State.CheckingForUpdates(S)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(p.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ge([D.memoize],w.prototype,"onRawError",null),ge([D.memoize],w.prototype,"onRawUpdateNotAvailable",null),ge([D.memoize],w.prototype,"onRawUpdateAvailable",null),ge([D.memoize],w.prototype,"onRawUpdateDownloaded",null),w=ge([te(0,d.ILifecycleMainService),te(1,r.IConfigurationService),te(2,m.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,E.IRequestService),te(5,f.ILogService),te(6,y.IProductService)],w),e.DarwinUpdateService=w}),define(Q[234],J([0,1,43,28,9,4,8,24,20,6,29,41]),function($,e,v,D,M,C,r,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let m=class{constructor(w,b,S){if(this.lifecycleMainService=w,this.logService=S,this._state=E.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,M.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};m=ge([te(0,d.ILifecycleMainService),te(1,I.IEnvironmentMainService),te(2,f.ILogService)],m);let p=class extends m{constructor(w,b,S,P,u,a){super(S,P,u);this.snap=w,this.snapRevision=b,this.telemetryService=a;const l=(0,D.watch)(r.dirname(this.snap)),s=C.Event.fromNodeEventEmitter(l,"change",(o,h)=>h),c=C.Event.filter(s,o=>o==="current"),n=C.Event.debounce(c,(o,h)=>h,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{n.dispose(),l.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(w=>{w?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,w.message||w))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+r.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((S,P)=>(0,D.realpath)(`${r.dirname(this.snap)}/current`,(u,a)=>u?P(u):S(a))),b=r.basename(w);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ge([te(2,d.ILifecycleMainService),te(3,I.IEnvironmentMainService),te(4,f.ILogService),te(5,y.ITelemetryService)],p),e.SnapUpdateService=p}),define(Q[45],J([0,1,14,28,4,39,33,2,10,8,3,15,13,21,158,51,52,24,5,6,22,101,27,102]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let i=class extends I.Disposable{constructor(o,h,g,k,L){super();this.environmentMainService=o,this.logService=h,this.backupMainService=g,this.dialogMainService=k,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,h=>(0,D.readFileSync)(h,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,h=>p.Promises.readFile(h,"utf8"))}doResolveLocalWorkspace(o,h){if(!!this.isWorkspacePath(o)&&o.scheme===d.Schemas.file)try{const g=h(o.fsPath);return g instanceof Promise?g.then(k=>this.doResolveWorkspace(o,k),k=>{}):this.doResolveWorkspace(o,g)}catch{return}}isWorkspacePath(o){return(0,s.isUntitledWorkspace)(o,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,h){try{const g=this.doParseStoredWorkspace(o,h),k=(0,c.getWorkspaceIdentifier)(o);return{id:k.id,configPath:k.configPath,folders:(0,s.toWorkspaceFolders)(g.folders,k.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:g.remoteAuthority,transient:g.transient}}catch(g){this.logService.warn(g.toString())}}doParseStoredWorkspace(o,h){const g=(0,C.parse)(h);if(g&&Array.isArray(g.folders))g.folders=g.folders.filter(k=>(0,s.isStoredWorkspaceFolder)(k));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return g}async createUntitledWorkspace(o,h){const{workspace:g,storedWorkspace:k}=this.newUntitledWorkspace(o,h),L=g.configPath.fsPath;return await p.Promises.mkdir((0,f.dirname)(L),{recursive:!0}),await p.Promises.writeFile(L,JSON.stringify(k,null,"	")),g}createUntitledWorkspaceSync(o,h){const{workspace:g,storedWorkspace:k}=this.newUntitledWorkspace(o,h),L=g.configPath.fsPath;return(0,D.mkdirSync)((0,f.dirname)(L),{recursive:!0}),(0,p.writeFileSync)(L,JSON.stringify(k,null,"	")),g}newUntitledWorkspace(o=[],h){const g=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,E.joinPath)(this.untitledWorkspacesHome,g),L=(0,E.joinPath)(k,s.UNTITLED_WORKSPACE_NAME),R=[];for(const O of o)R.push((0,s.getStoredWorkspaceFolder)(O.uri,!0,O.name,k,!y.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,c.getWorkspaceIdentifier)(L),storedWorkspace:{folders:R,remoteAuthority:h}}}async getWorkspaceIdentifier(o){return(0,c.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,s.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const h=(0,E.originalFSPath)(o.configPath);try{(0,p.rimrafSync)((0,f.dirname)(h));const g=(0,f.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,D.existsSync)(g)&&(0,p.writeFileSync)((0,f.join)(g,"obsolete"),"")}catch(g){this.logService.warn(`Unable to delete untitled workspace ${h} (${g}).`)}}getUntitledWorkspacesSync(){const o=[];try{const h=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(g=>(0,E.joinPath)(this.untitledWorkspacesHome,g,s.UNTITLED_WORKSPACE_NAME));for(const g of h){const k=(0,c.getWorkspaceIdentifier)(g),L=this.resolveLocalWorkspaceSync(g);L?o.push({workspace:k,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return o}async enterWorkspace(o,h,g){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,h,g))return;const L=this.doEnterWorkspace(o,(0,c.getWorkspaceIdentifier)(g));if(!!L)return this._onDidEnterWorkspace.fire({window:o,workspace:L.workspace}),L}async isValidTargetWorkspacePath(o,h,g){if(!g)return!0;if((0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,g))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(h,g)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,r.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(g)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,m.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,h){if(!o.config)return;o.focus();let g;return o.config.extensionDevelopmentPath||(g=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=h,o.config.backupPath=g,{workspace:h,backupPath:g}}};i=ge([te(0,S.IEnvironmentMainService),te(1,u.ILogService),te(2,w.IBackupMainService),te(3,b.IDialogMainService),te(4,a.IProductService)],i),e.WorkspacesManagementMainService=i}),define(Q[103],J([0,1,14,30,23,3,13,7,21,19,54,5,6,99,36,27,45]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let S=class{constructor(u,a,l,s,c){this.logService=u,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=s,this.configurationService=c}async start(u,a){this.logService.trace("Received data from other instance: ",u,a),C.isMacintosh&&v.app.focus({steal:!0});const l=this.parseOpenUrl(u);if(l.length){let s=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(s=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),s.then(()=>{for(const{uri:c,url:i}of l)this.urlService.open(c,{originalUrl:i})})}else return this.startOpenWindow(u,a)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,D.coalesce)(u._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch(l){return null}})):[]}async startOpenWindow(u,a){const l=(0,y.isLaunchedFromCli)(a)?0:4;let s=[];const c=u.wait&&u.waitMarkerFilePath?I.URI.file(u.waitMarkerFilePath):void 0,i=u.remote||void 0,n={context:l,cli:u,userEnv:a,waitMarkerFileURI:c,remoteAuthority:i};if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,n);else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let o=!1;if(u["new-window"]||u["unity-launch"])o=!0;else if(u["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!C.isMacintosh}if(o)s=this.windowsMainService.open({...n,forceNewWindow:!0,forceEmpty:!0});else{const h=this.windowsMainService.getLastActiveWindow();h?(this.windowsMainService.openExistingWindow(h,n),s=[h]):s=this.windowsMainService.open({...n,forceEmpty:!0})}}else s=this.windowsMainService.open({...n,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],gotoLineMode:u.goto});if(c&&s.length===1&&s[0])return Promise.race([s[0].whenClosedOrLoaded,(0,d.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return v.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?u.push(this.codeWindowToInfo(l)):u.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(s=>new Promise(c=>{const i=s.remoteAuthority;if(i){const n=`vscode:getDiagnosticInfoResponse${s.id}`,o={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(s):void 0};s.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:n,args:o}),v.ipcMain.once(n,(h,g)=>{g||c({hostName:i,errorMessage:`Unable to resolve connection to '${i}'.`}),c(g)}),setTimeout(()=>{c({hostName:i,errorMessage:`Fetching remote diagnostics for '${i}' timed out.`})},5e3)}else c(void 0)})))).filter(s=>!!s)}getFolderURIs(u){const a=[],l=u.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,w.isWorkspaceIdentifier)(l)){const s=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);s&&s.folders.forEach(i=>{a.push(i.uri)})}return a}codeWindowToInfo(u){const a=this.getFolderURIs(u),l=(0,r.assertIsDefined)(u.win);return this.browserWindowToInfo(l,a,u.remoteAuthority)}browserWindowToInfo(u,a=[],l){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:a,remoteAuthority:l}}};S=ge([te(0,m.ILogService),te(1,t.IWindowsMainService),te(2,p.IURLService),te(3,b.IWorkspacesManagementMainService),te(4,f.IConfigurationService)],S),e.LaunchMainService=S}),define(Q[53],J([0,1,43,14,26,117,46,4,33,2,10,8,3,7,82,71,21,150,52,24,5,20,6,22,29,66,36,27,45]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s,c,i,n,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let k=class ft extends f.Disposable{constructor(R,O,V,ee,oe,ae,K,T,N,G){super();this.sharedProcess=R,this.windowsMainService=O,this.dialogMainService=V,this.lifecycleMainService=ee,this.environmentMainService=oe,this.telemetryService=ae,this.logService=K,this.productService=T,this.themeMainService=N,this.workspacesManagementMainService=G,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,q=>q.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(q,_)=>_.id),q=>!!this.windowsMainService.getWindowById(q)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(q,_)=>_.id),q=>!!this.windowsMainService.getWindowById(q)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(q,_)=>_.id),q=>!!this.windowsMainService.getWindowById(q)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),q=>!!q),q=>q.id),I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(q,_)=>_.id),q=>!!this.windowsMainService.getWindowById(q))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(q,_,U)=>U),q=>!(Array.isArray(q)&&q.length===1&&q[0]==="workArea")),I.Event.fromNodeEventEmitter(D.screen,"display-added"),I.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(O=>({id:O.id,workspace:O.openedWorkspace,title:O.win?.getTitle()??"",filename:O.getRepresentedFilename(),dirty:O.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const O=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(O)return O.id}openWindow(R,O,V){return Array.isArray(O)?this.doOpenWindow(R,O,V):this.doOpenEmptyWindow(R,O)}async doOpenWindow(R,O,V=Object.create(null)){O.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:O,cli:this.environmentMainService.args,forceNewWindow:V.forceNewWindow,forceReuseWindow:V.forceReuseWindow,preferNewWindow:V.preferNewWindow,diffMode:V.diffMode,addMode:V.addMode,gotoLineMode:V.gotoLineMode,noRecentEntry:V.noRecentEntry,waitMarkerFileURI:V.waitMarkerFileURI,remoteAuthority:V.remoteAuthority||void 0})}async doOpenEmptyWindow(R,O){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},O)}async toggleFullScreen(R){const O=this.windowById(R);O&&O.toggleFullScreen()}async handleTitleDoubleClick(R){const O=this.windowById(R);O&&O.handleTitleDoubleClick()}async isMaximized(R){const O=this.windowById(R);return O?.win?O.win.isMaximized():!1}async maximizeWindow(R){const O=this.windowById(R);O?.win&&O.win.maximize()}async unmaximizeWindow(R){const O=this.windowById(R);O?.win&&O.win.unmaximize()}async minimizeWindow(R){const O=this.windowById(R);O?.win&&O.win.minimize()}async focusWindow(R,O){O&&typeof O.windowId=="number"&&(R=O.windowId);const V=this.windowById(R);V&&V.focus({force:O?.force??!1})}async setMinimumSize(R,O,V){const ee=this.windowById(R);if(ee?.win){const[oe,ae]=ee.win.getSize(),[K,T]=ee.win.getMinimumSize(),[N,G]=[O??K,V??T],[q,_]=[Math.max(oe,N),Math.max(ae,G)];(K!==N||T!==G)&&ee.win.setMinimumSize(N,G),(oe!==q||ae!==_)&&ee.win.setSize(q,_)}}async saveWindowSplash(R,O){this.themeMainService.saveWindowSplash(R,O)}async installShellCommand(R){const{source:O,target:V}=await this.getShellCommandLink();try{const{symbolicLink:ee}=await b.SymlinkSupport.stat(O);if(ee&&!ee.dangling){const oe=await(0,t.realpath)(O);if(V===oe)return}await b.Promises.unlink(O)}catch(ee){if(ee.code!=="ENOENT")throw ee}try{await b.Promises.symlink(V,O)}catch(ee){if(ee.code!=="EACCES"&&ee.code!=="ENOENT")throw ee;const{response:oe}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${V}' '${O}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(ae)}catch(ae){throw new Error((0,S.localize)(3,null,O))}}}async uninstallShellCommand(R){const{source:O}=await this.getShellCommandLink();try{await b.Promises.unlink(O)}catch(V){switch(V.code){case"EACCES":const{response:ee}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const oe=`osascript -e "do shell script \\"rm '${O}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(oe)}catch(oe){throw new Error((0,S.localize)(7,null,O))}break;case"ENOENT":break;default:throw V}}}async getShellCommandLink(){const R=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),O=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(R))throw new Error((0,S.localize)(8,null,R));return{source:O,target:R}}async showMessageBox(R,O){return this.dialogMainService.showMessageBox(O,this.toBrowserWindow(R))}async showSaveDialog(R,O){return this.dialogMainService.showSaveDialog(O,this.toBrowserWindow(R))}async showOpenDialog(R,O){return this.dialogMainService.showOpenDialog(O,this.toBrowserWindow(R))}toBrowserWindow(R){const O=this.windowById(R);if(O?.win)return O.win}async pickFileFolderAndOpen(R,O){const V=await this.dialogMainService.pickFileFolder(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openFileFolder",O.telemetryExtraData),this.doOpenPicked(await Promise.all(V.map(async ee=>await b.SymlinkSupport.existsDirectory(ee)?{folderUri:p.URI.file(ee)}:{fileUri:p.URI.file(ee)})),O,R))}async pickFolderAndOpen(R,O){const V=await this.dialogMainService.pickFolder(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openFolder",O.telemetryExtraData),this.doOpenPicked(V.map(ee=>({folderUri:p.URI.file(ee)})),O,R))}async pickFileAndOpen(R,O){const V=await this.dialogMainService.pickFile(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openFile",O.telemetryExtraData),this.doOpenPicked(V.map(ee=>({fileUri:p.URI.file(ee)})),O,R))}async pickWorkspaceAndOpen(R,O){const V=await this.dialogMainService.pickWorkspace(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openWorkspace",O.telemetryExtraData),this.doOpenPicked(V.map(ee=>({workspaceUri:p.URI.file(ee)})),O,R))}doOpenPicked(R,O,V){this.windowsMainService.open({context:3,contextWindowId:V,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:O.forceNewWindow})}sendPickerTelemetry(R,O,V){const ee=R?R.length:0;this.telemetryService.publicLog(O,{...V,outcome:ee?"success":"canceled",numberOfPaths:ee})}async showItemInFolder(R,O){D.shell.showItemInFolder(O)}async setRepresentedFilename(R,O){const V=this.windowById(R);V&&V.setRepresentedFilename(O)}async setDocumentEdited(R,O){const V=this.windowById(R);V&&V.setDocumentEdited(O)}async openExternal(R,O){return m.isLinuxSnap?this.safeSnapOpenExternal(O):D.shell.openExternal(O),!0}safeSnapOpenExternal(R){const O=process.env.GDK_PIXBUF_MODULE_FILE,V=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=O,process.env.GDK_PIXBUF_MODULEDIR=V}moveItemToTrash(R,O){return D.shell.trashItem(O)}async isAdmin(){let R;return m.isWindows?R=(await new Promise((O,V)=>{$(["native-is-elevated"],O,V)}))():R=process.getuid()===0,R}async writeElevated(R,O,V,ee){const oe=await new Promise((ae,K)=>{$(["@vscode/sudo-prompt"],ae,K)});return new Promise((ae,K)=>{const T=[`"${this.cliPath}"`];ee?.unlock&&T.push("--file-chmod"),T.push("--file-write",`"${O.fsPath}"`,`"${V.fsPath}"`);const N={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(T.join(" "),N,(G,q,_)=>{q&&this.logService.trace(`[sudo-prompt] received stdout: ${q}`),_&&this.logService.trace(`[sudo-prompt] received stderr: ${_}`),G?K(G):ae(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return w.virtualMachineHint.value()}get osColorScheme(){return{highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,O,V){process.kill(O,V)}async readClipboardText(R,O){return D.clipboard.readText(O)}async writeClipboardText(R,O,V){return D.clipboard.writeText(O,V)}async readClipboardFindText(R){return D.clipboard.readFindText()}async writeClipboardFindText(R,O){return D.clipboard.writeFindText(O)}async writeClipboardBuffer(R,O,V,ee){return D.clipboard.writeBuffer(O,Buffer.from(V),ee)}async readClipboardBuffer(R,O){return D.clipboard.readBuffer(O)}async hasClipboard(R,O,V){return D.clipboard.has(O,V)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,O){const V=this.windowById(R);V&&V.updateTouchBar(O)}async notifyReady(R){const O=this.windowById(R);O&&O.setReady()}async relaunch(R,O){return this.lifecycleMainService.relaunch(O)}async reload(R,O){const V=this.windowById(R);if(V){if((0,h.isWorkspaceIdentifier)(V.openedWorkspace)){const ee=V.openedWorkspace.configPath;if(ee.scheme===y.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ee))?.transient)return this.openWindow(V.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(V,O?.disableExtensions!==void 0?{_:[],"disable-extensions":O.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,O){const V=this.windowById(O);if(V?.win)return V.win.close()}async quit(R){const O=this.windowsMainService.getLastActiveWindow();O?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&O.win?O.win.close():this.lifecycleMainService.quit()}async exit(R,O){await this.lifecycleMainService.kill(O)}async resolveProxy(R,O){const ee=this.windowById(R)?.win?.webContents?.session;if(ee)return ee.resolveProxy(O)}async openDevTools(R,O){const V=this.windowById(R);V?.win&&V.win.webContents.openDevTools(O)}async toggleDevTools(R){const O=this.windowById(R);O?.win&&O.win.webContents.toggleDevTools()}async sendInputEvent(R,O){const V=this.windowById(R);V?.win&&(O.type==="mouseDown"||O.type==="mouseUp")&&V.win.webContents.sendInputEvent(O)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,O,V,ee){if(!m.isWindows)return;const oe=await new Promise((ae,K)=>{$(["vscode-windows-registry"],ae,K)});try{return oe.GetStringRegKey(O,V,ee)}catch{return}}async getPassword(R,O,V){const ee=await this.withKeytar(),oe=await ee.getPassword(O,V);if(oe)try{let{content:ae,hasNextChunk:K}=JSON.parse(oe);if(!ae||!K)return oe;let T=1;for(;K;){const N=await ee.getPassword(O,`${V}-${T}`),G=JSON.parse(N);ae+=G.content,K=G.hasNextChunk,T++}return ae}catch{return oe}return oe}async setPassword(R,O,V,ee){const oe=await this.withKeytar(),ae=3,K=async(T,N,G)=>{let q=0,_;for(;q<ae;)try{await oe.setPassword(T,N,G);return}catch(U){_=U,this.logService.warn("Error attempting to set a password: ",U),q++,await new Promise(j=>setTimeout(j,200))}throw _};if(m.isWindows&&ee.length>ft.MAX_PASSWORD_LENGTH){let T=0,N=0,G=!0;for(;G;){const q=ee.substring(T,T+ft.PASSWORD_CHUNK_SIZE);T+=ft.PASSWORD_CHUNK_SIZE,G=ee.length-T>0;const _={content:q,hasNextChunk:G};await K(O,N?`${V}-${N}`:V,JSON.stringify(_)),N++}}else await K(O,V,ee);this._onDidChangePassword.fire({service:O,account:V})}async deletePassword(R,O,V){const oe=await(await this.withKeytar()).deletePassword(O,V);return oe&&this._onDidChangePassword.fire({service:O,account:V}),oe}async findPassword(R,O){return(await this.withKeytar()).findPassword(O)}async findCredentials(R,O){return(await this.withKeytar()).findCredentials(O)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((R,O)=>{$(["keytar"],R,O)})}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,ge([r.memoize],k.prototype,"cliPath",null),k=ge([te(1,o.IWindowsMainService),te(2,P.IDialogMainService),te(3,l.ILifecycleMainService),te(4,u.IEnvironmentMainService),te(5,i.ITelemetryService),te(6,s.ILogService),te(7,c.IProductService),te(8,n.IThemeMainService),te(9,g.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Q[235],J([0,1,14,23,4,81,2,31,89,6,53,22,36]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends r.Disposable{constructor(b,S,P,u,a){super();this.logService=b,this.windowsMainService=S,this.nativeHostMainService=P,this.encryptionMainService=u,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=M.Event.fromNodeEventEmitter(v.app,"login",(S,P,u,a,l)=>({event:S,webContents:P,req:u,authInfo:a,callback:l}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:S,req:P,callback:u}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(a?.username,a?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(b);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const S=String((0,C.hash)({scheme:b.scheme,host:b.host,port:b.port}));let P,u;try{const c=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(c){const i=JSON.parse(await this.encryptionMainService.decrypt(c));P=i.username,u=i.password}}catch(c){this.logService.error(c)}if(this.state!==p.StoredCredentialsUsed&&typeof P=="string"&&typeof u=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:P,password:u};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const l={authInfo:b,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,l),this.state=p.LoginDialogShown;const s=await new Promise(c=>{const i=async(n,o,h)=>{if(o===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",i),h){const g={username:h.username,password:h.password};try{if(h.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(g));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(k){this.logService.error(k)}c({username:g.username,password:g.password})}else c(void 0)};a.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=s,s}};t=ge([te(0,f.ILogService),te(1,m.IWindowsMainService),te(2,y.INativeHostMainService),te(3,d.IEncryptionMainService),te(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(Q[236],J([0,1,14,26,33,2,10,3,83,148,74,52,24,5,103,6,53,56,22,57,67]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let l=class Pt{constructor(c,i,n,o,h,g,k,L,R){this.userEnv=c,this.environmentMainService=i,this.launchMainService=n,this.logService=o,this.diagnosticsService=h,this.dialogMainService=g,this.nativeHostMainService=k,this.protocolMainService=L,this.productService=R,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async c=>{const[i,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(i,n);this.safeSend(c,"vscode:issueSystemInfoResponse",o)}),v.ipcMain.on("vscode:listProcesses",async c=>{const i=[];try{const n=await this.launchMainService.getMainProcessId();i.push({name:(0,f.localize)(0,null),rootProcess:await(0,d.listProcesses)(n)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,y.isRemoteDiagnosticError)(h)?i.push({name:h.hostName,rootProcess:h}):h.processes&&i.push({name:h.hostName,rootProcess:h.processes})})}catch(n){this.logService.error(`Listing processes failed: ${n}`)}this.safeSend(c,"vscode:listProcessesResponse",i)}),v.ipcMain.on("vscode:issueReporterClipboard",async c=>{const i={title:this.productService.nameLong,message:(0,f.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,f.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,f.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const n=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(c,"vscode:issueReporterClipboardResponse",n.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async c=>{const i=await this.getPerformanceInfo();this.safeSend(c,"vscode:issuePerformanceInfoResponse",i)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const c={title:this.productService.nameLong,message:(0,f.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,f.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,f.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(c,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(c,i)=>{const{id:n,from:o,args:h}=i;let g;switch(o){case"issueReporter":g=this.issueReporterParentWindow;break;case"processExplorer":g=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}g&&g.webContents.send("vscode:runAction",{id:n,from:o,args:h})}),v.ipcMain.on("vscode:openExternal",(c,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),v.ipcMain.on("vscode:closeIssueReporter",c=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",c=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async c=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(c,"vscode:windowsInfoResponse",i.windows)})}safeSend(c,i,...n){c.sender.isDestroyed()||c.sender.send(i,...n)}async openReporter(c){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new C.DisposableStore,n=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,n,{backgroundColor:c.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:c.zoomLevel,alwaysOnTop:!1},"issue-reporter"),n.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:c,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:S.default}),this.issueReporterWindow.loadURL(r.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(c){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new C.DisposableStore,n=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,n,{backgroundColor:c.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:c.zoomLevel,alwaysOnTop:!0},"process-explorer"),n.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:c,product:S.default}),this.processExplorerWindow.loadURL(r.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(c,i,n,o){const h=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:c.width,height:c.height,minWidth:300,minHeight:200,x:c.x,y:c.y,title:n.title,backgroundColor:n.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:r.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(n.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:n.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[c,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(c,i)}getWindowPosition(c,i,n){let o;const h=v.screen.getAllDisplays();if(h.length===1)o=h[0];else{if(I.isMacintosh){const L=v.screen.getCursorScreenPoint();o=v.screen.getDisplayNearestPoint(L)}!o&&c&&(o=v.screen.getDisplayMatching(c.getBounds())),o||(o=v.screen.getPrimaryDisplay()||h[0])}const g={width:i,height:n},k=o.bounds;return g.x=k.x+k.width/2-g.width/2,g.y=k.y+k.height/2-g.height/2,k.width>0&&k.height>0&&(g.x<k.x&&(g.x=k.x),g.y<k.y&&(g.y=k.y),g.x>k.x+k.width&&(g.x=k.x),g.y>k.y+k.height&&(g.y=k.y),g.width>k.width&&(g.width=k.width),g.height>k.height&&(g.height=k.height)),g}async getPerformanceInfo(){try{const[c,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(c,i)}catch(c){throw this.logService.warn("issueService#getPerformanceInfo ",c.message),c}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=ge([te(1,m.IEnvironmentMainService),te(2,t.ILaunchMainService),te(3,w.ILogService),te(4,y.IDiagnosticsService),te(5,E.IDialogMainService),te(6,b.INativeHostMainService),te(7,u.IProtocolMainService),te(8,P.IProductService)],l),e.IssueMainService=l}),define(Q[237],J([0,1,23,19,24,20,6,53,22,50,29,41,77]),function($,e,v,D,M,C,r,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends m.AbstractUpdateService{constructor(w,b,S,P,u,a,l,s){super(w,b,P,u,a,s);this.telemetryService=S,this.nativeHostMainService=l}buildUpdateFeedUrl(w){return(0,m.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(E.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},v.CancellationToken.None).then(f.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const S=w?b.message||b:void 0;this.setState(E.State.Idle(1,S))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(E.State.Idle(1))}};p=ge([te(0,C.ILifecycleMainService),te(1,D.IConfigurationService),te(2,y.ITelemetryService),te(3,M.IEnvironmentMainService),te(4,f.IRequestService),te(5,r.ILogService),te(6,I.INativeHostMainService),te(7,d.IProductService)],p),e.LinuxUpdateService=p}),define(Q[238],J([0,1,43,28,26,9,23,46,8,7,114,21,19,24,18,20,6,53,22,50,29,41,77]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(h,g=1e3){for(;!h();)await(0,C.timeout)(g)}let i;function n(){return typeof i=="undefined"&&(i=D.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends s.AbstractUpdateService{constructor(g,k,L,R,O,V,ee,oe,ae){super(g,k,R,O,V,ae);this.telemetryService=L,this.fileService=ee,this.nativeHostMainService=oe}get cachePath(){const g=d.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(g,{recursive:!0}).then(()=>g)}initialize(){super.initialize(),n()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(g){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),n()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,s.createUpdateURL)(k,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(l.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},r.CancellationToken.None).then(u.asJson).then(k=>{const L=n();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(l.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(l.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(l.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(R=>E.Promises.exists(R).then(O=>{if(O)return Promise.resolve(R);const V=k.url,ee=k.hash,oe=`${R}.tmp`;return this.requestService.request({url:V},r.CancellationToken.None).then(ae=>this.fileService.writeFile(f.URI.file(oe),ae.stream)).then(ee?()=>(0,y.checksum)(oe,k.hash):()=>{}).then(()=>E.Promises.rename(oe,R)).then(()=>R)})).then(R=>{const O=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},O&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(k)):this.setState(l.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const L=g?k.message||k:void 0;this.setState(l.State.Idle(n(),L))}))}async doDownloadUpdate(g){g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(l.State.Idle(n()))}async getUpdatePackagePath(g){const k=await this.cachePath;return d.join(k,`CodeSetup-${this.productService.quality}-${g}.exe`)}async cleanup(g=null){const k=g?V=>!new RegExp(`${this.productService.quality}-${g}\\.exe$`).test(V):()=>!0,L=await this.cachePath,O=(await E.Promises.readdir(L)).filter(k).map(async V=>{try{await E.Promises.unlink(d.join(L,V))}catch(ee){}});await Promise.all(O)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const g=this.state.update;this.setState(l.State.Updating(g));const k=await this.cachePath;this.availableUpdate.updateFilePath=d.join(k,`CodeSetup-${this.productService.quality}-${g.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(n()))});const R=`${this.productService.win32MutexName}-ready`,O=await new Promise((V,ee)=>{$(["windows-mutex"],V,ee)});c(()=>O.isActive(R)).then(()=>this.setState(l.State.Ready(g)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?D.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}};ge([I.memoize],o.prototype,"cachePath",null),o=ge([te(0,w.ILifecycleMainService),te(1,m.IConfigurationService),te(2,a.ITelemetryService),te(3,p.IEnvironmentMainService),te(4,u.IRequestService),te(5,b.ILogService),te(6,t.IFileService),te(7,S.INativeHostMainService),te(8,P.IProductService)],o),e.Win32UpdateService=o}),define(Q[239],J([0,1,14,9,23,44,4,33,2,10,8,63,3,7,154,51,19,52,24,54,205,18,20,6,22,57,100,29,208,66,67,36,27,45]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s,c,i,n,o,h,g,k,L,R,O,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ee;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(ee||(ee={}));let oe=class extends d.Disposable{constructor(K,T,N,G,q,_,U,j,F,A,W,B,Y,x,z){super();this.logService=T,this.environmentMainService=N,this.fileService=G,this.configurationService=_,this.themeMainService=U,this.workspacesManagementMainService=j,this.backupMainService=F,this.telemetryService=A,this.dialogMainService=W,this.lifecycleMainService=B,this.productService=Y,this.protocolMainService=x,this.windowsMainService=z,this._onWillLoad=this._register(new r.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new r.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new r.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new r.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[X,ie]=this.restoreWindowState(K.state);this.windowState=X,this.logService.trace("window#ctor: using window state",X);const re=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),Z={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!re,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};m.isLinux?Z.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(Z.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(Z.fullscreenable=!1),m.isMacintosh&&(Z.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(Z.acceptFirstMouse=!1));const ce=m.isMacintosh&&se?.nativeTabs===!0;ce&&(Z.tabbingIdentifier=this.productService.nameShort);const le=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(Z.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(Z.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Z),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&le&&this._win.setSheetOffset(22),m.isMacintosh&&ie&&(!ce||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}re&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:X=>q.globalStorage.get(X),store:(X,ie)=>q.globalStorage.set(X,ie)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){m.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){m.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){m.isMacintosh&&K?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function T(){N.dispose(),G.dispose(),K()}const N=this.onDidClose(()=>T()),G=this.onWillLoad(()=>T())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(q,_)=>this.onWindowError(2,_)),this._win.webContents.on("did-fail-load",(q,_,U)=>this.onWindowError(3,{reason:U,exitCode:_})),this._win.webContents.on("will-prevent-unload",q=>{q.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),T=q=>{for(let _=q;_;_=_.parent)if(_.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},N=q=>q.resourceType==="xhr"||T(q.frame);this._win.webContents.session.webRequest.onBeforeRequest((q,_)=>{const U=p.URI.parse(q.url);return U.path.endsWith(".svg")&&!K.has(U.scheme)?_({cancel:!N(q)}):_({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((q,_)=>{const U=q.responseHeaders,j=U["content-type"]||U["Content-Type"];if(j&&Array.isArray(j)){const F=p.URI.parse(q.url);if(F.path.endsWith(".svg")&&K.has(F.scheme))return U["Content-Type"]=["image/svg+xml"],_({cancel:!1,responseHeaders:U});if(!F.path.includes(f.Schemas.vscodeRemoteResource)&&j.some(A=>A.toLowerCase().includes("image/svg")))return _({cancel:!N(q)})}return _({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",q=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",q,this._win)}),this._win.on("unmaximize",q=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",q,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(q=>this.onDidDeleteUntitledWorkspace(q)));const G=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:G},async(q,_)=>{const U=await this.marketplaceHeadersPromise;_({cancel:!1,requestHeaders:Object.assign(q.requestHeaders,U)})})}async onWindowError(K,T){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:T?.reason,code:T?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(N.response!==1){const G=N.response===0;this.destroyWindow(G)}}else if(K===2){let N;T?N=(0,t.localize)(6,null,T.reason,T.exitCode??"<unknown>"):N=(0,t.localize)(5,null);const q=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:N,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(q)}break}}destroyWindow(K){if(this._onDidDestroy.fire(),this._win?.destroy(),K&&this.config){let T,N;(0,O.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?T={folderUri:this.openedWorkspace.uri}:(0,O.isWorkspaceIdentifier)(this.openedWorkspace)?T={workspaceUri:this.openedWorkspace.configPath}:N=!0;const[G]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:T?[T]:void 0,forceEmpty:N,forceNewWindow:!0});G.focus()}}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let T=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const N=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.currentHttpProxy||N!==this.currentNoProxy)){this.currentHttpProxy=T,this.currentNoProxy=N;const G=T||"",q=N?`${N},<local>`:"<local>";this.logService.trace(`Setting proxy to '${G}', bypassing '${q}'`),this._win.webContents.session.setProxy({proxyRules:G,proxyBypassRules:q,pacScript:""})}}addTabbedWindow(K){m.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,T=Object.create(null)){this.isDocumentEdited()&&(!T.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,T),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0));const N=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new D.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:T.isReload?3:N?2:1})}updateConfiguration(K,T){const N=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(N){const G=(0,u.isLaunchedFromCli)(N)&&!(0,u.isLaunchedFromCli)(K.userEnv),q=this.isExtensionDevelopmentHost;(G||q)&&(K.userEnv={...N,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(K["disable-extensions"]=T.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),K.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const T=Object.assign({},this.currentConfig);T.workspace=await this.validateWorkspaceBeforeReload(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToWait,this.isExtensionDevelopmentHost&&K&&(T.verbose=K.verbose,T.debugId=K.debugId,T.extensionEnvironment=K.extensionEnvironment,T["inspect-extensions"]=K["inspect-extensions"],T["inspect-brk-extensions"]=K["inspect-brk-extensions"],T["extensions-dir"]=K["extensions-dir"]),T.isInitialStartup=!1,this.load(T,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,O.isWorkspaceIdentifier)(K.workspace)){const T=K.workspace.configPath;if(T.scheme===f.Schemas.file&&!await this.fileService.exists(T))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(K.workspace)){const T=K.workspace.uri;if(T.scheme===f.Schemas.file&&!await this.fileService.exists(T))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let N;try{N=v.screen.getDisplayMatching(this.getBounds())}catch(_){}const G=(0,R.defaultWindowState)();return{mode:3,display:N?N.id:void 0,width:this.windowState.width||G.width,height:this.windowState.height||G.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let T;if(!m.isMacintosh&&this._win.isMaximized()?T=0:T=1,T===0?K.mode=0:K.mode=1,T===1||T===0){let N;T===1?N=this.getBounds():N=this._win.getNormalBounds(),K.x=N.x,K.y=N.y,K.width=N.width,K.height=N.height}return K}restoreWindowState(K){(0,E.mark)("code/willRestoreCodeWindowState");let T=!1;if(K)try{const N=v.screen.getAllDisplays();T=N.length>1,K=this.validateWindowState(K,N)}catch(N){this.logService.warn(`Unexpected error validating window state: ${N}
${N.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),T]}validateWindowState(K,T){if(this.logService.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const q=this.getWorkingArea(T[0]);if(q){let _=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!q||(K.x<q.x&&(K.x=q.x),K.y<q.y&&(K.y=q.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",q),_(),K.width>q.width&&(K.width=q.width),K.height>q.height&&(K.height=q.height),K.x>q.x+q.width-128&&(K.x=q.x+q.width-K.width),K.y>q.y+q.height-128&&(K.y=q.y+q.height-K.height),_()}return K}if(K.display&&K.mode===3){const q=T.find(_=>_.id===K.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const _=(0,R.defaultWindowState)(3);return _.x=q.bounds.x,_.y=q.bounds.y,_}}let N,G;try{N=v.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),G=this.getWorkingArea(N)}catch(q){}if(N&&G&&K.x+K.width>G.x&&K.y+K.height>G.y&&K.x<G.x+G.width&&K.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,T]=this._win.getPosition(),[N,G]=this._win.getSize();return{x:K,y:T,width:N,height:G}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,T=!0){m.isMacintosh||(K==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const T=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!T),this._win.autoHideMenuBar=T;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,T,...N){this.isReady?this.send(K,...N):this.ready().then(()=>{T.isCancellationRequested||this.send(K,...N)})}send(K,...T){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${K}' for window that is destroyed`);return}try{this._win.webContents.send(K,...T)}catch(N){this.logService.warn(`Error sending IPC message to channel '${K}' of window ${this._id}: ${(0,C.toErrorMessage)(N)}`)}}}updateTouchBar(K){!m.isMacintosh||this.touchBarGroups.forEach((T,N)=>{const G=K[N];T.segments=this.createTouchBarGroupSegments(G)})}createTouchBar(){if(!!m.isMacintosh){for(let K=0;K<10;K++){const T=this.createTouchBarGroup();this.touchBarGroups.push(T)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const T=this.createTouchBarGroupSegments(K),N=new v.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:G=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:N.segments[G].id,from:"touchbar"})}});return N}createTouchBarGroupSegments(K=[]){return K.map(N=>{let G;N.icon&&!g.ThemeIcon.isThemeIcon(N.icon)&&N.icon?.dark?.scheme===f.Schemas.file&&(G=v.nativeImage.createFromPath(p.URI.revive(N.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let q;return typeof N.title=="string"?q=N.title:q=N.title.value,{id:N.id,label:G?void 0:q,icon:G}})}dispose(){super.dispose(),this._win=null}};oe=ge([te(1,c.ILogService),te(2,P.IEnvironmentMainService),te(3,l.IFileService),te(4,o.IStorageMainService),te(5,b.IConfigurationService),te(6,k.IThemeMainService),te(7,V.IWorkspacesManagementMainService),te(8,w.IBackupMainService),te(9,h.ITelemetryService),te(10,S.IDialogMainService),te(11,s.ILifecycleMainService),te(12,i.IProductService),te(13,n.IProtocolMainService),te(14,R.IWindowsMainService)],oe),e.CodeWindow=oe}),define(Q[68],J([0,1,14,30,9,4,33,2,10,3,15,7,21,157,5,20,6,38,27,45]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class qe extends I.Disposable{constructor(s,c,i,n){super();this.stateMainService=s,this.logService=c,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace}])))}handleWindowsJumpList(){!f.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(s){const c=[],i=[];for(let n of s)if((0,P.isRecentWorkspace)(n))!this.workspacesManagementMainService.isUntitledWorkspace(n.workspace)&&this.indexOfWorkspace(c,n.workspace)===-1&&c.push(n);else if((0,P.isRecentFolder)(n))this.indexOfFolder(c,n.folderUri)===-1&&c.push(n);else{const o=this.indexOfFile(i,n.fileUri)>=0,h=n.fileUri.scheme===d.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,y.basename)(n.fileUri))>=0;!o&&!h&&(i.push(n),f.isWindows&&n.fileUri.scheme===d.Schemas.file&&v.app.addRecentDocument(n.fileUri.fsPath))}this.addEntriesFromStorage(c,i),c.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(c.length=qe.MAX_TOTAL_RECENT_ENTRIES),i.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(i.length=qe.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:c,files:i}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(s){const c=h=>{const g=this.location(h);for(const k of s)if(y.extUriBiasedIgnorePathCase.isEqual(k,g))return!1;return!0},i=this.getRecentlyOpened(),n=i.workspaces.filter(c),o=i.files.filter(c);(n.length!==i.workspaces.length||o.length!==i.files.length)&&(this.saveRecentlyOpened({files:o,workspaces:n}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!f.isMacintosh)return;v.app.clearRecentDocuments();const s=this.getRecentlyOpened(),c=[];let i=0;for(let o=0;o<s.workspaces.length&&i<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const h=this.location(s.workspaces[o]);if(h.scheme===d.Schemas.file){const g=(0,y.originalFSPath)(h);await m.Promises.exists(g)&&(c.push(g),i++)}}const n=[];for(let o=0;o<s.files.length&&i<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const h=this.location(s.files[o]);if(h.scheme===d.Schemas.file){const g=(0,y.originalFSPath)(h);if(qe.COMMON_FILES_FILTER.includes((0,y.basename)(h))||c.includes(g))continue;await m.Promises.exists(g)&&(n.push(g),i++)}}n.reverse().forEach(o=>v.app.addRecentDocument(o)),c.reverse().forEach(o=>v.app.addRecentDocument(o))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(s){const c=[],i=[],n=s?.config?.workspace;(0,P.isWorkspaceIdentifier)(n)&&!this.workspacesManagementMainService.isUntitledWorkspace(n)?c.push({workspace:n}):(0,P.isSingleFolderWorkspaceIdentifier)(n)&&c.push({folderUri:n.uri});const o=s?.config?.filesToOpenOrCreate;if(o)for(let h of o){const g=h.fileUri;g&&this.indexOfFile(i,g)===-1&&i.push({fileUri:g})}return this.addEntriesFromStorage(c,i),{workspaces:c,files:i}}addEntriesFromStorage(s,c){let i=this.getRecentlyOpenedFromStorage();for(let n of i.workspaces){let o=(0,P.isRecentFolder)(n)?this.indexOfFolder(s,n.folderUri):this.indexOfWorkspace(s,n.workspace);o>=0?s[o].label=s[o].label||n.label:s.push(n)}for(let n of i.files){let o=this.indexOfFile(c,n.fileUri);o>=0?c[o].label=c[o].label||n.label:c.push(n)}}getRecentlyOpenedFromStorage(){const s=this.stateMainService.getItem(qe.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(s,this.logService)}saveRecentlyOpened(s){const c=(0,P.toStoreData)(s);this.stateMainService.setItem(qe.recentlyOpenedStorageKey,c)}updateWindowsJumpList(){if(!f.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let c=[];for(let o of v.app.getJumpListSettings().removedItems){const h=o.args;if(h){const g=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);g&&c.push(E.URI.parse(g[2]))}}this.removeRecentlyOpened(c);let i=!1;const n=(0,D.coalesce)(this.getRecentlyOpened().workspaces.slice(0,qe.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const h=(0,P.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:g,description:k}=this.getWindowsJumpListLabel(h,o.label);let L;return E.URI.isUri(h)?L=`--folder-uri "${h.toString()}"`:(i=!0,L=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:g.substr(0,255),description:k.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));n.length>0&&s.push({type:"custom",name:i?(0,p.localize)(2,null):(0,p.localize)(3,null),items:n})}s.push({type:"recent"});try{v.app.setJumpList(s)}catch(c){this.logService.warn("updateWindowsJumpList#setJumpList",c)}}getWindowsJumpListLabel(s,c){if(c)return{title:(0,r.splitName)(c).name,description:c};if(E.URI.isUri(s))return{title:(0,y.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,p.localize)(4,null),description:""};let i=(0,y.basename)(s.configPath);return i.endsWith(P.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,i),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,r.normalizeDriveLetter)(s.fsPath):s.toString()}location(s){return(0,P.isRecentFolder)(s)?s.folderUri:(0,P.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,c){return s.findIndex(i=>(0,P.isRecentWorkspace)(i)&&i.workspace.id===c.id)}indexOfFolder(s,c){return s.findIndex(i=>(0,P.isRecentFolder)(i)&&y.extUriBiasedIgnorePathCase.isEqual(i.folderUri,c))}indexOfFile(s,c){return s.findIndex(i=>y.extUriBiasedIgnorePathCase.isEqual(i.fileUri,c))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ge([te(0,S.IStateMainService),te(1,b.ILogService),te(2,u.IWorkspacesManagementMainService),te(3,w.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(Q[240],J([0,1,14,9,23,33,3,7,149,19,24,20,6,187,53,22,38,29,41,67,36,68]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let c=class St{constructor(o,h,g,k,L,R,O,V,ee,oe,ae){this.updateService=o,this.configurationService=h,this.windowsMainService=g,this.environmentMainService=k,this.telemetryService=L,this.workspacesHistoryMainService=R,this.stateMainService=O,this.lifecycleMainService=V,this.logService=ee,this.nativeHostMainService=oe,this.productService=ae,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new D.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new D.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(r.isMacintosh||(0,u.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(St.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,O,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,O,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,O,V)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,O,V)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const h=this.productService.requestFeatureUrl;h&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(h,"openUserVoiceUrl"));const g=this.productService.reportIssueUrl;g&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(g,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(r.language){const R=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${R}lang=${r.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!r.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,h){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(St.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!r.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!r.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=v.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(r.isMacintosh?new v.Menu:null);return}const h=new v.Menu;let g;if(r.isMacintosh){const L=new v.Menu;g=new v.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),h.append(g)}if(r.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new v.Menu;L.append(new v.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:L});this.setMenuById(L,"File"),h.append(R)}if(this.shouldDrawMenu("Edit")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),h.append(R)}if(this.shouldDrawMenu("Selection")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),h.append(R)}if(this.shouldDrawMenu("View")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:L});this.setMenuById(L,"View"),h.append(R)}if(this.shouldDrawMenu("Go")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),h.append(R)}if(this.shouldDrawMenu("Run")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),h.append(R)}if(this.shouldDrawMenu("Terminal")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),h.append(R)}let k;if(this.shouldDrawMenu("Window")){const L=new v.Menu;k=new v.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(k&&h.append(k),this.shouldDrawMenu("Help")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),h.append(R)}h.items&&h.items.length>0?v.Menu.setApplicationMenu(h):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const h=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),g=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const K=new v.Menu;this.setMenuById(K,"Preferences"),k=new v.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:K})}const L=new v.Menu,R=new v.MenuItem({label:d.localize(12,null),role:"services",submenu:L}),O=new v.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),V=new v.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ee=new v.MenuItem({label:d.localize(15,null),role:"unhide"}),oe=new v.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),ae=[h];ae.push(...g),k&&ae.push(i(),k),ae.push(i(),R,i(),O,V,ee,i(),oe),ae.forEach(K=>o.append(K))}shouldDrawMenu(o){if(!r.isMacintosh&&(0,u.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(r.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(r.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,h){h.forEach(g=>{if((0,p.isMenubarMenuItemSeparator)(g))o.append(i());else if((0,p.isMenubarMenuItemSubmenu)(g)){const k=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.label),submenu:k});this.setMenu(k,g.submenu.items),o.append(L)}else(0,p.isMenubarMenuItemRecentAction)(g)?o.append(this.createOpenRecentMenuItem(g)):(0,p.isMenubarMenuItemAction)(g)&&(g.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),r.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[g.id]?o.append(new v.MenuItem(this.likeAction(g.id,{label:this.mnemonicLabel(g.label),click:this.fallbackMenuHandlers[g.id]}))):o.append(this.createMenuItem(g.label,g.id,!1,g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)))})}setMenuById(o,h){this.menubarMenus&&this.menubarMenus[h]&&this.setMenu(o,this.menubarMenus[h].items)}insertCheckForUpdatesItems(o){const h=this.getUpdateMenuItems();h.length&&(h.forEach(g=>o.append(g)),o.append(i()))}createOpenRecentMenuItem(o){const h=I.URI.revive(o.uri),g=o.id,k=g==="openRecentFile"?{fileUri:h}:g==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new v.MenuItem(this.likeAction(g,{label:o.label,click:(L,R,O)=>{const V=this.isOptionClick(O);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:V,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([h])}},!1))}isOptionClick(o){return!!(o&&(!r.isMacintosh&&(o.ctrlKey||o.shiftKey)||r.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,h,g){const k={label:this.mnemonicLabel(o),role:g,enabled:!0};return new v.MenuItem(this.withKeybinding(h,k))}setMacWindowMenu(o){const h=new v.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),g=new v.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new v.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(i()),R.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,g,i(),L,...R,i(),k].forEach(O=>o.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,h,g,k){const L=this.mnemonicLabel(o),R=typeof h=="function"?h:(ae,K,T)=>{const N=ae?ae.userSettingsLabel:null;let G=h;Array.isArray(h)&&(G=this.isOptionClick(T)?h[1]:h[0]),N&&T.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:N}):this.runActionInRenderer({type:"commandId",commandId:G})},O=typeof g=="boolean"?g:this.windowsMainService.getWindowCount()>0,V=typeof k=="boolean"?k:!1,ee={label:L,click:R,enabled:O};V&&(ee.type="checkbox",ee.checked=V);let oe;return typeof h=="string"?oe=h:Array.isArray(h)&&(oe=h[0]),r.isMacintosh&&(oe==="editor.action.clipboardCutAction"?ee.role="cut":oe==="editor.action.clipboardCopyAction"?ee.role="copy":oe==="editor.action.clipboardPasteAction"&&(ee.role="paste"),oe==="undo"?ee.click=this.makeContextAwareClickHandler(R,{inDevTools:ae=>ae.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?ee.click=this.makeContextAwareClickHandler(R,{inDevTools:ae=>ae.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(ee.click=this.makeContextAwareClickHandler(R,{inDevTools:ae=>ae.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(oe,ee))}makeContextAwareClickHandler(o,h){return(g,k,L)=>{const R=v.BrowserWindow.getFocusedWindow();if(!R)return h.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return h.inDevTools(R.webContents.devToolsWebContents);o(g,k||R,L)}}runActionInRenderer(o){let h=v.BrowserWindow.getFocusedWindow();if(!h){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(h=k.win)}const g=h?this.windowsMainService.getWindowById(h.id):void 0;if(g){if(this.logService.trace("menubar#runActionInRenderer",o),r.isMacintosh&&!this.environmentMainService.isBuilt&&!g.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const k={id:o.commandId,from:"menu"};g.sendWhenReady("vscode:runAction",M.CancellationToken.None,k)}else{const k={userSettingsLabel:o.userSettingsLabel};g.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,h){const g=typeof o=="string"?this.keybindings[o]:void 0;if(g?.label){if(g.isNative!==!1)h.accelerator=g.label,h.userSettingsLabel=g.userSettingsLabel;else if(typeof h.label=="string"){const k=h.label.indexOf("[");k>=0?h.label=`${h.label.substr(0,k)} [${g.label}]`:h.label=`${h.label} [${g.label}]`}}else h.accelerator=void 0;return h}likeAction(o,h,g=!h.accelerator){g&&(h=this.withKeybinding(o,h));const k=h.click;return h.click=(L,R,O)=>{this.reportMenuActionTelemetry(o),k&&k(L,R,O)},h}openUrl(o,h){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(h)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,C.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};c.lastKnownMenubarStorageKey="lastKnownMenubarData",c=ge([te(0,P.IUpdateService),te(1,f.IConfigurationService),te(2,a.IWindowsMainService),te(3,y.IEnvironmentMainService),te(4,S.ITelemetryService),te(5,l.IWorkspacesHistoryMainService),te(6,b.IStateMainService),te(7,E.ILifecycleMainService),te(8,m.ILogService),te(9,t.INativeHostMainService),te(10,w.IProductService)],c),e.Menubar=c;function i(){return new v.MenuItem({type:"separator"})}}),define(Q[241],J([0,1,5,20,6,240]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let r=class{constructor(d,f,y){this.instantiationService=d,this.lifecycleMainService=f,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(d,f){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(f,d)}};r=ge([te(0,v.IInstantiationService),te(1,D.ILifecycleMainService),te(2,M.ILogService)],r),e.MenubarMainService=r}),define(Q[242],J([0,1,14,28,26,30,23,4,32,42,33,2,10,8,63,3,34,15,13,7,155,51,19,52,24,18,5,20,6,56,22,57,64,38,67,239,101,221,27,102,68,45]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s,c,i,n,o,h,g,k,L,R,O,V,ee,oe,ae,K,T,N,G,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function _(F){return(0,T.isWorkspaceIdentifier)(F?.workspace)}function U(F){return(0,T.isSingleFolderWorkspaceIdentifier)(F?.workspace)}let j=class it extends E.Disposable{constructor(A,W,B,Y,x,z,X,ie,re,se,Z,ce,le,he,me){super();this.machineId=A,this.initialUserEnv=W,this.logService=B,this.stateMainService=Y,this.environmentMainService=x,this.lifecycleMainService=z,this.backupMainService=X,this.configurationService=ie,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=Z,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=me,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new K.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const W=new E.DisposableStore;if(W.add(I.Event.any(A.onDidClose,A.onDidDestroy)(()=>W.dispose())),A.config.extensionDevelopmentPath)for(const B of A.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(u.URI.file(B)));A.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(u.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,W){let B=this.environmentMainService.args;const Y=W?.remoteAuthority||void 0,x=!0,z=W?.forceReuseWindow,X=!z;return this.open({...A,cli:B,forceEmpty:x,forceNewWindow:X,forceReuseWindow:z,remoteAuthority:Y})}openExistingWindow(A,W){A.focus(),this.handleWaitMarkerFile(W,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const W=[],B=[],Y=[],x=[],z=[];let X,ie=0;const re=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const le of re)U(le)?A.addMode?W.push(le):B.push(le):_(le)?Y.push(le):le.fileUri?(X||(X={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),X.filesToOpenOrCreate.push(le)):le.backupPath?z.push({backupFolder:(0,p.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):ie++;A.diffMode&&X&&X.filesToOpenOrCreate.length>=2&&(X.filesToDiff=X.filesToOpenOrCreate.slice(0,2),X.filesToOpenOrCreate=[]),X&&A.waitMarkerFileURI&&(X.filesToWait={paths:[...X.filesToDiff,...X.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...x),z.push(...this.backupMainService.getEmptyWindowBackupPaths())):z.length=0;const{windows:se,filesOpenedInWindow:Z}=this.doOpen(A,Y,B,z,ie,X,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${B.length}, emptyToRestore: ${z.length}, emptyToOpen: ${ie})`),se.length>1)if(Z)Z.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let he=!0,me=!0;if(le){const be=se.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),he=!1,me=!1)}if(he)for(let be=se.length-1;be>=0;be--){const de=se[be];if(!(de.openedWorkspace&&x.some(fe=>de.openedWorkspace&&fe.workspace.id===de.openedWorkspace.id)||de.backupPath&&z.some(fe=>de.backupPath&&fe.backupFolder===(0,p.basename)(de.backupPath)))){de.focus(),me=!1;break}}me&&se[se.length-1].focus()}const ce=X&&X.filesToDiff.length>0;if(!se.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!A.noRecentEntry){const le=[];for(const he of re)_(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):U(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(A,se),se}handleWaitMarkerFile(A,W){const B=A.waitMarkerFileURI;A.context===0&&B&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(B)}catch(Y){}})()}doOpen(A,W,B,Y,x,z,X){const ie=[];let re;function se(de,fe){ie.push(de),fe&&(re=de,z=void 0)}let{openFolderInNewWindow:Z,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&X.length>0){const de=X[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(de);fe&&se(this.doAddFoldersToExistingWindow(fe,X.map(Se=>Se.workspace.uri)))}const le=B.length+W.length+Y.length;if(z&&le===0){const de=z.filesToOpenOrCreate[0]||z.filesToDiff[0],fe=this.getWindows().filter(Ce=>z&&(0,S.isEqualAuthority)(Ce.remoteAuthority,z.remoteAuthority));let Se;de?.fileUri&&!ce&&((A.context===4||A.context===0||A.context===1)&&(Se=(0,ae.findWindowOnFile)(fe,de.fileUri,Ce=>Ce.configPath.scheme===m.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ce.configPath):void 0)),Se||(Se=this.doGetLastActiveWindow(fe))),Se?(0,T.isWorkspaceIdentifier)(Se.openedWorkspace)?W.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):(0,T.isSingleFolderWorkspaceIdentifier)(Se.openedWorkspace)?B.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):se(this.doOpenFilesInExistingWindow(A,Se,z),!0):se(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const he=(0,C.distinct)(W,de=>de.workspace.id);if(he.length>0){const de=(0,C.coalesce)(he.map(fe=>(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(de.length>0){const fe=de[0],Se=(0,S.isEqualAuthority)(z?.remoteAuthority,fe.remoteAuthority)?z:void 0;se(this.doOpenFilesInExistingWindow(A,fe,Se),!!Se),Z=!0}he.forEach(fe=>{if(de.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===fe.workspace.id))return;const Se=fe.remoteAuthority,Ce=(0,S.isEqualAuthority)(z?.remoteAuthority,Se)?z:void 0;se(this.doOpenFolderOrWorkspace(A,fe,Z,Ce),!!Ce),Z=!0})}const me=(0,C.distinct)(B,de=>S.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(me.length>0){const de=(0,C.coalesce)(me.map(fe=>(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(de.length>0){const fe=de[0],Se=(0,S.isEqualAuthority)(z?.remoteAuthority,fe.remoteAuthority)?z:void 0;se(this.doOpenFilesInExistingWindow(A,fe,Se),!!Se),Z=!0}me.forEach(fe=>{if(de.some(Re=>(0,T.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,fe.workspace.uri)))return;const Se=fe.remoteAuthority,Ce=(0,S.isEqualAuthority)(z?.remoteAuthority,Se)?z:void 0;se(this.doOpenFolderOrWorkspace(A,fe,Z,Ce),!!Ce),Z=!0})}const be=(0,C.distinct)(Y,de=>de.backupFolder);if(be.length>0&&be.forEach(de=>{const fe=de.remoteAuthority,Se=(0,S.isEqualAuthority)(z?.remoteAuthority,fe)?z:void 0;se(this.doOpenEmpty(A,!0,fe,Se,de),!!Se),Z=!0}),ie.length===0||z){z&&!x&&x++;const de=z?z.remoteAuthority:A.remoteAuthority;for(let fe=0;fe<x;fe++)se(this.doOpenEmpty(A,Z,de,z),!!z),Z=!0}return{windows:(0,C.distinct)(ie),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,W,B){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:B}),W.focus();const Y={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToWait:B?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",r.CancellationToken.None,Y),W}doAddFoldersToExistingWindow(A,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),A.focus();const B={foldersToAdd:W};return A.sendWhenReady("vscode:addFolders",r.CancellationToken.None,B),A}doOpenEmpty(A,W,B,Y,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:B,filesToOpen:Y,forceNewWindow:W});let z;return!W&&typeof A.contextWindowId=="number"&&(z=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:B,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:z,emptyWindowBackupInfo:x})}doOpenFolderOrWorkspace(A,W,B,Y,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:Y}),!B&&!x&&typeof A.contextWindowId=="number"&&(x=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:x})}getPathsToOpen(A){let W,B=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(A),B=!0):A.forceEmpty?W=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(W=this.doExtractPathsFromCLI(A.cli),W.length===0&&W.push(Object.create(null)),B=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),Y=!0),!A.addMode&&B){const x=W.filter(z=>U(z));if(x.length>1){const z=x[0].remoteAuthority;if(x.every(X=>(0,S.isEqualAuthority)(X.remoteAuthority,z))){const X=this.workspacesManagementMainService.createUntitledWorkspaceSync(x.map(ie=>({uri:ie.workspace.uri})));W.push({workspace:X,remoteAuthority:z}),W=W.filter(ie=>!U(ie))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(x=>_(x)||U(x)||x.backupPath)),W}doExtractPathsFromAPI(A){const W=[],B={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of(0,C.coalesce)(A.urisToOpen||[])){const x=this.resolveOpenable(Y,B);if(x)x.label=Y.label,W.push(x);else{const z=this.resourceFromOpenable(Y),X={title:this.productService.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:z.scheme===m.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:z.scheme===m.Schemas.file?(0,a.localize)(3,null,(0,y.getPathLabel)(z.fsPath,this.environmentMainService)):(0,a.localize)(4,null,z.toString()),noLink:!0};this.dialogMainService.showMessageBox(X,(0,P.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(A){const W=[],B={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const X of Y){const ie=this.cliArgToUri(X);if(ie){const re=this.resolveOpenable({folderUri:ie},B);re&&W.push(re)}}const x=A["file-uri"];if(x)for(const X of x){const ie=this.cliArgToUri(X);if(ie){const re=this.resolveOpenable((0,T.hasWorkspaceFileExtension)(X)?{workspaceUri:ie}:{fileUri:ie},B);re&&W.push(re)}}const z=A._;for(const X of z){const ie=B.remoteAuthority?this.doResolvePathRemote(X,B):this.doResolveFilePath(X,B);ie&&W.push(ie)}return W}cliArgToUri(A){try{const W=u.URI.parse(A);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${A}, ${W.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];A!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const Y of W)if(Y.workspace){const x=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});_(x)&&B.push(x)}else if(Y.folderUri){const x=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});U(x)&&B.push(x)}else A!=="folders"&&Y.backupPath&&B.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return B}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,W=Object.create(null)){let B=this.resourceFromOpenable(A);return B.scheme===m.Schemas.file?((0,ee.isFileToOpen)(A)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(B.fsPath,W)):this.doResolveRemoteOpenable(A,W)}doResolveRemoteOpenable(A,W){let B=this.resourceFromOpenable(A);const Y=(0,O.getRemoteAuthority)(B)||W.remoteAuthority;if(B=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)(B)),(0,ee.isFileToOpen)(A)){if(W.gotoLineMode){const{path:x,line:z,column:X}=(0,d.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:x}),selection:z?{startLineNumber:z,startColumn:X||1}:void 0,remoteAuthority:Y}}return{fileUri:B,remoteAuthority:Y}}else if((0,ee.isWorkspaceToOpen)(A))return{workspace:(0,N.getWorkspaceIdentifier)(B),remoteAuthority:Y};return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:Y}}resourceFromOpenable(A){return(0,ee.isWorkspaceToOpen)(A)?A.workspaceUri:(0,ee.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,W){let B,Y;W.gotoLineMode&&({path:A,line:B,column:Y}=(0,d.parseLineAndColumnAware)(A)),A=(0,d.sanitizeFilePath)((0,p.normalize)(A),(0,b.cwd)());try{const x=(0,D.statSync)(A);if(x.isFile()){if(!W.forceOpenWorkspaceAsFile){const z=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(A));if(z)return z.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:z.id,configPath:z.configPath},type:n.FileType.File,exists:!0,remoteAuthority:z.remoteAuthority,transient:z.transient}}return{fileUri:u.URI.file(A),type:n.FileType.File,exists:!0,selection:B?{startLineNumber:B,startColumn:Y||1}:void 0}}else{if(x.isDirectory())return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(u.URI.file(A),x),type:n.FileType.Directory,exists:!0};if(!w.isWindows&&A==="/dev/null")return{fileUri:u.URI.file(A),type:n.FileType.File,exists:!0}}}catch(x){const z=u.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([z]),W.ignoreFileNotFound)return{fileUri:z,type:n.FileType.File,exists:!1}}}doResolvePathRemote(A,W){const B=A.charCodeAt(0),Y=W.remoteAuthority;let x,z;W.gotoLineMode&&({path:A,line:x,column:z}=(0,d.parseLineAndColumnAware)(A)),B!==47&&((0,d.isWindowsDriveLetter)(B)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,d.toSlashes)(A)),A=`/${A}`);const X=u.URI.from({scheme:m.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,T.hasWorkspaceFileExtension)(A))return W.forceOpenWorkspaceAsFile?{fileUri:X,selection:x?{startLineNumber:x,startColumn:z||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,N.getWorkspaceIdentifier)(X),remoteAuthority:Y};if(W.gotoLineMode||p.posix.basename(A).indexOf(".")!==-1)return{fileUri:X,selection:x?{startLineNumber:x,startColumn:z||1}:void 0,remoteAuthority:Y}}return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(X),remoteAuthority:Y}}shouldOpenNewWindow(A){const W=this.configurationService.getValue("window"),B=W?.openFoldersInNewWindow||"default",Y=W?.openFilesInNewWindow||"off";let x=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(B==="on"||B==="off")&&(x=B==="on");let z=!1;return A.forceNewWindow||A.forceReuseWindow?z=!!A.forceNewWindow&&!A.forceReuseWindow:(w.isMacintosh?A.context===1&&(z=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(z=Y==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:z}}openExtensionDevelopmentHostWindow(A,W){const B=(0,ae.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(B)return this.lifecycleMainService.reload(B,W.cli),B.focus(),[B];let Y=W.cli["folder-uri"]||[],x=W.cli["file-uri"]||[],z=W.cli._;if(!z.length&&!Y.length&&!x.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,Z=se&&(se.workspace||se.folderUri);Z&&(u.URI.isUri(Z)?Z.scheme===m.Schemas.file?z=[Z.fsPath]:Y=[Z.toString()]:Z.configPath.scheme===m.Schemas.file?z=[(0,S.originalFSPath)(Z.configPath)]:x=[Z.configPath.toString()])}let X=W.remoteAuthority;for(const se of A)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const Z=u.URI.parse(se),ce=(0,O.getRemoteAuthority)(Z);ce&&(X?ce!==X&&this.logService.error("more than one extension development path authority"):X=ce)}z=z.filter(se=>{const Z=u.URI.file(se);return(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:(0,S.isEqualAuthority)((0,O.getRemoteAuthority)(Z),X)}),Y=Y.filter(se=>{const Z=this.cliArgToUri(se);return Z&&!!(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,S.isEqualAuthority)((0,O.getRemoteAuthority)(Z),X):!1}),x=x.filter(se=>{const Z=this.cliArgToUri(se);return Z&&!!(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,S.isEqualAuthority)((0,O.getRemoteAuthority)(Z),X):!1}),W.cli._=z,W.cli["folder-uri"]=Y,W.cli["file-uri"]=x;const ie=!z.length&&!Y.length&&!x.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:X};return this.open(re)}openInBrowserWindow(A){const W=this.configurationService.getValue("window"),B={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:A.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const x=Y.config;!B.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(B.extensionDevelopmentPath=x.extensionDevelopmentPath,B.verbose=x.verbose,B["inspect-brk-extensions"]=x["inspect-brk-extensions"],B.debugId=x.debugId,B.extensionEnvironment=x.extensionEnvironment,B["inspect-extensions"]=x["inspect-extensions"],B["extensions-dir"]=x["extensions-dir"])}else{const x=this.windowsStateHandler.getNewWindowState(B);(0,t.mark)("code/willCreateCodeWindow");const z=Y=this.instantiationService.createInstance(oe.CodeWindow,{state:x,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(z)}it.WINDOWS.push(z),this._onDidOpenWindow.fire(z),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(z.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(z)),(0,f.once)(z.onDidClose)(()=>this.onWindowClosed(z)),(0,f.once)(z.onDidDestroy)(()=>this._onDidDestroyWindow.fire(z));const X=(0,P.assertIsDefined)(z.win?.webContents);X.removeAllListeners("devtools-reload-page"),X.on("devtools-reload-page",()=>this.lifecycleMainService.reload(z)),this.lifecycleMainService.registerWindow(z)}return B.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(x=>{x||this.doOpenInBrowserWindow(Y,B,A)}):this.doOpenInBrowserWindow(Y,B,A),Y}doOpenInBrowserWindow(A,W,B){if(!W.extensionDevelopmentPath)if((0,T.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,T.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const Y=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,W.remoteAuthority)}A.load(W)}onWindowClosed(A){const W=it.WINDOWS.indexOf(A);it.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=v.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,S.isEqualAuthority)(W.remoteAuthority,A)))}doGetLastActiveWindow(A){const W=Math.max.apply(Math,A.map(B=>B.lastFocusTime));return A.find(B=>B.lastFocusTime===W)}sendToFocused(A,...W){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(A,r.CancellationToken.None,...W)}sendToAll(A,W,B){for(const Y of this.getWindows())B&&B.indexOf(Y.id)>=0||Y.sendWhenReady(A,r.CancellationToken.None,W)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(A){const W=this.getWindows().filter(B=>B.id===A);return(0,C.firstOrDefault)(W)}getWindowByWebContents(A){const W=v.BrowserWindow.fromWebContents(A);if(!!W)return this.getWindowById(W.id)}};j.WINDOWS=[],j=ge([te(2,g.ILogService),te(3,V.IStateMainService),te(4,i.IEnvironmentMainService),te(5,h.ILifecycleMainService),te(6,l.IBackupMainService),te(7,s.IConfigurationService),te(8,G.IWorkspacesHistoryMainService),te(9,q.IWorkspacesManagementMainService),te(10,o.IInstantiationService),te(11,c.IDialogMainService),te(12,n.IFileService),te(13,L.IProductService),te(14,R.IProtocolMainService)],j),e.WindowsMainService=j}),define(Q[243],J([0,1,51,36,68,45]),function($,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let r=class{constructor(d,f,y,E){this.workspacesManagementMainService=d,this.windowsMainService=f,this.workspacesHistoryMainService=y,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,f){const y=this.windowsMainService.getWindowById(d);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),f)}createUntitledWorkspace(d,f,y){return this.workspacesManagementMainService.createUntitledWorkspace(f,y)}deleteUntitledWorkspace(d,f){return this.workspacesManagementMainService.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(d,f){return this.workspacesManagementMainService.getWorkspaceIdentifier(f)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,f){return this.workspacesHistoryMainService.addRecentlyOpened(f)}async removeRecentlyOpened(d,f){return this.workspacesHistoryMainService.removeRecentlyOpened(f)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};r=ge([te(0,C.IWorkspacesManagementMainService),te(1,D.IWindowsMainService),te(2,M.IWorkspacesHistoryMainService),te(3,v.IBackupMainService)],r),e.WorkspacesMainService=r}),define(Q[244],J([0,1,14,28,26,17,44,16,32,42,39,33,2,10,8,3,15,13,7,31,71,122,35,125,85,235,134,51,226,19,180,162,74,52,225,89,24,54,91,170,188,171,222,90,172,18,183,94,73,5,75,236,201,103,20,6,185,241,53,22,64,231,76,38,219,100,202,29,204,206,65,41,210,233,237,234,238,99,211,212,213,214,216,36,242,217,27,68,243,45]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s,c,i,n,o,h,g,k,L,R,O,V,ee,oe,ae,K,T,N,G,q,_,U,j,F,A,W,B,Y,x,z,X,ie,re,se,Z,ce,le,he,me,be,de,fe,Se,Ce,Re,We,$e,ze,Qe,Ge,gt,Je,at,ct,Ve,He,H,ne,ue,pe,Ie,Me,Te,Fe,Oe,Ne,je,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends m.Disposable{constructor(we,ye,Ee,ve,Pe,De,ke,Le,Ae,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=Ee,this.logService=ve,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=ke,this.stateMainService=Le,this.fileService=Ae,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=ve=>ve?.startsWith(`${p.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((ve,Pe,De,ke)=>we(ke.requestingUrl)?De(ye.has(Pe)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((ve,Pe,De,ke)=>we(ke.requestingUrl)?ye.has(Pe):!1);const Ee=v.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,I.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,I.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Ee,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),v.app.on("activate",(Ee,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Ee,ve)=>{ve.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ve.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let we=[],ye;v.app.on("open-file",(Ee,ve)=>{this.logService.trace("app#open-file: ",ve),Ee.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const ve=this.windowsMainService?.getWindowByWebContents(Ee.sender);let Pe,De;return ve?.config?(Pe=ve.config,De={...process.env,...ve.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),v.ipcMain.handle("vscode:writeNlsFile",(Ee,ve,Pe)=>{const De=this.validateNlsPath([ve]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(Pe))}),v.ipcMain.handle("vscode:readNlsFile",async(Ee,...ve)=>{const Pe=this.validateNlsPath(ve);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(we){let ye;for(const Ee of we)typeof Ee=="string"&&(typeof ye!="string"?ye=Ee:ye=(0,t.join)(ye,Ee));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return P.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;w.isWindows&&we&&v.app.setAppUserModelId(we);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new c.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:ve,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(Ee),ke=await this.initServices(Ee,ve,Pe);if(this.environmentMainService.driverHandle){const Ae=await(0,ee.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(ke.createInstance(n.ProxyAuthHandler)),ke.invokeFunction(Ae=>this.initChannels(Ae,ye,De));const Le=ke.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));ke.invokeFunction(Ae=>this.afterWindowOpen(Ae,ve)),this.environmentMainService.args.trace&&ke.invokeFunction(Ae=>this.stopTracingEventually(Ae,Le))}async resolveMachineId(){let we=this.stateMainService.getItem(We.machineIdKey);return(!we||w.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(We.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,we,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Pe,"main")})(),ve=(async()=>(await ye.whenReady(),Ee))();return{sharedProcess:ye,sharedProcessReady:ve,sharedProcessClient:Ee}}async initServices(we,ye,Ee){const ve=new x.ServiceCollection;switch(process.platform){case"win32":ve.set(Ge.IUpdateService,new B.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":w.isLinuxSnap?ve.set(Ge.IUpdateService,new B.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ge.IUpdateService,new B.SyncDescriptor(at.LinuxUpdateService));break;case"darwin":ve.set(Ge.IUpdateService,new B.SyncDescriptor(Je.DarwinUpdateService));break}ve.set(Me.IWindowsMainService,new B.SyncDescriptor(Te.WindowsMainService,[we,this.userEnv])),ve.set(V.IDialogMainService,new B.SyncDescriptor(V.DialogMainService)),ve.set(ie.ILaunchMainService,new B.SyncDescriptor(ie.LaunchMainService)),ve.set(O.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Ee.then(De=>De.getChannel("diagnostics"))))),ve.set(z.IIssueMainService,new B.SyncDescriptor(z.IssueMainService,[this.userEnv])),ve.set(oe.IEncryptionMainService,new B.SyncDescriptor(oe.EncryptionMainService,[we])),ve.set(X.IKeyboardLayoutMainService,new B.SyncDescriptor(X.KeyboardLayoutMainService)),ve.set(le.INativeHostMainService,new B.SyncDescriptor(le.NativeHostMainService,[ye])),ve.set(pe.IWebviewManagerService,new B.SyncDescriptor(Ie.WebviewMainService)),ve.set(Oe.IWorkspacesService,new B.SyncDescriptor(je.WorkspacesMainService)),ve.set(bt.IWorkspacesManagementMainService,new B.SyncDescriptor(bt.WorkspacesManagementMainService)),ve.set(Ne.IWorkspacesHistoryMainService,new B.SyncDescriptor(Ne.WorkspacesHistoryMainService)),ve.set(ce.IMenubarMainService,new B.SyncDescriptor(ce.MenubarMainService)),ve.set(N.IExtensionUrlTrustService,new B.SyncDescriptor(G.ExtensionUrlTrustService)),ve.set(q.IExtensionHostStarter,new B.SyncDescriptor(_.WorkerMainProcessExtensionHostStarter)),ve.set(Ce.IStorageMainService,new B.SyncDescriptor(Ce.StorageMainService)),w.isWindows?ve.set(U.IExternalTerminalMainService,new B.SyncDescriptor(j.WindowsExternalTerminalService)):w.isMacintosh?ve.set(U.IExternalTerminalMainService,new B.SyncDescriptor(j.MacExternalTerminalService)):w.isLinux&&ve.set(U.IExternalTerminalMainService,new B.SyncDescriptor(j.LinuxExternalTerminalService));const Pe=new g.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(h.IBackupMainService,Pe),ve.set(He.IURLService,new B.SyncDescriptor(ne.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,s.getDelayedChannel)(Ee.then(Ze=>Ze.getChannel("telemetryAppender"))),ke=new $e.TelemetryAppenderClient(De),Le=(0,Re.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[ke],commonProperties:Le,piiPaths:Ae,sendErrorTelemetry:!0};ve.set(We.ITelemetryService,new B.SyncDescriptor(ze.TelemetryService,[Xe]))}else ve.set(We.ITelemetryService,Qe.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,ye,Ee){const ve=s.ProxyChannel.fromService(we.get(ie.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const Pe=this.fileService.getProvider(p.Schemas.file);(0,S.assertType)(Pe instanceof W.DiskFileSystemProvider);const De=new A.DiskFileSystemProviderChannel(Pe,this.logService);ye.registerChannel("localFilesystem",De);const ke=new L.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(L.UserConfigurationFileServiceId,s.ProxyChannel.fromService(ke)),Ee.then(Be=>Be.registerChannel(L.UserConfigurationFileServiceId,s.ProxyChannel.fromService(ke)));const Le=new gt.UpdateChannel(we.get(Ge.IUpdateService));ye.registerChannel("update",Le);const Ae=s.ProxyChannel.fromService(we.get(z.IIssueMainService));ye.registerChannel("issue",Ae);const Xe=s.ProxyChannel.fromService(we.get(oe.IEncryptionMainService));ye.registerChannel("encryption",Xe);const Ze=s.ProxyChannel.fromService(we.get(de.ISignService));ye.registerChannel("sign",Ze);const nt=s.ProxyChannel.fromService(we.get(X.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=we.get(le.INativeHostMainService);const xe=s.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",xe),Ee.then(Be=>Be.registerChannel("nativeHost",xe));const wt=s.ProxyChannel.fromService(we.get(Oe.IWorkspacesService));ye.registerChannel("workspaces",wt);const Ue=s.ProxyChannel.fromService(we.get(ce.IMenubarMainService));ye.registerChannel("menubar",Ue);const lt=s.ProxyChannel.fromService(we.get(He.IURLService));ye.registerChannel("url",lt);const rt=s.ProxyChannel.fromService(we.get(N.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=s.ProxyChannel.fromService(we.get(pe.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new Se.StorageDatabaseChannel(this.logService,we.get(Ce.IStorageMainService)));ye.registerChannel("storage",ot),Ee.then(Be=>Be.registerChannel("storage",ot));const ut=s.ProxyChannel.fromService(we.get(U.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ut);const et=new Z.LogLevelChannel(we.get(se.ILogService));ye.registerChannel("logLevel",et),Ee.then(Be=>Be.registerChannel("logLevel",et));const tt=new Z.LoggerChannel(we.get(se.ILoggerService));ye.registerChannel("logger",tt),Ee.then(Be=>Be.registerChannel("logger",tt));const ht=new R.ElectronExtensionHostDebugBroadcastChannel(we.get(Me.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ht);const _e=s.ProxyChannel.fromService(we.get(q.IExtensionHostStarter));ye.registerChannel(q.ipcExtensionHostStarterChannelName,_e)}openFirstWindow(we,ye){const Ee=this.windowsMainService=we.get(Me.IWindowsMainService),ve=we.get(He.IURLService),Pe=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:P.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(_e.uri);return Be?(De.push(Be),!1):!0}),Le=this,Ae=this.environmentMainService,Xe=this.productService;ve.registerHandler({async handleURL(_e,Be){if(_e.scheme===Xe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:P.URI.parse(_e.query).path,query:""})),Le.shouldBlockURI(_e))return!0;const Et=Le.getWindowOpenableFromProtocolLink(_e);if(Et){const[pt]=Ee.open({context:5,cli:{...Ae.args},urisToOpen:[Et],gotoLineMode:!0});return pt.focus(),!0}if(w.isMacintosh&&Ee.getWindowCount()===0){const[pt]=Ee.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,me.getRemoteAuthority)(_e)});return await pt.ready(),ve.open(_e,Be)}return!1}});const Ze=this._register(new Fe.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),nt=new s.StaticRouter(_e=>Ze.getActiveClientId().then(Be=>_e===Be)),xe=new H.URLHandlerRouter(nt),wt=ye.getChannel("urlHandler",xe);ve.registerHandler(new H.URLHandlerChannelClient(wt)),this._register(new ue.ElectronURLListener(ke,ve,Ee,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,lt=global.macOpenFiles,rt=(0,K.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],ut=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,tt=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return De.length>0?Ee.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!ut?Ee.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0,remoteAuthority:ht}):lt.length&&!st&&!ot&&!ut?Ee.open({context:1,cli:Ue,urisToOpen:lt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0}):Ee.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:tt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(we){return!!(we.authority===p.Schemas.file&&w.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,E.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===p.Schemas.file){const ye=P.URI.file(we.fsPath);return(0,Oe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===p.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const Ee=we.path.substring(1,ye),ve=we.path.substring(ye),Pe=P.URI.from({scheme:p.Schemas.vscodeRemote,authority:Ee,path:ve,query:we.query,fragment:we.fragment});return(0,Oe.hasWorkspaceFileExtension)(ve)?{workspaceUri:Pe}:/:[\d]+$/.test(ve)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(we){try{if((0,D.statSync)(we).isDirectory())return{folderUri:P.URI.file(we)};if((0,Oe.hasWorkspaceFileExtension)(we))return{workspaceUri:P.URI.file(we)}}catch(ye){}return{fileUri:P.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let Ee=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const ve=we.get(We.ITelemetryService);this._register(ye.onDidError(({type:ke,details:Le})=>{let Ae;switch(ke){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Ae)),ve.publicLog2("sharedprocesserror",{type:ke,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:Ee})}));const Pe=this.productService.win32MutexName;if(w.isWindows&&Pe)try{const ke=$.__$__nodeRequire("windows-mutex").Mutex,Le=new ke(Pe);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(ke){this.logService.error(ke)}v.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(ke,Le)=>{Le({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const De=we.get(Ge.IUpdateService);(De instanceof Ve.Win32UpdateService||De instanceof at.LinuxUpdateService||De instanceof Je.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,y.stripComments)(Le))["enable-crash-reporter"]===void 0){const Ze=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],xe=Le.substring(0,Le.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(xe))}}catch(ke){this.logService.error(ke)}}async resolveShellEnvironment(we,ye,Ee){try{return await(0,T.resolveShellEnv)(this.logService,we,ye)}catch(ve){const Pe=(0,r.toErrorMessage)(ve);Ee?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=we.get(V.IDialogMainService);let ve=!1;const Pe=async ke=>{if(ve)return;ve=!0;const Le=await v.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(ke=>ke.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};mt=ge([te(2,Y.IInstantiationService),te(3,se.ILogService),te(4,ae.IEnvironmentMainService),te(5,re.ILifecycleMainService),te(6,k.IConfigurationService),te(7,fe.IStateMainService),te(8,F.IFileService),te(9,he.IProductService)],mt),e.CodeApplication=mt}),define(Q[251],J([0,1,14,28,30,9,44,16,32,42,33,10,8,63,3,34,25,21,35,58,244,11,19,192,203,24,54,165,18,182,94,73,175,75,20,95,6,186,96,56,22,57,189,97,228,50,230,76,200,38,232,65,66,209]),function($,e,v,D,M,C,r,I,d,f,y,E,m,p,t,w,b,S,P,u,a,l,s,c,i,n,o,h,g,k,L,R,O,V,ee,oe,ae,K,T,N,G,q,_,U,j,F,A,W,B,Y,x,z,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(Z){console.error(Z.message),v.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(fe=>console.error(fe));const[Z,ce,le,he,me,be,de]=this.createServices();try{try{await this.initServices(le,he,me)}catch(fe){throw this.handleStartupDataDirError(le,de.nameLong,fe),fe}await Z.invokeFunction(async fe=>{const Se=fe.get(ae.ILogService),Ce=fe.get(ee.ILifecycleMainService),Re=fe.get(g.IFileService),We=await this.claimInstance(Se,le,Ce,Z,de,!0);return S.Promises.writeFile(le.mainLockfile,String(process.pid)).catch($e=>{Se.warn(`Error writing main lockfile: ${$e.stack}`)}),be.logger=new T.SpdLogLogger("main",(0,m.join)(le.logsPath,"main.log"),!0,!1,be.getLevel()),(0,f.once)(Ce.onWillShutdown)($e=>{Re.dispose(),he.dispose(),$e.join(S.Promises.unlink(le.mainLockfile).catch(()=>{}))}),Z.createInstance(a.CodeApplication,We,ce).startup()})}catch(fe){Z.invokeFunction(this.quit,fe)}}createServices(){const Z=new V.ServiceCollection,ce={_serviceBrand:void 0,...N.default};Z.set(G.IProductService,ce);const le=new n.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);Z.set(n.IEnvironmentMainService,le);const me=new oe.BufferLogService,be=new ae.MultiplexLogService([new ae.ConsoleMainLogger((0,ae.getLogLevel)(le)),me]);process.once("exit",()=>be.dispose()),Z.set(ae.ILogService,be);const de=new k.FileService(be);Z.set(g.IFileService,de);const fe=new L.DiskFileSystemProvider(be);de.registerProvider(E.Schemas.file,fe),Z.set(ae.ILoggerService,new K.LoggerService(be,de));const Se=new c.ConfigurationService(le.settingsResource,de);Z.set(s.IConfigurationService,Se),Z.set(ee.ILifecycleMainService,new R.SyncDescriptor(ee.LifecycleMainService));const Ce=new x.StateMainService(le,be,de);return Z.set(Y.IStateMainService,Ce),Z.set(F.IRequestService,new R.SyncDescriptor(A.RequestMainService)),Z.set(X.IThemeMainService,new R.SyncDescriptor(X.ThemeMainService)),Z.set(W.ISignService,new R.SyncDescriptor(B.SignService)),Z.set(U.ITunnelService,new R.SyncDescriptor(j.TunnelService)),Z.set(q.IProtocolMainService,new R.SyncDescriptor(_.ProtocolMainService)),[new O.InstantiationService(Z,!0),he,le,Se,Ce,me,ce]}patchEnvironment(Z){const ce={VSCODE_IPC_HOOK:Z.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(Z,ce,le){return C.Promises.settled([Promise.all([Z.extensionsPath,Z.codeCachePath,Z.logsPath,Z.globalStorageHome.fsPath,Z.workspaceStorageHome.fsPath,Z.backupHome].map(he=>he?S.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(Z,ce,le,he,me,be){let de;try{(0,p.mark)("code/willStartMainServer"),de=await(0,u.serve)(ce.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,f.once)(le.onWillShutdown)(()=>de.dispose())}catch(fe){if(fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,me.nameLong,fe),fe;let Se;try{Se=await(0,u.connect)(ce.mainIPCHandle,"main")}catch(We){if(!be||t.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,me.nameShort),(0,l.localize)(1,null),me.nameLong),We;try{(0,D.unlinkSync)(ce.mainIPCHandle)}catch($e){throw Z.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(Z,ce,le,he,me,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw Z.error(We),Se.dispose(),new Error(We)}let Ce;!ce.args.wait&&!ce.args.status&&(Ce=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,me.nameShort),(0,l.localize)(3,null),me.nameLong)},1e4));const Re=P.ProxyChannel.toService(Se.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const We=new i.DiagnosticsService(z.NullTelemetryService,me),$e=await Re.getMainProcessInfo(),ze=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await We.getDiagnostics($e,ze);throw console.log(Qe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Re,Z),Z.trace("Sending env to running instance..."),await Re.start(ce.args,process.env),Se.dispose(),Ce&&clearTimeout(Ce),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw Z.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(Z,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,M.coalesce)([Z.userDataPath,Z.extensionsPath,u.XDG_RUNTIME_DIR]).map(me=>(0,y.getPathLabel)(me,Z));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,r.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(Z,ce,le){v.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,l.localize)(6,null))],message:Z,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(Z,ce){if(t.isWindows){const le=await Z.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,me)=>{$(["windows-foreground-love"],he,me)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(Z,ce){const le=Z.get(ae.ILogService),he=Z.get(ee.ILifecycleMainService);let me=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(me=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(me)}resolveArgs(){const Z=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(Z.wait&&!Z.waitMarkerFilePath){const ce=(0,h.createWaitMarkerFile)(Z.verbose);ce&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ce),Z.waitMarkerFilePath=ce)}return Z}validatePaths(Z){if(Z["open-url"]&&(Z._urls=Z._,Z._=[]),!Z.remote){const ce=this.doValidatePaths(Z._,Z.goto);Z._=ce}return Z}doValidatePaths(Z,ce){const le=(0,w.cwd)(),he=Z.map(de=>{let fe=String(de),Se;ce&&(Se=(0,d.parseLineAndColumnAware)(fe),fe=Se.path),fe&&(fe=this.preparePath(le,fe));const Ce=(0,d.sanitizeFilePath)(fe,le),Re=(0,m.basename)(Ce);return Re&&!(0,d.isValidBasename)(Re)?null:ce&&Se?(Se.path=Ce,this.toPath(Se)):Ce}),me=t.isWindows||t.isMacintosh,be=(0,M.distinct)(he,de=>de&&me?de.toLowerCase():de||"");return(0,M.coalesce)(be)}preparePath(Z,ce){return t.isWindows&&(ce=(0,b.rtrim)(ce,'"')),ce=(0,b.trim)((0,b.trim)(ce," "),"	"),t.isWindows&&(ce=(0,m.resolve)(Z,ce),ce=(0,b.rtrim)(ce,".")),ce}toPath(Z){const ce=[Z.path];return typeof Z.line=="number"&&ce.push(String(Z.line)),typeof Z.column=="number"&&ce.push(String(Z.column)),ce.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ed3018f4310e906daa0a9119d997e75b8a38b879/core/vs/code/electron-main/main.js.map
