/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(Y){for(var e=[],m=0,L=Y.length;m<L;m++)e[m]=me[Y[m]];return e};define(me[56],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=m}),define(me[73],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(T){const I=[];for(let a in T)m.call(T,a)&&I.push(T[a]);return I}e.values=L;function D(T,I){for(let a in T)if(m.call(T,a)&&I({key:a,value:T[a]},function(){delete T[a]})===!1)return}e.forEach=D;function C(T,I){const a=Object.create(null);for(const w of T){const f=I(w);let v=a[f];v||(v=a[f]=[]),v.push(w)}return a}e.groupBy=C;function n(T){const I=Object.create(null);return T&&T.forEach((a,w)=>{I[w]=a}),I}e.fromMap=n;function k(T,I){const a=[],w=[];for(let f of T)I.has(f)||a.push(f);for(let f of I)T.has(f)||w.push(f);return{removed:a,added:w}}e.diffSets=k;function S(T,I){const a=[],w=[];for(let[f,v]of T)I.has(f)||a.push(v);for(let[f,v]of I)T.has(f)||w.push(v);return{removed:a,added:w}}e.diffMaps=S;class y{constructor(){this.map=new Map}add(I,a){let w=this.map.get(I);w||(w=new Set,this.map.set(I,w)),w.add(a)}delete(I,a){const w=this.map.get(I);!w||(w.delete(a),w.size===0&&this.map.delete(I))}forEach(I,a){const w=this.map.get(I);!w||w.forEach(a)}}e.SetMap=y}),define(me[57],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(n){return(k,S,y)=>{let T=null,I=null;if(typeof y.value=="function"?(T="value",I=y.value):typeof y.get=="function"&&(T="get",I=y.get),!I)throw new Error("not supported");y[T]=n(I,S)}}e.createDecorator=m;function L(n,k,S){let y=null,T=null;if(typeof S.value=="function"?(y="value",T=S.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",T=S.get),!T)throw new Error("not supported");const I=`$memoize$${k}`;S[y]=function(...a){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,a)}),this[I]}}e.memoize=L;function D(n,k,S){return m((y,T)=>{const I=`$debounce$${T}`,a=`$debounce$result$${T}`;return function(...w){this[a]||(this[a]=S?S():void 0),clearTimeout(this[I]),k&&(this[a]=k(this[a],...w),w=[this[a]]),this[I]=setTimeout(()=>{y.apply(this,w),this[a]=S?S():void 0},n)}})}e.debounce=D;function C(n,k,S){return m((y,T)=>{const I=`$throttle$timer$${T}`,a=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...v){if(this[a]||(this[a]=S?S():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),k&&(this[a]=k(this[a],...v)),this[f])return;const _=this[w]+n;_<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[a]]),this[a]=S?S():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),y.apply(this,[this[a]]),this[a]=S?S():void 0},_-Date.now()))}})}e.throttle=C}),define(me[15],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(b=>{b(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=m,e.errorHandler=new m;function L(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=L;function D(g){S(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=D;function C(g){S(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function n(g){if(g instanceof Error){let{name:o,message:b}=g;const i=g.stacktrace||g.stack;return{$isError:!0,name:o,message:b,stack:i}}return g}e.transformErrorForSerialization=n;const k="Canceled";function S(g){return g instanceof Error&&g.name===k&&g.message===k}e.isPromiseCanceledError=S;class y extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=y;function T(){const g=new Error(k);return g.name=g.message,g}e.canceled=T;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function a(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=a;function w(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function f(g){const o=new Error(`${g} has been disposed`);return o.name="DISPOSED",o}e.disposed=f;function v(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=_;class P extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=P;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function l(g){const o=g;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=l;function r(g,o=Object.create(null)){const b=new Error(g);return o.actions&&(b.actions=o.actions),b}e.createErrorWithActions=r}),define(me[17],ge([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(j,X=0){return j[j.length-(1+X)]}e.tail=L;function D(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=D;function C(j,X,K=(he,Ee)=>he===Ee){if(j===X)return!0;if(!j||!X||j.length!==X.length)return!1;for(let he=0,Ee=j.length;he<Ee;he++)if(!K(j[he],X[he]))return!1;return!0}e.equals=C;function n(j,X,K){let he=0,Ee=j.length-1;for(;he<=Ee;){const De=(he+Ee)/2|0,Pe=K(j[De],X);if(Pe<0)he=De+1;else if(Pe>0)Ee=De-1;else return De}return-(he+1)}e.binarySearch=n;function k(j,X){let K=0,he=j.length;if(he===0)return 0;for(;K<he;){const Ee=Math.floor((K+he)/2);X(j[Ee])?he=Ee:K=Ee+1}return K}e.findFirstInSorted=k;function S(j,X,K){if(j=j|0,j>=X.length)throw new TypeError("invalid index");let he=X[Math.floor(X.length*Math.random())],Ee=[],De=[],Pe=[];for(let Be of X){const He=K(Be,he);He<0?Ee.push(Be):He>0?De.push(Be):Pe.push(Be)}return j<Ee.length?S(j,Ee,K):j<Ee.length+Pe.length?Pe[0]:S(j-(Ee.length+Pe.length),De,K)}e.quickSelect=S;function y(j,X){const K=[];let he;for(const Ee of j.slice(0).sort(X))!he||X(he[0],Ee)!==0?(he=[Ee],K.push(he)):he.push(Ee);return K}e.groupBy=y;function T(j,X,K){const he=[];function Ee(Be,He,ze){if(He===0&&ze.length===0)return;const G=he[he.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=He,G.toInsert.push(...ze)):he.push({start:Be,deleteCount:He,toInsert:ze})}let De=0,Pe=0;for(;;){if(De===j.length){Ee(De,0,X.slice(Pe));break}if(Pe===X.length){Ee(De,j.length-De,[]);break}const Be=j[De],He=X[Pe],ze=K(Be,He);ze===0?(De+=1,Pe+=1):ze<0?(Ee(De,1,[]),De+=1):ze>0&&(Ee(De,0,[He]),Pe+=1)}return he}e.sortedDiff=T;function I(j,X,K){const he=T(j,X,K),Ee=[],De=[];for(const Pe of he)Ee.push(...j.slice(Pe.start,Pe.start+Pe.deleteCount)),De.push(...Pe.toInsert);return{removed:Ee,added:De}}e.delta=I;function a(j,X,K){if(K===0)return[];const he=j.slice(0,K).sort(X);return f(j,X,he,K,j.length),he}e.top=a;function w(j,X,K,he,Ee){return K===0?Promise.resolve([]):new Promise((De,Pe)=>{(async()=>{const Be=j.length,He=j.slice(0,K).sort(X);for(let ze=K,G=Math.min(K+he,Be);ze<Be;ze=G,G=Math.min(G+he,Be)){if(ze>K&&await new Promise(Z=>setTimeout(Z)),Ee&&Ee.isCancellationRequested)throw(0,m.canceled)();f(j,X,He,ze,G)}return He})().then(De,Pe)})}e.topAsync=w;function f(j,X,K,he,Ee){for(const De=K.length;he<Ee;he++){const Pe=j[he];if(X(Pe,K[De-1])<0){K.pop();const Be=k(K,He=>X(Pe,He)<0);K.splice(Be,0,Pe)}}}function v(j){return j.filter(X=>!!X)}e.coalesce=v;function _(j){let X=0;for(let K=0;K<j.length;K++)j[K]&&(j[X]=j[K],X+=1);j.length=X}e.coalesceInPlace=_;function P(j,X,K){j.splice(K,0,j.splice(X,1)[0])}e.move=P;function p(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=p;function l(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=l;function r(j,X=K=>K){const K=new Set;return j.filter(he=>{const Ee=X(he);return K.has(Ee)?!1:(K.add(Ee),!0)})}e.distinct=r;function g(j){const X=Object.create(null);return K=>{const he=j(K);return X[he]?!1:(X[he]=!0,!0)}}e.uniqueFilter=g;function o(j,X){const K=b(j,X);if(K!==-1)return j[K]}e.findLast=o;function b(j,X){for(let K=j.length-1;K>=0;K--){const he=j[K];if(X(he))return K}return-1}e.lastIndex=b;function i(j,X){return j.length>0?j[0]:X}e.firstOrDefault=i;function t(j,X,K=(he,Ee)=>he===Ee){let he=0;for(let Ee=0,De=Math.min(j.length,X.length);Ee<De&&K(j[Ee],X[Ee]);Ee++)he++;return he}e.commonPrefixLength=t;function c(j){return[].concat(...j)}e.flatten=c;function d(j,X){let K=typeof X=="number"?j:0;typeof X=="number"?K=j:(K=0,X=j);const he=[];if(K<=X)for(let Ee=K;Ee<X;Ee++)he.push(Ee);else for(let Ee=K;Ee>X;Ee--)he.push(Ee);return he}e.range=d;function s(j,X,K){return j.reduce((he,Ee)=>(he[X(Ee)]=K?K(Ee):Ee,he),Object.create(null))}e.index=s;function h(j,X){return j.push(X),()=>u(j,X)}e.insert=h;function u(j,X){const K=j.indexOf(X);if(K>-1)return j.splice(K,1),X}e.remove=u;function E(j,X,K){const he=j.slice(0,X),Ee=j.slice(X);return he.concat(K,Ee)}e.arrayInsert=E;function A(j,X){let K;if(typeof X=="number"){let he=X;K=()=>{const Ee=Math.sin(he++)*179426549;return Ee-Math.floor(Ee)}}else K=Math.random;for(let he=j.length-1;he>0;he-=1){const Ee=Math.floor(K()*(he+1)),De=j[he];j[he]=j[Ee],j[Ee]=De}}e.shuffle=A;function R(j,X){const K=j.indexOf(X);K>-1&&(j.splice(K,1),j.unshift(X))}e.pushToStart=R;function $(j,X){const K=j.indexOf(X);K>-1&&(j.splice(K,1),j.push(X))}e.pushToEnd=$;function N(j,X){return Array.isArray(j)?j.map(X):X(j)}e.mapArrayOrNot=N;function F(j){return Array.isArray(j)?j:[j]}e.asArray=F;function z(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=z;function M(j,X){for(const K of j){const he=X(K);if(he!==void 0)return he}}e.mapFind=M;function W(j,X,K){const he=x(j,X),Ee=j.length,De=K.length;j.length=Ee+De;for(let Pe=Ee-1;Pe>=he;Pe--)j[Pe+De]=j[Pe];for(let Pe=0;Pe<De;Pe++)j[Pe+he]=K[Pe]}e.insertInto=W;function U(j,X,K,he){const Ee=x(j,X),De=j.splice(Ee,K);return W(j,Ee,he),De}e.splice=U;function x(j,X){return X<0?Math.max(X+j.length,0):Math.min(X,j.length)}function B(j,X){let K=Number.MAX_SAFE_INTEGER,he=0;return j.forEach((Ee,De)=>{const Pe=X(Ee);Pe<K&&(K=Pe,he=De)}),he}e.minIndex=B;function O(j,X){let K=Number.MIN_SAFE_INTEGER,he=0;return j.forEach((Ee,De)=>{const Pe=X(Ee);Pe>K&&(K=Pe,he=De)}),he}e.maxIndex=O;class H{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let K=this.firstIdx;for(;K<this.items.length&&X(this.items[K]);)K++;const he=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,he}takeFromEndWhile(X){let K=this.lastIdx;for(;K>=0&&X(this.items[K]);)K--;const he=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,he}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const K=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,K}}e.ArrayQueue=H}),define(me[74],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const D=this;let C=!1,n;return function(){return C||(C=!0,n=L.apply(D,arguments)),n}}e.once=m}),define(me[75],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(me[76],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function D(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}L.is=D;const C=Object.freeze([]);function n(){return C}L.empty=n;function*k(g){yield g}L.single=k;function S(g){return g||C}L.from=S;function y(g){return!g||g[Symbol.iterator]().next().done===!0}L.isEmpty=y;function T(g){return g[Symbol.iterator]().next().value}L.first=T;function I(g,o){for(const b of g)if(o(b))return!0;return!1}L.some=I;function a(g,o){for(const b of g)if(o(b))return b}L.find=a;function*w(g,o){for(const b of g)o(b)&&(yield b)}L.filter=w;function*f(g,o){let b=0;for(const i of g)yield o(i,b++)}L.map=f;function*v(...g){for(const o of g)for(const b of o)yield b}L.concat=v;function*_(g){for(const o of g)for(const b of o)yield b}L.concatNested=_;function P(g,o,b){let i=b;for(const t of g)i=o(i,t);return i}L.reduce=P;function*p(g,o,b=g.length){for(o<0&&(o+=g.length),b<0?b+=g.length:b>g.length&&(b=g.length);o<b;o++)yield g[o]}L.slice=p;function l(g,o=Number.POSITIVE_INFINITY){const b=[];if(o===0)return[b,g];const i=g[Symbol.iterator]();for(let t=0;t<o;t++){const c=i.next();if(c.done)return[b,L.empty()];b.push(c.value)}return[b,{[Symbol.iterator](){return i}}]}L.consume=l;function r(g,o,b=(i,t)=>i===t){const i=g[Symbol.iterator](),t=o[Symbol.iterator]();for(;;){const c=i.next(),d=t.next();if(c.done!==d.done)return!1;if(c.done)return!0;if(!b(c.value,d.value))return!1}}L.equals=r})(m=e.Iterable||(e.Iterable={}))}),define(me[58],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function n(o,b=!1){let i=0,t=o.length,c="",d=0,s=16,h=0;function u(z){let M=0,W=0;for(;M<z;){const U=o.charCodeAt(i);if(U>=48&&U<=57)W=W*16+U-48;else if(U>=65&&U<=70)W=W*16+U-65+10;else if(U>=97&&U<=102)W=W*16+U-97+10;else break;i++,M++}return M<z&&(W=-1),W}function E(z){i=z,c="",d=0,s=16,h=0}function A(){const z=i;if(o.charCodeAt(i)===48)i++;else for(i++;i<o.length&&y(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===46)if(i++,i<o.length&&y(o.charCodeAt(i)))for(i++;i<o.length&&y(o.charCodeAt(i));)i++;else return h=3,o.substring(z,i);let M=i;if(i<o.length&&(o.charCodeAt(i)===69||o.charCodeAt(i)===101))if(i++,(i<o.length&&o.charCodeAt(i)===43||o.charCodeAt(i)===45)&&i++,i<o.length&&y(o.charCodeAt(i))){for(i++;i<o.length&&y(o.charCodeAt(i));)i++;M=i}else h=3;return o.substring(z,M)}function R(){let z="",M=i;for(;;){if(i>=t){z+=o.substring(M,i),h=2;break}const W=o.charCodeAt(i);if(W===34){z+=o.substring(M,i),i++;break}if(W===92){if(z+=o.substring(M,i),i++,i>=t){h=2;break}switch(o.charCodeAt(i++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const x=u(4);x>=0?z+=String.fromCharCode(x):h=4;break;default:h=5}M=i;continue}if(W>=0&&W<=31)if(S(W)){z+=o.substring(M,i),h=2;break}else h=6;i++}return z}function $(){if(c="",h=0,d=i,i>=t)return d=t,s=17;let z=o.charCodeAt(i);if(k(z)){do i++,c+=String.fromCharCode(z),z=o.charCodeAt(i);while(k(z));return s=15}if(S(z))return i++,c+=String.fromCharCode(z),z===13&&o.charCodeAt(i)===10&&(i++,c+=`
`),s=14;switch(z){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,c=R(),s=10;case 47:const M=i-1;if(o.charCodeAt(i+1)===47){for(i+=2;i<t&&!S(o.charCodeAt(i));)i++;return c=o.substring(M,i),s=12}if(o.charCodeAt(i+1)===42){i+=2;const W=t-1;let U=!1;for(;i<W;){if(o.charCodeAt(i)===42&&o.charCodeAt(i+1)===47){i+=2,U=!0;break}i++}return U||(i++,h=1),c=o.substring(M,i),s=13}return c+=String.fromCharCode(z),i++,s=16;case 45:if(c+=String.fromCharCode(z),i++,i===t||!y(o.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=A(),s=11;default:for(;i<t&&N(z);)i++,z=o.charCodeAt(i);if(d!==i){switch(c=o.substring(d,i),c){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return c+=String.fromCharCode(z),i++,s=16}}function N(z){if(k(z)||S(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let z;do z=$();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>i,scan:b?F:$,getToken:()=>s,getTokenValue:()=>c,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>h}}e.createScanner=n;function k(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function S(o){return o===10||o===13||o===8232||o===8233}function y(o){return o>=48&&o<=57}var T;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(T||(T={}));function I(o,b){const i=[],t=new Object;let c;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function h(u,E,A,R){d.value=u,d.offset=E,d.length=A,d.type=R,d.colonOffset=void 0,c=d}try{l(o,{onObjectBegin:(u,E)=>{if(b<=u)throw t;c=void 0,s=b>u,i.push("")},onObjectProperty:(u,E,A)=>{if(b<E||(h(u,E,A,"property"),i[i.length-1]=u,b<=E+A))throw t},onObjectEnd:(u,E)=>{if(b<=u)throw t;c=void 0,i.pop()},onArrayBegin:(u,E)=>{if(b<=u)throw t;c=void 0,i.push(0)},onArrayEnd:(u,E)=>{if(b<=u)throw t;c=void 0,i.pop()},onLiteralValue:(u,E,A)=>{if(b<E||(h(u,E,A,g(u)),b<=E+A))throw t},onSeparator:(u,E,A)=>{if(b<=E)throw t;if(u===":"&&c&&c.type==="property")c.colonOffset=E,s=!1,c=void 0;else if(u===","){const R=i[i.length-1];typeof R=="number"?i[i.length-1]=R+1:(s=!0,i[i.length-1]=""),c=void 0}}})}catch(u){if(u!==t)throw u}return{path:i,previousNode:c,isAtPropertyKey:s,matches:u=>{let E=0;for(let A=0;E<u.length&&A<i.length;A++)if(u[E]===i[A]||u[E]==="*")E++;else if(u[E]!=="**")return!1;return E===u.length}}}e.getLocation=I;function a(o,b=[],i=C.DEFAULT){let t=null,c=[];const d=[];function s(u){Array.isArray(c)?c.push(u):t!==null&&(c[t]=u)}return l(o,{onObjectBegin:()=>{const u={};s(u),d.push(c),c=u,t=null},onObjectProperty:u=>{t=u},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const u=[];s(u),d.push(c),c=u,t=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:s,onError:(u,E,A)=>{b.push({error:u,offset:E,length:A})}},i),c[0]}e.parse=a;function w(o,b=[],i=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(u){t.type==="property"&&(t.length=u-t.offset,t=t.parent)}function d(u){return t.children.push(u),u}l(o,{onObjectBegin:u=>{t=d({type:"object",offset:u,length:-1,parent:t,children:[]})},onObjectProperty:(u,E,A)=>{t=d({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:u,offset:E,length:A,parent:t})},onObjectEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,c(u+E)},onArrayBegin:(u,E)=>{t=d({type:"array",offset:u,length:-1,parent:t,children:[]})},onArrayEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,c(u+E)},onLiteralValue:(u,E,A)=>{d({type:g(u),offset:E,length:A,parent:t,value:u}),c(E+A)},onSeparator:(u,E,A)=>{t.type==="property"&&(u===":"?t.colonOffset=E:u===","&&c(E))},onError:(u,E,A)=>{b.push({error:u,offset:E,length:A})}},i);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=w;function f(o,b){if(!o)return;let i=o;for(let t of b)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===t){i=d.children[1],c=!0;break}if(!c)return}else{const c=t;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=f;function v(o){if(!o.parent||!o.parent.children)return[];const b=v(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;b.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&b.push(i)}return b}e.getNodePath=v;function _(o){switch(o.type){case"array":return o.children.map(_);case"object":const b=Object.create(null);for(let i of o.children){const t=i.children[1];t&&(b[i.children[0].value]=_(t))}return b;case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=_;function P(o,b,i=!1){return b>=o.offset&&b<o.offset+o.length||i&&b===o.offset+o.length}e.contains=P;function p(o,b,i=!1){if(P(o,b,i)){const t=o.children;if(Array.isArray(t))for(let c=0;c<t.length&&t[c].offset<=b;c++){const d=p(t[c],b,i);if(d)return d}return o}}e.findNodeAtOffset=p;function l(o,b,i=C.DEFAULT){const t=n(o,!1);function c(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function d(K){return K?he=>K(he,t.getTokenOffset(),t.getTokenLength()):()=>!0}const s=c(b.onObjectBegin),h=d(b.onObjectProperty),u=c(b.onObjectEnd),E=c(b.onArrayBegin),A=c(b.onArrayEnd),R=d(b.onLiteralValue),$=d(b.onSeparator),N=c(b.onComment),F=d(b.onError),z=i&&i.disallowComments,M=i&&i.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:z||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(K){case 12:case 13:z?U(10):N();break;case 16:U(1);break;case 15:case 14:break;default:return K}}}function U(K,he=[],Ee=[]){if(F(K),he.length+Ee.length>0){let De=t.getToken();for(;De!==17;){if(he.indexOf(De)!==-1){W();break}else if(Ee.indexOf(De)!==-1)break;De=W()}}}function x(K){const he=t.getTokenValue();return K?R(he):h(he),W(),!0}function B(){switch(t.getToken()){case 11:let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(U(2),K=0)}catch(he){U(2)}R(K);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return W(),!0}function O(){return t.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),t.getToken()===6?($(":"),W(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function H(){s(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||U(4,[],[]),$(","),W(),t.getToken()===2&&M)break}else K&&U(6,[],[]);O()||U(4,[],[2,5]),K=!0}return u(),t.getToken()!==2?U(7,[2],[]):W(),!0}function j(){E(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||U(4,[],[]),$(","),W(),t.getToken()===4&&M)break}else K&&U(6,[],[]);X()||U(4,[],[4,5]),K=!0}return A(),t.getToken()!==4?U(8,[4],[]):W(),!0}function X(){switch(t.getToken()){case 3:return j();case 1:return H();case 10:return x(!0);default:return B()}}return W(),t.getToken()===17?i.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(t.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=l;function r(o,b){let i=n(o),t=[],c,d=0,s;do switch(s=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:d!==s&&t.push(o.substring(d,s)),b!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,b)),d=i.getPosition();break}while(c!==17);return t.join("")}e.stripComments=r;function g(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(me[138],ge([0,1,58]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,y,T){let I,a,w,f,v;if(y){for(f=y.offset,v=f+y.length,w=f;w>0&&!k(S,w-1);)w--;let d=v;for(;d<S.length&&!k(S,d);)d++;a=S.substring(w,d),I=C(a,T)}else a=S,I=0,w=0,f=0,v=S.length;const _=n(T,S);let P=!1,p=0,l;T.insertSpaces?l=D(" ",T.tabSize||4):l="	";const r=(0,m.createScanner)(a,!1);let g=!1;function o(){return _+D(l,I+p)}function b(){let d=r.scan();for(P=!1;d===15||d===14;)P=P||d===14,d=r.scan();return g=d===16||r.getTokenError()!==0,d}const i=[];function t(d,s,h){!g&&s<v&&h>f&&S.substring(s,h)!==d&&i.push({offset:s,length:h-s,content:d})}let c=b();if(c!==17){const d=r.getTokenOffset()+w,s=D(l,I);t(s,w,d)}for(;c!==17;){let d=r.getTokenOffset()+r.getTokenLength()+w,s=b(),h="";for(;!P&&(s===12||s===13);){const E=r.getTokenOffset()+w;t(" ",d,E),d=r.getTokenOffset()+r.getTokenLength()+w,h=s===12?o():"",s=b()}if(s===2)c!==1&&(p--,h=o());else if(s===4)c!==3&&(p--,h=o());else{switch(c){case 3:case 1:p++,h=o();break;case 5:case 12:h=o();break;case 13:P?h=o():h=" ";break;case 6:h=" ";break;case 10:if(s===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:s===12||s===13?h=" ":s!==5&&s!==17&&(g=!0);break;case 16:g=!0;break}P&&(s===12||s===13)&&(h=o())}const u=r.getTokenOffset()+w;t(h,d,u),c=s}return i}e.format=L;function D(S,y){let T="";for(let I=0;I<y;I++)T+=S;return T}function C(S,y){let T=0,I=0;const a=y.tabSize||4;for(;T<S.length;){const w=S.charAt(T);if(w===" ")I++;else if(w==="	")I+=a;else break;T++}return Math.floor(I/a)}function n(S,y){for(let T=0;T<y.length;T++){const I=y.charAt(T);if(I==="\r")return T+1<y.length&&y.charAt(T+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=n;function k(S,y){return`\r
`.indexOf(S.charAt(y))!==-1}e.isEOL=k}),define(me[139],ge([0,1,58,138]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(y,T,I){return C(y,T,void 0,I)}e.removeProperty=D;function C(y,T,I,a,w){const f=T.slice(),v=[],_=(0,m.parseTree)(y,v);let P,p;for(;f.length>0&&(p=f.pop(),P=(0,m.findNodeAtLocation)(_,f),P===void 0&&I!==void 0);)typeof p=="string"?I={[p]:I}:I=[I];if(P)if(P.type==="object"&&typeof p=="string"&&Array.isArray(P.children)){const l=(0,m.findNodeAtLocation)(P,[p]);if(l!==void 0)if(I===void 0){if(!l.parent)throw new Error("Malformed AST");const r=P.children.indexOf(l.parent);let g,o=l.parent.offset+l.parent.length;if(r>0){const b=P.children[r-1];g=b.offset+b.length}else g=P.offset+1,P.children.length>1&&(o=P.children[1].offset);return n(y,{offset:g,length:o-g,content:""},a)}else return n(y,{offset:l.offset,length:l.length,content:JSON.stringify(I)},a);else{if(I===void 0)return[];const r=`${JSON.stringify(p)}: ${JSON.stringify(I)}`,g=w?w(P.children.map(b=>b.children[0].value)):P.children.length;let o;if(g>0){const b=P.children[g-1];o={offset:b.offset+b.length,length:0,content:","+r}}else P.children.length===0?o={offset:P.offset+1,length:0,content:r}:o={offset:P.offset+1,length:0,content:r+","};return n(y,o,a)}}else if(P.type==="array"&&typeof p=="number"&&Array.isArray(P.children))if(I!==void 0){const l=`${JSON.stringify(I)}`;let r;if(P.children.length===0||p===0)r={offset:P.offset+1,length:0,content:P.children.length===0?l:l+","};else{const g=p===-1||p>P.children.length?P.children.length:p,o=P.children[g-1];r={offset:o.offset+o.length,length:0,content:","+l}}return n(y,r,a)}else{const l=p,r=P.children[l];let g;if(P.children.length===1)g={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===l){const o=P.children[l-1],b=o.offset+o.length,i=P.offset+P.length;g={offset:b,length:i-2-b,content:""}}else g={offset:r.offset,length:P.children[l+1].offset-r.offset,content:""};return n(y,g,a)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${P.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return n(y,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},a)}}e.setProperty=C;function n(y,T,I){let a=k(y,T),w=T.offset,f=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;w>0&&!(0,L.isEOL)(a,w-1);)w--;for(;f<a.length&&!(0,L.isEOL)(a,f);)f++}const v=(0,L.format)(a,{offset:w,length:f-w},I);for(let P=v.length-1;P>=0;P--){const p=v[P];a=k(a,p),w=Math.min(w,p.offset),f=Math.max(f,p.offset+p.length),f+=p.content.length-p.length}const _=y.length-(a.length-f)-w;return[{offset:w,length:_,content:a.substring(w,f)}]}e.withFormatting=n;function k(y,T){return y.substring(0,T.offset)+T.content+y.substring(T.offset+T.length)}e.applyEdit=k;function S(y,T){let I=T.slice(0).sort((w,f)=>{const v=w.offset-f.offset;return v===0?w.length-f.length:v}),a=y.length;for(let w=I.length-1;w>=0;w--){let f=I[w];if(f.offset+f.length<=a)y=k(y,f);else throw new Error("Overlapping edit");a=f.offset}return y}e.applyEdits=S}),define(me[140],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new m(()=>D(this.getValue()))}}e.Lazy=m}),define(me[6],ge([0,1,74,76]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function n(t){C=t}if(e.setDisposableTracker=n,D){const t="__is_disposable_tracked__";n(new class{trackDisposable(c){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[t]||console.log(d)},3e3)}setParent(c,d){if(c&&c!==p.None)try{c[t]=!0}catch{}}markAsDisposed(c){if(c&&c!==p.None)try{c[t]=!0}catch{}}markAsSingleton(c){}})}function k(t){return C?.trackDisposable(t),t}function S(t){C?.markAsDisposed(t)}function y(t,c){C?.setParent(t,c)}function T(t,c){if(!!C)for(const d of t)C.setParent(d,c)}function I(t){return C?.markAsSingleton(t),t}e.markAsSingleton=I;class a extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=a;function w(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=w;function f(t){if(L.Iterable.is(t)){let c=[];for(const d of t)if(d)try{d.dispose()}catch(s){c.push(s)}if(c.length===1)throw c[0];if(c.length>1)throw new a(c);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=f;function v(...t){const c=_(()=>f(t));return T(t,c),c}e.combinedDisposable=v;function _(t){const c=k({dispose:(0,m.once)(()=>{S(c),t()})});return c}e.toDisposable=_;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return y(c,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new P,k(this),y(this._store,this)}dispose(){S(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&y(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&y(c,null),c}}e.MutableDisposable=l;class r{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class g{constructor(){this.references=new Map}acquire(c,...d){let s=this.references.get(c);s||(s={counter:0,object:this.createReferencedObject(c,...d)},this.references.set(c,s));const{object:h}=s,u=(0,m.once)(()=>{--s.counter==0&&(this.destroyReferencedObject(c,s.object),this.references.delete(c))});return s.counter++,{object:h,dispose:u}}}e.ReferenceCollection=g;class o{constructor(c){this.referenceCollection=c}async acquire(c,...d){const s=this.referenceCollection.acquire(c,...d);try{return{object:await s.object,dispose:()=>s.dispose()}}catch(h){throw s.dispose(),h}}}e.AsyncReferenceCollection=o;class b{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=b;function i(t){const c=new P;try{t(c)}finally{c.dispose()}}e.disposeOnReturn=i}),define(me[94],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const n=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=n}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,n){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(n){const y=this._last;this._last=k,k.prev=y,y.next=k}else{const y=this._first;this._first=k,k.next=y,y.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const n=C.prev;n.next=C.next,C.next.prev=n}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Te,Ce){for(var we=0;we<Ce.length;we++){var oe=Ce[we];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Te,oe.key,oe)}}function e(Te,Ce,we){return Ce&&Y(Te.prototype,Ce),we&&Y(Te,we),Te}function m(Te,Ce){if(!!Te){if(typeof Te=="string")return L(Te,Ce);var we=Object.prototype.toString.call(Te).slice(8,-1);if(we==="Object"&&Te.constructor&&(we=Te.constructor.name),we==="Map"||we==="Set")return Array.from(Te);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return L(Te,Ce)}}function L(Te,Ce){(Ce==null||Ce>Te.length)&&(Ce=Te.length);for(var we=0,oe=new Array(Ce);we<Ce;we++)oe[we]=Te[we];return oe}function D(Te,Ce){var we=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(we)return(we=we.call(Te)).next.bind(we);if(Array.isArray(Te)||(we=m(Te))||Ce&&Te&&typeof Te.length=="number"){we&&(Te=we);var oe=0;return function(){return oe>=Te.length?{done:!0}:{done:!1,value:Te[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function n(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Te){C.exports.defaults=Te}C.exports={defaults:n(),getDefaults:n,changeDefaults:k};var S=/[&<>"']/,y=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(Ce){return a[Ce]};function f(Te,Ce){if(Ce){if(S.test(Te))return Te.replace(y,w)}else if(T.test(Te))return Te.replace(I,w);return Te}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Te){return Te.replace(v,function(Ce,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var P=/(^|[^\[])\^/g;function p(Te,Ce){Te=Te.source||Te,Ce=Ce||"";var we={replace:function(ue,pe){return pe=pe.source||pe,pe=pe.replace(P,"$1"),Te=Te.replace(ue,pe),we},getRegex:function(){return new RegExp(Te,Ce)}};return we}var l=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Te,Ce,we){if(Te){var oe;try{oe=decodeURIComponent(_(we)).replace(l,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Ce&&!r.test(we)&&(we=c(Ce,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch(ue){return null}return we}var o={},b=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Te,Ce){o[" "+Te]||(b.test(Te)?o[" "+Te]=Te+"/":o[" "+Te]=u(Te,"/",!0)),Te=o[" "+Te];var we=Te.indexOf(":")===-1;return Ce.substring(0,2)==="//"?we?Ce:Te.replace(i,"$1")+Ce:Ce.charAt(0)==="/"?we?Ce:Te.replace(t,"$1")+Ce:Te+Ce}var d={exec:function(){}};function s(Te){for(var Ce=1,we,oe;Ce<arguments.length;Ce++){we=arguments[Ce];for(oe in we)Object.prototype.hasOwnProperty.call(we,oe)&&(Te[oe]=we[oe])}return Te}function h(Te,Ce){var we=Te.replace(/\|/g,function(pe,be,Fe){for(var Qe=!1,xe=be;--xe>=0&&Fe[xe]==="\\";)Qe=!Qe;return Qe?"|":" |"}),oe=we.split(/ \|/),ue=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>Ce)oe.splice(Ce);else for(;oe.length<Ce;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function u(Te,Ce,we){var oe=Te.length;if(oe===0)return"";for(var ue=0;ue<oe;){var pe=Te.charAt(oe-ue-1);if(pe===Ce&&!we)ue++;else if(pe!==Ce&&we)ue++;else break}return Te.substr(0,oe-ue)}function E(Te,Ce){if(Te.indexOf(Ce[1])===-1)return-1;for(var we=Te.length,oe=0,ue=0;ue<we;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===Ce[0])oe++;else if(Te[ue]===Ce[1]&&(oe--,oe<0))return ue;return-1}function A(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Te,Ce){if(Ce<1)return"";for(var we="";Ce>1;)Ce&1&&(we+=Te),Ce>>=1,Te+=Te;return we+Te}var $={escape:f,unescape:_,edit:p,cleanUrl:g,resolveUrl:c,noopTest:d,merge:s,splitCells:h,rtrim:u,findClosingBracket:E,checkSanitizeDeprecation:A,repeatString:R},N=C.exports.defaults,F=$.rtrim,z=$.splitCells,M=$.escape,W=$.findClosingBracket;function U(Te,Ce,we,oe){var ue=Ce.href,pe=Ce.title?M(Ce.title):null,be=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){oe.state.inLink=!0;var Fe={type:"link",raw:we,href:ue,title:pe,text:be,tokens:oe.inlineTokens(be,[])};return oe.state.inLink=!1,Fe}else return{type:"image",raw:we,href:ue,title:pe,text:M(be)}}function x(Te,Ce){var we=Te.match(/^(\s+)(?:```)/);if(we===null)return Ce;var oe=we[1];return Ce.split(`
`).map(function(ue){var pe=ue.match(/^\s+/);if(pe===null)return ue;var be=pe[0];return be.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var B=function(){function Te(we){this.options=we||N}var Ce=Te.prototype;return Ce.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Ce.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var pe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:F(pe,`
`)}}},Ce.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var pe=ue[0],be=x(pe,ue[3]||"");return{type:"code",raw:pe,lang:ue[2]?ue[2].trim():ue[2],text:be}}},Ce.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var pe=ue[2].trim();if(/#$/.test(pe)){var be=F(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:pe,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},Ce.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},Ce.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var pe=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},Ce.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var pe,be,Fe,Qe,xe,Xe,at,ct,le,_e,ae=ue[1].trim(),Q=ae.length>1,ye={type:"list",raw:"",ordered:Q,start:Q?+ae.slice(0,-1):"",loose:!1,items:[]};ae=Q?"\\d{1,9}\\"+ae.slice(-1):"\\"+ae,this.options.pedantic&&(ae=Q?ae:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ae+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(ue=Le.exec(oe)));){le=ue[2].split(`
`),this.options.pedantic?(Qe=2,_e=le[0].trimLeft()):(Qe=ue[2].search(/[^ ]/),Qe=ue[1].length+(Qe>4?1:Qe),_e=le[0].slice(Qe-ue[1].length)),Xe=!1,pe=ue[0],!le[0]&&/^ *$/.test(le[1])&&(pe=ue[1]+le.slice(0,2).join(`
`)+`
`,ye.loose=!0,le=[]);var et=new RegExp("^ {0,"+Math.min(3,Qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(xe=1;xe<le.length;xe++){if(ct=le[xe],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),et.test(ct)){pe=ue[1]+le.slice(0,xe).join(`
`)+`
`;break}if(!Xe){ct.trim()||(Xe=!0),ct.search(/[^ ]/)>=Qe?_e+=`
`+ct.slice(Qe):_e+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Qe||!ct.trim()){_e+=`
`+ct.slice(Qe);continue}else{pe=ue[1]+le.slice(0,xe).join(`
`)+`
`;break}}ye.loose||(at?ye.loose=!0:/\n *\n *$/.test(pe)&&(at=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(_e),be&&(Fe=be[0]!=="[ ] ",_e=_e.replace(/^\[[ xX]\] +/,""))),ye.items.push({type:"list_item",raw:pe,task:!!be,checked:Fe,loose:!1,text:_e}),ye.raw+=pe,oe=oe.slice(pe.length)}ye.items[ye.items.length-1].raw=pe.trimRight(),ye.items[ye.items.length-1].text=_e.trimRight(),ye.raw=ye.raw.trimRight();var qe=ye.items.length;for(xe=0;xe<qe;xe++)this.lexer.state.top=!1,ye.items[xe].tokens=this.lexer.blockTokens(ye.items[xe].text,[]),ye.items[xe].tokens.some(function(mt){return mt.type==="space"})&&(ye.loose=!0,ye.items[xe].loose=!0);return ye}},Ce.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue){var pe={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(pe.type="paragraph",pe.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),pe.tokens=[],this.lexer.inline(pe.text,pe.tokens)),pe}},Ce.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var pe=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ue[0],href:ue[2],title:ue[3]}}},Ce.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var pe={type:"table",header:z(ue[1]).map(function(at){return{text:at}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ue[0];var be=pe.align.length,Fe,Qe,xe,Xe;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(be=pe.rows.length,Fe=0;Fe<be;Fe++)pe.rows[Fe]=z(pe.rows[Fe],pe.header.length).map(function(at){return{text:at}});for(be=pe.header.length,Qe=0;Qe<be;Qe++)pe.header[Qe].tokens=[],this.lexer.inlineTokens(pe.header[Qe].text,pe.header[Qe].tokens);for(be=pe.rows.length,Qe=0;Qe<be;Qe++)for(Xe=pe.rows[Qe],xe=0;xe<Xe.length;xe++)Xe[xe].tokens=[],this.lexer.inlineTokens(Xe[xe].text,Xe[xe].tokens);return pe}}},Ce.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue){var pe={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Ce.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue){var pe={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Ce.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue){var pe={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Ce.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},Ce.tag=function(oe){var ue=this.rules.inline.tag.exec(oe);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},Ce.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var pe=ue[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=F(pe.slice(0,-1),"\\");if((pe.length-be.length)%2==0)return}else{var Fe=W(ue[2],"()");if(Fe>-1){var Qe=ue[0].indexOf("!")===0?5:4,xe=Qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,xe).trim(),ue[3]=""}}var Xe=ue[2],at="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Xe);ct&&(Xe=ct[1],at=ct[3])}else at=ue[3]?ue[3].slice(1,-1):"";return Xe=Xe.trim(),/^</.test(Xe)&&(this.options.pedantic&&!/>$/.test(pe)?Xe=Xe.slice(1):Xe=Xe.slice(1,-1)),U(ue,{href:Xe&&Xe.replace(this.rules.inline._escapes,"$1"),title:at&&at.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Ce.reflink=function(oe,ue){var pe;if((pe=this.rules.inline.reflink.exec(oe))||(pe=this.rules.inline.nolink.exec(oe))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ue[be.toLowerCase()],!be||!be.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(pe,be,pe[0],this.lexer)}},Ce.emStrong=function(oe,ue,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(oe);if(!!be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Qe=be[0].length-1,xe,Xe,at=Qe,ct=0,le=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,ue=ue.slice(-1*oe.length+Qe);(be=le.exec(ue))!=null;)if(xe=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!xe){if(Xe=xe.length,be[3]||be[4]){at+=Xe;continue}else if((be[5]||be[6])&&Qe%3&&!((Qe+Xe)%3)){ct+=Xe;continue}if(at-=Xe,!(at>0)){if(Xe=Math.min(Xe,Xe+at+ct),Math.min(Qe,Xe)%2){var _e=oe.slice(1,Qe+be.index+Xe);return{type:"em",raw:oe.slice(0,Qe+be.index+Xe+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}var ae=oe.slice(2,Qe+be.index+Xe-1);return{type:"strong",raw:oe.slice(0,Qe+be.index+Xe+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}}}}},Ce.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var pe=ue[2].replace(/\n/g," "),be=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return be&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=M(pe,!0),{type:"codespan",raw:ue[0],text:pe}}},Ce.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},Ce.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Ce.autolink=function(oe,ue){var pe=this.rules.inline.autolink.exec(oe);if(pe){var be,Fe;return pe[2]==="@"?(be=M(this.options.mangle?ue(pe[1]):pe[1]),Fe="mailto:"+be):(be=M(pe[1]),Fe=be),{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},Ce.url=function(oe,ue){var pe;if(pe=this.rules.inline.url.exec(oe)){var be,Fe;if(pe[2]==="@")be=M(this.options.mangle?ue(pe[0]):pe[0]),Fe="mailto:"+be;else{var Qe;do Qe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Qe!==pe[0]);be=M(pe[0]),pe[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},Ce.inlineText=function(oe,ue){var pe=this.rules.inline.text.exec(oe);if(pe){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):M(pe[0]):pe[0]:be=M(this.options.smartypants?ue(pe[0]):pe[0]),{type:"text",raw:pe[0],text:be}}},Te}(),O=$.noopTest,H=$.edit,j=$.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=H(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=H(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=H(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=H(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=H(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=H(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=j({},X),X.gfm=j({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=H(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=j({},X.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:H(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=H(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=H(X._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=H(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=H(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=H(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=H(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=H(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=H(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=H(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=H(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=j({},K),K.pedantic=j({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=j({},K.normal,{escape:H(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=H(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=j({},K.gfm,{br:H(K.br).replace("{2,}","*").getRegex(),text:H(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:X,inline:K},Ee=B,De=C.exports.defaults,Pe=he.block,Be=he.inline,He=$.repeatString;function ze(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Te){var Ce="",we,oe,ue=Te.length;for(we=0;we<ue;we++)oe=Te.charCodeAt(we),Math.random()>.5&&(oe="x"+oe.toString(16)),Ce+="&#"+oe+";";return Ce}var Z=function(){function Te(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||De,this.options.tokenizer=this.options.tokenizer||new Ee,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:Pe.normal,inline:Be.normal};this.options.pedantic?(oe.block=Pe.pedantic,oe.inline=Be.pedantic):this.options.gfm&&(oe.block=Pe.gfm,this.options.breaks?oe.inline=Be.breaks:oe.inline=Be.gfm),this.tokenizer.rules=oe}Te.lex=function(oe,ue){var pe=new Te(ue);return pe.lex(oe)},Te.lexInline=function(oe,ue){var pe=new Te(ue);return pe.inlineTokens(oe)};var Ce=Te.prototype;return Ce.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Ce.blockTokens=function(oe,ue){var pe=this;ue===void 0&&(ue=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var be,Fe,Qe,xe;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(at){return(be=at.call({lexer:pe},oe,ue))?(oe=oe.substring(be.raw.length),ue.push(be),!0):!1}))){if(be=this.tokenizer.space(oe)){oe=oe.substring(be.raw.length),be.type&&ue.push(be);continue}if(be=this.tokenizer.code(oe)){oe=oe.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(be);continue}if(be=this.tokenizer.fences(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.heading(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.hr(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.blockquote(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.list(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.html(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.def(oe)){oe=oe.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.lheading(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(Qe=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var at=Infinity,ct=oe.slice(1),le=void 0;pe.options.extensions.startBlock.forEach(function(_e){le=_e.call({lexer:this},ct),typeof le=="number"&&le>=0&&(at=Math.min(at,le))}),at<Infinity&&at>=0&&(Qe=oe.substring(0,at+1))}(),this.state.top&&(be=this.tokenizer.paragraph(Qe))){Fe=ue[ue.length-1],xe&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(be),xe=Qe.length!==oe.length,oe=oe.substring(be.raw.length);continue}if(be=this.tokenizer.text(oe)){oe=oe.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(be);continue}if(oe){var Xe="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Xe);break}else throw new Error(Xe)}}return this.state.top=!0,ue},Ce.inline=function(oe,ue){this.inlineQueue.push({src:oe,tokens:ue})},Ce.inlineTokens=function(oe,ue){var pe=this;ue===void 0&&(ue=[]);var be,Fe,Qe,xe=oe,Xe,at,ct;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(Xe=this.tokenizer.rules.inline.reflinkSearch.exec(xe))!=null;)le.includes(Xe[0].slice(Xe[0].lastIndexOf("[")+1,-1))&&(xe=xe.slice(0,Xe.index)+"["+He("a",Xe[0].length-2)+"]"+xe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Xe=this.tokenizer.rules.inline.blockSkip.exec(xe))!=null;)xe=xe.slice(0,Xe.index)+"["+He("a",Xe[0].length-2)+"]"+xe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Xe=this.tokenizer.rules.inline.escapedEmSt.exec(xe))!=null;)xe=xe.slice(0,Xe.index)+"++"+xe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(at||(ct=""),at=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(be=ae.call({lexer:pe},oe,ue))?(oe=oe.substring(be.raw.length),ue.push(be),!0):!1}))){if(be=this.tokenizer.escape(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.tag(oe)){oe=oe.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ue.push(be);continue}if(be=this.tokenizer.link(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ue.push(be);continue}if(be=this.tokenizer.emStrong(oe,xe,ct)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.codespan(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.br(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.del(oe)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.autolink(oe,G)){oe=oe.substring(be.raw.length),ue.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(oe,G))){oe=oe.substring(be.raw.length),ue.push(be);continue}if(Qe=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=Infinity,Q=oe.slice(1),ye=void 0;pe.options.extensions.startInline.forEach(function(Le){ye=Le.call({lexer:this},Q),typeof ye=="number"&&ye>=0&&(ae=Math.min(ae,ye))}),ae<Infinity&&ae>=0&&(Qe=oe.substring(0,ae+1))}(),be=this.tokenizer.inlineText(Qe,ze)){oe=oe.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(ct=be.raw.slice(-1)),at=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ue.push(be);continue}if(oe){var _e="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(_e);break}else throw new Error(_e)}}return ue},e(Te,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Te}(),ne=C.exports.defaults,ce=$.cleanUrl,J=$.escape,te=function(){function Te(we){this.options=we||ne}var Ce=Te.prototype;return Ce.code=function(oe,ue,pe){var be=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(oe,be);Fe!=null&&Fe!==oe&&(pe=!0,oe=Fe)}return oe=oe.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+J(be,!0)+'">'+(pe?oe:J(oe,!0))+`</code></pre>
`:"<pre><code>"+(pe?oe:J(oe,!0))+`</code></pre>
`},Ce.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Ce.html=function(oe){return oe},Ce.heading=function(oe,ue,pe,be){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+be.slug(pe)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(oe,ue,pe){var be=ue?"ol":"ul",Fe=ue&&pe!==1?' start="'+pe+'"':"";return"<"+be+Fe+`>
`+oe+"</"+be+`>
`},Ce.listitem=function(oe){return"<li>"+oe+`</li>
`},Ce.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(oe){return"<p>"+oe+`</p>
`},Ce.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},Ce.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Ce.tablecell=function(oe,ue){var pe=ue.header?"th":"td",be=ue.align?"<"+pe+' align="'+ue.align+'">':"<"+pe+">";return be+oe+"</"+pe+`>
`},Ce.strong=function(oe){return"<strong>"+oe+"</strong>"},Ce.em=function(oe){return"<em>"+oe+"</em>"},Ce.codespan=function(oe){return"<code>"+oe+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(oe){return"<del>"+oe+"</del>"},Ce.link=function(oe,ue,pe){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return pe;var be='<a href="'+J(oe)+'"';return ue&&(be+=' title="'+ue+'"'),be+=">"+pe+"</a>",be},Ce.image=function(oe,ue,pe){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return pe;var be='<img src="'+oe+'" alt="'+pe+'"';return ue&&(be+=' title="'+ue+'"'),be+=this.options.xhtml?"/>":">",be},Ce.text=function(oe){return oe},Te}(),ve=function(){function Te(){}var Ce=Te.prototype;return Ce.strong=function(oe){return oe},Ce.em=function(oe){return oe},Ce.codespan=function(oe){return oe},Ce.del=function(oe){return oe},Ce.html=function(oe){return oe},Ce.text=function(oe){return oe},Ce.link=function(oe,ue,pe){return""+pe},Ce.image=function(oe,ue,pe){return""+pe},Ce.br=function(){return""},Te}(),Me=function(){function Te(){this.seen={}}var Ce=Te.prototype;return Ce.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(oe,ue){var pe=oe,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[oe];do be++,pe=oe+"-"+be;while(this.seen.hasOwnProperty(pe))}return ue||(this.seen[oe]=be,this.seen[pe]=0),pe},Ce.slug=function(oe,ue){ue===void 0&&(ue={});var pe=this.serialize(oe);return this.getNextSafeSlug(pe,ue.dryrun)},Te}(),je=te,Ke=ve,Ze=Me,rt=C.exports.defaults,ut=$.unescape,it=function(){function Te(we){this.options=we||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Te.parse=function(oe,ue){var pe=new Te(ue);return pe.parse(oe)},Te.parseInline=function(oe,ue){var pe=new Te(ue);return pe.parseInline(oe)};var Ce=Te.prototype;return Ce.parse=function(oe,ue){ue===void 0&&(ue=!0);var pe="",be,Fe,Qe,xe,Xe,at,ct,le,_e,ae,Q,ye,Le,et,qe,mt,_t,kt,bt,gt=oe.length;for(be=0;be<gt;be++){if(ae=oe[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(bt=this.options.extensions.renderers[ae.type].call({parser:this},ae),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){pe+=bt||"";continue}switch(ae.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,ut(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(le="",ct="",xe=ae.header.length,Fe=0;Fe<xe;Fe++)ct+=this.renderer.tablecell(this.parseInline(ae.header[Fe].tokens),{header:!0,align:ae.align[Fe]});for(le+=this.renderer.tablerow(ct),_e="",xe=ae.rows.length,Fe=0;Fe<xe;Fe++){for(at=ae.rows[Fe],ct="",Xe=at.length,Qe=0;Qe<Xe;Qe++)ct+=this.renderer.tablecell(this.parseInline(at[Qe].tokens),{header:!1,align:ae.align[Qe]});_e+=this.renderer.tablerow(ct)}pe+=this.renderer.table(le,_e);continue}case"blockquote":{_e=this.parse(ae.tokens),pe+=this.renderer.blockquote(_e);continue}case"list":{for(Q=ae.ordered,ye=ae.start,Le=ae.loose,xe=ae.items.length,_e="",Fe=0;Fe<xe;Fe++)qe=ae.items[Fe],mt=qe.checked,_t=qe.task,et="",qe.task&&(kt=this.renderer.checkbox(mt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=kt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=kt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:kt}):et+=kt),et+=this.parse(qe.tokens,Le),_e+=this.renderer.listitem(et,_t,mt);pe+=this.renderer.list(_e,Q,ye);continue}case"html":{pe+=this.renderer.html(ae.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(_e=ae.tokens?this.parseInline(ae.tokens):ae.text;be+1<gt&&oe[be+1].type==="text";)ae=oe[++be],_e+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);pe+=ue?this.renderer.paragraph(_e):_e;continue}default:{var Et='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Et);return}else throw new Error(Et)}}}return pe},Ce.parseInline=function(oe,ue){ue=ue||this.renderer;var pe="",be,Fe,Qe,xe=oe.length;for(be=0;be<xe;be++){if(Fe=oe[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=Qe||"";continue}switch(Fe.type){case"escape":{pe+=ue.text(Fe.text);break}case"html":{pe+=ue.html(Fe.text);break}case"link":{pe+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{pe+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{pe+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{pe+=ue.codespan(Fe.text);break}case"br":{pe+=ue.br();break}case"del":{pe+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{pe+=ue.text(Fe.text);break}default:{var Xe='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return pe},Te}(),st=Z,Ae=it,wt=B,ee=te,re=ve,Se=Me,Ge=$.merge,Ye=$.checkSanitizeDeprecation,nt=$.escape,de=C.exports.getDefaults,ke=C.exports.changeDefaults,Ue=C.exports.defaults;function $e(Te,Ce,we){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Ce=="function"&&(we=Ce,Ce=null),Ce=Ge({},$e.defaults,Ce||{}),Ye(Ce),we){var oe=Ce.highlight,ue;try{ue=st.lex(Te,Ce)}catch(Qe){return we(Qe)}var pe=function(xe){var Xe;if(!xe)try{Ce.walkTokens&&$e.walkTokens(ue,Ce.walkTokens),Xe=Ae.parse(ue,Ce)}catch(at){xe=at}return Ce.highlight=oe,xe?we(xe):we(null,Xe)};if(!oe||oe.length<3||(delete Ce.highlight,!ue.length))return pe();var be=0;$e.walkTokens(ue,function(Qe){Qe.type==="code"&&(be++,setTimeout(function(){oe(Qe.text,Qe.lang,function(xe,Xe){if(xe)return pe(xe);Xe!=null&&Xe!==Qe.text&&(Qe.text=Xe,Qe.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}try{var Fe=st.lex(Te,Ce);return Ce.walkTokens&&$e.walkTokens(Fe,Ce.walkTokens),Ae.parse(Fe,Ce)}catch(Qe){if(Qe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+nt(Qe.message+"",!0)+"</pre>";throw Qe}}$e.options=$e.setOptions=function(Te){return Ge($e.defaults,Te),ke($e.defaults),$e},$e.getDefaults=de,$e.defaults=Ue,$e.use=function(){for(var Te=this,Ce=arguments.length,we=new Array(Ce),oe=0;oe<Ce;oe++)we[oe]=arguments[oe];var ue=Ge.apply(void 0,[{}].concat(we)),pe=$e.defaults.extensions||{renderers:{},childTokens:{}},be;we.forEach(function(Fe){if(Fe.extensions&&(be=!0,Fe.extensions.forEach(function(xe){if(!xe.name)throw new Error("extension name required");if(xe.renderer){var Xe=pe.renderers?pe.renderers[xe.name]:null;Xe?pe.renderers[xe.name]=function(){for(var at=arguments.length,ct=new Array(at),le=0;le<at;le++)ct[le]=arguments[le];var _e=xe.renderer.apply(this,ct);return _e===!1&&(_e=Xe.apply(this,ct)),_e}:pe.renderers[xe.name]=xe.renderer}if(xe.tokenizer){if(!xe.level||xe.level!=="block"&&xe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");pe[xe.level]?pe[xe.level].unshift(xe.tokenizer):pe[xe.level]=[xe.tokenizer],xe.start&&(xe.level==="block"?pe.startBlock?pe.startBlock.push(xe.start):pe.startBlock=[xe.start]:xe.level==="inline"&&(pe.startInline?pe.startInline.push(xe.start):pe.startInline=[xe.start]))}xe.childTokens&&(pe.childTokens[xe.name]=xe.childTokens)})),Fe.renderer&&function(){var xe=$e.defaults.renderer||new ee,Xe=function(le){var _e=xe[le];xe[le]=function(){for(var ae=arguments.length,Q=new Array(ae),ye=0;ye<ae;ye++)Q[ye]=arguments[ye];var Le=Fe.renderer[le].apply(xe,Q);return Le===!1&&(Le=_e.apply(xe,Q)),Le}};for(var at in Fe.renderer)Xe(at);ue.renderer=xe}(),Fe.tokenizer&&function(){var xe=$e.defaults.tokenizer||new wt,Xe=function(le){var _e=xe[le];xe[le]=function(){for(var ae=arguments.length,Q=new Array(ae),ye=0;ye<ae;ye++)Q[ye]=arguments[ye];var Le=Fe.tokenizer[le].apply(xe,Q);return Le===!1&&(Le=_e.apply(xe,Q)),Le}};for(var at in Fe.tokenizer)Xe(at);ue.tokenizer=xe}(),Fe.walkTokens){var Qe=$e.defaults.walkTokens;ue.walkTokens=function(xe){Fe.walkTokens.call(Te,xe),Qe&&Qe(xe)}}be&&(ue.extensions=pe),$e.setOptions(ue)})},$e.walkTokens=function(Te,Ce){for(var we=function(){var be=ue.value;switch(Ce(be),be.type){case"table":{for(var Fe=D(be.header),Qe;!(Qe=Fe()).done;){var xe=Qe.value;$e.walkTokens(xe.tokens,Ce)}for(var Xe=D(be.rows),at;!(at=Xe()).done;)for(var ct=at.value,le=D(ct),_e;!(_e=le()).done;){var ae=_e.value;$e.walkTokens(ae.tokens,Ce)}break}case"list":{$e.walkTokens(be.items,Ce);break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[be.type]?$e.defaults.extensions.childTokens[be.type].forEach(function(Q){$e.walkTokens(be[Q],Ce)}):be.tokens&&$e.walkTokens(be.tokens,Ce)}},oe=D(Te),ue;!(ue=oe()).done;)we()},$e.parseInline=function(Te,Ce){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Ce=Ge({},$e.defaults,Ce||{}),Ye(Ce);try{var we=st.lexInline(Te,Ce);return Ce.walkTokens&&$e.walkTokens(we,Ce.walkTokens),Ae.parseInline(we,Ce)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+nt(oe.message+"",!0)+"</pre>";throw oe}},$e.Parser=Ae,$e.parser=Ae.parse,$e.Renderer=ee,$e.TextRenderer=re,$e.Lexer=st,$e.lexer=st.lex,$e.Tokenizer=wt,$e.Slugger=Se,$e.parse=$e;var tt=$e;return tt}),define(me[77],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(n,k,S){return Math.min(Math.max(n,k),S)}e.clamp=m;function L(n,k){return(k+n%k)%k}e.rot=L;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function n(S){C.push(S,Date.now())}function k(){const S=[];for(let y=0;y<C.length;y+=2)S.push({name:C[y],startTime:C[y+1]});return S}return{mark:n,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const n of performance.getEntriesByType("mark"))C.push({name:n.name,startTime:Math.round(D+n.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(me[11],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,D=!1,C=!1,n=!1,k=!1,S=!1,y=!1,T,I=m,a,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const v=typeof f?.versions?.electron=="string"&&f.type==="renderer";if(e.isElectronSandboxed=v&&f?.sandboxed,typeof navigator=="object"&&!v)w=navigator.userAgent,L=w.indexOf("Windows")>=0,D=w.indexOf("Macintosh")>=0,y=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=w.indexOf("Linux")>=0,S=!0,T=navigator.language,I=T;else if(typeof f=="object"){L=f.platform==="win32",D=f.platform==="darwin",C=f.platform==="linux",n=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,T=m,I=m;const i=f.env.VSCODE_NLS_CONFIG;if(i)try{const t=JSON.parse(i),c=t.availableLanguages["*"];T=t.locale,I=c||m,a=t._translationsConfigFile}catch(t){}k=!0}else console.error("Unable to resolve platform.");var _;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function P(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let p=0;D?p=1:L?p=3:C&&(p=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=n,e.isNative=k,e.isWeb=S,e.isIOS=y,e.platform=p,e.userAgent=w,e.language=I;var l;(function(i){function t(){return e.language}i.value=t;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function d(){return e.language==="en"}i.isDefault=d})(l=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=a,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let i=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let d=0,s=i.length;d<s;d++){const h=i[d];if(h.id===c.data.vscodeScheduleAsyncWork){i.splice(d,1),h.callback();return}}});let t=0;return c=>{const d=++t;i.push({id:d,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return i=>setTimeout(i)})(),e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts)return e.setTimeout0;if(typeof f?.nextTick=="function")return f.nextTick.bind(f);const t=Promise.resolve();return c=>t.then(c)}();var r;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||y?2:L?1:3;let g=!0,o=!1;function b(){if(!o){o=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,g=new Uint16Array(i.buffer)[0]===(2<<8)+1}return g}e.isLittleEndian=b}),define(me[40],ge([0,1,11]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const D=m.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(C){return(0,m.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,m.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[9],ge([0,1,40]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,C=90,n=122,k=46,S=47,y=92,T=58,I=63;class a extends Error{constructor(r,g,o){let b;typeof g=="string"&&g.indexOf("not ")===0?(b="must not be",g=g.replace(/^not /,"")):b="must be";const i=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${i} ${b} of type ${g}`;t+=`. Received type ${typeof o}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function w(l,r){if(typeof l!="string")throw new a(r,"string",l)}function f(l){return l===S||l===y}function v(l){return l===S}function _(l){return l>=L&&l<=C||l>=D&&l<=n}function P(l,r,g,o){let b="",i=0,t=-1,c=0,d=0;for(let s=0;s<=l.length;++s){if(s<l.length)d=l.charCodeAt(s);else{if(o(d))break;d=S}if(o(d)){if(!(t===s-1||c===1))if(c===2){if(b.length<2||i!==2||b.charCodeAt(b.length-1)!==k||b.charCodeAt(b.length-2)!==k){if(b.length>2){const h=b.lastIndexOf(g);h===-1?(b="",i=0):(b=b.slice(0,h),i=b.length-1-b.lastIndexOf(g)),t=s,c=0;continue}else if(b.length!==0){b="",i=0,t=s,c=0;continue}}r&&(b+=b.length>0?`${g}..`:"..",i=2)}else b.length>0?b+=`${g}${l.slice(t+1,s)}`:b=l.slice(t+1,s),i=s-t-1;t=s,c=0}else d===k&&c!==-1?++c:c=-1}return b}function p(l,r){if(r===null||typeof r!="object")throw new a("pathObject","Object",r);const g=r.dir||r.root,o=r.base||`${r.name||""}${r.ext||""}`;return g?g===r.root?`${g}${o}`:`${g}${l}${o}`:o}e.win32={resolve(...l){let r="",g="",o=!1;for(let b=l.length-1;b>=-1;b--){let i;if(b>=0){if(i=l[b],w(i,"path"),i.length===0)continue}else r.length===0?i=m.cwd():(i=m.env[`=${r}`]||m.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==r.toLowerCase()&&i.charCodeAt(2)===y)&&(i=`${r}\\`));const t=i.length;let c=0,d="",s=!1;const h=i.charCodeAt(0);if(t===1)f(h)&&(c=1,s=!0);else if(f(h))if(s=!0,f(i.charCodeAt(1))){let u=2,E=u;for(;u<t&&!f(i.charCodeAt(u));)u++;if(u<t&&u!==E){const A=i.slice(E,u);for(E=u;u<t&&f(i.charCodeAt(u));)u++;if(u<t&&u!==E){for(E=u;u<t&&!f(i.charCodeAt(u));)u++;(u===t||u!==E)&&(d=`\\\\${A}\\${i.slice(E,u)}`,c=u)}}}else c=1;else _(h)&&i.charCodeAt(1)===T&&(d=i.slice(0,2),c=2,t>2&&f(i.charCodeAt(2))&&(s=!0,c=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(o){if(r.length>0)break}else if(g=`${i.slice(c)}\\${g}`,o=s,s&&r.length>0)break}return g=P(g,!o,"\\",f),o?`${r}\\${g}`:`${r}${g}`||"."},normalize(l){w(l,"path");const r=l.length;if(r===0)return".";let g=0,o,b=!1;const i=l.charCodeAt(0);if(r===1)return v(i)?"\\":l;if(f(i))if(b=!0,f(l.charCodeAt(1))){let c=2,d=c;for(;c<r&&!f(l.charCodeAt(c));)c++;if(c<r&&c!==d){const s=l.slice(d,c);for(d=c;c<r&&f(l.charCodeAt(c));)c++;if(c<r&&c!==d){for(d=c;c<r&&!f(l.charCodeAt(c));)c++;if(c===r)return`\\\\${s}\\${l.slice(d)}\\`;c!==d&&(o=`\\\\${s}\\${l.slice(d,c)}`,g=c)}}}else g=1;else _(i)&&l.charCodeAt(1)===T&&(o=l.slice(0,2),g=2,r>2&&f(l.charCodeAt(2))&&(b=!0,g=3));let t=g<r?P(l.slice(g),!b,"\\",f):"";return t.length===0&&!b&&(t="."),t.length>0&&f(l.charCodeAt(r-1))&&(t+="\\"),o===void 0?b?`\\${t}`:t:b?`${o}\\${t}`:`${o}${t}`},isAbsolute(l){w(l,"path");const r=l.length;if(r===0)return!1;const g=l.charCodeAt(0);return f(g)||r>2&&_(g)&&l.charCodeAt(1)===T&&f(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let r,g;for(let i=0;i<l.length;++i){const t=l[i];w(t,"path"),t.length>0&&(r===void 0?r=g=t:r+=`\\${t}`)}if(r===void 0)return".";let o=!0,b=0;if(typeof g=="string"&&f(g.charCodeAt(0))){++b;const i=g.length;i>1&&f(g.charCodeAt(1))&&(++b,i>2&&(f(g.charCodeAt(2))?++b:o=!1))}if(o){for(;b<r.length&&f(r.charCodeAt(b));)b++;b>=2&&(r=`\\${r.slice(b)}`)}return e.win32.normalize(r)},relative(l,r){if(w(l,"from"),w(r,"to"),l===r)return"";const g=e.win32.resolve(l),o=e.win32.resolve(r);if(g===o||(l=g.toLowerCase(),r=o.toLowerCase(),l===r))return"";let b=0;for(;b<l.length&&l.charCodeAt(b)===y;)b++;let i=l.length;for(;i-1>b&&l.charCodeAt(i-1)===y;)i--;const t=i-b;let c=0;for(;c<r.length&&r.charCodeAt(c)===y;)c++;let d=r.length;for(;d-1>c&&r.charCodeAt(d-1)===y;)d--;const s=d-c,h=t<s?t:s;let u=-1,E=0;for(;E<h;E++){const R=l.charCodeAt(b+E);if(R!==r.charCodeAt(c+E))break;R===y&&(u=E)}if(E!==h){if(u===-1)return o}else{if(s>h){if(r.charCodeAt(c+E)===y)return o.slice(c+E+1);if(E===2)return o.slice(c+E)}t>h&&(l.charCodeAt(b+E)===y?u=E:E===2&&(u=3)),u===-1&&(u=0)}let A="";for(E=b+u+1;E<=i;++E)(E===i||l.charCodeAt(E)===y)&&(A+=A.length===0?"..":"\\..");return c+=u,A.length>0?`${A}${o.slice(c,d)}`:(o.charCodeAt(c)===y&&++c,o.slice(c,d))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const r=e.win32.resolve(l);if(r.length<=2)return l;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const g=r.charCodeAt(2);if(g!==I&&g!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(_(r.charCodeAt(0))&&r.charCodeAt(1)===T&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return l},dirname(l){w(l,"path");const r=l.length;if(r===0)return".";let g=-1,o=0;const b=l.charCodeAt(0);if(r===1)return f(b)?l:".";if(f(b)){if(g=o=1,f(l.charCodeAt(1))){let c=2,d=c;for(;c<r&&!f(l.charCodeAt(c));)c++;if(c<r&&c!==d){for(d=c;c<r&&f(l.charCodeAt(c));)c++;if(c<r&&c!==d){for(d=c;c<r&&!f(l.charCodeAt(c));)c++;if(c===r)return l;c!==d&&(g=o=c+1)}}}}else _(b)&&l.charCodeAt(1)===T&&(g=r>2&&f(l.charCodeAt(2))?3:2,o=g);let i=-1,t=!0;for(let c=r-1;c>=o;--c)if(f(l.charCodeAt(c))){if(!t){i=c;break}}else t=!1;if(i===-1){if(g===-1)return".";i=g}return l.slice(0,i)},basename(l,r){r!==void 0&&w(r,"ext"),w(l,"path");let g=0,o=-1,b=!0,i;if(l.length>=2&&_(l.charCodeAt(0))&&l.charCodeAt(1)===T&&(g=2),r!==void 0&&r.length>0&&r.length<=l.length){if(r===l)return"";let t=r.length-1,c=-1;for(i=l.length-1;i>=g;--i){const d=l.charCodeAt(i);if(f(d)){if(!b){g=i+1;break}}else c===-1&&(b=!1,c=i+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(o=i):(t=-1,o=c))}return g===o?o=c:o===-1&&(o=l.length),l.slice(g,o)}for(i=l.length-1;i>=g;--i)if(f(l.charCodeAt(i))){if(!b){g=i+1;break}}else o===-1&&(b=!1,o=i+1);return o===-1?"":l.slice(g,o)},extname(l){w(l,"path");let r=0,g=-1,o=0,b=-1,i=!0,t=0;l.length>=2&&l.charCodeAt(1)===T&&_(l.charCodeAt(0))&&(r=o=2);for(let c=l.length-1;c>=r;--c){const d=l.charCodeAt(c);if(f(d)){if(!i){o=c+1;break}continue}b===-1&&(i=!1,b=c+1),d===k?g===-1?g=c:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||b===-1||t===0||t===1&&g===b-1&&g===o+1?"":l.slice(g,b)},format:p.bind(null,"\\"),parse(l){w(l,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return r;const g=l.length;let o=0,b=l.charCodeAt(0);if(g===1)return f(b)?(r.root=r.dir=l,r):(r.base=r.name=l,r);if(f(b)){if(o=1,f(l.charCodeAt(1))){let u=2,E=u;for(;u<g&&!f(l.charCodeAt(u));)u++;if(u<g&&u!==E){for(E=u;u<g&&f(l.charCodeAt(u));)u++;if(u<g&&u!==E){for(E=u;u<g&&!f(l.charCodeAt(u));)u++;u===g?o=u:u!==E&&(o=u+1)}}}}else if(_(b)&&l.charCodeAt(1)===T){if(g<=2)return r.root=r.dir=l,r;if(o=2,f(l.charCodeAt(2))){if(g===3)return r.root=r.dir=l,r;o=3}}o>0&&(r.root=l.slice(0,o));let i=-1,t=o,c=-1,d=!0,s=l.length-1,h=0;for(;s>=o;--s){if(b=l.charCodeAt(s),f(b)){if(!d){t=s+1;break}continue}c===-1&&(d=!1,c=s+1),b===k?i===-1?i=s:h!==1&&(h=1):i!==-1&&(h=-1)}return c!==-1&&(i===-1||h===0||h===1&&i===c-1&&i===t+1?r.base=r.name=l.slice(t,c):(r.name=l.slice(t,i),r.base=l.slice(t,c),r.ext=l.slice(i,c))),t>0&&t!==o?r.dir=l.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let r="",g=!1;for(let o=l.length-1;o>=-1&&!g;o--){const b=o>=0?l[o]:m.cwd();w(b,"path"),b.length!==0&&(r=`${b}/${r}`,g=b.charCodeAt(0)===S)}return r=P(r,!g,"/",v),g?`/${r}`:r.length>0?r:"."},normalize(l){if(w(l,"path"),l.length===0)return".";const r=l.charCodeAt(0)===S,g=l.charCodeAt(l.length-1)===S;return l=P(l,!r,"/",v),l.length===0?r?"/":g?"./":".":(g&&(l+="/"),r?`/${l}`:l)},isAbsolute(l){return w(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let r;for(let g=0;g<l.length;++g){const o=l[g];w(o,"path"),o.length>0&&(r===void 0?r=o:r+=`/${o}`)}return r===void 0?".":e.posix.normalize(r)},relative(l,r){if(w(l,"from"),w(r,"to"),l===r||(l=e.posix.resolve(l),r=e.posix.resolve(r),l===r))return"";const g=1,o=l.length,b=o-g,i=1,t=r.length-i,c=b<t?b:t;let d=-1,s=0;for(;s<c;s++){const u=l.charCodeAt(g+s);if(u!==r.charCodeAt(i+s))break;u===S&&(d=s)}if(s===c)if(t>c){if(r.charCodeAt(i+s)===S)return r.slice(i+s+1);if(s===0)return r.slice(i+s)}else b>c&&(l.charCodeAt(g+s)===S?d=s:s===0&&(d=0));let h="";for(s=g+d+1;s<=o;++s)(s===o||l.charCodeAt(s)===S)&&(h+=h.length===0?"..":"/..");return`${h}${r.slice(i+d)}`},toNamespacedPath(l){return l},dirname(l){if(w(l,"path"),l.length===0)return".";const r=l.charCodeAt(0)===S;let g=-1,o=!0;for(let b=l.length-1;b>=1;--b)if(l.charCodeAt(b)===S){if(!o){g=b;break}}else o=!1;return g===-1?r?"/":".":r&&g===1?"//":l.slice(0,g)},basename(l,r){r!==void 0&&w(r,"ext"),w(l,"path");let g=0,o=-1,b=!0,i;if(r!==void 0&&r.length>0&&r.length<=l.length){if(r===l)return"";let t=r.length-1,c=-1;for(i=l.length-1;i>=0;--i){const d=l.charCodeAt(i);if(d===S){if(!b){g=i+1;break}}else c===-1&&(b=!1,c=i+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(o=i):(t=-1,o=c))}return g===o?o=c:o===-1&&(o=l.length),l.slice(g,o)}for(i=l.length-1;i>=0;--i)if(l.charCodeAt(i)===S){if(!b){g=i+1;break}}else o===-1&&(b=!1,o=i+1);return o===-1?"":l.slice(g,o)},extname(l){w(l,"path");let r=-1,g=0,o=-1,b=!0,i=0;for(let t=l.length-1;t>=0;--t){const c=l.charCodeAt(t);if(c===S){if(!b){g=t+1;break}continue}o===-1&&(b=!1,o=t+1),c===k?r===-1?r=t:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||o===-1||i===0||i===1&&r===o-1&&r===g+1?"":l.slice(r,o)},format:p.bind(null,"/"),parse(l){w(l,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return r;const g=l.charCodeAt(0)===S;let o;g?(r.root="/",o=1):o=0;let b=-1,i=0,t=-1,c=!0,d=l.length-1,s=0;for(;d>=o;--d){const h=l.charCodeAt(d);if(h===S){if(!c){i=d+1;break}continue}t===-1&&(c=!1,t=d+1),h===k?b===-1?b=d:s!==1&&(s=1):b!==-1&&(s=-1)}if(t!==-1){const h=i===0&&g?1:i;b===-1||s===0||s===1&&b===t-1&&b===i+1?r.base=r.name=l.slice(h,t):(r.name=l.slice(h,b),r.base=l.slice(h,t),r.ext=l.slice(b,t))}return i>0?r.dir=l.slice(0,i-1):g&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[95],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...n){const k=n.reduce((T,I)=>(T[I]=!0,T),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(T=>!k[T]).forEach(T=>{for(let I=0;I<S.length;I++)if(T.search(S[I])!==-1){delete C[T];break}})}e.sanitizeProcessEnvironment=D}),define(me[47],ge([0,1,11]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class D{constructor(n){this._highResolution=L&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new D(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=D}),define(me[3],ge([0,1,15,74,6,94,47]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>D.Disposable.None;function g(M){return(W,U=null,x)=>{let B=!1,O;return O=M(H=>{if(!B)return O?O.dispose():B=!0,W.call(U,H)},null,x),B&&O.dispose(),O}}r.once=g;function o(M,W){return s((U,x=null,B)=>M(O=>U.call(x,W(O)),null,B))}r.map=o;function b(M,W){return s((U,x=null,B)=>M(O=>{W(O),U.call(x,O)},null,B))}r.forEach=b;function i(M,W){return s((U,x=null,B)=>M(O=>W(O)&&U.call(x,O),null,B))}r.filter=i;function t(M){return M}r.signal=t;function c(...M){return(W,U=null,x)=>(0,D.combinedDisposable)(...M.map(B=>B(O=>W.call(U,O),null,x)))}r.any=c;function d(M,W,U){let x=U;return o(M,B=>(x=W(x,B),x))}r.reduce=d;function s(M){let W;const U=new a({onFirstListenerAdd(){W=M(U.fire,U)},onLastListenerRemove(){W.dispose()}});return U.event}function h(M,W,U=100,x=!1,B){let O,H,j,X=0;const K=new a({leakWarningThreshold:B,onFirstListenerAdd(){O=M(he=>{X++,H=W(H,he),x&&!j&&(K.fire(H),H=void 0),clearTimeout(j),j=setTimeout(()=>{const Ee=H;H=void 0,j=void 0,(!x||X>1)&&K.fire(Ee),X=0},U)})},onLastListenerRemove(){O.dispose()}});return K.event}r.debounce=h;function u(M,W=(U,x)=>U===x){let U=!0,x;return i(M,B=>{const O=U||!W(B,x);return U=!1,x=B,O})}r.latch=u;function E(M,W){return[r.filter(M,W),r.filter(M,U=>!W(U))]}r.split=E;function A(M,W=!1,U=[]){let x=U.slice(),B=M(j=>{x?x.push(j):H.fire(j)});const O=()=>{x&&x.forEach(j=>H.fire(j)),x=null},H=new a({onFirstListenerAdd(){B||(B=M(j=>H.fire(j)))},onFirstListenerDidAdd(){x&&(W?setTimeout(O):O())},onLastListenerRemove(){B&&B.dispose(),B=null}});return H.event}r.buffer=A;class R{constructor(W){this.event=W}map(W){return new R(o(this.event,W))}forEach(W){return new R(b(this.event,W))}filter(W){return new R(i(this.event,W))}reduce(W,U){return new R(d(this.event,W,U))}latch(){return new R(u(this.event))}debounce(W,U=100,x=!1,B){return new R(h(this.event,W,U,x,B))}on(W,U,x){return this.event(W,U,x)}once(W,U,x){return g(this.event)(W,U,x)}}function $(M){return new R(M)}r.chain=$;function N(M,W,U=x=>x){const x=(...j)=>H.fire(U(...j)),B=()=>M.on(W,x),O=()=>M.removeListener(W,x),H=new a({onFirstListenerAdd:B,onLastListenerRemove:O});return H.event}r.fromNodeEventEmitter=N;function F(M,W,U=x=>x){const x=(...j)=>H.fire(U(...j)),B=()=>M.addEventListener(W,x),O=()=>M.removeEventListener(W,x),H=new a({onFirstListenerAdd:B,onLastListenerRemove:O});return H.event}r.fromDOMEventEmitter=F;function z(M){return new Promise(W=>g(M)(W))}r.toPromise=z})(k=e.Event||(e.Event={}));class S{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${S._idPool++}`}start(g){this._stopWatch=new n.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let y=-1;function T(r){const g=y;return y=r,{dispose(){y=g}}}e.setGlobalLeakWarningThreshold=T;class I{constructor(g,o=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let o=y;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||g<o)return;this._stacks||(this._stacks=new Map);const b=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(b)||0;if(this._stacks.set(b,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let t,c=0;for(const[d,s]of this._stacks)(!t||c<s)&&(t=d,c=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${c}):`),console.warn(t)}return()=>{const t=this._stacks.get(b)||0;this._stacks.set(b,t-1)}}}class a{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=y>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(g,o,b)=>{this._listeners||(this._listeners=new C.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(o?[g,o]:g);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,o);const c=this._leakageMon?.check(this._listeners.size),d=(0,D.toDisposable)(()=>{c&&c(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return b instanceof D.DisposableStore?b.add(d):Array.isArray(b)&&b.push(d),d}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,b]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,b):o[0].call(o[1],b)}catch(i){(0,m.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class w extends a{async fireAsync(g,o,b){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,g]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),c=[],d={...t,waitUntil:s=>{if(Object.isFrozen(c))throw new Error("waitUntil can NOT be called asynchronous");b&&(s=b(s,typeof i=="function"?i:i[0])),c.push(s)}};try{typeof i=="function"?i.call(void 0,d):i[0].call(i[1],d)}catch(s){(0,m.onUnexpectedError)(s);continue}Object.freeze(c),await Promise.allSettled(c).then(s=>{for(const h of s)h.status==="rejected"&&(0,m.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=w;class f extends a{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=f;class v extends f{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=v;class _ extends a{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=_;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const o={event:g,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const b=()=>{this.hasListeners&&this.unhook(o);const i=this.events.indexOf(o);this.events.splice(i,1)};return(0,D.toDisposable)((0,L.once)(b))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(o=>this.emitter.fire(o))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class p{constructor(){this.buffers=[]}wrapEvent(g){return(o,b,i)=>g(t=>{const c=this.buffers[this.buffers.length-1];c?c.push(()=>o.call(b,t)):o.call(b,t)},void 0,i)}bufferEvents(g){const o=[];this.buffers.push(o);const b=g();return this.buffers.pop(),o.forEach(i=>i()),b}}e.EventBufferer=p;class l{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=D.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(me[21],ge([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,S){const y=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(y)}}});var D;(function(k){function S(y){return y===k.None||y===k.Cancelled||y instanceof C?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=n}),define(me[78],ge([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(T){const I=this._icons.get(T.id);I?T.description?I.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function C(y){return y?y.replace(/\$\((.*?)\)/g,(T,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=C;class n{constructor(T,I,a){this.id=T,this.definition=I,this.description=a,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(y,T){const I=["codicon","codicon-"+y];return T&&I.push("codicon-modifier-"+T),I}e.getClassNamesArray=k;var S;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function I(f){if(f instanceof n)return["codicon","codicon-"+f.id];const v=T.exec(f.id);if(!v)return I(n.error);let[,_,P]=v;const p=["codicon","codicon-"+_];return P&&p.push("codicon-modifier-"+P.substr(1)),p}y.asClassNameArray=I;function a(f){return I(f).join(" ")}y.asClassName=a;function w(f){return"."+I(f).join(".")}y.asCSSSelector=w})(S=e.CSSIcon||(e.CSSIcon={}))}),define(me[96],ge([0,1,15,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(l){const r=l;return r?[r.on,r.pause,r.resume,r.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=D;function C(l){const r=l;return r?D(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function n(l,r){return new k(l,r)}e.newWriteableStream=n;class k{constructor(r,g){this.reducer=r,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(g=>g(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(g=>g(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,g){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(r,g){if(this.state.destroyed)return;let o;switch(r){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const b=o.indexOf(g);b>=0&&o.splice(b,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,r){const g=[];let o;for(;(o=l.read())!==null;)g.push(o);return r(g)}e.consumeReadable=S;function y(l,r,g){const o=[];let b;for(;(b=l.read())!==null&&o.length<g;)o.push(b);return b===null&&o.length>0?r(o):{read:()=>{if(o.length>0)return o.shift();if(typeof b!="undefined"){const i=b;return b=void 0,i}return l.read()}}}e.peekReadable=y;function T(l,r){return new Promise((g,o)=>{const b=[];I(l,{onData:i=>{r&&b.push(i)},onError:i=>{r?o(i):g(void 0)},onEnd:()=>{g(r?r(b):void 0)}})})}e.consumeStream=T;function I(l,r){l.on("error",g=>r.onError(g)),l.on("end",()=>r.onEnd()),l.on("data",g=>r.onData(g))}e.listenStream=I;function a(l,r){return new Promise((g,o)=>{const b=new L.DisposableStore,i=[],t=s=>{if(i.push(s),i.length>r)return b.dispose(),l.pause(),g({stream:l,buffer:i,ended:!1})},c=s=>o(s),d=()=>g({stream:l,buffer:i,ended:!0});b.add((0,L.toDisposable)(()=>l.removeListener("error",c))),l.on("error",c),b.add((0,L.toDisposable)(()=>l.removeListener("end",d))),l.on("end",d),b.add((0,L.toDisposable)(()=>l.removeListener("data",t))),l.on("data",t)})}e.peekStream=a;function w(l,r){const g=n(r);return g.end(l),g}e.toStream=w;function f(){const l=n(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=f;function v(l){let r=!1;return{read:()=>r?null:(r=!0,l)}}e.toReadable=v;function _(l,r,g){const o=n(g);return I(l,{onData:b=>o.write(r.data(b)),onError:b=>o.error(r.error?r.error(b):b),onEnd:()=>o.end()}),o}e.transform=_;function P(l,r,g){let o=!1;return{read:()=>{const b=r.read();return o?b:(o=!0,b!==null?g([l,b]):l)}}}e.prefixedReadable=P;function p(l,r,g){let o=!1;const b=n(g);return I(r,{onData:i=>o?b.write(i):(o=!0,b.write(g([l,i]))),onError:i=>b.error(i),onEnd:()=>{o||(o=!0,b.write(l)),b.end()}}),b}e.prefixedStream=p}),define(me[22],ge([0,1,96]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,C;class n{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new n(Buffer.allocUnsafe(t)):new n(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new n(t)}static fromString(t,c){return!(c?.dontUseNodeBuffer||!1)&&L?new n(Buffer.from(t)):(D||(D=new TextEncoder),new n(D.encode(t)))}static concat(t,c){if(typeof c=="undefined"){c=0;for(let h=0,u=t.length;h<u;h++)c+=t[h].byteLength}const d=n.alloc(c);let s=0;for(let h=0,u=t.length;h<u;h++){const E=t[h];d.set(E,s),s+=E.byteLength}return d}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,c){return new n(this.buffer.subarray(t,c))}set(t,c){t instanceof n?this.buffer.set(t.buffer,c):this.buffer.set(t,c)}readUInt32BE(t){return y(this.buffer,t)}writeUInt32BE(t,c){T(this.buffer,t,c)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,c){a(this.buffer,t,c)}readUInt8(t){return w(this.buffer,t)}writeUInt8(t,c){f(this.buffer,t,c)}}e.VSBuffer=n;function k(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0}e.readUInt16LE=k;function S(i,t,c){i[c+0]=t&255,t=t>>>8,i[c+1]=t&255}e.writeUInt16LE=S;function y(i,t){return i[t]*2**24+i[t+1]*2**16+i[t+2]*2**8+i[t+3]}e.readUInt32BE=y;function T(i,t,c){i[c+3]=t,t=t>>>8,i[c+2]=t,t=t>>>8,i[c+1]=t,t=t>>>8,i[c]=t}e.writeUInt32BE=T;function I(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0|i[t+2]<<16>>>0|i[t+3]<<24>>>0}e.readUInt32LE=I;function a(i,t,c){i[c+0]=t&255,t=t>>>8,i[c+1]=t&255,t=t>>>8,i[c+2]=t&255,t=t>>>8,i[c+3]=t&255}e.writeUInt32LE=a;function w(i,t){return i[t]}e.readUInt8=w;function f(i,t,c){i[c]=t}e.writeUInt8=f;function v(i){return m.consumeReadable(i,t=>n.concat(t))}e.readableToBuffer=v;function _(i){return m.toReadable(i)}e.bufferToReadable=_;function P(i){return m.consumeStream(i,t=>n.concat(t))}e.streamToBuffer=P;async function p(i){return i.ended?n.concat(i.buffer):n.concat([...i.buffer,await P(i.stream)])}e.bufferedStreamToBuffer=p;function l(i){return m.toStream(i,t=>n.concat(t))}e.bufferToStream=l;function r(i){return m.transform(i,{data:t=>typeof t=="string"?n.fromString(t):n.wrap(t)},t=>n.concat(t))}e.streamToBufferReadableStream=r;function g(i){return m.newWriteableStream(t=>n.concat(t),i)}e.newWriteableBufferStream=g;function o(i,t){return m.prefixedReadable(i,t,c=>n.concat(c))}e.prefixedBufferReadable=o;function b(i,t){return m.prefixedStream(i,t,c=>n.concat(c))}e.prefixedBufferStream=b}),define(me[8],ge([0,1,11]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(de){return!de||typeof de!="string"?!0:de.trim().length===0}e.isFalsyOrWhitespace=L;const D=/{(\d+)}/g;function C(de,...ke){return ke.length===0?de:de.replace(D,function(Ue,$e){const tt=parseInt($e,10);return isNaN(tt)||tt<0||tt>=ke.length?Ue:ke[tt]})}e.format=C;const n=/{([^}]+)}/g;function k(de,ke){return de.replace(n,(Ue,$e)=>ke[$e]??Ue)}e.format2=k;function S(de){return de.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.escape=S;function y(de){return de.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function T(de,ke){let Ue=0;const $e=ke.charCodeAt(0);for(let tt=de.length-1;tt>=0;tt--)de.charCodeAt(tt)===$e&&Ue++;return Ue}e.count=T;function I(de,ke,Ue="\u2026"){return de.length<=ke?de:`${de.substr(0,ke)}${Ue}`}e.truncate=I;function a(de,ke=" "){const Ue=w(de,ke);return f(Ue,ke)}e.trim=a;function w(de,ke){if(!de||!ke)return de;const Ue=ke.length;if(Ue===0||de.length===0)return de;let $e=0;for(;de.indexOf(ke,$e)===$e;)$e=$e+Ue;return de.substring($e)}e.ltrim=w;function f(de,ke){if(!de||!ke)return de;const Ue=ke.length,$e=de.length;if(Ue===0||$e===0)return de;let tt=$e,Te=-1;for(;Te=de.lastIndexOf(ke,tt-1),!(Te===-1||Te+Ue!==tt);){if(Te===0)return"";tt=Te}return de.substring(0,tt)}e.rtrim=f;function v(de){return de.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function _(de){return de.replace(/\*/g,"")}e.stripWildcards=_;function P(de,ke,Ue={}){if(!de)throw new Error("Cannot create regex from empty string");ke||(de=y(de)),Ue.wholeWord&&(/\B/.test(de.charAt(0))||(de="\\b"+de),/\B/.test(de.charAt(de.length-1))||(de=de+"\\b"));let $e="";return Ue.global&&($e+="g"),Ue.matchCase||($e+="i"),Ue.multiline&&($e+="m"),Ue.unicode&&($e+="u"),new RegExp(de,$e)}e.createRegExp=P;function p(de){return de.source==="^"||de.source==="^$"||de.source==="$"||de.source==="^\\s*$"?!1:!!(de.exec("")&&de.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function l(de){return!!de.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(de){return(de.global?"g":"")+(de.ignoreCase?"i":"")+(de.multiline?"m":"")+(de.unicode?"u":"")}e.regExpFlags=r;function g(de){return de.split(/\r\n|\r|\n/)}e.splitLines=g;function o(de){for(let ke=0,Ue=de.length;ke<Ue;ke++){const $e=de.charCodeAt(ke);if($e!==32&&$e!==9)return ke}return-1}e.firstNonWhitespaceIndex=o;function b(de,ke=0,Ue=de.length){for(let $e=ke;$e<Ue;$e++){const tt=de.charCodeAt($e);if(tt!==32&&tt!==9)return de.substring(ke,$e)}return de.substring(ke,Ue)}e.getLeadingWhitespace=b;function i(de,ke=de.length-1){for(let Ue=ke;Ue>=0;Ue--){const $e=de.charCodeAt(Ue);if($e!==32&&$e!==9)return Ue}return-1}e.lastNonWhitespaceIndex=i;function t(de,ke){return de<ke?-1:de>ke?1:0}e.compare=t;function c(de,ke,Ue=0,$e=de.length,tt=0,Te=ke.length){for(;Ue<$e&&tt<Te;Ue++,tt++){let oe=de.charCodeAt(Ue),ue=ke.charCodeAt(tt);if(oe<ue)return-1;if(oe>ue)return 1}const Ce=$e-Ue,we=Te-tt;return Ce<we?-1:Ce>we?1:0}e.compareSubstring=c;function d(de,ke){return s(de,ke,0,de.length,0,ke.length)}e.compareIgnoreCase=d;function s(de,ke,Ue=0,$e=de.length,tt=0,Te=ke.length){for(;Ue<$e&&tt<Te;Ue++,tt++){let oe=de.charCodeAt(Ue),ue=ke.charCodeAt(tt);if(oe===ue)continue;if(oe>=128||ue>=128)return c(de.toLowerCase(),ke.toLowerCase(),Ue,$e,tt,Te);h(oe)&&(oe-=32),h(ue)&&(ue-=32);const pe=oe-ue;if(pe!==0)return pe}const Ce=$e-Ue,we=Te-tt;return Ce<we?-1:Ce>we?1:0}e.compareSubstringIgnoreCase=s;function h(de){return de>=97&&de<=122}e.isLowerAsciiLetter=h;function u(de){return de>=65&&de<=90}e.isUpperAsciiLetter=u;function E(de,ke){return de.length===ke.length&&s(de,ke)===0}e.equalsIgnoreCase=E;function A(de,ke){const Ue=ke.length;return ke.length>de.length?!1:s(de,ke,0,Ue)===0}e.startsWithIgnoreCase=A;function R(de,ke){let Ue,$e=Math.min(de.length,ke.length);for(Ue=0;Ue<$e;Ue++)if(de.charCodeAt(Ue)!==ke.charCodeAt(Ue))return Ue;return $e}e.commonPrefixLength=R;function $(de,ke){let Ue,$e=Math.min(de.length,ke.length);const tt=de.length-1,Te=ke.length-1;for(Ue=0;Ue<$e;Ue++)if(de.charCodeAt(tt-Ue)!==ke.charCodeAt(Te-Ue))return Ue;return $e}e.commonSuffixLength=$;function N(de){return 55296<=de&&de<=56319}e.isHighSurrogate=N;function F(de){return 56320<=de&&de<=57343}e.isLowSurrogate=F;function z(de,ke){return(de-55296<<10)+(ke-56320)+65536}e.computeCodePoint=z;function M(de,ke,Ue){const $e=de.charCodeAt(Ue);if(N($e)&&Ue+1<ke){const tt=de.charCodeAt(Ue+1);if(F(tt))return z($e,tt)}return $e}e.getNextCodePoint=M;function W(de,ke){const Ue=de.charCodeAt(ke-1);if(F(Ue)&&ke>1){const $e=de.charCodeAt(ke-2);if(N($e))return z($e,Ue)}return Ue}function U(de,ke){const Ue=st.getInstance(),$e=ke,tt=de.length,Te=M(de,tt,ke);ke+=Te>=65536?2:1;let Ce=Ue.getGraphemeBreakType(Te);for(;ke<tt;){const we=M(de,tt,ke),oe=Ue.getGraphemeBreakType(we);if(ut(Ce,oe))break;ke+=we>=65536?2:1,Ce=oe}return ke-$e}e.nextCharLength=U;function x(de,ke){const Ue=st.getInstance(),$e=ke,tt=W(de,ke);ke-=tt>=65536?2:1;let Te=Ue.getGraphemeBreakType(tt);for(;ke>0;){const Ce=W(de,ke),we=Ue.getGraphemeBreakType(Ce);if(ut(we,Te))break;ke-=Ce>=65536?2:1,Te=we}return $e-ke}e.prevCharLength=x;function B(de,ke){const Ue=st.getInstance(),$e=de.length,tt=ke,Te=M(de,$e,ke),Ce=Ue.getGraphemeBreakType(Te);ke+=Te>=65536?2:1;let we=Ce;for(;ke<$e;){const ue=M(de,$e,ke),pe=Ue.getGraphemeBreakType(ue);if(ut(we,pe))break;ke+=ue>=65536?2:1,we=pe}const oe=ke;for(ke=tt,we=Ce;ke>0;){const ue=W(de,ke),pe=Ue.getGraphemeBreakType(ue);if(ut(pe,we))break;ke-=ue>=65536?2:1,we=pe}return[ke,oe]}function O(de,ke){return ke>0&&F(de.charCodeAt(ke))?B(de,ke-1):B(de,ke)}e.getCharContainingOffset=O;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function j(de){return H.test(de)}e.containsRTL=j;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function K(de){return X.test(de)}e.containsEmoji=K;const he=/^[\t\n\r\x20-\x7E]*$/;function Ee(de){return he.test(de)}e.isBasicASCII=Ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function De(de){return e.UNUSUAL_LINE_TERMINATORS.test(de)}e.containsUnusualLineTerminators=De;function Pe(de){for(let ke=0,Ue=de.length;ke<Ue;ke++)if(Be(de.charCodeAt(ke)))return!0;return!1}e.containsFullWidthCharacter=Pe;function Be(de){return de>=11904&&de<=55215||de>=63744&&de<=64255||de>=65281&&de<=65374}e.isFullWidthCharacter=Be;function He(de){return de>=127462&&de<=127487||de===8986||de===8987||de===9200||de===9203||de>=9728&&de<=10175||de===11088||de===11093||de>=127744&&de<=128591||de>=128640&&de<=128764||de>=128992&&de<=129008||de>=129280&&de<=129535||de>=129648&&de<=129782}e.isEmojiImprecise=He;function ze(de,ke){if(de.length<ke)return de;const Ue=/\b/g;let $e=0;for(;Ue.test(de)&&!(de.length-Ue.lastIndex<ke);)$e=Ue.lastIndex,Ue.lastIndex+=1;return de.substring($e).replace(/^\s/,"")}e.lcut=ze;const G=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,ne=/\x1b\[0?m/g;function ce(de){return de&&(de=de.replace(G,""),de=de.replace(Z,""),de=de.replace(ne,"")),de}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function J(de){return!!(de&&de.length>0&&de.charCodeAt(0)===65279)}e.startsWithUTF8BOM=J;function te(de){return J(de)?de.substr(1):de}e.stripUTF8BOM=te;function ve(de,ke){if(!de||!ke||de.length<ke.length)return!1;const Ue=ke.length,$e=de.toLowerCase();let tt=0,Te=-1;for(;tt<Ue;){const Ce=$e.indexOf(ke[tt],Te+1);if(Ce<0)return!1;Te=Ce,tt++}return!0}e.fuzzyContains=ve;function Me(de,ke=!1){return de?(ke&&(de=de.replace(/\\./g,"")),de.toLowerCase()!==de):!1}e.containsUppercaseCharacter=Me;function je(de){return de.charAt(0).toUpperCase()+de.slice(1)}e.uppercaseFirstLetter=je;function Ke(de,ke=1){if(ke===0)return"";let Ue=-1;do Ue=de.indexOf(`
`,Ue+1),ke--;while(ke>0&&Ue>=0);return Ue===-1?de:(de[Ue-1]==="\r"&&Ue--,de.substr(0,Ue))}e.getNLines=Ke;function Ze(de){const ke=90-65+1;return de=de%(2*ke),de<ke?String.fromCharCode(97+de):String.fromCharCode(65+de-ke)}e.singleLetterHash=Ze;function rt(de){return st.getInstance().getGraphemeBreakType(de)}e.getGraphemeBreakType=rt;function ut(de,ke){return de===0?ke!==5&&ke!==7:de===2&&ke===3?!1:de===4||de===2||de===3||ke===4||ke===2||ke===3?!0:!(de===8&&(ke===8||ke===9||ke===11||ke===12)||(de===11||de===9)&&(ke===9||ke===10)||(de===12||de===10)&&ke===10||ke===5||ke===13||ke===7||de===1||de===13&&ke===14||de===6&&ke===6)}e.breakBetweenGraphemeBreakType=ut;var it;(function(de){de[de.Other=0]="Other",de[de.Prepend=1]="Prepend",de[de.CR=2]="CR",de[de.LF=3]="LF",de[de.Control=4]="Control",de[de.Extend=5]="Extend",de[de.Regional_Indicator=6]="Regional_Indicator",de[de.SpacingMark=7]="SpacingMark",de[de.L=8]="L",de[de.V=9]="V",de[de.T=10]="T",de[de.LV=11]="LV",de[de.LVT=12]="LVT",de[de.ZWJ=13]="ZWJ",de[de.Extended_Pictographic=14]="Extended_Pictographic"})(it=e.GraphemeBreakType||(e.GraphemeBreakType={}));class st{constructor(){this._data=Ae()}static getInstance(){return st._INSTANCE||(st._INSTANCE=new st),st._INSTANCE}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const Ue=this._data,$e=Ue.length/3;let tt=1;for(;tt<=$e;)if(ke<Ue[3*tt])tt=2*tt;else if(ke>Ue[3*tt+1])tt=2*tt+1;else return Ue[3*tt+2];return 0}}st._INSTANCE=null;function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function wt(de,ke){if(de===0)return 0;const Ue=ee(de,ke);if(Ue!==void 0)return Ue;const $e=W(ke,de);return de-=re($e),de}e.getLeftDeleteOffset=wt;function ee(de,ke){let Ue=W(ke,de);for(de-=re(Ue);Se(Ue)||Ue===65039||Ue===8419;){if(de===0)return;Ue=W(ke,de),de-=re(Ue)}if(!!He(Ue)){if(de>=0){const $e=W(ke,de);$e===8205&&(de-=re($e))}return de}}function re(de){return de>=65536?2:1}function Se(de){return 127995<=de&&de<=127999}var Ge;(function(de){de[de.zwj=8205]="zwj",de[de.emojiVariantSelector=65039]="emojiVariantSelector",de[de.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class Ye{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ye.map){let $e=function(Ce){const we=new Map;for(let oe=0;oe<Ce.length;oe+=2)we.set(Ce[oe],Ce[oe+1]);return we};const ke=Ye.getData();let Ue=m.locale;(!Ue||!(Ue in ke))&&(Ue=m.language),(!Ue||!(Ue in ke))&&(Ue="_default");const tt=$e(ke._common),Te=$e(ke[Ue]);for(const[Ce,we]of Te)tt.set(Ce,we);Ye.map=tt}return Ye.map}static isAmbiguous(ke){return Ye.getConfusablesForCurrentLocale().has(ke)}static getPrimaryConfusable(ke){return Ye.getConfusablesForCurrentLocale().get(ke)}static getPrimaryConfusableCodePoints(){return new Set(Ye.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ye;class nt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(nt.getRawData())),this._data}static isInvisibleCharacter(ke){return nt.getData().has(ke)}static get codePoints(){return nt.getData()}}e.InvisibleCharacters=nt,nt._data=void 0}),define(me[48],ge([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(P){return D(P,0)}e.hash=L;function D(P,p){switch(typeof P){case"object":return P===null?C(349,p):Array.isArray(P)?S(P,p):y(P,p);case"string":return k(P,p);case"boolean":return n(P,p);case"number":return C(P,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=D;function C(P,p){return(p<<5)-p+P|0}e.numberHash=C;function n(P,p){return C(P?433:863,p)}function k(P,p){p=C(149417,p);for(let l=0,r=P.length;l<r;l++)p=C(P.charCodeAt(l),p);return p}e.stringHash=k;function S(P,p){return p=C(104579,p),P.reduce((l,r)=>D(r,l),p)}function y(P,p){return p=C(181387,p),Object.keys(P).sort().reduce((l,r)=>(l=k(r,l),D(P[r],l)),p)}class T{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=D(p,this._value),this._value}}e.Hasher=T;var I;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function a(P,p,l=32){const r=l-p,g=~((1<<r)-1);return(P<<p|(g&P)>>>r)>>>0}function w(P,p=0,l=P.byteLength,r=0){for(let g=0;g<l;g++)P[p+g]=r}function f(P,p,l="0"){for(;P.length<p;)P=l+P;return P}function v(P,p=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(l=>l.toString(16).padStart(2,"0")).join(""):f((P>>>0).toString(16),p/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const l=p.length;if(l===0)return;const r=this._buff;let g=this._buffLen,o=this._leftoverHighSurrogate,b,i;for(o!==0?(b=o,i=-1,o=0):(b=p.charCodeAt(0),i=0);;){let t=b;if(m.isHighSurrogate(b))if(i+1<l){const c=p.charCodeAt(i+1);m.isLowSurrogate(c)?(i++,t=m.computeCodePoint(b,c)):t=65533}else{o=b;break}else m.isLowSurrogate(b)&&(t=65533);if(g=this._push(r,g,t),i++,i<l)b=p.charCodeAt(i);else break}this._buffLen=g,this._leftoverHighSurrogate=o}_push(p,l,r){return r<128?p[l++]=r:r<2048?(p[l++]=192|(r&1984)>>>6,p[l++]=128|(r&63)>>>0):r<65536?(p[l++]=224|(r&61440)>>>12,p[l++]=128|(r&4032)>>>6,p[l++]=128|(r&63)>>>0):(p[l++]=240|(r&1835008)>>>18,p[l++]=128|(r&258048)>>>12,p[l++]=128|(r&4032)>>>6,p[l++]=128|(r&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=_._bigBlock32,l=this._buffDV;for(let s=0;s<64;s+=4)p.setUint32(s,l.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)p.setUint32(s,a(p.getUint32(s-12,!1)^p.getUint32(s-32,!1)^p.getUint32(s-56,!1)^p.getUint32(s-64,!1),1),!1);let r=this._h0,g=this._h1,o=this._h2,b=this._h3,i=this._h4,t,c,d;for(let s=0;s<80;s++)s<20?(t=g&o|~g&b,c=1518500249):s<40?(t=g^o^b,c=1859775393):s<60?(t=g&o|g&b|o&b,c=2400959708):(t=g^o^b,c=3395469782),d=a(r,5)+t+i+c+p.getUint32(s*4,!1)&4294967295,i=b,b=o,o=a(g,30),g=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+b&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[24],ge([0,1,17,8]),function(Y,e,m,L){"use strict";var D,C,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(i,t,c){let d=i.get(t);return d===void 0&&(d=c,i.set(t,d)),d}e.getOrSet=k;function S(i){const t=[];return i.forEach((c,d)=>{t.push(`${d} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=S;function y(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=y;class T{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const c=t.charCodeAt(0),d=this._value.charCodeAt(this._pos);return c-d}value(){return this._value[this._pos]}}e.StringIterator=T;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class a{constructor(t=!0,c=!0){this._splitOnBackslash=t,this._caseSensitive=c}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=a;var w;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(w||(w={}));class f{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(_||(_={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new f(t))}static forPaths(){return new P(new a)}static forStrings(){return new P(new T)}static forConfigKeys(){return new P(new I)}clear(){this._root=void 0}fill(t,c){if(c){const d=c.slice(0);(0,m.shuffle)(d);for(let s of d)this.set(s,t)}else{const d=t.slice(0);(0,m.shuffle)(d);for(let s of d)this.set(s[0],s[1])}}set(t,c){const d=this._iter.reset(t);let s;this._root||(this._root=new v,this._root.segment=d.value());const h=[];for(s=this._root;;){const E=d.cmp(s.segment);if(E>0)s.left||(s.left=new v,s.left.segment=d.value()),h.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new v,s.right.segment=d.value()),h.push([1,s]),s=s.right;else if(d.hasNext())d.next(),s.mid||(s.mid=new v,s.mid.segment=d.value()),h.push([0,s]),s=s.mid;else break}const u=s.value;s.value=c,s.key=t;for(let E=h.length-1;E>=0;E--){const A=h[E][1];A.updateHeight();const R=A.balanceFactor();if(R<-1||R>1){const $=h[E][0],N=h[E+1][0];if($===1&&N===1)h[E][1]=A.rotateLeft();else if($===-1&&N===-1)h[E][1]=A.rotateRight();else if($===1&&N===-1)A.right=h[E+1][1]=h[E+1][1].rotateRight(),h[E][1]=A.rotateLeft();else if($===-1&&N===1)A.left=h[E+1][1]=h[E+1][1].rotateLeft(),h[E][1]=A.rotateRight();else throw new Error;if(E>0)switch(h[E-1][0]){case-1:h[E-1][1].left=h[E][1];break;case 1:h[E-1][1].right=h[E][1];break;case 0:h[E-1][1].mid=h[E][1];break}else this._root=h[0][1]}}return u}get(t){return this._getNode(t)?.value}_getNode(t){const c=this._iter.reset(t);let d=this._root;for(;d;){const s=c.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else break}return d}has(t){const c=this._getNode(t);return!(c?.value===void 0&&c?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,c){const d=this._iter.reset(t),s=[];let h=this._root;for(;h;){const u=d.cmp(h.segment);if(u>0)s.push([-1,h]),h=h.left;else if(u<0)s.push([1,h]),h=h.right;else if(d.hasNext())d.next(),s.push([0,h]),h=h.mid;else break}if(!!h){if(c?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this._min(h.right),{key:E,value:A,segment:R}=u;this._delete(u.key,!1),h.key=E,h.value=A,h.segment=R}else{const u=h.left??h.right;if(s.length>0){const[E,A]=s[s.length-1];switch(E){case-1:A.left=u;break;case 0:A.mid=u;break;case 1:A.right=u;break}}else this._root=u}for(let u=s.length-1;u>=0;u--){const E=s[u][1];E.updateHeight();const A=E.balanceFactor();if(A>1?(E.right.balanceFactor()>=0||(E.right=s[u+1][1]=s[u+1][1].rotateRight()),s[u][1]=E.rotateLeft()):A<-1&&(E.left.balanceFactor()<=0||(E.left=s[u+1][1]=s[u+1][1].rotateLeft()),s[u][1]=E.rotateRight()),u>0)switch(s[u-1][0]){case-1:s[u-1][1].left=s[u][1];break;case 1:s[u-1][1].right=s[u][1];break;case 0:s[u-1][1].mid=s[u][1];break}else this._root=s[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const c=this._iter.reset(t);let d=this._root,s;for(;d;){const h=c.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(c.hasNext())c.next(),s=d.value||s,d=d.mid;else break}return d&&d.value||s}findSuperstr(t){const c=this._iter.reset(t);let d=this._root;for(;d;){const s=c.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(t){for(const[c,d]of this)t(d,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=c=>{if(!c)return!0;const d=c.balanceFactor();return d<-1||d>1?!1:t(c.left)&&t(c.right)};return t(this._root)}}e.TernarySearchTree=P;class p{constructor(t,c){this.uri=t,this.value=c}}class l{constructor(t,c){this[D]="ResourceMap",t instanceof l?(this.map=new Map(t.map),this.toKey=c??l.defaultToKey):(this.map=new Map,this.toKey=t??l.defaultToKey)}set(t,c){return this.map.set(this.toKey(t),new p(t,c)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,c){typeof c!="undefined"&&(t=t.bind(c));for(let[d,s]of this.map)t(s.value,s.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=l,l.defaultToKey=i=>i.toString();var r;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,c=0){const d=this._map.get(t);if(!!d)return c!==0&&this.touch(d,c),d.value}set(t,c,d=0){let s=this._map.get(t);if(s)s.value=c,d!==0&&this.touch(s,d);else{switch(s={key:t,value:c,next:void 0,previous:void 0},d){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(t,s),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this._map.get(t);if(!!c)return this._map.delete(t),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,c){const d=this._state;let s=this._head;for(;s;){if(c?t.bind(c)(s.value,s.key,this):t(s.value,s.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,c=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.key,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return s}values(){const t=this,c=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.value,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return s}entries(){const t=this,c=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:[d.key,d.value],done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return s}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._head,d=this.size;for(;c&&d>t;)this._map.delete(c.key),c=c.next,d--;this._head=c,this._size=d,c&&(c.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const c=t.next,d=t.previous;if(!c||!d)throw new Error("Invalid list");c.previous=d,d.next=c}t.next=void 0,t.previous=void 0,this._state++}touch(t,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this._head)return;const d=t.next,s=t.previous;t===this._tail?(s.next=void 0,this._tail=s):(d.previous=s,s.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(c===2){if(t===this._tail)return;const d=t.next,s=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=s,s.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((c,d)=>{t.push([d,c])}),t}fromJSON(t){this.clear();for(const[c,d]of t)this.set(c,d)}}e.LinkedMap=g;class o extends g{constructor(t,c=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class b{constructor(t){n.set(this,void 0),ot(this,n,t,"f")}get size(){return Oe(this,n,"f").size}forEach(t,c){Oe(this,n,"f").forEach(t,c)}get(t){return Oe(this,n,"f").get(t)}has(t){return Oe(this,n,"f").has(t)}entries(){return Oe(this,n,"f").entries()}keys(){return Oe(this,n,"f").keys()}values(){return Oe(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Oe(this,n,"f").entries()}}e.ReadonlyMapView=b}),define(me[97],ge([0,1,24,8]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(te,ve){for(let Me=0,je=J.length;Me<je;Me++){const Ke=J[Me](te,ve);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(J,te,ve){if(!ve||ve.length<te.length)return null;let Me;return J?Me=L.startsWithIgnoreCase(ve,te):Me=ve.indexOf(te)===0,Me?te.length>0?[{start:0,end:te.length}]:[]:null}function n(J,te){const ve=te.toLowerCase().indexOf(J.toLowerCase());return ve===-1?null:[{start:ve,end:ve+J.length}]}e.matchesContiguousSubString=n;function k(J,te){return S(J.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=k;function S(J,te,ve,Me){if(ve===J.length)return[];if(Me===te.length)return null;if(J[ve]===te[Me]){let je=null;return(je=S(J,te,ve+1,Me+1))?P({start:Me,end:Me+1},je):null}return S(J,te,ve,Me+1)}function y(J){return 97<=J&&J<=122}function T(J){return 65<=J&&J<=90}e.isUpper=T;function I(J){return 48<=J&&J<=57}function a(J){return J===32||J===9||J===10||J===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>w.add(J.charCodeAt(0)));function f(J){return a(J)||w.has(J)}function v(J,te){return J===te||f(J)&&f(te)}function _(J){return y(J)||T(J)||I(J)}function P(J,te){return te.length===0?te=[J]:J.end===te[0].start?te[0].start=J.start:te.unshift(J),te}function p(J,te){for(let ve=te;ve<J.length;ve++){const Me=J.charCodeAt(ve);if(T(Me)||I(Me)||ve>0&&!_(J.charCodeAt(ve-1)))return ve}return J.length}function l(J,te,ve,Me){if(ve===J.length)return[];if(Me===te.length)return null;if(J[ve]!==te[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=l(J,te,ve+1,Me+1);!je&&(Ke=p(te,Ke))<te.length;)je=l(J,te,ve+1,Ke),Ke++;return je===null?null:P({start:Me,end:Me+1},je)}}function r(J){let te=0,ve=0,Me=0,je=0,Ke=0;for(let st=0;st<J.length;st++)Ke=J.charCodeAt(st),T(Ke)&&te++,y(Ke)&&ve++,_(Ke)&&Me++,I(Ke)&&je++;const Ze=te/J.length,rt=ve/J.length,ut=Me/J.length,it=je/J.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ut,numericPercent:it}}function g(J){const{upperPercent:te,lowerPercent:ve}=J;return ve===0&&te>.6}function o(J){const{upperPercent:te,lowerPercent:ve,alphaPercent:Me,numericPercent:je}=J;return ve>.2&&te<.8&&Me>.6&&je<.2}function b(J){let te=0,ve=0,Me=0,je=0;for(let Ke=0;Ke<J.length;Ke++)Me=J.charCodeAt(Ke),T(Me)&&te++,y(Me)&&ve++,a(Me)&&je++;return(te===0||ve===0)&&je===0?J.length<=30:te<=5}function i(J,te){if(!te||(te=te.trim(),te.length===0)||!b(J)||te.length>60)return null;const ve=r(te);if(!o(ve)){if(!g(ve))return null;te=te.toLowerCase()}let Me=null,je=0;for(J=J.toLowerCase();je<te.length&&(Me=l(J,te,0,je))===null;)je=p(te,je+1);return Me}e.matchesCamelCase=i;function t(J,te,ve=!1){if(!te||te.length===0)return null;let Me=null,je=0;for(J=J.toLowerCase(),te=te.toLowerCase();je<te.length&&(Me=c(J,te,0,je,ve))===null;)je=d(te,je+1);return Me}e.matchesWords=t;function c(J,te,ve,Me,je){if(ve===J.length)return[];if(Me===te.length)return null;if(v(J.charCodeAt(ve),te.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=c(J,te,ve+1,Me+1,je),!je)for(;!Ke&&(Ze=d(te,Ze))<te.length;)Ke=c(J,te,ve+1,Ze,je),Ze++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function d(J,te){for(let ve=te;ve<J.length;ve++)if(f(J.charCodeAt(ve))||ve>0&&f(J.charCodeAt(ve-1)))return ve;return J.length}const s=D(e.matchesPrefix,i,n),h=D(e.matchesPrefix,i,k),u=new m.LRUCache(1e4);function E(J,te,ve=!1){if(typeof J!="string"||typeof te!="string")return null;let Me=u.get(J);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(J),"i"),u.set(J,Me));const je=Me.exec(te);return je?[{start:je.index,end:je.index+je[0].length}]:ve?h(J,te):s(J,te)}e.matchesFuzzy=E;function A(J,te){const ve=Be(J,J.toLowerCase(),0,te,te.toLowerCase(),0,!0);return ve?$(ve):null}e.matchesFuzzy2=A;function R(J,te,ve,Me,je,Ke){const Ze=Math.min(13,J.length);for(;ve<Ze;ve++){const rt=Be(J,te,ve,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function $(J){if(typeof J=="undefined")return[];const te=[],ve=J[1];for(let Me=J.length-1;Me>1;Me--){const je=J[Me]+ve,Ke=te[te.length-1];Ke&&Ke.end===je?Ke.end=je+1:te.push({start:je,end:je+1})}return te}e.createMatches=$;const N=128;function F(){const J=[],te=[];for(let ve=0;ve<=N;ve++)te[ve]=0;for(let ve=0;ve<=N;ve++)J.push(te.slice(0));return J}function z(J){const te=[];for(let ve=0;ve<=J;ve++)te[ve]=0;return te}const M=z(2*N),W=z(2*N),U=F(),x=F(),B=F(),O=!1;function H(J,te,ve,Me,je){function Ke(rt,ut,it=" "){for(;rt.length<ut;)rt=it+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=ve;rt++)rt===0?Ze+=" |":Ze+=`${te[rt-1]}|`,Ze+=J[rt].slice(0,je+1).map(ut=>Ke(ut.toString(),3)).join("|")+`
`;return Ze}function j(J,te,ve,Me){J=J.substr(te),ve=ve.substr(Me),console.log(H(x,J,J.length,ve,ve.length)),console.log(H(B,J,J.length,ve,ve.length)),console.log(H(U,J,J.length,ve,ve.length))}function X(J,te){if(te<0||te>=J.length)return!1;const ve=J.codePointAt(te);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function K(J,te){if(te<0||te>=J.length)return!1;switch(J.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function he(J,te,ve){return te[J]!==ve[J]}function Ee(J,te,ve,Me,je,Ke,Ze=!1){for(;te<ve&&je<Ke;)J[te]===Me[je]&&(Ze&&(M[te]=je),te+=1),je+=1;return te===ve}e.isPatternInWord=Ee;var De;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(De||(De={}));var Pe;(function(J){J.Default=[-100,0];function te(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}J.isDefault=te})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(J,te,ve,Me,je,Ke,Ze){const rt=J.length>N?N:J.length,ut=Me.length>N?N:Me.length;if(ve>=rt||Ke>=ut||rt-ve>ut-Ke||!Ee(te,ve,rt,je,Ke,ut,!0))return;He(rt,ut,ve,Ke,te,je);let it=1,st=1,Ae=ve,wt=Ke;const ee=[!1];for(it=1,Ae=ve;Ae<rt;it++,Ae++){const nt=M[Ae],de=W[Ae],ke=Ae+1<rt?W[Ae+1]:ut;for(st=nt-Ke+1,wt=nt;wt<ke;st++,wt++){let Ue=Number.MIN_SAFE_INTEGER,$e=!1;wt<=de&&(Ue=ze(J,te,Ae,ve,Me,je,wt,ut,Ke,U[it-1][st-1]===0,ee));let tt=0;Ue!==Number.MAX_SAFE_INTEGER&&($e=!0,tt=Ue+x[it-1][st-1]);const Te=wt>nt,Ce=Te?x[it][st-1]+(U[it][st-1]>0?-5:0):0,we=wt>nt+1&&U[it][st-1]>0,oe=we?x[it][st-2]+(U[it][st-2]>0?-5:0):0;if(we&&(!Te||oe>=Ce)&&(!$e||oe>=tt))x[it][st]=oe,B[it][st]=3,U[it][st]=0;else if(Te&&(!$e||Ce>=tt))x[it][st]=Ce,B[it][st]=2,U[it][st]=0;else if($e)x[it][st]=tt,B[it][st]=1,U[it][st]=U[it-1][st-1]+1;else throw new Error("not possible")}}if(O&&j(J,ve,Me,Ke),!ee[0]&&!Ze)return;it--,st--;const re=[x[it][st],Ke];let Se=0,Ge=0;for(;it>=1;){let nt=st;do{const de=B[it][nt];if(de===3)nt=nt-2;else if(de===2)nt=nt-1;else break}while(nt>=1);Se>1&&te[ve+it-1]===je[Ke+st-1]&&!he(nt+Ke-1,Me,je)&&Se+1>U[it][nt]&&(nt=st),nt===st?Se++:Se=1,Ge||(Ge=nt),it--,st=nt-1,re.push(st)}ut===rt&&(re[0]+=2);const Ye=Ge-rt;return re[0]-=Ye,re}e.fuzzyScore=Be;function He(J,te,ve,Me,je,Ke){let Ze=J-1,rt=te-1;for(;Ze>=ve&&rt>=Me;)je[Ze]===Ke[rt]&&(W[Ze]=rt,Ze--),rt--}function ze(J,te,ve,Me,je,Ke,Ze,rt,ut,it,st){if(te[ve]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let Ae=1,wt=!1;return Ze===ve-Me?Ae=J[ve]===je[Ze]?7:5:he(Ze,je,Ke)&&(Ze===0||!he(Ze-1,je,Ke))?(Ae=J[ve]===je[Ze]?7:5,wt=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?Ae=5:(X(Ke,Ze-1)||K(Ke,Ze-1))&&(Ae=5,wt=!0),Ae>1&&ve===Me&&(st[0]=!0),wt||(wt=he(Ze,je,Ke)||X(Ke,Ze-1)||K(Ke,Ze-1)),ve===Me?Ze>ut&&(Ae-=wt?3:5):it?Ae+=wt?2:0:Ae+=wt?0:1,Ze+1===rt&&(Ae-=wt?3:5),Ae}function G(J,te,ve,Me,je,Ke,Ze){return ne(J,te,ve,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function Z(J,te,ve,Me,je,Ke,Ze){return ne(J,te,ve,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=Z;function ne(J,te,ve,Me,je,Ke,Ze,rt){let ut=Be(J,te,ve,Me,je,Ke,rt);if(ut&&!Ze)return ut;if(J.length>=3){const it=Math.min(7,J.length-1);for(let st=ve+1;st<it;st++){const Ae=ce(J,st);if(Ae){const wt=Be(Ae,Ae.toLowerCase(),ve,Me,je,Ke,rt);wt&&(wt[0]-=3,(!ut||wt[0]>ut[0])&&(ut=wt))}}}return ut}function ce(J,te){if(te+1>=J.length)return;const ve=J[te],Me=J[te+1];if(ve!==Me)return J.slice(0,te)+Me+ve+J.slice(te+2)}}),define(me[141],ge([0,1,78,97,8]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),n=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function S(_){return _.replace(k,(P,p)=>p?P:`\\${P}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function T(_){return _.replace(y,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=T;const I=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function a(_){return _.indexOf(e.iconStartMarker)===-1?_:_.replace(I,(P,p,l,r)=>l?P:p||r||"")}e.stripIcons=a;function w(_){const P=_.indexOf(e.iconStartMarker);return P===-1?{text:_}:f(_,P)}e.parseLabelWithIcons=w;function f(_,P){const p=[];let l="";function r(s){if(s){l+=s;for(const h of s)p.push(b)}}let g=-1,o="",b=0,i,t,c=P;const d=_.length;for(r(_.substr(0,P));c<d;)i=_[c],t=_[c+1],i===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=c,r(o),o=e.iconStartMarker,c++):i===")"&&g!==-1?(b+=c-g+1,g=-1,o=""):g!==-1?n.test(i)?o+=i:(r(o),g=-1,o=""):r(i),c++;return r(o),{text:l,iconOffsets:p}}function v(_,P,p=!1){const{text:l,iconOffsets:r}=P;if(!r||r.length===0)return(0,L.matchesFuzzy)(_,l,p);const g=(0,D.ltrim)(l," "),o=l.length-g.length,b=(0,L.matchesFuzzy)(_,g,p);if(b)for(const i of b){const t=r[i.start+o]+o;i.start+=t,i.end+=t}return b}e.matchesFuzzyIconAware=v}),define(me[98],ge([0,1,15,141]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(w="",f=!1){if(this.value=w,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(w,f=0){return this.value+=y(this.supportThemeIcons?(0,L.escapeIcons)(w):w).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,f){return this.value+="\n```",this.value+=w,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}}e.MarkdownString=C;function n(a){return k(a)?!a.value:Array.isArray(a)?a.every(n):!0}e.isEmptyMarkdownString=n;function k(a){return a instanceof C?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function S(a,w){return a===w?!0:!a||!w?!1:a.value===w.value&&a.isTrusted===w.isTrusted&&a.supportThemeIcons===w.supportThemeIcons}e.markdownStringEqual=S;function y(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function T(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=T;function I(a){const w=[],f=a.split("|").map(_=>_.trim());a=f[0];const v=f[1];if(v){const _=/height=(\d+)/.exec(v),P=/width=(\d+)/.exec(v),p=_?_[1]:"",l=P?P[1]:"",r=isFinite(parseInt(l)),g=isFinite(parseInt(p));r&&w.push(`width="${l}"`),g&&w.push(`height="${p}"`)}return{href:a,dimensions:w}}e.parseHrefAndDimensions=I}),define(me[79],ge([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function D(y){return S(y,"NFC",L)}e.normalizeNFC=D;const C=new m.LRUCache(1e4);function n(y){return S(y,"NFD",C)}e.normalizeNFD=n;const k=/[^\u0000-\u0080]/;function S(y,T,I){if(!y)return y;const a=I.get(y);if(a)return a;let w;return k.test(y)?w=y.normalize(T):w=y,I.set(y,w),w}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(T){return n(T).replace(y,"")}}()}),define(me[49],ge([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const C="error",n="warning",k="warn",S="info",y="ignore";function T(a){return a?m.equalsIgnoreCase(C,a)?D.Error:m.equalsIgnoreCase(n,a)||m.equalsIgnoreCase(k,a)?D.Warning:m.equalsIgnoreCase(S,a)?D.Info:D.Ignore:D.Ignore}D.fromValue=T;function I(a){switch(a){case D.Error:return C;case D.Warning:return n;case D.Info:return S;default:return y}}D.toString=I}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(h){return Array.isArray(h)}e.isArray=m;function L(h){return typeof h=="string"}e.isString=L;function D(h){return Array.isArray(h)&&h.every(u=>L(u))}e.isStringArray=D;function C(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=C;function n(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=n;function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=k;function S(h){return h===!0||h===!1}e.isBoolean=S;function y(h){return typeof h=="undefined"}e.isUndefined=y;function T(h){return!I(h)}e.isDefined=T;function I(h){return y(h)||h===null}e.isUndefinedOrNull=I;function a(h,u){if(!h)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=a;function w(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=w;function f(...h){const u=[];for(let E=0;E<h.length;E++){const A=h[E];if(I(A))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);u.push(A)}return u}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function _(h){if(!C(h))return!1;for(let u in h)if(v.call(h,u))return!1;return!0}e.isEmptyObject=_;function P(h){return typeof h=="function"}e.isFunction=P;function p(...h){return h.length>0&&h.every(P)}e.areFunctions=p;function l(h,u){const E=Math.min(h.length,u.length);for(let A=0;A<E;A++)r(h[A],u[A])}e.validateConstraints=l;function r(h,u){if(L(u)){if(typeof h!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(P(u)){try{if(h instanceof u)return}catch{}if(!I(h)&&h.constructor===u||u.length===1&&u.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function g(h){let u=[],E=Object.getPrototypeOf(h);for(;Object.prototype!==E;)u=u.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return u}e.getAllPropertyNames=g;function o(h){const u=[];for(const E of g(h))typeof h[E]=="function"&&u.push(E);return u}e.getAllMethodNames=o;function b(h,u){const E=R=>function(){const $=Array.prototype.slice.call(arguments,0);return u(R,$)};let A={};for(const R of h)A[R]=E(R);return A}e.createProxyObject=b;function i(h){return h===null?void 0:h}e.withNullAsUndefined=i;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function c(h){return class{constructor(){return new Proxy({},{get(u,E){if(u[E])return u[E];throw new Error(`Not Implemented: ${h}->${String(E)}`)}})}}}e.NotImplementedProxy=c;function d(h,u="Unreachable"){throw new Error(u)}e.assertNever=d;function s(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=s}),define(me[30],ge([0,1,9,11,8,13]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(i){return i===47||i===92}e.isPathSeparator=n;function k(i){return i.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function S(i){return i.indexOf("/")===-1&&(i=k(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function y(i,t=m.posix.sep){if(!i)return"";const c=i.length,d=i.charCodeAt(0);if(n(d)){if(n(i.charCodeAt(1))&&!n(i.charCodeAt(2))){let h=3;const u=h;for(;h<c&&!n(i.charCodeAt(h));h++);if(u!==h&&!n(i.charCodeAt(h+1))){for(h+=1;h<c;h++)if(n(i.charCodeAt(h)))return i.slice(0,h+1).replace(/[\\/]/g,t)}}return t}else if(P(d)&&i.charCodeAt(1)===58)return n(i.charCodeAt(2))?i.slice(0,2)+t:i.slice(0,2);let s=i.indexOf("://");if(s!==-1){for(s+=3;s<c;s++)if(n(i.charCodeAt(s)))return i.slice(0,s+1)}return""}e.getRoot=y;function T(i){if(!L.isWindows||!i||i.length<5)return!1;let t=i.charCodeAt(0);if(t!==92||(t=i.charCodeAt(1),t!==92))return!1;let c=2;const d=c;for(;c<i.length&&(t=i.charCodeAt(c),t!==92);c++);return!(d===c||(t=i.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=T;const I=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,t=L.isWindows){const c=t?I:a;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||t&&w.test(i)||i==="."||i===".."||t&&i[i.length-1]==="."||t&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function v(i,t,c){const d=i===t;return!c||d?d:!i||!t?!1:(0,D.equalsIgnoreCase)(i,t)}e.isEqual=v;function _(i,t,c,d=m.sep){if(i===t)return!0;if(!i||!t||t.length>i.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(i,t))return!1;if(t.length===i.length)return!0;let h=t.length;return t.charAt(t.length-1)===d&&h--,i.charAt(h)===d}return t.charAt(t.length-1)!==d&&(t+=d),i.indexOf(t)===0}e.isEqualOrParent=_;function P(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=P;function p(i,t){return L.isWindows&&i.endsWith(":")&&(i+=m.sep),(0,m.isAbsolute)(i)||(i=(0,m.join)(t,i)),i=(0,m.normalize)(i),L.isWindows?(i=(0,D.rtrim)(i,m.sep),i.endsWith(":")&&(i+=m.sep)):(i=(0,D.rtrim)(i,m.sep),i||(i=m.sep)),i}e.sanitizeFilePath=p;function l(i){const t=(0,m.normalize)(i);return L.isWindows?i.length>3?!1:r(t)&&(i.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=l;function r(i,t){return(t!==void 0?t:L.isWindows)?P(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function g(i){return r(i)?i[0]:void 0}e.getDriveLetter=g;function o(i,t,c){return t.length>i.length?-1:i===t?0:(c&&(i=i.toLowerCase(),t=t.toLowerCase()),i.indexOf(t))}e.indexOfPath=o;function b(i){const t=i.split(":");let c,d,s;if(t.forEach(h=>{const u=Number(h);(0,C.isNumber)(u)?d===void 0?d=u:s===void 0&&(s=u):c=c?[c,h].join(":"):h}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:s!==void 0?s:d!==void 0?1:void 0}}e.parseLineAndColumnAware=b}),define(me[25],ge([0,1,13]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(P=>{v[P]&&typeof v[P]=="object"?_[P]=L(v[P]):_[P]=v[P]}),_}e.deepClone=L;function D(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const P=_.shift();Object.freeze(P);for(const p in P)if(C.call(P,p)){const l=P[p];typeof l=="object"&&!Object.isFrozen(l)&&_.push(l)}}return v}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function n(v,_){return k(v,_,new Set)}e.cloneAndChange=n;function k(v,_,P){if((0,m.isUndefinedOrNull)(v))return v;const p=_(v);if(typeof p!="undefined")return p;if((0,m.isArray)(v)){const l=[];for(const r of v)l.push(k(r,_,P));return l}if((0,m.isObject)(v)){if(P.has(v))throw new Error("Cannot clone recursive data-structure");P.add(v);const l={};for(let r in v)C.call(v,r)&&(l[r]=k(v[r],_,P));return P.delete(v),l}return v}function S(v,_,P=!0){return(0,m.isObject)(v)?((0,m.isObject)(_)&&Object.keys(_).forEach(p=>{p in v?P&&((0,m.isObject)(v[p])&&(0,m.isObject)(_[p])?S(v[p],_[p],P):v[p]=_[p]):v[p]=_[p]}),v):_}e.mixin=S;function y(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let P,p;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(P=0;P<v.length;P++)if(!y(v[P],_[P]))return!1}else{const l=[];for(p in v)l.push(p);l.sort();const r=[];for(p in _)r.push(p);if(r.sort(),!y(l,r))return!1;for(P=0;P<l.length;P++)if(!y(v[l[P]],_[l[P]]))return!1}return!0}e.equals=y;function T(v){const _=new Set;return JSON.stringify(v,(P,p)=>{if((0,m.isObject)(p)||Array.isArray(p)){if(_.has(p))return"[Circular]";_.add(p)}return p})}e.safeStringify=T;function I(v,_,P){const p=_(v);return typeof p=="undefined"?P:p}e.getOrDefault=I;function a(v,_){const P=Object.create(null);return!v||!_||Object.keys(_).forEach(l=>{const r=v[l],g=_[l];y(r,g)||(P[l]=g)}),P}e.distinct=a;function w(v,_){const P=_.toLowerCase(),p=Object.keys(v).find(l=>l.toLowerCase()===P);return p?v[p]:v[_]}e.getCaseInsensitive=w;function f(v,_){const P=Object.create(null);for(const[p,l]of Object.entries(v))_(p,l)&&(P[p]=l);return P}e.filter=f}),define(me[99],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function D(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=D}),define(me[2],ge([0,1,9,11]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,n=/^\/\//;function k(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function y(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const T="",I="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(t,c,d,s,h,u=!1){typeof t=="object"?(this.scheme=t.scheme||T,this.authority=t.authority||T,this.path=t.path||T,this.query=t.query||T,this.fragment=t.fragment||T):(this.scheme=S(t,u),this.authority=c||T,this.path=y(this.scheme,d||T),this.query=s||T,this.fragment=h||T,k(this,u))}static isUri(t){return t instanceof w?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return l(this,!1)}with(t){if(!t)return this;let{scheme:c,authority:d,path:s,query:h,fragment:u}=t;return c===void 0?c=this.scheme:c===null&&(c=T),d===void 0?d=this.authority:d===null&&(d=T),s===void 0?s=this.path:s===null&&(s=T),h===void 0?h=this.query:h===null&&(h=T),u===void 0?u=this.fragment:u===null&&(u=T),c===this.scheme&&d===this.authority&&s===this.path&&h===this.query&&u===this.fragment?this:new v(c,d,s,h,u)}static parse(t,c=!1){const d=a.exec(t);return d?new v(d[2]||T,b(d[4]||T),b(d[5]||T),b(d[7]||T),b(d[9]||T),c):new v(T,T,T,T,T)}static file(t){let c=T;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const d=t.indexOf(I,2);d===-1?(c=t.substring(2),t=I):(c=t.substring(2,d),t=t.substring(d)||I)}return new v("file",c,t,T,T)}static from(t){const c=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return k(c,!0),c}static joinPath(t,...c){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&t.scheme==="file"?d=w.file(m.win32.join(l(t,!0),...c)).path:d=m.posix.join(t.path,...c),t.with({path:d})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof w)return t;{const c=new v(t);return c._formatted=t.external,c._fsPath=t._sep===f?t.fsPath:null,c}}else return t}}e.URI=w;const f=L.isWindows?1:void 0;class v extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=f),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(i,t){let c,d=-1;for(let s=0;s<i.length;s++){const h=i.charCodeAt(s);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)d!==-1&&(c+=encodeURIComponent(i.substring(d,s)),d=-1),c!==void 0&&(c+=i.charAt(s));else{c===void 0&&(c=i.substr(0,s));const u=_[h];u!==void 0?(d!==-1&&(c+=encodeURIComponent(i.substring(d,s)),d=-1),c+=u):d===-1&&(d=s)}}return d!==-1&&(c+=encodeURIComponent(i.substring(d))),c!==void 0?c:i}function p(i){let t;for(let c=0;c<i.length;c++){const d=i.charCodeAt(c);d===35||d===63?(t===void 0&&(t=i.substr(0,c)),t+=_[d]):t!==void 0&&(t+=i[c])}return t!==void 0?t:i}function l(i,t){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=l;function r(i,t){const c=t?p:P;let d="",{scheme:s,authority:h,path:u,query:E,fragment:A}=i;if(s&&(d+=s,d+=":"),(h||s==="file")&&(d+=I,d+=I),h){let R=h.indexOf("@");if(R!==-1){const $=h.substr(0,R);h=h.substr(R+1),R=$.indexOf(":"),R===-1?d+=c($,!1):(d+=c($.substr(0,R),!1),d+=":",d+=c($.substr(R+1),!1)),d+="@"}h=h.toLowerCase(),R=h.indexOf(":"),R===-1?d+=c(h,!1):(d+=c(h.substr(0,R),!1),d+=h.substr(R))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const R=u.charCodeAt(1);R>=65&&R<=90&&(u=`/${String.fromCharCode(R+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const R=u.charCodeAt(0);R>=65&&R<=90&&(u=`${String.fromCharCode(R+32)}:${u.substr(2)}`)}d+=c(u,!0)}return E&&(d+="?",d+=c(E,!1)),A&&(d+="#",d+=t?A:P(A,!1)),d}function g(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+g(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(i){return i.match(o)?i.replace(o,t=>g(t)):i}}),define(me[59],ge([0,1,22,8,2]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(T){return JSON.stringify(T,S)}e.stringify=C;function n(T){let I=JSON.parse(T);return I=y(I),I}e.parse=n;var k;(function(T){T[T.Uri=1]="Uri",T[T.Regexp=2]="Regexp",T[T.ScmResource=3]="ScmResource",T[T.ScmResourceGroup=4]="ScmResourceGroup",T[T.ScmProvider=5]="ScmProvider",T[T.CommentController=6]="CommentController",T[T.CommentThread=7]="CommentThread",T[T.CommentThreadReply=8]="CommentThreadReply",T[T.CommentNode=9]="CommentNode",T[T.CommentThreadNode=10]="CommentThreadNode",T[T.TimelineActionContext=11]="TimelineActionContext",T[T.NotebookCellActionContext=12]="NotebookCellActionContext",T[T.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function S(T,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function y(T,I=0){if(!T||I>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return D.URI.revive(T);case 2:return new RegExp(T.source,T.flags)}if(T instanceof m.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let a=0;a<T.length;++a)T[a]=y(T[a],I+1);else for(const a in T)Object.hasOwnProperty.call(T,a)&&(T[a]=y(T[a],I+1))}return T}e.revive=y}),define(me[10],ge([0,1,11,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,y,T){this._hosts[S]=y,this._ports[S]=T}setConnectionToken(S,y){this._connectionTokens[S]=y}rewrite(S){if(this._delegate)return this._delegate(S);const y=S.authority;let T=this._hosts[y];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const I=this._ports[y],a=this._connectionTokens[y];let w=`path=${encodeURIComponent(S.path)}`;return typeof a=="string"&&(w+=`&tkn=${encodeURIComponent(a)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${T}:${I}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new C;class n{asBrowserUri(S,y){const T=this.toUri(S,y);return T.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===D.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${D.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?T.with({scheme:D.vscodeFileResource,authority:T.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(S,y){const T=this.toUri(S,y);return T.scheme===D.vscodeFileResource?T.with({scheme:D.file,authority:T.authority!==n.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(S,y){return L.URI.isUri(S)?S:L.URI.parse(y.toUrl(S))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(me[23],ge([0,1,30,10,9,11,8,2]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(w){return(0,k.uriToFsPath)(w,!0)}e.originalFSPath=S;class y{constructor(f){this._ignorePathCasing=f}compare(f,v,_=!1){return f===v?0:(0,n.compare)(this.getComparisonKey(f,_),this.getComparisonKey(v,_))}isEqual(f,v,_=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,_)===this.getComparisonKey(v,_)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,_=!1){if(f.scheme===v.scheme){if(f.scheme===L.Schemas.file)return m.isEqualOrParent(S(f),S(v),this._ignorePathCasing(f))&&f.query===v.query&&(_||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return m.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(_||f.fragment===v.fragment)}return!1}joinPath(f,...v){return k.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(D.dirname(S(f))).path:(v=D.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(D.normalize(S(f))).path:v=D.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===L.Schemas.file){const p=D.relative(S(f),S(v));return C.isWindows?m.toSlashes(p):p}let _=f.path||"/",P=v.path||"/";if(this._ignorePathCasing(f)){let p=0;for(const l=Math.min(_.length,P.length);p<l&&!(_.charCodeAt(p)!==P.charCodeAt(p)&&_.charAt(p).toLowerCase()!==P.charAt(p).toLowerCase());p++);_=P.substr(0,p)+_.substr(p)}return D.posix.relative(_,P)}resolvePath(f,v){if(f.scheme===L.Schemas.file){const _=k.URI.file(D.resolve(S(f),v));return f.with({authority:_.authority,path:_.path})}return v=m.toPosixPath(v),f.with({path:D.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,n.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=D.sep){if(f.scheme===L.Schemas.file){const _=S(f);return _.length>m.getRoot(_).length&&_[_.length-1]===v}else{const _=f.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=D.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=D.sep){let _=!1;if(f.scheme===L.Schemas.file){const P=S(f);_=P!==void 0&&P.length===m.getRoot(P).length&&P[P.length-1]===v}else{v="/";const P=f.path;_=P.length===1&&P.charCodeAt(P.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(w=>w.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new y(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(w,f){const v=[];for(let _=0;_<w.length;_++){const P=f(w[_]);w.some((p,l)=>l===_?!1:(0,e.isEqualOrParent)(P,f(p)))||v.push(w[_])}return v}e.distinctParents=T;var I;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[r,g]=l.split(":");r&&g&&_.set(r,g)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&_.set(w.META_DATA_MIME,p),_}w.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function a(w,f,v){if(f){let _=w.path;return _&&_[0]!==D.posix.sep&&(_=D.posix.sep+_),w.with({scheme:v,authority:f,path:_})}return w.with({scheme:v})}e.toLocalResource=a}),define(me[18],ge([0,1,21,15,3,6,23,11]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(x){return!!x&&typeof x.then=="function"}e.isThenable=S;function y(x){const B=new m.CancellationTokenSource,O=x(B.token),H=new Promise((j,X)=>{const K=B.token.onCancellationRequested(()=>{K.dispose(),B.dispose(),X((0,L.canceled)())});Promise.resolve(O).then(he=>{K.dispose(),B.dispose(),j(he)},he=>{K.dispose(),B.dispose(),X(he)})});return new class{cancel(){B.cancel()}then(j,X){return H.then(j,X)}catch(j){return this.then(void 0,j)}finally(j){return H.finally(j)}}}e.createCancelablePromise=y;function T(x,B,O){return Promise.race([x,new Promise(H=>B.onCancellationRequested(()=>H(O)))])}e.raceCancellation=T;async function I(x){let B=-1;const O=x.map((j,X)=>j.then(K=>(B=X,K))),H=await Promise.race(O);return x.forEach((j,X)=>{X!==B&&j.cancel()}),H}e.raceCancellablePromises=I;function a(x,B,O){let H;const j=setTimeout(()=>{H?.(void 0),O?.()},B);return Promise.race([x.finally(()=>clearTimeout(j)),new Promise(X=>H=X)])}e.raceTimeout=a;function w(x){return new Promise((B,O)=>{const H=x();S(H)?H.then(B,O):B(H)})}e.asPromise=w;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const H=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,H};this.queuedPromise=new Promise(H=>{this.activePromise.then(O,O).then(H)})}return new Promise((O,H)=>{this.queuedPromise.then(O,H)})}return this.activePromise=B(),new Promise((O,H)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,H(j)})})}}e.Throttler=f;class v{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=v;class _{constructor(){this.promiseMap=new Map}queue(B,O){const j=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(B)===j&&this.promiseMap.delete(B)});return this.promiseMap.set(B,j),j}}e.SequencerByKey=_;class P{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,O=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,j)=>{this.doResolve=H,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class p{constructor(B){this.delayer=new P(B),this.throttler=new f}trigger(B,O){return this.delayer.trigger(()=>this.throttler.queue(B),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class l{constructor(){this._isOpen=!1,this._promise=new Promise((B,O)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class r extends l{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function g(x,B){return B?new Promise((O,H)=>{const j=setTimeout(()=>{X.dispose(),O()},x),X=B.onCancellationRequested(()=>{clearTimeout(j),X.dispose(),H((0,L.canceled)())})}):y(O=>g(x,O))}e.timeout=g;function o(x,B=0){const O=setTimeout(x,B);return(0,C.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=o;function b(x){const B=[];let O=0;const H=x.length;function j(){return O<H?x[O++]():null}function X(K){K!=null&&B.push(K);const he=j();return he?he.then(X):Promise.resolve(B)}return Promise.resolve(null).then(X)}e.sequence=b;function i(x,B=H=>!!H,O=null){let H=0;const j=x.length,X=()=>{if(H>=j)return Promise.resolve(O);const K=x[H++];return Promise.resolve(K()).then(Ee=>B(Ee)?Promise.resolve(Ee):X())};return X()}e.first=i;function t(x,B=H=>!!H,O=null){if(x.length===0)return Promise.resolve(O);let H=x.length;const j=()=>{H=-1;for(const X of x)X.cancel?.()};return new Promise((X,K)=>{for(const he of x)he.then(Ee=>{--H>=0&&B(Ee)?(j(),X(Ee)):H===0&&X(O)}).catch(Ee=>{--H>=0&&(j(),K(Ee))})})}e.firstParallel=t;class c{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((O,H)=>{this.outstandingPromises.push({factory:B,c:O,e:H}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const O=B.factory();O.then(B.c,B.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class d extends c{constructor(){super(1)}}e.Queue=d;class s{constructor(){this.queues=new Map}queueFor(B,O=n.extUri){const H=O.getComparisonKey(B);let j=this.queues.get(H);return j||(j=new d,D.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(H)}),this.queues.set(H,j)),j}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=s;class h{constructor(B,O){this._token=-1,typeof B=="function"&&typeof O=="number"&&this.setIfNotSet(B,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},O)}setIfNotSet(B,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},O))}}e.TimeoutTimer=h;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,O){this.cancel(),this._token=setInterval(()=>{B()},O)}}e.IntervalTimer=u;class E{constructor(B,O){this.timeoutToken=-1,this.runner=B,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class A{constructor(B,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class R extends E{constructor(B,O){super(B,O);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class $ extends C.Disposable{constructor(B,O,H,j){super();this.maxWorkChunkSize=B,this.maxPendingWork=O,this.throttleDelay=H,this.handler=j,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,k.setTimeout0)(()=>{if(B)return;const O=Date.now()+3;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.runWhenIdle=(x,B)=>{const O=requestIdleCallback(x,typeof B=="number"?{timeout:B}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(O))}}}}();class N{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function F(x,B,O){let H;for(let j=0;j<O;j++)try{return await x()}catch(X){H=X,await g(B)}throw H}e.retry=F;class z{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,O,H){return this._pending={taskId:B,cancel:()=>H?.(),promise:O},O.then(()=>this.donePending(B),()=>this.donePending(B)),O}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let O,H;const j=new Promise((X,K)=>{O=X,H=K});this._next={run:B,promise:j,promiseResolve:O,promiseReject:H}}return this._next.promise}}e.TaskSequentializer=z;class M{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,O)=>{this.completeCallback=B,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(O=>{this.completeCallback(B),this.resolved=!0,O()})}error(B){return new Promise(O=>{this.errorCallback(B),this.rejected=!0,O()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=W;var U;(function(x){async function B(H){let j;const X=await Promise.all(H.map(K=>K.then(he=>he,he=>{j||(j=he)})));if(typeof j!="undefined")throw j;return X}x.settled=B;function O(H){return new Promise(async(j,X)=>{try{await H(j,X)}catch(K){X(K)}})}x.withAsyncBody=O})(U=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,18,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new m.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),n=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,E,A=!1){const R=u||"",$=E||"",N=D.value.collator.compare(R,$);return D.value.collatorIsNumeric&&N===0&&R!==$?R<$?-1:1:N}e.compareFileNames=k;function S(u,E){const A=C.value.collator;return u=u||"",E=E||"",g(A,u,E)}e.compareFileNamesDefault=S;function y(u,E){const A=C.value.collator;return u=u||"",E=E||"",t(u,E)||g(A,u,E)}e.compareFileNamesUpper=y;function T(u,E){const A=C.value.collator;return u=u||"",E=E||"",i(u,E)||g(A,u,E)}e.compareFileNamesLower=T;function I(u,E){return u=u||"",E=E||"",u===E?0:u<E?-1:1}e.compareFileNamesUnicode=I;function a(u,E,A=!1){A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase());const[R,$]=l(u),[N,F]=l(E);return R!==N?R<N?-1:1:$===F?0:$<F?-1:1}e.noIntlCompareFileNames=a;function w(u,E){const[A,R]=l(u),[$,N]=l(E);let F=D.value.collator.compare(R,N);if(F===0){if(D.value.collatorIsNumeric&&R!==N)return R<N?-1:1;if(F=D.value.collator.compare(A,$),D.value.collatorIsNumeric&&F===0&&A!==$)return A<$?-1:1}return F}e.compareFileExtensions=w;function f(u,E){u=u||"",E=E||"";const A=r(u),R=r(E),$=C.value.collator,N=n.value.collator;return g(N,A,R)||g($,u,E)}e.compareFileExtensionsDefault=f;function v(u,E){u=u||"",E=E||"";const A=r(u),R=r(E),$=C.value.collator,N=n.value.collator;return g(N,A,R)||t(u,E)||g($,u,E)}e.compareFileExtensionsUpper=v;function _(u,E){u=u||"",E=E||"";const A=r(u),R=r(E),$=C.value.collator,N=n.value.collator;return g(N,A,R)||i(u,E)||g($,u,E)}e.compareFileExtensionsLower=_;function P(u,E){u=u||"",E=E||"";const A=r(u).toLowerCase(),R=r(E).toLowerCase();return A!==R?A<R?-1:1:u!==E?u<E?-1:1:0}e.compareFileExtensionsUnicode=P;const p=/^(.*?)(\.([^.]*))?$/;function l(u,E=!1){const A=u?p.exec(u):[];let R=[A&&A[1]||"",A&&A[3]||""];return E&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function r(u){const E=u?p.exec(u):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function g(u,E,A){let R=u.compare(E,A);return R!==0?R:E.length!==A.length?E.length<A.length?-1:1:0}function o(u){const E=u.charAt(0);return E.toLocaleUpperCase()!==E}function b(u){const E=u.charAt(0);return E.toLocaleLowerCase()!==E}function i(u,E){return o(u)&&b(E)?-1:b(u)&&o(E)?1:0}function t(u,E){return b(u)&&o(E)?-1:o(u)&&b(E)?1:0}function c(u,E,A=!1){return A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase()),u===E?0:u<E?-1:1}function d(u,E,A=!1){const R=u.split(L.sep),$=E.split(L.sep),N=R.length-1,F=$.length-1;let z,M;for(let W=0;;W++){if(z=N===W,M=F===W,z&&M)return k(R[W],$[W],A);if(z)return-1;if(M)return 1;const U=c(R[W],$[W],A);if(U!==0)return U}}e.comparePaths=d;function s(u,E,A){const R=u.toLowerCase(),$=E.toLowerCase(),N=h(u,E,A);if(N)return N;const F=R.endsWith(A),z=$.endsWith(A);if(F!==z)return F?-1:1;const M=k(R,$);return M!==0?M:R.localeCompare($)}e.compareAnything=s;function h(u,E,A){const R=u.toLowerCase(),$=E.toLowerCase(),N=R.startsWith(A),F=$.startsWith(A);if(N!==F)return N?-1:1;if(N&&F){if(R.length<$.length)return-1;if(R.length>$.length)return 1}return 0}e.compareByPrefix=h}),define(me[101],ge([0,1,100,97,48,9,11,8]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,y=[S,[]];function T(U,x,B,O){if(!U||!x)return y;const H=U.length,j=x.length;if(H<j)return y;const X=U.toLowerCase();return I(x,B,j,U,X,H,O)}e.scoreFuzzy=T;function I(U,x,B,O,H,j,X){const K=[],he=[];for(let Be=0;Be<B;Be++){const He=Be*j,ze=He-j,G=Be>0,Z=U[Be],ne=x[Be];for(let ce=0;ce<j;ce++){const J=ce>0,te=He+ce,ve=te-1,Me=ze+ce-1,je=J?K[ve]:0,Ke=G&&J?K[Me]:0,Ze=G&&J?he[Me]:0;let rt;!Ke&&G?rt=0:rt=a(Z,ne,O,H,ce,Ze),rt&&Ke+rt>=je&&(X||G||H.startsWith(x,ce))?(he[te]=Ze+1,K[te]=Ke+rt):(he[te]=S,K[te]=je)}}const Ee=[];let De=B-1,Pe=j-1;for(;De>=0&&Pe>=0;){const Be=De*j+Pe;he[Be]===S||(Ee.push(Pe),De--),Pe--}return[K[B*j-1],Ee.reverse()]}function a(U,x,B,O,H,j){let X=0;if(!w(x,O[H]))return X;if(X+=1,j>0&&(X+=j*5),U===B[H]&&(X+=1),H===0)X+=8;else{const K=f(B.charCodeAt(H-1));K?X+=K:(0,L.isUpper)(B.charCodeAt(H))&&j===0&&(X+=2)}return X}function w(U,x){return U===x?!0:U==="/"||U==="\\"?x==="/"||x==="\\":!1}function f(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function _(U,x,B=0,O=0){const H=x;return H.values&&H.values.length>1?P(U,H.values,B,O):p(U,x,B,O)}e.scoreFuzzy2=_;function P(U,x,B,O){let H=0;const j=[];for(const X of x){const[K,he]=p(U,X,B,O);if(typeof K!="number")return v;H+=K,j.push(...he)}return[H,h(j)]}function p(U,x,B,O){const H=(0,L.fuzzyScore)(x.original,x.originalLowercase,B,U,U.toLowerCase(),O,!0);return H?[H[0],(0,L.createMatches)(H)]:v}const l=Object.freeze({score:0}),r=1<<18,g=1<<17,o=1<<16;function b(U,x,B,O){const H=O.values?O.values:[O];return(0,D.hash)({[O.normalized]:{values:H.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:U,description:x,allowNonContiguousMatches:B}})}function i(U,x,B,O,H){if(!U||!x.normalized)return l;const j=O.getItemLabel(U);if(!j)return l;const X=O.getItemDescription(U),K=b(j,X,B,x),he=H[K];if(he)return he;const Ee=t(j,X,O.getItemPath(U),x,B);return H[K]=Ee,Ee}e.scoreItemFuzzy=i;function t(U,x,B,O,H){const j=!B||!O.containsPathSeparator;return B&&(n.isLinux?O.pathNormalized===B:(0,k.equalsIgnoreCase)(O.pathNormalized,B))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:O.values&&O.values.length>1?c(U,x,B,O.values,j,H):d(U,x,B,O,j,H)}function c(U,x,B,O,H,j){let X=0;const K=[],he=[];for(const Ee of O){const{score:De,labelMatch:Pe,descriptionMatch:Be}=d(U,x,B,Ee,H,j);if(De===S)return l;X+=De,Pe&&K.push(...Pe),Be&&he.push(...Be)}return{score:X,labelMatch:h(K),descriptionMatch:h(he)}}function d(U,x,B,O,H,j){if(H||!x){const[X,K]=T(U,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(X){const he=(0,L.matchesPrefix)(O.normalized,U);let Ee;return he?(Ee=g,Ee+=Math.round(O.normalized.length/U.length*100)):Ee=o,{score:Ee+X,labelMatch:he||s(K)}}}if(x){let X=x;B&&(X=`${x}${C.sep}`);const K=X.length,he=`${X}${U}`,[Ee,De]=T(he,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(Ee){const Pe=s(De),Be=[],He=[];return Pe.forEach(ze=>{ze.start<K&&ze.end>K?(Be.push({start:0,end:ze.end-K}),He.push({start:ze.start,end:K})):ze.start>=K?Be.push({start:ze.start-K,end:ze.end-K}):He.push(ze)}),{score:Ee,labelMatch:Be,descriptionMatch:He}}}return l}function s(U){const x=[];if(!U)return x;let B;for(const O of U)B&&B.end===O?B.end+=1:(B={start:O,end:O+1},x.push(B));return x}function h(U){const x=U.sort((H,j)=>H.start-j.start),B=[];let O;for(const H of x)!O||!u(O,H)?(O=H,B.push(H)):(O.start=Math.min(O.start,H.start),O.end=Math.max(O.end,H.end));return B}function u(U,x){return!(U.end<x.start||x.end<U.start)}function E(U,x,B,O,H,j){const X=i(U,B,O,H,j),K=i(x,B,O,H,j),he=X.score,Ee=K.score;if((he===r||Ee===r)&&he!==Ee)return he===r?-1:1;if(he>o||Ee>o){if(he!==Ee)return he>Ee?-1:1;if(he<g&&Ee<g){const Z=R(X.labelMatch,K.labelMatch);if(Z!==0)return Z}const ze=H.getItemLabel(U)||"",G=H.getItemLabel(x)||"";if(ze.length!==G.length)return ze.length-G.length}if(he!==Ee)return he>Ee?-1:1;const De=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(K.labelMatch)&&K.labelMatch.length>0;if(De&&!Pe)return-1;if(Pe&&!De)return 1;const Be=A(U,X,H),He=A(x,K,H);return Be&&He&&Be!==He?He>Be?-1:1:$(U,x,B,H)}e.compareItemsByFuzzyScore=E;function A(U,x,B){let O=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?O=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(O=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const j=B.getItemDescription(U);j&&(H+=j.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-O}function R(U,x){if(!U&&!x||(!U||!U.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!U||!U.length)return 1;const B=U[0].start,H=U[U.length-1].end-B,j=x[0].start,K=x[x.length-1].end-j;return H===K?0:K<H?1:-1}function $(U,x,B,O){const H=O.getItemLabel(U)||"",j=O.getItemLabel(x)||"",X=O.getItemDescription(U),K=O.getItemDescription(x),he=H.length+(X?X.length:0),Ee=j.length+(K?K.length:0);if(he!==Ee)return he-Ee;const De=O.getItemPath(U),Pe=O.getItemPath(x);return De&&Pe&&De.length!==Pe.length?De.length-Pe.length:H!==j?(0,m.compareAnything)(H,j,B.normalized):X&&K&&X!==K?(0,m.compareAnything)(X,K,B.normalized):De&&Pe&&De!==Pe?(0,m.compareAnything)(De,Pe,B.normalized):0}function N(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function z(U){typeof U!="string"&&(U="");const x=U.toLowerCase(),{pathNormalized:B,normalized:O,normalizedLowercase:H}=M(U),j=B.indexOf(C.sep)>=0,X=N(U);let K;const he=U.split(F);if(he.length>1)for(const Ee of he){const De=N(Ee),{pathNormalized:Pe,normalized:Be,normalizedLowercase:He}=M(Ee);Be&&(K||(K=[]),K.push({original:Ee,originalLowercase:Ee.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:He,expectContiguousMatch:De}))}return{original:U,originalLowercase:x,pathNormalized:B,normalized:O,normalizedLowercase:H,values:K,containsPathSeparator:j,expectContiguousMatch:X}}e.prepareQuery=z;function M(U){let x;n.isWindows?x=U.replace(/\//g,C.sep):x=U.replace(/\\/g,C.sep);const B=(0,k.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:B,normalizedLowercase:B.toLowerCase()}}function W(U){return Array.isArray(U)?z(U.map(x=>x.original).join(F)):z(U.original)}e.pieceToQuery=W}),define(me[31],ge([0,1,18,30,24,9,8]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const S="**",y="/",T="[/\\\\]",I="[^/\\\\]",a=/\//g;function w(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${T}|${I}+${T}|${T}${I}+)*?`}}function f(O,H){if(!O)return[];const j=[];let X=!1,K=!1,he="";for(const Ee of O){switch(Ee){case H:if(!X&&!K){j.push(he),he="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":K=!0;break;case"]":K=!1;break}he+=Ee}return he&&j.push(he),j}e.splitGlobAware=f;function v(O){if(!O)return"";let H="";const j=f(O,y);if(j.every(X=>X===S))H=".*";else{let X=!1;j.forEach((K,he)=>{if(K===S){X||(H+=w(2),X=!0);return}let Ee=!1,De="",Pe=!1,Be="";for(const He of K){if(He!=="}"&&Ee){De+=He;continue}if(Pe&&(He!=="]"||!Be)){let ze;He==="-"?ze=He:(He==="^"||He==="!")&&!Be?ze="^":He===y?ze="":ze=n.escapeRegExpCharacters(He),Be+=ze;continue}switch(He){case"{":Ee=!0;continue;case"[":Pe=!0;continue;case"}":H+=`(?:${f(De,",").map(Z=>v(Z)).join("|")})`,Ee=!1,De="";break;case"]":H+="["+Be+"]",Pe=!1,Be="";break;case"?":H+=I;continue;case"*":H+=w(1);continue;default:H+=n.escapeRegExpCharacters(He)}}he<j.length-1&&(j[he+1]!==S||he+2<j.length)&&(H+=T),X=!1})}return H}const _=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new D.LRUCache(1e4),b=function(){return!1},i=function(){return null};function t(O,H){if(!O)return i;let j;typeof O!="string"?j=O.pattern:j=O,j=j.trim();const X=`${j}_${!!H.trimForExclusions}`;let K=o.get(X);if(K)return c(K,O);let he;if(_.test(j)){const Ee=j.substr(4);K=function(De,Pe){return typeof De=="string"&&De.endsWith(Ee)?j:null}}else(he=P.exec(d(j,H)))?K=s(he[1],j):(H.trimForExclusions?l:p).test(j)?K=h(j,H):(he=r.exec(d(j,H)))?K=u(he[1].substr(1),j,!0):(he=g.exec(d(j,H)))?K=u(he[1],j,!1):K=E(j);return o.set(X,K),c(K,O)}function c(O,H){return typeof H=="string"?O:function(j,X){return L.isEqualOrParent(j,H.base)?O(C.relative(H.base,j),X):null}}function d(O,H){return H.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function s(O,H){const j=`/${O}`,X=`\\${O}`,K=function(Ee,De){return typeof Ee!="string"?null:De?De===O?H:null:Ee===O||Ee.endsWith(j)||Ee.endsWith(X)?H:null},he=[O];return K.basenames=he,K.patterns=[H],K.allBasenames=he,K}function h(O,H){const j=B(O.slice(1,-1).split(",").map(De=>t(De,H)).filter(De=>De!==i),O),X=j.length;if(!X)return i;if(X===1)return j[0];const K=function(De,Pe){for(let Be=0,He=j.length;Be<He;Be++)if(j[Be](De,Pe))return O;return null},he=j.find(De=>!!De.allBasenames);he&&(K.allBasenames=he.allBasenames);const Ee=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Ee.length&&(K.allPaths=Ee),K}function u(O,H,j){const X=C.sep===C.posix.sep,K=X?O:O.replace(a,C.sep),he=C.sep+K,Ee=C.posix.sep+O,De=j?function(Pe,Be){return typeof Pe=="string"&&(Pe===K||Pe.endsWith(he)||!X&&(Pe===O||Pe.endsWith(Ee)))?H:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===K||!X&&Pe===O)?H:null};return De.allPaths=[(j?"*/":"./")+O],De}function E(O){try{const H=new RegExp(`^${v(O)}$`);return function(j){return H.lastIndex=0,typeof j=="string"&&H.test(j)?O:null}}catch(H){return i}}function A(O,H,j){return!O||typeof H!="string"?!1:R(O)(H,void 0,j)}e.match=A;function R(O,H={}){if(!O)return b;if(typeof O=="string"||z(O)){const j=t(O,H);if(j===i)return b;const X=function(K,he){return!!j(K,he)};return j.allBasenames&&(X.allBasenames=j.allBasenames),j.allPaths&&(X.allPaths=j.allPaths),X}return U(O,H)}e.parse=R;function $(O){if(!O)return;let H;return j=>(H||(H=(O()||Promise.resolve([])).then(X=>X?F(X):{})),H.then(X=>!!X[j]))}e.hasSiblingPromiseFn=$;function N(O){if(!O)return;let H;return j=>{if(!H){const X=O();H=X?F(X):{}}return!!H[j]}}e.hasSiblingFn=N;function F(O){const H={};for(const j of O)H[j]=!0;return H}function z(O){const H=O;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=z;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function W(O){return O.allPaths||[]}e.getPathTerms=W;function U(O,H){const j=B(Object.getOwnPropertyNames(O).map(De=>x(De,O[De],H)).filter(De=>De!==i)),X=j.length;if(!X)return i;if(!j.some(De=>!!De.requiresSiblings)){if(X===1)return j[0];const De=function(He,ze){for(let G=0,Z=j.length;G<Z;G++){const ne=j[G](He,ze);if(ne)return ne}return null},Pe=j.find(He=>!!He.allBasenames);Pe&&(De.allBasenames=Pe.allBasenames);const Be=j.reduce((He,ze)=>ze.allPaths?He.concat(ze.allPaths):He,[]);return Be.length&&(De.allPaths=Be),De}const K=function(De,Pe,Be){let He;for(let ze=0,G=j.length;ze<G;ze++){const Z=j[ze];Z.requiresSiblings&&Be&&(Pe||(Pe=C.basename(De)),He||(He=Pe.substr(0,Pe.length-C.extname(De).length)));const ne=Z(De,Pe,He,Be);if(ne)return ne}return null},he=j.find(De=>!!De.allBasenames);he&&(K.allBasenames=he.allBasenames);const Ee=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Ee.length&&(K.allPaths=Ee),K}function x(O,H,j){if(H===!1)return i;const X=t(O,j);if(X===i)return i;if(typeof H=="boolean")return X;if(H){const K=H.when;if(typeof K=="string"){const he=(Ee,De,Pe,Be)=>{if(!Be||!X(Ee,De))return null;const He=K.replace("$(basename)",Pe),ze=Be(He);return(0,m.isThenable)(ze)?ze.then(G=>G?O:null):ze?O:null};return he.requiresSiblings=!0,he}}return X}function B(O,H){const j=O.filter(De=>!!De.basenames);if(j.length<2)return O;const X=j.reduce((De,Pe)=>{const Be=Pe.basenames;return Be?De.concat(Be):De},[]);let K;if(H){K=[];for(let De=0,Pe=X.length;De<Pe;De++)K.push(H)}else K=j.reduce((De,Pe)=>{const Be=Pe.patterns;return Be?De.concat(Be):De},[]);const he=function(De,Pe){if(typeof De!="string")return null;if(!Pe){let He;for(He=De.length;He>0;He--){const ze=De.charCodeAt(He-1);if(ze===47||ze===92)break}Pe=De.substr(He)}const Be=X.indexOf(Pe);return Be!==-1?K[Be]:null};he.basenames=X,he.patterns=K,he.allBasenames=X;const Ee=O.filter(De=>!De.basenames);return Ee.push(he),Ee}}),define(me[80],ge([0,1,30,10,9,11,23,8,2]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(t,c,d){if(typeof t=="string"&&(t=S.URI.file(t)),d){const h=d.getWorkspaceFolder(t);if(h){const u=d.getWorkspace().folders.length>1;let E;if((0,n.isEqual)(h.uri,t)?E="":E=(0,n.relativePath)(h.uri,t),u){const A=h.name?h.name:(0,n.basename)(h.uri);E=E?A+" \u2022 "+E:A}return E}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,D.normalize)(I(t.fsPath));let s=(0,D.normalize)(t.fsPath);return!C.isWindows&&c?.userHome&&(s=w(s,c.userHome.fsPath)),s}e.getPathLabel=y;function T(t){if(!t)return;typeof t=="string"&&(t=S.URI.file(t));const c=(0,n.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(c)?I(c):c}e.getBaseLabel=T;function I(t,c){return(0,m.hasDriveLetter)(t,c)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let a=Object.create(null);function w(t,c){if(C.isWindows||!t||!c)return t;let d=a.original===c?a.normalized:void 0;return d||(d=`${(0,k.rtrim)(c,D.posix.sep)}${D.posix.sep}`,a={original:c,normalized:d}),(C.isLinux?t.startsWith(d):(0,k.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=w;function f(t,c){return t.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=f;const v="\u2026",_="\\\\",P="~";function p(t,c=D.sep){const d=new Array(t.length);let s=!1;for(let h=0;h<t.length;h++){let u=t[h];if(u===""){d[h]=`.${c}`;continue}if(!u){d[h]=u;continue}s=!0;let E="";u.indexOf(_)===0?(E=u.substr(0,u.indexOf(_)+_.length),u=u.substr(u.indexOf(_)+_.length)):u.indexOf(c)===0?(E=u.substr(0,u.indexOf(c)+c.length),u=u.substr(u.indexOf(c)+c.length)):u.indexOf(P)===0&&(E=u.substr(0,u.indexOf(P)+P.length),u=u.substr(u.indexOf(P)+P.length));const A=u.split(c);for(let R=1;s&&R<=A.length;R++)for(let $=A.length-R;s&&$>=0;$--){s=!1;let N=A.slice($,$+R).join(c);for(let F=0;!s&&F<t.length;F++)if(F!==h&&t[F]&&t[F].indexOf(N)>-1){const z=$+R===A.length,M=$>0&&t[F].indexOf(c)>-1?c+N:N,W=t[F].endsWith(M);s=!z||W}if(!s){let F="";(A[0].endsWith(":")||E!=="")&&($===1&&($=0,R++,N=A[0]+c+N),$>0&&(F=A[0]+c),F=E+F),$>0&&(F=F+v+c),F=F+N,$+R<A.length&&(F=F+c+v),d[h]=F}}s&&(d[h]=u)}return d}e.shorten=p;var l;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function r(t,c=Object.create(null)){const d=[];let s=!1,h="";for(const u of t)if(u==="$"||s&&u==="{")h&&d.push({value:h,type:l.TEXT}),h="",s=!0;else if(u==="}"&&s){const E=c[h];if(typeof E=="string")E.length&&d.push({value:E,type:l.VARIABLE});else if(E){const A=d[d.length-1];(!A||A.type!==l.SEPARATOR)&&d.push({value:E.label,type:l.SEPARATOR})}h="",s=!1}else h+=u;return h&&!s&&d.push({value:h,type:l.TEXT}),d.filter((u,E)=>{if(u.type===l.SEPARATOR){const A=d[E-1],R=d[E+1];return[A,R].every($=>$&&($.type===l.VARIABLE||$.type===l.TEXT)&&$.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=r;function g(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function o(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,d=>d==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function b(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=b;function i(t){const c=t.indexOf("/")!==-1?D.posix:D.win32,d=c.basename(t),s=c.dirname(t);return d.length?{name:d,parentPath:s}:{name:s,parentPath:""}}e.splitName=i}),define(me[102],ge([0,1,31,10,9,23,8]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let S=[],y=[],T=[];function I(t,c=!1){const d=a(t);S.push(d),d.userConfigured?T.push(d):y.push(d),c&&!d.userConfigured&&S.forEach(s=>{s.mime===d.mime||s.userConfigured||(d.extension&&s.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&s.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&s.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&s.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=I;function a(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function w(t){t?(S=S.filter(c=>!c.userConfigured),T=[]):(S=[],y=[],T=[])}e.clearTextMimes=w;function f(t,c){let d;if(t)switch(t.scheme){case L.Schemas.file:d=t.fsPath;break;case L.Schemas.data:d=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:d=t.path}if(!d)return[k.unknown];d=d.toLowerCase();const s=(0,D.basename)(d),h=v(d,s,T);if(h)return[h,k.text];const u=v(d,s,y);if(u)return[u,k.text];if(c){const E=_(c);if(E)return[E,k.text]}return[k.unknown]}e.guessMimeTypes=f;function v(t,c,d){let s=null,h=null,u=null;for(let E=d.length-1;E>=0;E--){const A=d[E];if(c===A.filenameLowercase){s=A;break}if(A.filepattern&&(!h||A.filepattern.length>h.filepattern.length)){const R=A.filepatternOnPath?t:c;A.filepatternLowercase?.(R)&&(h=A)}A.extension&&(!u||A.extension.length>u.extension.length)&&c.endsWith(A.extensionLowercase)&&(u=A)}return s?s.mime:h?h.mime:u?u.mime:null}function _(t){if((0,n.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let c=S.length-1;c>=0;c--){const d=S[c];if(!d.firstline)continue;const s=t.match(d.firstline);if(s&&s.length>0)return d.mime}return null}function P(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&P(t[0]):!0}e.isUnspecific=P;const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(t){const c=(0,D.extname)(t),d=p[c.toLowerCase()];return d!==void 0?d:g(t)}e.getMediaOrTextMime=r;function g(t){const c=(0,D.extname)(t);return l[c.toLowerCase()]}e.getMediaMime=g;function o(t){for(const c in l)if(l[c]===t)return c}e.getExtensionForMimeType=o;const b=/^(.+)\/(.+?)(;.+)?$/;function i(t,c){const d=b.exec(t);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:c?void 0:t}e.normalizeMimeType=i}),define(me[103],ge([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(T){return T.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const a=this._uriTransformer.transformIncoming(I);return a===I?I:L(m.URI.from(a))}transformOutgoing(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:L(m.URI.from(a))}transformOutgoingURI(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:m.URI.from(a)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function C(T,I,a){if(!T||a>200)return null;if(typeof T=="object"){if(T instanceof m.URI)return I.transformOutgoing(T);for(let w in T)if(Object.hasOwnProperty.call(T,w)){const f=C(T[w],I,a+1);f!==null&&(T[w]=f)}}return null}function n(T,I){const a=C(T,I,0);return a===null?T:a}e.transformOutgoingURIs=n;function k(T,I,a,w){if(!T||w>200)return null;if(typeof T=="object"){if(T.$mid===1)return a?m.URI.revive(I.transformIncoming(T)):I.transformIncoming(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const v=k(T[f],I,a,w+1);v!==null&&(T[f]=v)}}return null}function S(T,I){const a=k(T,I,!1,0);return a===null?T:a}e.transformIncomingURIs=S;function y(T,I){const a=k(T,I,!0,0);return a===null?T:a}e.transformAndReviveIncomingURIs=y}),define(me[32],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return m.test(S)}e.isUUID=L;const D=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(S){for(let y=0;y<S.length;y++)S[y]=Math.floor(Math.random()*256);return S};function k(){n(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,y="";return y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y}e.generateUuid=k}),define(me[142],ge([0,1,104]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const n=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return n;let S=0,y,T=S;for(;T<k.length;)if(y=k.charCodeAt(T),y===13||y===10){if(n.push(k.substring(S,T)),T++,T<k.length){const I=y;y=k.charCodeAt(T),(I===13&&y===10||I===10&&y===13)&&T++}S=T}else T++;return this.remaining=S<k.length?k.substr(S):null,n}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,60,81,289,18,30,79,9,11,23,2,32]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function f(M,W=w.UNLINK){if((0,n.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===w.UNLINK?_(M):v(M)}async function v(M){try{const W=(0,S.join)((0,L.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(M,W)}catch(U){return _(M)}_(W).catch(U=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function _(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function P(M){if((0,n.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(M,{recursive:!0})}e.rimrafSync=P;async function p(M,W){return g(await(W?l(M):(0,D.promisify)(m.readdir)(M)))}async function l(M){try{return await(0,D.promisify)(m.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const W=[],U=await p(M);for(const x of U){let B=!1,O=!1,H=!1;try{const j=await e.Promises.lstat((0,S.join)(M,x));B=j.isFile(),O=j.isDirectory(),H=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}W.push({name:x,isFile:()=>B,isDirectory:()=>O,isSymbolicLink:()=>H})}return W}function r(M){return g(m.readdirSync(M))}e.readdirSync=r;function g(M){return M.map(W=>typeof W=="string"?y.isMacintosh?(0,k.normalizeNFC)(W):W:(W.name=y.isMacintosh?(0,k.normalizeNFC)(W.name):W.name,W))}async function o(M){const W=await p(M),U=[];for(const x of W)await i.existsDirectory((0,S.join)(M,x))&&U.push(x);return U}function b(M,W=1e3){return new Promise(U=>{let x=!1;const B=setInterval(()=>{x||(x=!0,m.access(M,O=>{x=!1,O&&(clearInterval(B),U(void 0))}))},W)})}e.whenDeleted=b;var i;(function(M){async function W(B){let O;try{if(O=await e.Promises.lstat(B),!O.isSymbolicLink())return{stat:O}}catch(H){}try{return{stat:await e.Promises.stat(B),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(y.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw j}throw H}}M.stat=W;async function U(B){try{const{stat:O,symbolicLink:H}=await M.stat(B);return O.isFile()&&H?.dangling!==!0}catch(O){}return!1}M.existsFile=U;async function x(B){try{const{stat:O,symbolicLink:H}=await M.stat(B);return O.isDirectory()&&H?.dangling!==!0}catch(O){}return!1}M.existsDirectory=x})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function c(M,W,U){return t.queueFor(I.URI.file(M),T.extUriBiasedIgnorePathCase).queue(()=>{const x=u(U);return new Promise((B,O)=>s(M,W,x,H=>H?O(H):B()))})}let d=!0;function s(M,W,U,x){if(!d)return m.writeFile(M,W,{mode:U.mode,flag:U.flag},x);m.open(M,U.flag,U.mode,(B,O)=>{if(B)return x(B);m.writeFile(O,W,H=>{if(H)return m.close(O,()=>x(H));m.fdatasync(O,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),d=!1),m.close(O,X=>x(X))))})})}function h(M,W,U){const x=u(U);if(!d)return m.writeFileSync(M,W,{mode:x.mode,flag:x.flag});const B=m.openSync(M,x.flag,x.mode);try{m.writeFileSync(B,W);try{m.fdatasyncSync(B)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),d=!1}}finally{m.closeSync(B)}}e.writeFileSync=h;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function E(M,W){if(M===W)return;async function U(x){try{const B=await e.Promises.lstat(x);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(x,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(M,W),await U(W)}catch(x){if(M.toLowerCase()!==W.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await A(M,W,{preserveSymlinks:!1}),await f(M,w.MOVE),await U(W);else throw x}}async function A(M,W,U){return $(M,W,{root:{source:M,target:W},options:U,handledSourcePaths:new Set})}const R=511;async function $(M,W,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:x,symbolicLink:B}=await i.stat(M);if(B){if(U.options.preserveSymlinks)try{return await z(M,W,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(B.dangling)return}return x.isDirectory()?N(M,W,x.mode&R,U):F(M,W,x.mode&R)}async function N(M,W,U,x){await e.Promises.mkdir(W,{recursive:!0,mode:U});const B=await p(M);for(const O of B)await $((0,S.join)(M,O),(0,S.join)(W,O),x)}async function F(M,W,U){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,U)}async function z(M,W,U){let x=await e.Promises.readlink(M);(0,n.isEqualOrParent)(x,U.root.source,!y.isLinux)&&(x=(0,S.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,W)}e.Promises=new class{get access(){return(0,D.promisify)(m.access)}get stat(){return(0,D.promisify)(m.stat)}get lstat(){return(0,D.promisify)(m.lstat)}get utimes(){return(0,D.promisify)(m.utimes)}get read(){return(0,D.promisify)(m.read)}get readFile(){return(0,D.promisify)(m.readFile)}get write(){return(0,D.promisify)(m.write)}get appendFile(){return(0,D.promisify)(m.appendFile)}get fdatasync(){return(0,D.promisify)(m.fdatasync)}get truncate(){return(0,D.promisify)(m.truncate)}get rename(){return(0,D.promisify)(m.rename)}get copyFile(){return(0,D.promisify)(m.copyFile)}get open(){return(0,D.promisify)(m.open)}get close(){return(0,D.promisify)(m.close)}get symlink(){return(0,D.promisify)(m.symlink)}get readlink(){return(0,D.promisify)(m.readlink)}get chmod(){return(0,D.promisify)(m.chmod)}get mkdir(){return(0,D.promisify)(m.mkdir)}get unlink(){return(0,D.promisify)(m.unlink)}get rmdir(){return(0,D.promisify)(m.rmdir)}get realpath(){return(0,D.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return f}get move(){return E}get copy(){return A}}}),define(me[105],ge([0,1,60,9,8,28]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(T){const I=(0,L.dirname)(T);if(T===I)return T;const a=((0,L.basename)(T)||T).toLowerCase();try{const f=(0,C.readdirSync)(I).filter(v=>v.toLowerCase()===a);if(f.length===1){const v=n(I);if(v)return(0,L.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(a);if(v>=0){const _=n(I);if(_)return(0,L.join)(_,f[v])}}}catch(w){}return null}e.realcaseSync=n;async function k(T){try{return await C.Promises.realpath(T)}catch(I){const a=y(T);return await C.Promises.access(a,m.constants.R_OK),a}}e.realpath=k;function S(T){try{return m.realpathSync(T)}catch(I){const a=y(T);return m.accessSync(a,m.constants.R_OK),a}}e.realpathSync=S;function y(T){return(0,D.rtrim)((0,L.normalize)(T),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,m,L){var D=arguments.length,C=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,m,L);else for(var k=Y.length-1;k>=0;k--)(n=Y[k])&&(C=(D<3?n(C):D>3?n(e,m,C):n(e,m))||C);return D>3&&C&&Object.defineProperty(e,m,C),C};define(me[106],ge([0,1,17,18,22,21,57,15,3,6,59,8,13]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function f(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(P||(P={}));class p{constructor(O){this.buffer=O,this.pos=0}read(O){const H=this.buffer.slice(this.pos,this.pos+O);return this.pos+=H.byteLength,H}}class l{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(r||(r={}));function g(B){const O=D.VSBuffer.alloc(4);return O.writeUInt32BE(B,0),O}function o(B){return B.read(4).readUInt32BE(0)}function b(B){const O=D.VSBuffer.alloc(1);return O.writeUInt8(B,0),O}const i={Undefined:b(r.Undefined),String:b(r.String),Buffer:b(r.Buffer),VSBuffer:b(r.VSBuffer),Array:b(r.Array),Object:b(r.Object)},t=typeof Buffer!="undefined";function c(B,O){if(typeof O=="undefined")B.write(i.Undefined);else if(typeof O=="string"){const H=D.VSBuffer.fromString(O);B.write(i.String),B.write(g(H.byteLength)),B.write(H)}else if(t&&Buffer.isBuffer(O)){const H=D.VSBuffer.wrap(O);B.write(i.Buffer),B.write(g(H.byteLength)),B.write(H)}else if(O instanceof D.VSBuffer)B.write(i.VSBuffer),B.write(g(O.byteLength)),B.write(O);else if(Array.isArray(O)){B.write(i.Array),B.write(g(O.length));for(const H of O)c(B,H)}else{const H=D.VSBuffer.fromString(JSON.stringify(O));B.write(i.Object),B.write(g(H.byteLength)),B.write(H)}}function d(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(o(B)).toString();case r.Buffer:return B.read(o(B)).buffer;case r.VSBuffer:return B.read(o(B));case r.Array:{const H=o(B),j=[];for(let X=0;X<H;X++)j.push(d(B));return j}case r.Object:return JSON.parse(B.read(o(B)).toString())}}class s{constructor(O,H,j=null,X=1e3){this.protocol=O,this.ctx=H,this.logger=j,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(O,H){this.channels.set(O,H),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const H=this.send([O.type]);this.logger&&this.logger.logOutgoing(H,0,1,_(O.type));return}case 201:case 202:case 204:case 203:{const H=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(H,O.id,1,_(O.type),O.data);return}}}send(O,H=void 0){const j=new l;return c(j,O),c(j,H),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onRawMessage(O){const H=new p(O),j=d(H),X=d(H),K=j[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(K)}: ${j[2]}.${j[3]}`,X),this.onPromise({type:K,id:j[1],channelName:j[2],name:j[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(K)}: ${j[2]}.${j[3]}`,X),this.onEventListen({type:K,id:j[1],channelName:j[2],name:j[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:j[1]})}}onPromise(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const j=new C.CancellationTokenSource;let X;try{X=H.call(this.ctx,O.name,O.arg,j.token)}catch(Ee){X=Promise.reject(Ee)}const K=O.id;X.then(Ee=>{this.sendResponse({id:K,data:Ee,type:201}),this.activeRequests.delete(O.id)},Ee=>{Ee instanceof Error?this.sendResponse({id:K,data:{message:Ee.message,name:Ee.name,stack:Ee.stack?Ee.stack.split?Ee.stack.split(`
`):Ee.stack:void 0},type:202}):this.sendResponse({id:K,data:Ee,type:203}),this.activeRequests.delete(O.id)});const he=(0,y.toDisposable)(()=>j.cancel());this.activeRequests.set(O.id,he)}onEventListen(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const j=O.id,K=H.listen(this.ctx,O.name,O.arg)(he=>this.sendResponse({id:j,data:he,type:204}));this.activeRequests.set(O.id,K)}disposeActiveRequest(O){const H=this.activeRequests.get(O.id);H&&(H.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let H=this.pendingRequests.get(O.channelName);H||(H=[],this.pendingRequests.set(O.channelName,H));const j=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:O,timeoutTimer:j})}flushPendingRequests(O){const H=this.pendingRequests.get(O);if(H){for(const j of H)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=s;var h;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(O,H=null){this.protocol=O,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=H}getChannel(O){const H=this;return{call(j,X,K){return H.isDisposed?Promise.reject(k.canceled()):H.requestPromise(O,j,X,K)},listen(j,X){return H.isDisposed?Promise.reject(k.canceled()):H.requestEvent(O,j,X)}}}requestPromise(O,H,j,X=C.CancellationToken.None){const K=this.lastRequestId++,Ee={id:K,type:100,channelName:O,name:H,arg:j};if(X.isCancellationRequested)return Promise.reject(k.canceled());let De;return new Promise((Be,He)=>{if(X.isCancellationRequested)return He(k.canceled());const ze=()=>{const ce=J=>{switch(J.type){case 201:this.handlers.delete(K),Be(J.data);break;case 202:this.handlers.delete(K);const te=new Error(J.data.message);te.stack=J.data.stack,te.name=J.data.name,He(te);break;case 203:this.handlers.delete(K),He(J.data);break}};this.handlers.set(K,ce),this.sendRequest(Ee)};let G=null;this.state===P.Idle?ze():(G=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,ze()}));const Z=()=>{G?(G.cancel(),G=null):this.sendRequest({id:K,type:101}),He(k.canceled())},ne=X.onCancellationRequested(Z);De=(0,y.combinedDisposable)((0,y.toDisposable)(Z),ne),this.activeRequests.add(De)}).finally(()=>{this.activeRequests.delete(De)})}requestEvent(O,H,j){const X=this.lastRequestId++,he={id:X,type:102,channelName:O,name:H,arg:j};let Ee=null;const De=new S.Emitter({onFirstListenerAdd:()=>{Ee=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),Ee.then(()=>{Ee=null,this.activeRequests.add(De),this.sendRequest(he)})},onLastListenerRemove:()=>{Ee?(Ee.cancel(),Ee=null):(this.activeRequests.delete(De),this.sendRequest({id:X,type:103}))}}),Pe=Be=>De.fire(Be.data);return this.handlers.set(X,Pe),De.event}sendRequest(O){switch(O.type){case 100:case 102:{const H=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(H,O.id,0,`${f(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const H=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(H,O.id,0,f(O.type));return}}}send(O,H=void 0){const j=new l;return c(j,O),c(j,H),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onBuffer(O){const H=new p(O),j=d(H),X=d(H),K=j[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,_(K)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],0,_(K),X),this.onResponse({type:j[0],id:j[1],data:X})}}onResponse(O){if(O.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(O.id);H&&H(O)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([n.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class E{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:H,onDidClientDisconnect:j})=>{S.Event.once(H.onMessage)(K=>{const he=new p(K),Ee=d(he),De=new s(H,Ee),Pe=new u(H);this.channels.forEach((He,ze)=>De.registerChannel(ze,He));const Be={channelServer:De,channelClient:Pe,ctx:Ee};this._connections.add(Be),this._onDidAddConnection.fire(Be),j(()=>{De.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(H=>O.push(H)),O}getChannel(O,H){const j=this;return{call(X,K,he){let Ee;if((0,a.isFunction)(H)){let Pe=(0,m.getRandomElement)(j.connections.filter(H));Ee=Pe?Promise.resolve(Pe):S.Event.toPromise(S.Event.filter(j.onDidAddConnection,H))}else Ee=H.routeCall(j,X,K);const De=Ee.then(Pe=>Pe.channelClient.getChannel(O));return R(De).call(X,K,he)},listen(X,K){if((0,a.isFunction)(H))return j.getMulticastEvent(O,H,X,K);const he=H.routeEvent(j,X,K).then(Ee=>Ee.channelClient.getChannel(O));return R(he).listen(X,K)}}}getMulticastEvent(O,H,j,X){const K=this;let he=new y.DisposableStore;const Ee=new S.Emitter({onFirstListenerAdd:()=>{he=new y.DisposableStore;const De=new S.EventMultiplexer,Pe=new Map,Be=ze=>{const Z=ze.channelClient.getChannel(O).listen(j,X),ne=De.add(Z);Pe.set(ze,ne)},He=ze=>{const G=Pe.get(ze);!G||(G.dispose(),Pe.delete(ze))};K.connections.filter(H).forEach(Be),S.Event.filter(K.onDidAddConnection,H)(Be,void 0,he),K.onDidRemoveConnection(He,void 0,he),De.event(Ee.fire,Ee,he),he.add(De)},onLastListenerRemove:()=>{he.dispose()}});return Ee.event}registerChannel(O,H){this.channels.set(O,H),this._connections.forEach(j=>{j.channelServer.registerChannel(O,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class A{constructor(O,H,j=null){const X=new l;c(X,H),O.send(X.buffer),this.channelClient=new u(O,j),this.channelServer=new s(O,H,j)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,H){this.channelServer.registerChannel(O,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function R(B){return{call(O,H,j){return B.then(X=>X.call(O,H,j))},listen(O,H){const j=new S.Relay;return B.then(X=>j.input=X.listen(O,H)),j.event}}}e.getDelayedChannel=R;function $(B){let O=!1;return{call(H,j,X){return O?B.call(H,j,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>B.call(H,j,X))},listen(H,j){if(O)return B.listen(H,j);const X=new S.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=B.listen(H,j)),X.event}}}e.getNextTickChannel=$;class N{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const H of O.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await S.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=N;var F;(function(B){function O(K,he){const Ee=K,De=he&&he.disableMarshalling,Pe=new Map;for(const Be in Ee)j(Be)&&Pe.set(Be,S.Event.buffer(Ee[Be],!0));return new class{listen(Be,He,ze){const G=Pe.get(He);if(G)return G;if(X(He)){const Z=Ee[He];if(typeof Z=="function")return Z.call(Ee,ze)}throw new Error(`Event not found: ${He}`)}call(Be,He,ze){const G=Ee[He];if(typeof G=="function"){if(!De&&Array.isArray(ze))for(let Z=0;Z<ze.length;Z++)ze[Z]=(0,T.revive)(ze[Z]);return G.apply(Ee,ze)}throw new Error(`Method not found: ${He}`)}}}B.fromService=O;function H(K,he){const Ee=he&&he.disableMarshalling;return new Proxy({},{get(De,Pe){if(typeof Pe=="string")return he?.properties?.has(Pe)?he.properties.get(Pe):X(Pe)?function(Be){return K.listen(Pe,Be)}:j(Pe)?K.listen(Pe):async function(...Be){let He;he&&!(0,a.isUndefinedOrNull)(he.context)?He=[he.context,...Be]:He=Be;const ze=await K.call(Pe,He);return Ee?ze:(0,T.revive)(ze)};throw new Error(`Property not found: ${String(Pe)}`)}})}B.toService=H;function j(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}function X(K){return/^onDynamic/.test(K)&&I.isUpperAsciiLetter(K.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let O=B.toString();if(O!=="[object Object]")return O}return B}function W(B){return Array.isArray(B)?B.map(M):M(B)}function U(B,O,H,j,X,K,he){he=W(he);const Ee=z[X],De=Ee[j%Ee.length];let Pe=[`%c[${B}]%c[${String(O).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(K)?(Pe=Pe.concat(he),Pe.push(")")):Pe.push(he),console.log.apply(console,Pe)}e.logWithColors=U;class x{constructor(O,H){this._outgoingPrefix=O,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,H,j,X,K){this._totalOutgoing+=O,U(this._outgoingPrefix,this._totalOutgoing,O,H,j,X,K)}logIncoming(O,H,j,X,K){this._totalIncoming+=O,U(this._incomingPrefix,this._totalIncoming,O,H,j,X,K)}}e.IPCLogger=x}),define(me[107],ge([0,1,22,3,6,11,106]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var k;(function(b){b[b.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",b[b.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function y(){return S||(S=m.VSBuffer.alloc(0)),S}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,t){if(i===0)return y();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const h=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=i),h}if(this._chunks[0].byteLength>i){const h=this._chunks[0].slice(0,i);return t&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),h}let c=m.VSBuffer.alloc(i),d=0,s=0;for(;i>0;){const h=this._chunks[s];if(h.byteLength>i){const u=h.slice(0,i);c.set(u,d),d+=i,t&&(this._chunks[s]=h.slice(i),this._totalLength-=i),i-=i}else c.set(h,d),d+=h.byteLength,t?(this._chunks.shift(),this._totalLength-=h.byteLength):s++,i-=h.byteLength}return c}}e.ChunkStream=T;var I;(function(b){b[b.None=0]="None",b[b.Regular=1]="Regular",b[b.Control=2]="Control",b[b.Ack=3]="Ack",b[b.KeepAlive=4]="KeepAlive",b[b.Disconnect=5]="Disconnect",b[b.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var a;(function(b){b[b.HeaderLength=13]="HeaderLength",b[b.AcknowledgeTime=2e3]="AcknowledgeTime",b[b.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",b[b.KeepAliveTime=5e3]="KeepAliveTime",b[b.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",b[b.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",b[b.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(a=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(i,t,c,d){this.type=i,this.id=t,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends D.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5);else{const c=this._state.messageType,d=this._state.id,s=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new w(c,d,s,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=m.VSBuffer.alloc(13);t.writeUInt8(i.type,0),t.writeUInt32BE(i.id,1),t.writeUInt32BE(i.ack,5),t.writeUInt32BE(i.data.byteLength,9),this._writeSoon(t,i.data)}_bufferAdd(i,t){const c=this._totalLength===0;return this._data.push(i,t),this._totalLength+=i.byteLength+t.byteLength,c}_bufferTake(){const i=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,t){this._bufferAdd(i,t)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class _ extends D.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new w(1,0,0,i))}}e.Protocol=_;class P extends n.IPCClient{constructor(i,t,c=null){super(i,t,c);this.protocol=i}static fromSocket(i,t){return new P(new _(i),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=P;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class l{constructor(i){this.data=i,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],t=0,c=this._first;for(;c;)i[t++]=c.data,c=c.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const t=new l(i);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class g{constructor(){this.lastRuns=[];const i=Date.now();for(let t=0;t<g._HISTORY_LENGTH;t++)this.lastRuns[t]=i-1e3*t;setInterval(()=>{for(let t=g._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return g._INSTANCE||(g._INSTANCE=new g),g._INSTANCE}load(){const i=Date.now(),t=(1+g._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<g._HISTORY_LENGTH;d++)i-this.lastRuns[d]<=t&&c++;return 1-c/g._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}g._HISTORY_LENGTH=10,g._INSTANCE=null;class o{constructor(i,t=null,c=g.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new w(5,0,0,y());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const t=new w(4,0,0,y());this._socketWriter.write(t),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,t){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let t=0,c=i.length;t<c;t++)this._socketWriter.write(i[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new w(6,0,0,y())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const t=this._outgoingUnackMsg.toArray();for(let c=0,d=t.length;c<d;c++)this._socketWriter.write(t[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new w(1,t,this._incomingAckId,i);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(i){const t=new w(2,0,0,i);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),t=Date.now()-i.writtenTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-t,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new w(3,0,this._incomingAckId,y());this._socketWriter.write(i)}}e.PersistentProtocol=o}),define(me[108],ge([0,1,99]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let S=(0,m.toUint8)(k);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){let S=new Uint8Array(256);for(let y=0;y<256;y++)S[y]=k;return S}set(k,S){let y=(0,m.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=y:this._map.set(k,y)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var D;(function(n){n[n.False=0]="False",n[n.True=1]="True"})(D||(D={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(me[143],ge([0,1,108]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(n){n[n.Regular=0]="Regular",n[n.Whitespace=1]="Whitespace",n[n.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends m.CharacterClassifier{constructor(k){super(0);for(let S=0,y=k.length;S<y;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function C(n){let k={};return S=>(k.hasOwnProperty(S)||(k[S]=n(S)),k[S])}e.getMapForWordSeparators=C(n=>new D(n))}),define(me[50],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(D,C){this.lineNumber=D,this.column=C}with(D=this.lineNumber,C=this.column){return D===this.lineNumber&&C===this.column?this:new m(D,C)}delta(D=0,C=0){return this.with(this.lineNumber+D,this.column+C)}equals(D){return m.equals(this,D)}static equals(D,C){return!D&&!C?!0:!!D&&!!C&&D.lineNumber===C.lineNumber&&D.column===C.column}isBefore(D){return m.isBefore(this,D)}static isBefore(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<C.column}isBeforeOrEqual(D){return m.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<=C.column}static compare(D,C){let n=D.lineNumber|0,k=C.lineNumber|0;if(n===k){let S=D.column|0,y=C.column|0;return S-y}return n-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new m(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=m}),define(me[41],ge([0,1,50]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,n,k,S){C>k||C===k&&n>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=C,this.endColumn=n):(this.startLineNumber=C,this.startColumn=n,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,n){return!(n.lineNumber<C.startLineNumber||n.lineNumber>C.endLineNumber||n.lineNumber===C.startLineNumber&&n.column<C.startColumn||n.lineNumber===C.endLineNumber&&n.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,n){return!(n.startLineNumber<C.startLineNumber||n.endLineNumber<C.startLineNumber||n.startLineNumber>C.endLineNumber||n.endLineNumber>C.endLineNumber||n.startLineNumber===C.startLineNumber&&n.startColumn<C.startColumn||n.endLineNumber===C.endLineNumber&&n.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,n){return!(n.startLineNumber<C.startLineNumber||n.endLineNumber<C.startLineNumber||n.startLineNumber>C.endLineNumber||n.endLineNumber>C.endLineNumber||n.startLineNumber===C.startLineNumber&&n.startColumn<=C.startColumn||n.endLineNumber===C.endLineNumber&&n.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,n){let k,S,y,T;return n.startLineNumber<C.startLineNumber?(k=n.startLineNumber,S=n.startColumn):n.startLineNumber===C.startLineNumber?(k=n.startLineNumber,S=Math.min(n.startColumn,C.startColumn)):(k=C.startLineNumber,S=C.startColumn),n.endLineNumber>C.endLineNumber?(y=n.endLineNumber,T=n.endColumn):n.endLineNumber===C.endLineNumber?(y=n.endLineNumber,T=Math.max(n.endColumn,C.endColumn)):(y=C.endLineNumber,T=C.endColumn),new L(k,S,y,T)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,n){let k=C.startLineNumber,S=C.startColumn,y=C.endLineNumber,T=C.endColumn,I=n.startLineNumber,a=n.startColumn,w=n.endLineNumber,f=n.endColumn;return k<I?(k=I,S=a):k===I&&(S=Math.max(S,a)),y>w?(y=w,T=f):y===w&&(T=Math.min(T,f)),k>y||k===y&&S>T?null:new L(k,S,y,T)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,n){return!!C&&!!n&&C.startLineNumber===n.startLineNumber&&C.startColumn===n.startColumn&&C.endLineNumber===n.endLineNumber&&C.endColumn===n.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,n){return new L(this.startLineNumber,this.startColumn,C,n)}setStartPosition(C,n){return new L(C,n,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,n=C){return new L(C.lineNumber,C.column,n.lineNumber,n.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,n){return!(C.endLineNumber<n.startLineNumber||C.endLineNumber===n.startLineNumber&&C.endColumn<n.startColumn||n.endLineNumber<C.startLineNumber||n.endLineNumber===C.startLineNumber&&n.endColumn<C.startColumn)}static areIntersecting(C,n){return!(C.endLineNumber<n.startLineNumber||C.endLineNumber===n.startLineNumber&&C.endColumn<=n.startColumn||n.endLineNumber<C.startLineNumber||n.endLineNumber===C.startLineNumber&&n.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,n){if(C&&n){const y=C.startLineNumber|0,T=n.startLineNumber|0;if(y===T){const I=C.startColumn|0,a=n.startColumn|0;if(I===a){const w=C.endLineNumber|0,f=n.endLineNumber|0;if(w===f){const v=C.endColumn|0,_=n.endColumn|0;return v-_}return w-f}return I-a}return y-T}return(C?1:0)-(n?1:0)}static compareRangesUsingEnds(C,n){return C.endLineNumber===n.endLineNumber?C.endColumn===n.endColumn?C.startLineNumber===n.startLineNumber?C.startColumn-n.startColumn:C.startLineNumber-n.startLineNumber:C.endColumn-n.endColumn:C.endLineNumber-n.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(me[144],ge([0,1,50,41]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,S,y,T){super(k,S,y,T);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=y,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,S):new C(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new C(k,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new C(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let y=0,T=k.length;y<T;y++)if(!this.selectionsEqual(k[y],S[y]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,y,T,I){return I===0?new C(k,S,y,T):new C(y,T,k,S)}}e.Selection=C}),define(me[109],ge([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var n;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(n=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class y{constructor(l,r){this._findMatchBrand=void 0,this.range=l,this.matches=r}}e.FindMatch=y;var T;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(p){p[p.Disabled=0]="Disabled",p[p.EnabledForActive=1]="EnabledForActive",p[p.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class a{constructor(l,r,g){this.visibleColumn=l,this.className=r,this.horizontalLine=g}}e.IndentGuide=a;class w{constructor(l,r){this.top=l,this.endColumn=r}}e.IndentGuideHorizontalLine=w;var f;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class _{constructor(l,r,g,o,b,i){this.identifier=l,this.range=r,this.text=g,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=b,this._isTracked=i}}e.ValidAnnotatedEditOperation=_;class P{constructor(l,r,g){this.reverseEdits=l,this.changes=r,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=P}),define(me[145],ge([0,1,8,143,50,41,109]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(l,r,g,o){this.searchString=l,this.isRegex=r,this.matchCase=g,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=y(this.searchString):l=this.searchString.indexOf(`
`)>=0;let r=null;try{r=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(o){return null}if(!r)return null;let g=!this.isRegex&&!l;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new T(r,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function y(p){if(!p||p.length===0)return!1;for(let l=0,r=p.length;l<r;l++)if(p.charCodeAt(l)===92){if(l++,l>=r)break;const o=p.charCodeAt(l);if(o===110||o===114||o===87)return!0}return!1}e.isMultilineRegexSource=y;class T{constructor(l,r,g){this.regex=l,this.wordSeparators=r,this.simpleSearch=g}}e.SearchData=T;function I(p,l,r){if(!r)return new n.FindMatch(p,null);let g=[];for(let o=0,b=l.length;o<b;o++)g[o]=l[o];return new n.FindMatch(p,g)}e.createFindMatch=I;class a{constructor(l){let r=[],g=0;for(let o=0,b=l.length;o<b;o++)l.charCodeAt(o)===10&&(r[g++]=o);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(l){const r=this._lineFeedsOffsets;let g=0,o=r.length-1;if(o===-1||l<=r[0])return 0;for(;g<o;){const b=g+((o-g)/2>>0);r[b]>=l?o=b-1:r[b+1]>=l?(g=b,o=b):g=b+1}return g+1}}class w{static findMatches(l,r,g,o,b){const i=r.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(l,g,new P(i.wordSeparators,i.regex),o,b):this._doFindMatchesLineByLine(l,g,i,o,b):[]}static _getMultilineMatchRange(l,r,g,o,b,i){let t,c=0;o?(c=o.findLineFeedCountBeforeOffset(b),t=r+b+c):t=r+b;let d;if(o){let E=o.findLineFeedCountBeforeOffset(b+i.length)-c;d=t+i.length+E}else d=t+i.length;const s=l.getPositionAt(t),h=l.getPositionAt(d);return new C.Range(s.lineNumber,s.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(l,r,g,o,b){const i=l.getOffsetAt(r.getStartPosition()),t=l.getValueInRange(r,1),c=l.getEOL()===`\r
`?new a(t):null,d=[];let s=0,h;for(g.reset(0);h=g.next(t);)if(d[s++]=I(this._getMultilineMatchRange(l,i,t,c,h.index,h[0]),h,o),s>=b)return d;return d}static _doFindMatchesLineByLine(l,r,g,o,b){const i=[];let t=0;if(r.startLineNumber===r.endLineNumber){const d=l.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(g,d,r.startLineNumber,r.startColumn-1,t,i,o,b),i}const c=l.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(g,c,r.startLineNumber,r.startColumn-1,t,i,o,b);for(let d=r.startLineNumber+1;d<r.endLineNumber&&t<b;d++)t=this._findMatchesInLine(g,l.getLineContent(d),d,0,t,i,o,b);if(t<b){const d=l.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(g,d,r.endLineNumber,0,t,i,o,b)}return i}static _findMatchesInLine(l,r,g,o,b,i,t,c){const d=l.wordSeparators;if(!t&&l.simpleSearch){const u=l.simpleSearch,E=u.length,A=r.length;let R=-E;for(;(R=r.indexOf(u,R+E))!==-1;)if((!d||_(d,r,A,R,E))&&(i[b++]=new n.FindMatch(new C.Range(g,R+1+o,g,R+1+E+o),null),b>=c))return b;return b}const s=new P(l.wordSeparators,l.regex);let h;s.reset(0);do if(h=s.next(r),h&&(i[b++]=I(new C.Range(g,h.index+1+o,g,h.index+1+h[0].length+o),h,t),b>=c))return b;while(h);return b}static findNextMatch(l,r,g,o){const b=r.parseSearchRequest();if(!b)return null;const i=new P(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindNextMatchMultiline(l,g,i,o):this._doFindNextMatchLineByLine(l,g,i,o)}static _doFindNextMatchMultiline(l,r,g,o){const b=new D.Position(r.lineNumber,1),i=l.getOffsetAt(b),t=l.getLineCount(),c=l.getValueInRange(new C.Range(b.lineNumber,b.column,t,l.getLineMaxColumn(t)),1),d=l.getEOL()===`\r
`?new a(c):null;g.reset(r.column-1);let s=g.next(c);return s?I(this._getMultilineMatchRange(l,i,c,d,s.index,s[0]),s,o):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(l,new D.Position(1,1),g,o):null}static _doFindNextMatchLineByLine(l,r,g,o){const b=l.getLineCount(),i=r.lineNumber,t=l.getLineContent(i),c=this._findFirstMatchInLine(g,t,i,r.column,o);if(c)return c;for(let d=1;d<=b;d++){const s=(i+d-1)%b,h=l.getLineContent(s+1),u=this._findFirstMatchInLine(g,h,s+1,1,o);if(u)return u}return null}static _findFirstMatchInLine(l,r,g,o,b){l.reset(o-1);const i=l.next(r);return i?I(new C.Range(g,i.index+1,g,i.index+1+i[0].length),i,b):null}static findPreviousMatch(l,r,g,o){const b=r.parseSearchRequest();if(!b)return null;const i=new P(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindPreviousMatchMultiline(l,g,i,o):this._doFindPreviousMatchLineByLine(l,g,i,o)}static _doFindPreviousMatchMultiline(l,r,g,o){const b=this._doFindMatchesMultiline(l,new C.Range(1,1,r.lineNumber,r.column),g,o,10*k);if(b.length>0)return b[b.length-1];const i=l.getLineCount();return r.lineNumber!==i||r.column!==l.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(l,new D.Position(i,l.getLineMaxColumn(i)),g,o):null}static _doFindPreviousMatchLineByLine(l,r,g,o){const b=l.getLineCount(),i=r.lineNumber,t=l.getLineContent(i).substring(0,r.column-1),c=this._findLastMatchInLine(g,t,i,o);if(c)return c;for(let d=1;d<=b;d++){const s=(b+i-d-1)%b,h=l.getLineContent(s+1),u=this._findLastMatchInLine(g,h,s+1,o);if(u)return u}return null}static _findLastMatchInLine(l,r,g,o){let b=null,i;for(l.reset(0);i=l.next(r);)b=I(new C.Range(g,i.index+1,g,i.index+1+i[0].length),i,o);return b}}e.TextModelSearch=w;function f(p,l,r,g,o){if(g===0)return!0;const b=l.charCodeAt(g-1);if(p.get(b)!==0||b===13||b===10)return!0;if(o>0){const i=l.charCodeAt(g);if(p.get(i)!==0)return!0}return!1}function v(p,l,r,g,o){if(g+o===r)return!0;const b=l.charCodeAt(g+o);if(p.get(b)!==0||b===13||b===10)return!0;if(o>0){const i=l.charCodeAt(g+o-1);if(p.get(i)!==0)return!0}return!1}function _(p,l,r,g,o){return f(p,l,r,g,o)&&v(p,l,r,g,o)}e.isValidMatch=_;class P{constructor(l,r){this._wordSeparators=l,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const r=l.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(g=this._searchRegex.exec(l),!g))return null;const o=g.index,b=g[0].length;if(o===this._prevMatchStartIndex&&b===this._prevMatchLength){if(b===0){m.getNextCodePoint(l,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=b,!this._wordSeparators||_(this._wordSeparators,l,r,o,b))return g}while(g);return null}}e.Searcher=P}),define(me[110],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)k.indexOf(y)>=0||(S+="\\"+y);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=m();function L(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let y="g";k.ignoreCase&&(y+="i"),k.multiline&&(y+="m"),k.unicode&&(y+="u"),S=new RegExp(k.source,y)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const D={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,S,y,T,I=D){if(y.length>I.maxLen){let _=k-I.maxLen/2;return _<0?_=0:T+=_,y=y.substring(_,k+I.maxLen/2),C(k,S,y,T,I)}const a=Date.now(),w=k-1-T;let f=-1,v=null;for(let _=1;!(Date.now()-a>=I.timeBudget);_++){const P=w-I.windowSize*_;S.lastIndex=Math.max(0,P);const p=n(S,y,w,f);if(!p&&v||(v=p,P<=0))break;f=P}if(v){let _={word:v[0],startColumn:T+1+v.index,endColumn:T+1+v.index+v[0].length};return S.lastIndex=0,_}return null}e.getWordAtText=C;function n(k,S,y,T){let I;for(;I=k.exec(S);){const a=I.index||0;if(a<=y&&k.lastIndex>=y)return I;if(T>0&&a>T)return null}return null}}),define(me[146],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let S=0,y=k.notIn.length;S<y;S++)switch(k.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const y=k.findTokenIndexAtOffset(S-2),T=k.getStandardTokenType(y);return this.isOK(T)}_findNeutralCharacterInRange(k,S){for(let y=k;y<=S;y++){const T=String.fromCharCode(y);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class D{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function C(n,k,S){n.has(k)?n.get(k).push(S):n.set(k,[S])}}),define(me[82],ge([0,1,31,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(C,n,k,S){if(Array.isArray(C)){let y=0;for(const T of C){const I=D(T,n,k,S);if(I===10)return I;I>y&&(y=I)}return y}else{if(typeof C=="string")return S?C==="*"?5:C===k?10:0:0;if(C){const{language:y,pattern:T,scheme:I,hasAccessToAllModels:a}=C;if(!S&&!a)return 0;let w=0;if(I)if(I===n.scheme)w=10;else if(I==="*")w=5;else return 0;if(y)if(y===k)w=10;else if(y==="*")w=Math.max(w,5);else return 0;if(T){let f;if(typeof T=="string"?f=T:f={...T,base:(0,L.normalize)(T.base)},f===n.fsPath||(0,m.match)(f,n.fsPath))w=10;else return 0}return w}else return 0}}e.score=D}),define(me[147],ge([0,1,108]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class D{constructor(f,v,_){const P=new Uint8Array(f*v);for(let p=0,l=f*v;p<l;p++)P[p]=_;this._data=P,this.rows=f,this.cols=v}get(f,v){return this._data[f*this.cols+v]}set(f,v,_){this._data[f*this.cols+v]=_}}e.Uint8Matrix=D;class C{constructor(f){let v=0,_=0;for(let p=0,l=f.length;p<l;p++){let[r,g,o]=f[p];g>v&&(v=g),r>_&&(_=r),o>_&&(_=o)}v++,_++;let P=new D(_,v,0);for(let p=0,l=f.length;p<l;p++){let[r,g,o]=f[p];P.set(r,g,o)}this._states=P,this._maxCharCode=v}nextState(f,v){return v<0||v>=this._maxCharCode?0:this._states.get(f,v)}}e.StateMachine=C;let n=null;function k(){return n===null&&(n=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),n}var S;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let y=null;function T(){if(y===null){y=new m.CharacterClassifier(0);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<w.length;v++)y.set(w.charCodeAt(v),1);const f=".,;";for(let v=0;v<f.length;v++)y.set(f.charCodeAt(v),2)}return y}class I{static _createLink(f,v,_,P,p){let l=p-1;do{const r=v.charCodeAt(l);if(f.get(r)!==2)break;l--}while(l>P);if(P>0){const r=v.charCodeAt(P-1),g=v.charCodeAt(l);(r===40&&g===41||r===91&&g===93||r===123&&g===125)&&l--}return{range:{startLineNumber:_,startColumn:P+1,endLineNumber:_,endColumn:l+2},url:v.substring(P,l+1)}}static computeLinks(f,v=k()){const _=T();let P=[];for(let p=1,l=f.getLineCount();p<=l;p++){const r=f.getLineContent(p),g=r.length;let o=0,b=0,i=0,t=1,c=!1,d=!1,s=!1,h=!1;for(;o<g;){let u=!1;const E=r.charCodeAt(o);if(t===13){let A;switch(E){case 40:c=!0,A=0;break;case 41:A=c?0:1;break;case 91:s=!0,d=!0,A=0;break;case 93:s=!1,A=d?0:1;break;case 123:h=!0,A=0;break;case 125:A=h?0:1;break;case 39:A=i===34||i===96?0:1;break;case 34:A=i===39||i===96?0:1;break;case 96:A=i===39||i===34?0:1;break;case 42:A=i===42?1:0;break;case 124:A=i===124?1:0;break;case 32:A=s?0:1;break;default:A=_.get(E)}A===1&&(P.push(I._createLink(_,r,p,b,o)),u=!0)}else if(t===12){let A;E===91?(d=!0,A=0):A=_.get(E),A===1?u=!0:t=13}else t=v.nextState(t,E),t===0&&(u=!0);u&&(t=1,c=!1,d=!1,h=!1,b=o+1,i=E),o++}t===13&&P.push(I._createLink(_,r,p,b,g))}return P}}e.LinkComputer=I;function a(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:I.computeLinks(w)}e.computeLinks=a}),define(me[148],ge([0,1,3,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(n){this._onDidChange.fire({changedLanguages:n,changedColorMap:!1})}register(n,k){return this._map.set(n,k),this.fire([n]),(0,L.toDisposable)(()=>{this._map.get(n)===k&&(this._map.delete(n),this.fire([n]))})}registerPromise(n,k){let S=null,y=!1;return this._promises.set(n,k.then(T=>{this._promises.delete(n),!(y||!T)&&(S=this.register(n,T))})),(0,L.toDisposable)(()=>{y=!0,S&&S.dispose()})}getPromise(n){const k=this.get(n);if(k)return Promise.resolve(k);const S=this._promises.get(n);return S?S.then(y=>this.get(n)):null}get(n){return this._map.get(n)||null}setColorMap(n){this._colorMap=n,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(me[111],ge([0,1,22,11]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function C(I){for(let a=0,w=I.length;a<w;a+=4){const f=I[a+0],v=I[a+1],_=I[a+2],P=I[a+3];I[a+0]=P,I[a+1]=_,I[a+2]=v,I[a+3]=f}}function n(I){const a=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||C(a),m.VSBuffer.wrap(a)}function k(I){const a=I.buffer;if(L.isLittleEndian()||C(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const w=new Uint8Array(a.byteLength);return w.set(a),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function S(I){const a=new Uint32Array(y(I));let w=0;if(a[w++]=I.id,I.type==="full")a[w++]=1,a[w++]=I.data.length,a.set(I.data,w),w+=I.data.length;else{a[w++]=2,a[w++]=I.deltas.length;for(const f of I.deltas)a[w++]=f.start,a[w++]=f.deleteCount,f.data?(a[w++]=f.data.length,a.set(f.data,w),w+=f.data.length):a[w++]=0}return n(a)}e.encodeSemanticTokensDto=S;function y(I){let a=0;if(a+=1+1,I.type==="full")a+=1+I.data.length;else{a+=1,a+=(1+1+1)*I.deltas.length;for(const w of I.deltas)w.data&&(a+=w.data.length)}return a}function T(I){const a=k(I);let w=0;const f=a[w++];if(a[w++]===1){const p=a[w++],l=a.subarray(w,w+p);return w+=p,{id:f,type:"full",data:l}}const _=a[w++];let P=[];for(let p=0;p<_;p++){const l=a[w++],r=a[w++],g=a[w++];let o;g>0&&(o=a.subarray(w,w+g),w+=g),P[p]={start:l,deleteCount:r,data:o}}return{id:f,type:"delta",deltas:P}}e.decodeSemanticTokensDto=T}),define(me[112],ge([0,1,17,99]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,y){S=(0,L.toUint32)(S);const T=this.values,I=this.prefixSum,a=y.length;return a===0?!1:(this.values=new Uint32Array(T.length+a),this.values.set(T.subarray(0,S),0),this.values.set(T.subarray(S),S+a),this.values.set(y,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,y){return S=(0,L.toUint32)(S),y=(0,L.toUint32)(y),this.values[S]===y?!1:(this.values[S]=y,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,y){S=(0,L.toUint32)(S),y=(0,L.toUint32)(y);const T=this.values,I=this.prefixSum;if(S>=T.length)return!1;let a=T.length-S;return y>=a&&(y=a),y===0?!1:(this.values=new Uint32Array(T.length-y),this.values.set(T.subarray(0,S),0),this.values.set(T.subarray(S+y),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,L.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),S>=this.values.length&&(S=this.values.length-1);for(let T=y;T<=S;T++)this.prefixSum[T]=this.prefixSum[T-1]+this.values[T];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let y=0,T=this.values.length-1,I=0,a=0,w=0;for(;y<=T;)if(I=y+(T-y)/2|0,a=this.prefixSum[I],w=a-this.values[I],S<w)T=I-1;else if(S>=a)y=I+1;else break;return new n(I,S-w)}}e.PrefixSumComputer=D;class C{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const y=this._indexBySum[S],T=y>0?this._prefixSum[y-1]:0;return new n(y,S-T)}removeValues(S,y){this._values.splice(S,y),this._invalidate(S)}insertValues(S,y){this._values=(0,m.arrayInsert)(this._values,S,y),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,y=this._values.length;S<y;S++){const T=this._values[S],I=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=I+T;for(let a=0;a<T;a++)this._indexBySum[I+a]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,y){this._values[S]!==y&&(this._values[S]=y,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=C;class n{constructor(S,y){this.index=S,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=y}}e.PrefixSumIndexOfResult=n}),define(me[149],ge([0,1,8,50,112]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,S,y,T){this._uri=k,this._lines=S,this._eol=y,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const y of S)this._acceptDeleteRange(y.range),this._acceptInsertText(new L.Position(y.range.startLineNumber,y.range.startColumn),y.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,y=new Uint32Array(S);for(let T=0;T<S;T++)y[T]=this._lines[T].length+k;this._lineStarts=new D.PrefixSumComputer(y)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;let y=(0,m.splitLines)(S);if(y.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+y[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}y[y.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+y[0]);let T=new Uint32Array(y.length-1);for(let I=1;I<y.length;I++)this._lines.splice(k.lineNumber+I-1,0,y[I]),T[I-1]=y[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,T)}}e.MirrorTextModel=C}),define(me[150],ge([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,C=D*24,n=C*7,k=C*30,S=C*365;function y(I,a){typeof I!="number"&&(I=I.getTime());const w=Math.round((new Date().getTime()-I)/1e3);if(w<-30)return(0,m.localize)(0,null,y(new Date().getTime()+w*1e3,!1));if(w<30)return(0,m.localize)(1,null);let f;return w<L?(f=w,a?f===1?(0,m.localize)(2,null,f):(0,m.localize)(3,null,f):f===1?(0,m.localize)(4,null,f):(0,m.localize)(5,null,f)):w<D?(f=Math.floor(w/L),a?f===1?(0,m.localize)(6,null,f):(0,m.localize)(7,null,f):f===1?(0,m.localize)(8,null,f):(0,m.localize)(9,null,f)):w<C?(f=Math.floor(w/D),a?f===1?(0,m.localize)(10,null,f):(0,m.localize)(11,null,f):f===1?(0,m.localize)(12,null,f):(0,m.localize)(13,null,f)):w<n?(f=Math.floor(w/C),a?f===1?(0,m.localize)(14,null,f):(0,m.localize)(15,null,f):f===1?(0,m.localize)(16,null,f):(0,m.localize)(17,null,f)):w<k?(f=Math.floor(w/n),a?f===1?(0,m.localize)(18,null,f):(0,m.localize)(19,null,f):f===1?(0,m.localize)(20,null,f):(0,m.localize)(21,null,f)):w<S?(f=Math.floor(w/k),a?f===1?(0,m.localize)(22,null,f):(0,m.localize)(23,null,f):f===1?(0,m.localize)(24,null,f):(0,m.localize)(25,null,f)):(f=Math.floor(w/S),a?f===1?(0,m.localize)(26,null,f):(0,m.localize)(27,null,f):f===1?(0,m.localize)(28,null,f):(0,m.localize)(29,null,f))}e.fromNow=y;function T(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(me[152],ge([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(me[51],ge([0,1,17,13,152]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(y,T){return T&&(y.stack||y.stacktrace)?D.localize(0,null,k(y),n(y.stack)||n(y.stacktrace)):k(y)}function n(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function S(y=null,T=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const I=m.coalesce(y),a=S(I[0],T);return I.length>1?D.localize(4,null,a,I.length):a}if(L.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return C(I.error,T);if(I.exception)return C(I.exception,T)}return y.stack?C(y,T):y.message?y.message:D.localize(5,null)}e.toErrorMessage=S}),define(me[153],ge([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,37,30,10,25,9,11,40,95,13,142,28,153]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function f(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(o,b){if(k.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};b&&(i.cwd=b);const t=m.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(c=>{t.once("error",d=>{c({success:!1,error:d})}),t.once("exit",(d,s)=>{c(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?f(i.status):1})}else if(k.isLinux||k.isMacintosh)try{const i=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{m.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(c,d,s)=>{t(c?{success:!1,error:c}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function _(o){!o||(delete o.DEBUG,k.isMacintosh&&delete o.DYLD_LIBRARY_PATH,k.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=_;function P(o=S.env){return o.comspec||"cmd.exe"}e.getWindowsShell=P;class p{constructor(b,i,t,c){if(i!==void 0&&t!==void 0&&c!==void 0)this.cmd=b,this.args=i,this.shell=t,this.options=c;else{const d=b;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(S.env).forEach(s=>{d[s]=S.env[s]}),Object.keys(this.options.env).forEach(s=>{d[s]=this.options.env[s]}),this.options.env=d}}getSanitizedCommand(){let b=this.cmd.toLowerCase();const i=b.lastIndexOf(n.sep);return i!==-1&&(b=b.substring(i+1)),p.WellKnowCommands[b]?b:"other"}start(b){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(i=>{let t,c;const d=new Promise((s,h)=>{t=s,c=h});if(i){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=m.exec(s,this.options,(h,u,E)=>{this.childProcess=null;const A=h;A&&A.killed?c({killed:this.terminateRequested,stdout:u.toString(),stderr:E.toString()}):this.handleExec(t,b,h,u,E)})}else{let s=null;const h=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,t,b,c);const E={terminated:this.terminateRequested};T.isNumber(u)&&(E.cmdCode=u),t(E)};if(this.shell&&k.isWindows){const u=C.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let E=!1,A=!1;const R=[];let $=this.ensureQuotes(this.cmd);R.push($.value),E=$.quoted,this.args&&this.args.forEach(F=>{$=this.ensureQuotes(F),R.push($.value),A=A&&$.quoted});const N=["/s","/c"];E?A?N.push('"'+R.join(" ")+'"'):R.length>1?N.push('"'+R[0]+'" '+R.slice(1).join(" ")):N.push('"'+R[0]+'"'):N.push(R.join(" ")),s=m.spawn(P(),N,u)}else this.cmd&&(s=m.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(T.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",u=>{this.childProcess=null,c({terminated:this.terminateRequested,error:u})}),s.pid&&(this.childProcess.on("close",h),this.handleSpawn(s,t,b,c,!0)))}return d})}handleClose(b,i,t,c){}ensureQuotes(b){return p.regexp.test(b)?{value:'"'+b+'"',quoted:!0}:{value:b,quoted:b.length>0&&b[0]==='"'&&b[b.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(b=>b.pid,b=>-1):new Promise(b=>{this.pidResolve=b})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(b=>(this.terminateRequested=!0,v(b,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),b=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(b=>{if(!this.shell||!k.isWindows)return b(!1);const i=m.spawn(P(),["/s","/c"]);i.on("error",t=>b(!0)),i.on("exit",t=>b(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class l extends p{constructor(b,i,t,c){super(b,i,t,c);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(b,i,t,c,d){[c,d].forEach((s,h)=>{const u=new I.LineDecoder;u.write(s).forEach(R=>{i({line:R,source:h===0?0:1})});const A=u.end();A&&i({line:A,source:h===0?0:1})}),b({terminated:this.terminateRequested,error:t})}handleSpawn(b,i,t,c,d){const s=new I.LineDecoder,h=new I.LineDecoder;b.stdout.on("data",u=>{s.write(u).forEach(A=>t({line:A,source:0}))}),b.stderr.on("data",u=>{h.write(u).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=h}handleClose(b,i,t,c){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&t({line:d,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&t({line:s,source:1})}}e.LineProcess=l;function r(o){let b=[],i=!1;const t=function(c){if(i){b.push(c);return}(!o.send(c,s=>{if(s&&console.error(s),i=!1,b.length>0){const h=b.slice(0);b=[],h.forEach(u=>t(u))}})||k.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=r;var g;(function(o){async function b(i,t,c){if(n.isAbsolute(i))return i;if(t===void 0&&(t=S.cwd()),n.dirname(i)!=="."||(c===void 0&&T.isString(S.env.PATH)&&(c=S.env.PATH.split(n.delimiter)),c===void 0||c.length===0))return n.join(t,i);async function s(h){if(await a.Promises.exists(h)){let u;try{u=await a.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(u=await a.Promises.lstat(h))}return u?!u.isDirectory():!1}return!1}for(let h of c){let u;if(n.isAbsolute(h)?u=n.join(h,i):u=n.join(t,h,i),await s(u))return u;let E=u+".com";if(await s(E)||(E=u+".exe",await s(E)))return E}return n.join(t,i)}o.findExecutable=b})(g=e.win32||(e.win32={}))}),define(me[154],ge([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,154,11,110]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.deriveFromWorkspaceTrust=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class n{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=n;class k{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,Se){this._values[re]=Se}}e.ValidatedEditorOptions=k;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class y{constructor(re,Se,Ge,Ye){this.id=re,this.name=Se,this.defaultValue=Ge,this.schema=Ye}compute(re,Se,Ge){return Ge}}class T{constructor(re,Se=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=Se}validate(re){return this.defaultValue}}class I{constructor(re,Se,Ge,Ye){this.id=re,this.name=Se,this.defaultValue=Ge,this.schema=Ye}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,Se,Ge){return Ge}}function a(ee,re){return typeof ee=="undefined"?re:ee==="false"?!1:Boolean(ee)}e.boolean=a;class w extends I{constructor(re,Se,Ge,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ge),super(re,Se,Ge,Ye)}validate(re){return a(re,this.defaultValue)}}function f(ee,re,Se,Ge){if(typeof ee=="undefined")return re;let Ye=parseInt(ee,10);return isNaN(Ye)?re:(Ye=Math.max(Se,Ye),Ye=Math.min(Ge,Ye),Ye|0)}e.clampedInt=f;class v extends I{constructor(re,Se,Ge,Ye,nt,de=void 0){typeof de!="undefined"&&(de.type="integer",de.default=Ge,de.minimum=Ye,de.maximum=nt),super(re,Se,Ge,de),this.minimum=Ye,this.maximum=nt}static clampedInt(re,Se,Ge,Ye){return f(re,Se,Ge,Ye)}validate(re){return v.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class _ extends I{constructor(re,Se,Ge,Ye,nt){typeof nt!="undefined"&&(nt.type="number",nt.default=Ge),super(re,Se,Ge,nt),this.validationFn=Ye}static clamp(re,Se,Ge){return re<Se?Se:re>Ge?Ge:re}static float(re,Se){if(typeof re=="number")return re;if(typeof re=="undefined")return Se;const Ge=parseFloat(re);return isNaN(Ge)?Se:Ge}validate(re){return this.validationFn(_.float(re,this.defaultValue))}}class P extends I{static string(re,Se){return typeof re!="string"?Se:re}constructor(re,Se,Ge,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ge),super(re,Se,Ge,Ye)}validate(re){return P.string(re,this.defaultValue)}}function p(ee,re,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?re:ee}e.stringSet=p;class l extends I{constructor(re,Se,Ge,Ye,nt=void 0){typeof nt!="undefined"&&(nt.type="string",nt.enum=Ye,nt.default=Ge),super(re,Se,Ge,nt),this._allowedValues=Ye}validate(re){return p(re,this.defaultValue,this._allowedValues)}}class r extends y{constructor(re,Se,Ge,Ye,nt,de,ke=void 0){typeof ke!="undefined"&&(ke.type="string",ke.enum=nt,ke.default=Ye),super(re,Se,Ge,ke),this._allowedValues=nt,this._convert=de}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function g(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Se,Ge){return Ge===0?re.accessibilitySupport:Ge}}class b extends y{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:m.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{insertSpace:a(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(ee){switch(ee){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function s(ee){switch(ee){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class h extends T{constructor(){super(127,[65,33])}compute(re,Se,Ge){const Ye=["monaco-editor"];return Se.get(33)&&Ye.push(Se.get(33)),re.extraEditorClassName&&Ye.push(re.extraEditorClassName),Se.get(65)==="default"?Ye.push("mouse-default"):Se.get(65)==="copy"&&Ye.push("mouse-copy"),Se.get(99)&&Ye.push("showUnused"),Se.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class u extends w{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(re,Se,Ge){return Ge&&re.emptySelectionClipboard}}class E extends y{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:m.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{cursorMoveOnType:a(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":p(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":p(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Se.loop,this.defaultValue.loop)}}}class A extends y{constructor(){super(44,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?A.OFF:re==="true"?A.ON:re:Boolean(re)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class R extends T{constructor(){super(43)}compute(re,Se,Ge){return re.fontInfo}}class $ extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(re){let Se=_.float(re,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(Se,6,100)}compute(re,Se,Ge){return re.fontInfo.fontSize}}class N extends y{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(re){return re==="normal"||re==="bold"?re:String(v.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class F extends y{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:Ge,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:Ge,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:Ge,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:Ge,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:Ge,description:m.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{multiple:p(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??p(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??p(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??p(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??p(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??p(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends y{constructor(){const re={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:re.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:re.above,description:m.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:a(Se.enabled,this.defaultValue.enabled),delay:v.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:a(Se.sticky,this.defaultValue.sticky),above:a(Se.above,this.defaultValue.above)}}}var M;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class W extends T{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(re,Se,Ge){return W.computeLayout(Se,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const Se=re.height/re.lineHeight,Ge=re.scrollBeyondLastLine?Se-1:0,Ye=(re.viewLineCount+Ge)/(re.pixelRatio*re.height),nt=Math.floor(re.viewLineCount/Ye);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:Ge,desiredRatio:Ye,minimapLineCount:nt}}static _computeMinimapLayout(re,Se){const Ge=re.outerWidth,Ye=re.outerHeight,nt=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const de=Se.stableMinimapLayoutInput,ke=de&&re.outerHeight===de.outerHeight&&re.lineHeight===de.lineHeight&&re.typicalHalfwidthCharacterWidth===de.typicalHalfwidthCharacterWidth&&re.pixelRatio===de.pixelRatio&&re.scrollBeyondLastLine===de.scrollBeyondLastLine&&re.minimap.enabled===de.minimap.enabled&&re.minimap.side===de.minimap.side&&re.minimap.size===de.minimap.size&&re.minimap.showSlider===de.minimap.showSlider&&re.minimap.renderCharacters===de.minimap.renderCharacters&&re.minimap.maxColumn===de.minimap.maxColumn&&re.minimap.scale===de.minimap.scale&&re.verticalScrollbarWidth===de.verticalScrollbarWidth&&re.isViewportWrapping===de.isViewportWrapping,Ue=re.lineHeight,$e=re.typicalHalfwidthCharacterWidth,tt=re.scrollBeyondLastLine,Te=re.minimap.renderCharacters;let Ce=nt>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const we=re.minimap.maxColumn,oe=re.minimap.size,ue=re.minimap.side,pe=re.verticalScrollbarWidth,be=re.viewLineCount,Fe=re.remainingWidth,Qe=re.isViewportWrapping,xe=Te?2:3;let Xe=Math.floor(nt*Ye);const at=Xe/nt;let ct=!1,le=!1,_e=xe*Ce,ae=Ce/nt,Q=1;if(oe==="fill"||oe==="fit"){const{typicalViewportLineCount:kt,extraLinesBeyondLastLine:bt,desiredRatio:gt,minimapLineCount:Et}=W.computeContainedMinimapLineCount({viewLineCount:be,scrollBeyondLastLine:tt,height:Ye,lineHeight:Ue,pixelRatio:nt});if(be/Et>1)ct=!0,le=!0,Ce=1,_e=1,ae=Ce/nt;else{let Lt=!1,yt=Ce+1;if(oe==="fit"){const At=Math.ceil((be+bt)*_e);Qe&&ke&&Fe<=Se.stableFitRemainingWidth?(Lt=!0,yt=Se.stableFitMaxMinimapScale):Lt=At>Xe}if(oe==="fill"||Lt){ct=!0;const At=Ce;_e=Math.min(Ue*nt,Math.max(1,Math.floor(1/gt))),Qe&&ke&&Fe<=Se.stableFitRemainingWidth&&(yt=Se.stableFitMaxMinimapScale),Ce=Math.min(yt,Math.max(1,Math.floor(_e/xe))),Ce>At&&(Q=Math.min(2,Ce/At)),ae=Ce/nt/Q,Xe=Math.ceil(Math.max(kt,be+bt)*_e),Qe?(Se.stableMinimapLayoutInput=re,Se.stableFitRemainingWidth=Fe,Se.stableFitMaxMinimapScale=Ce):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const ye=Math.floor(we*ae),Le=Math.min(ye,Math.max(0,Math.floor((Fe-pe-2)*ae/($e+ae)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(nt*Le);const qe=et/nt;et=Math.floor(et*Q);const mt=Te?1:2,_t=ue==="left"?0:Ge-Le-pe;return{renderMinimap:mt,minimapLeft:_t,minimapWidth:Le,minimapHeightIsEditorHeight:ct,minimapIsSampling:le,minimapScale:Ce,minimapLineHeight:_e,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(re,Se){const Ge=Se.outerWidth|0,Ye=Se.outerHeight|0,nt=Se.lineHeight|0,de=Se.lineNumbersDigitCount|0,ke=Se.typicalHalfwidthCharacterWidth,Ue=Se.maxDigitWidth,$e=Se.pixelRatio,tt=Se.viewLineCount,Te=re.get(122),Ce=Te==="inherit"?re.get(121):Te,we=Ce==="inherit"?re.get(117):Ce,oe=re.get(120),ue=re.get(2),pe=Se.isDominatedByLongLines,be=re.get(49),Fe=re.get(59).renderType!==0,Qe=re.get(60),xe=re.get(93),Xe=re.get(64),at=re.get(91),ct=at.verticalScrollbarSize,le=at.verticalHasArrows,_e=at.arrowSize,ae=at.horizontalScrollbarSize,Q=re.get(57),ye=re.get(37);let Le;if(typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)){const Bt=parseFloat(Q.substr(0,Q.length-2));Le=v.clampedInt(Bt*ke,0,0,1e3)}else Le=v.clampedInt(Q,0,0,1e3);ye&&(Le+=16);let et=0;if(Fe){const Bt=Math.max(de,Qe);et=Math.round(Bt*Ue)}let qe=0;be&&(qe=nt);let mt=0,_t=mt+qe,kt=_t+et,bt=kt+Le;const gt=Ge-qe-et-Le;let Et=!1,Ct=!1,Lt=-1;ue!==2&&(Ce==="inherit"&&pe?(Et=!0,Ct=!0):we==="on"||we==="bounded"?Ct=!0:we==="wordWrapColumn"&&(Lt=oe));const yt=W._computeMinimapLayout({outerWidth:Ge,outerHeight:Ye,lineHeight:nt,typicalHalfwidthCharacterWidth:ke,pixelRatio:$e,scrollBeyondLastLine:xe,minimap:Xe,verticalScrollbarWidth:ct,viewLineCount:tt,remainingWidth:gt,isViewportWrapping:Ct},Se.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(mt+=yt.minimapWidth,_t+=yt.minimapWidth,kt+=yt.minimapWidth,bt+=yt.minimapWidth);const At=gt-yt.minimapWidth,xt=Math.max(1,Math.floor((At-ct-2)/ke)),Tt=le?_e:0;return Ct&&(Lt=Math.max(1,xt),we==="bounded"&&(Lt=Math.min(Lt,oe))),{width:Ge,height:Ye,glyphMarginLeft:mt,glyphMarginWidth:qe,lineNumbersLeft:_t,lineNumbersWidth:et,decorationsLeft:kt,decorationsWidth:Le,contentLeft:bt,contentWidth:At,minimap:yt,viewportColumn:xt,isWordWrapMinified:Et,isViewportWrapping:Ct,wrappingColumn:Lt,verticalScrollbarWidth:ct,horizontalScrollbarHeight:ae,overviewRuler:{top:Tt,width:ct,height:Ye-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=W;class U extends y{constructor(){const re={enabled:!0};super(56,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:m.localize(43,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:a(re.enabled,this.defaultValue.enabled)}}}class x extends y{constructor(){const re={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",re,{"editor.inlayHints.enabled":{type:"boolean",default:re.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:m.localize(46,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:a(Se.enabled,this.defaultValue.enabled),fontSize:v.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class B extends _{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>_.clamp(re,0,150),{markdownDescription:m.localize(47,null)})}compute(re,Se,Ge){return re.fontInfo.lineHeight}}class O extends y{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:re.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:m.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:a(Se.enabled,this.defaultValue.enabled),size:p(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(Se.side,this.defaultValue.side,["right","left"]),showSlider:p(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Se.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(Se.scale,1,1,3),maxColumn:v.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(ee){return ee==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends y{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{top:v.clampedInt(Se.top,0,0,1e3),bottom:v.clampedInt(Se.bottom,0,0,1e3)}}}class X extends y{constructor(){const re={enabled:!0,cycle:!1};super(75,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:m.localize(61,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:a(Se.enabled,this.defaultValue.enabled),cycle:a(Se.cycle,this.defaultValue.cycle)}}}class K extends T{constructor(){super(128)}compute(re,Se,Ge){return re.pixelRatio}}class he extends y{constructor(){const re={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:m.localize(62,null)},comments:{type:"boolean",default:re.comments,description:m.localize(63,null)},other:{type:"boolean",default:re.other,description:m.localize(64,null)}}}],default:re,description:m.localize(65,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const Se=re,Ge={other:a(Se.other,this.defaultValue.other),comments:a(Se.comments,this.defaultValue.comments),strings:a(Se.strings,this.defaultValue.strings)};return Ge.other&&Ge.comments&&Ge.strings?!0:!Ge.other&&!Ge.comments&&!Ge.strings?!1:Ge}return this.defaultValue}}var Ee;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Ee=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class De extends y{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(re){let Se=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(Se=4,Ge=re):re==="interval"?Se=3:re==="relative"?Se=2:re==="on"?Se=1:Se=0),{renderType:Se,renderFn:Ge}}}function Pe(ee){const re=ee.get(86);return re==="editable"?ee.get(80):re!=="on"}e.filterValidationDecorations=Pe;class Be extends y{constructor(){const re=[],Se={type:"number",description:m.localize(71,null)};super(90,"rulers",re,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:re,description:m.localize(73,null)})}validate(re){if(Array.isArray(re)){let Se=[];for(let Ge of re)if(typeof Ge=="number")Se.push({column:v.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Ye=Ge;Se.push({column:v.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Se.sort((Ge,Ye)=>Ge.column-Ye.column),Se}return this.defaultValue}}function He(ee,re){if(typeof ee!="string")return re;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends y{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:m.localize(84,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re,Ge=v.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=v.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:He(Se.vertical,this.defaultValue.vertical),horizontal:He(Se.horizontal,this.defaultValue.horizontal),useShadows:a(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:v.clampedInt(Se.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:v.clampedInt(Se.verticalSliderSize,Ye,0,1e3),scrollByPage:a(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.deriveFromWorkspaceTrust="deriveFromWorkspaceTrust",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class G extends y{constructor(){const re={nonBasicASCII:e.deriveFromWorkspaceTrust,invisibleCharacters:e.deriveFromWorkspaceTrust,ambiguousCharacters:e.deriveFromWorkspaceTrust,includeComments:e.deriveFromWorkspaceTrust,allowedCharacters:""};super(112,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:re.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:re.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:re.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:re.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"string",default:re.allowedCharacters,description:m.localize(89,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{nonBasicASCII:te(Se.nonBasicASCII,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),invisibleCharacters:te(Se.invisibleCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),ambiguousCharacters:te(Se.ambiguousCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),includeComments:te(Se.includeComments,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),allowedCharacters:Z(Se.allowedCharacters,"")}}}function Z(ee,re){return typeof ee!="string"?re:ee}class ne extends y{constructor(){const re={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:m.localize(90,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:a(Se.enabled,this.defaultValue.enabled),mode:p(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ce extends y{constructor(){const re={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,description:m.localize(91,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:a(re.enabled,this.defaultValue.enabled)}}}class J extends y{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:re.bracketPairs,description:m.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:re.bracketPairsHorizontal,description:m.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:m.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:m.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:re.highlightActiveIndentation,description:m.localize(102,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{bracketPairs:te(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function te(ee,re,Se){const Ge=Se.indexOf(ee);return Ge===-1?re:Se[Ge]}class ve extends y{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(103,null),m.localize(104,null)],default:re.insertMode,description:m.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:m.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:m.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:m.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:m.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:m.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:m.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:m.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:m.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{insertMode:p(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(Se.showIcons,this.defaultValue.showIcons),showStatusBar:a(Se.showStatusBar,this.defaultValue.showStatusBar),preview:a(Se.preview,this.defaultValue.preview),previewMode:p(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Se.showMethods,this.defaultValue.showMethods),showFunctions:a(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:a(Se.showFields,this.defaultValue.showFields),showVariables:a(Se.showVariables,this.defaultValue.showVariables),showClasses:a(Se.showClasses,this.defaultValue.showClasses),showStructs:a(Se.showStructs,this.defaultValue.showStructs),showInterfaces:a(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Se.showModules,this.defaultValue.showModules),showProperties:a(Se.showProperties,this.defaultValue.showProperties),showEvents:a(Se.showEvents,this.defaultValue.showEvents),showOperators:a(Se.showOperators,this.defaultValue.showOperators),showUnits:a(Se.showUnits,this.defaultValue.showUnits),showValues:a(Se.showValues,this.defaultValue.showValues),showConstants:a(Se.showConstants,this.defaultValue.showConstants),showEnums:a(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Se.showKeywords,this.defaultValue.showKeywords),showWords:a(Se.showWords,this.defaultValue.showWords),showColors:a(Se.showColors,this.defaultValue.showColors),showFiles:a(Se.showFiles,this.defaultValue.showFiles),showReferences:a(Se.showReferences,this.defaultValue.showReferences),showFolders:a(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Se.showSnippets,this.defaultValue.showSnippets),showUsers:a(Se.showUsers,this.defaultValue.showUsers),showIssues:a(Se.showIssues,this.defaultValue.showIssues)}}}class Me extends y{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(145,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class je extends T{constructor(){super(129,[80])}compute(re,Se,Ge){return Se.get(80)?!0:re.tabFocusMode}}var Ke;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(Ke=e.WrappingIndent||(e.WrappingIndent={}));function Ze(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class rt extends T{constructor(){super(131,[130])}compute(re,Se,Ge){const Ye=Se.get(130);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const ut="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?it:L.isLinux?st:ut,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ae(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var wt;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=42]="fontFamily",ee[ee.fontInfo=43]="fontInfo",ee[ee.fontLigatures=44]="fontLigatures",ee[ee.fontSize=45]="fontSize",ee[ee.fontWeight=46]="fontWeight",ee[ee.formatOnPaste=47]="formatOnPaste",ee[ee.formatOnType=48]="formatOnType",ee[ee.glyphMargin=49]="glyphMargin",ee[ee.gotoLocation=50]="gotoLocation",ee[ee.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",ee[ee.hover=52]="hover",ee[ee.inDiffEditor=53]="inDiffEditor",ee[ee.inlineSuggest=54]="inlineSuggest",ee[ee.letterSpacing=55]="letterSpacing",ee[ee.lightbulb=56]="lightbulb",ee[ee.lineDecorationsWidth=57]="lineDecorationsWidth",ee[ee.lineHeight=58]="lineHeight",ee[ee.lineNumbers=59]="lineNumbers",ee[ee.lineNumbersMinChars=60]="lineNumbersMinChars",ee[ee.linkedEditing=61]="linkedEditing",ee[ee.links=62]="links",ee[ee.matchBrackets=63]="matchBrackets",ee[ee.minimap=64]="minimap",ee[ee.mouseStyle=65]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=67]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=69]="multiCursorModifier",ee[ee.multiCursorPaste=70]="multiCursorPaste",ee[ee.occurrencesHighlight=71]="occurrencesHighlight",ee[ee.overviewRulerBorder=72]="overviewRulerBorder",ee[ee.overviewRulerLanes=73]="overviewRulerLanes",ee[ee.padding=74]="padding",ee[ee.parameterHints=75]="parameterHints",ee[ee.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=78]="quickSuggestions",ee[ee.quickSuggestionsDelay=79]="quickSuggestionsDelay",ee[ee.readOnly=80]="readOnly",ee[ee.renameOnType=81]="renameOnType",ee[ee.renderControlCharacters=82]="renderControlCharacters",ee[ee.renderFinalNewline=83]="renderFinalNewline",ee[ee.renderLineHighlight=84]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=86]="renderValidationDecorations",ee[ee.renderWhitespace=87]="renderWhitespace",ee[ee.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",ee[ee.roundedSelection=89]="roundedSelection",ee[ee.rulers=90]="rulers",ee[ee.scrollbar=91]="scrollbar",ee[ee.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=93]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=94]="scrollPredominantAxis",ee[ee.selectionClipboard=95]="selectionClipboard",ee[ee.selectionHighlight=96]="selectionHighlight",ee[ee.selectOnLineNumbers=97]="selectOnLineNumbers",ee[ee.showFoldingControls=98]="showFoldingControls",ee[ee.showUnused=99]="showUnused",ee[ee.snippetSuggestions=100]="snippetSuggestions",ee[ee.smartSelect=101]="smartSelect",ee[ee.smoothScrolling=102]="smoothScrolling",ee[ee.stickyTabStops=103]="stickyTabStops",ee[ee.stopRenderingLineAfter=104]="stopRenderingLineAfter",ee[ee.suggest=105]="suggest",ee[ee.suggestFontSize=106]="suggestFontSize",ee[ee.suggestLineHeight=107]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",ee[ee.suggestSelection=109]="suggestSelection",ee[ee.tabCompletion=110]="tabCompletion",ee[ee.tabIndex=111]="tabIndex",ee[ee.unicodeHighlighting=112]="unicodeHighlighting",ee[ee.unusualLineTerminators=113]="unusualLineTerminators",ee[ee.useShadowDOM=114]="useShadowDOM",ee[ee.useTabStops=115]="useTabStops",ee[ee.wordSeparators=116]="wordSeparators",ee[ee.wordWrap=117]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=120]="wordWrapColumn",ee[ee.wordWrapOverride1=121]="wordWrapOverride1",ee[ee.wordWrapOverride2=122]="wordWrapOverride2",ee[ee.wrappingIndent=123]="wrappingIndent",ee[ee.wrappingStrategy=124]="wrappingStrategy",ee[ee.showDeprecated=125]="showDeprecated",ee[ee.inlayHints=126]="inlayHints",ee[ee.editorClassName=127]="editorClassName",ee[ee.pixelRatio=128]="pixelRatio",ee[ee.tabFocusMode=129]="tabFocusMode",ee[ee.layoutInfo=130]="layoutInfo",ee[ee.wrappingInfo=131]="wrappingInfo"})(wt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new w(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(146,null)})),acceptSuggestionOnEnter:Ae(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(147,null),""],markdownDescription:m.localize(148,null)})),accessibilitySupport:Ae(new o),accessibilityPageSize:Ae(new v(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(149,null)})),ariaLabel:Ae(new P(4,"ariaLabel",m.localize(150,null))),autoClosingBrackets:Ae(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),autoClosingDelete:Ae(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(154,null),""],description:m.localize(155,null)})),autoClosingOvertype:Ae(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingQuotes:Ae(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(158,null),m.localize(159,null),""],description:m.localize(160,null)})),autoIndent:Ae(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[m.localize(161,null),m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null)],description:m.localize(166,null)})),automaticLayout:Ae(new w(10,"automaticLayout",!1)),autoSurround:Ae(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(167,null),m.localize(168,null),m.localize(169,null),""],description:m.localize(170,null)})),bracketPairColorization:Ae(new ce),bracketPairGuides:Ae(new J),stickyTabStops:Ae(new w(103,"stickyTabStops",!1,{description:m.localize(171,null)})),codeLens:Ae(new w(14,"codeLens",!0,{description:m.localize(172,null)})),codeLensFontFamily:Ae(new P(15,"codeLensFontFamily","",{description:m.localize(173,null)})),codeLensFontSize:Ae(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(174,null)})),colorDecorators:Ae(new w(17,"colorDecorators",!0,{description:m.localize(175,null)})),columnSelection:Ae(new w(18,"columnSelection",!1,{description:m.localize(176,null)})),comments:Ae(new b),contextmenu:Ae(new w(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new w(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(177,null)})),cursorBlinking:Ae(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:m.localize(178,null)})),cursorSmoothCaretAnimation:Ae(new w(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(179,null)})),cursorStyle:Ae(new r(24,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],s,{description:m.localize(180,null)})),cursorSurroundingLines:Ae(new v(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(181,null)})),cursorSurroundingLinesStyle:Ae(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(182,null),m.localize(183,null)],description:m.localize(184,null)})),cursorWidth:Ae(new v(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(185,null)})),disableLayerHinting:Ae(new w(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new w(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new w(30,"domReadOnly",!1)),dragAndDrop:Ae(new w(31,"dragAndDrop",!0,{description:m.localize(186,null)})),emptySelectionClipboard:Ae(new u),extraEditorClassName:Ae(new P(33,"extraEditorClassName","")),fastScrollSensitivity:Ae(new _(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(187,null)})),find:Ae(new E),fixedOverflowWidgets:Ae(new w(36,"fixedOverflowWidgets",!1)),folding:Ae(new w(37,"folding",!0,{description:m.localize(188,null)})),foldingStrategy:Ae(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),foldingHighlight:Ae(new w(39,"foldingHighlight",!0,{description:m.localize(192,null)})),foldingImportsByDefault:Ae(new w(40,"foldingImportsByDefault",!1,{description:m.localize(193,null)})),unfoldOnClickAfterEndOfLine:Ae(new w(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(194,null)})),fontFamily:Ae(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(195,null)})),fontInfo:Ae(new R),fontLigatures2:Ae(new A),fontSize:Ae(new $),fontWeight:Ae(new N),formatOnPaste:Ae(new w(47,"formatOnPaste",!1,{description:m.localize(196,null)})),formatOnType:Ae(new w(48,"formatOnType",!1,{description:m.localize(197,null)})),glyphMargin:Ae(new w(49,"glyphMargin",!0,{description:m.localize(198,null)})),gotoLocation:Ae(new F),hideCursorInOverviewRuler:Ae(new w(51,"hideCursorInOverviewRuler",!1,{description:m.localize(199,null)})),hover:Ae(new z),inDiffEditor:Ae(new w(53,"inDiffEditor",!1)),letterSpacing:Ae(new _(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>_.clamp(ee,-5,20),{description:m.localize(200,null)})),lightbulb:Ae(new U),lineDecorationsWidth:Ae(new I(57,"lineDecorationsWidth",10)),lineHeight:Ae(new B),lineNumbers:Ae(new De),lineNumbersMinChars:Ae(new v(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new w(61,"linkedEditing",!1,{description:m.localize(201,null)})),links:Ae(new w(62,"links",!0,{description:m.localize(202,null)})),matchBrackets:Ae(new l(63,"matchBrackets","always",["always","near","never"],{description:m.localize(203,null)})),minimap:Ae(new O),mouseStyle:Ae(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new _(66,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(204,null)})),mouseWheelZoom:Ae(new w(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(205,null)})),multiCursorMergeOverlapping:Ae(new w(68,"multiCursorMergeOverlapping",!0,{description:m.localize(206,null)})),multiCursorModifier:Ae(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[m.localize(207,null),m.localize(208,null)],markdownDescription:m.localize(209,null)})),multiCursorPaste:Ae(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(210,null),m.localize(211,null)],markdownDescription:m.localize(212,null)})),occurrencesHighlight:Ae(new w(71,"occurrencesHighlight",!0,{description:m.localize(213,null)})),overviewRulerBorder:Ae(new w(72,"overviewRulerBorder",!0,{description:m.localize(214,null)})),overviewRulerLanes:Ae(new v(73,"overviewRulerLanes",3,0,3)),padding:Ae(new j),parameterHints:Ae(new X),peekWidgetDefaultFocus:Ae(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(215,null),m.localize(216,null)],description:m.localize(217,null)})),definitionLinkOpensInPeek:Ae(new w(77,"definitionLinkOpensInPeek",!1,{description:m.localize(218,null)})),quickSuggestions:Ae(new he),quickSuggestionsDelay:Ae(new v(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(219,null)})),readOnly:Ae(new w(80,"readOnly",!1)),renameOnType:Ae(new w(81,"renameOnType",!1,{description:m.localize(220,null),markdownDeprecationMessage:m.localize(221,null)})),renderControlCharacters:Ae(new w(82,"renderControlCharacters",!0,{description:m.localize(222,null),restricted:!0})),renderFinalNewline:Ae(new w(83,"renderFinalNewline",!0,{description:m.localize(223,null)})),renderLineHighlight:Ae(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(224,null)],description:m.localize(225,null)})),renderLineHighlightOnlyWhenFocus:Ae(new w(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(226,null)})),renderValidationDecorations:Ae(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),revealHorizontalRightPadding:Ae(new v(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ae(new w(89,"roundedSelection",!0,{description:m.localize(231,null)})),rulers:Ae(new Be),scrollbar:Ae(new ze),scrollBeyondLastColumn:Ae(new v(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(232,null)})),scrollBeyondLastLine:Ae(new w(93,"scrollBeyondLastLine",!0,{description:m.localize(233,null)})),scrollPredominantAxis:Ae(new w(94,"scrollPredominantAxis",!0,{description:m.localize(234,null)})),selectionClipboard:Ae(new w(95,"selectionClipboard",!0,{description:m.localize(235,null),included:L.isLinux})),selectionHighlight:Ae(new w(96,"selectionHighlight",!0,{description:m.localize(236,null)})),selectOnLineNumbers:Ae(new w(97,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),showUnused:Ae(new w(99,"showUnused",!0,{description:m.localize(240,null)})),showDeprecated:Ae(new w(125,"showDeprecated",!0,{description:m.localize(241,null)})),inlayHints:Ae(new x),snippetSuggestions:Ae(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(242,null),m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),smartSelect:Ae(new Me),smoothScrolling:Ae(new w(102,"smoothScrolling",!1,{description:m.localize(247,null)})),stopRenderingLineAfter:Ae(new v(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new ve),inlineSuggest:Ae(new ne),suggestFontSize:Ae(new v(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(248,null)})),suggestLineHeight:Ae(new v(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestOnTriggerCharacters:Ae(new w(108,"suggestOnTriggerCharacters",!0,{description:m.localize(250,null)})),suggestSelection:Ae(new l(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),tabCompletion:Ae(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),tabIndex:Ae(new v(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new G),unusualLineTerminators:Ae(new l(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),useShadowDOM:Ae(new w(114,"useShadowDOM",!0)),useTabStops:Ae(new w(115,"useTabStops",!0,{description:m.localize(263,null)})),wordSeparators:Ae(new P(116,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:m.localize(264,null)})),wordWrap:Ae(new l(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(265,null),m.localize(266,null),m.localize(267,null),m.localize(268,null)],description:m.localize(269,null)})),wordWrapBreakAfterCharacters:Ae(new P(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new P(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new v(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(270,null)})),wordWrapOverride1:Ae(new l(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new l(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ae(new r(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ze,{enumDescriptions:[m.localize(271,null),m.localize(272,null),m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),wrappingStrategy:Ae(new l(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(276,null),m.localize(277,null)],description:m.localize(278,null)})),editorClassName:Ae(new h),pixelRatio:Ae(new K),tabFocusMode:Ae(new je),layoutInfo:Ae(new W),wrappingInfo:Ae(new rt)}}),define(me[155],ge([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(me[160],ge([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(me[162],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[163],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[164],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(me[165],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[166],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[167],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[168],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[169],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[170],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(me[171],ge([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(me[172],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[173],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[174],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[175],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[176],ge([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[177],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(n){n[n.ACTIVATE=1]="ACTIVATE",n[n.RESTORE=2]="RESTORE",n[n.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(n){n[n.PICK=0]="PICK",n[n.DISABLED=1]="DISABLED",n[n.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var D;(function(n){n[n.API=0]="API",n[n.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(n){n[n.Center=0]="Center",n[n.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",n[n.NearTop=2]="NearTop",n[n.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[178],ge([0,1,157]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(a){return a=a.trim(),a==="*"||L.test(a)}e.isValidVersionStr=C;function n(a){if(!C(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=a.match(L);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=n;function k(a){if(!a)return null;let w=a.majorBase,f=a.majorMustEqual,v=a.minorBase,_=a.minorMustEqual,P=a.patchBase,p=a.patchMustEqual;a.hasCaret&&(w===0||(_=!1),p=!1);let l=0;if(a.preRelease){const r=D.exec(a.preRelease);if(r){const[,g,o,b]=r;l=Date.UTC(Number(g),Number(o)-1,Number(b))}}return{majorBase:w,majorMustEqual:f,minorBase:v,minorMustEqual:_,patchBase:P,patchMustEqual:p,isMinimum:a.hasGreaterEquals,notBefore:l}}e.normalizeVersion=k;function S(a,w,f){let v;typeof a=="string"?v=k(n(a)):v=a;let _;w instanceof Date?_=w.getTime():typeof w=="string"&&(_=new Date(w).getTime());let P;if(typeof f=="string"?P=k(n(f)):P=f,!v||!P)return!1;let p=v.majorBase,l=v.minorBase,r=v.patchBase,g=P.majorBase,o=P.minorBase,b=P.patchBase,i=P.notBefore,t=P.majorMustEqual,c=P.minorMustEqual,d=P.patchMustEqual;return P.isMinimum?p>g?!0:p<g?!1:l>o?!0:l<o||_&&_<i?!1:r>=b:(p===1&&g===0&&(!t||!c||!d)&&(g=1,o=0,b=0,t=!0,c=!1,d=!1),p<g?!1:p>g?!t:l<o?!1:l>o?!c:r<b?!1:r>b?!d:!(_&&_<i))}e.isValidVersion=S;function y(a,w,f,v){return f.isBuiltin||typeof f.main=="undefined"?!0:I(a,w,f.engines.vscode,v)}e.isValidExtensionVersion=y;function T(a,w,f){return a==="*"||I(w,f,a)}e.isEngineValid=T;function I(a,w,f,v=[]){let _=k(n(f));if(!_)return v.push(m.localize(0,null,f)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(m.localize(1,null,f)),!1}else if(!_.majorMustEqual)return v.push(m.localize(2,null,f)),!1;return S(a,w,_)?!0:(v.push(m.localize(3,null,a,f)),!1)}}),define(me[115],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(D,C=[],n=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m}),define(me[83],ge([0,1,115]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(n,k,S){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],S)),L.push([n,k])}e.registerSingleton=D;function C(){return L}e.getSingletonServiceDescriptors=C}),define(me[179],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let n of this._nodes.values())n.outgoing.size===0&&C.push(n);return C}insertEdge(C,n){const k=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(n);k.outgoing.set(this._hashFn(n),S),S.incoming.set(this._hashFn(C),k)}removeNode(C){const n=this._hashFn(C);this._nodes.delete(n);for(let k of this._nodes.values())k.outgoing.delete(n),k.incoming.delete(n)}lookupOrInsertNode(C){const n=this._hashFn(C);let k=this._nodes.get(n);return k||(k=new m(C),this._nodes.set(n,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[n,k]of this._nodes)C.push(`${n}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,n]of this._nodes){const k=new Set([C]),S=this._findCycle(n,k);if(S)return S}}_findCycle(C,n){for(let[k,S]of C.outgoing){if(n.has(k))return[...n,k].join(" -> ");n.add(k);const y=this._findCycle(S,n);if(y)return y;n.delete(k)}}}e.Graph=L}),define(me[4],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(n,k,S,y){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:n,index:S,optional:y}):(k[m.DI_DEPENDENCIES]=[{id:n,index:S,optional:y}],k[m.DI_TARGET]=k)}function D(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const k=function(S,y,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,S,T,!1)};return k.toString=()=>n,m.serviceIds.set(n,k),k}e.createDecorator=D;function C(n){return n}e.refineServiceDecorator=C}),define(me[180],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[181],ge([0,1,3,48,6,24,77,82,180]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function y(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(y):!!v.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(_,P){let p={selector:_,provider:P,_score:-1,_time:this._clock++};return this._entries.push(p),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(p){let l=this._entries.indexOf(p);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),p=void 0)}})}has(_){return this.all(_).length>0}all(_){if(!_)return[];this._updateScores(_);const P=[];for(let p of this._entries)p._score>0&&P.push(p.provider);return P}ordered(_){const P=[];return this._orderedForEach(_,p=>P.push(p.provider)),P}orderedGroups(_){const P=[];let p,l;return this._orderedForEach(_,r=>{p&&l===r._score?p.push(r.provider):(l=r._score,p=[r.provider],P.push(p))}),P}_orderedForEach(_,P){if(!!_){this._updateScores(_);for(const p of this._entries)p._score>0&&P(p)}}_updateScores(_){let P={uri:_.uri.toString(),language:_.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let p of this._entries)if(p._score=(0,k.score)(p.selector,_.uri,_.getLanguageId(),(0,S.shouldSynchronizeModel)(_)),y(p.selector)&&p._score>0){for(let l of this._entries)l._score=0;p._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(_,P){return _._score<P._score?1:_._score>P._score?-1:_._time<P._time?1:_._time>P._time?-1:0}}e.LanguageFeatureRegistry=T;const I=new WeakMap;let a=0;function w(v){let _=I.get(v);return _===void 0&&(_=++a,I.set(v,_)),_}class f{constructor(_,P,p=Number.MAX_SAFE_INTEGER){this._registry=_,this.min=P,this.max=p,this._cache=new C.LRUCache(50,.7)}_key(_){return _.id+this._registry.all(_).reduce((P,p)=>(0,L.doHash)(w(p),P),0)}_clamp(_){return _===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(_*1.3)))}get(_){const P=this._key(_),p=this._cache.get(P);return this._clamp(p?.value)}update(_,P){const p=this._key(_);let l=this._cache.get(p);return l||(l=new n.MovingAverage,this._cache.set(p,l)),l.update(P),this.get(_)}}e.LanguageFeatureRequestDelays=f}),define(me[84],ge([0,1,2,41,181,148,78]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var S;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var y;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(y=e.ColorId||(e.ColorId={}));var T;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class a{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let A=this.getForeground(E),R="mtk"+A,$=this.getFontStyle(E);return $&1&&(R+=" mtki"),$&2&&(R+=" mtkb"),$&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(E,A){const R=this.getForeground(E),$=this.getFontStyle(E);let N=`color: ${A[R]};`;return $&1&&(N+="font-style: italic;"),$&2&&(N+="font-weight: bold;"),$&4&&(N+="text-decoration: underline;"),N}}e.TokenMetadata=a;var w;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(w=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(E){const A=u[E];let R=A&&n.iconRegistry.get(A);return R||(console.info("No codicon found for CompletionItemKind "+E),R=n.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(E,A){let R=u[E];return typeof R=="undefined"&&!A&&(R=9),R}}();var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var r;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(r=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(u){return u&&m.URI.isUri(u.uri)&&L.Range.isIRange(u.range)&&(L.Range.isIRange(u.originSelectionRange)||L.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=g;var o;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(o=e.SymbolKind||(e.SymbolKind={}));var b;(function(u){u[u.Deprecated=1]="Deprecated"})(b=e.SymbolTag||(e.SymbolTag={}));var i;(function(u){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function R(F){return E.get(F)}u.fromString=R;function $(F){return A.get(F)}u.toString=$;function N(F,z){const M=A.get(F);let W=M&&n.iconRegistry.get("symbol-"+M);return W||(console.info("No codicon found for SymbolKind "+F),W=n.Codicon.symbolProperty),`${z?"inline":"block"} ${W.classNames}`}u.toCssClassName=N})(i=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(E){this.value=E}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var c;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var s;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var h;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(h=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,11,8,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const n=new Map;n.set("false",!1),n.set("true",!0),n.set("isMac",m.isMacintosh),n.set("isLinux",m.isLinux),n.set("isWindows",m.isWindows),n.set("isWeb",m.isWeb),n.set("isMacNative",m.isMacintosh&&!m.isWeb),n.set("isEdge",C.indexOf("Edg/")>=0),n.set("isFirefox",C.indexOf("Firefox")>=0),n.set("isChrome",C.indexOf("Chrome")>=0),n.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var S;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return a.INSTANCE}static true(){return w.INSTANCE}static has(F){return f.create(F)}static equals(F,z){return v.create(F,z)}static notEquals(F,z){return p.create(F,z)}static regex(F,z){return t.create(F,z)}static in(F,z){return _.create(F,z)}static not(F){return l.create(F)}static and(...F){return s.create(F,null)}static or(...F){return h.create(F,null,!0)}static greater(F,z){return g.create(F,z)}static greaterEquals(F,z){return o.create(F,z)}static smaller(F,z){return b.create(F,z)}static smallerEquals(F,z){return i.create(F,z)}static deserialize(F,z=!1){if(!!F)return this._deserializeOrExpression(F,z)}static _deserializeOrExpression(F,z){let M=F.split("||");return h.create(M.map(W=>this._deserializeAndExpression(W,z)),null,!0)}static _deserializeAndExpression(F,z){let M=F.split("&&");return s.create(M.map(W=>this._deserializeOne(W,z)),null)}static _deserializeOne(F,z){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return p.create(M[0].trim(),this._deserializeValue(M[1],z))}if(F.indexOf("==")>=0){let M=F.split("==");return v.create(M[0].trim(),this._deserializeValue(M[1],z))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],z))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return _.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return i.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return b.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?l.create(F.substr(1).trim()):f.create(F)}static _deserializeValue(F,z){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,z){if((0,L.isFalsyOrWhitespace)(F)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),W=F.lastIndexOf("/");if(M===W||M<0){if(z)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let U=F.slice(M+1,W),x=F[W+1]==="i"?"i":"";try{return new RegExp(U,x)}catch(B){if(z)throw new Error(`bad regexp-value '${F}', parse error: ${B}`);return console.warn(`bad regexp-value '${F}', parse error: ${B}`),null}}}e.ContextKeyExpr=y;function T(N,F){const z=N?N.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!z&&!M?!0:!z||!M?!1:z.equals(M)}e.expressionsAreEqualWithConstantSubstitution=T;function I(N,F){return N.cmp(F)}class a{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class w{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class f{constructor(F,z){this.key=F,this.negated=z,this.type=2}static create(F,z=null){const M=n.get(F);return typeof M=="boolean"?M?w.INSTANCE:a.INSTANCE:new f(F,z)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=n.get(this.key);return typeof F=="boolean"?F?w.INSTANCE:a.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class v{constructor(F,z,M){this.key=F,this.value=z,this.negated=M,this.type=4}static create(F,z,M=null){if(typeof z=="boolean")return z?f.create(F,M):l.create(F,M);const W=n.get(F);return typeof W=="boolean"?z===(W?"true":"false")?w.INSTANCE:a.INSTANCE:new v(F,z,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=n.get(this.key);if(typeof F=="boolean"){const z=F?"true":"false";return this.value===z?w.INSTANCE:a.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class _{constructor(F,z){this.key=F,this.valueKey=z,this.type=10,this.negated=null}static create(F,z){return new _(F,z)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const z=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray(z)?z.indexOf(M)>=0:typeof M=="string"&&typeof z=="object"&&z!==null?k.call(z,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this)),this.negated}}e.ContextKeyInExpr=_;class P{constructor(F){this._actual=F,this.type=11}static create(F){return new P(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new P(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class p{constructor(F,z,M){this.key=F,this.value=z,this.negated=M,this.type=5}static create(F,z,M=null){if(typeof z=="boolean")return z?l.create(F,M):f.create(F,M);const W=n.get(F);return typeof W=="boolean"?z===(W?"true":"false")?a.INSTANCE:w.INSTANCE:new p(F,z,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=n.get(this.key);if(typeof F=="boolean"){const z=F?"true":"false";return this.value===z?a.INSTANCE:w.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class l{constructor(F,z){this.key=F,this.negated=z,this.type=3}static create(F,z=null){const M=n.get(F);return typeof M=="boolean"?M?a.INSTANCE:w.INSTANCE:new l(F,z)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=n.get(this.key);return typeof F=="boolean"?F?a.INSTANCE:w.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=l;function r(N,F){if(typeof N=="string"){const z=parseFloat(N);isNaN(z)||(N=z)}return typeof N=="string"||typeof N=="number"?F(N):a.INSTANCE}class g{constructor(F,z,M){this.key=F,this.value=z,this.negated=M,this.type=12}static create(F,z,M=null){return r(z,W=>new g(F,W,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class o{constructor(F,z,M){this.key=F,this.value=z,this.negated=M,this.type=13}static create(F,z,M=null){return r(z,W=>new o(F,W,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class b{constructor(F,z,M){this.key=F,this.value=z,this.negated=M,this.type=14}static create(F,z,M=null){return r(z,W=>new b(F,W,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=b;class i{constructor(F,z,M){this.key=F,this.value=z,this.negated=M,this.type=15}static create(F,z,M=null){return r(z,W=>new i(F,W,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(F,z){this.key=F,this.regexp=z,this.type=7,this.negated=null}static create(F,z){return new t(F,z)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const z=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return z<M?-1:z>M?1:0}equals(F){if(F.type===this.type){const z=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&z===M}return!1}substituteConstants(){return this}evaluate(F){let z=F.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=c.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class c{constructor(F){this._actual=F,this.type=8}static create(F){return new c(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new c(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=c;function d(N){let F=null;for(let z=0,M=N.length;z<M;z++){const W=N[z].substituteConstants();if(N[z]!==W&&F===null){F=[];for(let U=0;U<z;U++)F[U]=N[U]}F!==null&&(F[z]=W)}return F===null?N:F}class s{constructor(F,z){this.expr=F,this.negated=z,this.type=6}static create(F,z){return s._normalizeArr(F,z)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let z=0,M=this.expr.length;z<M;z++){const W=I(this.expr[z],F.expr[z]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].equals(F.expr[z]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:s.create(F,this.negated)}evaluate(F){for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].evaluate(F))return!1;return!0}static _normalizeArr(F,z){const M=[];let W=!1;for(const U of F)if(!!U){if(U.type===1){W=!0;continue}if(U.type===0)return a.INSTANCE;if(U.type===6){M.push(...U.expr);continue}M.push(U)}if(M.length===0&&W)return w.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let U=1;U<M.length;U++)M[U-1].equals(M[U])&&(M.splice(U,1),U--);if(M.length===1)return M[0];for(;M.length>1;){const U=M[M.length-1];if(U.type!==9)break;M.pop();const x=M.pop(),B=M.length===0,O=h.create(U.expr.map(H=>s.create([H,x],null)),null,B);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new s(M,z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let z of this.expr)F.push(...z.keys());return F}map(F){return new s(this.expr.map(z=>z.map(F)),null)}negate(){if(!this.negated){const F=[];for(let z of this.expr)F.push(z.negate());this.negated=h.create(F,this,!0)}return this.negated}}class h{constructor(F,z){this.expr=F,this.negated=z,this.type=9}static create(F,z,M){return h._normalizeArr(F,z,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let z=0,M=this.expr.length;z<M;z++){const W=I(this.expr[z],F.expr[z]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].equals(F.expr[z]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:h.create(F,this.negated,!1)}evaluate(F){for(let z=0,M=this.expr.length;z<M;z++)if(this.expr[z].evaluate(F))return!0;return!1}static _normalizeArr(F,z,M){let W=[],U=!1;if(F){for(let x=0,B=F.length;x<B;x++){const O=F[x];if(!!O){if(O.type===0){U=!0;continue}if(O.type===1)return w.INSTANCE;if(O.type===9){W=W.concat(O.expr);continue}W.push(O)}}if(W.length===0&&U)return a.INSTANCE;W.sort(I)}if(W.length!==0){if(W.length===1)return W[0];for(let x=1;x<W.length;x++)W[x-1].equals(W[x])&&(W.splice(x,1),x--);if(W.length===1)return W[0];if(M){for(let x=0;x<W.length;x++)for(let B=x+1;B<W.length;B++)R(W[x],W[B])&&(W.splice(B,1),B--);if(W.length===1)return W[0]}return new h(W,z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let z of this.expr)F.push(...z.keys());return F}map(F){return new h(this.expr.map(z=>z.map(F)),null)}negate(){if(!this.negated){let F=[];for(let z of this.expr)F.push(z.negate());for(;F.length>1;){const z=F.shift(),M=F.shift(),W=[];for(const x of $(z))for(const B of $(M))W.push(s.create([x,B],null));const U=F.length===0;F.unshift(h.create(W,null,U))}this.negated=F[0]}return this.negated}}class u extends f{constructor(F,z,M){super(F,null);this._defaultValue=z,typeof M=="object"?u._info.push({...M,key:F}):M!==!0&&u._info.push({key:F,description:M,type:z!=null?typeof z:void 0})}static all(){return u._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return p.create(this.key,F)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(N,F){return N<F?-1:N>F?1:0}function A(N,F,z,M){return N<z?-1:N>z?1:F<M?-1:F>M?1:0}function R(N,F){if(F.type===6&&N.type!==9&&N.type!==6){for(const W of F.expr)if(N.equals(W))return!0}const z=N.negate(),M=$(z).concat($(F));M.sort(I);for(let W=0;W<M.length;W++){const x=M[W].negate();for(let B=W+1;B<M.length;B++){const O=M[B];if(x.equals(O))return!0}}return!1}e.implies=R;function $(N){return N.type===9?N.expr:[N]}}),define(me[182],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(me[183],ge([0,1,10,156,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function n(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function k(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function S(l,r){switch(l){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function y(l,r){return r==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function T(l,r,g){return y(r,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g?!0:I(g).includes(l)}e.isTargetPlatformCompatible=T;function I(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function a(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=a;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var f;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var _;(function(l){l[l.None=0]="None",l[l.Install=1]="Install",l[l.Update=2]="Update"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var P;(function(l){l.Unsupported="Unsupported",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(r,g){super(r);this.code=g,this.name=g}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(me[184],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(me[185],ge([0,1,37,10,9,11,95,28,113,158,184]),function(Y,e,m,L,D,C,n,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=y.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends a{openTerminal(r,g){return this.spawnTerminal(m,r,S.getWindowsShell(),g)}spawnTerminal(r,g,o,b){const i=g.windowsExec||w.getDefaultTerminalWindows();b&&b[1]===":"&&(b=b[0].toUpperCase()+b.substr(1));const t=D.basename(i).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(i,b?[b]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return i.indexOf(" ")>=0&&c.push('""'),c.push(i),(t==="wt"||t==="wt.exe")&&c.push("-d ."),new Promise((d,s)=>{const h=_(process),u=r.spawn(o,c,{cwd:b,env:h});u.on("error",s),u.on("exit",()=>d())})}runInTerminal(r,g,o,b,i){const t="windowsExec"in i&&i.windowsExec?i.windowsExec:w.getDefaultTerminalWindows();return new Promise((c,d)=>{const s=`"${g} - ${I}"`,h=`""${o.join('" "')}" & pause"`,u=["/c","start",s,"/wait",t,"/c",h],E=Object.assign({},_(process),b);Object.keys(E).filter($=>E[$]===null).forEach($=>delete E[$]);const A={cwd:g,env:E,windowsVerbatimArguments:!0};m.spawn(w.CMD,u,A).on("error",$=>{d(P($))}),c(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class f extends a{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,o,b,i){const t=i.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((c,d)=>{if(t===T.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const s=t===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`,Y).fsPath,"-t",r||I,"-w",g];for(let R of o)u.push("-a"),u.push(R);if(b){const R=Object.assign({},_(process),b);for(let $ in R){const N=R[$];N===null?(u.push("-u"),u.push($)):(u.push("-e"),u.push(`${$}=${N}`))}}let E="";const A=m.spawn(f.OSASCRIPT,u);A.on("error",R=>{d(P(R))}),A.stderr.on("data",R=>{E+=R.toString()}),A.on("exit",R=>{if(R===0)c(void 0);else if(E){const $=E.split(`
`,1);d(new Error($[0]))}else d(new Error(y.localize(1,null,s,R)))})}else d(new Error(y.localize(2,null,t)))})}spawnTerminal(r,g,o){const b=g.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((i,t)=>{const c=["-a",b];o&&c.push(o);const d=_(process),s=r.spawn("/usr/bin/open",c,{cwd:o,env:d});s.on("error",t),s.on("exit",()=>i())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class v extends a{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,o,b,i){const t=i.linuxExec?Promise.resolve(i.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((c,d)=>{let s=[];t.then(h=>{h.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const u=`${p(o)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;s.push(`''${u}''`);const E=Object.assign({},_(process),b);Object.keys(E).filter(N=>E[N]===null).forEach(N=>delete E[N]);const A={cwd:g,env:E};let R="";const $=m.spawn(h,s,A);$.on("error",N=>{d(P(N))}),$.stderr.on("data",N=>{R+=N.toString()}),$.on("exit",N=>{if(N===0)c(void 0);else if(R){const F=R.split(`
`,1);d(new Error(F[0]))}else d(new Error(y.localize(4,null,h,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{r?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,g,o){const b=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((i,t)=>{b.then(c=>{const d=_(process),s=r.spawn(c,[],{cwd:o,env:d});s.on("error",t),s.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=y.localize(3,null);function _(l){const r={...l.env};return(0,n.sanitizeProcessEnvironment)(r),r}function P(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(y.localize(5,null,l.path)):l}function p(l){let r="";for(let g of l)g.indexOf(" ")>=0?r+='"'+g+'"':r+=g,r+=" ";return r}}),define(me[42],ge([0,1,24,9,8,13,2,159,4]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function y(M){return M.create===!0}e.isFileOpenForWriteOptions=y;var T;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var a;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=w;function f(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=f;function v(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=_;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(W,U){super(W);this.code=U}}e.FileSystemProviderError=p;function l(M,W){const U=new p(M.toString(),W);return g(U,W),U}e.createFileSystemProviderError=l;function r(M){return M||l((0,k.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=r;function g(M,W){return M.name=W?`${W} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=g;function o(M){if(!M)return P.Unknown;if(M instanceof p)return M.code;const W=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!W)return P.Unknown;switch(W[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=o;function b(M){if(M instanceof h)return M.fileOperationResult;switch(o(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=b;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(W,U,x){this.resource=W,this.operation=U,this.target=x}isOperation(W){return this.operation===W}}e.FileOperationEvent=t;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class d{constructor(W,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const x=new Map;for(const B of W){const O=x.get(B.type);O?O.push([B.resource,B]):x.set(B.type,[[B.resource,B]])}for(const[B,O]of x)switch(B){case 1:this.added=m.TernarySearchTree.forUris(()=>U),this.added.fill(O);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>U),this.updated.fill(O);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>U),this.deleted.fill(O);break}}contains(W,...U){return this.doContains(W,{includeChildren:!1},...U)}affects(W,...U){return this.doContains(W,{includeChildren:!0},...U)}doContains(W,U,...x){if(!W)return!1;const B=x.length>0;return!!((!B||x.includes(1))&&(this.added?.get(W)||U.includeChildren&&this.added?.findSuperstr(W))||(!B||x.includes(0))&&(this.updated?.get(W)||U.includeChildren&&this.updated?.findSuperstr(W))||(!B||x.includes(2))&&(this.deleted?.findSubstr(W)||U.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function s(M,W,U){return!M||!W||M===W||W.length>M.length?!1:(W.charAt(W.length-1)!==L.sep&&(W+=L.sep),U?(0,D.startsWithIgnoreCase)(M,W):M.indexOf(W)===0)}e.isParent=s;class h extends Error{constructor(W,U,x){super(W);this.fileOperationResult=U,this.options=x}}e.FileOperationError=h;class u extends h{constructor(W,U,x){super(W,2,x);this.stat=U}}e.NotModifiedSinceFileOperationError=u;var E;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function $(M,W){if(!W.hasProvider(n.URI.from({scheme:M.scheme})))return new Promise(U=>{const x=W.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===M.scheme&&B.added&&(x.dispose(),U())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(W){return(0,C.isNumber)(W)||(W=0),W<N.KB?(0,k.localize)(1,null,W.toFixed(0)):W<N.MB?(0,k.localize)(2,null,(W/N.KB).toFixed(2)):W<N.GB?(0,k.localize)(3,null,(W/N.MB).toFixed(2)):W<N.TB?(0,k.localize)(4,null,(W/N.GB).toFixed(2)):(0,k.localize)(5,null,(W/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function z(M){return{maxFileSize:M===0?300*N.MB:16*N.GB,maxHeapSize:M===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=z}),define(me[85],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...D){this._entries=new Map;for(let[C,n]of D)this.set(C,n)}set(D,C){const n=this._entries.get(D);return this._entries.set(D,C),n}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=m}),define(me[186],ge([0,1,18,15,115,179,4,85]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class y extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class T{constructor(f=new k.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=f,this._strict=v,this._parent=_,this._services.set(n.IInstantiationService,this)}createChild(f){return new T(f,this._strict,this)}invokeFunction(f,...v){let _=a.traceInvocation(f),P=!1;try{return f({get:l=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(l,_);if(!r)throw new Error(`[invokeFunction] unknown service '${l}'`);return r}},...v)}finally{P=!0,_.stop()}}createInstance(f,...v){let _,P;return f instanceof D.SyncDescriptor?(_=a.traceCreation(f.ctor),P=this._createInstance(f.ctor,f.staticArguments.concat(v),_)):(_=a.traceCreation(f),P=this._createInstance(f,v,_)),_.stop(),P}_createInstance(f,v=[],_){let P=n._util.getServiceDependencies(f).sort((r,g)=>r.index-g.index),p=[];for(const r of P){let g=this._getOrCreateServiceInstance(r.id,_);if(!g&&this._strict&&!r.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${r.id}.`);p.push(g)}let l=P.length>0?P[0].index:v.length;if(v.length!==l){console.warn(`[createInstance] First service dependency of ${f.name} at position ${l+1} conflicts with ${v.length} static arguments`);let r=l-v.length;r>0?v=v.concat(new Array(r)):v=v.slice(0,l)}return new f(...[...v,...p])}_setServiceInstance(f,v){if(this._services.get(f)instanceof D.SyncDescriptor)this._services.set(f,v);else if(this._parent)this._parent._setServiceInstance(f,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let v=this._services.get(f);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):v}_getOrCreateServiceInstance(f,v){let _=this._getServiceInstanceOrDescriptor(f);return _ instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,_,v.branch(f,!0)):(v.branch(f,!1),_)}_safeCreateAndCacheServiceInstance(f,v,_){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,v,_)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,v,_){const P=new C.Graph(r=>r.id.toString());let p=0;const l=[{id:f,desc:v,_trace:_}];for(;l.length;){const r=l.pop();if(P.lookupOrInsertNode(r),p++>1e3)throw new y(P);for(let g of n._util.getServiceDependencies(r.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(g.id);if(!o&&!g.optional&&console.warn(`[createInstance] ${f} depends on ${g.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const b={id:g.id,desc:o,_trace:r._trace.branch(g.id,!0)};P.insertEdge(r,b),l.push(b)}}}for(;;){const r=P.roots();if(r.length===0){if(!P.isEmpty())throw new y(P);break}for(const{data:g}of r){if(this._getServiceInstanceOrDescriptor(g.id)instanceof D.SyncDescriptor){const b=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,b)}P.removeNode(g)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,v,_=[],P,p){if(this._services.get(f)instanceof D.SyncDescriptor)return this._createServiceInstance(v,_,P,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,v,_,P,p);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(f,v=[],_,P){if(_){const p=new m.IdleValue(()=>this._createInstance(f,v,P));return new Proxy(Object.create(null),{get(l,r){if(r in l)return l[r];let g=p.value,o=g[r];return typeof o!="function"||(o=o.bind(g),l[r]=o),o},set(l,r,g){return p.value[r]=g,!0}})}else return this._createInstance(f,v,P)}}e.InstantiationService=T;var I;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(I||(I={}));class a{constructor(f,v){this.type=f,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return S?new a(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(f){return S?new a(0,f.name):a._None}branch(f,v){let _=new a(2,f.toString());return this._dep.push([f,v,_]),_}stop(){let f=Date.now()-this._start;a._totals+=f;let v=!1;function _(p,l){let r=[],g=new Array(p+1).join("	");for(const[o,b,i]of l._dep)if(b&&i){v=!0,r.push(`${g}CREATES -> ${o}`);let t=_(p+1,i);t&&r.push(t)}else r.push(`${g}uses -> ${o}`);return r.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(f>2||v)&&console.log(P.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(me[12],ge([0,1,51,3,6,11,4]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function y(b,i,t){switch(i){case S.Trace:b.trace(t);break;case S.Debug:b.debug(t);break;case S.Info:b.info(t);break;case S.Warning:b.warn(t);break;case S.Error:b.error(t);break;case S.Critical:b.critical(t);break;default:throw new Error("Invalid log level")}}e.log=y;function T(b){let i="";for(let t=0;t<b.length;t++){let c=b[t];if(typeof c=="object")try{c=JSON.stringify(c)}catch(d){}i+=(t>0?" ":"")+c}return i}e.format=T;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class a extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,T([i,...t]))}debug(i,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,T([i,...t]))}info(i,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,T([i,...t]))}warn(i,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,T([i,...t]))}error(i,...t){if(this.checkLogLevel(S.Error))if(i instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=i.stack,this.log(S.Error,T(c))}else this.log(S.Error,T([i,...t]))}critical(i,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,T([i,...t]))}flush(){}}e.AbstractMessageLogger=a;class w extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}debug(i,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}info(i,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}warn(i,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...t):console.warn(`[main ${k()}]`,i,...t))}error(i,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...t):console.error(`[main ${k()}]`,i,...t))}critical(i,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...t):console.error(`[main ${k()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class f extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class v extends I{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,m.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class _ extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const c of this.logServices)c.trace(i,...t)}debug(i,...t){for(const c of this.logServices)c.debug(i,...t)}info(i,...t){for(const c of this.logServices)c.info(i,...t)}warn(i,...t){for(const c of this.logServices)c.warn(i,...t)}error(i,...t){for(const c of this.logServices)c.error(i,...t)}critical(i,...t){for(const c of this.logServices)c.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=_;class P extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=P;class p extends D.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(c))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let c=this.loggers.get(i.toString());return c||(c=this.doCreateLogger(i,t?.always?S.Trace:this.logLevel,t),this.loggers.set(i.toString(),c),t?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class l{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=l;function r(b){if(b.verbose)return S.Trace;if(typeof b.logLevel=="string"){const i=g(b.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function g(b){switch(b){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=g;function o(b){switch(b){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(me[187],ge([0,1,42,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(k,S,y,T,I){try{const a=await new Promise((f,v)=>{Y(["spdlog"],f,v)});a.setFlushOn(L.LogLevel.Trace);const w=await a.createAsyncRotatingLogger(k,S,y,T);return I&&w.clearFormatters(),w}catch(a){console.error(a)}return null}function C(k,S,y){switch(S){case L.LogLevel.Trace:k.trace(y);break;case L.LogLevel.Debug:k.debug(y);break;case L.LogLevel.Info:k.info(y);break;case L.LogLevel.Warning:k.warn(y);break;case L.LogLevel.Error:k.error(y);break;case L.LogLevel.Critical:k.critical(y);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(S,y,T,I,a){super();this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(S,y,T,I),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(S,y,T,I){const a=T?6:1,w=30/a*m.ByteSize.MB,f=await D(S,y,w,a,I);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:v,message:_}of this.buffer)C(this._logger,v,_);this.buffer=[]}}log(S,y){this._logger?C(this._logger,S,y):this.getLevel()<=S&&this.buffer.push({level:S,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(me[116],ge([0,1,49,160,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var n;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(n=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function y(f,v){return v-f}S.compare=y;const T=Object.create(null);T[S.Error]=(0,L.localize)(0,null),T[S.Warning]=(0,L.localize)(1,null),T[S.Info]=(0,L.localize)(2,null);function I(f){return T[f]||""}S.toString=I;function a(f){switch(f){case m.default.Error:return S.Error;case m.default.Warning:return S.Warning;case m.default.Info:return S.Info;case m.default.Ignore:return S.Hint}}S.fromSeverity=a;function w(f){switch(f){case S.Error:return m.default.Error;case S.Warning:return m.default.Warning;case S.Info:return m.default.Info;case S.Hint:return m.default.Ignore}}S.toSeverity=w}(n=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const y="";function T(a){return I(a,!0)}S.makeKey=T;function I(a,w){let f=[y];return a.source?f.push(a.source.replace("\xA6","\\\xA6")):f.push(y),a.code?typeof a.code=="string"?f.push(a.code.replace("\xA6","\\\xA6")):f.push(a.code.value.replace("\xA6","\\\xA6")):f.push(y),a.severity!==void 0&&a.severity!==null?f.push(n.toString(a.severity)):f.push(y),a.message&&w?f.push(a.message.replace("\xA6","\\\xA6")):f.push(y),a.startLineNumber!==void 0&&a.startLineNumber!==null?f.push(a.startLineNumber.toString()):f.push(y),a.startColumn!==void 0&&a.startColumn!==null?f.push(a.startColumn.toString()):f.push(y),a.endLineNumber!==void 0&&a.endLineNumber!==null?f.push(a.endLineNumber.toString()):f.push(y),a.endColumn!==void 0&&a.endColumn!==null?f.push(a.endColumn.toString()):f.push(y),f.push(y),f.join("\xA6")}S.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(me[188],ge([0,1,3,49,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,D.createDecorator)("notificationService");var C;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var n;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(n=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=S}),define(me[189],ge([0,1,6,8,2,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function n(S,y){return D.URI.isUri(S)?(0,L.equalsIgnoreCase)(S.scheme,y):(0,L.startsWithIgnoreCase)(S,y+":")}e.matchesScheme=n;function k(S,...y){return y.some(T=>n(S,T))}e.matchesSomeScheme=k}),define(me[190],ge([0,1,10,11,40,23]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)n=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Y));n=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const S=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:S.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n});var We=this&&this.__param||function(Y,e){return function(m,L){e(m,L,Y)}};define(me[117],ge([0,1,18,21,6,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var n;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(n=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends D.Disposable{constructor(I,a){super();this.deferred=new m.DeferredPromise,a.withProgress(I,w=>(this.reporter=w,this.lastStep&&w.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=Ve([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class y extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const a=++this.currentOperationId,w=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>w.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:w.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=y,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[43],ge([0,1,56,13]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(n,k){m.ok(L.isString(n)),m.ok(L.isObject(k)),m.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,k)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new D}),define(me[191],ge([0,1,3,43]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,y){this.schemasById[D(S)]=y,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new C;L.Registry.add(e.Extensions.JSONContribution,n)}),define(me[86],ge([0,1,17,3,13,155,191,43]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=k.Registry.as(n.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,o=!0){this.registerConfigurations([g],o)}registerConfigurations(g,o=!0){const b=this.doRegisterConfigurations(g,o);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterConfigurations(g){const o=this.doDeregisterConfigurations(g);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:g,remove:o}){const b=[];b.push(...this.doDeregisterConfigurations(o)),b.push(...this.doRegisterConfigurations(g,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,m.distinct)(b))}registerDefaultConfigurations(g){const o=[],b=[];for(const i of g)for(const t in i)if(o.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...i[t]};const c={type:"object",default:this.defaultValues[t],description:C.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};b.push(...f(t)),this.configurationProperties[t]=c,this.defaultLanguageConfigurationOverridesNode.properties[t]=c}else{this.defaultValues[t]=i[t];const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(b),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(g){const o=[];for(const b of g)for(const i in b)if(o.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const t=this.configurationProperties[i];t&&(this.updatePropertyDefaultValue(i,t),this.updateSchema(i,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const o of g)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,o){const b=[];return g.forEach(i=>{b.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),b}doDeregisterConfigurations(g){const o=[],b=i=>{if(i.properties)for(const t in i.properties)o.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>b(t))};for(const i of g){b(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return o}validateAndRegisterProperties(g,o=!0,b,i=3){i=D.isUndefinedOrNull(g.scope)?i:g.scope;let t=[],c=g.properties;if(c)for(let s in c){if(o&&p(s)){delete c[s];continue}const h=c[s];if(this.updatePropertyDefaultValue(s,h),e.OVERRIDE_PROPERTY_REGEX.test(s)?h.scope=void 0:(h.scope=D.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=D.isUndefinedOrNull(h.restricted)?!!b?.restrictedConfigurations?.includes(s):h.restricted),c[s].hasOwnProperty("included")&&!c[s].included){this.excludedConfigurationProperties[s]=c[s],delete c[s];continue}else this.configurationProperties[s]=c[s];!c[s].deprecationMessage&&c[s].markdownDeprecationMessage&&(c[s].deprecationMessage=c[s].markdownDeprecationMessage),t.push(s)}let d=g.allOf;if(d)for(let s of d)t.push(...this.validateAndRegisterProperties(s,o,b,i));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const o=b=>{let i=b.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);let t=b.allOf;t&&t.forEach(o)};o(g)}updateSchema(g,o){switch(e.allSettings.properties[g]=o,o.scope){case 1:e.applicationSettings.properties[g]=o;break;case 2:e.machineSettings.properties[g]=o;break;case 6:e.machineOverridableSettings.properties[g]=o;break;case 3:e.windowSettings.properties[g]=o;break;case 4:e.resourceSettings.properties[g]=o;break;case 5:e.resourceSettings.properties[g]=o,this.resourceLanguageSettingsSchema.properties[g]=o;break}}removeFromSchema(g,o){switch(delete e.allSettings.properties[g],o.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const o=`[${g}]`,b={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,b),e.allSettings.properties[o]=b,e.applicationSettings.properties[o]=b,e.machineSettings.properties[o]=b,e.machineOverridableSettings.properties[o]=b,e.windowSettings.properties[o]=b,e.resourceSettings.properties[o]=b}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,o){let b=this.defaultValues[g];D.isUndefined(b)&&(b=o.default),D.isUndefined(b)&&(b=_(o.type)),o.default=b}}const a="\\[([^\\]]+)\\]",w=new RegExp(a,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${a})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(r){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let o=w.exec(r);for(;o?.length;){const b=o[1].trim();b&&g.push(b),o=w.exec(r)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=f;function v(r){return r.reduce((g,o)=>`${g}[${o}]`,"")}e.keyFromOverrideIdentifiers=v;function _(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const P=new I;k.Registry.add(e.Extensions.Configuration,P);function p(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?C.localize(7,null,r):P.getConfigurationProperties()[r]!==void 0?C.localize(8,null,r):null:C.localize(6,null)}e.validateProperty=p;function l(){const r=[],g=P.getConfigurationProperties();for(const o of Object.keys(g))r.push([o,g[o].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=l}),define(me[118],ge([0,1,13,2,86,4,43]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function k(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=k;function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||m.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=S;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function I(r,g){const o=Object.create(null);for(let b in r)a(o,b,r[b],g);return o}e.toValuesTree=I;function a(r,g,o,b){const i=g.split("."),t=i.pop();let c=r;for(let d=0;d<i.length;d++){let s=i[d],h=c[s];switch(typeof h){case"undefined":h=c[s]=Object.create(null);break;case"object":break;default:b(`Ignoring ${g} as ${i.slice(0,d+1).join(".")} is ${JSON.stringify(h)}`);return}c=h}if(typeof c=="object"&&c!==null)try{c[t]=o}catch(d){b(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(c)}`)}else b(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=a;function w(r,g){const o=g.split(".");f(r,o)}e.removeFromValueTree=w;function f(r,g){const o=g.shift();if(g.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const b=r[o];typeof b=="object"&&!Array.isArray(b)&&(f(b,g),Object.keys(b).length===0&&delete r[o])}}function v(r,g,o){function b(c,d){let s=c;for(const h of d){if(typeof s!="object"||s===null)return;s=s[h]}return s}const i=g.split("."),t=b(r,i);return typeof t=="undefined"?o:t}e.getConfigurationValue=v;function _(r,g,o){Object.keys(g).forEach(b=>{b!=="__proto__"&&(b in r?m.isObject(r[b])&&m.isObject(g[b])?_(r[b],g[b],o):o&&(r[b]=g[b]):r[b]=g[b])})}e.merge=_;function P(){const r=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=P;function p(){const r=Object.create(null),g=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let o in g){let b=g[o].default;a(r,o,b,i=>console.error(`Conflict in default settings: ${i}`))}return r}e.getDefaultValues=p;function l(r,g,o){const b=r.inspect(g),i=r.inspect(o);return typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:b.defaultValue}e.getMigratedSettingValue=l}),define(me[192],ge([0,1,17,3,58,6,24,25,13,2,118,86,43]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(i={},t=[],c=[]){this._contents=i,this._keys=t,this._overrides=c,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,T.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const c=this.getContentsForOverrideIdentifer(t);return c?i?(0,T.getConfigurationValue)(c,i):c:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const c of this.overrides)c.identifiers.includes(i)&&t.push(...c.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return m.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=k.deepClone(this.contents),c=k.deepClone(this.overrides),d=[...this.keys];for(const s of i){this.mergeContents(t,s.contents);for(const h of s.overrides){const[u]=c.filter(E=>m.equals(E.identifiers,h.identifiers));u?(this.mergeContents(u.contents,h.contents),u.keys.push(...h.keys),u.keys=m.distinct(u.keys)):c.push(k.deepClone(h))}for(const h of s.keys)d.indexOf(h)===-1&&d.push(h)}return new w(t,d,c)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let c={};for(const d of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let s=this.contents[d],h=t[d];h&&(typeof s=="object"&&typeof h=="object"?(s=k.deepClone(s),this.mergeContents(s,h)):s=h),c[d]=s}return new w(c,this.keys,this.overrides)}mergeContents(i,t){for(const c of Object.keys(t)){if(c in i&&S.isObject(i[c])&&S.isObject(t[c])){this.mergeContents(i[c],t[c]);continue}i[c]=k.deepClone(t[c])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,c=null;const d=s=>{s&&(c?this.mergeContents(c,s):c=k.deepClone(s))};for(const s of this.overrides)m.equals(s.identifiers,[i])?t=s.contents:s.identifiers.includes(i)&&d(s.contents);return d(t),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,T.addToValueTree)(this.contents,i,t,c=>{throw new Error(c)})}removeValue(i){this.removeKey(i)&&(0,T.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let c=0;c<t;c++)i.indexOf(this.keys[c])===0&&(t=c);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=w;class f extends w{constructor(){const i=(0,T.getDefaultValues)(),t=(0,T.getConfigurationKeys)(),c=[];for(const d of Object.keys(i))I.OVERRIDE_PROPERTY_REGEX.test(d)&&c.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(i[d]),contents:(0,T.toValuesTree)(i[d],s=>console.error(`Conflict in default settings file: ${s}`))});super(i,t,c)}}e.DefaultConfigurationModel=f;class v{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!S.isUndefinedOrNull(i)){const c=this.doParseContent(i);this.parseRaw(c,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:c,keys:d,overrides:s,restricted:h}=this.doParseRaw(i,t);this._configurationModel=new w(c,d,s),this._restrictedConfigurations=h||[]}doParseContent(i){let t={},c=null,d=[],s=[],h=[];function u(A){Array.isArray(d)?d.push(A):c!==null&&(d[c]=A)}let E={onObjectBegin:()=>{let A={};u(A),s.push(d),d=A,c=null},onObjectProperty:A=>{c=A},onObjectEnd:()=>{d=s.pop()},onArrayBegin:()=>{let A=[];u(A),s.push(d),d=A,c=null},onArrayEnd:()=>{d=s.pop()},onLiteralValue:u,onError:(A,R,$)=>{h.push({error:A,offset:R,length:$})}};if(i)try{D.visit(i,E),t=d[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(i,t){const c=a.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(i,c,!0,t);i=d.raw;const s=(0,T.toValuesTree)(i,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),h=Object.keys(i),u=this.toOverrides(i,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:s,keys:h,overrides:u,restricted:d.restricted}}filter(i,t,c,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:i,restricted:[]};const s={},h=[];for(let u in i)if(I.OVERRIDE_PROPERTY_REGEX.test(u)&&c){const E=this.filter(i[u],t,!1,d);s[u]=E.raw,h.push(...E.restricted)}else{const E=t[u],A=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&h.push(u),(A===void 0||d.scopes===void 0||d.scopes.includes(A))&&(d.skipRestricted&&E?.restricted||(s[u]=i[u]))}return{raw:s,restricted:h}}toOverrides(i,t){const c=[];for(const d of Object.keys(i))if(I.OVERRIDE_PROPERTY_REGEX.test(d)){const s={};for(const h in i[d])s[h]=i[d][h];c.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(s),contents:(0,T.toValuesTree)(s,t)})}return c}}e.ConfigurationModelParser=v;class _ extends C.Disposable{constructor(i,t,c,d){super();this.userSettingsResource=i,this.scopes=t,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class P{constructor(i,t,c=new w,d=new w,s=new n.ResourceMap,h=new w,u=new n.ResourceMap,E=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=c,this._workspaceConfiguration=d,this._folderConfigurations=s,this._memoryConfiguration=h,this._memoryConfigurationByResource=u,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(i,t,c){return this.getConsolidateConfigurationModel(t,c).getValue(i)}updateValue(i,t,c={}){let d;c.resource?(d=this._memoryConfigurationByResource.get(c.resource),d||(d=new w,this._memoryConfigurationByResource.set(c.resource,d))):d=this._memoryConfiguration,t===void 0?d.removeValue(i):d.setValue(i,t),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,c){const d=this.getConsolidateConfigurationModel(t,c),s=this.getFolderConfigurationModelForResource(t.resource,c),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,u=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),E=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),A=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),R=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),$=c?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,N=s?t.overrideIdentifier?s.freeze().override(t.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,F=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(i):h.getValue(i),z=d.getValue(i),M=m.distinct(m.flatten(d.overrides.map(W=>W.identifiers))).filter(W=>d.getOverrideValue(i,W)!==void 0);return{defaultValue:u,userValue:E,userLocalValue:A,userRemoteValue:R,workspaceValue:$,workspaceFolderValue:N,memoryValue:F,value:z,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:s?.freeze().getValue(i),override:t.overrideIdentifier?s?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:h.getValue(i),override:t.overrideIdentifier?h.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const c=[];for(const d of t)for(const s of(0,I.overrideIdentifiersFromKey)(d)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=i.getKeysForOverrideIdentifier(s),E=[...u.filter(A=>h.indexOf(A)===-1),...h.filter(A=>u.indexOf(A)===-1),...h.filter(A=>!k.equals(this._defaultConfiguration.override(s).getValue(A),i.override(s).getValue(A)))];c.push([s,E])}return this.updateDefaultConfiguration(i),{keys:t,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:c,removed:d,overrides:s}=g(this.localUserConfiguration,i),h=[...t,...c,...d];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:c,removed:d,overrides:s}=g(this.remoteUserConfiguration,i);let h=[...t,...c,...d];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:c,removed:d,overrides:s}=g(this.workspaceConfiguration,i);let h=[...t,...c,...d];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:s}}compareAndUpdateFolderConfiguration(i,t){const c=this.folderConfigurations.get(i),{added:d,updated:s,removed:h,overrides:u}=g(c,t);let E=[...d,...s,...h];return(E.length||!c)&&this.updateFolderConfiguration(i,t),{keys:E,overrides:u}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:c,updated:d,removed:s,overrides:h}=g(t,void 0);return{keys:[...c,...d,...s],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let c=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?c.override(i.overrideIdentifier):c}getConsolidatedConfigurationModelForResource({resource:i},t){let c=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const d=t.getFolder(i);d&&(c=this.getFolderConsolidatedConfiguration(d.uri)||c);const s=this._memoryConfigurationByResource.get(i);s&&(c=c.merge(s))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const c=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(i);d?(t=c.merge(d),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=c}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const c=t.getFolder(i);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:c,overrides:d,keys:s}=this._folderConfigurations.get(t);return i.push([t,{contents:c,overrides:d,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(c=>i.add(c))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(c=>i.add(c))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>t.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>t.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>t.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(i).forEach(d=>t.add(d))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),c=this.parseConfigurationModel(i.user),d=this.parseConfigurationModel(i.workspace),s=i.folders.reduce((h,u)=>(h.set(y.URI.revive(u[0]),this.parseConfigurationModel(u[1])),h),new n.ResourceMap);return new P(t,c,new w,d,s,new w,new n.ResourceMap,!1)}static parseConfigurationModel(i){return new w(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=P;function p(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const i=new Set,t=new Map;for(const d of b)d.keys.forEach(s=>i.add(s)),d.overrides.forEach(([s,h])=>{const u=(0,n.getOrSet)(t,s,new Set);h.forEach(E=>u.add(E))});const c=[];return t.forEach((d,s)=>c.push([s,[...d.values()]])),{keys:[...i.values()],overrides:c}}e.mergeChanges=p;class l{constructor(i,t,c,d){this.change=i,this.previous=t,this.currentConfiguraiton=c,this.currentWorkspace=d,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(u=>s.add(u)),i.overrides.forEach(([,u])=>u.forEach(E=>s.add(E))),this.affectedKeys=[...s.values()];const h=new w;this.affectedKeys.forEach(u=>h.setValue(u,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const c=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!k.equals(c,d)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let c=(0,T.toValuesTree)({[t]:!0},()=>{}),d;for(;typeof c=="object"&&(d=Object.keys(c)[0]);){if(i=i[d],!i)return!1;c=c[d]}return!0}}e.ConfigurationChangeEvent=l;class r extends l{constructor(i,t,c,d){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=c,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=r;function g(b,i){const{added:t,removed:c,updated:d}=o(i,b),s=[],h=b?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const E=u.filter(A=>!h.includes(A));for(const A of E)s.push([A,i.getKeysForOverrideIdentifier(A)])}if(b){const E=h.filter(A=>!u.includes(A));for(const A of E)s.push([A,b.getKeysForOverrideIdentifier(A)])}if(i&&b){for(const E of h)if(u.includes(E)){const A=o({contents:b.getOverrideValue(void 0,E)||{},keys:b.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});s.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:c,updated:d,overrides:s}}function o(b,i){const t=b?i?b.keys.filter(s=>i.keys.indexOf(s)===-1):[...b.keys]:[],c=i?b?i.keys.filter(s=>b.keys.indexOf(s)===-1):[...i.keys]:[],d=[];if(b&&i){for(const s of i.keys)if(b.keys.indexOf(s)!==-1){const h=(0,T.getConfigurationValue)(i.contents,s),u=(0,T.getConfigurationValue)(b.contents,s);k.equals(h,u)||d.push(s)}}return{added:t,removed:c,updated:d}}}),define(me[119],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(n,k=L.Unknown,S){super(n);this._message=n,this._code=k,this._detail=S,this.isHandled=k===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(n){return n instanceof D&&n._code===L.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof D&&n._code===L.NoResolverFound}static isHandled(n){return n instanceof D&&n.isHandled}}e.RemoteAuthorityResolverError=D}),define(me[62],ge([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===m.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function D(y){if(!y)return;const T=y.indexOf("+");return T<0?y:y.substr(0,T)}e.getRemoteName=D;function C(y){return y.scheme!==m.Schemas.file&&y.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function n(y){if(y.folders.length)return y.folders.every(T=>C(T.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=n;function k(y){return n(y)?.scheme}e.getVirtualWorkspaceScheme=k;function S(y){return n(y)!==void 0}e.isVirtualWorkspace=S}),define(me[27],ge([0,1,8,4,62]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.getWorkspaceSupportTypeMessage=C;function n(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,f){if(typeof w=="undefined"||w===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof w=="string"||typeof f=="string"){let v=typeof w=="string"?w:w.value,_=typeof f=="string"?f:f.value;return m.equalsIgnoreCase(v,_)}return w._lower===f._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=S;function y(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function T(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function I(a,w){if(w){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(w)}`;return a.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[193],ge([0,1,8,27]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(f,v){return f.uuid&&v.uuid?f.uuid===v.uuid:f.id===v.id?!0:(0,m.compareIgnoreCase)(f.id,v.id)===0}e.areSameExtensions=D;class C{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?D(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function n(f,v){return`${f}.${v}`}e.getExtensionId=n;function k(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(f,v){return k(n(f,v))}e.getGalleryExtensionId=S;function y(f,v){const _=[],P=p=>{for(const l of _)if(l.some(r=>D(v(r),v(p))))return l;return null};for(const p of f){const l=P(p);l?l.push(p):_.push([p])}return _}e.groupByExtension=y;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function I(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function a(f){const v=new Set;for(const _ of f)_.malicious&&v.add(_.id.id);return v}e.getMaliciousExtensionsSet=a;function w(f,v){const _=[],P=v.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const p=P.shift();if(p&&_.every(l=>!D(l.identifier,{id:p}))){const l=f.filter(r=>D(r.identifier,{id:p}));l.length===1&&(_.push(l[0]),P.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=w}),define(me[120],ge([0,1,3,11,4,12]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var n;(function(f){f.Http="http",f.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=I;function a(f,v){return v?v!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=a;let w=class{constructor(v){this.logService=v,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v,_){return this._tunnelProvider=v,v?(this._canElevate=_.elevation,this._privacyOptions=_.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],_=Array.from(this._tunnels.values());for(let P of _){const p=Array.from(P.values());for(let l of p){const r=await l.value;r&&v.push(r)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:_}of v.values())await _.then(P=>P?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,_,P,p,l=!1,r=k.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${_}:${P} on local port ${p}.`),!v)return;_||(_="localhost");const o=this.retainOrCreateTunnel(v,_,P,p,l,r,g);return o?o.then(b=>{if(!b){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(_,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(b);return(b.tunnelRemoteHost!==_||b.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const _=this._tunnels.get(v.tunnelRemoteHost);if(_){const P=_.get(v.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,P))}}}}async tryDisposeTunnel(v,_,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${_}.`);const p=P.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(_),p}}async closeTunnel(v,_){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${_} `);const P=this._tunnels.get(v);if(P&&P.has(_)){const p=P.get(_);p.refcount=0,await this.tryDisposeTunnel(v,_,p)}}addTunnelToMap(v,_,P){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(_,{refcount:1,value:P})}async removeEmptyTunnelFromMap(v,_){const P=this._tunnels.get(v);P&&(await P.get(_)||P.delete(_),P.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,_){let P=[v];T(v)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):I(v)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const p=P.map(l=>this._tunnels.get(l));for(const l of p){const r=l?.get(_);if(r)return r}}canTunnel(v){return!!y(v)}createWithProvider(v,_,P,p,l,r,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${_}:${P} on local port ${p}.`);const b={elevationRequired:l?a(p===void 0?P:p):!1},i={remoteAddress:{host:_,port:P},localAddressPort:p,privacy:r,public:r!==k.Private,protocol:g},t=v.forwardPort(i,b);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(_,P,t),t}};w=Ve([We(0,C.ILogService)],w),e.AbstractTunnelService=w}),define(me[194],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>Y(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),n=new C.validator;if(n){const k=String(m._nextId++);return this.validators.set(k,n),{id:k,data:n.createNewMessage(D)}}}catch(C){}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const n=this.validators.get(D.id);if(!n)return!1;this.validators.delete(D.id);try{return n.validate(C)==="ok"}catch(k){return!1}}async sign(D){try{const C=await this.vsda(),n=new C.signer;if(n)return n.sign(D)}catch(C){}return D}}e.SignService=m,m._nextId=1}),define(me[195],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,C,n=5){let k;return k=C(S=>{const y=typeof S=="string"?S:S.data;let T=this._terminalBufferMap.get(D);if(T){T.data.push(y);return}const I=setTimeout(()=>this.flushBuffer(D),n);T={data:[y],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),k.dispose()}},this._terminalBufferMap.set(D,T)}),k}stopBuffering(D){const C=this._terminalBufferMap.get(D);C&&C.dispose()}flushBuffer(D){const C=this._terminalBufferMap.get(D);C&&(this._terminalBufferMap.delete(D),this._callback(D,C.data.join("")))}}e.TerminalDataBufferer=m}),define(me[196],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(me[87],ge([0,1,78,3,6,4,43,196]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(_){function P(p){return p&&typeof p=="object"&&typeof p.id=="string"}_.isThemeColor=P})(S=e.ThemeColor||(e.ThemeColor={}));function y(_){return{id:_}}e.themeColorFromId=y;var T;(function(_){function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||S.isThemeColor(i.color))}_.isThemeIcon=P;const p=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const t=p.exec(i);if(!t)return;let[,c]=t;return{id:c}}_.fromString=l;function r(i,t){let c=i.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),t&&(c=`${c}~${t}`),{id:c}}_.modify=r;function g(i){const t=i.id.lastIndexOf("~");if(t!==-1)return i.id.substring(t+1)}_.getModifier=g;function o(i,t){return i.id===t.id&&i.color?.id===t.color?.id}_.isEqual=o;function b(i,t){return{id:i.id,color:t?y(t):void 0}}_.asThemeIcon=b,_.asClassNameArray=m.CSSIcon.asClassNameArray,_.asClassName=m.CSSIcon.asClassName,_.asCSSSelector=m.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function I(_){switch(_){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,D.toDisposable)(()=>{const p=this.themingParticipants.indexOf(P);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new a;n.Registry.add(e.Extensions.ThemingContribution,w);function f(_){return w.onColorThemeChange(_)}e.registerThemingParticipant=f;class v extends D.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,p){let l=this.theme.getColor(P);return l&&p&&(l=p(l,this.theme)),l?l.toString():null}}e.Themable=v}),define(me[44],ge([0,1,24,23,2,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var n;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function k(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=k;function S(a){const w=a;return!!(w&&typeof w=="object"&&D.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=S;class y{constructor(w,f,v,_,P){this._id=w,this._transient=v,this._configuration=_,this._ignorePathCasing=P,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(w){this._id=w.id,this._configuration=w.configuration,this._transient=w.transient,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class T{constructor(w,f){this.raw=f,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,L.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function I(a){return new T({uri:a,index:0,name:(0,L.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=I}),define(me[197],ge([0,1,30,58,139,80,10,9,11,23,2,161,4,62,44]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(M){return(typeof M=="string"?(0,k.extname)(M):(0,y.extname)(M))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function P(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function p(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=p;function l(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=l;function r(M){const W=M;return typeof W?.id=="string"&&T.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=r;function g(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=g;function o(M){const W=M;return typeof W?.id=="string"&&T.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=o;function b(M){const W=M;if(W?.uri)return{id:W.id,uri:T.URI.revive(W.uri)};const U=M;if(U?.configPath)return{id:U.id,configPath:T.URI.revive(U.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=b;function i(M,W){return y.extUriBiasedIgnorePathCase.isEqualOrParent(M,W.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function t(M){return c(M)||d(M)}e.isStoredWorkspaceFolder=t;function c(M){const W=M;return typeof W?.path=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=c;function d(M){const W=M;return typeof W?.uri=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=d;function s(M,W,U,x,B=!S.isWindows,O){if(M.scheme!==x.scheme)return{name:U,uri:M.toString(!0)};let H=W?void 0:O.relativePath(x,M);if(H!==void 0)H.length===0?H=".":S.isWindows&&M.scheme===n.Schemas.file&&!B&&(H=H.replace(/\//g,"\\"));else if(M.scheme===n.Schemas.file)H=M.fsPath,S.isWindows&&(H=(0,C.normalizeDriveLetter)(H),B&&(H=(0,m.toSlashes)(H)));else{if(!O.isEqualAuthority(M.authority,x.authority))return{name:U,uri:M.toString(!0)};H=M.path}return{name:U,path:H}}e.getStoredWorkspaceFolder=s;function h(M,W,U){let x=[],B=new Set;const O=U.dirname(W);for(let H of M){let j;if(c(H))H.path&&(j=U.resolvePath(O,H.path));else if(d(H))try{j=T.URI.parse(H.uri),j.path[0]!=="/"&&(j=j.with({path:"/"+j.path}))}catch(X){console.warn(X)}if(j){let X=U.getComparisonKey(j);if(!B.has(X)){B.add(X);const K=H.name||U.basenameOrAuthority(j);x.push(new f.WorkspaceFolder({uri:j,name:K,index:x.length},H))}}}return x}e.toWorkspaceFolders=h;function u(M,W,U,x,B){let O=E(W,M);const H=B.dirname(W),j=B.dirname(x),X=[],K=A(O.folders);for(const Pe of O.folders){const Be=c(Pe)?B.resolvePath(H,Pe.path):T.URI.parse(Pe.uri);let He;U?He=!1:He=!c(Pe)||(0,k.isAbsolute)(Pe.path),X.push(s(Be,He,Pe.name,j,K,B))}const he={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Ee=D.setProperty(M,["folders"],X,he);let De=D.applyEdits(M,Ee);return(0,y.isEqualAuthority)(O.remoteAuthority,(0,w.getRemoteAuthority)(x))&&(De=D.applyEdits(De,D.removeProperty(De,["remoteAuthority"],he))),De}e.rewriteWorkspaceFileForNewLocation=u;function E(M,W){let U=L.parse(W);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>t(x));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function A(M){return S.isWindows?M.some(W=>c(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function $(M){return typeof M.folderUri=="string"}function N(M){return typeof M.fileUri=="string"}function F(M,W){const U={workspaces:[],files:[]};if(M){const x=function(O,H){for(let j=0;j<O.length;j++)try{H(O[j],j)}catch(X){W.warn(`Error restoring recent entry ${JSON.stringify(O[j])}: ${X.toString()}. Skip entry.`)}},B=M;if(Array.isArray(B.entries))x(B.entries,O=>{const H=O.label,j=O.remoteAuthority;R(O)?U.workspaces.push({label:H,remoteAuthority:j,workspace:{id:O.workspace.id,configPath:T.URI.parse(O.workspace.configPath)}}):$(O)?U.workspaces.push({label:H,remoteAuthority:j,folderUri:T.URI.parse(O.folderUri)}):N(O)&&U.files.push({label:H,remoteAuthority:j,fileUri:T.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&x(O.workspaces3,(H,j)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[j]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:H.id,configPath:T.URI.parse(H.configURIPath)}}):typeof H=="string"&&U.workspaces.push({label:X,folderUri:T.URI.parse(H)})}),Array.isArray(O.files2)&&x(O.files2,(H,j)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[j]||void 0;typeof H=="string"&&U.files.push({label:X,fileUri:T.URI.parse(H)})})}}return U}e.restoreRecentlyOpened=F;function z(M){const W={entries:[]};for(const U of M.workspaces)p(U)?W.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):W.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)W.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return W}e.toStoreData=z}),define(me[88],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const C=this._idPool++;return this._data.set(C,D),this.logDebugInfo(),C}get(D,C){return this._data.has(D)?this._data.get(D)[C]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(me[45],ge([0,1,10,23,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k):this._providerInfo.set(k,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(me[26],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(me[198],ge([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(n,k,S){this._deferredPromises=new Map,this._id=n,this._shared=k,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const y=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of y.values())T.complete()}catch(T){for(const I of y.values())I.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,n])=>n!==void 0).map(([n])=>n)}get whenReady(){return this._init}get(n,k){let S=this._value[n];return typeof S=="undefined"&&(S=k),S}update(n,k){this._value[n]=k;let S=this._deferredPromises.get(n);if(S!==void 0)return S.p;const y=new m.DeferredPromise;return this._deferredPromises.set(n,y),this._scheduler.isScheduled()||this._scheduler.schedule(),y.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class D extends L{constructor(n,k){super(n.identifier.value,!0,k);this._extension=n}setKeysForSync(n){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},n)}}e.ExtensionGlobalMemento=D}),define(me[199],ge([0,1,3,2,12]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(S.value,y)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));y.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:y.apiNotebook})}};C=Ve([We(0,D.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[14],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[200],ge([0,1,27,3]),function(Y,e,m,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,S){D.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),ot(this,D,S,"f"),Oe(this,D,"f").onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(k){return Oe(this,D,"f").get(this._id,k)}store(k,S){return Oe(this,D,"f").store(this._id,k,S)}delete(k){return Oe(this,D,"f").delete(this._id,k)}}e.ExtensionSecrets=C,D=new WeakMap}),define(me[121],ge([0,1,4,3]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(n){this._enabled=n}$onDidChangeTelemetryEnabled(n){this._enabled=n,this._onDidChangeTelemetryEnabled.fire(n)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(me[63],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,D=(p,l)=>{const r={controllerId:l};return L.set(p,r),r};e.createPrivateApiFor=D;const C=p=>L.get(p);e.getPrivateApiFor=C;const n=(p,l,r,g)=>{let o=r;return{enumerable:!0,configurable:!1,get(){return o},set(b){if(!g(o,b)){const i=o;o=b,p.listener?.({op:3,key:l,value:b,previous:i})}}}},k=(p,l)=>p===l,S={range:(p,l)=>p===l?!0:!p||!l?!1:p.isEqual(l),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(p,l)=>!(p.length!==l.length||p.some(r=>!l.find(g=>r.id===g.id)))},y=Object.keys(S),T=(p,l)=>({range:n(p,"range",void 0,S.range),label:n(p,"label",l,S.label),description:n(p,"description",void 0,S.description),canResolveChildren:n(p,"canResolveChildren",!1,S.canResolveChildren),busy:n(p,"busy",!1,S.busy),error:n(p,"error",void 0,S.error),tags:n(p,"tags",[],S.tags)}),I=(p,l)=>{const r=new Map;for(const g of y)S[g](p[g],l[g])||r.set(g,l[g]);return r};e.diffTestItems=I;class a extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=a;class w extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class f extends Error{constructor(l,r,g){super(`TestItem with ID "${l}" is from controller "${r}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=f;const v=p=>{const l=(0,e.getPrivateApiFor)(p);let r=new Map;return{get size(){return r.size},forEach(g,o){for(const b of r.values())g.call(o,b,this)},replace(g){const o=new Map,b=new Set(r.keys()),i={op:4,ops:[]};for(const t of g){if(!(t instanceof _))throw new w(t.id);const c=(0,e.getPrivateApiFor)(t).controllerId;if(c!==l.controllerId)throw new f(t.id,c,l.controllerId);if(o.has(t.id))throw new a(t.id);o.set(t.id,t),b.delete(t.id),i.ops.push({op:0,item:t})}for(const t of b.keys())i.ops.push({op:1,id:t});l.listener?.(i),r=o},add(g){if(!(g instanceof _))throw new w(g.id);r.set(g.id,g),l.listener?.({op:0,item:g})},delete(g){r.delete(g)&&l.listener?.({op:1,id:g})},get(g){return r.get(g)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class _{constructor(l,r,g,o){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const b=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return b.parent instanceof P?void 0:b.parent}},children:{value:v(this),enumerable:!0,writable:!1},...T(b,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class P extends _{constructor(l,r){super(l,l,r,void 0)}}e.TestItemRootImpl=P}),define(me[52],ge([0,1,4,120,3,14]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var n;(function(S){function y(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}S.fromApiTunnel=y;function T(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}S.fromServiceTunnel=T})(n=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(y){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,T){return{dispose:()=>{}}}async $providePortAttributes(y,T,I,a,w){return[]}async $forwardPort(y,T){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([We(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[7],ge([0,1,17,15,98,24,102,8,13,2,32,42,119]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a){"use strict";var w,f,v,_,P,p,l,r,g,o,b,i,t,c,d,s,h,u,E,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function V(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(V,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(V,q),Object.setPrototypeOf(V.prototype,q.prototype),V}let $=P=class{constructor(V){w.set(this,void 0),ot(this,w,V,"f")}static from(...V){let se=V;return new P(function(){if(se){for(const Ie of se)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();se=void 0}})}dispose(){typeof Oe(this,w,"f")=="function"&&(Oe(this,w,"f").call(this),ot(this,w,void 0,"f"))}};w=new WeakMap,$=P=Ve([R],$),e.Disposable=$;let N=p=class{constructor(V,se){if(V<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=V,this._character=se}static Min(...V){if(V.length===0)throw new TypeError;let se=V[0];for(let Ie=1;Ie<V.length;Ie++){const Je=V[Ie];Je.isBefore(se)&&(se=Je)}return se}static Max(...V){if(V.length===0)throw new TypeError;let se=V[0];for(let Ie=1;Ie<V.length;Ie++){const Je=V[Ie];Je.isAfter(se)&&(se=Je)}return se}static isPosition(V){if(!V)return!1;if(V instanceof p)return!0;let{line:se,character:Ie}=V;return typeof se=="number"&&typeof Ie=="number"}get line(){return this._line}get character(){return this._character}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,se=0){if(V===null||se===null)throw(0,L.illegalArgument)();let Ie;return typeof V=="undefined"?Ie=0:typeof V=="number"?Ie=V:(Ie=typeof V.lineDelta=="number"?V.lineDelta:0,se=typeof V.characterDelta=="number"?V.characterDelta:0),Ie===0&&se===0?this:new p(this.line+Ie,this.character+se)}with(V,se=this.character){if(V===null||se===null)throw(0,L.illegalArgument)();let Ie;return typeof V=="undefined"?Ie=this.line:typeof V=="number"?Ie=V:(Ie=typeof V.line=="number"?V.line:this.line,se=typeof V.character=="number"?V.character:this.character),Ie===this.line&&se===this.character?this:new p(Ie,se)}toJSON(){return{line:this.line,character:this.character}}};N=p=Ve([R],N),e.Position=N;let F=l=class{constructor(V,se,Ie,Je){let lt,dt;if(typeof V=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Je=="number"?(lt=new N(V,se),dt=new N(Ie,Je)):V instanceof N&&se instanceof N&&(lt=V,dt=se),!lt||!dt)throw new Error("Invalid arguments");lt.isBefore(dt)?(this._start=lt,this._end=dt):(this._start=dt,this._end=lt)}static isRange(V){return V instanceof l?!0:V?N.isPosition(V.start)&&N.isPosition(V.end):!1}get start(){return this._start}get end(){return this._end}contains(V){return V instanceof l?this.contains(V._start)&&this.contains(V._end):V instanceof N?!(V.isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const se=N.Max(V.start,this._start),Ie=N.Min(V.end,this._end);if(!se.isAfter(Ie))return new l(se,Ie)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const se=N.Min(V.start,this._start),Ie=N.Max(V.end,this.end);return new l(se,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,se=this.end){if(V===null||se===null)throw(0,L.illegalArgument)();let Ie;return V?N.isPosition(V)?Ie=V:(Ie=V.start||this.start,se=V.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&se.isEqual(this.end)?this:new l(Ie,se)}toJSON(){return[this.start,this.end]}};F=l=Ve([R],F),e.Range=F;let z=r=class extends F{constructor(V,se,Ie,Je){let lt,dt;if(typeof V=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Je=="number"?(lt=new N(V,se),dt=new N(Ie,Je)):V instanceof N&&se instanceof N&&(lt=V,dt=se),!lt||!dt)throw new Error("Invalid arguments");super(lt,dt);this._anchor=lt,this._active=dt}static isSelection(V){return V instanceof r?!0:V?F.isRange(V)&&N.isPosition(V.anchor)&&N.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=r=Ve([R],z),e.Selection=z;class M{constructor(V,se,Ie){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof Ie!="undefined"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z\-]+$/.test(Ie)))throw(0,L.illegalArgument)("connectionToken");this.host=V,this.port=Math.round(se),this.connectionToken=Ie}}e.ResolvedAuthority=M;class W extends Error{constructor(V,se=a.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(V);this._message=V,this._code=se,this._detail=Ie,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable(V,se){return new W(V,a.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(V){return new W(V,a.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var U;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var x;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=g=class{constructor(V,se){this._range=V,this._newText=se}static isTextEdit(V){return V instanceof g?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,se){return new g(V,se)}static insert(V,se){return g.replace(new F(V,V),se)}static delete(V){return g.replace(V,"")}static setEndOfLine(V){const se=new g(new F(new N(0,0),new N(0,0)),"");return se.newEol=V,se}get range(){return this._range}set range(V){if(V&&!F.isRange(V))throw(0,L.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,L.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,L.illegalArgument)("newEol");this._newEol=V}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=g=Ve([R],B),e.TextEdit=B;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,se,Ie,Je){this._edits.push({_type:1,from:V,to:se,options:Ie,metadata:Je})}createFile(V,se,Ie){this._edits.push({_type:1,from:void 0,to:V,options:se,metadata:Ie})}deleteFile(V,se,Ie){this._edits.push({_type:1,from:V,to:void 0,options:se,metadata:Ie})}replaceNotebookMetadata(V,se,Ie){this._edits.push({_type:3,metadata:Ie,uri:V,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(V,se,Ie,Je,lt){let dt,ft,Pt=[],Ft;if(Ne.isNotebookRange(se)&&Ot.isNotebookCellDataArray(Ie)&&!Ot.isNotebookCellDataArray(Je)?(dt=se.start,ft=se.end,Pt=Ie,Ft=Je):typeof se=="number"&&typeof Ie=="number"&&Ot.isNotebookCellDataArray(Je)&&(dt=se,ft=Ie,Pt=Je,Ft=lt),dt===void 0||ft===void 0)throw new Error("Invalid arguments");(dt!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:V,index:dt,count:ft-dt,cells:Pt,metadata:Ft})}replaceNotebookCellMetadata(V,se,Ie,Je){this._edits.push({_type:3,metadata:Je,uri:V,edit:{editType:8,index:se,metadata:Ie}})}replace(V,se,Ie,Je){this._edits.push({_type:2,uri:V,edit:new B(se,Ie),metadata:Je})}insert(V,se,Ie,Je){this.replace(V,new F(se,se),Ie,Je)}delete(V,se,Ie){this.replace(V,se,"",Ie)}has(V){return this._edits.some(se=>se._type===2&&se.uri.toString()===V.toString())}set(V,se){if(se)for(const Ie of se)Ie&&this._edits.push({_type:2,uri:V,edit:Ie});else{for(let Ie=0;Ie<this._edits.length;Ie++){const Je=this._edits[Ie];Je._type===2&&Je.uri.toString()===V.toString()&&(this._edits[Ie]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(V){const se=[];for(let Ie of this._edits)Ie._type===2&&Ie.uri.toString()===V.toString()&&se.push(Ie.edit);return se}entries(){const V=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let Ie=V.get(se.uri);Ie||(Ie=[se.uri,[]],V.set(se.uri,Ie)),Ie[1].push(se.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=Ve([R],H),e.WorkspaceEdit=H;let j=o=class{constructor(V){this._tabstop=1,this.value=V||""}static isSnippetString(V){return V instanceof o?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}appendText(V){return this.value+=o._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,se=this._tabstop++){if(typeof V=="function"){const Ie=new o;Ie._tabstop=this._tabstop,V(Ie),this._tabstop=Ie._tabstop,V=Ie.value}else V=o._escape(V);return this.value+="${",this.value+=se,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,se=this._tabstop++){const Ie=V.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(V,se){if(typeof se=="function"){const Ie=new o;Ie._tabstop=this._tabstop,se(Ie),this._tabstop=Ie._tabstop,se=Ie.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,se&&(this.value+=":",this.value+=se),this.value+="}",this}};j=o=Ve([R],j),e.SnippetString=j;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let he=b=class{constructor(V,se){if(this.uri=V,se)if(se instanceof F)this.range=se;else if(se instanceof N)this.range=new F(se,se);else throw new Error("Illegal argument")}static isLocation(V){return V instanceof b?!0:V?F.isRange(V.range)&&y.URI.isUri(V.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};he=b=Ve([R],he),e.Location=he;let Ee=class{constructor(V,se){this.location=V,this.message=se}static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&y.URI.isUri(V.location.uri):!1}static isEqual(V,se){return V===se?!0:!V||!se?!1:V.message===se.message&&V.location.range.isEqual(se.location.range)&&V.location.uri.toString()===se.location.uri.toString()}};Ee=Ve([R],Ee),e.DiagnosticRelatedInformation=Ee;let De=class{constructor(V,se,Ie=K.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=V,this.message=se,this.severity=Ie}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,se){return V===se?!0:!V||!se?!1:V.message===se.message&&V.severity===se.severity&&V.code===se.code&&V.severity===se.severity&&V.source===se.source&&V.range.isEqual(se.range)&&(0,m.equals)(V.tags,se.tags)&&(0,m.equals)(V.relatedInformation,se.relatedInformation,Ee.isEqual)}};De=Ve([R],De),e.Diagnostic=De;let Pe=class{constructor(V,se){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=se}};Pe=Ve([R],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let He=class{constructor(V,se=Be.Text){this.range=V,this.kind=se}toJSON(){return{range:this.range,kind:Be[this.kind]}}};He=Ve([R],He),e.DocumentHighlight=He;var ze;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let Z=i=class{constructor(V,se,Ie,Je,lt){this.name=V,this.kind=se,this.containerName=lt,typeof Ie=="string"&&(this.containerName=Ie),Je instanceof he?this.location=Je:Ie instanceof F&&(this.location=new he(Je,Ie)),i.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};Z=i=Ve([R],Z),e.SymbolInformation=Z;let ne=t=class{constructor(V,se,Ie,Je,lt){this.name=V,this.detail=se,this.kind=Ie,this.range=Je,this.selectionRange=lt,this.children=[],t.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children&&V.children.forEach(t.validate)}};ne=t=Ve([R],ne),e.DocumentSymbol=ne;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ce=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let J=class{constructor(V,se){this.title=V,this.kind=se}};J=Ve([R],J),e.CodeAction=J;let te=c=class{constructor(V){this.value=V}append(V){return new c(this.value?this.value+c.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+c.sep)}};te.sep=".",te=c=Ve([R],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let ve=class{constructor(V,se){if(this.range=V,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ve=Ve([R],ve),e.SelectionRange=ve;class Me{constructor(V,se,Ie,Je,lt,dt){this.kind=V,this.name=se,this.detail=Ie,this.uri=Je,this.range=lt,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor(V,se){this.fromRanges=se,this.from=V}}e.CallHierarchyIncomingCall=je;class Ke{constructor(V,se){this.fromRanges=se,this.to=V}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(V,se){this.range=V,this.command=se}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let ut=d=class{constructor(V,se=!1){f.set(this,void 0),ot(this,f,new D.MarkdownString(V,{supportThemeIcons:se}),"f")}static isMarkdownString(V){return V instanceof d?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}get value(){return Oe(this,f,"f").value}set value(V){Oe(this,f,"f").value=V}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(V){Oe(this,f,"f").isTrusted=V}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(V){Oe(this,f,"f").supportThemeIcons=V}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(V){Oe(this,f,"f").supportHtml=V}appendText(V){return Oe(this,f,"f").appendText(V),this}appendMarkdown(V){return Oe(this,f,"f").appendMarkdown(V),this}appendCodeblock(V,se){return Oe(this,f,"f").appendCodeblock(se??"",V),this}};f=new WeakMap,ut=d=Ve([R],ut),e.MarkdownString=ut;let it=class{constructor(V,se){this.label=V,this.documentation=se}};it=Ve([R],it),e.ParameterInformation=it;let st=class{constructor(V,se){this.label=V,this.documentation=se,this.parameters=[]}};st=Ve([R],st),e.SignatureInformation=st;let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ae=Ve([R],Ae),e.SignatureHelp=Ae;var wt;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(wt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ee;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(ee=e.InlayHintKind||(e.InlayHintKind={}));let re=class{constructor(V,se,Ie){this.text=V,this.position=se,this.kind=Ie}};re=Ve([R],re),e.InlayHint=re;var Se;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Ge=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(q){q[q.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(V,se){this.label=V,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=Ve([R],nt),e.CompletionItem=nt;let de=class{constructor(V=[],se=!1){this.items=V,this.isIncomplete=se}};de=Ve([R],de),e.CompletionList=de;let ke=class{constructor(V,se,Ie){this.text=V,this.range=se,this.command=Ie}};ke=Ve([R],ke),e.InlineSuggestion=ke;let Ue=class{constructor(V){this.items=V}};Ue=Ve([R],Ue),e.InlineSuggestions=Ue;var $e;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})($e=e.ViewColumn||(e.ViewColumn={}));var tt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Te;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ce;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var we;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(we=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pe;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(pe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function V(se){switch(se){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(V,se){if(se&&!y.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.target=se}};be=Ve([R],be),e.DocumentLink=be;let Fe=class{constructor(V,se,Ie,Je){this.red=V,this.green=se,this.blue=Ie,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let Qe=class{constructor(V,se){if(se&&!(se instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.color=se}};Qe=Ve([R],Qe),e.ColorInformation=Qe;let xe=class{constructor(V){if(!V||typeof V!="string")throw(0,L.illegalArgument)("label");this.label=V}};xe=Ve([R],xe),e.ColorPresentation=xe;var Xe;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var at;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ct{constructor(V,se,Ie){if(this.startIndex=V,this.length=se,this.tooltip=Ie,typeof V!="number"||V<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=ct;var le;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(V){this.options=V,typeof V!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=_e;var ae;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ae=e.TaskRevealKind||(e.TaskRevealKind={}));var Q;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Q=e.TaskPanelKind||(e.TaskPanelKind={}));let ye=s=class{constructor(V,se){if(this.label=se,typeof V!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=V}static from(V){switch(V){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};ye.Clean=new s("clean","Clean"),ye.Build=new s("build","Build"),ye.Rebuild=new s("rebuild","Rebuild"),ye.Test=new s("test","Test"),ye=s=Ve([R],ye),e.TaskGroup=ye;function Le(q){let V="";for(let se=0;se<q.length;se++)V+=q[se].replace(/,/g,",,")+",";return V}let et=class{constructor(V,se,Ie){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=V,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ie):this._options=se)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(let se of this._args)V.push(se);return Le(V)}};et=Ve([R],et),e.ProcessExecution=et;let qe=class{constructor(V,se,Ie){if(this._args=[],Array.isArray(se)){if(!V)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V,this._args=se,this._options=Ie}else{if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V,this._options=se}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)V.push(typeof se=="string"?se:se.value);return Le(V)}};qe=Ve([R],qe),e.ShellExecution=qe;var mt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class kt{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=kt;let bt=h=class{constructor(V,se,Ie,Je,lt,dt){this.__deprecated=!1,this._definition=this.definition=V;let ft;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ie,this.execution=Je,ft=lt,this.__deprecated=!0):se===_t.Global||se===_t.Workspace?(this.target=se,this._name=this.name=Ie,this._source=this.source=Je,this.execution=lt,ft=dt):(this.target=se,this._name=this.name=Ie,this._source=this.source=Je,this.execution=lt,ft=dt),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof et?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const se=this._definition.type;(h.EmptyType===se||h.ProcessType===se||h.ShellType===se||h.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=h=Ve([R],bt),e.Task=bt;var gt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let Et=class{constructor(V,se=Ct.None){this.collapsibleState=se,y.URI.isUri(V)?this.resourceUri=V:this.label=V}};Et=Ve([R],Et),e.TreeItem=Et;var Ct;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor(V){this._value=V}async asString(){return JSON.stringify(this._value)}};Lt=Ve([R],Lt),e.TreeDataTransferItem=Lt;let yt=class{constructor(){this._items=new Map}get(V){return this._items.get(V)}set(V,se){this._items.set(V,se)}forEach(V){this._items.forEach(V)}};yt=Ve([R],yt),e.TreeDataTransfer=yt;let At=class{constructor(V,se){this.id=V,this.color=se}};At=Ve([R],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let xt=class{constructor(V){this.id=V}};xt=Ve([R],xt),e.ThemeColor=xt;var Tt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(Tt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor(V,se){if(typeof V!="string"&&(!V||!y.URI.isUri(V)&&!y.URI.isUri(V.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof V=="string"?(this.baseFolder=y.URI.file(V),this.base=V):y.URI.isUri(V)?(this.baseFolder=V,this.base=V.fsPath):(this.baseFolder=V.uri,this.base=V.uri.fsPath),this.pattern=se}};Bt=Ve([R],Bt),e.RelativePattern=Bt;let Ht=class{constructor(V,se,Ie,Je){this.enabled=typeof V=="boolean"?V:!0,typeof se=="string"&&(this.condition=se),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Ht=Ve([R],Ht),e.Breakpoint=Ht;let St=class extends Ht{constructor(V,se,Ie,Je,lt){super(se,Ie,Je,lt);if(V===null)throw(0,L.illegalArgument)("location");this.location=V}};St=Ve([R],St),e.SourceBreakpoint=St;let Qt=class extends Ht{constructor(V,se,Ie,Je,lt){super(se,Ie,Je,lt);this.functionName=V}};Qt=Ve([R],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Ht{constructor(V,se,Ie,Je,lt,dt,ft){super(Je,lt,dt,ft);if(!se)throw(0,L.illegalArgument)("dataId");this.label=V,this.dataId=se,this.canPersist=Ie}};Vt=Ve([R],Vt),e.DataBreakpoint=Vt;let si=class{constructor(V,se,Ie){this.command=V,this.args=se||[],this.options=Ie}};si=Ve([R],si),e.DebugAdapterExecutable=si;let oi=class{constructor(V,se){this.port=V,this.host=se}};oi=Ve([R],oi),e.DebugAdapterServer=oi;let Rt=class{constructor(V){this.path=V}};Rt=Ve([R],Rt),e.DebugAdapterNamedPipeServer=Rt;let Xt=class{constructor(V){this.implementation=V}};Xt=Ve([R],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor(V,se){this.range=V,this.expression=se}};ai=Ve([R],ai),e.EvaluatableExpression=ai;var Yt;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(V,se){this.range=V,this.text=se}};zt=Ve([R],zt),e.InlineValueText=zt;let vt=class{constructor(V,se,Ie=!0){this.range=V,this.variableName=se,this.caseSensitiveLookup=Ie}};vt=Ve([R],vt),e.InlineValueVariableLookup=vt;let li=class{constructor(V,se){this.range=V,this.expression=se}};li=Ve([R],li),e.InlineValueEvaluatableExpression=li;let Mt=class{constructor(V,se){this.frameId=V,this.stoppedLocation=se}};Mt=Ve([R],Mt),e.InlineValueContext=Mt;var jt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Jt=u=class extends Error{constructor(V,se=I.FileSystemProviderErrorCode.Unknown,Ie){super(y.URI.isUri(V)?V.toString(!0):V);this.code=Ie?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}static FileExists(V){return new u(V,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(V){return new u(V,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(V){return new u(V,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(V){return new u(V,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Jt=u=Ve([R],Jt),e.FileSystemError=Jt;let ci=class{constructor(V,se,Ie){this.start=V,this.end=se,this.kind=Ie}};ci=Ve([R],ci),e.FoldingRange=ci;var fi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(V,se=[]){this.tokenTypes=V,this.tokenModifiers=se}}e.SemanticTokensLegend=Zt;function _i(q){return typeof q=="undefined"||(0,S.isStringArray)(q)}class qt{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let se=0,Ie=V.tokenTypes.length;se<Ie;se++)this._tokenTypeStrToInt.set(V.tokenTypes[se],se);for(let se=0,Ie=V.tokenModifiers.length;se<Ie;se++)this._tokenModifierStrToInt.set(V.tokenModifiers[se],se)}}push(V,se,Ie,Je,lt){if(typeof V=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Je=="number"&&(typeof lt=="number"||typeof lt=="undefined"))return typeof lt=="undefined"&&(lt=0),this._pushEncoded(V,se,Ie,Je,lt);if(F.isRange(V)&&typeof se=="string"&&_i(Ie))return this._push(V,se,Ie);throw(0,L.illegalArgument)()}_push(V,se,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=V.start.line,lt=V.start.character,dt=V.end.character-V.start.character,ft=this._tokenTypeStrToInt.get(se);let Pt=0;if(Ie)for(const Ft of Ie){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Ft);Pt|=1<<Nt>>>0}this._pushEncoded(Je,lt,dt,ft,Pt)}_pushEncoded(V,se,Ie,Je,lt){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Ft=0,Nt=0;for(let Ut=0;Ut<Pt;Ut++){let $t=this._data[5*Ut],di=this._data[5*Ut+1];$t===0?($t=Ft,di+=Nt):$t+=Ft,this._data[5*Ut]=$t,this._data[5*Ut+1]=di,Ft=$t,Nt=di}}let dt=V,ft=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=lt,this._prevLine=V,this._prevChar=se}static _sortAndDeltaEncode(V){let se=[];const Ie=V.length/5|0;for(let ft=0;ft<Ie;ft++)se[ft]=ft;se.sort((ft,Pt)=>{const Ft=V[5*ft],Nt=V[5*Pt];if(Ft===Nt){const Ut=V[5*ft+1],$t=V[5*Pt+1];return Ut-$t}return Ft-Nt});const Je=new Uint32Array(V.length);let lt=0,dt=0;for(let ft=0;ft<Ie;ft++){const Pt=5*se[ft],Ft=V[Pt+0],Nt=V[Pt+1],Ut=V[Pt+2],$t=V[Pt+3],di=V[Pt+4],Wi=Ft-lt,Xi=Wi===0?Nt-dt:Nt,hi=5*ft;Je[hi+0]=Wi,Je[hi+1]=Xi,Je[hi+2]=Ut,Je[hi+3]=$t,Je[hi+4]=di,lt=Ft,dt=Nt}return Je}build(V){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),V):new Gt(qt._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=qt;class Gt{constructor(V,se){this.resultId=se,this.data=V}}e.SemanticTokens=Gt;class Si{constructor(V,se,Ie){this.start=V,this.deleteCount=se,this.data=Ie}}e.SemanticTokensEdit=Si;class Ci{constructor(V,se){this.resultId=se,this.edits=V}}e.SemanticTokensEdits=Ci;var Kt;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new At("arrow-left")},ei=Ve([R],ei),e.QuickInputButtons=ei;var Di;(function(q){q[q.Default=1]="Default",q[q.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(V,se,Ie){this.badge=V,this.tooltip=se,this.color=Ie}static validate(V){if(V.badge){let se=(0,k.nextCharLength)(V.badge,0);if(se<V.badge.length&&(se+=(0,k.nextCharLength)(V.badge,se)),V.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(V){this.kind=V}};ti=Ve([R],ti),e.ColorTheme=ti;var gi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ne{constructor(V,se){if(V<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");V<=se?(this._start=V,this._end=se):(this._start=se,this._end=V)}static isNotebookRange(V){return V instanceof Ne?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(V){let se=this._start,Ie=this._end;return V.start!==void 0&&(se=V.start),V.end!==void 0&&(Ie=V.end),se===this._start&&Ie===this._end?this:new Ne(se,Ie)}}e.NotebookRange=Ne;class Ot{constructor(V,se,Ie,Je,lt,dt,ft){this.kind=V,this.value=se,this.languageId=Ie,this.mime=Je,this.outputs=lt??[],this.metadata=dt,this.executionSummary=ft,Ot.validate(this)}static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(se=>Ot.isNotebookCellData(se))}static isNotebookCellData(V){return!0}}e.NotebookCellData=Ot;class pi{constructor(V){this.cells=V}}e.NotebookData=pi;class pt{constructor(V,se){this.data=V,this.mime=se;const Ie=(0,n.normalizeMimeType)(se,!0);if(!Ie)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}static isNotebookCellOutputItem(V){return V instanceof pt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const se={name:V.name,message:V.message,stack:V.stack};return pt.json(se,"application/vnd.code.notebook.error")}static stdout(V){return pt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return pt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,se="application/octet-stream"){return new pt(V,se)}static text(V,se=n.Mimes.text){const Ie=Oe(pt,v,"f",_).encode(String(V));return new pt(Ie,se)}static json(V,se="application/json"){const Ie=JSON.stringify(V,void 0,"	");return pt.text(Ie,se)}}e.NotebookCellOutputItem=pt,v=pt,_={value:new TextEncoder};class ii{constructor(V,se,Ie){this.items=ii.ensureUniqueMimeTypes(V,!0),typeof se=="string"?(this.id=se,this.metadata=Ie):(this.id=(0,T.generateUuid)(),this.metadata=se??Ie)}static isNotebookCellOutput(V){return V instanceof ii?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&(0,S.isArray)(V.items)}static ensureUniqueMimeTypes(V,se=!1){const Ie=new Set,Je=new Set;for(let lt=0;lt<V.length;lt++){const dt=V[lt],ft=(0,n.normalizeMimeType)(dt.mime);if(!Ie.has(ft)){Ie.add(ft);continue}Je.add(lt),se&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?V:V.filter((lt,dt)=>!Je.has(dt))}}e.NotebookCellOutput=ii;var Ii;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(V,se){this.text=V,this.alignment=se}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(V,se=[]){this.uri=V,this.provides=(0,m.asArray)(se)}}e.NotebookRendererScript=Ri;let ni=class{constructor(V,se){this.label=V,this.timestamp=se}};ni=Ve([R],ni),e.TimelineItem=ni;var Li;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor(V,se){this.ranges=V,this.wordPattern=se}}e.LinkedEditingRanges=Oi;class Ni{constructor(V,se){this._port=V,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var ie;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(ie=e.TestResultState||(e.TestResultState={}));var fe;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(fe=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Re=class{constructor(V=void 0,se=void 0,Ie=void 0){this.include=V,this.exclude=se,this.profile=Ie}};Re=Ve([R],Re),e.TestRunRequest=Re;let ht=E=class{constructor(V){this.message=V}static diff(V,se,Ie){const Je=new E(V);return Je.expectedOutput=se,Je.actualOutput=Ie,Je}};ht=E=Ve([R],ht),e.TestMessage=ht;let Dt=class{constructor(V){this.id=V}};Dt=Ve([R],Dt),e.TestTag=Dt;let It=class{constructor(V,se){this.covered=V,this.total=se}};It=Ve([R],It),e.CoveredCount=It;let Ui=A=class{constructor(V,se,Ie,Je){this.uri=V,this.statementCoverage=se,this.branchCoverage=Ie,this.functionCoverage=Je}static fromDetails(V,se){const Ie=new It(0,0),Je=new It(0,0),lt=new It(0,0);for(const ft of se)if("branches"in ft){Ie.total+=1,Ie.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Je.total+=1,Je.covered+=Pt.executionCount>0?1:0}else lt.total+=1,lt.covered+=ft.executionCount>0?1:0;const dt=new A(V,Ie,Je.total>0?Je:void 0,lt.total>0?lt:void 0);return dt.detailedCoverage=se,dt}};Ui=A=Ve([R],Ui),e.FileCoverage=Ui;let xi=class{constructor(V,se,Ie=[]){this.executionCount=V,this.location=se,this.branches=Ie}};xi=Ve([R],xi),e.StatementCoverage=xi;let Bi=class{constructor(V,se){this.executionCount=V,this.location=se}};Bi=Ve([R],Bi),e.BranchCoverage=Bi;let $i=class{constructor(V,se){this.executionCount=V,this.location=se}};$i=Ve([R],$i),e.FunctionCoverage=$i;var qi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(V,se,Ie,Je,lt,dt){this.kind=V,this.name=se,this.detail=Ie,this.uri=Je,this.range=lt,this.selectionRange=dt}}e.TypeHierarchyItem=Qi}),define(me[122],ge([0,1,56,10,8,149,110,7,17]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const y=new Map;function T(f,v){v?y.set(f,v):y.delete(f)}e.setWordDefinitionFor=T;function I(f){return y.get(f)}e.getWordDefinitionFor=I;class a extends C.MirrorTextModel{constructor(v,_,P,p,l,r,g,o){super(_,P,p,l);this._proxy=v,this._languageId=r,this._isDirty=g,this._notebook=o,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,S.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,P){return v._getWordRangeAtPosition(_,P)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,m.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,m.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const P=this._eol,p=_.start.line,l=_.end.line,r=[];r.push(this._lines[p].substring(_.start.character));for(let g=p+1;g<l;g++)r.push(this._lines[g]);return r.push(this._lines[l].substring(0,_.end.character)),r.join(P)}_lineAt(v){let _;if(v instanceof k.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new w(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),P=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,P))}_validateRange(v){if(!(v instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),P=this._validatePosition(v.end);return _===v.start&&P===v.end?v:new k.Range(_.line,_.character,P.line,P.character)}_validatePosition(v){if(!(v instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:P}=v,p=!1;if(_<0)_=0,P=0,p=!0;else if(_>=this._lines.length)_=this._lines.length-1,P=this._lines[_].length,p=!0;else{const l=this._lines[_].length;P<0?(P=0,p=!0):P>l&&(P=l,p=!0)}return p?new k.Position(_,P):v}_getWordRangeAtPosition(v,_){const P=this._validatePosition(v);if(!_)_=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const p=(0,n.getWordAtText)(P.character+1,(0,n.ensureValidWordDefinition)(_),this._lines[P.line],0);if(p)return new k.Range(P.line,p.startColumn-1,P.line,p.endColumn-1)}}e.ExtHostDocumentData=a;class w{constructor(v,_,P){this._line=v,this._text=_,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=w}),define(me[201],ge([0,1,7,3,112,6,82,24,2,32]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(a,w,f,v){this._notebook=f,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,y.generateUuid)()}),this._init(),this._disposables.add(w.onDidChangeDocument(P=>{const p=this._cellUris.get(P.document.uri);p!==void 0&&(this._cellLengths.setValue(p,this._cells[p].document.getText().length+1),this._cellLines.setValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(P=>_(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const a=[],w=[];for(const f of this._notebook.getCells())f.kind===m.NotebookCellKind.Code&&(!this._selector||(0,n.score)(this._selector,f.document.uri,f.document.languageId,!0))&&(this._cellUris.set(f.document.uri,this._cells.length),this._cells.push(f),a.push(f.document.getText().length+1),w.push(f.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(w))}get version(){return this._versionId}getText(a){if(!a){let p="";for(const l of this._cells)p+=l.document.getText()+`
`;return p=p.slice(0,-1),p}if(a.isEmpty)return"";const w=this.locationAt(a.start),f=this.locationAt(a.end),v=this._cellUris.get(w.uri),_=this._cellUris.get(f.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new m.Range(w.range.start,f.range.end));const P=[this._cells[v].document.getText(new m.Range(w.range.start,new m.Position(this._cells[v].document.lineCount,0)))];for(let p=v+1;p<_;p++)P.push(this._cells[p].document.getText());return P.push(this._cells[_].document.getText(new m.Range(new m.Position(0,0),f.range.end))),P.join(`
`)}offsetAt(a){const w=this._cellLines.getIndexOf(a.line),f=this._cellLengths.getPrefixSum(w.index-1),v=this._cells[w.index].document.offsetAt(a.with(w.remainder));return f+v}positionAt(a){if(typeof a=="number"){const f=this._cellLengths.getIndexOf(a),v=this._cellLines.getPrefixSum(f.index-1);return this._cells[f.index].document.positionAt(f.remainder).translate(v)}const w=this._cellUris.get(a.uri);if(w!==void 0){const f=this._cellLines.getPrefixSum(w-1);return new m.Position(f+a.range.start.line,a.range.start.character)}return new m.Position(0,0)}locationAt(a){m.Range.isRange(a)||(a=new m.Range(a,a));const w=this._cellLines.getIndexOf(a.start.line);let f=w;a.isEmpty||(f=this._cellLines.getIndexOf(a.end.line));const v=new m.Position(w.remainder,a.start.character),_=new m.Position(f.remainder,a.end.character),P=new m.Range(v,_),p=this._cells[w.index];return new m.Location(p.document.uri,p.document.validateRange(P))}contains(a){return this._cellUris.has(a)}validateRange(a){const w=this.validatePosition(a.start),f=this.validatePosition(a.end);return a.with(w,f)}validatePosition(a){const w=this._cellLines.getIndexOf(a.line),f=new m.Position(w.remainder,a.character),v=this._cells[w.index].document.validatePosition(f),_=this._cellLines.getPrefixSum(w.index-1);return new m.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=T}),define(me[202],ge([0,1,7,14,3]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([We(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[64],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=n=>n,this.transformOutgoing=n=>n,this.transformOutgoingURI=n=>n,this.transformOutgoingScheme=n=>n)}}e.URITransformerService=L}),define(me[203],ge([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let y=this.buffers.indexOf(S);return y<0&&(y=this.buffers.length,this.buffers.push(S)),y}}function D(k,S){if(S.serializeBuffersForPostMessage){const y=new L,T=(w,f)=>{if(f instanceof ArrayBuffer){const v=y.add(f);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(f)){const v=C(f);if(v){const _=y.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},I=JSON.stringify(k,T),a=y.buffers.map(w=>{const f=new Uint8Array(w);return m.VSBuffer.wrap(f)});return{message:I,buffers:a}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=D;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function n(k,S){const y=S.map(a=>{const w=new ArrayBuffer(a.byteLength);return new Uint8Array(w).set(a.buffer),w}),T=S.length?(a,w)=>{if(typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const f=w,{index:v}=f,_=y[v];if(f.view)switch(f.view.type){case 1:return new Int8Array(_,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return w}:void 0;return{message:JSON.parse(k,T),arrayBuffers:y}}e.deserializeWebviewMessage=n}),define(me[204],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function D(n){const k=new Map;return n.types.forEach((S,y)=>{k.set(S,{asString:async()=>n.items[y].asString})}),k}L.toITreeDataTransfer=D;async function C(n){const k={types:[],items:[]},S=Array.from(n.entries());for(const y of S)k.types.push(y[0]),k.items.push({asString:await y[1].asString()});return k}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[89],ge([0,1,10,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(k,S){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===m.Schemas.file&&(k=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:S.authority,path:k.path})),L.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=D;function C(k){return k.replace(/./g,S=>{const y=S.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?S:"-"+y.toString(16).padStart(4,"0")})}function n(k){return k.replace(/-([0-9a-f]{4})/g,(S,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=n}),define(me[205],ge([0,1,3,6,89]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,S,y){this._proxy=k,this._editors=S,this._initData=y,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const T=S.getVisibleTextEditors();for(const I of this._insets.values())T.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,y,T,I){let a;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===k){a=l;break}if(!a)throw new Error("not a visible editor");const w=this,f=this._handlePool++,v=new m.Emitter,_=new m.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,D.asWebviewUri)(l,w._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(l){this._options=l,w._proxy.$setOptions(f,l)}get options(){return this._options}set html(l){this._html=l,w._proxy.$setHtml(f,l)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(l){return w._proxy.$postMessage(f,l)}},p=new class{constructor(){this.editor=k,this.line=S,this.height=y,this.webview=P,this.onDidDispose=_.event}dispose(){w._insets.has(f)&&(w._insets.delete(f),w._proxy.$disposeEditorInset(f),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(f,a.id,a.value.document.uri,S+1,y,T||{},I.identifier,I.extensionLocation),this._insets.set(f,{editor:k,inset:p,onDidReceiveMessage:v}),p}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const y=this._insets.get(k);y&&y.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(me[206],ge([0,1,171,13,2,6,4,61,43,42,17,10]),function(Y,e,m,L,D,C,n,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function a(N,F,z){for(const M of z.visibleEditorPanes)if(M.group.id===F&&N.matches(M.input))return M.getViewState()}e.findViewStateForEditor=a;function w(N){if(g(N))return!1;const F=N;return D.URI.isUri(F?.resource)}e.isResourceEditorInput=w;function f(N){if(g(N))return!1;const F=N;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=f;function v(N){if(g(N)||f(N))return!1;const F=N;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function _(N){if(g(N))return!1;const F=N;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var P;(function(N){N[N.SHORT=0]="SHORT",N[N.MEDIUM=1]="MEDIUM",N[N.LONG=2]="LONG"})(P=e.Verbosity||(e.Verbosity={}));var p;(function(N){N[N.EXPLICIT=1]="EXPLICIT",N[N.AUTO=2]="AUTO",N[N.FOCUS_CHANGE=3]="FOCUS_CHANGE",N[N.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var l;(function(N){N[N.None=0]="None",N[N.Readonly=2]="Readonly",N[N.Untitled=4]="Untitled",N[N.Singleton=8]="Singleton",N[N.RequiresTrust=16]="RequiresTrust",N[N.CanSplitInGroup=32]="CanSplitInGroup",N[N.ForceDescription=64]="ForceDescription"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends C.Disposable{}e.AbstractEditorInput=r;function g(N){return N instanceof r}e.isEditorInput=g;function o(N){const F=N;return D.URI.isUri(F?.preferredResource)}function b(N){const F=N;return g(F?.primary)&&g(F?.secondary)}e.isSideBySideEditorInput=b;function i(N){const F=N;return g(F?.modified)&&g(F?.original)}e.isDiffEditorInput=i;function t(N){return g(N?.editor)}e.isEditorInputWithOptions=t;function c(N){const F=N;return t(N)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=c;function d(N){const F=N;return typeof F?.groupId=="number"&&g(F.editor)}e.isEditorIdentifier=d;var s;(function(N){N[N.UNKNOWN=0]="UNKNOWN",N[N.REPLACE=1]="REPLACE",N[N.MOVE=2]="MOVE",N[N.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(N){N[N.PRIMARY=1]="PRIMARY",N[N.SECONDARY=2]="SECONDARY",N[N.BOTH=3]="BOTH",N[N.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(F,z){if(!F)return;if(z?.supportSideBySide){const{primary:W,secondary:U}=this.getSideEditors(F);if(W&&U){if(z?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(W,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===h.ANY)return this.getOriginalUri(W,{filterByScheme:z.filterByScheme})??this.getOriginalUri(U,{filterByScheme:z.filterByScheme});F=z.supportSideBySide===h.PRIMARY?W:U}}if(f(F)||v(F))return;const M=o(F)?F.preferredResource:F.resource;return!M||!z||!z.filterByScheme?M:this.filterUri(M,z.filterByScheme)}getSideEditors(F){return b(F)||v(F)?{primary:F.primary,secondary:F.secondary}:i(F)||f(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,z){if(!F)return;if(z?.supportSideBySide){const{primary:W,secondary:U}=this.getSideEditors(F);if(W&&U){if(z?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(W,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===h.ANY)return this.getCanonicalUri(W,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:z.filterByScheme});F=z.supportSideBySide===h.PRIMARY?W:U}}if(f(F)||v(F))return;const M=F.resource;return!M||!z||!z.filterByScheme?M:this.filterUri(M,z.filterByScheme)}filterUri(F,z){if(Array.isArray(z)){if(z.some(M=>F.scheme===M))return F}else if(z===F.scheme)return F}}e.EditorResourceAccessor=new u;var E;(function(N){N[N.LEFT=0]="LEFT",N[N.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const z=this.instantiationService=F.get(n.IInstantiationService);for(const[M,W]of this.editorSerializerConstructors)this.createEditorSerializer(M,W,z);this.editorSerializerConstructors.clear()}createEditorSerializer(F,z,M){const W=M.createInstance(z);this.editorSerializerInstances.set(F,W)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,z){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,z,this.instantiationService):this.editorSerializerConstructors.set(F,z),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new A);async function R(N,F){if(!N||!N.length)return[];const z=await Promise.all(N.map(async M=>{const W=D.URI.revive(M.fileUri);if(!W||!await F.canHandleResource(W))return;let x=M.exists,B=M.type;if(typeof x!="boolean"||typeof B!="number")try{B=(await F.resolve(W)).isFile?y.FileType.File:y.FileType.Unknown,x=!0}catch{x=!1}if(!x&&M.openOnlyIfExists||B!==y.FileType.File)return;const O={selection:x?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let H;return x?H={resource:W,options:O}:H={resource:W,options:O,forceUntitled:!0},H}));return(0,T.coalesce)(z)}e.pathsToEditors=R;var $;(function(N){N[N.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",N[N.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[123],ge([0,1,3,18,172]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,y,T){const I={command:k};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof T=="number"){const a=setTimeout(()=>{clearTimeout(a);const w=this.pendingRequests.get(I.seq);if(w){this.pendingRequests.delete(I.seq);const f={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,D.localize)(0,null,T,k)};w(f)}},T)}return y&&this.pendingRequests.set(I.seq,y),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const S=k,y=this.pendingRequests.get(S.request_seq);y&&(this.pendingRequests.delete(S.request_seq),y(S));break}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,y)=>k.set(y,S)),await(0,L.timeout)(500),k.forEach((S,y)=>{S({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(y)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[207],ge([0,1,8,2,9,25,10]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(i,t,c){return i.replace(k,function(d,s){return t&&s.length>0&&s[0]!=="_"?d:c&&c.hasOwnProperty(s)?c[s]:d})}e.formatPII=S;function y(i){const t={};for(const c of Object.keys(i))c.startsWith("!")||(t[c]=i[c]);return t}e.filterExceptionsFromTelemetry=y;function T(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||T(i.parentSession))}e.isSessionAttach=T;function I(i){let t=i.configuration.type;if(!!t)return t==="vslsShare"&&(t=i.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function a(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=a;function w(i,t,c){let d,s=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=h.exec(i);){let E=u.index+1,A=E+u[0].length;if(E<=t&&A>=c){d=u[0],s=E;break}}if(d){let E=/\w+/g,A=null;for(;(A=E.exec(d))&&!(A.index+1+s+A[0].length>=c););A&&(d=d.substring(0,E.lastIndex))}return d?{start:s,end:s+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=w;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(i){return!!(i&&i.match(f))}e.isUri=v;function _(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(v(i.path))return L.URI.parse(i.path);if((0,D.isAbsolute)(i.path))return L.URI.file(i.path)}return i.path}function P(i){if(typeof i.path=="object"){const t=L.URI.revive(i.path);if(t)return t.scheme===n.Schemas.file?t.fsPath:t.toString()}return i.path}function p(i,t){const c=t?_:P,d=(0,C.deepClone)(i);return r(d,(s,h)=>{s&&h&&(h.path=c(h))}),d}e.convertToDAPaths=p;function l(i,t){const c=t?_:P,d=(0,C.deepClone)(i);return r(d,(s,h)=>{!s&&h&&(h.path=c(h))}),d}e.convertToVSCPaths=l;function r(i,t){switch(i.type){case"event":const c=i;switch(c.event){case"output":t(!1,c.body.source);break;case"loadedSource":t(!1,c.body.source);break;case"breakpoint":t(!1,c.body.breakpoint.source);break;default:break}break;case"request":const d=i;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(h=>t(!1,h));break;default:break}break;case"response":const s=i;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(h=>t(!1,h.source));break;case"loadedSources":s.body.sources.forEach(h=>t(!1,h));break;case"scopes":s.body.scopes.forEach(h=>t(!1,h.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(h=>t(!1,h.source));break;case"setBreakpoints":s.body.breakpoints.forEach(h=>t(!1,h.source));break;default:break}break}}function g(i){return i.filter(t=>!t.presentation?.hidden).sort((t,c)=>t.presentation?c.presentation?t.presentation.group?c.presentation.group?t.presentation.group!==c.presentation.group?t.presentation.group.localeCompare(c.presentation.group):o(t.presentation.order,c.presentation.order):-1:c.presentation.group?1:o(t.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=g;function o(i,t){return typeof i!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:i-t}async function b(i,t){const c=i.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(c!=="none"&&(await t.saveAll(),c==="allEditorsInActiveGroup")){const d=t.activeEditorPane;d&&await t.save({editor:d.input,groupId:d.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(me[208],ge([0,1,28,37,173,124,9,8,25,11,183,123]),function(Y,e,m,L,D,C,n,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",r=>this.handleData(r))}sendMessage(p){if(this.outputStream){const l=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${a.TWO_CRLF}${l}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+l))}continue}}else{const l=this.rawData.indexOf(a.TWO_CRLF);if(l!==-1){const g=this.rawData.toString("utf8",0,l).split(a.HEADER_LINESEPARATOR);for(const o of g){const b=o.split(a.HEADER_FIELDSEPARATOR);b[0]==="Content-Length"&&(this.contentLength=Number(b[1]))}this.rawData=this.rawData.slice(l+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class w extends a{startSession(){return new Promise((p,l)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",g=>{r?this._onError.fire(g):l(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=w;class f extends w{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=f;class v extends w{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=v;class _ extends a{constructor(p,l,r){super();this.adapterExecutable=p,this.debugType=l,this.outputService=r}async startSession(){const p=this.adapterExecutable.command,l=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(p)if(n.isAbsolute(p)){if(!await m.Promises.exists(p))throw new Error(D.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let g=process.env;if(r.env&&Object.keys(r.env).length>0&&(g=S.mixin(S.deepClone(process.env),r.env)),p==="node")if(Array.isArray(l)&&l.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:g,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(i.cwd=r.cwd);const t=L.fork(l[0],l.slice(1),i);if(!t.pid)throw new Error(D.localize(2,null,l[0]));this.serverProcess=t}else throw new Error(D.localize(3,null));else{const b={env:g};r.cwd&&(b.cwd=r.cwd),this.serverProcess=L.spawn(p,l,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,i)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)});const o=this.outputService;if(o){const b=i=>i.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",i=>{const t=o.getChannel(T.ExtensionsChannelId);t&&t.append(b(i))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((p,l)=>{const r=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,o,b){if(g)return l(g)});r.on("exit",p),r.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,l){if(!p)return;const r=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?r.runtime=n.join(l,p.runtime):r.runtime=p.runtime),p.runtimeArgs&&(r.runtimeArgs=p.runtimeArgs),p.program&&(n.isAbsolute(p.program)?r.program=p.program:r.program=n.join(l,p.program)),p.args&&(r.args=p.args);const g=p;return g.win&&(r.win=_.extract(g.win,l)),g.winx86&&(r.winx86=_.extract(g.winx86,l)),g.windows&&(r.windows=_.extract(g.windows,l)),g.osx&&(r.osx=_.extract(g.osx,l)),g.linux&&(r.linux=_.extract(g.linux,l)),r}static platformAdapterExecutable(p,l){let r=Object.create(null);l=l.toLowerCase();for(const c of p)if(c.contributes){const d=c.contributes.debuggers;d&&d.length>0&&d.filter(s=>typeof s.type=="string"&&k.equalsIgnoreCase(s.type,l)).forEach(s=>{const h=_.extract(s,c.extensionLocation.fsPath);r=S.mixin(r,h,c.isBuiltin)})}let g;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=r.winx86||r.win||r.windows:y.isWindows?g=r.win||r.windows:y.isMacintosh?g=r.osx:y.isLinux&&(g=r.linux),g=g||r;let o=g.program||r.program;const b=g.args||r.args;let i=g.runtime||r.runtime;const t=g.runtimeArgs||r.runtimeArgs;if(i)return{type:"executable",command:i,args:(t||[]).concat(typeof o=="string"?[o]:[]).concat(b||[])};if(o)return{type:"executable",command:o,args:b||[]}}}e.ExecutableDebugAdapter=_}),define(me[209],ge([0,1,37,11,30,185]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function n(a,w){return new Promise((f,v)=>{let _="";const P=m.spawn(a,w);P.pid&&P.stdout.on("data",p=>{_+=p.toString()}),P.on("error",p=>{v(p)}),P.on("close",p=>{f(_)})})}let k;function S(a,w){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const f=w.getConfiguration("terminal");return k.runInTerminal(a.title,a.cwd,a.args,a.env||{},f.external||{})}e.runInExternalTerminal=S;async function y(a){if(a)if(L.isWindows){const w=await new Promise((f,v)=>{Y(["windows-process-tree"],f,v)});return new Promise(f=>{w.getProcessTree(a,v=>{f(v.children.length>0)})})}else return n("/usr/bin/pgrep",["-lP",String(a)]).then(w=>{const f=w.trim();return!(f.length===0||f.indexOf(" tmux")>=0)},w=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var T;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(T||(T={}));function I(a,w,f,v){a=a.trim().toLowerCase();let _;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?_=1:a.indexOf("cmd.exe")>=0?_=0:a.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let P,p=" ";switch(_){case 1:if(P=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),f){const r=(0,D.getDriveLetter)(f);r&&(p+=`${r}:; `),p+=`cd ${P(f)}; `}if(v)for(let r in v){const g=v[r];g===null?p+=`Remove-Item env:${r}; `:p+=`\${env:${r}}='${g}'; `}if(w.length>0){const r=P(w.shift());p+=r[0]==="'"?`& ${r} `:`${r} `;for(let g of w)p+=`${P(g)} `}break;case 0:if(P=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),f){const r=(0,D.getDriveLetter)(f);r&&(p+=`${r}: && `),p+=`cd ${P(f)} && `}if(v){p+='cmd /C "';for(let r in v){let g=v[r];g===null?p+=`set "${r}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,o=>`^${o}`),p+=`set "${r}=${g}" && `)}}for(let r of w)p+=`${P(r)} `;v&&(p+='"');break;case 2:P=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const l=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(f&&(p+=`cd ${P(f)} ; `),v){p+="/usr/bin/env";for(let r in v){const g=v[r];g===null?p+=` -u ${l(r)}`:p+=` ${l(`${r}=${g}`)}`}p+=" "}for(let r of w)p+=`${P(r)} `;break}return p}e.prepareCommand=I}),define(me[125],ge([0,1,31,76,102,10,9,11,61]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var a;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(a=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(_=e.CellEditType||(e.CellEditType={}));var P;(function(E){E.scheme=C.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function R(W,U){return W.with({scheme:E.scheme,fragment:`ch${U.toString().padStart(7,"0")}${W.scheme!==C.Schemas.file?W.scheme:""}`})}E.generate=R;function $(W){if(W.scheme!==E.scheme)return;const U=A.exec(W.fragment);return U?{handle:Number(U[1]),notebook:W.with({scheme:W.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parse=$;function N(W,U,x){return W.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${U.toString().padStart(7,"0")},${x??""},${W.scheme!==C.Schemas.file?W.scheme:""}`})}E.generateCellOutputUri=N;function F(W){if(W.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const U=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!U)return;const x=Number(U[1]),B=U[2]&&U[2]!==""?U[2]:void 0,O=U[3];return{handle:x,outputId:B,notebook:W.with({scheme:O||C.Schemas.file,fragment:null})}}E.parseCellOutputUri=F;function z(W,U,x){return W.with({scheme:x,fragment:`ch${U.toString().padStart(7,"0")}${W.scheme!==C.Schemas.file?W.scheme:""}`})}E.generateCellUri=z;function M(W,U){if(W.scheme!==U)return;const x=A.exec(W.fragment);return x?{handle:Number(x[1]),notebook:W.with({scheme:W.fragment.substr(x[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parseCellUri=M})(P=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function l(E){return p.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=l;function r(E){return p.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function g(E){return p.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=g;const o=E=>k.isWindows?E.replace(/\//g,"\\"):E;class b{constructor(A=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(A)].map($=>({pattern:$,matches:m.parse(o($))}))}sort(A){const R=new Map(L.Iterable.map(A,N=>[N,o(N)]));let $=[];for(const{matches:N}of this.order)for(const[F,z]of R)if(N(z)){$.push(F),R.delete(F);break}return R.size&&($=$.concat([...R.keys()].sort((N,F)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(F)))),$}prioritize(A,R){const $=this.findIndex(A);if($===-1){this.order.unshift({pattern:A,matches:m.parse(o(A))});return}const N=new Set(R.map(z=>this.findIndex(z,$)));N.delete(-1);const F=Array.from(N).sort();this.order.splice($+1,0,...F.map(z=>this.order[z]));for(let z=F.length-1;z>=0;z--)this.order.splice(F[z],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,R=this.order.length){const $=o(A);for(let N=0;N<R;N++)if(this.order[N].matches($))return N;return-1}}e.MimeTypeDisplayOrder=b;function i(E,A,R,$=(N,F)=>N===F){const N=[];function F(W,U,x){if(U===0&&x.length===0)return;const B=N[N.length-1];B&&B.start+B.deleteCount===W?(B.deleteCount+=U,B.toInsert.push(...x)):N.push({start:W,deleteCount:U,toInsert:x})}let z=0,M=0;for(;;){if(z===E.length){F(z,0,A.slice(M));break}if(M===A.length){F(z,E.length-z,[]);break}const W=E[z],U=A[M];if($(W,U)){z+=1,M+=1;continue}R(U)?(F(z,1,[]),z+=1):(F(z,0,[U]),M+=1)}return N}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(E){E.default="default",E.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(E){const A=E;return!!((typeof A.include=="string"||m.isRelativePattern(A.include))&&(typeof A.exclude=="string"||m.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=c;function d(E,A,R){if(Array.isArray(E.viewType)&&E.viewType.indexOf(A)>=0||E.viewType===A)return!0;if(E.filenamePattern){let $=c(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,N=c(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(m.match($,(0,n.basename)(R.fsPath).toLowerCase()))return!(N&&m.match(N,(0,n.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class s{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)A[R]=this.textModel.cells[R].getHashValue();return A}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var h;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(A){return`${u._prefix}${A}`}static parse(A){if(A.startsWith(u._prefix))return A.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(me[210],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(me[211],ge([0,1,4,61]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(me[212],ge([0,1,175,4,61]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[213],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=m;function L(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=L}),define(me[126],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const n=(I,a)=>{a.expand!==void 0&&(I.expand=a.expand),a.item!==void 0&&(I.item=I.item?Object.assign(I.item,a.item):a.item)};e.applyTestItemUpdate=n;var k;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var S;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class y{add(a){}update(a){}remove(a,w){}complete(){}}e.IncrementalChangeCollector=y;class T{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const w=this.createChangeCollector();for(const f of a)switch(f[0]){case 0:{const v=f[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const P=this.createItem(v,_);this.items.set(v.item.extId,P),w.add(P)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),w.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=f[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),w.update(_);break}case 2:{const v=this.items.get(f[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[f[1]]];for(;_.length;)for(const P of _.pop()){const p=this.items.get(P);p&&(_.push(p.children),this.items.delete(P),w.remove(p,p!==v),p.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f[1]);break;case 3:this.updatePendingRoots(f[1]);break;case 5:this._tags.set(f[1].id,f[1]);break;case 6:this._tags.delete(f[1]);break}w.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=T}),define(me[90],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class D{constructor(n,k=n.length){if(this.path=n,this.viewEnd=k,n.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(n,k,S=n.parent){if(n.id===k)return new D([k]);let y=[n.id];for(let T=S;T&&T.id!==k;T=T.parent)y.push(T.id);return y.push(k),new D(y.reverse())}static isRoot(n){return!n.includes("\0")}static fromString(n){return new D(n.split("\0"))}static join(n,k){return new D([...n.path,k])}static joinToString(n,k){return n.toString()+"\0"+k}static compare(n,k){return n===k?0:k.startsWith(n+"\0")?2:n.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let n=1;n<=this.viewEnd;n++)yield new D(this.path,n)}compare(n){if(typeof n=="string")return D.compare(this.toString(),n);for(let k=0;k<n.viewEnd&&k<this.viewEnd;k++)if(n.path[k]!==this.path[k])return 1;return n.viewEnd>this.viewEnd?2:n.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let n=1;n<this.viewEnd;n++)this.stringifed+="\0",this.stringifed+=this.path[n]}return this.stringifed}}e.TestId=D}),define(me[214],ge([0,1,9,40,13,25,11,80,176]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(I,a,w){this._contributedVariables=new Map,this._context=I,this._labelService=a,w&&(this._envVariablesPromise=w.then(f=>this.prepareEnv(f)))}prepareEnv(I){if(n.isWindows){const a=Object.create(null);return Object.keys(I).forEach(w=>{a[w.toLowerCase()]=I[w]}),a}return I}resolveWithEnvironment(I,a,w){return this.recursiveResolve(this.prepareEnv(I),a?a.uri:void 0,w)}async resolveAsync(I,a){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a)}async resolveAnyBase(I,a,w,f){const v=C.deepClone(a);return n.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):n.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):n.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,v,w,f)}async resolveAnyAsync(I,a,w){return this.resolveAnyBase(I,a,w)}async resolveAnyMap(I,a,w){const f=new Map;return{newConfig:await this.resolveAnyBase(I,a,w,f),resolvedVariables:f}}resolveWithInteractionReplace(I,a,w,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,a,w,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,a){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,a)}recursiveResolve(I,a,w,f,v){if(D.isString(w))return this.resolveString(I,a,w,f,v);if(D.isArray(w))return w.map(_=>this.recursiveResolve(I,a,_,f,v));if(D.isObject(w)){let _=Object.create(null);return Object.keys(w).forEach(P=>{const p=this.resolveString(I,a,P,f,v);_[p]=this.recursiveResolve(I,a,w[P],f,v)}),_}return w}resolveString(I,a,w,f,v){return w.replace(y.VARIABLE_REGEXP,(P,p)=>{if(p.includes(y.VARIABLE_LHS))return P;let l=this.evaluateSingleVariable(I,P,p,a,f);return v&&v.set(p,l),l!==P&&D.isString(l)&&l.match(y.VARIABLE_REGEXP)&&(l=this.resolveString(I,a,l,f,v)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,a,w,f,v){let _;const P=w.split(":");P.length>1&&(w=P[0],_=P[1]);const p=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,S.localize)(0,null,a))},l=()=>{const g=p();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,S.localize)(1,null,a,m.basename(g)))},r=()=>{if(_){const g=this._context.getFolderUri(_);if(g)return g;throw new Error((0,S.localize)(2,null,a,_))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,a)):new Error((0,S.localize)(4,null,a))};switch(w){case"env":if(_){if(I){const g=I[n.isWindows?_.toLowerCase():_];if(D.isString(g))return g}return""}throw new Error((0,S.localize)(5,null,a));case"config":if(_){const g=this._context.getConfigurationValue(f,_);if(D.isUndefinedOrNull(g))throw new Error((0,S.localize)(6,null,a,_));if(D.isObject(g))throw new Error((0,S.localize)(7,null,a,_));return g}throw new Error((0,S.localize)(8,null,a));case"command":return this.resolveFromMap(a,_,v,"command");case"input":return this.resolveFromMap(a,_,v,"input");default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return f||_?(0,k.normalizeDriveLetter)(this.fsPath(r())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(r()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,S.localize)(9,null,a));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,S.localize)(10,null,a));case"file":return p();case"fileWorkspaceFolder":return l();case"relativeFile":return f||_?m.relative(this.fsPath(r()),p()):p();case"relativeFileDirname":const b=m.dirname(p());if(f||_){const d=m.relative(this.fsPath(r()),b);return d.length===0?".":d}return b;case"fileDirname":return m.dirname(p());case"fileExtname":return m.extname(p());case"fileBasename":return m.basename(p());case"fileBasenameNoExtension":const i=m.basename(p());return i.slice(0,i.length-m.extname(i).length);case"fileDirnameBasename":return m.basename(m.dirname(p()));case"execPath":const t=this._context.getExecPath();return t||a;case"execInstallFolder":const c=this._context.getAppRoot();return c||a;case"pathSeparator":return m.sep;default:try{const d=_?`${w}:${_}`:w;return this.resolveFromMap(a,d,v,void 0)}catch(d){return a}}}}resolveFromMap(I,a,w,f){if(a&&w){const v=f===void 0?w[a]:w[f+":"+a];if(typeof v=="string")return v;throw new Error((0,S.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[127],ge([0,1,4,206]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var D;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var C;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var n;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(n=e.GroupLocation||(e.GroupLocation={}));var k;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function y(v){const _=v;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=y;var T;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function w(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=w;function f(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(me[215],ge([0,1,4,127]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(C){const n=C;return typeof C=="number"||(0,L.isEditorGroup)(n)}e.isPreferredGroup=D}),define(me[16],ge([0,1,17,22,98,290,59,25,13,2,41,84,177,116,63,125,90,215,7]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(le){function _e(Q){const{selectionStartLineNumber:ye,selectionStartColumn:Le,positionLineNumber:et,positionColumn:qe}=Q,mt=new p.Position(ye-1,Le-1),_t=new p.Position(et-1,qe-1);return new p.Selection(mt,_t)}le.to=_e;function ae(Q){const{anchor:ye,active:Le}=Q;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}le.from=ae})(l=e.Selection||(e.Selection={}));var r;(function(le){function _e(Q){if(!Q)return;const{start:ye,end:Le}=Q;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}le.from=_e;function ae(Q){if(!Q)return;const{startLineNumber:ye,startColumn:Le,endLineNumber:et,endColumn:qe}=Q;return new p.Range(ye-1,Le-1,et-1,qe-1)}le.to=ae})(r=e.Range||(e.Range={}));var g;(function(le){function _e(ae){switch(ae){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 4:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}le.to=_e})(g=e.TokenType||(e.TokenType={}));var o;(function(le){function _e(Q){return new p.Position(Q.lineNumber-1,Q.column-1)}le.to=_e;function ae(Q){return{lineNumber:Q.line+1,column:Q.character+1}}le.from=ae})(o=e.Position||(e.Position={}));var b;(function(le){function _e(ye,Le){return(0,m.coalesce)((0,m.asArray)(ye).map(et=>ae(et,Le)))}le.from=_e;function ae(ye,Le){if(typeof ye=="string")return{$serialized:!0,language:ye};if(ye)return{$serialized:!0,language:ye.language,scheme:Q(ye.scheme,Le),pattern:typeof ye.pattern=="undefined"?void 0:Ge.from(ye.pattern),exclusive:ye.exclusive}}function Q(ye,Le){return Le&&typeof ye=="string"?Le.transformOutgoingScheme(ye):ye}})(b=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(le){function _e(Q){switch(Q){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}le.from=_e;function ae(Q){switch(Q){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}le.to=ae})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(le){function _e(Q){let ye;return Q.code&&((0,S.isString)(Q.code)||(0,S.isNumber)(Q.code)?ye=String(Q.code):ye={value:String(Q.code.value),target:Q.code.target}),{...r.from(Q.range),message:Q.message,source:Q.source,code:ye,severity:d.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(c.from),tags:Array.isArray(Q.tags)?(0,m.coalesce)(Q.tags.map(i.from)):void 0}}le.from=_e;function ae(Q){const ye=new p.Diagnostic(r.to(Q),Q.message,d.to(Q.severity));return ye.source=Q.source,ye.code=(0,S.isString)(Q.code)?Q.code:Q.code?.value,ye.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(c.to),ye.tags=Q.tags&&(0,m.coalesce)(Q.tags.map(i.to)),ye}le.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var c;(function(le){function _e(Q){return{...r.from(Q.location.range),message:Q.message,resource:Q.location.uri}}le.from=_e;function ae(Q){return new p.DiagnosticRelatedInformation(new p.Location(Q.resource,r.to(Q)),Q.message)}le.to=ae})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(le){function _e(Q){switch(Q){case p.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}le.from=_e;function ae(Q){switch(Q){case w.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}le.to=ae})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(le){function _e(Q){return typeof Q=="number"&&Q>=p.ViewColumn.One?Q-1:Q===p.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}le.from=_e;function ae(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function h(le){return typeof le.range!="undefined"}function u(le){return le.length===0?!0:!!h(le[0])}e.isDecorationOptionsArr=u;var E;(function(le){function _e(qe){return qe.map(le.from)}le.fromMany=_e;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let mt;if(ae(qe)){const{language:gt,value:Et}=qe;mt={value:"```"+gt+`
`+Et+"\n```\n"}}else p.MarkdownString.isMarkdownString(qe)?mt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?mt={value:qe}:mt={value:""};const _t=Object.create(null);mt.uris=_t;const kt=gt=>{try{let Et=y.URI.parse(gt,!0);Et=Et.with({query:ye(Et.query,_t)}),_t[gt]=Et}catch(Et){}return""},bt=new C.Renderer;return bt.link=kt,bt.image=gt=>kt(D.parseHrefAndDimensions(gt).href),C(mt.value,{renderer:bt}),mt}le.from=Q;function ye(qe,mt){if(!qe)return qe;let _t;try{_t=(0,n.parse)(qe)}catch(bt){}if(!_t)return qe;let kt=!1;return _t=(0,k.cloneAndChange)(_t,bt=>{if(y.URI.isUri(bt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[gt]=bt,kt=!0,gt}else return}),kt?JSON.stringify(_t):qe}function Le(qe){const mt=new p.MarkdownString(qe.value,qe.supportThemeIcons);return mt.isTrusted=qe.isTrusted,mt.supportHtml=qe.supportHtml,mt}le.to=Le;function et(qe){if(!!qe)return typeof qe=="string"?qe:le.from(qe)}le.fromStrict=et})(E=e.MarkdownString||(e.MarkdownString={}));function A(le){return u(le)?le.map(_e=>({range:r.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?E.fromMany(_e.hoverMessage):_e.hoverMessage?E.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):le.map(_e=>({range:r.from(_e)}))}e.fromRangeOrRangeWithMessage=A;function R(le){return typeof le=="undefined"?le:typeof le=="string"?y.URI.file(le):le}e.pathOrURIToURI=R;var $;(function(le){function _e(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?R(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}le.from=_e})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(le){function _e(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?$.from(ae.before):void 0,after:ae.after?$.from(ae.after):void 0}}le.from=_e})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(le){function _e(ae){if(typeof ae=="undefined")return ae;switch(ae){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=_e})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(le){function _e(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?F.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?N.from(ae.light):void 0,dark:ae.dark?N.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?$.from(ae.before):void 0,after:ae.after?$.from(ae.after):void 0}}le.from=_e})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(le){function _e(Q){return{text:Q.newText,eol:Q.newEol&&Ae.from(Q.newEol),range:r.from(Q.range)}}le.from=_e;function ae(Q){const ye=new p.TextEdit(r.to(Q.range),Q.text);return ye.newEol=typeof Q.eol=="undefined"?void 0:Ae.to(Q.eol),ye}le.to=ae})(M=e.TextEdit||(e.TextEdit={}));var W;(function(le){function _e(Q,ye,Le){const et={edits:[]};if(Q instanceof p.WorkspaceEdit)for(let qe of Q._allEntries())if(qe._type===1)et.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const mt=ye?.getDocument(qe.uri);et.edits.push({_type:2,resource:qe.uri,edit:M.from(qe.edit),modelVersionId:mt?.version,metadata:qe.metadata})}else qe._type===3?et.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&et.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map($e.from)}});return et}le.from=_e;function ae(Q){const ye=new p.WorkspaceEdit;for(const Le of Q.edits)Le.edit?ye.replace(y.URI.revive(Le.resource),r.to(Le.edit.range),Le.edit.text):ye.renameFile(y.URI.revive(Le.oldUri),y.URI.revive(Le.newUri),Le.options);return ye}le.to=ae})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(le){const _e=Object.create(null);_e[p.SymbolKind.File]=0,_e[p.SymbolKind.Module]=1,_e[p.SymbolKind.Namespace]=2,_e[p.SymbolKind.Package]=3,_e[p.SymbolKind.Class]=4,_e[p.SymbolKind.Method]=5,_e[p.SymbolKind.Property]=6,_e[p.SymbolKind.Field]=7,_e[p.SymbolKind.Constructor]=8,_e[p.SymbolKind.Enum]=9,_e[p.SymbolKind.Interface]=10,_e[p.SymbolKind.Function]=11,_e[p.SymbolKind.Variable]=12,_e[p.SymbolKind.Constant]=13,_e[p.SymbolKind.String]=14,_e[p.SymbolKind.Number]=15,_e[p.SymbolKind.Boolean]=16,_e[p.SymbolKind.Array]=17,_e[p.SymbolKind.Object]=18,_e[p.SymbolKind.Key]=19,_e[p.SymbolKind.Null]=20,_e[p.SymbolKind.EnumMember]=21,_e[p.SymbolKind.Struct]=22,_e[p.SymbolKind.Event]=23,_e[p.SymbolKind.Operator]=24,_e[p.SymbolKind.TypeParameter]=25;function ae(ye){return typeof _e[ye]=="number"?_e[ye]:6}le.from=ae;function Q(ye){for(const Le in _e)if(_e[Le]===ye)return Number(Le);return p.SymbolKind.Property}le.to=Q})(U=e.SymbolKind||(e.SymbolKind={}));var x;(function(le){function _e(Q){switch(Q){case p.SymbolTag.Deprecated:return 1}}le.from=_e;function ae(Q){switch(Q){case 1:return p.SymbolTag.Deprecated}}le.to=ae})(x=e.SymbolTag||(e.SymbolTag={}));var B;(function(le){function _e(Q){return{name:Q.name,kind:U.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:K.from(Q.location)}}le.from=_e;function ae(Q){const ye=new p.SymbolInformation(Q.name,U.to(Q.kind),Q.containerName,K.to(Q.location));return ye.tags=Q.tags&&Q.tags.map(x.to),ye}le.to=ae})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(le){function _e(Q){const ye={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:r.from(Q.range),selectionRange:r.from(Q.selectionRange),kind:U.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(ye.children=Q.children.map(_e)),ye}le.from=_e;function ae(Q){const ye=new p.DocumentSymbol(Q.name,Q.detail,U.to(Q.kind),r.to(Q.range),r.to(Q.selectionRange));return(0,m.isNonEmptyArray)(Q.tags)&&(ye.tags=Q.tags.map(x.to)),Q.children&&(ye.children=Q.children.map(ae)),ye}le.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(le){function _e(Q){const ye=new p.CallHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),r.to(Q.range),r.to(Q.selectionRange));return ye._sessionId=Q._sessionId,ye._itemId=Q._itemId,ye}le.to=_e;function ae(Q,ye,Le){if(ye=ye??Q._sessionId,Le=Le??Q._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,name:Q.name,detail:Q.detail,kind:U.from(Q.kind),uri:Q.uri,range:r.from(Q.range),selectionRange:r.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}le.from=ae})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(le){function _e(ae){return new p.CallHierarchyIncomingCall(H.to(ae.from),ae.fromRanges.map(Q=>r.to(Q)))}le.to=_e})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(le){function _e(ae){return new p.CallHierarchyOutgoingCall(H.to(ae.to),ae.fromRanges.map(Q=>r.to(Q)))}le.to=_e})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(le){function _e(Q){return{range:Q.range&&r.from(Q.range),uri:Q.uri}}le.from=_e;function ae(Q){return new p.Location(y.URI.revive(Q.uri),r.to(Q.range))}le.to=ae})(K=e.location||(e.location={}));var he;(function(le){function _e(Q){const ye=Q,Le=Q;return{originSelectionRange:ye.originSelectionRange?r.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Le.uri,range:r.from(ye.targetRange?ye.targetRange:Le.range),targetSelectionRange:ye.targetSelectionRange?r.from(ye.targetSelectionRange):void 0}}le.from=_e;function ae(Q){return{targetUri:y.URI.revive(Q.uri),targetRange:r.to(Q.range),targetSelectionRange:Q.targetSelectionRange?r.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?r.to(Q.originSelectionRange):void 0}}le.to=ae})(he=e.DefinitionLink||(e.DefinitionLink={}));var Ee;(function(le){function _e(Q){return{range:r.from(Q.range),contents:E.fromMany(Q.contents)}}le.from=_e;function ae(Q){return new p.Hover(Q.contents.map(E.to),r.to(Q.range))}le.to=ae})(Ee=e.Hover||(e.Hover={}));var De;(function(le){function _e(Q){return{range:r.from(Q.range),expression:Q.expression}}le.from=_e;function ae(Q){return new p.EvaluatableExpression(r.to(Q.range),Q.expression)}le.to=ae})(De=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(le){function _e(Q){if(Q instanceof p.InlineValueText)return{type:"text",range:r.from(Q.range),text:Q.text};if(Q instanceof p.InlineValueVariableLookup)return{type:"variable",range:r.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof p.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}le.from=_e;function ae(Q){switch(Q.type){case"text":return{range:r.to(Q.range),text:Q.text};case"variable":return{range:r.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:r.to(Q.range),expression:Q.expression}}}le.to=ae})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(le){function _e(Q){return{frameId:Q.frameId,stoppedLocation:r.from(Q.stoppedLocation)}}le.from=_e;function ae(Q){return new p.InlineValueContext(Q.frameId,r.to(Q.stoppedLocation))}le.to=ae})(Be=e.InlineValueContext||(e.InlineValueContext={}));var He;(function(le){function _e(Q){return{range:r.from(Q.range),kind:Q.kind}}le.from=_e;function ae(Q){return new p.DocumentHighlight(r.to(Q.range),Q.kind)}le.to=ae})(He=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(le){function _e(ae){switch(ae){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}le.to=_e})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(le){function _e(ae){return{triggerKind:ze.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}le.to=_e})(G=e.CompletionContext||(e.CompletionContext={}));var Z;(function(le){function _e(Q){switch(Q){case p.CompletionItemTag.Deprecated:return 1}}le.from=_e;function ae(Q){switch(Q){case 1:return p.CompletionItemTag.Deprecated}}le.to=ae})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(le){const _e=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ae(Le){return _e.get(Le)??9}le.from=ae;const Q=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function ye(Le){return Q.get(Le)??p.CompletionItemKind.Property}le.to=ye})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(le){function _e(ae,Q){const ye=new p.CompletionItem(ae.label);return ye.insertText=ae.insertText,ye.kind=ne.to(ae.kind),ye.tags=ae.tags?.map(Z.to),ye.detail=ae.detail,ye.documentation=D.isMarkdownString(ae.documentation)?E.to(ae.documentation):ae.documentation,ye.sortText=ae.sortText,ye.filterText=ae.filterText,ye.preselect=ae.preselect,ye.commitCharacters=ae.commitCharacters,T.Range.isIRange(ae.range)?ye.range=r.to(ae.range):typeof ae.range=="object"&&(ye.range={inserting:r.to(ae.range.insert),replacing:r.to(ae.range.replace)}),ye.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?ye.insertText=new p.SnippetString(ae.insertText):(ye.insertText=ae.insertText,ye.textEdit=ye.range instanceof p.Range?new p.TextEdit(ye.range,ye.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ye.additionalTextEdits=ae.additionalTextEdits.map(Le=>M.to(Le))),ye.command=Q&&ae.command?Q.fromInternal(ae.command):void 0,ye}le.to=_e})(ce=e.CompletionItem||(e.CompletionItem={}));var J;(function(le){function _e(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0}}le.from=_e;function ae(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation}}le.to=ae})(J=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(le){function _e(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(J.from):[],activeParameter:Q.activeParameter}}le.from=_e;function ae(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(J.to):[],activeParameter:Q.activeParameter}}le.to=ae})(te=e.SignatureInformation||(e.SignatureInformation={}));var ve;(function(le){function _e(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(te.from):[]}}le.from=_e;function ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(te.to):[]}}le.to=ae})(ve=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(le){function _e(Q){return{text:Q.text,position:o.from(Q.position),kind:je.from(Q.kind??p.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}le.from=_e;function ae(Q){const ye=new p.InlayHint(Q.text,o.to(Q.position),je.to(Q.kind));return ye.whitespaceAfter=Q.whitespaceAfter,ye.whitespaceBefore=Q.whitespaceBefore,ye}le.to=ae})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(le){function _e(Q){return Q}le.from=_e;function ae(Q){return Q}le.to=ae})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(le){function _e(Q){return{range:r.from(Q.range),url:Q.target,tooltip:Q.tooltip}}le.from=_e;function ae(Q){let ye;if(Q.url)try{ye=typeof Q.url=="string"?y.URI.parse(Q.url,!0):y.URI.revive(Q.url)}catch(Le){}return new p.DocumentLink(r.to(Q.range),ye)}le.to=ae})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(le){function _e(Q){const ye=new p.ColorPresentation(Q.label);return Q.textEdit&&(ye.textEdit=M.to(Q.textEdit)),Q.additionalTextEdits&&(ye.additionalTextEdits=Q.additionalTextEdits.map(Le=>M.to(Le))),ye}le.to=_e;function ae(Q){return{label:Q.label,textEdit:Q.textEdit?M.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(ye=>M.from(ye)):void 0}}le.from=ae})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(le){function _e(Q){return new p.Color(Q[0],Q[1],Q[2],Q[3])}le.to=_e;function ae(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}le.from=ae})(rt=e.Color||(e.Color={}));var ut;(function(le){function _e(Q){return{range:r.from(Q.range)}}le.from=_e;function ae(Q){return new p.SelectionRange(r.to(Q.range))}le.to=ae})(ut=e.SelectionRange||(e.SelectionRange={}));var it;(function(le){function _e(ae){switch(ae){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}le.to=_e})(it=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var st;(function(le){function _e(Q){switch(Q){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.On:default:return 1}}le.from=_e;function ae(Q){switch(Q){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 1:default:return p.TextEditorLineNumbersStyle.On}}le.to=ae})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(le){function _e(Q){if(Q===p.EndOfLine.CRLF)return 1;if(Q===p.EndOfLine.LF)return 0}le.from=_e;function ae(Q){if(Q===1)return p.EndOfLine.CRLF;if(Q===0)return p.EndOfLine.LF}le.to=ae})(Ae=e.EndOfLine||(e.EndOfLine={}));var wt;(function(le){function _e(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=_e})(wt=e.ProgressLocation||(e.ProgressLocation={}));var ee;(function(le){function _e(ae){const Q={start:ae.start+1,end:ae.end+1};return ae.kind&&(Q.kind=re.from(ae.kind)),Q}le.from=_e})(ee=e.FoldingRange||(e.FoldingRange={}));var re;(function(le){function _e(ae){if(ae)switch(ae){case p.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}le.from=_e})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Se;(function(le){function _e(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?r.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.EditorResolution.DISABLED:void 0}}le.from=_e})(Se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ge;(function(le){function _e(Q){return Q instanceof p.RelativePattern||typeof Q=="string"?Q:ae(Q)?new p.RelativePattern(Q.base,Q.pattern):Q}le.from=_e;function ae(Q){const ye=Q;return ye&&typeof ye.base=="string"&&typeof ye.pattern=="string"}})(Ge=e.GlobPattern||(e.GlobPattern={}));var Ye;(function(le){function _e(ae){if(ae){if(Array.isArray(ae))return ae.map(_e);if(typeof ae=="string")return ae;{const Q=ae;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:Ge.from(Q.pattern),exclusive:Q.exclusive}}}else return}le.from=_e})(Ye=e.LanguageSelector||(e.LanguageSelector={}));var nt;(function(le){function _e(Q){return{start:Q.start,end:Q.end}}le.from=_e;function ae(Q){return new p.NotebookRange(Q.start,Q.end)}le.to=ae})(nt=e.NotebookRange||(e.NotebookRange={}));var de;(function(le){function _e(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}le.to=_e;function ae(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}le.from=ae})(de=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ke;(function(le){function _e(Q){switch(Q){case p.NotebookCellKind.Markup:return v.CellKind.Markup;case p.NotebookCellKind.Code:default:return v.CellKind.Code}}le.from=_e;function ae(Q){switch(Q){case v.CellKind.Markup:return p.NotebookCellKind.Markup;case v.CellKind.Code:default:return p.NotebookCellKind.Code}}le.to=ae})(ke=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(le){function _e(Q){const ye={metadata:Q.metadata??Object.create(null),cells:[]};for(let Le of Q.cells)p.NotebookCellData.validate(Le),ye.cells.push($e.from(Le));return ye}le.from=_e;function ae(Q){const ye=new p.NotebookData(Q.cells.map($e.to));return(0,S.isEmptyObject)(Q.metadata)||(ye.metadata=Q.metadata),ye}le.to=ae})(Ue=e.NotebookData||(e.NotebookData={}));var $e;(function(le){function _e(Q){return{cellKind:ke.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:de.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Te.from):[]}}le.from=_e;function ae(Q){return new p.NotebookCellData(ke.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Te.to):void 0,Q.metadata,Q.internalMetadata?de.to(Q.internalMetadata):void 0)}le.to=ae})($e=e.NotebookCellData||(e.NotebookCellData={}));var tt;(function(le){function _e(Q){return{mime:Q.mime,valueBytes:L.VSBuffer.wrap(Q.data)}}le.from=_e;function ae(Q){return new p.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}le.to=ae})(tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(le){function _e(Q){return{outputId:Q.id,items:Q.items.map(tt.from),metadata:Q.metadata}}le.from=_e;function ae(Q){const ye=Q.items.map(tt.to);return new p.NotebookCellOutput(ye,Q.outputId,Q.metadata)}le.to=ae})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(le){function _e(Le){if(Le!=null){if(Le instanceof p.RelativePattern||typeof Le=="string")return Le;if(ye(Le))return new p.RelativePattern(Le.base,Le.pattern);if(Q(Le))return{include:Ge.from(Le.include)||void 0,exclude:Ge.from(Le.exclude)||void 0}}}le.from=_e;function ae(Le){return typeof Le=="string"?Le:ye(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}le.to=ae;function Q(Le){const et=Le,qe=Ge.from(et.include);if(!(qe&&qe instanceof p.RelativePattern||typeof qe=="string"))return!1;const mt=Ge.from(et.exclude);return!!(mt&&mt instanceof p.RelativePattern||typeof mt=="string")}function ye(Le){const et=Le;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var we;(function(le){function _e(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?$.from(ae.top):void 0}}le.from=_e})(we=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(le){function _e(ae,Q,ye){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Le,ye),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}le.from=_e})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(le){function _e(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}le.from=_e})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var pe;(function(le){function _e(Q){return{uri:Q.uri,provides:Q.provides}}le.from=_e;function ae(Q){return new p.NotebookRendererScript(y.URI.revive(Q.uri),Q.provides)}le.to=ae})(pe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(le){function _e(Q){return{message:E.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?K.from(Q.location):void 0}}le.from=_e;function ae(Q){const ye=new p.TestMessage(typeof Q.message=="string"?Q.message:E.to(Q.message));return ye.actualOutput=Q.actual,ye.expectedOutput=Q.expected,ye.location=Q.location?K.to(Q.location):void 0,ye}le.to=ae})(be=e.TestMessage||(e.TestMessage={}));var Fe;(function(le){let _e;(function(ae){ae.Delimiter="\0"})(_e||(_e={})),le.namespace=(ae,Q)=>ae+"\0"+Q,le.denamespace=ae=>{const Q=ae.indexOf("\0");return{ctrlId:ae.slice(0,Q),tagId:ae.slice(Q+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Qe;(function(le){function _e(Le){const et=(0,f.getPrivateApiFor)(Le).controllerId;return{extId:_.TestId.fromExtHostTestItem(Le,et).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Fe.namespace(et,qe.id)),range:r.from(Le.range)||null,description:Le.description||null,error:Le.error&&E.fromStrict(Le.error)||null}}le.from=_e;function ae(Le){return{parent:void 0,error:void 0,id:_.TestId.fromString(Le.extId).localId,label:Le.label,uri:y.URI.revive(Le.uri),tags:(Le.tags||[]).map(et=>{const{tagId:qe}=Fe.denamespace(et);return new p.TestTag(qe)}),range:r.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}le.toPlain=ae;function Q(Le){const et=_.TestId.fromString(Le.extId),qe=new f.TestItemImpl(et.controllerId,et.localId,Le.label,y.URI.revive(Le.uri));return qe.range=r.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function ye(Le){let et;for(const qe of Le.tests){const mt=Q(qe.item);(0,f.getPrivateApiFor)(mt).parent=et,et=mt}return et}le.toItemFromContext=ye})(Qe=e.TestItem||(e.TestItem={})),function(le){function _e(Q){return{id:Q.id}}le.from=_e;function ae(Q){return new p.TestTag(Q.id)}le.to=ae}(Fe=e.TestTag||(e.TestTag={}));var xe;(function(le){const _e=(Q,ye)=>{const Le={...Qe.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(et=>({state:et.state,duration:et.duration,messages:et.messages.filter(qe=>qe.type===0).map(be.to)})),children:Q.children.map(et=>ye.get(et)).filter(S.isDefined).map(et=>_e(et,ye))};for(const et of Le.children)et.parent=Le;return Le};function ae(Q){const ye=[],Le=new Map;for(const et of Q.items)Le.set(et.item.extId,et),Q.request.targets.some(qe=>qe.controllerId===et.controllerId&&qe.testIds.includes(et.item.extId))&&ye.push(et);return{completedAt:Q.completedAt,results:ye.map(et=>_e(et,Le))}}le.to=ae})(xe=e.TestResults||(e.TestResults={}));var Xe;(function(le){function _e(Le){return{covered:Le.covered,total:Le.covered}}function ae(Le){return"line"in Le?o.from(Le):r.from(Le)}function Q(Le){return"branches"in Le?{count:Le.executionCount,location:ae(Le.location),type:1,branches:Le.branches.length?Le.branches.map(et=>({count:et.executionCount,location:et.location&&ae(et.location)})):void 0}:{type:0,count:Le.executionCount,location:ae(Le.location)}}le.fromDetailed=Q;function ye(Le){return{uri:Le.uri,statement:_e(Le.statementCoverage),branch:Le.branchCoverage&&_e(Le.branchCoverage),function:Le.functionCoverage&&_e(Le.functionCoverage),details:Le.detailedCoverage?.map(Q)}}le.fromFile=ye})(Xe=e.TestCoverage||(e.TestCoverage={}));var at;(function(le){function _e(ae){switch(ae){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}le.to=_e})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ct;(function(le){function _e(Q){const ye=new p.TypeHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",y.URI.revive(Q.uri),r.to(Q.range),r.to(Q.selectionRange));return ye._sessionId=Q._sessionId,ye._itemId=Q._itemId,ye}le.to=_e;function ae(Q,ye,Le){if(ye=ye??Q._sessionId,Le=Le??Q._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,kind:U.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:r.from(Q.range),selectionRange:r.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}le.from=ae})(ct=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[216],ge([0,1,2,15,7,16,94]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(y,T,I,a={timeout:1500,errors:3}){this._logService=y,this._documents=T,this._mainThreadBulkEdits=I,this._thresholds=a,this._callbacks=new n.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(y){return(T,I,a)=>{const f={dispose:this._callbacks.push([T,I,y])};return Array.isArray(a)&&a.push(f),f}}async $participateInSave(y,T){const I=m.URI.revive(y);let a=!1;const w=setTimeout(()=>a=!0,this._thresholds.timeout),f=[];try{for(let v of[...this._callbacks]){if(a)break;const _=this._documents.getDocument(I),P=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:C.TextDocumentSaveReason.to(T)});f.push(P)}}finally{clearTimeout(w)}return f}_deliverEventAsyncAndBlameBadListeners([y,T,I],a){const w=this._badListeners.get(y);return typeof w=="number"&&w>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,y,T,a).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const v=this._badListeners.get(y);this._badListeners.set(y,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(y,T,I,a){const w=[],f=Date.now(),{document:v,reason:_}=a,{version:P}=v,p=Object.freeze({document:v,reason:_,waitUntil(l){if(Object.isFrozen(w))throw(0,L.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(l))}});try{T.apply(I,[p])}catch(l){return Promise.reject(l)}return Object.freeze(w),new Promise((l,r)=>{const g=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(w).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(g),l(o)}).catch(o=>{clearTimeout(g),r(o)})}).then(l=>{const r={edits:[]};for(const g of l)if(Array.isArray(g)&&g.every(o=>o instanceof D.TextEdit))for(const{newText:o,newEol:b,range:i}of g)r.edits.push({_type:2,resource:v.uri,edit:{range:i&&C.Range.from(i),text:o,eol:b&&C.EndOfLine.from(b)}});if(r.edits.length!==0)return P===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(me[217],ge([0,1,3,31,2,16,7]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(T,I,a,w,f){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,a&&(this._config+=1),w&&(this._config+=2),f&&(this._config+=4);const v=(0,L.parse)(I),_=T(P=>{if(!a)for(let p of P.created){const l=D.URI.revive(p);v(l.fsPath)&&this._onDidCreate.fire(l)}if(!w)for(let p of P.changed){const l=D.URI.revive(p);v(l.fsPath)&&this._onDidChange.fire(l)}if(!f)for(let p of P.deleted){const l=D.URI.revive(p);v(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=n.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(T,I,a){this._logService=I,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(T,I,a,w){return new k(this._onFileSystemEvent.event,T,I,a,w)}$onFileEvent(T){this._onFileSystemEvent.fire(T)}$onDidRunFileOperation(T,I){switch(T){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(T){return this._createWillExecuteEvent(T,this._onWillRenameFile)}getOnWillCreateFileEvent(T){return this._createWillExecuteEvent(T,this._onWillCreateFile)}getOnWillDeleteFileEvent(T){return this._createWillExecuteEvent(T,this._onWillDeleteFile)}_createWillExecuteEvent(T,I){return(a,w,f)=>{const v=function(P){a.call(w,P)};return v.extension=T,I.event(v,void 0,f)}}async $onWillRunFileOperation(T,I,a,w){switch(T){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(f=>({oldUri:D.URI.revive(f.source),newUri:D.URI.revive(f.target)}))},a,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(f=>D.URI.revive(f.target))},a,w);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(f=>D.URI.revive(f.target))},a,w)}}async _fireWillEvent(T,I,a,w){const f=new Set,v=[];if(await T.fireAsync(I,w,async(P,p)=>{const l=Date.now(),r=await Promise.resolve(P);r instanceof n.WorkspaceEdit&&(v.push(r),f.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-l>a&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),w.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let P of v){let{edits:p}=C.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(p)}return{edit:_,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=S}),define(me[218],ge([0,1,10,25,2,16,7,125]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(a,w,f,v){this.start=a,this.deletedCount=w,this.deletedItems=f,this.items=v}static asApiEvents(a){return a.map(w=>({start:w.start,deletedCount:w.deletedCount,deletedItems:w.deletedItems,items:w.items.map(f=>f.apiCell)}))}}class y{constructor(a,w,f){this.notebook=a,this._extHostDocument=w,this._cellData=f,this.handle=f.handle,this.uri=D.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=f.internalMetadata??{},this._metadata=Object.freeze(f.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(f.internalMetadata??{}))}static asModelAddData(a,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,w=this._extHostDocument.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:w.document,get mime(){return a._mime},set mime(f){a._mime=f},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(C.NotebookCellOutput.to)}setOutputItems(a,w,f){const v=f.map(C.NotebookCellOutputItem.to),_=this._outputs.find(P=>P.id===a);_&&(w||(_.items.length=0),_.items.push(...v))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=y;class T{constructor(a,w,f,v,_,P){this._proxy=a,this._textDocumentsAndEditors=w,this._textDocuments=f,this._emitter=v,this.uri=_,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===m.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(w){return w=a._validateIndex(w),a._cells[w].apiCell},getCells(w){return(w?a._getCells(w):a._cells).map(v=>v.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,w){this._versionId=a.versionId,this._isDirty=w;for(const f of a.rawEvents)f.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===k.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(f.index,f.metadata):f.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(f.index,f.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let w=a.start|0,f=a.end|0;return w<0&&(w=0),f>this._cells.length&&(f=this._cells.length),a.with({start:w,end:f})}_getCells(a){a=this._validateRange(a);const w=[];for(let f=a.start;f<a.end;f++)w.push(this._cells[f]);return w}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,w){if(this._disposed)return;const f=[],v=[],_=[];a.reverse().forEach(P=>{const l=P[2].map(o=>{const b=new y(this,this._textDocumentsAndEditors,o);return w||v.push(y.asModelAddData(this.apiNotebook,o)),b}),r=new S(P[0],P[1],[],l),g=this._cells.splice(P[0],P[1],...l);for(const o of g)_.push(o.uri),r.deletedItems.push(o.apiCell);f.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),w||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(f)}))}_moveCell(a,w){const f=this._cells.splice(a,1);this._cells.splice(w,0,...f);const v=[new S(a,1,f.map(_=>_.apiCell),[]),new S(w,0,[],f)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(v)}))}_setCellOutputs(a,w){const f=this._cells[a];f.setOutputs(w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_setCellOutputItems(a,w,f,v){const _=this._cells[a];_.setOutputItems(w,f,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(a,w){const f=this._cells[a];f.apiCell.document.languageId!==w&&this._textDocuments.$acceptModelModeChanged(f.uri,w)}_changeCellMime(a,w){const f=this._cells[a];f.apiCell.mime=w}_changeCellMetadata(a,w){const f=this._cells[a],v=f.apiCell.metadata;f.setMetadata(w);const _=f.apiCell.metadata;(0,L.equals)(v,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell}))}_changeCellInternalMetadata(a,w){const f=this._cells[a],v=f.internalMetadata;if(f.setInternalMetadata(w),v.runState!==w.runState){const _=w.runState??n.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,state:_}))}}getCellFromApiCell(a){return this._cells.find(w=>w.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(w=>w.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(me[128],ge([0,1,7,16,15]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,y){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:y})}replaceCells(S,y,T){this._throwIfFinalized(),!(S===y&&T.length===0)&&this._collectedEdits.push({editType:1,index:S,count:y-S,cells:T.map(L.NotebookCellData.from)})}}class n{constructor(S,y,T,I,a,w){this.id=S,this._proxy=y,this.notebookData=T,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=I,this._viewColumn=w}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(y){if(!Array.isArray(y)||!y.every(m.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");S._selections=y,S._trySetSelections(y)},get visibleRanges(){return S._visibleRanges},revealRange(y,T){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(y),T??m.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(y){const T=new C(this.document.version);return y(T),S._applyEdit(T.finalize())},setDecorations(y,T){return S.setDecorations(y,T)}},n.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const y=[];let T=-1;for(let I=0;I<S.cellEdits.length;I++){if(T<0){y.push(S.cellEdits[I]),T++;continue}const w=y[T],f=S.cellEdits[I];if(w.editType===1&&f.editType===1&&w.index===f.index){w.cells.push(...S.cellEdits[I].cells),w.count+=S.cellEdits[I].count;continue}y.push(S.cellEdits[I]),T++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,y)}setDecorations(S,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return y.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(y),S.key)}}e.ExtHostNotebookEditor=n,n.apiEditorsToExtHost=new WeakMap}),define(me[219],ge([0,1,16,117,164,21,57,15]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,w,f){const v=this._handles++,{title:_,location:P,cancellable:p}=w,l={label:(0,D.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(v,{location:m.ProgressLocation.from(P),title:_,source:l,cancellable:p},a).catch(k.onUnexpectedExternalError),this._withProgress(v,f,!!p)}_withProgress(a,w,f){let v;f&&(v=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,v));const _=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),v&&v.dispose()};let P;try{P=w(new T(this._proxy,a),f&&v?v.token:C.CancellationToken.None)}catch(p){throw _(a),p}return P.then(p=>_(a),p=>_(a)),P}$acceptProgressCanceled(a){const w=this._mapHandleToCancellationSource.get(a);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=S;function y(I,a){return I.message=a.message,typeof a.increment=="number"&&(typeof I.increment=="number"?I.increment+=a.increment:I.increment=a.increment),I}class T extends L.Progress{constructor(a,w){super(f=>this.throttledReport(f));this._proxy=a,this._handle=w}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,n.throttle)(100,(I,a)=>y(I,a),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(me[129],ge([0,1,56,15,75,16,7]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(a,w,f){const v=k._Keys.nextId();a.$registerTextEditorDecorationType(w.identifier,v,C.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:v,dispose(){a.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=k,k._Keys=new D.IdGenerator("TextEditorDecorationType");class S{constructor(a,w){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=w.undoStopBefore,this._undoStopAfter=w.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,w){this._throwIfFinalized();let f=null;if(a instanceof n.Position)f=new n.Range(a,a);else if(a instanceof n.Range)f=a;else throw new Error("Unrecognized location");this._pushEdit(f,w,!1)}insert(a,w){this._throwIfFinalized(),this._pushEdit(new n.Range(a,a),w,!0)}delete(a){this._throwIfFinalized();let w=null;if(a instanceof n.Range)w=a;else throw new Error("Unrecognized location");this._pushEdit(w,null,!0)}_pushEdit(a,w,f){const v=this._document.validateRange(a);this._collectedEdits.push({range:v,text:w,forceMoveMarkers:f})}setEndOfLine(a){if(this._throwIfFinalized(),a!==n.EndOfLine.LF&&a!==n.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=S;class y{constructor(a,w,f,v){this._proxy=a,this._id=w,this._accept(f),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(P){_._setTabSize(P)},get insertSpaces(){return _._insertSpaces},set insertSpaces(P){_._setInsertSpaces(P)},get cursorStyle(){return _._cursorStyle},set cursorStyle(P){_._setCursorStyle(P)},get lineNumbers(){return _._lineNumbers},set lineNumbers(P){_._setLineNumbers(P)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const w=Math.floor(a);return w>0?w:null}if(typeof a=="string"){const w=parseInt(a,10);return isNaN(w)?null:w>0?w:null}return null}_setTabSize(a){const w=this._validateTabSize(a);if(w!==null){if(typeof w=="number"){if(this._tabSize===w)return;this._tabSize=w}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:w}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const w=this._validateInsertSpaces(a);if(typeof w=="boolean"){if(this._insertSpaces===w)return;this._insertSpaces=w}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:w}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(a)})))}assign(a){const w={};let f=!1;if(typeof a.tabSize!="undefined"){const v=this._validateTabSize(a.tabSize);v==="auto"?(f=!0,w.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,f=!0,w.tabSize=v)}if(typeof a.insertSpaces!="undefined"){const v=this._validateInsertSpaces(a.insertSpaces);v==="auto"?(f=!0,w.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,f=!0,w.insertSpaces=v)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,f=!0,w.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,f=!0,w.lineNumbers=C.TextEditorLineNumbersStyle.from(a.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,w))}_warnOnError(a,w){w.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=y;class T{constructor(a,w,f,v,_,P,p,l){this.id=a,this._proxy=w,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new y(this._proxy,this.id,P,f),this._visibleRanges=p,this._viewColumn=l;const r=this;this.value=Object.freeze({get document(){return v.getValue()},set document(g){throw(0,L.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(g){if(!(g instanceof n.Selection))throw(0,L.illegalArgument)("selection");r._selections=[g],r._trySetSelection()},get selections(){return r._selections},set selections(g){if(!Array.isArray(g)||g.some(o=>!(o instanceof n.Selection)))throw(0,L.illegalArgument)("selections");r._selections=g,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(g){throw(0,L.readonly)("visibleRanges")},get options(){return r._options.value},set options(g){r._disposed||r._options.assign(g)},get viewColumn(){return r._viewColumn},set viewColumn(g){throw(0,L.readonly)("viewColumn")},edit(g,o={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new S(v.getValue(),o);return g(b),r._applyEdit(b)},insertSnippet(g,o,b={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!o||Array.isArray(o)&&o.length===0)i=r._selections.map(t=>C.Range.from(t));else if(o instanceof n.Position){const{lineNumber:t,column:c}=C.Position.from(o);i=[{startLineNumber:t,startColumn:c,endLineNumber:t,endColumn:c}]}else if(o instanceof n.Range)i=[C.Range.from(o)];else{i=[];for(const t of o)if(t instanceof n.Range)i.push(C.Range.from(t));else{const{lineNumber:c,column:d}=C.Position.from(t);i.push({startLineNumber:c,startColumn:d,endLineNumber:c,endColumn:d})}}return w.$tryInsertSnippet(a,g.value,i,b)},setDecorations(g,o){const b=o.length===0;b&&!r._hasDecorationsForKey.has(g.key)||(b?r._hasDecorationsForKey.delete(g.key):r._hasDecorationsForKey.add(g.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(o))return w.$trySetDecorations(a,g.key,C.fromRangeOrRangeWithMessage(o));{const i=new Array(4*o.length);for(let t=0,c=o.length;t<c;t++){const d=o[t];i[4*t]=d.start.line+1,i[4*t+1]=d.start.character+1,i[4*t+2]=d.end.line+1,i[4*t+3]=d.end.character+1}return w.$trySetDecorationsFast(a,g.key,i)}}))},revealRange(g,o){r._runOnProxy(()=>w.$tryRevealRange(a,C.Range.from(g),o||n.TextEditorRevealType.Default))},show(g){w.$tryShowEditor(a,C.ViewColumn.from(g))},hide(){w.$tryHideEditor(a)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,m.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,m.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,m.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,m.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const w=a.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const f=w.edits.map(_=>_.range);f.sort((_,P)=>_.end.line===P.end.line?_.end.character===P.end.character?_.start.line===P.start.line?_.start.character-P.start.character:_.start.line-P.start.line:_.end.character-P.end.character:_.end.line-P.end.line);for(let _=0,P=f.length-1;_<P;_++){const p=f[_].end;if(f[_+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=w.edits.map(_=>({range:C.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,v,{setEndOfLine:typeof w.setEndOfLine=="number"?C.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this._logService.warn(w),null))}}e.ExtHostTextEditor=T}),define(me[220],ge([0,1,167,23,2,3,6,18,7,13,17,16,21,204]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(P,p){if((0,y.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let l;return Array.isArray(P.highlights)&&(l=P.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),l=l.length?l:void 0),{label:P.label,highlights:l}}}class v{constructor(p,l,r){this._proxy=p,this.commands=l,this.logService=r,this.treeViews=new Map;function g(o){return o&&o.$treeViewId&&o.$treeItemHandle}l.registerArgumentProcessor({processArgument:o=>g(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(b=>g(b)?this.convertArgument(b):b):o})}registerTreeDataProvider(p,l,r){const g=this.createTreeView(p,{treeDataProvider:l},r);return{dispose:()=>g.dispose()}}createTreeView(p,l,r){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=l.dragAndDropController?.supportedMimeTypes,o=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,dragAndDropMimeTypes:g}),b=this.createExtHostTreeView(p,l,r);return{get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get message(){return b.message},set message(i){b.message=i},get title(){return b.title},set title(i){b.title=i},get description(){return b.description},set description(i){b.description=i},reveal:(i,t)=>b.reveal(i,t),dispose:async()=>{await o,this.treeViews.delete(p),b.dispose()}}}$getChildren(p,l){const r=this.treeViews.get(p);return r?r.getChildren(l):Promise.reject(new Error((0,m.localize)(0,null,p)))}async $onDrop(p,l,r,g,o){const b=this.treeViews.get(p);if(!b)return Promise.reject(new Error((0,m.localize)(1,null,p)));const i=w.TreeDataTransferConverter.toITreeDataTransfer(l);if(g===p&&o){const t=await b.onWillDrop(o);t&&t.forEach((c,d)=>{c&&i.set(d,c)})}return b.onDrop(i,r)}async $hasResolve(p){const l=this.treeViews.get(p);if(!l)throw new Error((0,m.localize)(2,null,p));return l.hasResolve}$resolve(p,l,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(3,null,p));return g.resolveTreeItem(l,r)}$setExpanded(p,l,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(4,null,p));g.setExpanded(l,r)}$setSelection(p,l){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(5,null,p));r.setSelection(l)}$setVisible(p,l){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(6,null,p));r.setVisible(l)}createExtHostTreeView(p,l,r){const g=new _(p,l,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(p,g),g}convertArgument(p){const l=this.treeViews.get(p.$treeViewId);return l?l.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=v;class _ extends n.Disposable{constructor(p,l,r,g,o,b){super();if(this.viewId=p,this.proxy=r,this.commands=g,this.logService=o,this.extension=b,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new a.CancellationTokenSource,b.contributes&&b.contributes.views)for(const c in b.contributes.views)for(const d of b.contributes.views[c])d.id===p&&(this._title=d.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,t;this._register(C.Event.debounce(this._onDidChangeData.event,(c,d)=>(c||(c={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(s=>t=s),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?c.elements.push(...d.element):c.elements.push(d.element)),d.message&&(c.message=!0),c),200,!0)(({message:c,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const s=t;return i=null,this.refresh(d).then(()=>s())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,y.isUndefinedOrNull)(p))}async getChildren(p){const l=p?this.getExtensionElement(p):void 0;if(p&&!l)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(p);return r||(r=await this.fetchChildrenNodes(l)),r?r.map(g=>g.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,l){l=l||{select:!0,focus:!1};const r=(0,y.isUndefinedOrNull)(l.select)?!0:l.select,g=(0,y.isUndefinedOrNull)(l.focus)?!1:l.focus,o=(0,y.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(b=>this.resolveTreeNode(p,b[b.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:b.map(t=>t.item)},{select:r,focus:g,expand:o})),b=>this.logService.error(b)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:g,expand:o})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,l){const r=this.getExtensionElement(p);r&&(l?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(p){(0,T.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(p){const l=[];for(const r of p){const g=this.getExtensionElement(r);g&&l.push(g)}if(!(!this.dndController?.onWillDrop||l.length===0))return this.dndController.onWillDrop(l)}async onDrop(p,l){const r=this.getExtensionElement(l);if(!!r)return(0,k.asPromise)(()=>this.dndController?.onDrop(p,r))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,l){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(p);if(r){const g=this.nodes.get(r);if(g){const o=await this.dataProvider.resolveTreeItem(g.extensionItem,r,l)??g.extensionItem;return g.item.tooltip=this.getTooltip(o.tooltip),g.item.command=this.getCommand(g.disposableStore,o.command),g.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(l=>l?this.resolveUnknownParentChain(l).then(r=>this.resolveTreeNode(l,r[r.length-1]).then(g=>(r.push(g),r))):Promise.resolve([]))}resolveParent(p){const l=this.nodes.get(p);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,l){const r=this.nodes.get(p);return r?Promise.resolve(r):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(g=>this.createHandle(p,g,l,!0)).then(g=>this.getChildren(l?l.item.handle:void 0).then(()=>{const o=this.getExtensionElement(g);if(o){const b=this.nodes.get(o);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(p){if(p){let l;if(typeof p=="string"){const r=this.getExtensionElement(p);l=r?this.nodes.get(r):void 0}else l=p;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const l=new a.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=p?this.nodes.get(p):void 0,g=await this.dataProvider.getChildren(p);if(l.token.isCancellationRequested)return;const o=await Promise.all((0,T.coalesce)(g||[]).map(async b=>{const i=await this.dataProvider.getTreeItem(b);return i&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(b,i,r):null}));return l.token.isCancellationRequested?void 0:(0,T.coalesce)(o)}finally{l.dispose()}}refresh(p){if(p.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new a.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(p);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const l=new Set,r=p.map(o=>this.nodes.get(o));for(const o of r)if(o&&!l.has(o.item.handle)){let b=o;for(;b&&b.parent&&r.findIndex(i=>b&&b.parent&&i&&i.item.handle===b.parent.item.handle)===-1;){const i=this.elements.get(b.parent.item.handle);b=i?this.nodes.get(i):void 0}b&&!b.parent&&l.add(o.item.handle)}const g=[];return l.forEach(o=>{const b=this.elements.get(o);if(b){const i=this.nodes.get(b);i&&(!i.parent||!l.has(i.parent.item.handle))&&g.push(o)}}),g}refreshHandles(p){const l={};return Promise.all(p.map(r=>this.refreshNode(r).then(g=>{g&&(l[r]=g.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(p){const l=this.getExtensionElement(p);if(l){const r=this.nodes.get(l);if(r)return this.clearChildren(l),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(g=>{if(g){const o=this.createTreeNode(l,g,r.parent);return this.updateNodeCache(l,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,l,r){const g=this.createTreeNode(p,l,r);if(l.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,l.id));return this.addNodeToCache(p,g),this.addNodeToParentCache(g,r),g}getTooltip(p){return S.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}getCommand(p,l){return l?this.commands.toInternal(l,p):void 0}createTreeNode(p,l,r){const g=new n.DisposableStore,o=this.createHandle(p,l,r),b=this.getLightIconPath(l);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:f(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(g,l.command),contextValue:l.contextValue,icon:b,iconDark:this.getDarkIconPath(l)||b,themeIcon:this.getThemeIcon(l),collapsibleState:(0,y.isUndefinedOrNull)(l.collapsibleState)?S.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:r,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(p){return p.iconPath instanceof S.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:l,label:r,resourceUri:g},o,b){if(l)return`${_.ID_HANDLE_PREFIX}/${l}`;const i=f(r,this.extension),t=o?o.item.handle:_.LABEL_HANDLE_PREFIX;let c=i?i.label:g?(0,L.basename)(g):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const d=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,s=this.getChildrenNodes(o)||[];let h,u=0;do{if(h=`${t}/${u}:${c}`,b||!this.elements.has(h)||d===h)break;u++}while(u<=s.length);return h}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon))return typeof p.iconPath=="string"||D.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return D.URI.isUri(p)?p:D.URI.file(p)}addNodeToCache(p,l){this.elements.set(l.item.handle,p),this.nodes.set(p,l)}updateNodeCache(p,l,r,g){this.elements.delete(l.item.handle),this.nodes.delete(p),l.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(p,l);const o=this.getChildrenNodes(g)||[],b=o.filter(i=>i.item.handle===r.item.handle)[0];b&&o.splice(o.indexOf(b),1,l)}addNodeToParentCache(p,l){l?(l.children||(l.children=[]),l.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const l=this.nodes.get(p);if(l){if(l.children)for(const r of l.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}l.children=void 0}}else this.clearAll()}clear(p){const l=this.nodes.get(p);if(l){if(l.children)for(const r of l.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}this.nodes.delete(p),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}_.LABEL_HANDLE_PREFIX="0",_.ID_HANDLE_PREFIX="1"}),define(me[221],ge([0,1,18,3,6,13,63,16,126,90]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class T extends D.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new n.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const w of this.tree.values())this.updateExpandability(w)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const w=this.diff[this.diff.length-1];if(w&&a[0]===1){if(w[0]===1&&w[1].extId===a[1].extId){(0,S.applyTestItemUpdate)(w[1],a[1]);return}if(w[0]===0&&w[1].item.extId===a[1].extId){(0,S.applyTestItemUpdate)(w[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,w){const f=this.tree.get(a);if(!!f){if((f.expandLevels===void 0||w>f.expandLevels)&&(f.expandLevels=w),f.expand===1){const v=this.resolveChildren(f);return v.isOpen()?this.expandChildren(f,w-1):v.wait().then(()=>this.expandChildren(f,w-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.expandChildren(f,w-1)):this.expandChildren(f,w-1)}}dispose(){for(const a of this.tree.values())(0,n.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,w){switch(w.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(y.TestId.joinToString(a.fullId,w.id));break;case 0:this.upsertItem(w.item,a);break;case 4:for(const p of w.ops)this.onTestItemEvent(a,p);break;case 3:const{key:f,value:v,previous:_}=w,P=a.fullId.toString();switch(f){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(v,_,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:k.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:k.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[f]:v??null}}]);break}break;default:(0,C.assertNever)(w)}}upsertItem(a,w){if(!(a instanceof n.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const f=y.TestId.fromExtHostTestItem(a,this.root.id,w?.actual),v=(0,n.getPrivateApiFor)(a);v.parent&&v.parent!==w?.actual&&v.parent.children.delete(a.id);let _=this.tree.get(f.toString());if(!_){_={fullId:f,actual:a,parent:w?f.parentId:null,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(a,w),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:k.TestItem.from(a)}]),this.connectItemAndChildren(a,_,w);return}if(_.actual===a){this.connectItem(a,_,w);return}const P=_.actual.children,p=_.actual,l=(0,n.diffTestItems)(p,a);(0,n.getPrivateApiFor)(p).listener=void 0,_.actual=a,_.expand=0;for(const[r,g]of l)this.onTestItemEvent(_,{op:3,key:r,value:g,previous:p[r]});this.connectItemAndChildren(a,_,w);for(const r of P)a.children.get(r.id)||this.removeItem(y.TestId.joinToString(f,r.id))}diffTagRefs(a,w,f){const v=new Set(w.map(_=>_.id));for(const _ of a)v.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:f,item:{tags:a.map(_=>k.TestTag.namespace(this.controllerId,_.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const w=this.tags.get(a.id);w?w.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const w=this.tags.get(a);w&&!--w.refCount&&(this.tags.delete(a),this.pushDiff([6,k.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,w){(0,n.getPrivateApiFor)(a).parent=w&&w.actual!==this.root?w.actual:void 0}connectItem(a,w,f){this.setItemParent(a,f);const v=(0,n.getPrivateApiFor)(a);v.parent=f?.actual,v.listener=_=>this.onTestItemEvent(w,_),this.updateExpandability(w)}connectItemAndChildren(a,w,f){this.connectItem(a,w,f);for(const v of a.children)this.upsertItem(v,w)}updateExpandability(a){let w;this._resolveHandler?a.resolveBarrier?w=a.resolveBarrier.isOpen()?3:2:w=a.actual.canResolveChildren?1:0:w=0,w!==a.expand&&(a.expand=w,this.pushDiff([1,{extId:a.fullId.toString(),expand:w}]),w===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,w){if(w<0)return;const f=[];for(const v of a.actual.children){const _=this.expand(y.TestId.joinToString(a.fullId,v.id),w);(0,m.isThenable)(_)&&f.push(_)}if(f.length)return Promise.all(f).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const _=new m.Barrier;return _.open(),_}a.expand=2,this.pushExpandStateUpdate(a);const w=a.resolveBarrier=new m.Barrier,f=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(_){f(_)}return(0,m.isThenable)(v)?v.catch(f).then(()=>{w.open(),this.updateExpandability(a)}):(w.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const w=this.tree.get(a);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const f=[w];for(;f.length;){const v=f.pop();if(!!v){(0,n.getPrivateApiFor)(v.actual).listener=void 0;for(const _ of v.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)f.push(this.tree.get(y.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=T}),define(me[222],ge([0,1,4,182]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(me[223],ge([0,1,27,3,9]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=C;class n{constructor(T){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let I of T.activationEvents)I==="onUri"&&(I=`onUri:${m.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(T)}}keepOnly(T){const I=new Set;T.forEach(a=>I.add(m.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>I.has(m.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,I){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const a=n._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(a.map(w=>w.identifier)),I.length>0){const w=new Set;I.forEach(f=>w.add(m.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!w.has(m.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(a)}static _findLoopingExtensions(T){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,P){this.addNode(_),this.addNode(P),this._arcs.has(_)?this._arcs.get(_).push(P):this._arcs.set(_,[P])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,P){const p=I.getArcs(_);for(let l=0;l<p.length;l++)if(!P.has(p[l]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let _ of T){const P=m.ExtensionIdentifier.toKey(_.identifier);if(a.set(P,_),_.extensionDependencies)for(let p of _.extensionDependencies){const l=m.ExtensionIdentifier.toKey(p);I.addArc(P,l)}}let w=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>w.add(_));let f=I.getNodes().filter(_=>!w.has(_)),v;do{v=!1;for(let _=0;_<f.length;_++){const P=f[_];I.hasOnlyGoodArcs(P,w)&&(f.splice(_,1),_--,w.add(P),v=!0)}}while(v);return f.map(_=>a.get(_))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const I=this._activationMap.get(T);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const I=this._extensionsMap.get(m.ExtensionIdentifier.toKey(T));return I||void 0}}e.ExtensionDescriptionRegistry=n;var k;(function(y){y[y.Builtin=0]="Builtin",y[y.User=1]="User",y[y.Dev=2]="Dev"})(k||(k={}));function S(y,T){const I=y.isBuiltin?0:y.isUnderDevelopment?2:1,a=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(I!==a)return I-a;const w=D.posix.basename(y.extensionLocation.path),f=D.posix.basename(T.extensionLocation.path);return w<f?-1:w>f?1:0}}),define(me[224],ge([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function C(k){const S=m.VSBuffer.alloc(1);switch(k){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function n(k,S){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=n}),define(me[29],ge([0,1,3,2,4,27,193]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class y{constructor(g){this.dependency=g}}e.MissingExtensionDependency=y;var T;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;function a(r,g){return r.enabledApiProposals?.includes(g)?!0:Boolean(r.enableProposedApi)}e.isProposedApiEnabled=a;function w(r,g){if(!a(r,g))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=w;class f{constructor(g,o,b,i){this.codeLoadingTime=g,this.activateCallTime=o,this.activateResolvedTime=b,this.activationReason=i}}e.ActivationTimes=f;class v{constructor(g,o){this.description=g,this.value=o}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var _;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(_=e.ActivationKind||(e.ActivationKind={}));function P(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,n.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=P;function p(r,g){return{identifier:new C.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!g,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=p;class l{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,o){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,o,b,i,t){}_onDidActivateExtensionError(g,o){}_onExtensionRuntimeError(g,o){}_onExtensionHostExit(g){}}e.NullExtensionService=l}),define(me[225],ge([0,1,15,27,29,12]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const n=Promise.resolve(void 0);class k{constructor(v,_,P,p){this.startup=v,this.codeLoadingTime=_,this.activateCallTime=P,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,_){return v===-1||_===-1?-1:_-v}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(v,_,P,p,l,r){this.activationFailed=v,this.activationFailedError=_,this.activationTimes=P,this.module=p,this.exports=l,this.subscriptions=r}}e.ActivatedExtension=y;class T extends y{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class I extends y{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class a extends y{constructor(v){super(!0,v,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=a;let w=class{constructor(v,_,P,p,l){this._logService=l,this._isDisposed=!1,this._registry=v,this._resolvedExtensionsSet=new Set,_.forEach(r=>this._resolvedExtensionsSet.add(L.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,P.forEach(r=>this._hostExtensionsMap.set(L.ExtensionIdentifier.toKey(r),r)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(v){const _=L.ExtensionIdentifier.toKey(v);return this._activatedExtensions.has(_)}getActivatedExtension(v){const _=L.ExtensionIdentifier.toKey(v),P=this._activatedExtensions.get(_);if(!P)throw new Error("Extension `"+v.value+"` is not known or not activated");return P}activateByEvent(v,_){if(this._alreadyActivatedEvents[v])return n;const P=this._registry.getExtensionDescriptionsForActivationEvent(v);return this._activateExtensions(P.map(p=>({id:p.identifier,reason:{startup:_,extensionId:p.identifier,activationEvent:v}}))).then(()=>{this._alreadyActivatedEvents[v]=!0})}activateById(v,_){const P=this._registry.getExtensionDescription(v);if(!P)throw new Error("Extension `"+v+"` is not known");return this._activateExtensions([{id:P.identifier,reason:_}])}_handleActivateRequest(v,_,P){if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(v.id))){_[L.ExtensionIdentifier.toKey(v.id)]=v;return}const p=this._registry.getExtensionDescription(v.id);if(!p){const g=new Error(`Cannot activate unknown extension '${v.id.value}'`);this._host.onExtensionActivationError(v.id,g,new D.MissingExtensionDependency(v.id.value)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(v.id),new a(g));return}const l=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let r=!0;for(let g=0,o=l.length;g<o;g++){const b=l[g];if(this._resolvedExtensionsSet.has(L.ExtensionIdentifier.toKey(b)))continue;const i=this._activatedExtensions.get(L.ExtensionIdentifier.toKey(b));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const s=p.displayName||p.identifier.value,h=this._registry.getExtensionDescription(b),u=h&&h.displayName||b,E=new Error(`Cannot activate the '${s}' extension because its dependency '${u}' failed to activate`);E.detail=i.activationFailedError,this._host.onExtensionActivationError(p.identifier,E,null),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new a(E));return}if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(b))){r=!1,_[L.ExtensionIdentifier.toKey(b)]={id:this._hostExtensionsMap.get(L.ExtensionIdentifier.toKey(b)),reason:v.reason};continue}const t=this._registry.getExtensionDescription(b);if(t){if(!t.main&&!t.browser)continue;r=!1,_[L.ExtensionIdentifier.toKey(b)]={id:t.identifier,reason:v.reason};continue}const c=p.displayName||p.identifier.value,d=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${b}'`);this._host.onExtensionActivationError(p.identifier,d,new D.MissingExtensionDependency(b)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new a(d));return}r?_[L.ExtensionIdentifier.toKey(p.identifier)]=v:P.push(v)}_activateExtensions(v){if(v.length===0||(v=v.filter(l=>!this._activatedExtensions.has(L.ExtensionIdentifier.toKey(l.id))),v.length===0))return Promise.resolve(void 0);const _=Object.create(null),P=[];for(let l=0,r=v.length;l<r;l++)this._handleActivateRequest(v[l],_,P);for(let l=0,r=P.length;l<r;l++){const g=L.ExtensionIdentifier.toKey(P[l].id);_[g]&&delete _[g]}const p=Object.keys(_).map(l=>_[l]);return P.length===0?Promise.all(p.map(l=>this._activateExtension(l.id,l.reason))).then(l=>{}):this._activateExtensions(p).then(l=>this._activateExtensions(P))}_activateExtension(v,_){const P=L.ExtensionIdentifier.toKey(v);if(this._activatedExtensions.has(P))return Promise.resolve(void 0);const p=this._activatingExtensions.get(P);if(p)return p;const l=this._host.actualActivateExtension(v,_).then(void 0,r=>{const g=new Error;return r&&r.name&&(g.name=r.name),r&&r.message?g.message=`Activating extension '${v.value}' failed: ${r.message}.`:g.message=`Activating extension '${v.value}' failed: ${r}.`,r&&r.stack&&(g.stack=r.stack),this._isDisposed&&m.isPromiseCanceledError(r)?new a(r):(this._host.onExtensionActivationError(v,g,null),this._logService.error(`Activating extension ${v.value} failed due to an error:`),this._logService.error(r),new a(r))}).then(r=>{this._activatedExtensions.set(P,r),this._activatingExtensions.delete(P)});return this._activatingExtensions.set(P,l),l}};w=Ve([We(4,C.ILogService)],w),e.ExtensionsActivator=w}),define(me[226],ge([0,1,12,26,29]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:D.ExtensionHostLogFileName}))}};C=Ve([We(0,m.ILoggerService),We(1,L.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[227],ge([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,n)=>{this._actualOk=C,this._actualErr=n,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,n){return this._ensureActual().then(C,n)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(me[53],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(y,T){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=T,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function D(S){const y=new m(!0,S);return L[y.nid]=y,y}e.createMainContextProxyIdentifier=D;function C(S){const y=new m(!1,S);return L[y.nid]=y,y}e.createExtHostContextProxyIdentifier=C;function n(S){return L[S].sid}e.getStringIdentifierForProxy=n;class k{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=k}),define(me[5],ge([0,1,59,2,53]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var n;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(n=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(l){l.name="$ident";function r(o,b){return Object.defineProperty(o,l.name,{value:b,enumerable:!0}),o}l.mixin=r;function g(o){return o[l.name]}l.of=g})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class w{static mixin(r){return r._id=w._n++,r}}e.IdObject=w,w._n=0;var f;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(l){if(l&&l.edits)for(const r of l.edits)typeof r.resource=="object"?r.resource=L.URI.revive(r.resource):(r.newUri=L.URI.revive(r.newUri),r.oldUri=L.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,m.revive)(r.metadata));return l}e.reviveWorkspaceEditDto=P;var p;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,y){return this._proxy.$setPassword(k,S,y)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(me[65],ge([0,1,4,12,5,14]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let n=class{constructor(S,y){this._extHostLogService=y,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,y,T){const I=this.getUsageKey(S,y);this._reportedUsages.has(I)||(this._reportedUsages.add(I),y.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:S}))}getUsageKey(S,y){return`${S}-${y.identifier.value}`}};n=Ve([We(0,C.IExtHostRpcService),We(1,L.ILogService)],n),e.ExtHostApiDeprecationService=n,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,y){}})}),define(me[228],ge([0,1,3,5,7,27]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class n{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,y,T,I={}){const a=C.ExtensionIdentifier.toKey(S.identifier),w=this._inFlightRequests.get(a)||[],f=[...T].sort().join(" ");let v=w.find(_=>_.scopes===f);if(v)return v.result;{const _=this._getSession(S,a,y,T,I);v={scopes:f,result:_},w.push(v),this._inFlightRequests.set(a,w);try{await _}finally{const P=w.findIndex(p=>p.scopes===f);P>-1&&(w.splice(P),this._inFlightRequests.set(a,w))}return _}}async _getSession(S,y,T,I,a={}){await this._proxy.$ensureProvider(T);const w=S.displayName||S.name;return this._proxy.$getSession(T,I,y,w,a)}async removeSession(S,y){const T=this._authenticationProviders.get(S);return T?T.provider.removeSession(y):this._proxy.$removeSession(S,y)}registerAuthenticationProvider(S,y,T,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:y,provider:T,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(w=>w.id===S)||this._providers.push({id:S,label:y});const a=T.onDidChangeSessions(w=>{this._proxy.$sendDidChangeSessions(S,{added:w.added??[],changed:w.changed??[],removed:w.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,y,I?.supportsMultipleAccounts??!1),new D.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(S);const w=this._providers.findIndex(f=>f.id===S);w>-1&&this._providers.splice(w),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,y){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.createSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,y){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,y){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,y){return this._onDidChangeSessions.fire({provider:{id:S,label:y}}),Promise.resolve()}}e.ExtHostAuthentication=n}),define(me[229],ge([0,1,5,14,16]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,S){this._extHostDocumentsAndEditors=S,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const S=D.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=Ve([We(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[230],ge([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const n=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return n.$readText()},writeText(k){return n.$writeText(k)}})}}e.ExtHostClipboard=L}),define(me[38],ge([0,1,13,7,16,25,5,17,12,59,41,50,2,6,4,14,63,22,53,51]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(c,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=c.getProxy(n.MainContext.MainThreadCommands),this._logService=d,this.converter=new g(this,s=>{const h=this._apiCommands.get(s);return h?.result===b.Void?h:void 0},d),this._argumentProcessors=[{processArgument(s){return(0,y.revive)(s)}},{processArgument(s){return(0,C.cloneAndChange)(s,function(h){if(T.Range.isIRange(h))return D.Range.to(h);if(I.Position.isIPosition(h))return D.Position.to(h);if(T.Range.isIRange(h.range)&&a.URI.isUri(h.uri))return D.location.to(h);if(h instanceof P.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const d=this.registerCommand(!1,c.id,async(...s)=>{const h=c.args.map((E,A)=>{if(!E.validate(s[A]))throw new Error(`Invalid argument '${E.name}' when running '${c.id}', received: ${s[A]}`);return E.convert(s[A])}),u=await this.executeCommand(c.internalId,...h);return c.result.convert(u,s,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new L.Disposable(()=>{d.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,d,s,h,u,E){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:s,thisArg:h,description:u,extension:E}),c&&this._proxy.$registerCommand(d),new L.Disposable(()=>{this._commands.delete(d)&&c&&this._proxy.$unregisterCommand(d)})}executeCommand(c,...d){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,d,!0)}async _doExecuteCommand(c,d,s){if(this._commands.has(c))return this._executeContributedCommand(c,d,!1);{let h=!1;const u=(0,C.cloneAndChange)(d,function(E){if(E instanceof L.Position)return D.Position.from(E);if(E instanceof L.Range)return D.Range.from(E);if(E instanceof L.Location)return D.location.from(E);if(L.NotebookRange.isNotebookRange(E))return D.NotebookRange.from(E);if(E instanceof ArrayBuffer)return h=!0,P.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return h=!0,P.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(c,h?new p.SerializableObjectWithBuffers(u):u,s);return(0,y.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(c,d,!1);throw E}}}async _executeContributedCommand(c,d,s){const h=this._commands.get(c);if(!h)throw new Error("Unknown command");let{callback:u,thisArg:E,description:A}=h;if(A)for(let R=0;R<A.args.length;R++)try{(0,m.validateConstraint)(d[R],A.args[R].constraint)}catch($){throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${A.args[R].name}' - ${A.args[R].description}`)}try{return await u.apply(E,d)}catch(R){if(c===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...d);$&&(c=$.command)}throw this._logService.error(R,c,h.extension?.identifier),s?new class extends Error{constructor(){super((0,l.toErrorMessage)(R));this.id=c,this.source=h.extension?.displayName??h.extension?.name}}:R}}$executeContributedCommand(c,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(d=d.map(s=>this._argumentProcessors.reduce((h,u)=>u.processArgument(h),s)),this._executeContributedCommand(c,d,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),this._proxy.$getCommands().then(d=>(c&&(d=d.filter(s=>s[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[d,s]of this._commands){let{description:h}=s;h&&(c[d]=h)}return Promise.resolve(c)}};r=Ve([We(0,v.IExtHostRpcService),We(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class g{constructor(c,d,s){this._commands=c,this._lookupApiCommand=d,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,d){if(!c)return;const s={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return s;const h=this._lookupApiCommand(c.command);if(h)s.id=h.internalId,s.arguments=h.args.map((u,E)=>u.convert(c.arguments&&c.arguments[E]));else if((0,k.isNonEmptyArray)(c.arguments)){const u=++this._cachIdPool;this._cache.set(u,c),d.add((0,w.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",c.command,u)}return s}fromInternal(c){const d=n.ObjectIdentifier.of(c);return typeof d=="number"?this._cache.get(d):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const d=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class o{constructor(c,d,s,h){this.name=c,this.description=d,this.validate=s,this.convert=h}optional(){return new o(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,d){return new o(c??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",t=>a.URI.isUri(t),t=>t),o.Position=new o("position","A position in a text document",t=>L.Position.isPosition(t),D.Position.from),o.Range=new o("range","A range in a text document",t=>L.Range.isRange(t),D.Range.from),o.Selection=new o("selection","A selection in a text document",t=>L.Selection.isSelection(t),D.Selection.from),o.Number=new o("number","",t=>typeof t=="number",t=>t),o.String=new o("string","",t=>typeof t=="string",t=>t),o.CallHierarchyItem=new o("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,D.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,D.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",t=>t instanceof _.TestItemImpl,D.TestItem.from);class b{constructor(c,d){this.description=c,this.convert=d}}e.ApiCommandResult=b,b.Void=new b("no result",t=>t);class i{constructor(c,d,s,h,u){this.id=c,this.internalId=d,this.description=s,this.args=h,this.result=u}}e.ApiCommand=i}),define(me[231],ge([0,1,16,7,84,38,17,111]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,w)=>{if((0,n.isFalsyOrEmpty)(a))return;class f extends L.SymbolInformation{static to(_){const P=new f(_.name,m.SymbolKind.to(_.kind),_.containerName||"",new L.Location(w[0],m.Range.to(_.range)));return P.detail=_.detail,P.range=P.location.range,P.selectionRange=m.Range.to(_.selectionRange),P.children=_.children?_.children.map(f.to):[],P}}return a.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(w=>L.Position.isPosition(w)),a=>a.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(w=>{let f;for(const v of w.reverse())f=new L.SelectionRange(m.Range.to(v),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:m.Range.to(a.range),placeholder:a.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return m.WorkspaceEdit.to(a)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const w=(0,k.decodeSemanticTokensDto)(a);if(w.type==="full")return new L.SemanticTokens(w.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const w=(0,k.decodeSemanticTokensDto)(a);if(w.type==="full")return new L.SemanticTokens(w.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,w,f)=>{if(!a)return new L.CompletionList([]);const v=a.suggestions.map(_=>m.CompletionItem.to(_,f));return new L.CompletionList(v,a.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return m.SignatureHelp.to(a)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,w,f)=>T(v=>new L.CodeLens(m.Range.to(v.range),v.command&&f.fromInternal(v.command)))(a))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>L.Range.isRange(a),a=>L.Selection.isSelection(a)?m.Selection.from(a):m.Range.from(a)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,w,f)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const _=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=m.WorkspaceEdit.to(v.edit)),v.command&&(_.command=f.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(a))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(w=>new L.ColorInformation(m.Range.to(w.range),m.Color.to(w.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",a=>a instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:m.Range.from(a.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(w=>m.NotebookExclusiveDocumentPattern.to(w))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class y{static register(w){S.forEach(w.registerApiCommand,w)}}e.ExtHostApiCommands=y;function T(a){return w=>{if(Array.isArray(w))return w.map(a)}}function I(a){if(!Array.isArray(a))return;const w=[];for(const f of a)D.isLocationLink(f)?w.push(m.DefinitionLink.to(f)):w.push(m.location.to(f));return w}}),define(me[232],ge([0,1,18,57,3,6,2,84,27,16,7,5]),function(Y,e,m,L,D,C,n,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(w,f,v){const _=w.getProxy(I.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c||t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.commentThreadHandle);return d||t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.thread.commentThreadHandle);return d?{thread:d,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let s=t.commentUniqueId,h=d.getCommentByUniqueId(s);return h||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let s=t.text,h=t.commentUniqueId,u=d.getCommentByUniqueId(h);return u?(u.body=s,u):t}return t}})}createCommentController(t,c,d){const s=P.handlePool++,h=new l(t,s,c,d);this._commentControllers.set(h.handle,h);const u=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return u.push(h),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),u),h.value}$createCommentThreadTemplate(t,c,d){const s=this._commentControllers.get(t);!s||s.$createCommentThreadTemplate(c,d)}async $updateCommentThreadTemplate(t,c,d){const s=this._commentControllers.get(t);!s||s.$updateCommentThreadTemplate(c,d)}$deleteCommentThread(t,c){const d=this._commentControllers.get(t);d&&d.$deleteCommentThread(c)}$provideCommentingRanges(t,c,d){const s=this._commentControllers.get(t);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const h=v.getDocument(n.URI.revive(c));return(0,m.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(h,d)).then(u=>u?u.map(E=>y.Range.from(E)):void 0)}$toggleReaction(t,c,d,s,h){const u=this._commentControllers.get(t);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const E=u.getCommentThread(c);if(E){const A=E.getCommentByUniqueId(s.uniqueIdInThread);if(u!==void 0&&A&&u.reactionHandler)return u.reactionHandler(A,o(h))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class p{constructor(t,c,d,s,h,u,E){this._commentControllerHandle=c,this._id=d,this._uri=s,this._range=h,this._comments=u,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),_.$createCommentThread(c,this.handle,this._id,this._uri,y.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(R){A.range=R},get comments(){return A.comments},set comments(R){A.comments=R},get collapsibleState(){return A.collapsibleState},set collapsibleState(R){A.collapsibleState=R},get canReply(){return A.canReply},set canReply(R){A.canReply=R},get contextValue(){return A.contextValue},set contextValue(R){A.contextValue=R},get label(){return A.label},set label(R){A.label=R},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),c={};t("range")&&(c.range=y.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(d=>r(this,d,this._commentsMap))),t("collapsibleState")&&(c.collapseState=b(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(let c of this._commentsMap){let d=c[0],s=c[1];if(t===s)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}p._handlePool=0,Ve([(0,L.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,c,d,s){this._extension=t,this._handle=c,this._id=d,this._label=s,this._threads=new Map,_.$registerCommentController(this.handle,d,s);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(u){h.options=u},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(u){h.commentingRangeProvider=u},get reactionHandler(){return h.reactionHandler},set reactionHandler(u){h.reactionHandler=u},createCommentThread(u,E,A){return h.createCommentThread(u,E,A).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,_.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,d,s){if(typeof t=="string"){const h=new p(this.id,this.handle,t,c,d,s,this._extension.identifier);return this._threads.set(h.handle,h),h}else{const h=new p(this.id,this.handle,void 0,t,c,d,this._extension.identifier);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(t,c){const d=new p(this.id,this.handle,void 0,n.URI.revive(t),y.Range.to(c),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(t,c){let d=this._threads.get(t);d&&(d.range=y.Range.to(c))}$deleteCommentThread(t){let c=this._threads.get(t);c&&c.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(i,t,c){let d=c.get(t);d||(d=++i.commentHandle,c.set(t,d));const s=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:d,body:y.MarkdownString.from(t.body),userName:t.author.name,userIconPath:s,label:t.label,commentReactions:t.reactions?t.reactions.map(h=>g(h)):void 0}}function g(i){return{label:i.label,iconPath:i.iconPath?y.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function o(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?n.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function b(i){if(i!==void 0)switch(i){case T.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=a}),define(me[130],ge([0,1,2,5,7,4,14,12,17,8,9]),function(Y,e,m,L,D,C,n,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bi{constructor(w,f){this._logService=f,this._provider=new Map,this._proxy=w.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,f){const v=bi._handlePool++;this._provider.set(v,{provider:w,extensionId:f}),this._proxy.$registerDecorationProvider(v,f.value);const _=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(v,null);return}let p=(0,S.asArray)(P);if(p.length<=bi._maxEventSize){this._proxy.$onDidChange(v,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,p.length);const l=p.map(o=>({uri:o,rank:(0,y.count)(o.path,"/")})),r=(0,S.groupBy)(l,(o,b)=>o.rank-b.rank||(0,y.compare)(o.uri.path,b.uri.path));let g=[];e:for(let o of r){let b;for(let i of o){let t=(0,T.dirname)(i.uri.path);if(b!==t&&(b=t,g.push(i.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(v,g)});return new D.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(w,f,v){if(!this._provider.has(w))return Object.create(null);const _=Object.create(null),{provider:P,extensionId:p}=this._provider.get(w);return await Promise.all(f.map(async l=>{try{const{uri:r,id:g}=l,o=await Promise.resolve(P.provideFileDecoration(m.URI.revive(r),v));if(!o)return;try{D.FileDecoration.validate(o),_[g]=[o.propagate,o.tooltip,o.badge,o.color]}catch(b){this._logService.warn(`INVALID decoration from extension '${p.value}': ${b}`)}}catch(r){this._logService.error(r)}})),_}};I._handlePool=0,I._maxEventSize=250,I=Ve([We(0,n.IExtHostRpcService),We(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[233],ge([0,1,162,116,2,5,7,16,3,12,24,45]),function(Y,e,m,L,D,C,n,k,S,y,T,I){"use strict";var a,w,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(p,l,r,g,o,b){this._name=p,this._owner=l,this._maxDiagnosticsPerFile=r,a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,ot(this,f,new T.ResourceMap(i=>g.getComparisonKey(i)),"f"),ot(this,a,o,"f"),ot(this,w,b,"f")}dispose(){this._isDisposed||(Oe(this,w,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,l){if(!p){this.clear();return}this._checkDisposed();let r=[];if(D.URI.isUri(p)){if(!l){this.delete(p);return}Oe(this,f,"f").set(p,l.slice()),r=[p]}else if(Array.isArray(p)){r=[];let o;p=[...p].sort(v._compareIndexedTuplesByUri);for(const b of p){const[i,t]=b;if((!o||i.toString()!==o.toString())&&(o&&Oe(this,f,"f").get(o).length===0&&Oe(this,f,"f").delete(o),o=i,r.push(i),Oe(this,f,"f").set(i,[])),t){const c=Oe(this,f,"f").get(i);c&&c.push(...t)}else{const c=Oe(this,f,"f").get(i);c&&(c.length=0)}}}if(Oe(this,w,"f").fire(r),!Oe(this,a,"f"))return;const g=[];for(let o of r){let b=[];const i=Oe(this,f,"f").get(o);if(i)if(i.length>this._maxDiagnosticsPerFile){b=[];const t=[n.DiagnosticSeverity.Error,n.DiagnosticSeverity.Warning,n.DiagnosticSeverity.Information,n.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(let d of i)if(d.severity===t[c]&&b.push(k.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;b.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:b[b.length-1].startLineNumber,startColumn:b[b.length-1].startColumn,endLineNumber:b[b.length-1].endLineNumber,endColumn:b[b.length-1].endColumn})}else b=i.map(t=>k.Diagnostic.from(t));g.push([o,b])}Oe(this,a,"f").$changeMany(this._owner,g)}delete(p){this._checkDisposed(),Oe(this,w,"f").fire([p]),Oe(this,f,"f").delete(p),Oe(this,a,"f")&&Oe(this,a,"f").$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Oe(this,w,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner)}forEach(p,l){this._checkDisposed();for(let r of Oe(this,f,"f").keys())p.apply(l,[r,this.get(r),this])}get(p){this._checkDisposed();const l=Oe(this,f,"f").get(p);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,l){return p[0].toString()<l[0].toString()?-1:p[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=v,a=new WeakMap,w=new WeakMap,f=new WeakMap;let _=class ri{constructor(p,l,r){this._logService=l,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=p.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(p){const l=new T.ResourceMap;for(const r of p)l.set(r,r);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(p,l){const{_collections:r,_proxy:g,_onDidChangeDiagnostics:o,_logService:b,_fileSystemInfoService:i}=this,t=new class{$changeMany(s,h){g.$changeMany(s,h),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,s,h.length===0?"CLEARING":h)}$clear(s){g.$clear(s),b.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,s)}dispose(){g.dispose()}};let c;if(!l)l="_generated_diagnostic_collection_name_#"+ri._idPool++,c=l;else if(!r.has(l))c=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do c=l+ri._idPool++;while(r.has(c))}return new class extends v{constructor(){super(l,c,ri._maxDiagnosticsPerFile,i.extUri,t,o);r.set(c,this)}dispose(){super.dispose(),r.delete(c)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const l=new Map,r=[];for(const g of this._collections.values())g.forEach((o,b)=>{let i=l.get(o.toString());typeof i=="undefined"&&(i=r.length,l.set(o.toString(),i),r.push([o,[]])),r[i][1]=r[i][1].concat(...b)});return r}}_getDiagnostics(p){let l=[];for(let r of this._collections.values())r.has(p)&&(l=l.concat(r.get(p)));return l}$acceptMarkersChange(p){if(!this._mirrorCollection){const l="_generated_mirror",r=new v(l,l,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(l,r),this._mirrorCollection=r}for(const[l,r]of p)this._mirrorCollection.set(D.URI.revive(l),r.map(k.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=Ve([We(1,y.ILogService),We(2,I.IExtHostFileSystemInfo)],_),e.ExtHostDiagnostics=_}),define(me[234],ge([0,1,2,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(n){this._proxy=n.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(n){return this._proxy.$showOpenDialog(n).then(k=>k?k.map(S=>m.URI.revive(S)):void 0)}showSaveDialog(n){return this._proxy.$showSaveDialog(n).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=D}),define(me[235],ge([0,1,15,2,7,5,10,21,8]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{constructor(I,a,w){this._documentsAndEditors=a,this._logService=w,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,a){if(Object.keys(n.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const w=y._handlePool++;this._documentContentProviders.set(w,a),this._proxy.$registerTextContentProvider(w,I);let f;return typeof a.onDidChange=="function"&&(f=a.onDidChange(v=>{if(v.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(w,v).then(_=>{if(!_&&typeof _!="string")return;const P=this._documentsAndEditors.getDocument(v);if(!P)return;const p=(0,S.splitLines)(_);if(!P.equalLines(p))return this._proxy.$onVirtualDocumentChange(v,_)},m.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(w)&&this._proxy.$unregisterTextContentProvider(w),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(I,a){const w=this._documentContentProviders.get(I);return w?Promise.resolve(w.provideTextDocumentContent(L.URI.revive(a),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=y,y._handlePool=0}),define(me[236],ge([0,1,3,6,2,5,122,16,13,25,7]),function(Y,e,m,L,D,C,n,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(w,f){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!w)return;const f=this._documentsAndEditors.getDocument(w);if(f)return f}getDocument(w){const f=this.getDocumentData(w);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return f.document}ensureDocumentData(w){const f=this._documentsAndEditors.getDocument(w);if(f)return Promise.resolve(f);let v=this._documentLoader.get(w.toString());return v||(v=this._proxy.$tryOpenDocument(w).then(_=>{this._documentLoader.delete(w.toString());const P=D.URI.revive(_);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(P))},_=>(this._documentLoader.delete(w.toString()),Promise.reject(_))),this._documentLoader.set(w.toString(),v)),v}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(f=>D.URI.revive(f))}$acceptModelModeChanged(w,f){const v=D.URI.revive(w),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(f),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(w){const f=D.URI.revive(w),v=this._documentsAndEditors.getDocument(f);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(w,f){const v=D.URI.revive(w),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(f),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,f,v){const _=D.URI.revive(w),P=this._documentsAndEditors.getDocument(_);if(!P)throw new Error("unknown document");P._acceptIsDirty(v),P.onEvents(f);let p;f.isUndoing?p=T.TextDocumentChangeReason.Undo:f.isRedoing&&(p=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,y.deepFreeze)({document:P.document,contentChanges:f.changes.map(l=>({range:k.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:p}))}setWordDefinitionFor(w,f){(0,n.setWordDefinitionFor)(w,f)}}e.ExtHostDocuments=I}),define(me[46],ge([0,1,56,3,6,2,4,5,122,14,129,16,12,24,10,76,140]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(r,g){this._extHostRpc=r,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new w.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const g=[],o=[],b=[];if(r.removedDocuments)for(const i of r.removedDocuments){const t=C.URI.revive(i),c=this._documents.get(t);c?.unref()&&(this._documents.delete(t),g.push(c.value))}if(r.addedDocuments)for(const i of r.addedDocuments){const t=C.URI.revive(i.uri);let c=this._documents.get(t);if(c&&t.scheme!==f.Schemas.vscodeNotebookCell&&t.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);c||(c=new P(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(t,c),o.push(c.value)),c.ref()}if(r.removedEditors)for(const i of r.removedEditors){const t=this._editors.get(i);this._editors.delete(i),t&&b.push(t)}if(r.addedEditors)for(const i of r.addedEditors){const t=C.URI.revive(i.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const c=this._documents.get(t).value,d=new T.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>c.document),i.selections.map(I.Selection.to),i.options,i.visibleRanges.map(s=>I.Range.to(s)),typeof i.editorPosition=="number"?I.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,d)}r.newActiveEditor!==void 0&&(m.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,D.dispose)(g),(0,D.dispose)(b),r.removedDocuments&&this._onDidRemoveDocuments.fire(g),r.addedDocuments&&this._onDidAddDocuments.fire(o),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return r?g:g?.value}allEditors(){return[...this._editors.values()]}};p=Ve([We(0,y.IExtHostRpcService),We(1,a.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,n.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[54],ge([0,1,16,5,2,3,4,14,18]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,n.createDecorator)("IExtHostEditorTabs");let y=class{constructor(I){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let a=-1;this._tabs=I.map((f,v)=>(f.isActive&&(a=v),Object.freeze({label:f.label,viewColumn:m.ViewColumn.to(f.viewColumn),index:v,resource:D.URI.revive(f.resource),additionalResourcesAndViewIds:f.additionalResourcesAndViewIds.map(({resource:_,viewId:P})=>({resource:D.URI.revive(_),viewId:P})),viewId:f.editorId,isActive:f.isActive,move:async(_,P)=>{this._proxy.$moveTab(f,_,m.ViewColumn.from(P)),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(f),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((f,v)=>f.viewColumn===v.viewColumn?f.index-v.index:f.viewColumn-v.viewColumn);const w=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==w&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};y=Ve([We(0,k.IExtHostRpcService)],y),e.ExtHostEditorTabs=y}),define(me[237],ge([0,1,2,5,6,7,16,147,8,22,29]),function(Y,e,m,L,D,C,n,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const v=this._schemes.indexOf(f);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),v=[];let _,P,p=14,l=14;for(const r of f){let g=_?(0,S.commonPrefixLength)(_,r):0;for(g===0?P=1:P=l;g<r.length;g++)g+1===r.length?(p=l,l=9):l+=1,v.push([P,r.toUpperCase().charCodeAt(g),l]),v.push([P,r.toLowerCase().charCodeAt(g),l]),P=l;_=r,l=p}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new k.StateMachine(v)}}provideDocumentLinks(f){this._initStateMachine();const v=[],_=k.LinkComputer.computeLinks({getLineContent(P){return f.lineAt(P-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const P of _){const p=n.DocumentLink.to(P);p.target&&v.push(p)}return v}}class a{constructor(f,v){this._extHostLanguageFeatures=v,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,v,_,P={}){if(this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(p,_);let l=2;P.isCaseSensitive&&(l+=1024),P.isReadonly&&(l+=2048),typeof _.copy=="function"&&(l+=8),typeof _.open=="function"&&typeof _.close=="function"&&typeof _.read=="function"&&typeof _.write=="function"&&((0,T.checkProposedApiEnabled)(f,"fsChunks"),l+=4),this._proxy.$registerFileSystemProvider(p,v,l).catch(g=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${v}`),console.error(g)});const r=_.onDidChangeFile(g=>{const o=[];for(const b of g){let{uri:i,type:t}=b;if(i.scheme!==v)continue;let c;switch(t){case C.FileChangeType.Changed:c=0;break;case C.FileChangeType.Created:c=1;break;case C.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:i,type:c})}this._proxy.$onFileSystemChange(p,o)});return(0,D.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(f){const{type:v,ctime:_,mtime:P,size:p,permissions:l}=f;return{type:v,ctime:_,mtime:P,size:p,permissions:l}}$stat(f,v){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(v))).then(_=>a._asIStat(_))}$readdir(f,v){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(v)))}$readFile(f,v){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(v))).then(_=>y.VSBuffer.wrap(_))}$writeFile(f,v,_,P){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(v),_.buffer,P))}$delete(f,v,_){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(v),_))}$rename(f,v,_,P){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(v),m.URI.revive(_),P))}$copy(f,v,_,P){const p=this._getFsProvider(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(m.URI.revive(v),m.URI.revive(_),P))}$mkdir(f,v){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(v)))}$watch(f,v,_,P){const p=this._getFsProvider(f).watch(m.URI.revive(_),P);this._watches.set(v,p)}$unwatch(f,v){const _=this._watches.get(v);_&&(_.dispose(),this._watches.delete(v))}$open(f,v,_){const P=this._getFsProvider(f);if(!P.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(P.open(m.URI.revive(v),_))}$close(f,v){const _=this._getFsProvider(f);if(!_.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(_.close(v))}$read(f,v,_,P){const p=this._getFsProvider(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const l=y.VSBuffer.alloc(P);return Promise.resolve(p.read(v,_,l.buffer,0,P)).then(r=>l.slice(0,r))}$write(f,v,_,P){const p=this._getFsProvider(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(v,_,P.buffer,0,P.byteLength))}_getFsProvider(f){const v=this._fsProvider.get(f);if(!v){const _=new Error;throw _.name="ENOPRO",_.message="no provider",_}return v}}e.ExtHostFileSystem=a}),define(me[66],ge([0,1,5,42,7,22,4,14,45,6]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Wt{constructor(a,w){this._fileSystemProvider=new Map,this._proxy=a.getProxy(m.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(v){try{const _=f._fileSystemProvider.get(v.scheme);if(!_)return await f._proxy.$stat(v);await f._proxy.$ensureActivation(v.scheme);const P=await _.stat(v);return{type:P.type,ctime:P.ctime,mtime:P.mtime,size:P.size,permissions:P.permissions}}catch(_){Wt._handleError(_)}},async readDirectory(v){try{const _=f._fileSystemProvider.get(v.scheme);return _?(await f._proxy.$ensureActivation(v.scheme),(await _.readDirectory(v)).slice()):await f._proxy.$readdir(v)}catch(_){return Wt._handleError(_)}},async createDirectory(v){try{return await f._proxy.$mkdir(v)}catch(_){return Wt._handleError(_)}},async readFile(v){try{const _=f._fileSystemProvider.get(v.scheme);return _?(await f._proxy.$ensureActivation(v.scheme),(await _.readFile(v)).slice()):f._proxy.$readFile(v).then(P=>P.buffer)}catch(_){return Wt._handleError(_)}},async writeFile(v,_){try{return await f._proxy.$writeFile(v,C.VSBuffer.wrap(_))}catch(P){return Wt._handleError(P)}},async delete(v,_){try{const P=f._fileSystemProvider.get(v.scheme);return P?(await f._proxy.$ensureActivation(v.scheme),await P.delete(v,{recursive:!1,..._})):await f._proxy.$delete(v,{recursive:!1,useTrash:!1,..._})}catch(P){return Wt._handleError(P)}},async rename(v,_,P){try{return await f._proxy.$rename(v,_,{overwrite:!1,...P})}catch(p){return Wt._handleError(p)}},async copy(v,_,P){try{return await f._proxy.$copy(v,_,{overwrite:!1,...P})}catch(p){return Wt._handleError(p)}},isWritableFileSystem(v){const _=w.getCapabilities(v);if(typeof _=="number")return!(_&2048)}})}static _handleError(a){if(a instanceof D.FileSystemError)throw a;if(!(a instanceof Error))throw new D.FileSystemError(String(a));if(a.name==="ENOPRO")throw D.FileSystemError.Unavailable(a.message);switch(a.name){case L.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(a.message);case L.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(a.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(a.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(a.message);case L.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(a.message);case L.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(a.message);default:throw new D.FileSystemError(a.message,a.name)}}addFileSystemProvider(a,w){return this._fileSystemProvider.set(a,w),(0,y.toDisposable)(()=>this._fileSystemProvider.delete(a))}};T=Ve([We(0,k.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,n.createDecorator)("IExtHostConsumerFileSystem")}),define(me[238],ge([0,1,2,38]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(n,k,S,y){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=y;const T=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(T)}$willAddInteractiveDocument(n,k,S,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:n,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(n,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[n]})}}e.ExtHostInteractive=D}),define(me[239],ge([0,1,6,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(n){this._handlePool=0,this._proxy=n.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(n){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,n),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=D}),define(me[240],ge([0,1,2,25,16,7,5,8,41,17,13,144,6,111,75,88,47,15,3]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(G,Z){this._documents=G,this._provider=Z}async provideDocumentSymbols(G,Z){const ne=this._documents.getDocument(G),ce=await this._provider.provideDocumentSymbols(ne,Z);if(!(0,y.isFalsyOrEmpty)(ce))return ce[0]instanceof C.DocumentSymbol?ce.map(D.DocumentSymbol.from):l._asDocumentSymbolTree(ce)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((ce,J)=>{let te=ce.location.range.start.compareTo(J.location.range.start);return te===0&&(te=J.location.range.end.compareTo(ce.location.range.end)),te});const Z=[],ne=[];for(const ce of G){const J={name:ce.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ce.kind),tags:ce.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:ce.containerName,range:D.Range.from(ce.location.range),selectionRange:D.Range.from(ce.location.range),children:[]};for(;;){if(ne.length===0){ne.push(J),Z.push(J);break}const te=ne[ne.length-1];if(S.Range.containsRange(te.range,J.range)&&!S.Range.equalsRange(te.range,J.range)){te.children&&te.children.push(J),ne.push(J);break}ne.pop()}}return Z}}class r{constructor(G,Z,ne){this._documents=G,this._commands=Z,this._provider=ne,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,Z){const ne=this._documents.getDocument(G),ce=await this._provider.provideCodeLenses(ne,Z);if(!ce||Z.isCancellationRequested)return;const J=this._cache.add(ce),te=new a.DisposableStore;this._disposables.set(J,te);const ve={cacheId:J,lenses:[]};for(let Me=0;Me<ce.length;Me++)ve.lenses.push({cacheId:[J,Me],range:D.Range.from(ce[Me].range),command:this._commands.toInternal(ce[Me].command,te)});return ve}async resolveCodeLens(G,Z){const ne=G.cacheId&&this._cache.get(...G.cacheId);if(!ne)return;let ce;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?ce=ne:ce=await this._provider.resolveCodeLens(ne,Z),ce||(ce=ne),Z.isCancellationRequested)return;const J=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!J)return G.command=this._commands.toInternal(ce.command??r._badCmd,J),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(ze){return Array.isArray(ze)?ze.map(D.DefinitionLink.from):ze?[D.DefinitionLink.from(ze)]:[]}class o{constructor(G,Z){this._documents=G,this._provider=Z}async provideDefinition(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideDefinition(ce,J,ne);return g(te)}}class b{constructor(G,Z){this._documents=G,this._provider=Z}async provideDeclaration(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideDeclaration(ce,J,ne);return g(te)}}class i{constructor(G,Z){this._documents=G,this._provider=Z}async provideImplementation(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideImplementation(ce,J,ne);return g(te)}}class t{constructor(G,Z){this._documents=G,this._provider=Z}async provideTypeDefinition(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideTypeDefinition(ce,J,ne);return g(te)}}class c{constructor(G,Z){this._documents=G,this._provider=Z}async provideHover(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideHover(ce,J,ne);if(!(!te||(0,y.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=ce.getWordRangeAtPosition(J)),te.range||(te.range=new C.Range(J,J)),D.Hover.from(te)}}class d{constructor(G,Z){this._documents=G,this._provider=Z}async provideEvaluatableExpression(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideEvaluatableExpression(ce,J,ne);if(te)return D.EvaluatableExpression.from(te)}}class s{constructor(G,Z){this._documents=G,this._provider=Z}async provideInlineValues(G,Z,ne,ce){const J=this._documents.getDocument(G),te=await this._provider.provideInlineValues(J,D.Range.to(Z),D.InlineValueContext.to(ne),ce);if(Array.isArray(te))return te.map(ve=>D.InlineValue.from(ve))}}class h{constructor(G,Z){this._documents=G,this._provider=Z}async provideDocumentHighlights(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideDocumentHighlights(ce,J,ne);if(Array.isArray(te))return te.map(D.DocumentHighlight.from)}}class u{constructor(G,Z){this._documents=G,this._provider=Z}async provideLinkedEditingRanges(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.provideLinkedEditingRanges(ce,J,ne);if(te&&Array.isArray(te.ranges))return{ranges:(0,y.coalesce)(te.ranges.map(D.Range.from)),wordPattern:te.wordPattern}}}class E{constructor(G,Z){this._documents=G,this._provider=Z}async provideReferences(G,Z,ne,ce){const J=this._documents.getDocument(G),te=D.Position.to(Z),ve=await this._provider.provideReferences(J,te,ne,ce);if(Array.isArray(ve))return ve.map(D.location.from)}}class A{constructor(G,Z,ne,ce,J,te,ve){this._documents=G,this._commands=Z,this._diagnostics=ne,this._provider=ce,this._logService=J,this._extension=te,this._apiDeprecation=ve,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,Z,ne,ce){const J=this._documents.getDocument(G),te=I.Selection.isISelection(Z)?D.Selection.to(Z):D.Range.to(Z),ve=[];for(const ut of this._diagnostics.getDiagnostics(G))if(te.intersection(ut.range)&&ve.push(ut)>A._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:ne.only?new C.CodeActionKind(ne.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ne.trigger)},je=await this._provider.provideCodeActions(J,te,Me,ce);if(!(0,y.isNonEmptyArray)(je)||ce.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new a.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ut=0;ut<je.length;ut++){const it=je[ut];!it||(A._isCommand(it)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:it.title,command:this._commands.toInternal(it,Ze)})):(Me.only&&(it.kind?Me.only.contains(it.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ut],title:it.title,command:it.command&&this._commands.toInternal(it.command,Ze),diagnostics:it.diagnostics&&it.diagnostics.map(D.Diagnostic.from),edit:it.edit&&D.WorkspaceEdit.from(it.edit),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,disabled:it.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,Z){const[ne,ce]=G,J=this._cache.get(ne,ce);if(!J||A._isCommand(J)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(J,Z)??J;return te?.edit?D.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}A._maxCodeActionsPerFile=1e3;class R{constructor(G,Z){this._documents=G,this._provider=Z}async provideDocumentFormattingEdits(G,Z,ne){const ce=this._documents.getDocument(G),J=await this._provider.provideDocumentFormattingEdits(ce,Z,ne);if(Array.isArray(J))return J.map(D.TextEdit.from)}}class ${constructor(G,Z){this._documents=G,this._provider=Z}async provideDocumentRangeFormattingEdits(G,Z,ne,ce){const J=this._documents.getDocument(G),te=D.Range.to(Z),ve=await this._provider.provideDocumentRangeFormattingEdits(J,te,ne,ce);if(Array.isArray(ve))return ve.map(D.TextEdit.from)}}class N{constructor(G,Z){this._documents=G,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,Z,ne,ce,J){const te=this._documents.getDocument(G),ve=D.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(te,ve,ne,ce,J);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class F{constructor(G,Z){this._provider=G,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,Z){const ne=n.IdObject.mixin({symbols:[]}),ce=await this._provider.provideWorkspaceSymbols(G,Z);if((0,y.isNonEmptyArray)(ce))for(const J of ce){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const te=n.IdObject.mixin(D.WorkspaceSymbol.from(J));this._symbolCache.set(te._id,J),ne.symbols.push(te)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(G,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const ne=this._symbolCache.get(G._id);if(ne){const ce=await this._provider.resolveWorkspaceSymbol(ne,Z);return ce&&(0,L.mixin)(G,D.WorkspaceSymbol.from(ce),!0)}}releaseWorkspaceSymbols(G){const Z=this._resultCache.get(G);if(Z){for(let[ne,ce]=Z;ne<=ce;ne++)this._symbolCache.delete(ne);this._resultCache.delete(G)}}}class z{constructor(G,Z,ne){this._documents=G,this._provider=Z,this._logService=ne}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,Z,ne,ce){const J=this._documents.getDocument(G),te=D.Position.to(Z);try{const ve=await this._provider.provideRenameEdits(J,te,ne,ce);return ve?D.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=z._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(G,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ce=this._documents.getDocument(G),J=D.Position.to(Z);try{const te=await this._provider.prepareRename(ce,J,ne);let ve,Me;if(C.Range.isRange(te)?(ve=te,Me=ce.getText(te)):(0,T.isObject)(te)&&(ve=te.range,Me=te.placeholder),!ve||!Me)return;if(ve.start.line>J.line||ve.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ve),text:Me}}catch(te){const ve=z._asMessage(te);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,Z){this.resultId=G,this.tokens=Z}}class W{constructor(G,Z){this._documents=G,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,Z,ne){const ce=this._documents.getDocument(G),J=Z!==0?this._previousResults.get(Z):null;let te=typeof J?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ce,J.resultId,ne):await this._provider.provideDocumentSemanticTokens(ce,ne);return J&&this._previousResults.delete(Z),te?(te=W._fixProvidedSemanticTokens(te),this._send(W._convertToEdits(J,te),te)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return W._isSemanticTokens(G)?W._isCorrectSemanticTokens(G)?G:new C.SemanticTokens(new Uint32Array(G.data),G.resultId):W._isSemanticTokensEdits(G)?W._isCorrectSemanticTokensEdits(G)?G:new C.SemanticTokensEdits(G.edits.map(Z=>new C.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const Z of G.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,Z){if(!W._isSemanticTokens(Z)||!G||!G.tokens)return Z;const ne=G.tokens,ce=ne.length,J=Z.data,te=J.length;let ve=0;const Me=Math.min(ce,te);for(;ve<Me&&ne[ve]===J[ve];)ve++;if(ve===ce&&ve===te)return new C.SemanticTokensEdits([],Z.resultId);let je=0;const Ke=Me-ve;for(;je<Ke&&ne[ce-je-1]===J[te-je-1];)je++;return new C.SemanticTokensEdits([{start:ve,deleteCount:ce-ve-je,data:J.subarray(ve,te-je)}],Z.resultId)}_send(G,Z){if(W._isSemanticTokens(G)){const ne=this._nextResultId++;return this._previousResults.set(ne,new M(G.resultId,G.data)),(0,w.encodeSemanticTokensDto)({id:ne,type:"full",data:G.data})}if(W._isSemanticTokensEdits(G)){const ne=this._nextResultId++;return W._isSemanticTokens(Z)?this._previousResults.set(ne,new M(Z.resultId,Z.data)):this._previousResults.set(ne,new M(G.resultId)),(0,w.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(G.edits||[]).map(ce=>({start:ce.start,deleteCount:ce.deleteCount,data:ce.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class U{constructor(G,Z){this._documents=G,this._provider=Z}async provideDocumentRangeSemanticTokens(G,Z,ne){const ce=this._documents.getDocument(G),J=await this._provider.provideDocumentRangeSemanticTokens(ce,D.Range.to(Z),ne);return J?this._send(J):null}_send(G){return(0,w.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(G,Z,ne,ce,J){this._documents=G,this._commands=Z,this._provider=ne,this._apiDeprecation=ce,this._extension=J,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,Z,ne,ce){const J=this._documents.getDocument(G),te=D.Position.to(Z),ve=J.getWordRangeAtPosition(te)||new C.Range(te,te),Me=ve.with({end:te}),je=new _.StopWatch(!0),Ke=await this._provider.provideCompletionItems(J,te,ce,D.CompletionContext.to(ne));if(!Ke||ce.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,rt=x.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ut=new a.DisposableStore;this._disposables.set(rt,ut);const it=[],st={x:rt,b:it,a:{replace:D.Range.from(ve),insert:D.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let Ae=0;Ae<Ze.items.length;Ae++){const wt=Ze.items[Ae],ee=this._convertCompletionItem(wt,[rt,Ae],Me,ve);it.push(ee)}return st}async resolveCompletionItem(G,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...G);if(!ne)return;const ce=await this._provider.resolveCompletionItem(ne,Z);if(!!ce)return this._convertCompletionItem(ce,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,Z,ne,ce){const J=this._disposables.get(Z[0]);if(!J)throw Error("DisposableStore is missing...");const te={x:Z,a:G.label,b:G.kind!==void 0?D.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(D.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(G.command,J)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=G.textEdit.newText):typeof G.insertText=="string"?te.h=G.insertText:G.insertText instanceof C.SnippetString&&(te.h=G.insertText.value,te.i|=4);let ve;return G.textEdit?ve=G.textEdit.range:G.range&&(ve=G.range),C.Range.isRange(ve)?te.j=D.Range.from(ve):ve&&(!ne?.isEqual(ve.inserting)||!ce?.isEqual(ve.replacing))&&(te.j={insert:D.Range.from(ve.inserting),replace:D.Range.from(ve.replacing)}),te}}class B{constructor(G,Z,ne){this._documents=G,this._provider=Z,this._commands=ne,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,Z,ne,ce){const J=this._documents.getDocument(G),te=D.Position.to(Z),ve=await this._provider.provideInlineCompletionItems(J,te,{selectedCompletionInfo:ne.selectedSuggestionInfo?{range:D.Range.to(ne.selectedSuggestionInfo.range),text:ne.selectedSuggestionInfo.text}:void 0,triggerKind:ne.triggerKind},ce);if(!ve||ce.isCancellationRequested)return;const Me=(0,T.isArray)(ve)?{items:ve}:ve,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ut;return Ze.command&&(Ke||(Ke=new a.DisposableStore,this._disposables.set(je,Ke)),ut=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?D.Range.from(Ze.range):void 0,command:ut,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const Z=this._disposables.get(G);Z&&Z.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,Z){const ne=this._cache.get(G,Z);ne&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new p.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let Z=O.map.get(G);return Z||(Z=new O,O.map.set(G,Z)),Z}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class H{constructor(G,Z){this._documents=G,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(G,Z,ne,ce){const J=this._documents.getDocument(G),te=D.Position.to(Z),ve=this.reviveContext(ne),Me=await this._provider.provideSignatureHelp(J,te,ce,ve);if(Me){const je=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:je}}}reviveContext(G){let Z;if(G.activeSignatureHelp){const ne=D.SignatureHelp.to(G.activeSignatureHelp),ce=this._cache.get(G.activeSignatureHelp.id,0);ce?(Z=ce,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return{...G,activeSignatureHelp:Z}}releaseSignatureHelp(G){this._cache.delete(G)}}class j{constructor(G,Z){this._documents=G,this._provider=Z}async provideInlayHints(G,Z,ne){const ce=this._documents.getDocument(G),J=await this._provider.provideInlayHints(ce,D.Range.to(Z),ne);return J?{hints:J.map(D.InlayHint.from)}:void 0}}class X{constructor(G,Z){this._documents=G,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(G,Z){const ne=this._documents.getDocument(G),ce=await this._provider.provideDocumentLinks(ne,Z);if(!(!Array.isArray(ce)||ce.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ce.filter(X._validateLink).map(D.DocumentLink.from)};{const J=this._cache.add(ce),te={links:[],id:J};for(let ve=0;ve<ce.length;ve++){if(!X._validateLink(ce[ve]))continue;const Me=D.DocumentLink.from(ce[ve]);Me.cacheId=[J,ve],te.links.push(Me)}return te}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...G);if(!ne)return;const ce=await this._provider.resolveDocumentLink(ne,Z);if(!(!ce||!X._validateLink(ce)))return D.DocumentLink.from(ce)}releaseLinks(G){this._cache.delete(G)}}class K{constructor(G,Z){this._documents=G,this._provider=Z}async provideColors(G,Z){const ne=this._documents.getDocument(G),ce=await this._provider.provideDocumentColors(ne,Z);return Array.isArray(ce)?ce.map(te=>({color:D.Color.from(te.color),range:D.Range.from(te.range)})):[]}async provideColorPresentations(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Range.to(Z.range),te=D.Color.to(Z.color),ve=await this._provider.provideColorPresentations(te,{document:ce,range:J},ne);if(!!Array.isArray(ve))return ve.map(D.ColorPresentation.from)}}class he{constructor(G,Z){this._documents=G,this._provider=Z}async provideFoldingRanges(G,Z,ne){const ce=this._documents.getDocument(G),J=await this._provider.provideFoldingRanges(ce,Z,ne);if(!!Array.isArray(J))return J.map(D.FoldingRange.from)}}class Ee{constructor(G,Z,ne){this._documents=G,this._provider=Z,this._logService=ne}async provideSelectionRanges(G,Z,ne){const ce=this._documents.getDocument(G),J=Z.map(D.Position.to),te=await this._provider.provideSelectionRanges(ce,J,ne);if(!(0,y.isNonEmptyArray)(te))return[];if(te.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<J.length;Me++){const je=[];ve.push(je);let Ke=J[Me],Ze=te[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(D.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return ve}}class De{constructor(G,Z){this._documents=G,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.prepareCallHierarchy(ce,J,ne);if(!te)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(te)?te.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,te)]}async provideCallsTo(G,Z,ne){const ce=this._itemFromCache(G,Z);if(!ce)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(ce,ne);if(!!J)return J.map(te=>({from:this._cacheAndConvertItem(G,te.from),fromRanges:te.fromRanges.map(ve=>D.Range.from(ve))}))}async provideCallsFrom(G,Z,ne){const ce=this._itemFromCache(G,Z);if(!ce)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(ce,ne);if(!!J)return J.map(te=>({to:this._cacheAndConvertItem(G,te.to),fromRanges:te.fromRanges.map(ve=>D.Range.from(ve))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,Z){const ne=this._cache.get(G),ce=D.CallHierarchyItem.from(Z,G,ne.size.toString(36));return ne.set(ce._itemId,Z),ce}_itemFromCache(G,Z){return this._cache.get(G)?.get(Z)}}class Pe{constructor(G,Z){this._documents=G,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(G,Z,ne){const ce=this._documents.getDocument(G),J=D.Position.to(Z),te=await this._provider.prepareTypeHierarchy(ce,J,ne);if(!te)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(te)?te.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,te)]}async provideSupertypes(G,Z,ne){const ce=this._itemFromCache(G,Z);if(!ce)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySupertypes(ce,ne);if(!!J)return J.map(te=>this._cacheAndConvertItem(G,te))}async provideSubtypes(G,Z,ne){const ce=this._itemFromCache(G,Z);if(!ce)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySubtypes(ce,ne);if(!!J)return J.map(te=>this._cacheAndConvertItem(G,te))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,Z){const ne=this._cache.get(G),ce=D.TypeHierarchyItem.from(Z,G,ne.size.toString(36));return ne.set(ce._itemId,Z),ce}_itemFromCache(G,Z){return this._cache.get(G)?.get(Z)}}class Be{constructor(G,Z){this.adapter=G,this.extension=Z}}class He{constructor(G,Z,ne,ce,J,te,ve){this._adapter=new Map,this._uriTransformer=Z,this._proxy=G.getProxy(n.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=ce,this._diagnostics=J,this._logService=te,this._apiDeprecation=ve}_transformDocumentSelector(G){return D.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new C.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return He._handlePool++}_withAdapter(G,Z,ne,ce,J=!1){const te=this._adapter.get(G);if(!te)return Promise.resolve(ce);if(te.adapter instanceof Z){let ve;te.extension&&(ve=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=ne(te.adapter,te.extension),je=te.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ke=>{J&&Ke instanceof P.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,Z){const ne=this._nextHandle();return this._adapter.set(ne,new Be(G,Z)),ne}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,Z,ne,ce){const J=this._addNewAdapter(new l(this._documents,ne),G),te=ce&&ce.label||He._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Z),te),this._createDisposable(J)}$provideDocumentSymbols(G,Z,ne){return this._withAdapter(G,l,ce=>ce.provideDocumentSymbols(m.URI.revive(Z),ne),void 0)}registerCodeLensProvider(G,Z,ne){const ce=this._nextHandle(),J=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new r(this._documents,this._commands.converter,ne),G)),this._proxy.$registerCodeLensSupport(ce,this._transformDocumentSelector(Z),J);let te=this._createDisposable(ce);if(J!==void 0){const ve=ne.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(J));te=C.Disposable.from(te,ve)}return te}$provideCodeLenses(G,Z,ne){return this._withAdapter(G,r,ce=>ce.provideCodeLenses(m.URI.revive(Z),ne),void 0)}$resolveCodeLens(G,Z,ne){return this._withAdapter(G,r,ce=>ce.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(G,Z){this._withAdapter(G,r,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(G,Z,ne){const ce=this._addNewAdapter(new o(this._documents,ne),G);return this._proxy.$registerDefinitionSupport(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideDefinition(G,Z,ne,ce){return this._withAdapter(G,o,J=>J.provideDefinition(m.URI.revive(Z),ne,ce),[])}registerDeclarationProvider(G,Z,ne){const ce=this._addNewAdapter(new b(this._documents,ne),G);return this._proxy.$registerDeclarationSupport(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideDeclaration(G,Z,ne,ce){return this._withAdapter(G,b,J=>J.provideDeclaration(m.URI.revive(Z),ne,ce),[])}registerImplementationProvider(G,Z,ne){const ce=this._addNewAdapter(new i(this._documents,ne),G);return this._proxy.$registerImplementationSupport(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideImplementation(G,Z,ne,ce){return this._withAdapter(G,i,J=>J.provideImplementation(m.URI.revive(Z),ne,ce),[])}registerTypeDefinitionProvider(G,Z,ne){const ce=this._addNewAdapter(new t(this._documents,ne),G);return this._proxy.$registerTypeDefinitionSupport(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideTypeDefinition(G,Z,ne,ce){return this._withAdapter(G,t,J=>J.provideTypeDefinition(m.URI.revive(Z),ne,ce),[])}registerHoverProvider(G,Z,ne,ce){const J=this._addNewAdapter(new c(this._documents,ne),G);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideHover(G,Z,ne,ce){return this._withAdapter(G,c,J=>J.provideHover(m.URI.revive(Z),ne,ce),void 0)}registerEvaluatableExpressionProvider(G,Z,ne,ce){const J=this._addNewAdapter(new d(this._documents,ne),G);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideEvaluatableExpression(G,Z,ne,ce){return this._withAdapter(G,d,J=>J.provideEvaluatableExpression(m.URI.revive(Z),ne,ce),void 0)}registerInlineValuesProvider(G,Z,ne,ce){const J=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new s(this._documents,ne),G);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(Z),J);let ve=this._createDisposable(te);if(J!==void 0){const Me=ne.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(J));ve=C.Disposable.from(ve,Me)}return ve}$provideInlineValues(G,Z,ne,ce,J){return this._withAdapter(G,s,te=>te.provideInlineValues(m.URI.revive(Z),ne,ce,J),void 0)}registerDocumentHighlightProvider(G,Z,ne){const ce=this._addNewAdapter(new h(this._documents,ne),G);return this._proxy.$registerDocumentHighlightProvider(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideDocumentHighlights(G,Z,ne,ce){return this._withAdapter(G,h,J=>J.provideDocumentHighlights(m.URI.revive(Z),ne,ce),void 0)}registerLinkedEditingRangeProvider(G,Z,ne){const ce=this._addNewAdapter(new u(this._documents,ne),G);return this._proxy.$registerLinkedEditingRangeProvider(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideLinkedEditingRanges(G,Z,ne,ce){return this._withAdapter(G,u,async J=>{const te=await J.provideLinkedEditingRanges(m.URI.revive(Z),ne,ce);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?He._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider(G,Z,ne){const ce=this._addNewAdapter(new E(this._documents,ne),G);return this._proxy.$registerReferenceSupport(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideReferences(G,Z,ne,ce,J){return this._withAdapter(G,E,te=>te.provideReferences(m.URI.revive(Z),ne,ce,J),void 0)}registerCodeActionProvider(G,Z,ne,ce){const J=new a.DisposableStore,te=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(Z),{providedKinds:ce?.providedCodeActionKinds?.map(ve=>ve.value),documentation:ce?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,J)}))},He._extLabel(G),Boolean(ne.resolveCodeAction)),J.add(this._createDisposable(te)),J}$provideCodeActions(G,Z,ne,ce,J){return this._withAdapter(G,A,te=>te.provideCodeActions(m.URI.revive(Z),ne,ce,J),void 0)}$resolveCodeAction(G,Z,ne){return this._withAdapter(G,A,ce=>ce.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(G,Z){this._withAdapter(G,A,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(G,Z,ne){const ce=this._addNewAdapter(new R(this._documents,ne),G);return this._proxy.$registerDocumentFormattingSupport(ce,this._transformDocumentSelector(Z),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentFormattingEdits(G,Z,ne,ce){return this._withAdapter(G,R,J=>J.provideDocumentFormattingEdits(m.URI.revive(Z),ne,ce),void 0)}registerDocumentRangeFormattingEditProvider(G,Z,ne){const ce=this._addNewAdapter(new $(this._documents,ne),G);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(Z),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(G,Z,ne,ce,J){return this._withAdapter(G,$,te=>te.provideDocumentRangeFormattingEdits(m.URI.revive(Z),ne,ce,J),void 0)}registerOnTypeFormattingEditProvider(G,Z,ne,ce){const J=this._addNewAdapter(new N(this._documents,ne),G);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Z),ce,G.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(G,Z,ne,ce,J,te){return this._withAdapter(G,N,ve=>ve.provideOnTypeFormattingEdits(m.URI.revive(Z),ne,ce,J,te),void 0)}registerWorkspaceSymbolProvider(G,Z){const ne=this._addNewAdapter(new F(Z,this._logService),G);return this._proxy.$registerNavigateTypeSupport(ne,typeof Z.resolveWorkspaceSymbol=="function"),this._createDisposable(ne)}$provideWorkspaceSymbols(G,Z,ne){return this._withAdapter(G,F,ce=>ce.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(G,Z,ne){return this._withAdapter(G,F,ce=>ce.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(G,Z){this._withAdapter(G,F,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(G,Z,ne){const ce=this._addNewAdapter(new z(this._documents,ne,this._logService),G);return this._proxy.$registerRenameSupport(ce,this._transformDocumentSelector(Z),z.supportsResolving(ne)),this._createDisposable(ce)}$provideRenameEdits(G,Z,ne,ce,J){return this._withAdapter(G,z,te=>te.provideRenameEdits(m.URI.revive(Z),ne,ce,J),void 0)}$resolveRenameLocation(G,Z,ne,ce){return this._withAdapter(G,z,J=>J.resolveRenameLocation(m.URI.revive(Z),ne,ce),void 0)}registerDocumentSemanticTokensProvider(G,Z,ne,ce){const J=this._nextHandle(),te=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new Be(new W(this._documents,ne),G)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Z),ce,te);let ve=this._createDisposable(J);if(te){const Me=ne.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(te));ve=C.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(G,Z,ne,ce){return this._withAdapter(G,W,J=>J.provideDocumentSemanticTokens(m.URI.revive(Z),ne,ce),null,!0)}$releaseDocumentSemanticTokens(G,Z){this._withAdapter(G,W,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(G,Z,ne,ce){const J=this._addNewAdapter(new U(this._documents,ne),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Z),ce),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(G,Z,ne,ce){return this._withAdapter(G,U,J=>J.provideDocumentRangeSemanticTokens(m.URI.revive(Z),ne,ce),null,!0)}registerCompletionItemProvider(G,Z,ne,ce){const J=this._addNewAdapter(new x(this._documents,this._commands.converter,ne,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Z),ce,x.supportsResolving(ne),`${G.identifier.value}(${ce.join("")})`),this._createDisposable(J)}$provideCompletionItems(G,Z,ne,ce,J){return this._withAdapter(G,x,te=>te.provideCompletionItems(m.URI.revive(Z),ne,ce,J),void 0)}$resolveCompletionItem(G,Z,ne){return this._withAdapter(G,x,ce=>ce.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(G,Z){this._withAdapter(G,x,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(G,Z,ne){const ce=this._addNewAdapter(new B(this._documents,ne,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideInlineCompletions(G,Z,ne,ce,J){return this._withAdapter(G,B,te=>te.provideInlineCompletions(m.URI.revive(Z),ne,ce,J),void 0)}$handleInlineCompletionDidShow(G,Z,ne){this._withAdapter(G,B,async ce=>{ce.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(G,Z){this._withAdapter(G,B,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(G,Z,ne,ce){const J=Array.isArray(ce)?{triggerCharacters:ce,retriggerCharacters:[]}:ce,te=this._addNewAdapter(new H(this._documents,ne),G);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(Z),J),this._createDisposable(te)}$provideSignatureHelp(G,Z,ne,ce,J){return this._withAdapter(G,H,te=>te.provideSignatureHelp(m.URI.revive(Z),ne,ce,J),void 0)}$releaseSignatureHelp(G,Z){this._withAdapter(G,H,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(G,Z,ne){const ce=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new j(this._documents,ne),G);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Z),ce);let te=this._createDisposable(J);if(ce!==void 0){const ve=ne.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ce));te=C.Disposable.from(te,ve)}return te}$provideInlayHints(G,Z,ne,ce){return this._withAdapter(G,j,J=>J.provideInlayHints(m.URI.revive(Z),ne,ce),void 0)}registerDocumentLinkProvider(G,Z,ne){const ce=this._addNewAdapter(new X(this._documents,ne),G);return this._proxy.$registerDocumentLinkProvider(ce,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(ce)}$provideDocumentLinks(G,Z,ne){return this._withAdapter(G,X,ce=>ce.provideLinks(m.URI.revive(Z),ne),void 0)}$resolveDocumentLink(G,Z,ne){return this._withAdapter(G,X,ce=>ce.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(G,Z){this._withAdapter(G,X,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(G,Z,ne){const ce=this._addNewAdapter(new K(this._documents,ne),G);return this._proxy.$registerDocumentColorProvider(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideDocumentColors(G,Z,ne){return this._withAdapter(G,K,ce=>ce.provideColors(m.URI.revive(Z),ne),[])}$provideColorPresentations(G,Z,ne,ce){return this._withAdapter(G,K,J=>J.provideColorPresentations(m.URI.revive(Z),ne,ce),void 0)}registerFoldingRangeProvider(G,Z,ne){const ce=this._nextHandle(),J=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new he(this._documents,ne),G)),this._proxy.$registerFoldingRangeProvider(ce,this._transformDocumentSelector(Z),J);let te=this._createDisposable(ce);if(J!==void 0){const ve=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));te=C.Disposable.from(te,ve)}return te}$provideFoldingRanges(G,Z,ne,ce){return this._withAdapter(G,he,J=>J.provideFoldingRanges(m.URI.revive(Z),ne,ce),void 0)}registerSelectionRangeProvider(G,Z,ne){const ce=this._addNewAdapter(new Ee(this._documents,ne,this._logService),G);return this._proxy.$registerSelectionRangeProvider(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$provideSelectionRanges(G,Z,ne,ce){return this._withAdapter(G,Ee,J=>J.provideSelectionRanges(m.URI.revive(Z),ne,ce),[])}registerCallHierarchyProvider(G,Z,ne){const ce=this._addNewAdapter(new De(this._documents,ne),G);return this._proxy.$registerCallHierarchyProvider(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$prepareCallHierarchy(G,Z,ne,ce){return this._withAdapter(G,De,J=>Promise.resolve(J.prepareSession(m.URI.revive(Z),ne,ce)),void 0)}$provideCallHierarchyIncomingCalls(G,Z,ne,ce){return this._withAdapter(G,De,J=>J.provideCallsTo(Z,ne,ce),void 0)}$provideCallHierarchyOutgoingCalls(G,Z,ne,ce){return this._withAdapter(G,De,J=>J.provideCallsFrom(Z,ne,ce),void 0)}$releaseCallHierarchy(G,Z){this._withAdapter(G,De,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(G,Z,ne){const ce=this._addNewAdapter(new Pe(this._documents,ne),G);return this._proxy.$registerTypeHierarchyProvider(ce,this._transformDocumentSelector(Z)),this._createDisposable(ce)}$prepareTypeHierarchy(G,Z,ne,ce){return this._withAdapter(G,Pe,J=>Promise.resolve(J.prepareSession(m.URI.revive(Z),ne,ce)),void 0)}$provideTypeHierarchySupertypes(G,Z,ne,ce){return this._withAdapter(G,Pe,J=>J.provideSupertypes(Z,ne,ce),void 0)}$provideTypeHierarchySubtypes(G,Z,ne,ce){return this._withAdapter(G,Pe,J=>J.provideSubtypes(Z,ne,ce),void 0)}$releaseTypeHierarchy(G,Z){this._withAdapter(G,Pe,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,k.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:He._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:He._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?He._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?He._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:He._serializeRegExp(G.beforeText),afterText:G.afterText?He._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?He._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map(He._serializeOnEnterRule)}setLanguageConfiguration(G,Z,ne){let{wordPattern:ce}=ne;if(ce&&(0,k.regExpLeadsToEndlessLoop)(ce))throw new Error(`Invalid language configuration: wordPattern '${ce}' is not allowed to match the empty string.`);ce?this._documents.setWordDefinitionFor(Z,ce):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const J=this._nextHandle(),te={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?He._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?He._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?He._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Z,te),this._createDisposable(J)}$setWordDefinitions(G){for(const Z of G)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=He,He._handlePool=0}),define(me[241],ge([0,1,5,16,7,49,18,6]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(T,I,a,w){this._documents=I,this._commands=a,this._uriTransformer=w,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=T.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(T){this._languageIds=T}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(T,I){await this._proxy.$changeLanguage(T,I);const a=this._documents.getDocumentData(T);if(!a)throw new Error(`document '${T.toString}' NOT found`);return a.document}async tokenAtPosition(T,I){const a=T.version,w=L.Position.from(I),f=await this._proxy.$tokensAtPosition(T.uri,w),v={type:D.StandardTokenType.Other,range:T.getWordRangeAtPosition(I)??new D.Range(I.line,I.character,I.line,I.character)};if(!f)return v;const _={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!_.range.contains(I)||a!==T.version?v:_}createLanguageStatusItem(T,I,a){const w=this._handlePool++,f=this._proxy,v=this._ids,_=`${T.identifier.value}/${I}`;if(v.has(_))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);v.add(_);const P={selector:a,id:I,name:T.displayName??T.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let p,l=new k.DisposableStore;const r=()=>{p?.dispose(),p=(0,n.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(w,{id:_,name:P.name??T.displayName??T.name,source:T.displayName??T.name,selector:L.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===D.LanguageStatusSeverity.Error?C.default.Error:P.severity===D.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:P.command&&this._commands.toInternal(P.command,l),accessibilityInfo:P.accessibilityInformation})},0)},g={dispose(){l.dispose(),p?.dispose(),f.$removeLanguageStatus(w),v.delete(_)},get id(){return P.id},get name(){return P.name},set name(o){P.name=o,r()},get selector(){return P.selector},set selector(o){P.selector=o,r()},get text(){return P.text},set text(o){P.text=o,r()},get detail(){return P.detail},set detail(o){P.detail=o,r()},get severity(){return P.severity},set severity(o){P.severity=o,r()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(o){P.accessibilityInformation=o,r()},get command(){return P.command},set command(o){P.command=o,r()}};return r(),g}}e.ExtHostLanguages=S}),define(me[131],ge([0,1,12,5,26,14,3]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(T,I){const a=new n.Emitter;super(I.logLevel,a.event);this._proxy=T.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(a)}$setLevel(T){this._onDidChangeLogLevel.fire(T)}doCreateLogger(T,I,a){return new S(this._proxy,T,I,a)}};k=Ve([We(0,C.IExtHostRpcService),We(1,D.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends m.AbstractMessageLogger{constructor(T,I,a,w){super(w?.always);this.proxy=T,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(a),this.proxy.$createLogger(I,w).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(T,I){const a=[[T,I]];this.isLoggerCreated?this.doLog(a):this.buffer.push(...a)}doLog(T){this.proxy.$log(this.file,T)}}}),define(me[242],ge([0,1,5,12,29]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let n=class{constructor(S,y){this._logService=y,this._proxy=S.getProxy(m.MainContext.MainThreadMessageService)}showMessage(S,y,T,I,a){const w={extension:S};let f;typeof I=="string"||C(I)?f=[I,...a]:(w.modal=I?.modal,w.useCustom=I?.useCustom,w.detail=I?.detail,f=a),w.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const v=[];for(let _=0;_<f.length;_++){const P=f[_];if(typeof P=="string")v.push({title:P,handle:_,isCloseAffordance:!1});else if(typeof P=="object"){let{title:p,isCloseAffordance:l}=P;v.push({title:p,isCloseAffordance:!!l,handle:_})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(y,T,w,v).then(_=>{if(typeof _=="number")return f[_]})}};n=Ve([We(1,L.ILogService)],n),e.ExtHostMessageService=n}),define(me[243],ge([0,1,22,3,48,6,24,8,13,2,88,5,16,7,53,218,128]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(l,r,g,o,b){this._textDocumentsAndEditors=g,this._textDocuments=o,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new n.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new T.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const t=i.notebookEditor?.notebookUri,c=i.cell.handle,s=this._documents.get(t)?.getCell(c);if(s)return s.apiCell}return i}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const r=this._editors.get(l);if(!r)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(l){for(const[r,g]of this._editors)if(g.apiEditor===l)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,r){const g=this._documents.get(l);if(!g&&!r)throw new Error(`NO notebook document for '${l}'`);return g}_getProviderData(l){const r=this._notebookContentProviders.get(l);if(!r)throw new Error(`NO provider for '${l}'`);return r}registerNotebookContentProvider(l,r,g,o,b){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:l,provider:g});let i;return g.onDidChangeNotebookContentOptions&&(i=g.onDidChangeNotebookContentOptions(()=>{const t=a.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},r,a.NotebookDocumentContentOptions.from(o),P._convertNotebookRegistrationData(l,b)),new w.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(l,r){if(!r)return;const g=r.filenamePattern.map(o=>a.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(r.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:r.displayName,filenamePattern:g,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,r,g){const o=P._notebookStatusBarItemProviderHandlePool++,b=typeof g.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,b,r);let i;return b!==void 0&&(i=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(b))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,b),i&&i.dispose()})}async createNotebookDocument(l){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&a.NotebookData.from(l.content)});return y.URI.revive(r)}async openNotebookDocument(l){const r=this._documents.get(l);if(r)return r.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(l),o=this._documents.get(y.URI.revive(g));return(0,S.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(l,r){y.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let g;typeof r=="object"?g={position:a.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(a.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:g={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,g),b=o&&this._editors.get(o)?.apiEditor;if(b)return b;throw o?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,r,g,o){const b=this._notebookStatusBarItemProviders.get(l),i=y.URI.revive(r),t=this._documents.get(i);if(!t||!b)return;const c=t.getCellFromIndex(g);if(!c)return;const d=await b.provideCellStatusBarItems(c.apiCell,o);if(!d)return;const s=new C.DisposableStore,h=this._statusBarCache.add([s]),E=(Array.isArray(d)?d:[d]).map(A=>a.NotebookStatusBarItem.from(A,this._commandsConverter,s));return{cacheId:h,items:E}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,r,g,o,b){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,g),this._notebookProxy.$registerNotebookSerializer(i,{id:l.identifier,location:l.extensionLocation},r,a.NotebookDocumentContentOptions.from(o),P._convertNotebookRegistrationData(l,b)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(l,r,g){const o=this._notebookSerializer.get(l);if(!o)throw new Error("NO serializer found");const b=await o.deserializeNotebook(r.buffer,g);return new f.SerializableObjectWithBuffers(a.NotebookData.from(b))}async $notebookToData(l,r,g){const o=this._notebookSerializer.get(l);if(!o)throw new Error("NO serializer found");const b=await o.serializeNotebook(a.NotebookData.to(r.value),g);return m.VSBuffer.wrap(b)}async $openNotebook(l,r,g,o,b){const{provider:i}=this._getProviderData(l),t=await i.openNotebook(y.URI.revive(r),{backupId:g,untitledDocumentData:o?.buffer},b);return new f.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(a.NotebookCellData.from)})}async $saveNotebook(l,r,g){const o=this.getNotebookDocument(y.URI.revive(r)),{provider:b}=this._getProviderData(l);return await b.saveNotebook(o.apiNotebook,g),!0}async $saveNotebookAs(l,r,g,o){const b=this.getNotebookDocument(y.URI.revive(r)),{provider:i}=this._getProviderData(l);return await i.saveNotebookAs(y.URI.revive(g),b.apiNotebook,o),!0}async $backupNotebook(l,r,g){const o=this.getNotebookDocument(y.URI.revive(r)),b=this._getProviderData(l),i=this._extensionStoragePaths.workspaceValue(b.extension)??this._extensionStoragePaths.globalValue(b.extension),t=String((0,D.hash)([o.uri.toString(),this._backupIdPool++])),c=y.URI.joinPath(i,t),d=await b.provider.backupNotebook(o.apiNotebook,{destination:c},g);return o.updateBackup(d),d.id}_createExtHostEditor(l,r,g){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const o=new _.ExtHostNotebookEditor(r,this._notebookEditorsProxy,l,g.visibleRanges.map(a.NotebookRange.to),g.selections.map(a.NotebookRange.to),typeof g.viewColumn=="number"?a.ViewColumn.to(g.viewColumn):void 0);this._editors.set(r,o)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const g of l.value.removedDocuments){const o=y.URI.revive(g),b=this._documents.get(o);b&&(b.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===o.toString()&&this._editors.delete(i.id)}if(l.value.addedDocuments){const g=[];for(const o of l.value.addedDocuments){const b=y.URI.revive(o.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const i=this,t=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){i._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){i._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){i._onDidChangeCellMetadata.fire(c)},emitCellExecutionStateChange(c){i._onDidChangeCellExecutionState.fire(c)}},b,o);g.push(...o.cells.map(c=>v.ExtHostCell.asModelAddData(t.apiNotebook,c))),this._documents.get(b)?.dispose(),this._documents.set(b,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(l.value.addedEditors)for(const g of l.value.addedEditors){if(this._editors.has(g.id))return;const o=y.URI.revive(g.documentUri),b=this._documents.get(o);b&&this._createExtHostEditor(b,g.id,g)}const r=[];if(l.value.removedEditors)for(const g of l.value.removedEditors){const o=this._editors.get(g);o&&(this._editors.delete(g),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),r.push(o))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const g=new Set;this._visibleNotebookEditors.forEach(o=>g.add(o.id));for(const o of this._editors.values()){const b=g.has(o.id);o._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(me[244],ge([0,1,3,75,12,5,14,16]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(I,a){const w=S._Keys.nextId();I.$registerNotebookEditorDecorationType(w,k.NotebookDecorationRenderOptions.from(a)),this.value={key:w,dispose(){I.$removeNotebookEditorDecorationType(w)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let y=class{constructor(I,a,w){this._logService=I,this._extHostRpc=a,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,a);const w=this._notebooksAndEditors.getEditorById(I);a.visibleRanges&&w._acceptVisibleRanges(a.visibleRanges.ranges.map(k.NotebookRange.to)),a.selections&&w._acceptSelections(a.selections.selections.map(k.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const a in I)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(k.ViewColumn.to(I[a]))}};y=Ve([We(0,D.ILogService),We(1,n.IExtHostRpcService)],y),e.ExtHostNotebookEditors=y}),define(me[245],ge([0,1,17,18,21,3,6,24,2,27,12,5,38,16,7,89,210,29,53]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(i,t,c,d,s){this._initData=t,this._extHostNotebook=c,this._commands=d,this._logService=s,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=i.getProxy(I.MainContext.MainThreadNotebookKernels);const h=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:E}}else if(u&&"notebookEditor"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return u})],a.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(i,t,c,d,s,h){for(let H of this._kernelData.values())if(H.controller.id===t&&y.ExtensionIdentifier.equals(i.identifier,H.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const u=this._handlePool++,E=this;this._logService.trace(`NotebookController[${u}], CREATED by ${i.identifier.value}, ${t}`);const A=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${i.identifier}'`);let R=!1;const $=new n.DisposableStore,N=new C.Emitter,F=new C.Emitter,z={id:`${i.identifier.value}/${t}`,notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:d||i.identifier.value,preloads:h?h.map(w.NotebookRendererScript.from):[]};let M=s??A,W;this._proxy.$addKernel(u,z).catch(H=>{console.log(H),R=!0});let U=0;const x=()=>{if(R)return;const H=++U;Promise.resolve().then(()=>{H===U&&this._proxy.$updateKernel(u,z)})},B=new k.ResourceMap,O={get id(){return t},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return z.label},set label(H){z.label=H??i.displayName??i.name,x()},get detail(){return z.detail??""},set detail(H){z.detail=H,x()},get description(){return z.description??""},set description(H){z.description=H,x()},get kind(){return(0,P.checkProposedApiEnabled)(i,"notebookControllerKind"),z.kind??""},set kind(H){(0,P.checkProposedApiEnabled)(i,"notebookControllerKind"),z.kind=H,x()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(H){z.supportedLanguages=H,x()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(H){z.supportsExecutionOrder=H,x()},get rendererScripts(){return z.preloads?z.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(H){M=H??A},get interruptHandler(){return W},set interruptHandler(H){W=H,z.supportsInterrupt=Boolean(H),x()},createNotebookCellExecution(H){if(R)throw new Error("notebook controller is DISPOSED");if(!B.has(H.notebook.uri))throw E._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(B.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return E._createNotebookCellExecution(H)},dispose:()=>{R||(this._logService.trace(`NotebookController[${u}], DISPOSED`),R=!0,this._kernelData.delete(u),$.dispose(),N.dispose(),F.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(H,j){E._proxy.$updateNotebookPriority(u,H.uri,j)},onDidReceiveMessage:F.event,postMessage(H,j){return(0,P.checkProposedApiEnabled)(i,"notebookMessaging"),E._proxy.$postMessage(u,j&&E._extHostNotebook.getIdByEditor(j),H)},asWebviewUri(H){return(0,P.checkProposedApiEnabled)(i,"notebookMessaging"),(0,v.asWebviewUri)(H,E._initData.remote)}};return this._kernelData.set(u,{extensionId:i.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:N,associatedNotebooks:B}),O}$acceptNotebookAssociation(i,t,c){const d=this._kernelData.get(i);if(d){const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));c?d.associatedNotebooks.set(s.uri,!0):d.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,s.uri.toString(),c),d.onDidChangeSelection.fire({selected:c,notebook:s.apiNotebook})}}async $executeCells(i,t,c){const d=this._kernelData.get(i);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(t)),h=[];for(let u of c){const E=s.getCell(u);E&&h.push(E.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,s.uri.toString(),h.length),await d.controller.executeHandler.call(d.controller,h,s.apiNotebook,d.controller)}catch(u){this._logService.error(`NotebookController[${i}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(i,t,c){const d=this._kernelData.get(i);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,s.apiNotebook);else for(let h of c){const u=s.getCell(h);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,t,c){const d=this._kernelData.get(i);if(!d)return;const s=this._extHostNotebook.getEditorById(t);d.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:c}))}_createNotebookCellExecution(i){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const d=new g(c.notebook,c,this._proxy);this._activeExecutions.set(c.uri,d);const s=d.onDidChangeState(()=>{d.state===r.Resolved&&(d.dispose(),s.dispose(),this._activeExecutions.delete(c.uri))});return d.asApiObject()}};l=Ve([We(4,T.ILogService)],l),e.ExtHostNotebookKernels=l;var r;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(r||(r={}));class g extends n.Disposable{constructor(i,t,c){super();this._document=i,this._cell=t,this._proxy=c,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new o(10,d=>this.update(d)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const t=Array.isArray(i)?i:[i];return this._proxy.$updateExecutions(new p.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let t=this._cell;if(i&&(t=this._document.getCellFromApiCell(i)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(i){return i.map(t=>{const c=f.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return c===t.items?w.NotebookCellOutput.from(t):w.NotebookCellOutput.from({items:c,id:t.id,metadata:t.metadata})})}async updateOutputs(i,t,c){const d=this.cellIndexToHandle(t),s=this.validateAndConvertOutputs((0,m.asArray)(i));return this.updateSoon({editType:_.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:c,outputs:s})}async updateOutputItems(i,t,c){return i=f.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(i),!0),this.updateSoon({editType:_.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:i.map(w.NotebookCellOutputItem.from),outputId:t.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(c){i._executionOrder=c,i.update([{editType:_.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,executionOrder:i._executionOrder}])},start(c){if(i._state===r.Resolved||i._state===r.Started)throw new Error("Cannot call start again");i._state=r.Started,i._onDidChangeState.fire(),i.update({editType:_.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,runStartTime:c})},end(c,d){if(i._state===r.Resolved)throw new Error("Cannot call resolve twice");i._state=r.Resolved,i._onDidChangeState.fire(),i.updateSoon({editType:_.CellExecutionUpdateType.Complete,executionHandle:i._handle,runEndTime:d,lastRunSuccess:c}),i._collector.flush(),i._proxy.$removeExecution(i._handle)},clearOutput(c){return i.verifyStateForOutput(),i.updateOutputs([],c,!1)},appendOutput(c,d){return i.verifyStateForOutput(),i.updateOutputs(c,d,!0)},replaceOutput(c,d){return i.verifyStateForOutput(),i.updateOutputs(c,d,!1)},appendOutputItems(c,d){return i.verifyStateForOutput(),i.updateOutputItems(c,d,!0)},replaceOutputItems(c,d){return i.verifyStateForOutput(),i.updateOutputItems(c,d,!1)}})}}g.HANDLE=0;class o{constructor(i,t){this.delay=i,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>i.complete())}}}),define(me[246],ge([0,1,3,5,128,29]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class n{constructor(S,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,y,T){const I=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(y)?.fire({editor:I.apiEditor,message:T})}createRendererMessaging(S,y){if(!S.contributes?.notebookRenderer?.some(w=>w.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const T=(0,C.isProposedApiEnabled)(S,"notebookEditor"),I=new WeakMap;return{onDidReceiveMessage:(w,f,v)=>{const _=T?w:P=>{const p={};I.set(p,P.editor),w({editor:p,message:P.message})};return this.getOrCreateEmitterFor(y).event(_,f,v)},postMessage:(w,f)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(w)&&([w,f]=[f,w]);const v=T?f:I.get(f),_=v&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(v);return this.proxy.$postMessage(_?.id,y,w)}}}getOrCreateEmitterFor(S){let y=this._rendererMessageEmitters.get(S);return y||(y=new m.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,y),y)}}e.ExtHostNotebookRenderers=n}),define(me[132],ge([0,1,5,6,4,14,12,211,66,26,45,151,22]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class w extends L.Disposable{constructor(_,P,p,l){super();this.id=_,this.name=P,this.logger=p,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(_){this.append(_+`
`)}append(_){this.write(_),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,_)}replace(_){const P=this.offset;this.write(_),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,P),this.visible&&this.logger.flush()}show(_,P){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:P))}hide(){this.proxy.$close(this.id)}write(_){this.offset+=a.VSBuffer.fromString(_).byteLength,this.logger.info(_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=w;let f=class{constructor(_,P,p,l,r){this.extHostFileSystem=p,this.extHostFileSystemInfo=l,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(P.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[P,p]of this.channels)p.visible=P===this.visibleChannelId}createOutputChannel(_,P){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const p=this.doCreateOutputChannel(_,P);return p.then(l=>{this.channels.set(l.id,l),l.visible=l.id===this.visibleChannelId}),this.createExtHostOutputChannel(_,p)}async doCreateOutputChannel(_,P){const p=await this.createOutputDirectory(),l=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(_,!1,l,P.identifier.value);return new w(g,_,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(_,P){let p=!1;const l=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return _},append(r){l(),P.then(g=>g.append(r))},appendLine(r){l(),P.then(g=>g.appendLine(r))},clear(){l(),P.then(r=>r.clear())},replace(r){l(),P.then(g=>g.replace(r))},show(r,g){l(),P.then(o=>o.show(r,g))},hide(){l(),P.then(r=>r.hide())},dispose(){p=!0,P.then(r=>r.dispose())}}}};f=Ve([We(0,C.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,T.IExtHostFileSystemInfo),We(4,n.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(me[247],ge([0,1,18,21,3,6,5,2,7,15,17,49,87,29]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(v,_,P){const p=v.getProxy(n.MainContext.MainThreadQuickOpen);class l{constructor(s,h){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=h}showQuickPick(s,h,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(s),A=++this._instances,R=p.$show(A,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},u),$={},N=R.then(()=>$);return Promise.race([N,E]).then(F=>{if(F!==$)return E.then(z=>{const M=[];for(let W=0;W<z.length;W++){const U=z[W];typeof U=="string"?M.push({label:U,handle:W}):U.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:U.label}):M.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:W})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{h.onDidSelectItem(z[W])}),p.$setItems(A,M),R.then(W=>{if(typeof W=="number")return z[W];if(Array.isArray(W))return W.map(U=>z[U])})})}).then(void 0,F=>{if(!(0,y.isPromiseCanceledError)(F))return p.$setError(A,F),Promise.reject(F)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,h=L.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,p.$input(s,typeof this._validateInput=="function",h).then(void 0,u=>{if(!(0,y.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(s){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,h=L.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!u)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(A=>A.uri.toString()===u.uri.toString())}createQuickPick(s){const h=new t(s,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(s){const h=new c(s,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(s,h){const u=this._sessions.get(s);u&&u._fireDidChangeValue(h)}$onDidAccept(s){const h=this._sessions.get(s);h&&h._fireDidAccept()}$onDidChangeActive(s,h){const u=this._sessions.get(s);u instanceof t&&u._fireDidChangeActive(h)}$onDidChangeSelection(s,h){const u=this._sessions.get(s);u instanceof t&&u._fireDidChangeSelection(h)}$onDidTriggerButton(s,h){const u=this._sessions.get(s);u&&u._fireDidTriggerButton(h)}$onDidTriggerItemButton(s,h,u){const E=this._sessions.get(s);E instanceof t&&E._fireDidTriggerItemButton(h,u)}$onDidHide(s){const h=this._sessions.get(s);h&&h._fireDidHide()}}class r{constructor(s,h){this._extensionId=s,this._onDidDispose=h,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((h,u)=>{const E=h===S.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(E,h)}),this.update({buttons:s.map((h,u)=>({...i(h),tooltip:h.tooltip,handle:h===S.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const h=this._handlesToButtons.get(s);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(s){if(!this._disposed){for(const h of Object.keys(s)){const u=s[h];this._pendingUpdate[h]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function g(d){if(d instanceof S.ThemeIcon)return{id:d.id};const s=b(d),h=o(d);return{dark:typeof s=="string"?k.URI.file(s):s,light:typeof h=="string"?k.URI.file(h):h}}function o(d){return typeof d=="object"&&"light"in d?d.light:d}function b(d){return typeof d=="object"&&"dark"in d?d.dark:d}function i(d){const s=g(d.iconPath);let h,u;return"id"in s?u=a.ThemeIcon.asClassName(s):h=s,{iconPath:h,iconClass:u}}class t extends r{constructor(s,h){super(s.identifier,h);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(u=>u.kind!==void 0)&&(0,w.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((u,E)=>{this._handlesToItems.set(E,u),this._itemsToHandles.set(u,E)});const h=[];for(let u=0;u<s.length;u++){const E=s[u];E.kind===S.QuickPickItemKind.Separator?h.push({type:"separator",label:E.label}):h.push({handle:u,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((A,R)=>({...i(A),tooltip:A.tooltip,handle:R}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(s){const h=(0,T.coalesce)(s.map(u=>this._handlesToItems.get(u)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(s){const h=(0,T.coalesce)(s.map(u=>this._handlesToItems.get(u)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(s,h){const u=this._handlesToItems.get(s);if(!u||!u.buttons||!u.buttons.length)return;const E=u.buttons[h];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:u})}}class c extends r{constructor(s,h){super(s,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?I.default.Error:I.default.Ignore})}}return new l(_,P)}e.createExtHostQuickOpen=f}),define(me[248],ge([0,1,2,3,57,6,18,5,17,100,12,27,87,16,29]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||a.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function _(d,s){if(!d.iconPath&&!s.iconPath)return 0;if(d.iconPath){if(!s.iconPath)return 1}else return-1;const h=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,u=typeof s.iconPath=="string"?s.iconPath:m.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,y.comparePaths)(h,u)}function P(d,s){let h=0;if(d.strikeThrough!==s.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==s.faded)return d.faded?1:-1;if(d.tooltip!==s.tooltip)return(d.tooltip||"").localeCompare(s.tooltip||"");if(h=_(d,s),h!==0)return h;if(d.light&&s.light)h=_(d.light,s.light);else{if(d.light)return 1;if(s.light)return-1}if(h!==0)return h;if(d.dark&&s.dark)h=_(d.dark,s.dark);else{if(d.dark)return 1;if(s.dark)return-1}return h}function p(d,s){if(d.command!==s.command)return d.command<s.command?-1:1;if(d.title!==s.title)return d.title<s.title?-1:1;if(d.tooltip!==s.tooltip){if(d.tooltip!==void 0&&s.tooltip!==void 0)return d.tooltip<s.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(d.arguments===s.arguments)return 0;if(d.arguments)if(s.arguments){if(d.arguments.length!==s.arguments.length)return d.arguments.length-s.arguments.length}else return 1;else return-1;for(let h=0;h<d.arguments.length;h++){const u=d.arguments[h],E=s.arguments[h];if(u!==E)return u<E?-1:1}return 0}function l(d,s){let h=(0,y.comparePaths)(d.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(h!==0)return h;if(d.command&&s.command)h=p(d.command,s.command);else{if(d.command)return 1;if(s.command)return-1}if(h!==0)return h;if(d.decorations&&s.decorations)h=P(d.decorations,s.decorations);else{if(d.decorations)return 1;if(s.decorations)return-1}return h}function r(d,s){for(let h=0;h<d.length;h++)if(d[h]!==s[h])return!1;return!0}function g(d,s){return d.command===s.command&&d.title===s.title&&d.tooltip===s.tooltip&&(d.arguments&&s.arguments?r(d.arguments,s.arguments):d.arguments===s.arguments)}function o(d,s){return(0,S.equals)(d,s,g)}class b{constructor(s,h,u){this._extension=s,this._proxy=h,this._sourceControlHandle=u,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,h){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,h)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=b;class i{constructor(s,h,u,E,A){this._proxy=s,this._commands=h,this._sourceControlHandle=u,this._id=E,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,h){const u=this._resourceStatesCommandsMap.get(s);return u?(0,n.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(l),u=(0,S.sortedDiff)(this._resourceSnapshot,s,l).map(R=>{const $=R.toInsert.map(N=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,N);const z=N.resourceUri;let M;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const he=new C.DisposableStore;M=this._commands.converter.toInternal(N.command,he),this._resourceStatesDisposablesMap.set(F,he)}else this._resourceStatesCommandsMap.set(F,N.command);const W=v(N.decorations),U=N.decorations&&v(N.decorations.light)||W,x=N.decorations&&v(N.decorations.dark)||W,B=[U,x],O=N.decorations&&N.decorations.tooltip||"",H=N.decorations&&!!N.decorations.strikeThrough,j=N.decorations&&!!N.decorations.faded,X=N.contextValue||"";return{rawResource:[F,z,B,O,H,j,X,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:$}}),E=u.map(({start:R,deleteCount:$,toInsert:N})=>[R,$,N.map(F=>F.rawResource)]),A=u.reverse();for(const{start:R,deleteCount:$,toInsert:N}of A){const F=N.map(M=>M.handle),z=this._handlesSnapshot.splice(R,$,...F);for(const M of z)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=s,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class t{constructor(s,h,u,E,A,R){this._extension=s,this._proxy=h,this._commands=u,this._id=E,this._label=A,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new b(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,A,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=s;const h=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=s;const h=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:h??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&o(this._statusBarCommands,s))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=s;const h=(s||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}get selected(){return this._selected}createResourceGroup(s,h){const u=new i(this._proxy,this._commands,this.handle,s,h),E=L.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const s=[],h=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const A=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),A.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),s.push([u.handle,u.id,u.label,u.features]);const R=u._takeResourceStateSnapshot();R.length>0&&h.push([u.handle,R]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,s,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(h=>{const u=h._takeResourceStateSnapshot();u.length!==0&&s.push([h.handle,u])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,D.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Hi{constructor(s,h,u){this._commands=h,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=s.getProxy(k.MainContext.MainThreadSCM),this._telemetry=s.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const A=this._sourceControls.get(E.sourceControlHandle);if(!A)return E;const R=A.getResourceGroup(E.groupHandle);return R?R.getResourceState(E.handle):E}else if(E&&E.$mid===4){const A=this._sourceControls.get(E.sourceControlHandle);return A?A.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const A=this._sourceControls.get(E.handle);return A||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,h,u,E){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,h,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const A=Hi._handlePool++,R=new t(s,this._proxy,this._commands,h,u,E);this._sourceControls.set(A,R);const $=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(s.identifier))||[];return $.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(s.identifier),$),R}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const h=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(s.identifier)),u=h&&h[h.length-1];return u&&u.inputBox}$provideOriginalResource(s,h,u){const E=m.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,E.toString());const A=this._sourceControls.get(s);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,n.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(E,u)).then(R=>R||null)}$onInputBoxValueChange(s,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const u=this._sourceControls.get(s);return u&&u.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(s,h,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,h,u);const A=this._sourceControls.get(s);if(!A)return Promise.resolve(void 0);const R=A.getResourceGroup(h);return R?R.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(s,h,u){this.logService.trace("ExtHostSCM#$validateInput",s);const E=this._sourceControls.get(s);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,n.asPromise)(()=>E.inputBox.validateInput(h,u)).then(A=>{if(!A)return Promise.resolve(void 0);const R=w.MarkdownString.fromStrict(A.message);return R?Promise.resolve([R,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};c._handlePool=0,c=Ve([We(2,T.ILogService)],c),e.ExtHostSCM=c});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[249],ge([0,1,7,5,165,6,16,13]),function(Y,e,m,L,D,C,n,k){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(f,v,_,P,p=m.StatusBarAlignment.Left,l){S.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,ot(this,S,f,"f"),ot(this,y,v,"f"),this._entryId=T.ID_GEN++,this._extension=_,this._id=P,this._alignment=p,this._priority=this.validatePriority(l)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!T.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let v;this._name?v=this._name:v=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?n.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,S,"f").$setEntry(this._entryId,f,v,this._text,P,this._command?.internal,_,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,S=new WeakMap,y=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const v={message:f};return this._messages.unshift(v),this._update(),new m.Disposable(()=>{const _=this._messages.indexOf(v);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(f,v){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new I(this)}createStatusBarEntry(f,v,_,P){return new T(this._proxy,this._commands,f,v,_,P)}setStatusBarMessage(f,v){const _=this._statusMessage.setMessage(f);let P;return typeof v=="number"?P=setTimeout(()=>_.dispose(),v):typeof v!="undefined"&&v.then(()=>_.dispose(),()=>_.dispose()),new m.Disposable(()=>{_.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=a}),define(me[92],ge([0,1,5,3,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}getValue(k,S,y){return this._proxy.$getValue(k,S).then(T=>T||y)}setValue(k,S,y){return this._proxy.$setValue(k,S,y)}$acceptValue(k,S,y){this._onDidChangeStorage.fire({shared:k,key:S,value:y})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(me[67],ge([0,1,4,26,12,66,2]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(y,T,I){this._logService=T,this._extHostFileSystem=I,this._workspace=y.workspace??void 0,this._environment=y.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(y){return n.URI.joinPath(this._environment.workspaceStorageHome,y)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const y=this._workspace.id,T=await this._getWorkspaceStorageURI(y);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(n.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:n.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(y){if(this._value)return n.URI.joinPath(this._value,y.identifier.value)}globalValue(y){return n.URI.joinPath(this._environment.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([We(0,L.IExtHostInitDataService),We(1,D.ILogService),We(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(me[34],ge([0,1,3,5,4,2,14,6,7,166,15,213,21,32,195,87,13,18]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class p{constructor(d,s,h,u){this._proxy=d,this._id=s,this._creationOptions=h,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(A,R=!0){E._checkDisposed(),E._proxy.$sendText(E._id,A,R)},show(A){E._checkDisposed(),E._proxy.$show(E._id,A)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(d,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,_.withNullAsUndefined)(d.shellPath),shellArgs:(0,_.withNullAsUndefined)(d.shellArgs),cwd:(0,_.withNullAsUndefined)(d.cwd),env:(0,_.withNullAsUndefined)(d.env),icon:(0,_.withNullAsUndefined)(i(d.iconPath)),color:v.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,_.withNullAsUndefined)(d.message),strictEnv:(0,_.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(d.location,s?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,s,h,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:v.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(d,s)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,s){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,s){return d===this._cols&&s===this._rows||d===0||s===0?!1:(this._cols=d,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=p;class l{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,s){this._pty.setDimensions?.({columns:d,rows:s})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=l;let r=1,g=class extends k.Disposable{constructor(d,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[h,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,s){const h=new p(this._proxy,(0,w.generateUuid)(),d,d.name),u=new l(d.pty);return h.createExtensionTerminal(d.location,this._serializeParentTerminal(d,s).resolvedExtHostIdentifier,i(d.iconPath),t(d.color)).then(E=>{const A=this._setupExtHostProcessListeners(E,u);this._terminalProcessDisposables[E]=A}),this._terminals.push(h),h.value}_serializeParentTerminal(d,s){if(s=s||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const h=d.location.parentTerminal;if(h){const u=this._terminals.find(E=>E.value===h);u&&(s.resolvedExtHostIdentifier=u._id)}}else d.location&&typeof d.location!="object"?s.location=d.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(d,s){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const u=new l(s),E=this._setupExtHostProcessListeners(d,u);this._terminalProcessDisposables[d]=E}async $acceptActiveTerminalChanged(d){const s=this._activeTerminal;if(d===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(d);h&&(this._activeTerminal=h,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,s){const h=this._getTerminalById(d);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:s})}async $acceptTerminalDimensions(d,s,h){const u=this._getTerminalById(d);u&&u.setDimensions(s,h)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(d,s,h){this._terminalProcesses.get(d)?.resize(s,h)}async $acceptTerminalTitleChange(d,s){const h=this._getTerminalById(d);h&&(h.name=s)}async $acceptTerminalClosed(d,s){const h=this._getTerminalObjectIndexById(this._terminals,d);if(h!==null){const u=this._terminals.splice(h,1)[0];u.setExitCode(s),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(d,s,h,u){if(s){const R=this._getTerminalObjectIndexById(this._terminals,s);if(R!==null){this._terminals[R]._id=d,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const E={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:C.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},A=new p(this._proxy,d,E,h);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(d,s){const h=this._getTerminalById(d);h&&h._setProcessId(s)}async $startExtensionTerminal(d,s){const h=this._getTerminalById(d);if(!h)return{message:(0,y.localize)(0,null,d)};h.isOpen||await new Promise(E=>{const A=this.onDidOpenTerminal(async R=>{R===h.value&&(A.dispose(),E())})});const u=this._terminalProcesses.get(d);u?u.startSendingEvents(s):this._extensionTerminalAwaitingStart[d]={initialDimensions:s}}_setupExtHostProcessListeners(d,s){const h=new k.DisposableStore;h.add(s.onProcessReady(E=>this._proxy.$sendProcessReady(d,E.pid,E.cwd))),h.add(s.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(d,E))),this._bufferer.startBuffering(d,s.onProcessData),h.add(s.onProcessExit(E=>this._onProcessExit(d,E))),this._terminalProcesses.set(d,s);const u=this._extensionTerminalAwaitingStart[d];return u&&s instanceof l&&(s.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),h}$acceptProcessAckDataEvent(d,s){this._terminalProcesses.get(d)?.acknowledgeDataEvent(s)}$acceptProcessInput(d,s){this._terminalProcesses.get(d)?.input(s)}$acceptTerminalInteraction(d){const s=this._getTerminalById(d);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(d,s,h){try{this._terminalProcesses.get(d)?.resize(s,h)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(d,s){this._terminalProcesses.get(d)?.shutdown(s)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:s}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,s,h){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,h),this._proxy.$registerProfileProvider(s,d.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(d,s){const h=new a.CancellationTokenSource().token;let u=await this._profileProviders.get(d)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,s);return}this.createTerminalFromOptions(u.options,s)}}async $provideLinks(d,s){const h=this._getTerminalById(d);if(!h)return[];this._terminalLinkCache.delete(d);const u=this._terminalLinkCancellationSource.get(d);u&&u.dispose(!0);const E=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,E);const A=[],R={terminal:h.value,line:s},$=[];for(const z of this._linkProviders)$.push(P.Promises.withAsyncBody(async M=>{E.token.onCancellationRequested(()=>M({provider:z,links:[]}));const W=await z.provideTerminalLinks(R,E.token)||[];E.token.isCancellationRequested||M({provider:z,links:W})}));const N=await Promise.all($);if(E.token.isCancellationRequested)return[];const F=new Map;for(const z of N)z&&z.links.length>0&&A.push(...z.links.map(M=>{const W={id:r++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(W.id,{provider:z.provider,link:M}),W}));return this._terminalLinkCache.set(d,F),A}$activateLink(d,s){const h=this._terminalLinkCache.get(d)?.get(s);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(d,s){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const h=this._terminalProcessDisposables[d];h&&(h.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,s)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,s){const h=this._getTerminalObjectIndexById(d,s);return h!==null?d[h]:null}_getTerminalObjectIndexById(d,s){let h=null;return d.some((u,E)=>u._id===s?(h=E,!0):!1),h}getEnvironmentVariableCollection(d){let s=this._environmentVariableCollections.get(d.identifier.value);return s||(s=new o,this._setEnvironmentVariableCollection(d.identifier.value,s)),s}_syncEnvironmentVariableCollection(d,s){const h=(0,I.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(d,s.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(d){d.forEach(s=>{const h=s[0],u=new o(s[1]);this._setEnvironmentVariableCollection(h,u)})}$acceptDefaultProfile(d,s){this._defaultProfile=d,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(d,s){this._environmentVariableCollections.set(d,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,s)})}};g=Ve([We(1,n.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class o{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Replace})}append(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Append})}prepend(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,s){const h=this.map.get(d);(!h||h.value!==s.value||h.type!==s.type)&&(this.map.set(d,s),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,s){this.map.forEach((h,u)=>d.call(s,u,h,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let b=class extends g{constructor(d){super(!1,d)}createTerminal(d,s,h){throw new T.NotSupportedError}createTerminalFromOptions(d,s){throw new T.NotSupportedError}};b=Ve([We(0,n.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function i(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function t(c){return v.ThemeColor.isThemeColor(c)?c:void 0}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[250],ge([0,1,17,22,21,3,74,48,6,25,13,32,5,14,63,16,7,221,126,90]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(R,$){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(a.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new b(this.proxy),$.registerArgumentProcessor({processArgument:N=>N?.$mid===13?v.TestItem.toItemFromContext(N):N})}createTestController(R,$){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const N=new S.DisposableStore,F=N.add(new P.SingleUseTestCollection(R));F.root.label=$;const z=new Map,M=this.proxy,W={items:F.root.children,get label(){return $},set label(x){$=x,F.root.label=x,M.$updateControllerLabel(R,$)},get id(){return R},createRunProfile:(x,B,O,H,j)=>{let X=(0,k.hash)(x);for(;z.has(X);)X++;const K=new u(this.proxy,R,X,x,B,O,H,j);return z.set(X,K),K},createTestItem(x,B,O){return new f.TestItemImpl(R,x,B,O)},createTestRun:(x,B,O=!0)=>this.runTracker.createTestRun(R,F,x,B,O),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{N.dispose()}};W.createRunConfiguration=W.createRunProfile,M.$registerTestController(R,$),N.add((0,S.toDisposable)(()=>M.$unregisterTestController(R)));const U={controller:W,collection:F,profiles:z};return this.controllers.set(R,U),N.add((0,S.toDisposable)(()=>this.controllers.delete(R))),N.add(F.onDidGenerateDiff(x=>M.$publishDiff(R,x))),W}createTestObserver(){return this.observer.checkout()}async runTests(R,$=D.CancellationToken.None){const N=i(R);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(N.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(z=>z.id)??[F.collection.root.id],profileGroup:E[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:R.exclude?.map(z=>z.id)},$)}$provideFileCoverage(R,$,N){return(0,m.mapFind)(this.runTracker.trackers,z=>z.id===R?z.getCoverage($):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(R,$,N,F){return(0,m.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage($):void 0)?.resolveFileCoverage(N,F)??Promise.resolve([])}$configureRunProfile(R,$){this.controllers.get(R)?.profiles.get($)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map($=>(0,y.deepFreeze)(v.TestResults.to($))).concat(this.results).sort(($,N)=>N.completedAt-$.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,$){const N=this.controllers.get(l.TestId.fromString(R).controllerId)?.collection;N&&(await N.expand(R,$<0?Infinity:$),N.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,$){const N=this.controllers.get(R.controllerId);if(!N)return;const{collection:F,profiles:z}=N,M=z.get(R.profileId);if(!M)return;const W=R.testIds.map(O=>F.tree.get(O)).filter(T.isDefined),U=R.excludeExtIds.map(O=>N.collection.tree.get(O)).filter(T.isDefined).filter(O=>W.some(H=>H.fullId.compare(O.fullId)===2));if(!W.length)return;const x=new _.TestRunRequest(W.some(O=>O.actual instanceof f.TestItemRootImpl)?void 0:W.map(O=>O.actual),U.map(O=>O.actual),M),B=this.runTracker.prepareForMainThreadTestRun(x,t.fromInternal(R,N.collection),$);try{await M.runHandler(x,$)}finally{B.isRunning&&!$.isCancellationRequested&&await C.Event.toPromise(B.onEnd),B.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};g=Ve([We(0,w.IExtHostRpcService)],g),e.ExtHostTesting=g;class o extends S.Disposable{constructor(R,$,N){super();this.dto=R,this.proxy=$,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const $=this.dto.id,N=this.dto.controllerId,F=(0,I.generateUuid)(),z=new c(this.proxy,$,F),M=B=>(O,...H)=>{if(U){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),B(O,...H))},W=(B,O)=>{const H=O instanceof Array?O.map(v.TestMessage.from):[v.TestMessage.from(O)];if(B.uri&&B.range){const j={range:v.Range.from(B.range),uri:B.uri};for(const X of H)X.location=X.location||j}this.proxy.$appendTestMessagesInRun($,F,l.TestId.fromExtHostTestItem(B,N).toString(),H)};let U=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return z.coverageProvider},set coverageProvider(B){z.coverageProvider=B},enqueued:M(B=>{this.proxy.$updateTestStateInRun($,F,l.TestId.fromExtHostTestItem(B,N).toString(),1)}),skipped:M(B=>{this.proxy.$updateTestStateInRun($,F,l.TestId.fromExtHostTestItem(B,N).toString(),5)}),started:M(B=>{this.proxy.$updateTestStateInRun($,F,l.TestId.fromExtHostTestItem(B,N).toString(),2)}),errored:M((B,O,H)=>{W(B,O),this.proxy.$updateTestStateInRun($,F,l.TestId.fromExtHostTestItem(B,N).toString(),6,H)}),failed:M((B,O,H)=>{W(B,O),this.proxy.$updateTestStateInRun($,F,l.TestId.fromExtHostTestItem(B,N).toString(),4,H)}),passed:M((B,O)=>{this.proxy.$updateTestStateInRun($,F,l.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString(),3,O)}),appendOutput:(B,O,H)=>{U||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun($,F,L.VSBuffer.fromString(B),O&&v.location.from(O),H&&l.TestId.fromExtHostTestItem(H,N).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask($,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:x,coverage:z}),this.proxy.$startedTestRunTask($,{id:F,name:R,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof f.TestItemImpl))throw new f.InvalidTestItemError(R.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const $=[],N=this.dto.colllection.root;for(;;){const F=v.TestItem.from(R);if($.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===N))break;R=R.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,$)}}class b{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,$,N){return this.getTracker(R,$,N)}cancelRunById(R){for(const $ of this.tracked.values())if($.id===R){$.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,$,N,F,z){const M=this.tracked.get(N);if(M)return M.createRun(F);const W=t.fromPublic(R,$,N,z),U=i(N);this.proxy.$startedExtensionTestRun({controllerId:R,profile:U&&{group:E[U.kind],id:U.profileId},exclude:N.exclude?.map(B=>B.id)??[],id:W.id,include:N.include?.map(B=>B.id)??[$.root.id],persist:z});const x=this.getTracker(N,W);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),x.createRun(F)}getTracker(R,$,N){const F=new o($,this.proxy,N);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=b;const i=A=>{if(!!A.profile){if(!(A.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class t{constructor(R,$,N,F,z,M){this.controllerId=R,this.id=$,this.isPersisted=z,this.colllection=M,this.includePrefix=N.map(W=>W+"\0"),this.excludePrefix=F.map(W=>W+"\0")}static fromPublic(R,$,N,F){return new t(R,(0,I.generateUuid)(),N.include?.map(z=>l.TestId.fromExtHostTestItem(z,R).toString())??[R],N.exclude?.map(z=>l.TestId.fromExtHostTestItem(z,R).toString())??[],F,$)}static fromInternal(R,$){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,$)}isIncluded(R){const $=l.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if($===N||$.startsWith(N))return!1;for(const N of this.includePrefix)if($===N||$.startsWith(N))return!0;return!1}}e.TestRunDto=t;class c{constructor(R,$,N){this.proxy=R,this.runId=$,this.taskId=N}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch($){throw this.fileCoverage=void 0,$}}async resolveFileCoverage(R,$){const N=await this.fileCoverage;let F=N?.[R];return!this._coverageProvider||!N||!F?[]:(F.detailedCoverage||(F=N[R]=await this._coverageProvider.resolveFileCoverage?.(F,$)??F),F.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class d extends p.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,v.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:$,removed:N}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...$].map(F=>F.revived)},get removed(){return[...N].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,$){return{...R,revived:v.TestItem.toPlain(R.item),depth:$?$.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=s;class h{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map($=>$.revived)},dispose:(0,n.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class u{constructor(R,$,N,F,z,M,W=!1,U=void 0){this.controllerId=$,this.profileId=N,this._label=F,this.kind=z,this.runHandler=M,this._isDefault=W,this._tag=U,r.set(this,void 0),ot(this,r,R,"f");const x=E[z];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);Oe(this,r,"f").$publishTestRunProfile({profileId:N,controllerId:$,tag:U?v.TestTag.namespace(this.controllerId,U.id):null,label:F,group:x,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?v.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Oe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,r=new WeakMap;const E={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[251],ge([0,1,3,17,5,129,16,7]),function(Y,e,m,L,D,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(T,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const I=this._extHostDocumentsAndEditors.allEditors();return T?I:I.map(a=>a.value)}async showTextDocument(T,I,a){let w;typeof I=="number"?w={position:n.ViewColumn.from(I),preserveFocus:a}:typeof I=="object"?w={position:n.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?n.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:w={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(T.uri,w),v=f&&this._extHostDocumentsAndEditors.getEditor(f);if(v)return v.value;throw f?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,I){return new C.TextEditorDecorationType(this._proxy,T,I).value}$acceptEditorPropertiesChanged(T,I){const a=this._extHostDocumentsAndEditors.getEditor(T);if(!a)throw new Error("unknown text editor");if(I.options&&a._acceptOptions(I.options),I.selections){const w=I.selections.selections.map(n.Selection.to);a._acceptSelections(w)}if(I.visibleRanges){const w=L.coalesce(I.visibleRanges.map(n.Range.to));a._acceptVisibleRanges(w)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...I.options,lineNumbers:n.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const w=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),f=I.selections.selections.map(n.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:f,kind:w})}if(I.visibleRanges){const w=L.coalesce(I.visibleRanges.map(n.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:w})}}$acceptEditorPositionData(T){for(const I in T){const a=this._extHostDocumentsAndEditors.getEditor(I);if(!a)throw new Error("Unknown text editor");const w=n.ViewColumn.to(T[I]);a.value.viewColumn!==w&&(a._acceptViewColumn(w),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:w}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=S}),define(me[252],ge([0,1,2,4,5,6,7]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(T,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const w=a.uri===void 0?void 0:m.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(S(w))?.get(a.handle)}return a}})}async $getTimeline(T,I,a,w,f){return this._providers.get(T)?.provideTimeline(m.URI.revive(I),a,w,f)}registerTimelineProvider(T,I,a,w){const f=new C.DisposableStore,v=this.convertTimelineItem(I.id,w,f).bind(this);let _;I.onDidChange&&(_=I.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:I.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:T,onDidChange:void 0,async provideTimeline(p,l,r,g){g?.resetCache&&(f.clear(),P.get(I.id)?.clear());const o=await I.provideTimeline(p,l,r);if(o==null)return;const b=v(p,g);return{...o,source:I.id,items:o.items.map(b)}},dispose(){for(const p of P.values())p.get(I.id)?.clear();_?.dispose(),f.dispose()}})}convertTimelineItem(T,I,a){return(w,f)=>{let v;if(f?.cacheResults){let _=this._itemsBySourceAndUriMap.get(T);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(T,_));const P=S(w);v=_.get(P),v===void 0&&(v=new Map,_.set(P,v))}return _=>{const{iconPath:P,...p}=_,l=`${T}|${_.id??_.timestamp}`;v?.set(l,_);let r,g,o;return _.iconPath&&(P instanceof n.ThemeIcon?o={id:P.id,color:P.color}:m.URI.isUri(P)?(r=P,g=P):{light:r,dark:g}=P),{...p,id:p.id??void 0,handle:l,source:T,command:_.command?I.toInternal(_.command,a):void 0,icon:r,iconDark:g,themeIcon:o,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,C.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(T.id)?.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=k;function S(y){return y?.toString()}}),define(me[253],ge([0,1,6,10,2,5]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class n{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,y,T,I){if(this._openers.has(y))throw new Error(`Opener with id '${y}' already registered`);const a=I.schemes.find(w=>!n.supportedSchemes.has(w));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(y,T),this._proxy.$registerUriOpener(y,I.schemes,S,I.label),(0,m.toDisposable)(()=>{this._openers.delete(y),this._proxy.$unregisterUriOpener(y)})}async $canOpenUri(S,y,T){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const a=D.URI.revive(y);return I.canOpenExternalUri(a,T)}async $openUri(S,y,T){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(D.URI.revive(y.resolvedUri),{sourceUri:D.URI.revive(y.sourceUri)},T)}}e.ExtHostUriOpeners=n,n.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[254],ge([0,1,5,2,6,15,27]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(y){this.handles=new Set,this.handlers=new Map,this._proxy=y.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(y,T){if(this.handles.has(n.ExtensionIdentifier.toKey(y)))throw new Error(`Protocol handler already registered for extension ${y}`);const I=k.HandlePool++;return this.handles.add(n.ExtensionIdentifier.toKey(y)),this.handlers.set(I,T),this._proxy.$registerUriHandler(I,y),(0,D.toDisposable)(()=>{this.handles.delete(n.ExtensionIdentifier.toKey(y)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(y,T){const I=this.handlers.get(y);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(T))}catch(a){(0,C.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(y){return L.URI.revive(await this._proxy.$createAppUri(y))}}e.ExtHostUrls=k,k.HandlePool=0});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[68],ge([0,1,3,10,2,178,203,89,5]),function(Y,e,m,L,D,C,n,k,S){"use strict";var y,T,I,a,w,f,v,_,P,p,l,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(h,u,E,A,R,$,N){y.set(this,void 0),T.set(this,void 0),I.set(this,void 0),a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),v.set(this,""),_.set(this,void 0),P.set(this,!1),p.set(this,!1),l.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new m.Emitter),this._onDidDispose=Oe(this,r,"f").event,ot(this,y,h,"f"),ot(this,T,u,"f"),ot(this,_,E,"f"),ot(this,a,A,"f"),ot(this,w,R,"f"),ot(this,f,$,"f"),ot(this,l,o($),"f"),ot(this,I,N,"f")}dispose(){ot(this,P,!0,"f"),Oe(this,r,"f").fire(),Oe(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return ot(this,p,!0,"f"),(0,k.asWebviewUri)(h,Oe(this,a,"f").remote)}get cspSource(){const h=Oe(this,f,"f").extensionLocation;if(h.scheme===L.Schemas.https||h.scheme===L.Schemas.http){let u=h.toString();return u.endsWith("/")||(u+="/"),u+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,v,"f")}set html(h){this.assertNotDisposed(),Oe(this,v,"f")!==h&&(ot(this,v,h,"f"),!Oe(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(ot(this,p,!0,"f"),Oe(this,I,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,T,"f").$setHtml(Oe(this,y,"f"),h))}get options(){return this.assertNotDisposed(),Oe(this,_,"f")}set options(h){this.assertNotDisposed(),Oe(this,T,"f").$setOptions(Oe(this,y,"f"),t(Oe(this,f,"f"),Oe(this,w,"f"),h)),ot(this,_,h,"f")}async postMessage(h){if(Oe(this,P,"f"))return!1;const u=(0,n.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Oe(this,l,"f")});return Oe(this,T,"f").$postMessage(Oe(this,y,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,y=new WeakMap,T=new WeakMap,I=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,_=new WeakMap,P=new WeakMap,p=new WeakMap,l=new WeakMap,r=new WeakMap;function o(s){try{const h=(0,C.normalizeVersion)((0,C.parseVersion)(s.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class b{constructor(h,u,E,A,R){this.initData=u,this.workspace=E,this._logService=A,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=h.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(h,u,...E){const A=this.getWebview(h);if(A){const{message:R}=(0,n.deserializeWebviewMessage)(u,E);A._onMessageEmitter.fire(R)}}$onMissingCsp(h,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,u,E){const A=new g(h,this._webviewProxy,c(u),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(h,A),A._onDidDispose(()=>{this._webviews.delete(h)}),A}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=b;function i(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=i;function t(s,h,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||d(s,h)}}e.serializeWebviewOptions=t;function c(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(h=>D.URI.from(h))}}e.reviveOptions=c;function d(s,h){return[...(h?.getWorkspaceFolders()||[]).map(u=>u.uri),s.extensionLocation]}}),define(me[255],ge([0,1,21,48,6,10,23,2,16,68,88,5,7]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(o,b){this.document=o,this._storagePath=b,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,b){await this.getEdit(o).undo(),b||this.disposeBackup()}async redo(o,b){await this.getEdit(o).redo(),b||this.disposeBackup()}disposeEdits(o){for(const b of o)this._edits.delete(b)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=r(this.document.uri)+this._backupCounter++;return(0,n.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const b=this._edits.get(o,0);if(!b)throw new Error("No edit found");return b}}class f{constructor(){this._documents=new Map}get(o,b){return this._documents.get(this.key(o,b))}add(o,b,i){const t=this.key(o,b.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${o} resource:${b.uri}`);const c=new w(b,i);return this._documents.set(t,c),c}delete(o,b){const i=this.key(o,b.uri);this._documents.delete(i)}key(o,b){return`${o}@@@${b}`}}var v;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(o,b,i){return this.add(0,o,b,i)}addCustomProvider(o,b,i){return this.add(1,o,b,i)}get(o){return this._providers.get(o)}add(o,b,i,t){if(this._providers.has(b))throw new Error(`Provider for viewType:${b} already registered`);return this._providers.set(b,{type:o,extension:i,provider:t}),new a.Disposable(()=>this._providers.delete(b))}}class P{constructor(o,b,i,t,c){this._extHostDocuments=b,this._extensionStoragePaths=i,this._extHostWebview=t,this._extHostWebviewPanels=c,this._editorProviders=new _,this._documents=new f,this._proxy=o.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,b,i,t){const c=new D.DisposableStore;return p(i)?(c.add(this._editorProviders.addTextProvider(b,o,i)),this._proxy.$registerTextEditorProvider((0,y.toExtensionData)(o),b,t.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(o))):(c.add(this._editorProviders.addCustomProvider(b,o,i)),this.supportEditing(i)&&c.add(i.onDidChangeCustomDocument(d=>{const s=this.getCustomDocumentEntry(b,d.document.uri);if(l(d)){const h=s.addEdit(d);this._proxy.$onDidEdit(d.document.uri,b,h,d.label)}else this._proxy.$onContentChange(d.document.uri,b)})),this._proxy.$registerCustomEditorProvider((0,y.toExtensionData)(o),b,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(o))),a.Disposable.from(c,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(b)}))}async $createCustomDocument(o,b,i,t,c){const d=this._editorProviders.get(b);if(!d)throw new Error(`No provider found for '${b}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${b}'`);const s=k.URI.revive(o),h=await d.provider.openCustomDocument(s,{backupId:i,untitledDocumentData:t?.buffer},c);let u;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(b,h,u),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(o,b){const i=this._editorProviders.get(b);if(!i)throw new Error(`No provider found for '${b}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${b}'`);const t=k.URI.revive(o),{document:c}=this.getCustomDocumentEntry(b,t);this._documents.delete(b,c),c.dispose()}async $resolveWebviewEditor(o,b,i,t,c,d){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);const h=S.ViewColumn.to(c),u=this._extHostWebview.createNewWebview(b,t.webviewOptions,s.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(b,i,t.title,h,t.panelOptions,u),A=k.URI.revive(o);switch(s.type){case 1:{const{document:R}=this.getCustomDocumentEntry(i,A);return s.provider.resolveCustomEditor(R,E,d)}case 0:{const R=this._extHostDocuments.getDocument(A);return s.provider.resolveCustomTextEditor(R,E,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,b,i){this.getCustomDocumentEntry(b,o).disposeEdits(i)}async $onMoveCustomEditor(o,b,i){const t=this._editorProviders.get(i);if(!t)throw new Error(`No provider found for '${i}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const c=this._extHostWebviewPanels.getWebviewPanel(o);if(!c)throw new Error("No webview found");const d=k.URI.revive(b),s=this._extHostDocuments.getDocument(d);await t.provider.moveCustomTextEditor(s,c,m.CancellationToken.None)}async $undo(o,b,i,t){return this.getCustomDocumentEntry(b,o).undo(i,t)}async $redo(o,b,i,t){return this.getCustomDocumentEntry(b,o).redo(i,t)}async $revert(o,b,i){const t=this.getCustomDocumentEntry(b,o);await this.getCustomEditorProvider(b).revertCustomDocument(t.document,i),t.disposeBackup()}async $onSave(o,b,i){const t=this.getCustomDocumentEntry(b,o);await this.getCustomEditorProvider(b).saveCustomDocument(t.document,i),t.disposeBackup()}async $onSaveAs(o,b,i,t){const c=this.getCustomDocumentEntry(b,o);return this.getCustomEditorProvider(b).saveCustomDocumentAs(c.document,k.URI.revive(i),t)}async $backup(o,b,i){const t=this.getCustomDocumentEntry(b,o),d=await this.getCustomEditorProvider(b).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},i);return t.updateBackup(d),d.id}getCustomDocumentEntry(o,b){const i=this._documents.get(o,k.URI.revive(b));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(o){const i=this._editorProviders.get(o)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function p(g){return typeof g.resolveCustomTextEditor=="function"}function l(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function r(g){const o=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,L.hash)(o)+""}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[256],ge([0,1,3,6,2,32,16,68,5,7]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";var T,I,a,w,f,v,_,P,p,l,r,g,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class b extends L.Disposable{constructor(d,s,h,u,E,A,R){super();T.set(this,void 0),I.set(this,void 0),a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),v.set(this,void 0),_.set(this,void 0),P.set(this,void 0),p.set(this,!0),l.set(this,!0),r.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,g,"f").event,o.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,o,"f").event,ot(this,T,d,"f"),ot(this,I,s,"f"),ot(this,a,h,"f"),ot(this,f,A,"f"),ot(this,P,E,"f"),ot(this,v,u,"f"),ot(this,w,R,"f")}dispose(){Oe(this,r,"f")||(ot(this,r,!0,"f"),Oe(this,g,"f").fire(),Oe(this,I,"f").$disposeWebview(Oe(this,T,"f")),Oe(this,w,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,w,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,a,"f")}get title(){return this.assertNotDisposed(),Oe(this,v,"f")}set title(d){this.assertNotDisposed(),Oe(this,v,"f")!==d&&(ot(this,v,d,"f"),Oe(this,I,"f").$setTitle(Oe(this,T,"f"),d))}get iconPath(){return this.assertNotDisposed(),Oe(this,_,"f")}set iconPath(d){this.assertNotDisposed(),Oe(this,_,"f")!==d&&(ot(this,_,d,"f"),Oe(this,I,"f").$setIconPath(Oe(this,T,"f"),D.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,P,"f")=="number"&&Oe(this,P,"f")<0))return Oe(this,P,"f")}get active(){return this.assertNotDisposed(),Oe(this,l,"f")}get visible(){return this.assertNotDisposed(),Oe(this,p,"f")}_updateViewState(d){Oe(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(ot(this,l,d.active,"f"),ot(this,p,d.visible,"f"),ot(this,P,d.viewColumn,"f"),Oe(this,o,"f").fire({webviewPanel:this}))}reveal(d,s){this.assertNotDisposed(),Oe(this,I,"f").$reveal(Oe(this,T,"f"),{viewColumn:d?n.ViewColumn.from(d):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Oe(this,r,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,I=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,_=new WeakMap,P=new WeakMap,p=new WeakMap,l=new WeakMap,r=new WeakMap,g=new WeakMap,o=new WeakMap;class i{constructor(d,s,h){this.webviews=s,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,s,h,u,E={}){const A=typeof u=="object"?u.viewColumn:u,R={viewColumn:n.ViewColumn.from(A),preserveFocus:typeof u=="object"&&!!u.preserveFocus},$=(0,k.shouldSerializeBuffersForPostMessage)(d),N=i.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),N,s,{title:h,panelOptions:t(E),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,E),serializeBuffersForPostMessage:$},R);const F=this.webviews.createNewWebview(N,E,d);return this.createNewWebviewPanel(N,s,h,A,E,F)}$onDidChangeWebviewPanelViewStates(d){const s=Object.keys(d);s.sort((h,u)=>{const E=d[h],A=d[u];return E.active?1:A.active?-1:+E.visible-+A.visible});for(const h of s){const u=this.getWebviewPanel(h);if(!u)continue;const E=d[h];u._updateViewState({active:E.active,visible:E.visible,viewColumn:n.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,s,h){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:h,extension:d}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new y.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(d,s,h,u){const E=this._serializers.get(s);if(!E)throw new Error(`No serializer found for '${s}'`);const{serializer:A,extension:R}=E,$=this.webviews.createNewWebview(d,h.webviewOptions,R),N=this.createNewWebviewPanel(d,s,h.title,u,h.panelOptions,$);await A.deserializeWebviewPanel(N,h.state)}createNewWebviewPanel(d,s,h,u,E,A){const R=new b(d,this._proxy,s,h,u,E,A);return this._webviewPanels.set(d,R),R}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=i;function t(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[257],ge([0,1,3,6,68,5,7]),function(Y,e,m,L,D,C,n){"use strict";var k,S,y,T,I,a,w,f,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(r,g,o,b,i,t){super();k.set(this,void 0),S.set(this,void 0),y.set(this,void 0),T.set(this,void 0),I.set(this,!1),a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),v.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,v,"f").event,_.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,_,"f").event,ot(this,y,o,"f"),ot(this,w,b,"f"),ot(this,k,r,"f"),ot(this,S,g,"f"),ot(this,T,i,"f"),ot(this,a,t,"f")}dispose(){Oe(this,I,"f")||(ot(this,I,!0,"f"),Oe(this,_,"f").fire(),Oe(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(r){this.assertNotDisposed(),Oe(this,w,"f")!==r&&(ot(this,w,r,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Oe(this,f,"f")}set description(r){this.assertNotDisposed(),Oe(this,f,"f")!==r&&(ot(this,f,r,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,k,"f"),r))}get visible(){return Oe(this,a,"f")}get webview(){return Oe(this,T,"f")}get viewType(){return Oe(this,y,"f")}_setVisible(r){r===Oe(this,a,"f")||Oe(this,I,"f")||(ot(this,a,r,"f"),Oe(this,v,"f").fire())}show(r){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,k,"f"),!!r)}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,y=new WeakMap,T=new WeakMap,I=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,_=new WeakMap;class p{constructor(r,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,g,o,b){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:o,extension:r}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(r),g,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new n.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(r,g,o,b,i){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:c,extension:d}=t,s=this._extHostWebview.createNewWebview(r,{},d),h=new P(r,this._proxy,g,o,s,!0);this._webviewViews.set(r,h),await c.resolveWebviewView(h,{state:b},i)}async $onDidChangeWebviewViewVisibility(r,g){this.getWebviewView(r)._setVisible(g)}async $disposeWebviewView(r){const g=this.getWebviewView(r);this._webviewViews.delete(r),g.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const g=this._webviewViews.get(r);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=p}),define(me[133],ge([0,1,3,5,2,10,8,4,14]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let y=class zi{constructor(I){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,a){let w;if(typeof I=="string"){w=I;try{I=D.URI.parse(I)}catch(f){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,n.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,w,a)}async asExternalUri(I,a){if((0,n.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(I,a);return D.URI.from(w)}};y.InitialState={focused:!0},y=Ve([We(0,S.IExtHostRpcService)],y),e.ExtHostWindow=y,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(me[258],ge([0,1,9,81,32,38,6,5,2,14]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends n.Disposable{constructor(a,w){super();const f=a.getProxy(k.MainContext.MainThreadDownloadService);w.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=S.URI.file((0,m.join)((0,L.tmpdir)(),(0,D.generateUuid)()));return await f.$download(v,_),_})}};T=Ve([We(0,y.IExtHostRpcService),We(1,C.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(me[259],ge([0,1,131,10,187,32]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class n extends m.ExtHostLoggerService{doCreateLogger(S,y,T){return S.scheme===L.Schemas.file?new D.SpdLogLogger(T?.name||(0,C.generateUuid)(),S.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,y):super.doCreateLogger(S,y,T)}}e.ExtHostLoggerService=n}),define(me[260],ge([0,1,60,9,2,67,6,10,18,28]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const b=await super._getWorkspaceStorageURI(o);if(b.scheme!==k.Schemas.file)return b;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${b.fsPath}.`),b;const i=b.fsPath;let t=0;do{let c;t===0?c=i:c=/[/\\]$/.test(i)?`${i.substr(0,i.length-1)}-${t}`:`${i}-${t}`,await I(c);const d=L.join(c,"vscode.lock"),s=await v(this._logService,d,!1);if(s)return this._workspaceStorageLock=s,process.on("exit",()=>{s.dispose()}),D.URI.file(c);t++}while(t<10);return b}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function I(g){try{await y.Promises.stat(g);return}catch{}try{await y.Promises.mkdir(g,{recursive:!0})}catch{}}const a=1e3,w=10*60*1e3;class f extends n.Disposable{constructor(o,b){super();this.logService=o,this.filename=b,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const i=await _(o,b);(!i||i.pid!==process.pid)&&(o.info(`Lock '${b}': The lock was lost unexpectedly.`),this._timer.cancel());try{await y.Promises.utimes(b,new Date,new Date)}catch(t){o.error(t),o.info(`Lock '${b}': Could not update mtime.`)}},a)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(o){}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const b={pid:process.pid,willReleaseAt:Date.now()+o};await y.Promises.writeFile(this.filename,JSON.stringify(b),{flag:"w"})}catch(b){this.logService.error(b)}}}async function v(g,o,b){try{const t={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(o,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const i=await _(g,o);return!i||i.pid!==process.pid?b?(g.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),l(g,o)):(g.info(`Lock '${o}': Lock acquired.`),new f(g,o))}async function _(g,o){let b;try{b=await y.Promises.readFile(o)}catch(i){return g.error(i),null}try{return JSON.parse(String(b))}catch(i){return g.error(i),null}}async function P(g,o){let b;try{b=await y.Promises.stat(o)}catch(i){return g.error(i),0}return b.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch(o){return!1}}async function l(g,o){const b=await _(g,o);if(!b)return g.info(`Lock '${o}': Could not read pid of lock holder.`),r(g,o);if(b.willReleaseAt){let s=b.willReleaseAt-Date.now();if(s<5e3){for(s>0?g.info(`Lock '${o}': The lockfile is scheduled to be released in ${s} ms.`):g.info(`Lock '${o}': The lockfile is scheduled to have been released.`);s>0;){if(await(0,S.timeout)(Math.min(100,s)),await P(g,o)===0)return r(g,o);s=b.willReleaseAt-Date.now()}return r(g,o)}}if(!p(b.pid))return g.info(`Lock '${o}': The pid ${b.pid} appears to be gone.`),r(g,o);const i=await P(g,o),t=Date.now()-i;if(t<=w)return g.info(`Lock '${o}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const c=await P(g,o),d=Date.now()-c;return d<=w?(g.info(`Lock '${o}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),r(g,o))}async function r(g,o){g.info(`Lock '${o}': Deleting a stale lock.`);try{await y.Promises.unlink(o)}catch(b){}return v(g,o,!0)}}),define(me[261],ge([0,1,32,14,34]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends D.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,y){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:y})}createTerminalFromOptions(k,S){const y=new D.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(y),y.create(k,this._serializeParentTerminal(k,S)),y.value}};C=Ve([We(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(me[262],ge([0,1,5,14,170,6,26,2,37,23,28,7,11,52,3,120,77,12]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(h,u,E){this.remoteAddress=h,this.localAddress=u,this._dispose=E,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function l(s){const h=s.trim().split(`
`),u=[];return h.forEach(A=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);R&&R.length>=3&&u.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),u.reduce((A,R)=>(A[R.socket]=R,A),{})}e.getSockets=l;function r(...s){const h=[].concat(...s.map(o));return[...new Map(h.filter(u=>u.st==="0A").map(u=>{const E=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:g(E[0]),port:parseInt(E[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=r;function g(s){let h="";if(s.length===8)for(let u=s.length-2;u>=0;u-=2)h+=parseInt(s.substr(u,2),16),u!==0&&(h+=".");else for(let u=s.length-4;u>=0;u-=4)h+=parseInt(s.substr(u,4),16).toString(16),u!==0&&(h+=":");return h}e.parseIpAddress=g;function o(s){const h=s.trim().split(`
`),u=h.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return h.map(A=>A.trim().split(/\s+/).reduce((R,$,N)=>(R[u[N]||N]=$,R),{}))}e.loadConnectionTable=o;function b(s){return!!s.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||s.indexOf("out/vs/server/main.js")!==-1||s.indexOf("_productName=VSCode")!==-1}function i(s){const h=s.trim().split(`
`),u=[];return h.forEach(E=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);A&&A.length>=4&&u.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),u}e.getRootProcesses=i;async function t(s,h,u){const E=u.reduce((R,$)=>(R[$.pid]=$,R),{}),A=[];return s.forEach(({socket:R,ip:$,port:N})=>{const F=h[R]?h[R].pid:void 0,z=F?E[F]?.cmd:void 0;F&&z&&!b(z)&&A.push({host:$,port:N,detail:z,pid:F})}),A}e.findPorts=t;function c(s,h,u){const E=new Map,A=i(h);for(const R of s){const $=u.get(R.port);if($){E.set(R.port,$);continue}const N=A.find(F=>F.cmd.includes(`${R.port}`));if(N){let F=N,z;do z=A.find(M=>M.ppid===F.pid),z&&(F=z);while(z);E.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=c;let d=class extends C.Disposable{constructor(h,u,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(m.MainContext.MainThreadTunnelService),a.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(u,h.displayName);if(E){const A=new p(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,u){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:h,provider:u}),this._proxy.$registerPortsAttributesProvider(h,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(h,u,E,A,R){const $=[];for(const F of h){const z=this._portAttributesProviders.get(F);if(!z)return[];$.push(...await Promise.all(u.map(async M=>z.provider.providePortAttributes(M,E,A,R))))}const N=$.filter(F=>!!F);return N.length>0?N.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let u=new _.MovingAverage,E;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),R=(await this.findCandidatePorts()).filter(N=>(0,v.isLocalhost)(N.host)||(0,v.isAllInterfaces)(N.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(N=>N.port).join(", ")}`);const $=new Date().getTime()-A;u.update($),(!E||JSON.stringify(E)!==JSON.stringify(R))&&(E=R,await this._proxy.$onFoundNewCandidates(E)),await new Promise(N=>setTimeout(()=>N(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let u=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,u){if(this._extensionTunnels.has(h.host)){const E=this._extensionTunnels.get(h.host);E.has(h.port)&&(u&&E.get(h.port).disposeListener.dispose(),await E.get(h.port).tunnel.dispose(),E.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(h,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const A=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const R=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:A,disposeListener:R}),w.TunnelDto.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const u=await Promise.all(h.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),E=h.filter((A,R)=>u[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(A=>A.port).join(", ")} to ${E.map(A=>A.port).join(", ")}`),E}async findCandidatePorts(){let h="",u="";try{h=await T.Promises.readFile("/proc/net/tcp","utf8"),u=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const E=r(h,u),A=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,B,O)=>{U(B)})}),R=l(A),$=await T.Promises.readdir("/proc"),N=[];for(let U of $)try{const x=Number(U),B=y.joinPath(k.URI.file("/proc"),U);if((await T.Promises.stat(B.fsPath)).isDirectory()&&!isNaN(x)){const H=await T.Promises.readlink(y.joinPath(B,"cwd").fsPath),j=await T.Promises.readFile(y.joinPath(B,"cmdline").fsPath,"utf8");N.push({pid:x,cwd:H,cmd:j})}}catch(x){}const F=[],z=E.filter(U=>{const x=R[U.socket];return x||F.push(U),x}),M=t(z,R,N);let W;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(x=>{(0,S.exec)("ps -F -A -l | grep root",(B,O,H)=>{x(O)})});this._foundRootPorts=c(F,U,this._foundRootPorts),W=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.join(", ")}`)}return M.then(U=>W?U.concat(W):U)}};d=Ve([We(0,L.IExtHostRpcService),We(1,n.IExtHostInitDataService),We(2,P.ILogService)],d),e.ExtHostTunnelService=d}),define(me[263],ge([0,1,18,22,21,15,3,6,103,227,53]),function(Y,e,m,L,D,C,n,k,S,y,T){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(E,A){try{return JSON.stringify(E,A)}catch(R){return"null"}}const w="$$ref$$",f={[w]:-1};class v{constructor(A,R){this.jsonString=A,this.referencedBuffers=R}}function _(E,A=null,R=!1){const $=[];return{jsonString:(R?a:JSON.stringify)(E,(F,z)=>{if(typeof z=="undefined")return f;if(typeof z=="object"){if(z instanceof L.VSBuffer){const M=$.push(z)-1;return{[w]:M}}if(A)return A(F,z)}return z}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=_;function P(E,A,R){return JSON.parse(E,($,N)=>{if(N){const F=N[w];if(typeof F=="number")return A[F];if(R&&N.$mid===1)return R.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=P;function p(E,A){return JSON.stringify(E,A)}function l(E){return E?(A,R)=>R&&R.$mid===1?E.transformOutgoing(R):R:null}var r;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},b=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(A,R=null,$=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new n.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=R,this._uriTransformer=$,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,F=T.ProxyIdentifier.count;N<F;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,S.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:R,sid:$}=A;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,$)),this._proxies[R]}_createProxy(A,R){let $={get:(N,F)=>(typeof F=="string"&&!N[F]&&F.charCodeAt(0)===36&&(N[F]=(...z)=>this._remoteCall(A,F,z)),F===i?R:N[F])};return new Proxy(Object.create(null),$)}set(A,R){return this._locals[A.nid]=R,R}assertRegistered(A){for(let R=0,$=A.length;R<$;R++){const N=A[R];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const R=A.byteLength,$=c.read(A,0),N=$.readUInt8(),F=$.readUInt32();switch(N){case 1:case 2:{let{rpcId:z,method:M,args:W}=s.deserializeRequestJSONArgs($);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(R,F,z,M,W,N===2);break}case 3:case 4:{let{rpcId:z,method:M,args:W}=s.deserializeRequestMixedArgs($);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(R,F,z,M,W,N===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let z=s.deserializeReplyOKJSON($);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(R,F,z);break}case 10:{const z=s.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(R,F,z);break}case 8:{let z=s.deserializeReplyOKVSBuffer($);this._receiveReply(R,F,z);break}case 11:{let z=s.deserializeReplyErrError($);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(R,F,z);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,R,$,N,F,z){this._logger&&this._logger.logIncoming(A,R,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)($)}.${N}(`,F);const M=String(R);let W,U;if(z){const B=new D.CancellationTokenSource;F.push(B.token),W=this._invokeHandler($,N,F),U=()=>B.cancel()}else W=this._invokeHandler($,N,F),U=o;this._cancelInvokedHandlers[M]=U;const x=s.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(x.byteLength,R,1,"ack"),this._protocol.send(x),W.then(B=>{delete this._cancelInvokedHandlers[M];const O=s.serializeReplyOK(R,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",B),this._protocol.send(O)},B=>{delete this._cancelInvokedHandlers[M];const O=s.serializeReplyErr(R,B);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",B),this._protocol.send(O)})}_receiveCancel(A,R){this._logger&&this._logger.logIncoming(A,R,1,"receiveCancel");const $=String(R);this._cancelInvokedHandlers[$]&&this._cancelInvokedHandlers[$]()}_receiveReply(A,R,$){this._logger&&this._logger.logIncoming(A,R,0,"receiveReply:",$);const N=String(R);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],F.resolveOk($)}_receiveReplyErr(A,R,$){this._logger&&this._logger.logIncoming(A,R,0,"receiveReplyErr:",$);const N=String(R);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let z;$&&($.$isError?(z=new Error,z.name=$.name,z.message=$.message,z.stack=$.stack):z=$),F.resolveErr(z)}_invokeHandler(A,R,$){try{return Promise.resolve(this._doInvokeHandler(A,R,$))}catch(N){return Promise.reject(N)}}_doInvokeHandler(A,R,$){const N=this._locals[A];if(!N)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(A));let F=N[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,T.getStringIdentifierForProxy)(A));return F.apply(N,$)}_remoteCall(A,R,$){if(this._isDisposed)return Promise.reject(C.canceled());let N=null;if($.length>0&&D.CancellationToken.isCancellationToken($[$.length-1])&&(N=$.pop()),N&&N.isCancellationRequested)return Promise.reject(C.canceled());const F=s.serializeRequestArguments($,this._uriReplacer),z=++this._lastMessageId,M=String(z),W=new y.LazyPromise;N&&N.onCancellationRequested(()=>{const x=s.serializeCancel(z);this._logger&&this._logger.logOutgoing(x.byteLength,z,0,"cancel"),this._protocol.send(s.serializeCancel(z))}),this._pendingRPCReplies[M]=W,this._onWillSendRequest(z);const U=s.serializeRequest(z,A,R,F,!!N);return this._logger&&this._logger.logOutgoing(U.byteLength,z,0,`request: ${(0,T.getStringIdentifierForProxy)(A)}.${R}(`,$),this._protocol.send(U),W}}e.RPCProtocol=t,I=b,t.UNRESPONSIVE_TIME=3*1e3;class c{constructor(A,R){this._buff=A,this._offset=R}static alloc(A,R,$){let N=new c(L.VSBuffer.alloc($+1+4),0);return N.writeUInt8(A),N.writeUInt32(R),N}static read(A,R){return new c(A,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,$}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,$}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,R}static sizeMixedArray(A){let R=0;R+=1;for(let $=0,N=A.length;$<N;$++){const F=A[$];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let z=0;z<F.buffers.length;++z)R+=this.sizeVSBuffer(F.buffers[z]);break;case 4:break}}return R}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let R=0,$=A.length;R<$;R++){const N=A[R];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let F=0;F<N.buffers.length;++F)this.writeBuffer(N.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(A);for(let $=0;$<A;$++)switch(this.readUInt8()){case 1:R[$]=this.readLongString();break;case 2:R[$]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),z=this.readLongString(),M=[];for(let W=0;W<F;++W)M.push(this.readVSBuffer());R[$]=new T.SerializableObjectWithBuffers(P(z,M,null));break;case 4:R[$]=void 0;break}return R}}c.sizeUInt32=4;var d;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(d||(d={}));class s{static _useMixedArgSerialization(A){for(let R=0,$=A.length;R<$;R++)if(A[R]instanceof L.VSBuffer||A[R]instanceof T.SerializableObjectWithBuffers||typeof A[R]=="undefined")return!0;return!1}static serializeRequestArguments(A,R){if(this._useMixedArgSerialization(A)){const $=[];for(let N=0,F=A.length;N<F;N++){const z=A[N];if(z instanceof L.VSBuffer)$[N]={type:2,value:z};else if(typeof z=="undefined")$[N]={type:4};else if(z instanceof T.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:W}=_(z.value,R);$[N]={type:3,value:L.VSBuffer.fromString(M),buffers:W}}else $[N]={type:1,value:L.VSBuffer.fromString(p(z,R))}}return{type:1,args:$}}return{type:0,args:p(A,R)}}static serializeRequest(A,R,$,N,F){switch(N.type){case 0:return this._requestJSONArgs(A,R,$,N.args,F);case 1:return this._requestMixedArgs(A,R,$,N.args,F)}}static _requestJSONArgs(A,R,$,N,F){const z=L.VSBuffer.fromString($),M=L.VSBuffer.fromString(N);let W=0;W+=c.sizeUInt8(),W+=c.sizeShortString(z),W+=c.sizeLongString(M);let U=c.alloc(F?2:1,A,W);return U.writeUInt8(R),U.writeShortString(z),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(A){const R=A.readUInt8(),$=A.readShortString(),N=A.readLongString();return{rpcId:R,method:$,args:JSON.parse(N)}}static _requestMixedArgs(A,R,$,N,F){const z=L.VSBuffer.fromString($);let M=0;M+=c.sizeUInt8(),M+=c.sizeShortString(z),M+=c.sizeMixedArray(N);let W=c.alloc(F?4:3,A,M);return W.writeUInt8(R),W.writeShortString(z),W.writeMixedArray(N),W.buffer}static deserializeRequestMixedArgs(A){const R=A.readUInt8(),$=A.readShortString(),N=A.readMixedArray(),F=new Array(N.length);for(let z=0,M=N.length;z<M;z++){const W=N[z];typeof W=="string"?F[z]=JSON.parse(W):F[z]=W}return{rpcId:R,method:$,args:F}}static serializeAcknowledged(A){return c.alloc(5,A,0).buffer}static serializeCancel(A){return c.alloc(6,A,0).buffer}static serializeReplyOK(A,R,$){if(typeof R=="undefined")return this._serializeReplyOKEmpty(A);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,R);if(R instanceof T.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:F}=_(R.value,$,!0);return this._serializeReplyOKJSONWithBuffers(A,N,F)}else return this._serializeReplyOKJSON(A,a(R,$))}static _serializeReplyOKEmpty(A){return c.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,R){let $=0;$+=c.sizeVSBuffer(R);let N=c.alloc(8,A,$);return N.writeVSBuffer(R),N.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,R){const $=L.VSBuffer.fromString(R);let N=0;N+=c.sizeLongString($);let F=c.alloc(9,A,N);return F.writeLongString($),F.buffer}static _serializeReplyOKJSONWithBuffers(A,R,$){const N=L.VSBuffer.fromString(R);let F=0;F+=c.sizeUInt32,F+=c.sizeLongString(N);for(const M of $)F+=c.sizeVSBuffer(M);let z=c.alloc(10,A,F);z.writeUInt32($.length),z.writeLongString(N);for(const M of $)z.writeBuffer(M);return z.buffer}static deserializeReplyOKJSON(A){const R=A.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(A,R){const $=A.readUInt32(),N=A.readLongString(),F=[];for(let z=0;z<$;++z)F.push(A.readVSBuffer());return new T.SerializableObjectWithBuffers(P(N,F,R))}static serializeReplyErr(A,R){return R?this._serializeReplyErrEror(A,R):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,R){const $=L.VSBuffer.fromString(a(C.transformErrorForSerialization(R),null));let N=0;N+=c.sizeLongString($);let F=c.alloc(11,A,N);return F.writeLongString($),F.buffer}static deserializeReplyErrError(A){const R=A.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(A){return c.alloc(12,A,0).buffer}}var h;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var u;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(u||(u={}))}),define(me[264],ge([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(me[265],ge([0,1,10,9,11,2,4,62,44,222,264]),function(Y,e,m,L,D,C,n,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,n.createDecorator)("pathService");let I=class Vi{constructor(w,f,v,_){this.localUserHome=w,this.remoteAgentService=f,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||w})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(w,f){if(w.remoteAuthority)return m.Schemas.vscodeRemote;const v=(0,k.getVirtualWorkspaceScheme)(f.getWorkspace());if(v)return v;const _=f.getWorkspace().folders[0];if(_)return _.uri.scheme;const P=f.getWorkspace().configuration;return P?P.scheme:m.Schemas.file}async userHome(w){return w?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(w=>w===1?L.win32:L.posix)}async fileURI(w){let f="";if(await this.resolveOS===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const _=w.indexOf("/",2);_===-1?(f=w.substring(2),w="/"):(f=w.substring(2,_),w=w.substring(_)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:f,path:w,query:"",fragment:""})}};I=Ve([We(1,T.IRemoteAgentService),We(2,y.IWorkbenchEnvironmentService),We(3,S.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(me[69],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(n,k){this.line=n,this.character=k}isBefore(n){return!1}isBeforeOrEqual(n){return!1}isAfter(n){return!1}isAfterOrEqual(n){return!1}isEqual(n){return!1}compareTo(n){return 0}translate(n,k){return new m(0,0)}with(n){return new m(0,0)}}e.Position=m;class L{constructor(n,k,S,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(n,k),this.end=new m(S,y)}contains(n){return!1}isEqual(n){return!1}intersection(n){}union(n){return new L(0,0,0,0)}with(n){return new L(0,0,0,0)}}e.Range=L;var D;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[33],ge([0,1,17,31,25,30,8,4,9,15,69,13]),function(Y,e,m,L,D,C,n,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",w=" characters skipped \u27EB",f=(a.length+w.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var v;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var _;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function P(x){return!!x.preview}e.resultIsMatch=P;function p(x){return!!x.resource}e.isFileMatch=p;function l(x){return!!x.message}e.isProgressMessage=l;var r;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=g;class o{constructor(B,O,H){this.ranges=O;const j=Array.isArray(O)?O:[O];if(H&&H.matchLines===1&&b(j)){B=(0,n.getNLines)(B,H.matchLines);let X="",K=0,he=0;const Ee=Math.floor(H.charsPerLine/5),De=[];for(const Pe of j){const Be=Math.max(Pe.startColumn-Ee,0),He=Pe.startColumn+H.charsPerLine;if(Be>he+Ee+f){const ze=a+(Be-he)+w;X+=ze+B.slice(Be,He),K+=Be-(he+ze.length)}else X+=B.slice(he,He);De.push(new t(0,Pe.startColumn-K,Pe.endColumn-K)),he=He}this.preview={text:X,matches:Array.isArray(this.ranges)?De:De[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:B,matches:(0,m.mapArrayOrNot)(O,K=>new i(K.startLineNumber-X,K.startColumn,K.endLineNumber-X,K.endColumn))}}}}e.TextSearchMatch=o;function b(x){const B=x[0].startLineNumber;for(const O of x)if(O.startLineNumber!==B||O.endLineNumber!==B)return!1;return!0}class i{constructor(B,O,H,j){this.startLineNumber=B,this.startColumn=O,this.endLineNumber=H,this.endColumn=j}}e.SearchRange=i;class t extends i{constructor(B,O,H){super(B,O,B,H)}}e.OneLineRange=t;var c;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function d(x,B=!0){const O=x&&x.files&&x.files.exclude,H=B&&x&&x.search&&x.search.exclude;if(!O&&!H)return;if(!O||!H)return O||H;let j=Object.create(null);return j=D.mixin(j,D.deepClone(O)),j=D.mixin(j,D.deepClone(H),!0),j}e.getExcludes=d;function s(x,B){return x.excludePattern&&L.match(x.excludePattern,B)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.match(x.includePattern,B)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(O=>{const H=O.folder.fsPath;if(C.isEqualOrParent(B,H)){const j=S.relative(H,B);return!O.includePattern||!!L.match(O.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var h;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(B,O){super(B);this.code=O}}e.SearchError=u;function E(x){const B=x.message;if((0,y.isPromiseCanceledError)(x))return new u(B,h.canceled);try{const O=JSON.parse(B);return new u(O.message,O.code)}catch(O){return new u(B,h.other)}}e.deserializeSearchError=E;function A(x){const B={message:x.message,code:x.code};return new Error(JSON.stringify(B))}e.serializeSearchError=A;function R(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=R;function $(x){return x.type==="success"}e.isSerializedSearchSuccess=$;function N(x){return!!x.path}e.isSerializedFileMatch=N;function F(x,B){const O=x.searchPath?x.searchPath:x.relativePath;return(0,n.fuzzyContains)(O,B)}e.isFilePatternMatch=F;class z{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function M(x,B){const O={...x||{},...B||{}};return Object.keys(O).filter(H=>{const j=O[H];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=M;class W{constructor(B,O){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=B.includePattern;O.includePattern&&(H?H={...H,...O.includePattern}:H=O.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}matchesExcludesSync(B,O,H){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,O,H))}includedInQuerySync(B,O,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,O,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,O,H))}includedInQuery(B,O,H){const j=this._parsedExcludeExpression(B,O,H),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,O,H):!0;return(0,I.isPromise)(j)?j.then(K=>K?!1:X()):X()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=W;function U(x){for(const B in x)if(typeof x[B]!="boolean")return!0;return!1}}),define(me[35],ge([0,1,17,18,21,3,24,10,77,23,8,13,2,168,4,12,188,44,45,26,14,7,33,5]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l,r,g,o,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(A,R,$){return new y.ExtUri(N=>s(N,$)).isEqual(A,R)}function t(A,R,$){return i(A.uri,R.uri,$)?0:(0,T.compare)(A.uri.toString(),R.uri.toString())}function c(A,R,$){return A.index!==R.index?A.index<R.index?-1:1:i(A.uri,R.uri,$)?(0,T.compare)(A.name,R.name):(0,T.compare)(A.uri.toString(),R.uri.toString())}function d(A,R,$,N){const F=A.slice(0).sort((M,W)=>$(M,W,N)),z=R.slice(0).sort((M,W)=>$(M,W,N));return(0,m.delta)(F,z,(M,W)=>$(M,W,N))}function s(A,R){const $=R.getCapabilities(A.scheme);return!($&&$&1024)}class h extends P.Workspace{constructor(R,$,N,F,z,M,W){super(R,N.map(U=>new P.WorkspaceFolder(U)),F,z,W);this._name=$,this._isUntitled=M,this._workspaceFolders=[],this._structure=n.TernarySearchTree.forUris(W),N.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(R,$,N,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:z,name:M,folders:W,configuration:U,transient:x,isUntitled:B}=R,O=[],H=$;$?W.forEach((he,Ee)=>{const De=a.URI.revive(he.uri),Pe=h._findFolder(N||$,De,F);Pe?(Pe.name=he.name,Pe.index=he.index,O.push(Pe)):O.push({uri:De,name:he.name,index:Ee})}):O.push(...W.map(({uri:he,name:Ee,index:De})=>({uri:a.URI.revive(he),name:Ee,index:De}))),O.sort((he,Ee)=>he.index<Ee.index?-1:1);const j=new h(z,M,O,!!x,U?a.URI.revive(U):null,!!B,he=>s(he,F)),{added:X,removed:K}=d(H?H.workspaceFolders:[],j.workspaceFolders,t,F);return{workspace:j,added:X,removed:K}}static _findFolder(R,$,N){for(let F=0;F<R.folders.length;F++){const z=R.workspaceFolders[F];if(i(z.uri,$,N))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,$){return $&&this._structure.get(R)&&(R=(0,y.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let u=class{constructor(R,$,N,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=N,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(b.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(b.MainContext.MainThreadMessageService);const z=$.workspace;this._confirmedWorkspace=z?new h(z.id,z.name,[],!!z.transient,z.configuration?a.URI.revive(z.configuration):null,!!z.isUntitled,M=>s(M,N)):void 0}$initializeWorkspace(R,$){this._trusted=$,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:k.Schemas.untitled,path:(0,y.basename)((0,y.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,$,N,...F){const z=[];if(Array.isArray(F)&&F.forEach(B=>{a.URI.isUri(B.uri)&&!z.some(O=>i(O.uri,B.uri,this._extHostFileSystemInfo))&&z.push({uri:B.uri,name:B.name||(0,y.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[$,N].some(B=>typeof B!="number"||B<0)||N===0&&z.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+N>M.length)return!1;const W=M.slice(0);W.splice($,N,...z.map(B=>({uri:B.uri,name:B.name||(0,y.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<W.length;B++){const O=W[B];if(W.some((H,j)=>j!==B&&i(O.uri,H.uri,this._extHostFileSystemInfo)))return!1}W.forEach((B,O)=>B.index=O);const{added:U,removed:x}=d(M,W,c,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const B=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(B,$,N,z).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,w.localize)(0,null,B,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(R,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,$)}async getWorkspaceFolder2(R,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,$)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,$){let N,F="";if(typeof R=="string"?(N=a.URI.file(R),F=R):typeof R!="undefined"&&(N=R,F=R.fsPath),!N)return F;const z=this.getWorkspaceFolder(N,!0);if(!z)return F;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let M=(0,y.relativePath)(z.uri,N);return $&&z.name&&(M=`${z.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:$,added:N,removed:F}=h.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:F}))}findFiles(R,$,N,F,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if($===null?M=!1:$&&(typeof $=="string"?M=$:M=$.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:U}=E(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(W),(0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(N),z).then(x=>Array.isArray(x)?x.map(B=>a.URI.revive(B)):[])}async findTextInFiles(R,$,N,F,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),W=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:U,folder:x}=E($.include),B=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,O={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:W,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:U,excludePattern:B},H=!1;if(this._activeSearchCallbacks[M]=j=>{if(H)return;const X=a.URI.revive(j.resource);j.results.forEach(K=>{(0,o.resultIsMatch)(K)?N({uri:X,preview:{text:K.preview.text,matches:(0,m.mapArrayOrNot)(K.preview.matches,he=>new g.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,m.mapArrayOrNot)(K.ranges,he=>new g.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):N({uri:X,text:K.text,lineNumber:K.lineNumber})})},z.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(x),O,M,z);return delete this._activeSearchCallbacks[M],j||{}}catch(j){throw delete this._activeSearchCallbacks[M],j}}$handleTextSearchResult(R,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([We(0,r.IExtHostRpcService),We(1,l.IExtHostInitDataService),We(2,p.IExtHostFileSystemInfo),We(3,v.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function E(A){let R,$;return A&&(typeof A=="string"?R=A:(R=A.pattern,$=A.baseFolder||a.URI.file(A.base))),{includePattern:R,folder:$}}}),define(me[36],ge([0,1,25,3,35,5,7,192,86,13,18,4,14,12,2]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(b,i){if(i){const t=i.split(".");let c=b;for(let d=0;c&&d<t.length;d++)c=c[t[d]];return c}}function _(b){return b instanceof f.URI}function P(b){return b&&b.uri instanceof f.URI&&b.languageId&&typeof b.languageId=="string"}function p(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function l(b){return b&&b.uri instanceof f.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function r(b){if(_(b))return{resource:b};if(P(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(p(b))return{overrideIdentifier:b.languageId};if(l(b))return{resource:b.uri};if(b===null)return{resource:null}}let g=class{constructor(i,t,c){this._proxy=i.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=c,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new o(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,t){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(i,t))}};g=Ve([We(0,a.IExtHostRpcService),We(1,D.IExtHostWorkspace),We(2,w.ILogService)],g),e.ExtHostConfiguration=g;class o{constructor(i,t,c,d){this._onDidChangeConfiguration=new L.Emitter,this._proxy=i,this._logService=d,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,t){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,c))}getConfiguration(i,t,c){const d=r(t)||{},s=this._toReadonlyValue(i?v(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,d,c?.identifier);function h(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case n.ConfigurationTarget.Global:return 1;case n.ConfigurationTarget.Workspace:return 4;case n.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(E){return typeof v(s,E)!="undefined"},get:(E,A)=>{this._validateConfigurationAccess(i?`${i}.${E}`:E,d,c?.identifier);let R=v(s,E);if(typeof R=="undefined")R=A;else{let $;const N=(F,z)=>{let M;const W=()=>{$=$||(0,m.deepClone)(s),M=M||v($,z)};return(0,y.isObject)(F)?new Proxy(F,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return W(),()=>M;if($)return M=M||v($,z),M[x];const B=U[x];return typeof x=="string"?N(B,`${z}.${x}`):B},set:(U,x,B)=>(W(),M&&(M[x]=B),!0),deleteProperty:(U,x)=>(W(),M&&delete M[x],!0),defineProperty:(U,x,B)=>(W(),M&&Object.defineProperty(M,x,B),!0)}):F};R=N(R,E)}return R},update:(E,A,R,$)=>{E=i?`${i}.${E}`:E;const N=h(R);return A!==void 0?this._proxy.$updateConfigurationOption(N,E,A,d,$):this._proxy.$removeConfigurationOption(N,E,d,$)},inspect:E=>{E=i?`${i}.${E}`:E;const A=(0,m.deepClone)(this._configuration.inspect(E,d,this._extHostWorkspace.workspace));if(A)return{key:E,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof s=="object"&&(0,m.mixin)(u,s,!1),Object.freeze(u)}_toReadonlyValue(i){const t=c=>(0,y.isObject)(c)?new Proxy(c,{get:(d,s)=>t(d[s]),set:(d,s,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(d,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(d,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return t(i)}_validateConfigurationAccess(i,t,c){const d=S.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),s=c?`[${c.value}] `:"";if(d===4){typeof t?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){t?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,t){const c=new k.ConfigurationChangeEvent(i,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,s)=>c.affectsConfiguration(d,r(s))})}_toMap(i){return i.reduce((t,c)=>(t.set(c[0],c[1]),t),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[70],ge([0,1,2,18,3,5,7,35,46,36,21,34,14,26,4,10,11,12,65,212,15]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l,r){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(z){function M(U){if(U!=null)return U}z.from=M;function W(U){if(U!=null)return U}z.to=W})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var b;(function(z){function M(U){if(U!=null)return U}z.from=M;function W(U){if(U!=null)return U}z.to=W})(b=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(z){function M(U){if(U!=null)return U}z.from=M;function W(U){if(U!=null)return U}z.to=W})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(z){function M(x){if(x){const B=x;return B&&!!B.process}else return!1}z.is=M;function W(x){if(x==null)return;const B={process:x.process,args:x.args};return x.options&&(B.options=i.from(x.options)),B}z.from=W;function U(x){if(x!=null)return new n.ProcessExecution(x.process,x.args,x.options)}z.to=U})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(z){function M(U){if(U!=null)return U}z.from=M;function W(U){if(U!=null)return U}z.to=W})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(z){function M(x){if(x){const B=x;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=M;function W(x){if(x==null)return;const B={};return x.commandLine!==void 0?B.commandLine=x.commandLine:(B.command=x.command,B.args=x.args),x.options&&(B.options=c.from(x.options)),B}z.from=W;function U(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new n.ShellExecution(x.commandLine,x.options):new n.ShellExecution(x.command,x.args?x.args:[],x.options)}z.to=U})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(z){function M(x){if(x){let B=x;return B&&B.customExecution==="customExecution"}else return!1}z.is=M;function W(x){return{customExecution:"customExecution"}}z.from=W;function U(x,B){return B.get(x)}z.to=U})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(z){function M(W,U){let x;return W.scope!==void 0&&typeof W.scope!="number"?x=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===n.TaskScope.Workspace&&U&&U.workspaceFile?x=U.workspaceFile:x=l.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:x}}z.from=M})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(z){function M(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}z.from=M})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(z){function M(x,B){if(x==null)return[];const O=[];for(let H of x){const j=W(H,B);j&&O.push(j)}return O}z.fromMany=M;function W(x,B){if(x==null)return;let O;x.execution instanceof n.ProcessExecution?O=t.from(x.execution):x.execution instanceof n.ShellExecution?O=d.from(x.execution):x.execution&&x.execution instanceof n.CustomExecution&&(O=s.from(x.execution));const H=o.from(x.definition);let j;return x.scope?typeof x.scope=="number"?j=x.scope:j=x.scope.uri:j=n.TaskScope.Workspace,!H||!j?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:B.identifier.value,label:x.source,scope:j},execution:O,isBackground:x.isBackground,group:u.from(x.group),presentationOptions:b.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}z.from=W;async function U(x,B,O){if(x==null)return;let H;t.is(x.execution)?H=t.to(x.execution):d.is(x.execution)?H=d.to(x.execution):s.is(x.execution)&&(H=s.to(x._id,O));const j=o.to(x.definition);let X;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?X=x.source.scope:X=await B.resolveWorkspaceFolder(m.URI.revive(x.source.scope)):X=n.TaskScope.Workspace),!j||!X)return;const K=new n.Task(j,X,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(K.isBackground=x.isBackground),x.group!==void 0&&(K.group=n.TaskGroup.from(x.group._id),K.group&&x.group.isDefault&&(K.group=new n.TaskGroup(K.group.id,K.group.label),x.group.isDefault&&(K.group.isDefault=x.group.isDefault))),x.presentationOptions&&(K.presentationOptions=b.to(x.presentationOptions)),x._id&&(K._id=x._id),x.detail&&(K.detail=x.detail),K}z.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var A;(function(z){function M(U){return U}z.from=M;function W(U){if(!!U)return Object.assign(Object.create(null),U)}z.to=W})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,W,U){this._id=W,this._task=U,g.set(this,void 0),ot(this,g,M,"f")}get task(){return this._task}terminate(){Oe(this,g,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}g=new WeakMap;var $;(function(z){function M(W){return{id:W._id,task:void 0}}z.from=M})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(M,W,U,x,B,O,H,j){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=x,this._configurationService=B,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,W,U){if(!U)return new n.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:W,provider:U,extension:M}),this._proxy.$registerTaskProvider(x,W),new n.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(M,W){this._proxy.$registerTaskSystem(M,W)}fetchTasks(M){return this._proxy.$fetchTasks(A.from(M)).then(async W=>{const U=[];for(let x of W){const B=await E.to(x,this._workspaceProvider,this._providedCustomExecutions2);B&&U.push(B)}return U})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(W=>M.push(W)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,W,U){const x=this._providedCustomExecutions2.get(M.id);x&&(this._activeCustomExecutions2.set(M.id,x),this._terminalService.attachPtyToTerminal(W,await x.callback(U))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const W=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const W=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:W,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const W=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:M.exitCode})}$provideTasks(M,W){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));const x=[],B=(0,L.asPromise)(()=>U.provider.provideTasks(T.CancellationToken.None)).then(O=>this.provideTasksInternal(W,x,U,O));return new Promise(O=>{B.then(H=>{Promise.all(x).then(()=>{O(H)})})})}async $resolveTask(M,W){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(W.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${U.type}].`);const x=await E.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const B=await U.provider.resolveTask(x,T.CancellationToken.None);if(!B)return;this.checkDeprecation(B,U);const O=E.from(B,U.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(O.execution)&&await this.addCustomExecution(O,B,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,W,U){const x=await this._proxy.$createTaskId(M);!U&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,W.execution)),this._providedCustomExecutions2.set(x,W.execution)}async getTaskExecution(M,W){if(typeof M=="string"){const B=this._taskExecutionPromises.get(M);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let U=this._taskExecutionPromises.get(M.id);if(U)return U;const x=new Promise((B,O)=>{function H(j,X,K){K?B(new R(j,X.id,K)):O("Unexpected: Task does not exist.")}W?H(this,M,W):E.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(j=>H(this,M,j))});return this._taskExecutionPromises.set(M.id,x),x.then(B=>(this._taskExecutions.set(M.id,B),B),B=>Promise.reject(B))}checkDeprecation(M,W){M._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let U=this._notProvidedCustomExecutions.values(),x=U.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=U.next()}};N=Ve([We(0,a.IExtHostRpcService),We(1,w.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,y.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,P.ILogService),We(7,p.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let F=class extends N{constructor(M,W,U,x,B,O,H,j){super(M,W,U,x,B,O,H,j);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(M,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(W,M);if(U===void 0)throw new Error("Task is not valid");if(s.is(U.execution))await this.addCustomExecution(U,W,!1);else throw new r.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),W);return this._proxy.$executeTask(U).catch(B=>{throw new Error(B)}),x}provideTasksInternal(M,W,U,x){const B=[];if(x)for(let O of x){this.checkDeprecation(O,U),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const H=E.from(O,U.extension);H&&s.is(H.execution)?(B.push(H),W.push(this.addCustomExecution(H,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:U.extension}}async resolveTaskInternal(M){if(s.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,W,U){}};F=Ve([We(0,a.IExtHostRpcService),We(1,w.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,y.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,P.ILogService),We(7,p.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(me[266],ge([0,1,17,73,31,80,24,10,9,23,8,13,2,145,174,118,44,127,265,33]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(h,u,E,A){this.configurationService=h,this.workspaceContextService=u,this.editorGroupsService=E,this.pathService=A}text(h,u,E={}){h=this.getContentPattern(h,E);const A=this.configurationService.getValue(),R=u&&u.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(u?.map(_.toWorkspaceFolder),E),type:2,contentPattern:h,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:A.search.usePCRE2||R||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(h,u){const E=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const A={...h,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(h,u)&&(A.isCaseSensitive=!0),this.isMultiline(h)&&(A.isMultiline=!0),A}file(h,u={}){return{...this.commonQuery(h,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(h,u){return h?(h=Array.isArray(h)?h.map(t):t(h),u?this.parseSearchPaths(h):{pattern:o(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],u={}){const E=this.handleIncludeExclude(u.includePattern,u.expandPatterns),A=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),R=h.length>1,$=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,u,A)):h.map(z=>this.getFolderQueryForRoot(z,u,A,R))).filter(z=>!!z),N={_reason:u._reason,folderQueries:$,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:A.pattern,includePattern:E.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const M=m.coalesce(m.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,l.pathIncludedInQuery)(N,U.fsPath)),W=this.commonQueryFromFileList(M);return{...N,...W}}const F=u.extraFileResources&&u.extraFileResources.filter(z=>(0,l.pathIncludedInQuery)(N,z.fsPath));return N.extraFileResources=F&&F.length?F:void 0,N}commonQueryFromFileList(h){const u=[],E=new n.ResourceMap,A={};let R=!1;return h.forEach($=>{if($.scheme===k.Schemas.walkThrough)return;if((0,y.isAbsolutePath)($)){const F=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:S.dirname($.fsPath)});let z=E.get(F);z||(R=!0,z={folder:F,includePattern:{}},u.push(z),E.set(F,z));const M=S.relative(F.fsPath,$.fsPath);(0,I.assertIsDefined)(z.includePattern)[M.replace(/\\/g,"/")]=!0}else $.fsPath&&(R=!0,A[$.fsPath]=!0)}),{folderQueries:u,includePattern:A,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(h,u){if(u.isSmartCase){if(h.isRegExp){if(T.containsUppercaseCharacter(h.pattern,!0))return!0}else if(T.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,w.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const u=W=>S.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),A=(Array.isArray(h)?h:b(h)).map(W=>{const U=this.pathService.resolvedUserHome;return U?(0,C.untildify)(W,U.scheme===k.Schemas.file?U.fsPath:U.path):W}),R=L.groupBy(A,W=>u(W)?"searchPaths":"exprSegments"),$=(R.exprSegments||[]).map(W=>T.rtrim(W,"/")).map(W=>T.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),i(W))),N={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(N.searchPaths=F);const z=m.flatten($),M=o(...z);return M&&(N.pattern=M),N}getExcludesForFolder(h,u){return u.disregardExcludeSettings?void 0:(0,l.getExcludes)(h,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const u=m.flatten(h.map(A=>{let{pathPortion:R,globPortion:$}=g(A);$&&($=c($));const N=this.expandOneSearchPath(R);return m.flatten(N.map(F=>this.resolveOneSearchPathPattern(F,$)))})),E=new Map;return u.forEach(A=>{const R=A.searchPath.toString(),$=E.get(R);$?A.pattern&&($.pattern=$.pattern||{},$.pattern[A.pattern]=!0):E.set(R,{searchPath:A.searchPath,pattern:A.pattern?o(A.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:h})}]:[{searchPath:a.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=t(h),h.startsWith("../")||h===".."){const A=S.posix.resolve(u.path,h);return[{searchPath:u.with({path:A})}]}const E=c(h);return[{searchPath:u,pattern:E}]}else{if(h==="./"||h===".\\")return[];{const u=h.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(R=>{const $=u.match(new RegExp(`^${T.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return $?{match:$,folder:R}:null}).filter(I.isDefined);if(A.length)return A.map(R=>{const $=R.match[1];return{searchPath:R.folder.uri,pattern:$&&c($)}});{const R=h.match(/\.[\/\\](.+)[\/\\]?/),$=R?R[1]:h,N=f.localize(0,null,$);throw new Error(N)}}}}resolveOneSearchPathPattern(h,u){const E=h.pattern&&u?`${h.pattern}/${u}`:h.pattern||u,A=[{searchPath:h.searchPath,pattern:E}];return E&&!E.endsWith("**")&&A.push({searchPath:h.searchPath,pattern:E+"/**"}),A}getFolderQueryForSearchPath(h,u,E){const A=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(h.searchPath),u,E,!1);return A?{...A,includePattern:h.pattern}:null}getFolderQueryForRoot(h,u,E,A){let R;const $=a.URI.isUri(h)?h:h.uri;if(E.searchPaths){const W=E.searchPaths.filter(U=>(0,y.isEqual)(U.searchPath,$))[0];if(W&&!W.pattern)return null;W&&(R=W.pattern)}const N=this.configurationService.getValue({resource:$}),z={...this.getExcludesForFolder(N,u)||{},...R||{}},M=a.URI.isUri(h)?(0,y.basename)(h):h.name;return{folder:$,folderName:A?M:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!N.search.followSymlinks}}};r=Ve([We(0,v.IConfigurationService),We(1,_.IWorkspaceContextService),We(2,P.IEditorGroupsService),We(3,p.IPathService)],r),e.QueryBuilder=r;function g(s){const h=s.match(/[\*\{\}\(\)\[\]\?]/);if(h){const u=h.index,E=s.substr(0,u).match(/[/|\\][^/\\]*$/);if(E){let A=s.substr(0,E.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:s.substr((E.index||0)+1)}}}return{pathPortion:s}}function o(...s){return s.length?s.reduce((h,u)=>(h[u]=!0,h),Object.create(null)):void 0}function b(s){return D.splitGlobAware(s,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(s){return[`**/${s}/**`,`**/${s}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function t(s){return s.replace(/\\/g,"/")}function c(s){return t(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(s,h){s=m.distinct(s,A=>A.toString());const u=[],E=h.getWorkspace();return s&&s.forEach(A=>{let R;if(h.getWorkbenchState()===2)R=(0,y.relativePath)(E.folders[0].uri,A),R&&R!=="."&&(R="./"+R);else{const $=h.getWorkspaceFolder(A);if($){const N=$.name;if(E.folders.filter(z=>z.name===N).length===1){const z=(0,y.relativePath)($.uri,A);z===""?R=`./${$.name}`:R=`./${$.name}/${z}`}else R=A.fsPath}}R&&u.push(R)}),u}e.resolveResourcesForSearchIncludes=d}),define(me[267],ge([0,1,23,2,21,15,4,266,33,44]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function I(v,_){const P=_.activationEvents;if(!P)return Promise.resolve(void 0);const p=[],l=[];for(const t of P)if(/^workspaceContains:/.test(t)){const c=t.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||v.forceUsingSearch?l.push(c):p.push(c)}if(p.length===0&&l.length===0)return Promise.resolve(void 0);let r;const g=new Promise((t,c)=>{r=t}),o=t=>r({activationEvent:t}),b=Promise.all(p.map(t=>a(v,t,o))).then(()=>{}),i=w(v,_.identifier,l,o);return Promise.all([b,i]).then(()=>{r(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function a(v,_,P){for(const p of v.folders)if(await v.exists(m.joinPath(L.URI.revive(p),_))){P(`workspaceContains:${_}`);return}}async function w(v,_,P,p){if(P.length===0)return Promise.resolve(void 0);const l=new D.CancellationTokenSource,r=v.checkExists(v.folders,P,l.token),g=setTimeout(async()=>{l.cancel(),v.logService.info(`Not activating extension '${_.value}': Timed out while searching for 'workspaceContains' pattern ${P.join(",")}`)},T);let o=!1;try{o=await r}catch(b){C.isPromiseCanceledError(b)||C.onUnexpectedError(b)}l.dispose(),clearTimeout(g),o&&p(`workspaceContains:${P.join(",")}`)}function f(v,_,P,p){const l=v.get(n.IInstantiationService),r=v.get(S.ISearchService),o=l.createInstance(k.QueryBuilder).file(_.map(b=>(0,y.toWorkspaceFolder)(L.URI.revive(b))),{_reason:"checkExists",includePattern:P,exists:!0});return r.fileSearch(o,p).then(b=>!!b.limitHit,b=>C.isPromiseCanceledError(b)?!1:Promise.reject(b))}e.checkGlobFileExists=f});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[39],ge([0,1,163,9,71,23,18,6,24,2,12,5,36,225,92,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,91,200,10]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l,r,g,o,b,i,t,c,d,s,h,u,E,A,R,$,N){"use strict";var F,z,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let W=class ji extends k.Disposable{constructor(O,H,j,X,K,he,Ee,De,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=H,this._extHostContext=j,this._initData=Ee,this._extHostWorkspace=X,this._extHostConfiguration=K,this._logService=he,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new n.Barrier,this._readyToStartExtensionHost=new n.Barrier,this._readyToRunExtensions=new n.Barrier,this._eagerExtensionsActivated=new n.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=De,this._instaService=O.createChild(new s.ServiceCollection([f.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const He=new Set;this._initData.hostExtensions.forEach(ze=>He.add(l.ExtensionIdentifier.toKey(ze))),this._activator=this._register(new w.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,G,Z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,p.transformErrorForSerialization(G),Z)},actualActivateExtension:async(ze,G)=>{if(He.has(l.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,G),new w.HostExtension;const Z=this._registry.getExtensionDescription(ze);return this._activateExtension(Z,G)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){p.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(H){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,H){return this._activator.activateByEvent(O,H)}_activateById(O,H){return this._activator.activateById(O,H)}activateByIdWithErrors(O,H){return this._activateById(O,H).then(()=>{const j=this._activator.getActivatedExtension(O);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==N.Schemas.file)return O;const H=await this._hostUtils.realpath(O.fsPath);return y.URI.file(H)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=S.TernarySearchTree.forUris(H=>C.extUriBiasedIgnorePathCase.ignorePathCasing(H));for(const H of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(H)){const j=await this._realPathExtensionUri(H.extensionLocation);O.set(j,H)}return O})()),this._extensionPathIndex}_deactivate(O){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return H;const j=this._activator.getActivatedExtension(O);if(!j)return H;try{typeof j.module.deactivate=="function"&&(H=Promise.resolve(j.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,k.dispose)(j.subscriptions)}catch(X){this._logService.error(X)}return H}async _activateExtension(O,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,H).then(j=>{const X=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,H),this._logExtensionActivationTimes(O,H,"success",X),j},j=>{throw this._logExtensionActivationTimes(O,H,"failure"),j})}_logExtensionActivationTimes(O,H,j,X){const K=U(O,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...X||{},outcome:j})}_doActivateExtension(O,H){const j=U(O,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${O.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const K=new w.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,C.joinPath)(O.extensionLocation,X),K),this._loadExtensionContext(O)]).then(he=>(D.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),ji._callActivate(this._logService,O.identifier,he[0],he[1],K))).then(he=>(D.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),he))}_loadExtensionContext(O){const H=new g.ExtensionGlobalMemento(O,this._storage),j=new g.ExtensionMemento(O.identifier.value,!1,this._storage),X=new $.ExtensionSecrets(O,this._secretState),K=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,he=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([H.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Ee=this;let De;return Object.freeze({globalState:H,workspaceState:j,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return Ee._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return Ee._storagePath.globalValue(O).fsPath},get logPath(){return L.join(Ee._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return y.URI.joinPath(Ee._initData.logsLocation,O.identifier.value)},get storageUri(){return Ee._storagePath.workspaceValue(O)},get globalStorageUri(){return Ee._storagePath.globalValue(O)},get extensionMode(){return K},get extension(){return De===void 0&&(De=new x(Ee,O.identifier,O,he)),De},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(O,"extensionRuntime"),Ee.extensionRuntime},get environmentVariableCollection(){return Ee._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,H,j,X,K){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,H,j,X,K).then(he=>new w.ActivatedExtension(!1,null,K.build(),j,he,X.subscriptions))}static _callActivateOptional(O,H,j,X,K){if(typeof j.activate=="function")try{K.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${H.value}`);const he=typeof global=="object"?global:self,Ee=j.activate.apply(he,[X]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(Ee).then(De=>(K.activateResolveStop(),De))}catch(he){return Promise.reject(he)}else return Promise.resolve(j)}_activateOneStartupFinished(O,H){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:H}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const H of O.activationEvents)H==="onStartupFinished"&&this._activateOneStartupFinished(O,H)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(H),X=Promise.all([O,j]).then(()=>{});return Promise.race([X,(0,n.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(O,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,H){if(this.isActivated(H.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={logService:this._logService,folders:O.map(he=>he.uri),forceUsingSearch:j,exists:he=>this._hostUtils.exists(he.fsPath),checkExists:(he,Ee,De)=>this._mainThreadWorkspaceProxy.$checkExists(he,Ee,De)},K=await(0,A.checkActivateWorkspaceContainsExtension)(X,H);if(!!K)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:K.activationEvent}).then(void 0,he=>this._logService.error(he))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:H}=this._initData.environment;if(!O||!H)throw new Error(m.localize(0,null));const j=await this._loadCommonJSModule(null,H,new w.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(m.localize(1,null,H.toString()));return new Promise((X,K)=>{const he=(Pe,Be)=>{Pe?K(Pe):X(typeof Be=="number"&&Be>0?1:0)},Ee=(0,C.originalFSPath)(H),De=j.run(Ee,he);De&&De.then&&De.then(()=>{X(0)}).catch(Pe=>{K(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,H){return this._resolvers[O]=H,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const H=O.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const j=O.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(O,H){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:b.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),D.mark(`code/extHost/willResolveAuthority/${j}`);const K=await X.resolve(O,{resolveAttempt:H});D.mark(`code/extHost/didResolveAuthorityOK/${j}`);const he={authority:O,host:K.host,port:K.port,connectionToken:K.connectionToken},Ee={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:he,options:Ee,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(D.mark(`code/extHost/didResolveAuthorityError/${j}`),K instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(O,H){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const K=y.URI.revive(H);if(typeof X.getCanonicalURI=="undefined")return K;const he=await(0,n.asPromise)(()=>X.getCanonicalURI(K));return he||K}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,H){return H===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(O,!1))}async $activate(O,H){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,H),!0):!1}async $deltaExtensions(O,H){O.forEach(X=>X.extensionLocation=y.URI.revive(X.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(H.map(async X=>{const K=this._registry.getExtensionDescription(X);K&&j.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(O.map(async X=>{const K=await this._realPathExtensionUri(X.extensionLocation);j.set(K,X)})),this._registry.deltaExtensions(O,H),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let H=r.VSBuffer.alloc(O),j=Math.random()%256;for(let X=0;X<O;X++)H.writeUInt8(j,X);return H}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};W=Ve([We(0,i.IInstantiationService),We(1,e.IHostUtils),We(2,d.IExtHostRpcService),We(3,v.IExtHostWorkspace),We(4,a.IExtHostConfiguration),We(5,T.ILogService),We(6,t.IExtHostInitDataService),We(7,c.IExtensionStoragePaths),We(8,h.IExtHostTunnelService),We(9,u.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function U(B,O){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class x{constructor(O,H,j,X){F.set(this,void 0),z.set(this,void 0),M.set(this,void 0),ot(this,F,O,"f"),ot(this,z,H,"f"),ot(this,M,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=X}get isActive(){return Oe(this,F,"f").isActivated(Oe(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,F,"f").getExtensionExports(Oe(this,M,"f"))}activate(){return Oe(this,F,"f").activateByIdWithErrors(Oe(this,M,"f"),{startup:!1,extensionId:Oe(this,z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,F=new WeakMap,z=new WeakMap,M=new WeakMap}),define(me[55],ge([0,1,9,2,3,18,5,7,123,35,39,46,214,36,207,14,4,13,40,54]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let r=class{constructor(s,h,u,E,A,R){this._workspaceService=h,this._extensionService=u,this._editorsService=E,this._configurationService=A,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=s.getProxy(n.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(N=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,h){const u=s;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let E=`debug:${encodeURIComponent(u.path||"")}`,A="?";return h&&(E+=`${A}session=${encodeURIComponent(h.id)}`,A="&"),E+=`${A}ref=${u.sourceReference}`,L.URI.parse(E)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const h=[];for(const u of s.getAllExtensionDescriptions())if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0)for(const A of E)(0,f.isDebuggerMainContribution)(A)&&h.push(A.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(h=>s.push(h)),s}addBreakpoints(s){this.startBreakpoints();const h=s.filter(A=>{const R=A.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,A),!0)});this.fireBreakpointChanges(h,[],[]);const u=[],E=new Map;for(const A of h)if(A instanceof k.SourceBreakpoint){let R=E.get(A.location.uri.toString());R||(R={type:"sourceMulti",uri:A.location.uri,lines:[]},E.set(A.location.uri.toString(),R),u.push(R)),R.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof k.FunctionBreakpoint&&u.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(s){this.startBreakpoints();const h=s.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],h,[]);const u=h.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),E=h.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),A=h.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(u,E,A)}startDebugging(s,h,u){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,h,u){if(!h)return new k.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:E,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,E),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,h,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(s,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:E,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,E),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,h){if(!h)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:u,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==h)})}async $runInTerminal(s,h){return Promise.resolve(void 0)}async $substituteVariables(s,h){if(!this._variableResolver){const[A,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,R)}let u;const E=await this.getFolder(s);return E&&(u={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,h)}createDebugAdapter(s,h){if(s.type==="implementation")return new t(s.implementation)}createSignService(){}async $startDASession(s,h){const u=this,E=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const R=this.convertToDto(A),$=this.createDebugAdapter(R,E);if(!$)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const N=$;return this._debugAdapters.set(s,N),this.getDebugAdapterTrackers(E).then(F=>(F&&this._debugAdaptersTrackers.set(s,F),N.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const M=z,W={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(M.arguments.value);W.body={signature:U},N.sendResponse(W)}else throw new Error("no signer")}catch(U){W.success=!1,W.message=U.message,N.sendResponse(W)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(z),z=(0,f.convertToVSCPaths)(z,!0),u._debugServiceProxy.$acceptDAMessage(s,z)}),N.onError(z=>{F&&F.onError&&F.onError(z),this._debugServiceProxy.$acceptDAError(s,z.name,z.message,z.stack)}),N.onExit(z=>{F&&F.onExit&&F.onExit((0,P.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,P.withNullAsUndefined)(z),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),N.startSession()))})}$sendDAMessage(s,h){h=(0,f.convertToDAPaths)(h,!1);const u=this._debugAdaptersTrackers.get(s);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h);const E=this._debugAdapters.get(s);E&&E.sendMessage(h)}$stopDASession(s){const h=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),h&&h.onWillStopSession&&h.onWillStopSession();const u=this._debugAdapters.get(s);return this._debugAdapters.delete(s),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const h=[],u=[],E=[];if(s.added)for(const A of s.added){const R=A.id;if(R&&!this._breakpoints.has(R)){let $;if(A.type==="function")$=new k.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")$=new k.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const N=L.URI.revive(A.uri);$=new k.SourceBreakpoint(new k.Location(N,new k.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}$._id=R,this._breakpoints.set(R,$),h.push($)}}if(s.removed)for(const A of s.removed){const R=this._breakpoints.get(A);R&&(this._breakpoints.delete(A),u.push(R))}if(s.changed){for(const A of s.changed)if(A.id){const R=this._breakpoints.get(A.id);if(R){if(R instanceof k.FunctionBreakpoint&&A.type==="function"){const $=R;$.enabled=A.enabled,$.condition=A.condition,$.hitCondition=A.hitCondition,$.logMessage=A.logMessage,$.functionName=A.functionName}else if(R instanceof k.SourceBreakpoint&&A.type==="source"){const $=R;$.enabled=A.enabled,$.condition=A.condition,$.hitCondition=A.hitCondition,$.logMessage=A.logMessage,$.location=new k.Location(L.URI.revive(A.uri),new k.Position(A.line,A.character))}E.push(R)}}}this.fireBreakpointChanges(h,u,E)}$provideDebugConfigurations(s,h,u){return(0,C.asPromise)(async()=>{const E=this.getConfigProviderByHandle(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(h);return E.provideDebugConfigurations(A,u)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,h,u,E){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(s);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(h);return A.resolveDebugConfiguration(R,u,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,h,u,E){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(s);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(h);return A.resolveDebugConfigurationWithSubstitutedVariables(R,u,E)})}async $provideDebugAdapter(s,h){const u=this.getAdapterDescriptorFactoryByHandle(s);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(h);return this.getAdapterDescriptor(u,E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(s){const h=await this.getSession(s);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(s){const h=await this.getSession(s);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,h){const u=await this.getSession(s);u&&u._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(s,h){const E={session:await this.getSession(s),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const h=this._adapterFactories.filter(u=>u.type===s);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(s){const h=this._adapterFactories.filter(u=>u.handle===s);if(h.length>0)return h[0].factory}getConfigProviderByHandle(s){const h=this._configProviders.filter(u=>u.handle===s);if(h.length>0)return h[0].provider}definesDebugType(s,h){if(s.contributes){const u=s.contributes.debuggers;if(u&&u.length>0){for(const E of u)if(E.label&&E.type&&E.type===h)return!0}}return!1}getDebugAdapterTrackers(s){const u=s.configuration.type,E=this._trackerFactories.filter(A=>A.type===u||A.type==="*").map(A=>(0,C.asPromise)(()=>A.factory.createDebugAdapterTracker(s)).then(R=>R,R=>null));return Promise.race([Promise.all(E).then(A=>{const R=A.filter($=>!!$);if(R.length>0)return new i(R)}),new Promise((A,R)=>{const $=setTimeout(()=>{clearTimeout($),R(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(s,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(s){const A=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>s.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,A))).then(R=>{if(R)return R})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,E))}daExecutableFromPackage(s,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,h,u){(s.length>0||h.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:h,changed:u}))}async getSession(s){if(s)if(typeof s=="string"){const h=this._debugSessions.get(s);if(h)return h}else{let h=this._debugSessions.get(s.id);if(!h){const u=await this.getFolder(s.folderUri),E=s.parent?this._debugSessions.get(s.parent):void 0;h=new g(this._debugServiceProxy,s.id,s.type,s.name,u,s.configuration,E),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(s){if(s){const h=L.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};r=Ve([We(0,v.IExtHostRpcService),We(1,y.IExtHostWorkspace),We(2,T.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,w.IExtHostConfiguration),We(5,l.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class g{constructor(s,h,u,E,A,R,$){this._debugServiceProxy=s,this._id=h,this._type=u,this._name=E,this._workspaceFolder=A,this._configuration=R,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,h)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=g;class o{constructor(s){this.value=Object.freeze({append(h){s.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=o;class b extends a.AbstractVariableResolverService{constructor(s,h,u,E,A){function R(){if(h){const $=h.activeEditor();if($)return $.document.uri;const N=E.tabs.filter(F=>F.isActive);if(N.length>0){const F=N[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:N[0].resource}}}super({getFolderUri:$=>{const N=s.filter(F=>F.name===$);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:($,N)=>u.getConfiguration(void 0,$).get(N),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=R();if($)return m.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const $=R();if($){const N=A.getWorkspaceFolder($);if(N)return m.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(h){const $=h.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(h){const $=h.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=b;class i{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(h=>h.onError?h.onError(s):void 0)}onExit(s,h){this.trackers.forEach(u=>u.onExit?u.onExit(s,h):void 0)}}class t extends S.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends r{constructor(s,h,u,E,A,R){super(s,h,u,E,A,R)}createVariableResolver(s,h,u){return new b(s,h,u,this._editorTabs)}};c=Ve([We(0,v.IExtHostRpcService),We(1,y.IExtHostWorkspace),We(2,T.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,w.IExtHostConfiguration),We(5,l.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(me[268],ge([0,1,71,2,5,36,29,27,14,26,4,39,40,12]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(l,r,g,o,b,i,t){this._apiFactory=l,this._extensionRegistry=r,this._instaService=g,this._extHostConfiguration=o,this._extHostExtensionService=b,this._initData=i,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,r,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(_,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,r,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let r of l.nodeModuleName)this._factories.set(r,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(r=>l.alternativeModuleName(r))}};f=Ve([We(2,T.IInstantiationService),We(3,C.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,y.IExtHostInitDataService),We(6,w.ILogService)],f),e.RequireInterceptor=f;class v{constructor(l,r,g,o,b){this._apiFactory=l,this._extensionPaths=r,this._extensionRegistry=g,this._configProvider=o,this._logService=b,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,r){const g=this._extensionPaths.findSubstr(r);if(g){let o=this._extApiImpl.get(k.ExtensionIdentifier.toKey(g.identifier));return o||(o=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(g.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((b,i)=>o+=`	${i} -> ${b.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(n.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(l,r,g){this._extensionPaths=l,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(D.MainContext.MainThreadTelemetry);const{environment:o}=g,b=r.getProxy(D.MainContext.MainThreadKeytar);if(o.appRoot){let i=o.appRoot.fsPath;a.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,t)=>b.$getPassword(i,t),setPassword:(i,t,c)=>b.$setPassword(i,t,c),deletePassword:(i,t)=>b.$deletePassword(i,t),findPassword:i=>b.$findPassword(i),findCredentials(i){return b.$findCredentials(i)}}}load(l,r){const g=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(l){const r=l.length;if(r<=7||!this.alternativeNames)return;const g=r-7;if((l.charAt(g)==="/"||l.charAt(g)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};_=Ve([We(1,S.IExtHostRpcService),We(2,y.IExtHostInitDataService)],_);let P=class{constructor(l,r,g){this._extensionPaths=l,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(D.MainContext.MainThreadTelemetry);const o=g.getProxy(D.MainContext.MainThreadWindow);this._impl=(b,i)=>{const t=L.URI.parse(b);return i?this.callOriginal(b,i):t.scheme==="http"||t.scheme==="https"?o.$openUri(t,b,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?o.$openUri(t,b,{}):this.callOriginal(b,i)}}load(l,r,g){const o=this._extensionPaths.findSubstr(r);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=g(l),this._impl}callOriginal(l,r){return this.sendNoForwardTelemetry(),this._original(l,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([We(2,S.IExtHostRpcService)],P)}),define(me[269],ge([0,1,169,11,7,208,35,39,46,36,34,14,55,194,18,209,54]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends a.ExtHostDebugServiceBase{constructor(r,g,o,b,i,t,c){super(r,g,o,b,i,c);this._terminalService=t,this._integratedTerminalInstances=new p}createDebugAdapter(r,g){switch(r.type){case"server":return new C.SocketDebugAdapter(r);case"pipeServer":return new C.NamedPipeDebugAdapter(r);case"executable":return new C.ExecutableDebugAdapter(r,g.type)}return super.createDebugAdapter(r,g)}daExecutableFromPackage(r,g){const o=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),r.type);if(o)return new D.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new w.SignService}async $runInTerminal(r,g){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const o=await this._configurationService.getConfigProvider(),b=this._terminalService.getDefaultShell(!0),i=this._terminalService.getDefaultShellArgs(!0),t=r.title||m.localize(0,null),c=JSON.stringify({shell:b,shellArgs:i});let d=await this._integratedTerminalInstances.checkout(c,t),s,h=!1;if(d)s=r.cwd;else{const R={shellPath:b,shellArgs:i,cwd:r.cwd,name:t,iconPath:new D.ThemeIcon("debug")};h=!0,d=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,c)}d.show(!0);const u=await d.processId;h?await new Promise(R=>setTimeout(R,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0||b.indexOf("cmd.exe")>=0?d.sendText("cls"):b.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const E=(0,v.prepareCommand)(b,r.args,s,r.env);d.sendText(E);const A=this.onDidTerminateDebugSession(R=>{R.id===g&&(this._integratedTerminalInstances.free(d),A.dispose())});return u}else if(r.kind==="external")return(0,v.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,g)}createVariableResolver(r,g,o){return new a.ExtHostVariableResolverService(r,g,o,this._editorTabs,this._workspaceService)}};P=Ve([We(0,I.IExtHostRpcService),We(1,n.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,S.IExtHostDocumentsAndEditors),We(4,y.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,_.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class p{constructor(){this._terminalInstances=new Map}async checkout(r,g){const b=[...this._terminalInstances.entries()].map(([i,t])=>(0,f.createCancelablePromise)(async c=>{if(i.name!==g||t.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await i.processId))return null;const d=Date.now();return t.lastUsedAt+p.minUseDelay>d||c.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=d,i)}));return await(0,f.firstParallel)(b,i=>!!i)}insert(r,g){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:g})}free(r){const g=this._terminalInstances.get(r);g&&(g.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}p.minUseDelay=1e3}),define(me[270],ge([0,1,9,2,113,35,55,46,36,44,34,14,26,70,10,12,65,54,23,81]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends w.ExtHostTaskBase{constructor(o,b,i,t,c,d,s,h,u){super(o,b,i,t,c,d,s,h);this.workspaceService=i,this.editorTabs=u,b.remote.isRemote&&b.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:b.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,b){const i=b;if(!b.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const t=w.TaskHandleDTO.from(i,this.workspaceService),c=await this._proxy.$getTaskExecution(t);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(c,b);return this._proxy.$executeTask(t).catch(()=>{}),d}else{const t=w.TaskDTO.from(b,o);if(t===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,b,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),b);return this._proxy.$executeTask(t).catch(()=>{}),c}}provideTasksInternal(o,b,i,t){const c=[];if(t)for(let d of t){this.checkDeprecation(d,i),(!d.definition||!o[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const s=w.TaskDTO.from(d,i.extension);s&&(c.push(s),w.CustomExecutionDTO.is(s.execution)&&b.push(this.addCustomExecution(s,d,!0)))}return{tasks:c,extension:i.extension}}async resolveTaskInternal(o){return o}async getVariableResolver(o){if(this._variableResolver===void 0){const b=await this._configurationService.getConfigProvider();this._variableResolver=new n.ExtHostVariableResolverService(o,this._editorService,b,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(o){let b=o&&o.length>0?o[0]:void 0;if(!b){const i=L.URI.file((0,l.homedir)());b=new y.WorkspaceFolder({uri:i,name:p.basename(i),index:0})}return{uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,b){const i=L.URI.revive(o),t={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(i),d=await this._workspaceProvider.getWorkspaceFolders2()??[],s=await this.getVariableResolver(d),h=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let u of b.variables)t.variables[u]=await s.resolveAsync(h,u);if(b.process!==void 0){let u;if(b.process.path!==void 0){u=b.process.path.split(m.delimiter);for(let E=0;E<u.length;E++)u[E]=await s.resolveAsync(h,u[E])}t.process=await D.win32.findExecutable(await s.resolveAsync(h,b.process.name),b.process.cwd!==void 0?await s.resolveAsync(h,b.process.cwd):void 0,u)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(o,b,i){return D.win32.findExecutable(o,b,i)}};r=Ve([We(0,I.IExtHostRpcService),We(1,a.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,k.IExtHostDocumentsAndEditors),We(4,S.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,v.ILogService),We(7,_.IExtHostApiDeprecationService),We(8,P.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(me[271],ge([0,1,18,15,71,6,2,5,263,12,83,85,26,186,14,64,39,34]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(r,g,o,b){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=o,this._rpcProtocol=new S.RPCProtocol(r,null,b),g=p._transform(g,this._rpcProtocol);const i=new I.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());i.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...g}),i.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),i.set(v.IURITransformerService,new v.URITransformerService(b)),i.set(_.IHostUtils,o);const t=new w.InstantiationService(i,!0);this._disposables.add(t.invokeFunction(h=>h.get(P.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(h=>h.get(_.IExtHostExtensionService))),this._logService=t.invokeFunction(h=>h.get(y.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(h=>h.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(u,E)=>{let A="",R,$;for(const N of E)A+=`
	at ${N.toString()}`,$=N.getFileName(),!R&&$&&(R=h.findSubstr(n.URI.file($)));return c.set(u,R),`${u.name||"Error"}: ${u.message||""}${A}`}});const d=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(h=>{const u=L.transformErrorForSerialization(h),E=c.get(h);E?d.$onExtensionRuntimeError(E.identifier,u):s.$onUnexpectedError(u)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(o=>{this._logService.error(o)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,g){r.extensions.forEach(b=>b.extensionLocation=n.URI.revive(g.transformIncomingURIs(b.extensionLocation))),r.environment.appRoot=n.URI.revive(g.transformIncomingURIs(r.environment.appRoot));const o=r.environment.extensionDevelopmentLocationURI;return o&&(r.environment.extensionDevelopmentLocationURI=o.map(b=>n.URI.revive(g.transformIncomingURIs(b)))),r.environment.extensionTestsLocationURI=n.URI.revive(g.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=n.URI.revive(g.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=n.URI.revive(g.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=n.URI.revive(g.transformIncomingURIs(r.logsLocation)),r.logFile=n.URI.revive(g.transformIncomingURIs(r.logFile)),r.workspace=g.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=p}),define(me[272],ge([0,1,9,21,51,31,23,47,33]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(a,w,f){this.config=a,this.provider=w,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&C.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&C.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const w=this.config.folderQueries||[];return new Promise((f,v)=>{const _=P=>{this.resultCount++,a(P)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const p=P.toString(),l=m.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,l)||this.matchFile(_,{base:P,basename:l})}),Promise.all(w.map(P=>this.searchInFolder(P,_))).then(P=>{f({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{v(new Error((0,D.toErrorMessage)(P)))})})}async searchInFolder(a,w){const f=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(a),_=this.initDirectoryTree(),P=new S.QueryGlobTester(this.config,a),p=!P.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(f),l=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,f.token),g=l.elapsed(),o=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(b=>{const i=m.posix.relative(a.folder.path,b.path);if(p){const t=m.basename(b.path);this.matchFile(w,{base:a.folder,relativePath:i,basename:t});return}this.addDirectoryEntries(_,a.folder,i,w)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,P,w),{providerTime:g,postProcessTime:o.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(a){const w=(0,S.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),f=(0,S.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:f,includes:w,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},w,f,v){if(f===this.filePattern){const P=m.basename(this.filePattern);this.matchFile(v,{base:w,relativePath:this.filePattern,basename:P})}function _(P){const p=m.basename(P),l=m.dirname(P);let r=a[l];r||(r=a[l]=[],_(l)),r.push({base:w,relativePath:P,basename:p})}_(f)}matchDirectoryTree({rootEntries:a,pathToEntries:w},f,v){const _=this,P=this.filePattern;function p(l){const r=C.hasSiblingFn(()=>l.map(g=>g.basename));for(let g=0,o=l.length;g<o;g++){const b=l[g],{relativePath:i,basename:t}=b;if(f.matchesExcludesSync(i,t,P!==t?r:void 0))continue;const c=w[i];if(c)p(c);else{if(i===P)continue;_.matchFile(v,b)}if(_.isLimitHit)break}}p(a)}matchFile(a,w){(!this.includePattern||w.relativePath&&this.includePattern(w.relativePath,w.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(w))}}class T{constructor(){this.sessions=new Map}fileSearch(a,w,f,v){const _=this.getSessionTokenSource(a.cacheKey),P=new y(a,w,_&&_.token);let p=0;const l=r=>{p+=r.length,f(r.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(P,T.BATCH_SIZE,l,v).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:r.stats}}))}clearCache(a){const w=this.getSessionTokenSource(a);w&&w.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new L.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:n.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,w,f,v){v.onCancellationRequested(()=>{a.cancel()});const _=p=>{p&&(P.push(p),w>0&&P.length>=w&&(f(P),P=[]))};let P=[];return a.search(_).then(p=>(P.length&&f(P),p),p=>(P.length&&f(P),Promise.reject(p)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(me[134],ge([0,1,17,21,51,31,10,9,23,13,2,33]),function(Y,e,m,L,D,C,n,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(l,r,g,o){this.query=l,this.provider=r,this.fileUtils=g,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,r){const g=this.query.folderQueries||[],o=new L.CancellationTokenSource;return r.onCancellationRequested(()=>o.cancel()),new Promise((b,i)=>{this.collector=new f(l);let t=!1;const c=(d,s)=>{if(!t&&!this.isLimitHit){const h=this.resultSize(d);_(d)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,t=!0,o.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const u=this.resultSize(d);this.resultCount+=u,(u>0||!_(d))&&this.collector.add(d,s)}};Promise.all(g.map((d,s)=>this.searchInFolder(d,h=>c(h,s),o.token))).then(d=>{o.dispose(),this.collector.flush();const s=d.some(h=>!!h&&!!h.limitHit);b({limitHit:this.isLimitHit||s,messages:(0,m.flatten)(d.map(h=>h?.message?(0,y.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},d=>{o.dispose();const s=(0,D.toErrorMessage)(d);i(new Error(s))})})}resultSize(l){return _(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,r){const g=Array.isArray(l.ranges)?l.ranges:[l.ranges],o=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:g.slice(0,r),preview:{matches:o.slice(0,r),text:l.preview.text},uri:l.uri}}async searchInFolder(l,r,g){const o=new I.QueryGlobTester(this.query,l),b=[],i={report:d=>{if(!this.validateProviderResult(d))return;const s=l.folder.scheme===n.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(d.uri))):void 0,h=S.relativePath(l.folder,d.uri);if(h){const u=o.includedInQuery(h,k.basename(h),s);(0,y.isPromise)(u)?b.push(u.then(E=>{E&&r(d)})):u&&r(d)}}},t=this.getSearchOptionsForFolder(l),c=await this.provider.provideTextSearchResults(w(this.query.contentPattern),t,i,g);return b.length&&await Promise.all(b),c}validateProviderResult(l){if(_(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const r=(0,I.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),g=(0,I.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),o={folder:T.URI.from(l.folder),excludes:g,includes:r,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=a;function w(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class f{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,r=>this.sendItems(r))}add(l,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!S.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(v(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=f;function v(p){return _(p)?{preview:{matches:(0,m.mapArrayOrNot)(p.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:p.preview.text},ranges:(0,m.mapArrayOrNot)(p.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function _(p){return!!p.preview}e.extensionResultIsMatch=_;class P{constructor(l,r){this.maxBatchSize=l,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,r){!l||this.addItemToBatch(l,r)}addItems(l,r){!l||this.addItemsToBatch(l,r)}addItemToBatch(l,r){this.batch.push(l),this.batchSize+=r,this.onUpdate()}addItemsToBatch(l,r){this.batch=this.batch.concat(l),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(me[72],ge([0,1,6,5,4,272,14,64,12,2,134]),function(Y,e,m,L,D,C,n,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(v,_,P){this.extHostRpc=v,this._uriTransformer=_,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const P=this._handlePool++;return this._textSearchProvider.set(P,_),this._proxy.$registerTextSearchProvider(P,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const P=this._handlePool++;return this._fileSearchProvider.set(P,_),this._proxy.$registerFileSearchProvider(P,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(v,_,P,p){const l=a(P),r=this._fileSearchProvider.get(v);if(r)return this._fileSearchManager.fileSearch(l,r,g=>{this._proxy.$handleFileMatch(v,_,g.map(o=>o.resource))},p);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,P,p){const l=this._textSearchProvider.get(v);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const r=a(P);return this.createTextSearchManager(r,l).search(o=>this._proxy.$handleTextMatch(v,_,o),p)}$enableExtensionHostSearch(){}createTextSearchManager(v,_){return new T.TextSearchManager(v,_,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};I=Ve([We(0,n.IExtHostRpcService),We(1,k.IURITransformerService),We(2,S.ILogService)],I),e.ExtHostSearch=I;function a(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(v=>y.URI.revive(v))}}e.reviveQuery=a;function w(f){return{...f,folder:y.URI.revive(f.folder)}}}),define(me[273],ge([0,1,21,15,3,49,2,114,109,146,82,42,5,231,230,38,232,36,233,234,235,216,236,46,39,237,217,240,241,242,132,219,247,248,249,92,34,251,220,16,7,254,68,133,35,73,205,239,62,130,70,55,72,12,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,45,250,253,91,54,121,245,69,246,10,189,244,199,238,6,29]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l,r,g,o,b,i,t,c,d,s,h,u,E,A,R,$,N,F,z,M,W,U,x,B,O,H,j,X,K,he,Ee,De,Pe,Be,He,ze,G,Z,ne,ce,J,te,ve,Me,je,Ke,Ze,rt,ut,it,st,Ae,wt,ee,re,Se,Ge,Ye,nt,de,ke,Ue,$e,tt,Te,Ce,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function oe(ue){const pe=ue.get(Z.IExtHostInitDataService),be=ue.get(Ae.IExtHostFileSystemInfo),Fe=ue.get(Ze.IExtHostConsumerFileSystem),Qe=ue.get(i.IExtHostExtensionService),xe=ue.get(H.IExtHostWorkspace),Xe=ue.get(Ge.IExtHostTelemetry),at=ue.get(P.IExtHostConfiguration),ct=ue.get(ze.IURITransformerService),le=ue.get(G.IExtHostRpcService),_e=ue.get(N.IExtHostStorage),ae=ue.get(Ke.IExtensionStoragePaths),Q=ue.get(He.ILoggerService),ye=ue.get(He.ILogService),Le=ue.get(J.IExtHostTunnelService),et=ue.get(te.IExtHostApiDeprecationService),qe=ue.get(O.IExtHostWindow),mt=ue.get(re.IExtHostSecretState),_t=ue.get(Se.IExtHostEditorTabs);le.set(a.ExtHostContext.ExtHostFileSystemInfo,be),le.set(a.ExtHostContext.ExtHostLogLevelServiceShape,Q),le.set(a.ExtHostContext.ExtHostWorkspace,xe),le.set(a.ExtHostContext.ExtHostConfiguration,at),le.set(a.ExtHostContext.ExtHostExtensionService,Qe),le.set(a.ExtHostContext.ExtHostStorage,_e),le.set(a.ExtHostContext.ExtHostTunnelService,Le),le.set(a.ExtHostContext.ExtHostWindow,qe),le.set(a.ExtHostContext.ExtHostSecretState,mt),le.set(a.ExtHostContext.ExtHostTelemetry,Xe),le.set(a.ExtHostContext.ExtHostEditorTabs,_t);const kt=le.set(a.ExtHostContext.ExtHostDecorations,ue.get(Ee.IExtHostDecorations)),bt=le.set(a.ExtHostContext.ExtHostDocumentsAndEditors,ue.get(b.IExtHostDocumentsAndEditors)),gt=le.set(a.ExtHostContext.ExtHostCommands,ue.get(v.IExtHostCommands)),Et=le.set(a.ExtHostContext.ExtHostTerminalService,ue.get(F.IExtHostTerminalService)),Ct=le.set(a.ExtHostContext.ExtHostDebugService,ue.get(Pe.IExtHostDebugService)),Lt=le.set(a.ExtHostContext.ExtHostSearch,ue.get(Be.IExtHostSearch)),yt=le.set(a.ExtHostContext.ExtHostTask,ue.get(De.IExtHostTask)),At=le.set(a.ExtHostContext.ExtHostOutputService,ue.get(u.IExtHostOutputService)),xt=le.set(a.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(le)),Tt=le.set(a.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(le,bt)),Bt=le.set(a.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(le,bt,ye)),Ht=le.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(ye,Tt,le.getProxy(a.MainContext.MainThreadBulkEdits))),St=le.set(a.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(le,gt,bt,Tt,ae)),Qt=le.set(a.ExtHostContext.ExtHostNotebookDocuments,new tt.ExtHostNotebookDocuments(ye,St)),Vt=le.set(a.ExtHostContext.ExtHostNotebookEditors,new $e.ExtHostNotebookEditors(ye,le,St)),si=le.set(a.ExtHostContext.ExtHostNotebookKernels,new Ye.ExtHostNotebookKernels(le,pe,St,gt,ye)),oi=le.set(a.ExtHostContext.ExtHostNotebookRenderers,new de.ExtHostNotebookRenderers(le,St)),Rt=le.set(a.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(le,bt)),Xt=le.set(a.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(le.getProxy(a.MainContext.MainThreadTreeViews),gt,ye)),ai=le.set(a.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(le.getProxy(a.MainContext.MainThreadEditorInsets),Rt,pe)),Yt=le.set(a.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(le,ye,be)),zt=le.set(a.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(le,Tt,gt.converter,ct)),vt=le.set(a.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(le,ct,Tt,gt,Yt,ye,et)),li=le.set(a.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(le,vt)),Mt=le.set(a.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(le,ye,bt)),jt=le.set(a.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(le,xe,gt)),Jt=le.set(a.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(le,gt,ye)),ci=le.set(a.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(le,gt,Tt)),fi=le.set(a.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(le.getProxy(a.MainContext.MainThreadProgress))),Ei=le.set(a.ExtHostContext.ExtHosLabelService,new K.ExtHostLabelService(le)),mi=le.set(a.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(le)),Zt=le.set(a.ExtHostContext.ExtHostAuthentication,new ve.ExtHostAuthentication(le)),_i=le.set(a.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(le,gt)),qt=le.set(a.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(le,{remote:pe.remote},xe,ye,et)),Gt=le.set(a.ExtHostContext.ExtHostWebviewPanels,new it.ExtHostWebviewPanels(le,qt,xe)),Si=le.set(a.ExtHostContext.ExtHostCustomEditors,new ut.ExtHostCustomEditors(le,Tt,ae,qt,Gt)),Ci=le.set(a.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(le,qt)),Kt=le.set(a.ExtHostContext.ExtHostTesting,new wt.ExtHostTesting(le,gt)),yi=le.set(a.ExtHostContext.ExtHostUriOpeners,new ee.ExtHostUriOpeners(le));le.set(a.ExtHostContext.ExtHostInteractive,new Te.ExtHostInteractive(le,St,bt,gt));const ei=(0,j.values)(a.ExtHostContext);le.assertRegistered(ei);const Di=new st.ExtHostBulkEdits(le,bt),ki=new f.ExtHostClipboard(le),ui=new h.ExtHostMessageService(le,ye),ti=new l.ExtHostDialogs(le),gi=new $.ExtHostStatusBar(le,gt.converter);return w.ExtHostApiCommands.register(gt),function(Ne,Ot,pi){const pt=function(){let ie=!Ne.isUnderDevelopment;function fe(){ie||(ye.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Re(ht){if(Array.isArray(ht))ht.forEach(Re);else if(typeof ht=="string")fe();else{const Dt=ht;typeof Dt.scheme=="undefined"&&fe(),typeof Dt.exclusive=="boolean"&&(0,we.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return ht}}(),ii={getSession(ie,fe,Re){return Zt.getSession(Ne,ie,fe,Re)},async hasSession(ie,fe){return(0,we.checkProposedApiEnabled)(Ne,"authSession"),!!await Zt.getSession(Ne,ie,fe,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Re,ht){return Zt.registerAuthenticationProvider(ie,fe,Re,ht)}},Ii={registerCommand(ie,fe,Re){return gt.registerCommand(!0,ie,fe,Re,void 0,Ne)},registerTextEditorCommand(ie,fe,Re){return gt.registerCommand(!0,ie,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){ye.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Dt.edit(It=>{fe.apply(Re,[Dt,It,...ht])}).then(It=>{It||ye.warn("Edits from command "+ie+" were not applied.")},It=>{ye.warn("An error occurred while running command "+ie,It)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ie,fe,Re)=>((0,we.checkProposedApiEnabled)(Ne,"diffCommand"),gt.registerCommand(!0,ie,async(...ht)=>{const Dt=bt.activeEditor(!0);if(!Dt){ye.warn("Cannot execute "+ie+" because there is no active text editor.");return}const It=await Rt.getDiffInformation(Dt.id);fe.apply(Re,[It,...ht])},void 0,void 0,Ne)),executeCommand(ie,...fe){return gt.executeCommand(ie,...fe)},getCommands(ie=!1){return gt.getCommands(ie)}},vi={get machineId(){return pe.telemetryInfo.machineId},get sessionId(){return pe.telemetryInfo.sessionId},get language(){return pe.environment.appLanguage},get appName(){return pe.environment.appName},get appRoot(){return pe.environment.appRoot?.fsPath??""},get appHost(){return pe.environment.appHost},get uriScheme(){return pe.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return Xe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Xe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(pe.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,fe){return qe.openUri(ie,{allowTunneling:!!pe.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===pe.environment.appUriScheme)return xt.createAppUri(ie);try{return await qe.asExternalUri(ie,{allowTunneling:!!pe.remote.authority})}catch(fe){if((0,Ue.matchesScheme)(ie,ke.Schemas.http)||(0,Ue.matchesScheme)(ie,ke.Schemas.https))return ie;throw fe}},get remoteName(){return(0,he.getRemoteName)(pe.remote.authority)},get remoteAuthority(){return(0,we.checkProposedApiEnabled)(Ne,"resolvers"),pe.remote.authority},get uiKind(){return pe.uiKind}};pe.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=pe.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pi={createTestController(ie,fe){return Kt.createTestController(ie,fe)},createTestObserver(){return(0,we.checkProposedApiEnabled)(Ne,"testObserver"),Kt.createTestObserver()},runTests(ie){return(0,we.checkProposedApiEnabled)(Ne,"testObserver"),Kt.runTests(ie)},get onDidChangeTestResults(){return(0,we.checkProposedApiEnabled)(Ne,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,we.checkProposedApiEnabled)(Ne,"testObserver"),Kt.results}},Ti={getExtension(ie){const fe=Ot.getExtensionDescription(ie);if(fe)return new i.Extension(Qe,Ne.identifier,fe,wi)},get all(){return Ot.getAllExtensionDescriptions().map(ie=>new i.Extension(Qe,Ne.identifier,ie,wi))},get onDidChange(){return Ot.onDidChange}},Ai={createDiagnosticCollection(ie){return Yt.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:ie=>Yt.getDiagnostics(ie),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(ie,fe){return zt.changeLanguage(ie.uri,fe)},match(ie,fe){return(0,T.score)(W.LanguageSelector.from(ie),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(ie,fe,Re){return vt.registerCodeActionProvider(Ne,pt(ie),fe,Re)},registerCodeLensProvider(ie,fe){return vt.registerCodeLensProvider(Ne,pt(ie),fe)},registerDefinitionProvider(ie,fe){return vt.registerDefinitionProvider(Ne,pt(ie),fe)},registerDeclarationProvider(ie,fe){return vt.registerDeclarationProvider(Ne,pt(ie),fe)},registerImplementationProvider(ie,fe){return vt.registerImplementationProvider(Ne,pt(ie),fe)},registerTypeDefinitionProvider(ie,fe){return vt.registerTypeDefinitionProvider(Ne,pt(ie),fe)},registerHoverProvider(ie,fe){return vt.registerHoverProvider(Ne,pt(ie),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ie,fe){return vt.registerEvaluatableExpressionProvider(Ne,pt(ie),fe,Ne.identifier)},registerInlineValuesProvider(ie,fe){return vt.registerInlineValuesProvider(Ne,pt(ie),fe,Ne.identifier)},registerDocumentHighlightProvider(ie,fe){return vt.registerDocumentHighlightProvider(Ne,pt(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return vt.registerLinkedEditingRangeProvider(Ne,pt(ie),fe)},registerReferenceProvider(ie,fe){return vt.registerReferenceProvider(Ne,pt(ie),fe)},registerRenameProvider(ie,fe){return vt.registerRenameProvider(Ne,pt(ie),fe)},registerDocumentSymbolProvider(ie,fe,Re){return vt.registerDocumentSymbolProvider(Ne,pt(ie),fe,Re)},registerWorkspaceSymbolProvider(ie){return vt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,fe){return vt.registerDocumentFormattingEditProvider(Ne,pt(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return vt.registerDocumentRangeFormattingEditProvider(Ne,pt(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Re,...ht){return vt.registerOnTypeFormattingEditProvider(Ne,pt(ie),fe,[Re].concat(ht))},registerDocumentSemanticTokensProvider(ie,fe,Re){return vt.registerDocumentSemanticTokensProvider(Ne,pt(ie),fe,Re)},registerDocumentRangeSemanticTokensProvider(ie,fe,Re){return vt.registerDocumentRangeSemanticTokensProvider(Ne,pt(ie),fe,Re)},registerSignatureHelpProvider(ie,fe,Re,...ht){return typeof Re=="object"?vt.registerSignatureHelpProvider(Ne,pt(ie),fe,Re):vt.registerSignatureHelpProvider(Ne,pt(ie),fe,typeof Re=="undefined"?[]:[Re,...ht])},registerCompletionItemProvider(ie,fe,...Re){return vt.registerCompletionItemProvider(Ne,pt(ie),fe,Re)},registerInlineCompletionItemProvider(ie,fe){return(0,we.checkProposedApiEnabled)(Ne,"inlineCompletions"),vt.registerInlineCompletionsProvider(Ne,pt(ie),fe)},registerDocumentLinkProvider(ie,fe){return vt.registerDocumentLinkProvider(Ne,pt(ie),fe)},registerColorProvider(ie,fe){return vt.registerColorProvider(Ne,pt(ie),fe)},registerFoldingRangeProvider(ie,fe){return vt.registerFoldingRangeProvider(Ne,pt(ie),fe)},registerSelectionRangeProvider(ie,fe){return vt.registerSelectionRangeProvider(Ne,ie,fe)},registerCallHierarchyProvider(ie,fe){return vt.registerCallHierarchyProvider(Ne,ie,fe)},registerTypeHierarchyProvider(ie,fe){return vt.registerTypeHierarchyProvider(Ne,ie,fe)},setLanguageConfiguration:(ie,fe)=>vt.setLanguageConfiguration(Ne,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,we.checkProposedApiEnabled)(Ne,"tokenInformation"),zt.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return(0,we.checkProposedApiEnabled)(Ne,"inlayHints"),vt.registerInlayHintsProvider(Ne,ie,fe)},createLanguageStatusItem(ie,fe){return(0,we.checkProposedApiEnabled)(Ne,"languageStatus"),zt.createLanguageStatusItem(Ne,ie,fe)}},Ri={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ie,fe,Re){const ht=await(n.URI.isUri(ie)?Promise.resolve(ni.openTextDocument(ie)):Promise.resolve(ie));return Rt.showTextDocument(ht,fe,Re)},createTextEditorDecorationType(ie){return Rt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,fe,Re){return Rt.onDidChangeActiveTextEditor(ie,fe,Re)},onDidChangeVisibleTextEditors(ie,fe,Re){return Rt.onDidChangeVisibleTextEditors(ie,fe,Re)},onDidChangeTextEditorSelection(ie,fe,Re){return Rt.onDidChangeTextEditorSelection(ie,fe,Re)},onDidChangeTextEditorOptions(ie,fe,Re){return Rt.onDidChangeTextEditorOptions(ie,fe,Re)},onDidChangeTextEditorVisibleRanges(ie,fe,Re){return Rt.onDidChangeTextEditorVisibleRanges(ie,fe,Re)},onDidChangeTextEditorViewColumn(ie,fe,Re){return Rt.onDidChangeTextEditorViewColumn(ie,fe,Re)},onDidCloseTerminal(ie,fe,Re){return Et.onDidCloseTerminal(ie,fe,Re)},onDidOpenTerminal(ie,fe,Re){return Et.onDidOpenTerminal(ie,fe,Re)},onDidChangeActiveTerminal(ie,fe,Re){return Et.onDidChangeActiveTerminal(ie,fe,Re)},onDidChangeTerminalDimensions(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"terminalDimensions"),Et.onDidChangeTerminalDimensions(ie,fe,Re)},onDidChangeTerminalState(ie,fe,Re){return Et.onDidChangeTerminalState(ie,fe,Re)},onDidWriteTerminalData(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),Et.onDidWriteTerminalData(ie,fe,Re)},get state(){return qe.state},onDidChangeWindowState(ie,fe,Re){return qe.onDidChangeWindowState(ie,fe,Re)},showInformationMessage(ie,...fe){return ui.showMessage(Ne,C.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return ui.showMessage(Ne,C.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return ui.showMessage(Ne,C.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Re){return Array.isArray(ie)&&ie.some(ht=>ht.kind!==void 0)&&(0,we.checkProposedApiEnabled)(Ne,"quickPickSeparators"),jt.showQuickPick(ie,fe,Re)},showWorkspaceFolderPick(ie){return jt.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return jt.showInput(ie,fe)},showOpenDialog(ie){return ti.showOpenDialog(ie)},showSaveDialog(ie){return ti.showSaveDialog(ie)},createStatusBarItem(ie,fe,Re){let ht,Dt,It;return typeof ie=="string"?(ht=ie,Dt=fe,It=Re):(Dt=ie,It=fe),gi.createStatusBarEntry(Ne,ht,Dt,It)},setStatusBarMessage(ie,fe){return gi.setStatusBarMessage(ie,fe)},withScmProgress(ie){return et.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fi.withProgress(Ne,{location:U.ProgressLocation.SourceControl},(fe,Re)=>ie({report(ht){}}))},withProgress(ie,fe){return fi.withProgress(Ne,ie,fe)},createOutputChannel(ie){return At.createOutputChannel(ie,Ne)},createWebviewPanel(ie,fe,Re,ht){return Gt.createWebviewPanel(Ne,ie,fe,Re,ht)},createWebviewTextEditorInset(ie,fe,Re,ht){return(0,we.checkProposedApiEnabled)(Ne,"editorInsets"),ai.createWebviewEditorInset(ie,fe,Re,ht,Ne)},createTerminal(ie,fe,Re){return typeof ie=="object"?("location"in ie&&(0,we.checkProposedApiEnabled)(Ne,"terminalLocation"),"pty"in ie?Et.createExtensionTerminal(ie):Et.createTerminalFromOptions(ie)):Et.createTerminal(ie,fe,Re)},registerTerminalLinkProvider(ie){return Et.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return Et.registerProfileProvider(Ne,ie,fe)},registerTreeDataProvider(ie,fe){return Xt.registerTreeDataProvider(ie,fe,Ne)},createTreeView(ie,fe){return Xt.createTreeView(ie,fe,Ne)},registerWebviewPanelSerializer:(ie,fe)=>Gt.registerWebviewPanelSerializer(Ne,ie,fe),registerCustomEditorProvider:(ie,fe,Re={})=>Si.registerCustomEditorProvider(Ne,ie,fe,Re),registerFileDecorationProvider(ie){return kt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return xt.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return jt.createQuickPick(Ne)},createInputBox(){return jt.createInputBox(Ne.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Re){return mi.onDidChangeActiveColorTheme(ie,fe,Re)},registerWebviewViewProvider(ie,fe,Re){return Ci.registerWebviewViewProvider(Ne,ie,fe,Re?.webviewOptions)},get activeNotebookEditor(){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeActiveNotebookEditor(ie,fe,Re)},get visibleNotebookEditors(){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(ie,fe,Re)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(ie,fe,Re)},showNotebookDocument(ie,fe){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"externalUriOpener"),yi.registerExternalUriOpener(Ne.identifier,ie,fe,Re)},get tabs(){return(0,we.checkProposedApiEnabled)(Ne,"tabs"),_t.tabs},get activeTab(){return(0,we.checkProposedApiEnabled)(Ne,"tabs"),_t.activeTab},get onDidChangeTabs(){return(0,we.checkProposedApiEnabled)(Ne,"tabs"),_t.onDidChangeTabs},get onDidChangeActiveTab(){return(0,we.checkProposedApiEnabled)(Ne,"tabs"),_t.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,we.checkProposedApiEnabled)(Ne,"inlineCompletions"),d.InlineCompletionController.get(ie)}},ni={get rootPath(){return et.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return xe.getWorkspaceFolder(ie)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(ie){throw L.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,fe,...Re)=>xe.updateWorkspaceFolders(Ne,ie,fe||0,...Re),onDidChangeWorkspaceFolders:function(ie,fe,Re){return xe.onDidChangeWorkspace(ie,fe,Re)},asRelativePath:(ie,fe)=>xe.getRelativePath(ie,fe),findFiles:(ie,fe,Re,ht)=>xe.findFiles(W.GlobPattern.from(ie),W.GlobPattern.from(fe),Re,Ne.identifier,ht),findTextInFiles:(ie,fe,Re,ht)=>{(0,we.checkProposedApiEnabled)(Ne,"findTextInFiles");let Dt,It;return typeof fe=="object"?(Dt=fe,It=Re):(Dt={},It=fe,ht=Re),xe.findTextInFiles(ie,Dt||{},It,Ne.identifier,ht)},saveAll:ie=>xe.saveAll(ie),applyEdit(ie){return Di.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,fe,Re,ht)=>Mt.createFileSystemWatcher(W.GlobPattern.from(ie),fe,Re,ht),get textDocuments(){return Tt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let fe;const Re=ie;if(typeof ie=="string")fe=Promise.resolve(n.URI.file(ie));else if(n.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Re||typeof Re=="object")fe=Tt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ht=>Tt.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(ie,fe,Re)=>Tt.onDidAddDocument(ie,fe,Re),onDidCloseTextDocument:(ie,fe,Re)=>Tt.onDidRemoveDocument(ie,fe,Re),onDidChangeTextDocument:(ie,fe,Re)=>Tt.onDidChangeDocument(ie,fe,Re),onDidSaveTextDocument:(ie,fe,Re)=>Tt.onDidSaveDocument(ie,fe,Re),onWillSaveTextDocument:(ie,fe,Re)=>Ht.getOnWillSaveTextDocumentEvent(Ne)(ie,fe,Re),get notebookDocuments(){return St.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Re;if(n.URI.isUri(ie))Re=ie,await St.openNotebookDocument(ie);else if(typeof ie=="string")Re=n.URI.revive(await St.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Re,ht){return St.registerNotebookSerializer(Ne,ie,fe,Re,(0,we.isProposedApiEnabled)(Ne,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(ie,fe,Re,ht)=>((0,we.checkProposedApiEnabled)(Ne,"notebookContentProvider"),St.registerNotebookContentProvider(Ne,ie,fe,Re,(0,we.isProposedApiEnabled)(Ne,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(ie,fe,Re)=>pi.onDidChangeConfiguration(ie,fe,Re),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,pi.getConfiguration(ie,fe,Ne)},registerTextDocumentContentProvider(ie,fe){return Bt.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(et.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ie,fe)),registerFileSystemProvider(ie,fe,Re){return(0,Ce.combinedDisposable)(li.registerFileSystemProvider(Ne,ie,fe,Re),Fe.addFileSystemProvider(ie,fe))},get fs(){return Fe.value},registerFileSearchProvider:(ie,fe)=>((0,we.checkProposedApiEnabled)(Ne,"fileSearchProvider"),Lt.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,we.checkProposedApiEnabled)(Ne,"textSearchProvider"),Lt.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,we.checkProposedApiEnabled)(Ne,"resolvers"),Qe.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,we.checkProposedApiEnabled)(Ne,"resolvers"),Ei.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,fe,Re)=>Mt.onDidCreateFile(ie,fe,Re),onDidDeleteFiles:(ie,fe,Re)=>Mt.onDidDeleteFile(ie,fe,Re),onDidRenameFiles:(ie,fe,Re)=>Mt.onDidRenameFile(ie,fe,Re),onWillCreateFiles:(ie,fe,Re)=>Mt.getOnWillCreateFileEvent(Ne)(ie,fe,Re),onWillDeleteFiles:(ie,fe,Re)=>Mt.getOnWillDeleteFileEvent(Ne)(ie,fe,Re),onWillRenameFiles:(ie,fe,Re)=>Mt.getOnWillRenameFileEvent(Ne)(ie,fe,Re),openTunnel:ie=>((0,we.checkProposedApiEnabled)(Ne,"resolvers"),Le.openTunnel(Ne,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,we.checkProposedApiEnabled)(Ne,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(ie,fe,Re)=>((0,we.checkProposedApiEnabled)(Ne,"resolvers"),Le.onDidChangeTunnels(ie,fe,Re)),registerPortAttributesProvider:(ie,fe)=>((0,we.checkProposedApiEnabled)(Ne,"portsAttributes"),Le.registerPortsAttributesProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,we.checkProposedApiEnabled)(Ne,"timeline"),_i.registerTimelineProvider(ie,fe,Ne.identifier,gt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:ie=>((0,we.checkProposedApiEnabled)(Ne,"workspaceTrust"),xe.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Re)=>xe.onDidGrantWorkspaceTrust(ie,fe,Re)},Li={get inputBox(){return et.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ne)},createSourceControl(ie,fe,Re){return Jt.createSourceControl(Ne,ie,fe,Re)}},Fi={createCommentController(ie,fe){return ci.createCommentController(Ne,ie,fe)}},Mi={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},onDidStartDebugSession(ie,fe,Re){return Ct.onDidStartDebugSession(ie,fe,Re)},onDidTerminateDebugSession(ie,fe,Re){return Ct.onDidTerminateDebugSession(ie,fe,Re)},onDidChangeActiveDebugSession(ie,fe,Re){return Ct.onDidChangeActiveDebugSession(ie,fe,Re)},onDidReceiveDebugSessionCustomEvent(ie,fe,Re){return Ct.onDidReceiveDebugSessionCustomEvent(ie,fe,Re)},onDidChangeBreakpoints(ie,fe,Re){return Ct.onDidChangeBreakpoints(ie,fe,Re)},registerDebugConfigurationProvider(ie,fe,Re){return Ct.registerDebugConfigurationProvider(ie,fe,Re||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return Ct.registerDebugAdapterDescriptorFactory(Ne,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return Ct.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Ct.startDebugging(ie,fe,{parentSession:Re}):Ct.startDebugging(ie,fe,Re||{})},stopDebugging(ie){return Ct.stopDebugging(ie)},addBreakpoints(ie){return Ct.addBreakpoints(ie)},removeBreakpoints(ie){return Ct.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return Ct.asDebugSourceUri(ie,fe)}},Oi={registerTaskProvider:(ie,fe)=>yt.registerTaskProvider(Ne,ie,fe),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Ne,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,fe,Re)=>yt.onDidStartTask(ie,fe,Re),onDidEndTask:(ie,fe,Re)=>yt.onDidEndTask(ie,fe,Re),onDidStartTaskProcess:(ie,fe,Re)=>yt.onDidStartTaskProcess(ie,fe,Re),onDidEndTaskProcess:(ie,fe,Re)=>yt.onDidEndTaskProcess(ie,fe,Re)},Ni={createNotebookController(ie,fe,Re,ht,Dt){return si.createNotebookController(Ne,ie,fe,Re,ht,(0,we.isProposedApiEnabled)(Ne,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>St.registerNotebookCellStatusBarItemProvider(Ne,ie,fe),get onDidSaveNotebookDocument(){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return oi.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(ie,fe,Re)},onDidChangeNotebookCells(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeNotebookCells(ie,fe,Re)},onDidChangeNotebookCellExecutionState(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),St.onDidChangeNotebookCellExecutionState(ie,fe,Re)},onDidChangeCellOutputs(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeCellOutputs(ie,fe,Re)},onDidChangeCellMetadata(ie,fe,Re){return(0,we.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeCellMetadata(ie,fe,Re)},createConcatTextDocument(ie,fe){return(0,we.checkProposedApiEnabled)(Ne,"notebookConcatTextDocument"),new je.ExtHostNotebookConcatDocument(St,Tt,ie,fe)}};return{version:pe.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:y.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:a.UIKind,Uri:n.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=oe}),define(me[274],ge([0,1,83,132,35,130,36,38,46,34,70,55,72,92,52,65,133,66,45,91,121,54,131,12,226]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p,l,r,g,o,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(b.ILoggerService,o.ExtHostLoggerService),(0,m.registerSingleton)(b.ILogService,i.ExtHostLogService),(0,m.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(n.IExtHostConfiguration,n.ExtHostConfiguration),(0,m.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,m.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,m.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage),(0,m.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,m.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,m.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,m.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,m.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,m.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(me[93],ge([0,1,17,12,33,69]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function n(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=n;function k(I,a,w,f){const v=(0,m.mapArrayOrNot)(w,S),_=new D.TextSearchMatch(a,v,f),P=_.preview.matches;return{ranges:(0,m.mapArrayOrNot)(v,y),uri:I,preview:{text:_.preview.text,matches:(0,m.mapArrayOrNot)(P,y)}}}e.createTextSearchResult=k;function S(I){return new D.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function y(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let T=class{constructor(a,w){this.prefix=a,this.logService=w}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};T=Ve([We(1,L.ILogService)],T),e.OutputChannel=T}),define(me[275],ge([0,1,96,22]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(b=>b===o)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,n=512,k=512*8,S=512*128;class y{constructor(b){this.iconvLiteDecoder=b}static async create(b){let i;if(b!==e.UTF8)i=(await new Promise((c,d)=>{Y(["iconv-lite-umd"],c,d)})).getDecoder(w(b));else{const t=new TextDecoder;i={write(c){return t.decode(c,{stream:!0})},end(){return t.decode()}}}return new y(i)}write(b){return this.iconvLiteDecoder.write(b)}end(){return this.iconvLiteDecoder.end()}}function T(o,b){const i=b.minBytesRequiredForDetection??b.guessEncoding?k:n;return new Promise((t,c)=>{const d=(0,m.newWriteableStream)(A=>A.join("")),s=[];let h=0,u;const E=async()=>{try{const A=await g({buffer:L.VSBuffer.concat(s),bytesRead:h},b.guessEncoding);A.encoding=await b.overwriteEncoding(A.encoding),u=await y.create(A.encoding);const R=u.write(L.VSBuffer.concat(s).buffer);d.write(R),s.length=0,h=0,t({stream:d,detected:A})}catch(A){c(A)}};(0,m.listenStream)(o,{onData:async A=>{u?d.write(u.write(A.buffer)):(s.push(A),h+=A.byteLength,h>=i&&(o.pause(),await E(),setTimeout(()=>o.resume())))},onError:A=>d.error(A),onEnd:async()=>{u||await E(),d.end(u?.end())}})})}e.toDecodeStream=T;async function I(o,b,i){const c=(await new Promise((h,u)=>{Y(["iconv-lite-umd"],h,u)})).getEncoder(w(b),i);let d=!1,s=!1;return{read(){if(s)return null;const h=o.read();if(typeof h!="string"){if(s=!0,!d&&i?.addBOM)switch(b){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=c.end();return u&&u.length>0?(d=!0,L.VSBuffer.wrap(u)):null}return d=!0,L.VSBuffer.wrap(c.write(h))}}}e.toEncodeReadable=I;async function a(o){return(await new Promise((i,t)=>{Y(["iconv-lite-umd"],i,t)})).encodingExists(w(o))}e.encodingExists=a;function w(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=w;function f(o,b){if(!o||b<e.UTF16be_BOM.length)return null;const i=o.readUInt8(0),t=o.readUInt8(1);if(i===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(b<e.UTF8_BOM.length)return null;const c=o.readUInt8(2);return i===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=f;const v=["ascii","utf-16","utf-32"];async function _(o){const b=await new Promise((s,h)=>{Y(["jschardet"],s,h)}),i=o.slice(0,S),t=l(i.buffer),c=b.detect(t);if(!c||!c.encoding)return null;const d=c.encoding.toLowerCase();return 0<=v.indexOf(d)?null:p(c.encoding)}const P={ibm866:"cp866",big5:"cp950"};function p(o){const b=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[b]||b}function l(o){let b="";for(let i=0;i<o.length;i++)b+=String.fromCharCode(o[i]);return b}function r(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const b=o.match(/windows(\d+)/);return b?"windows-"+b[1]:o}}e.toCanonicalName=r;function g({buffer:o,bytesRead:b},i){let t=f(o,b),c=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&o){let d=!0,s=!0,h=!1;for(let u=0;u<b&&u<C;u++){const E=u%2==1,A=o.readUInt8(u)===0;if(A&&(h=!0),d&&(E&&!A||!E&&A)&&(d=!1),s&&(E&&A||!E&&!A)&&(s=!1),A&&!d&&!s)break}h&&(d?t=e.UTF16le:s?t=e.UTF16be:c=!0)}return i&&!c&&!t&&o?_(o.slice(0,b)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:c,encoding:t}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[135],ge([0,1,275,28,134]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends D.TextSearchManager{constructor(k,S,y=L,T="searchProcess"){super(k,S,{readdir:I=>y.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,m.toCanonicalName)(I)},T)}}e.NativeTextSearchManager=C}),define(me[276],ge([0,1,277,291,292,2,293]),function(Y,e,m,L,D,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(I,a,w,f,v,_){const P=_.environment.useHostProxy,p=typeof P=="boolean"?P:!_.remote.isRemote,l=(0,n.createProxyResolver)({resolveProxy:g=>I.resolveProxy(g),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(g,o,...b)=>{switch(g){case n.LogLevel.Trace:f.trace(o,...b);break;case n.LogLevel.Debug:f.debug(o,...b);break;case n.LogLevel.Info:f.info(o,...b);break;case n.LogLevel.Warning:f.warn(o,...b);break;case n.LogLevel.Error:f.error(o,...b);break;case n.LogLevel.Critical:f.critical(o,...b);break;case n.LogLevel.Off:break;default:i(g,o,b);break}function i(t,c,...d){f.error("Unknown log level",t),f.error(c,...d)}},getLogLevel:()=>f.getLevel(),proxyResolveTelemetry:g=>{v.$publicLog2("resolveProxy",g)},useHostProxy:p,env:process.env}),r=S(a,l);return T(w,r)}e.connectProxyResolver=k;function S(I,a){const w={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(v=>{w.config=I.getConfiguration("http").get("proxySupport")||"off"});const f={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(v=>{f.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,n.createHttpPatch)(m,a,{config:"off"},f,!0)),on:Object.assign({},m,(0,n.createHttpPatch)(m,a,{config:"on"},f,!0)),override:Object.assign({},m,(0,n.createHttpPatch)(m,a,{config:"override"},f,!0)),onRequest:Object.assign({},m,(0,n.createHttpPatch)(m,a,w,f,!0)),default:Object.assign(m,(0,n.createHttpPatch)(m,a,w,f,!1))},https:{off:Object.assign({},L,(0,n.createHttpPatch)(L,a,{config:"off"},f,!0)),on:Object.assign({},L,(0,n.createHttpPatch)(L,a,{config:"on"},f,!0)),override:Object.assign({},L,(0,n.createHttpPatch)(L,a,{config:"override"},f,!0)),onRequest:Object.assign({},L,(0,n.createHttpPatch)(L,a,w,f,!0)),default:Object.assign(L,(0,n.createHttpPatch)(L,a,w,f,!1))},tls:Object.assign(D,(0,n.createTlsPatch)(D))}}const y=new Map;function T(I,a){return I.getExtensionPathIndex().then(w=>{const f=Y.__$__nodeRequire("module"),v=f._load;f._load=function(P,p,l){if(P==="tls")return a.tls;if(P!=="http"&&P!=="https")return v.apply(this,arguments);const r=a[P],g=w.findSubstr(C.URI.file(p.filename));let o=y.get(g);if(o||y.set(g,o={}),!o[P]){let b=r.default;o[P]={...b}}return o[P]}})}}),define(me[278],ge([0,1,37,9,79,30,11,8,93,279]),function(Y,e,m,L,D,C,n,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(l,r,g,o){const b=a(l,r,g,o),i=r.folder.fsPath;return{cmd:m.spawn(T,b.args,{cwd:i}),rgDiskPath:T,siblingClauses:b.siblingClauses,rgArgs:b,cwd:i}}e.spawnRipgrepCmd=I;function a(l,r,g,o){const b=["--files","--hidden","--case-sensitive"];f([r],g,!1).forEach(t=>{const c=(0,S.anchorGlob)(t);if(b.push("-g",c),n.isMacintosh){const d=(0,D.normalizeNFD)(c);d!==c&&b.push("-g",d)}});const i=w([r],o,void 0,!1);return i.globArgs.forEach(t=>{const c=`!${(0,S.anchorGlob)(t)}`;if(b.push("-g",c),n.isMacintosh){const d=(0,D.normalizeNFD)(c);d!==c&&b.push("-g",d)}}),r.disregardIgnoreFiles!==!1?b.push("--no-ignore"):b.push("--no-ignore-parent"),r.ignoreSymlinks||b.push("--follow"),l.exists&&b.push("--quiet"),b.push("--no-config"),r.disregardGlobalIgnoreFiles&&b.push("--no-ignore-global"),{args:b,siblingClauses:i.siblingClauses}}function w(l,r,g,o=!0){const b=[];let i={};return l.forEach(t=>{const c=Object.assign({},t.excludePattern||{},r||{}),d=v(c,o?t.folder.fsPath:void 0,g);b.push(...d.globArgs),d.siblingClauses&&(i=Object.assign(i,d.siblingClauses))}),{globArgs:b,siblingClauses:i}}e.foldersToRgExcludeGlobs=w;function f(l,r,g=!0){const o=[];return l.forEach(b=>{const i=Object.assign({},r||{},b.includePattern||{}),t=v(i,g?b.folder.fsPath:void 0);o.push(...t.globArgs)}),o}e.foldersToIncludeGlobs=f;function v(l,r,g){const o=[],b={};return Object.keys(l).forEach(i=>{if(g&&g.has(i)||!i)return;const t=l[i];i=P(r?_(r,i):i),i.startsWith("\\\\")?i="\\\\"+i.substr(2).replace(/\\/g,"/"):i=i.replace(/\\/g,"/"),typeof t=="boolean"&&t?(i.startsWith("\\\\")&&(i+="**"),o.push(p(i))):t&&t.when&&(b[i]=t)}),{globArgs:o,siblingClauses:b}}function _(l,r){return L.isAbsolute(r)?r:L.join(l,r)}e.getAbsoluteGlob=_;function P(l){return l=k.rtrim(l,"\\"),k.rtrim(l,"/")}function p(l){return C.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=p}),define(me[280],ge([0,1,37,60,9,104,17,51,31,79,30,11,47,8,13,28,33,278,101]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(i=>i())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&S.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&S.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(c=>{const d=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),s=c.folder.fsPath;t.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==s).forEach(h=>{(0,T.isEqualOrParent)(h,s)&&(d[D.relative(s,h)]=!0)}),this.folderExcludePatterns.set(s,new o(d,s))})}cancel(){this.isCanceled=!0,l.forEach(t=>t())}walk(t,c,d,s,h){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);c.forEach(u=>{const E=D.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,E)||this.matchFile(d,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(t,(u,E)=>{this.call(this.cmdTraversal,this,u,d,s,A=>{if(A){const R=(0,k.toErrorMessage)(A);console.error(R),this.errors.push(R),E(A,void 0)}else E(null,void 0)})},(u,E)=>{this.fileWalkSW.stop();const A=u?n.coalesce(u)[0]:null;h(A,this.isLimitHit)})}parallel(t,c,d){const s=new Array(t.length),h=new Array(t.length);let u=!1,E=0;if(t.length===0)return d(null,[]);t.forEach((A,R)=>{c(A,($,N)=>{if($?(u=!0,s[R]=null,h[R]=$):(s[R]=N,h[R]=null),++E===t.length)return d(u?h:null,s)})})}call(t,c,...d){try{t.apply(c,d)}catch(s){d[d.length-1](s)}}cmdTraversal(t,c,d,s){const h=t.folder.fsPath,u=I.isMacintosh;let E;const A=()=>E&&E.kill();l.add(A);let R=U=>{l.delete(A),R=()=>{},s(U)},$="";const N=this.initDirectoryTree();let F;const z=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);E=z.cmd,F=!Object.keys(z.siblingClauses).length;const M=z.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let W=`${z.rgDiskPath} ${M}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),d({message:W}),this.cmdResultCount=0,this.collectStdout(E,"utf8",d,(U,x,B)=>{if(U){R(U);return}if(this.isLimitHit){R();return}const H=($+(u?y.normalizeNFC(x||""):x)).split(`
`);if(B){const j=H.length;H[j-1]=H[j-1].trim(),H[j-1]||H.pop()}else $=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,F){for(const j of H)if(this.matchFile(c,{base:h,relativePath:j,searchPath:this.getSearchPath(t,j)}),this.isLimitHit){A();break}(B||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,N,h,H,c),B&&(this.matchDirectoryTree(N,h,c),R())})}spawnFindCmd(t){const c=this.folderExcludePatterns.get(t.folder.fsPath),d=c.getBasenameTerms(),s=c.getPathTerms(),h=["-L","."];if(d.length||s.length){h.push("-not","(","(");for(const u of d)h.push("-name",u),h.push("-o");for(const u of s)h.push("-path",u),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),m.spawn("find",h,{cwd:t.folder.fsPath})}readStdout(t,c,d){let s="";this.collectStdout(t,c,()=>{},(h,u,E)=>{if(h){d(h);return}s+=u,E&&d(null,s)})}collectStdout(t,c,d,s){let h=(A,R,$)=>{(A||$)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),s(A,R,$)},u=!1;t.stdout?(this.forwardData(t.stdout,c,h),t.stdout.once("data",()=>u=!0)):d({message:"stdout is null"});let E;t.stderr?E=this.collectData(t.stderr):d({message:"stderr is null"}),t.on("error",A=>{h(A)}),t.on("close",A=>{let R;!u&&(R=this.decodeData(E,c))&&b(R)?h(new Error(`command failed with error code ${A}: ${this.decodeData(E,c)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(t,c,d){const s=new C.StringDecoder(c);return t.on("data",h=>{d(null,s.write(h))}),s}collectData(t){const c=[];return t.on("data",d=>{c.push(d)}),c}decodeData(t,c){const d=new C.StringDecoder(c);return t.map(s=>d.write(s)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:c},d,s,h){s.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const u=E=>{const A=D.basename(E),R=D.dirname(E);let $=c[R];$||($=c[R]=[],u(R)),$.push({base:d,relativePath:E,basename:A,searchPath:this.getSearchPath(t,E)})};s.forEach(u)}matchDirectoryTree({rootEntries:t,pathToEntries:c},d,s){const h=this,u=this.folderExcludePatterns.get(d),E=this.filePattern;function A(R){h.directoriesWalked++;const $=S.hasSiblingFn(()=>R.map(N=>N.basename));for(let N=0,F=R.length;N<F;N++){const z=R[N],{relativePath:M,basename:W}=z;if(u.test(M,W,E!==W?$:void 0))continue;const U=c[M];if(U)A(U);else{if(h.filesWalked++,M===E)continue;h.matchFile(s,z)}if(h.isLimitHit)break}}A(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,c,d,s,h){const u=t.folder,E=S.hasSiblingFn(()=>d);this.parallel(d,(A,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const $=c?[c,A].join(D.sep):A;if(this.folderExcludePatterns.get(t.folder.fsPath).test($,A,this.config.filePattern!==A?E:void 0))return R(null);const N=[u.fsPath,$].join(D.sep);L.lstat(N,(F,z)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(N,z,(M,W)=>M||this.isCanceled||this.isLimitHit?R(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,z,(U,x)=>U||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?R(null):(this.walkedPaths[x]=!0,v.Promises.readdir(N).then(B=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,$,B,s,O=>R(O||null))},B=>{R(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&f.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(s,{base:u.fsPath,relativePath:$,searchPath:this.getSearchPath(t,$)}),R(null,void 0)))})},A=>{const R=A&&n.coalesce(A);return h(R&&R.length>0?R[0]:void 0)})}matchFile(t,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,D.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(c))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,c,d){return c.isSymbolicLink()?L.stat(t,d):d(null,c)}realPathIfNeeded(t,c,d){return c.isSymbolicLink()?L.realpath(t,(s,h)=>s?d(s):d(null,h)):d(null,t)}getSearchPath(t,c){return t.folderName?D.join(t.folderName,c):c}}e.FileWalker=r;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,c,d){this.walker.walk(this.folderQueries,this.extraFiles,t,c,(s,h)=>{d(s,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class o{constructor(t,c){this.expression=t,this.root=c,this.init(t)}init(t){let c,d;Object.keys(t).filter(s=>t[s]).forEach(s=>{D.isAbsolute(s)?(c=c||S.getEmptyExpression(),c[s]=t[s]):(d=d||S.getEmptyExpression(),d[s]=t[s])}),this.absoluteParsedExpr=c&&S.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(t,c,d){return this.relativeParsedExpr&&this.relativeParsedExpr(t,c,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,t),c,d)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getPathTerms(this.relativeParsedExpr)),t}}function b(i){const t=i.trim().split(`
`),c=t[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return w.uppercaseFirstLetter(t[t.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}e.rgErrorMsgForDisplay=b}),define(me[136],ge([0,1,37,294,104,17,73,31,9,8,2,33,69,295,279,93]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=f.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(u){this.outputChannel=u}provideTextSearchResults(u,E,A,R){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise(($,N)=>{R.onCancellationRequested(()=>O());const F=b(u,E),z=E.folder.fsPath,M=F.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${_} ${M}
 - cwd: ${z}`);let W=m.spawn(_,F,{cwd:z});W.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),N((0,I.serializeSearchError)(new I.SearchError(he&&he.message,I.SearchErrorCode.rgProcessError)))});let U=!1;const x=new r(E.maxResults,z,E.previewOptions);x.on("result",he=>{U=!0,j="",A.report(he)});let B=!1;const O=()=>{B=!0,W&&W.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,O()});let j="";W.stdout.on("data",he=>{x.handleData(he),U||(j+=he)});let X=!1;W.stdout.once("data",()=>X=!0);let K="";W.stderr.on("data",he=>{const Ee=he.toString();this.outputChannel.appendLine(Ee),K+=Ee}),W.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),j&&this.outputChannel.appendLine(`Got data without result: ${j}`),this.outputChannel.appendLine(""),B)$({limitHit:H});else{x.flush(),W=null;let he;K&&!X&&(he=p(K))?N((0,I.serializeSearchError)(new I.SearchError(he.message,he.code))):$({limitHit:H})}})})}}e.RipgrepTextSearchEngine=P;function p(h){const u=h.split(`
`),E=u[0].trim();if(u.some(R=>R.startsWith("regex parse error")))return new I.SearchError(l(u),I.SearchErrorCode.regexParseError);const A=E.match(/grep config error: unknown encoding: (.*)/);if(A)return new I.SearchError(`Unknown encoding: ${A[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function l(h){const u=["Regex parse error"],E=h.filter(A=>A.startsWith("PCRE2:"));if(E.length>=1){const A=E[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const R=A.split(":")[1];u.push(":"+R)}}return u.join("")}e.buildRegexParseError=l;class r extends L.EventEmitter{constructor(u,E,A){super();this.maxResults=u,this.rootFolder=E,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,E){return super.on(u,E),this}handleData(u){if(this.isDone)return;const E=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(E)}handleDecodedData(u){let E=u.indexOf(`
`);const A=this.remainder+u;if(E>=0)E+=this.remainder.length;else{this.remainder=A;return}let R=0;for(;E>=0;)this.handleLine(A.substring(R,E).trim()),R=E+1,E=A.indexOf(`
`,R);this.remainder=A.substring(R)}handleLine(u){if(this.isDone||!u)return;let E;try{E=JSON.parse(u)}catch(A){throw new Error(`malformed line from rg: ${u}`)}if(E.type==="match"){const A=g(E.data.path),R=T.URI.file(S.join(this.rootFolder,A)),$=this.createTextSearchMatch(E.data,R);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const A=g(E.data.path),R=T.URI.file(S.join(this.rootFolder,A));this.createTextSearchContext(E.data,R).forEach(N=>this.onResult(N))}}createTextSearchMatch(u,E){const A=u.line_number-1,R=g(u.lines),$=Buffer.from(R);let N=0,F=0,z=A;u.submatches.length===0&&u.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(u.submatches.map((W,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=g(W.match),B=$.slice(N,W.start).toString().length,O=F+B,H=o(x),j=z,X=H.numLines+j,K=H.numLines>0?H.lastLineLength:H.lastLineLength+O;return N=W.end,F=K,z=X,new a.Range(j,O,X,K)}));return(0,v.createTextSearchResult)(E,R,M,this.previewOptions)}createTextSearchContext(u,E){const A=g(u.lines),R=u.line_number;return A.replace(/\r?\n$/,"").split(`
`).map(($,N)=>({text:$,uri:E,lineNumber:R+N}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=r;function g(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function o(h){const u=/\n/g;let E=0,A=-1,R;for(;R=u.exec(h);)E++,A=R.index;const $=A>=0?h.length-A-1:h.length;return{numLines:E,lastLineLength:$}}function b(h,u){const E=["--hidden"];E.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:R}=(0,n.groupBy)(u.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const N=new Set;R.forEach(F=>{N.add(F)}),E.push("-g","!*"),N.forEach(F=>{i(F).map(v.anchorGlob).forEach(z=>{E.push("-g",z)})})}A&&A.length&&A.forEach(N=>{E.push("-g",N)}),u.excludes.map(v.anchorGlob).forEach(N=>E.push("-g",`!${N}`)),u.maxFileSize&&E.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?E.push("--no-ignore-parent"):E.push("--no-ignore"),u.followSymlinks&&E.push("--follow"),u.encoding&&u.encoding!=="utf8"&&E.push("--encoding",u.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,y.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),u.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),h.isRegExp&&(h.pattern=t(h.pattern),E.push("--auto-hybrid-regex"));let $;if(h.isWordMatch){const F=(0,y.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(h.isRegExp){let N=d(h.pattern);N=s(N),E.push("--regexp",N)}else $=h.pattern,E.push("--fixed-strings");return E.push("--no-config"),u.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),h.isMultiline&&E.push("--multiline"),u.beforeContext&&E.push("--before-context",u.beforeContext+""),u.afterContext&&E.push("--after-context",u.afterContext+""),E.push("--"),$&&E.push($),E.push("."),E}function i(h){const u=(0,k.splitGlobAware)(h,"/");return u.map((E,A)=>u.slice(0,A+1).join("/"))}e.spreadGlobComponents=i;function t(h){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(u);)h=h.replace(u,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(E);)h=h.replace(E,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=t;const c=h=>h.type==="Assertion"&&h.kind==="lookbehind";function d(h){let u;try{u=new w.RegExpParser().parsePattern(h)}catch{return h}let E="",A=0;const R=(F,z,M)=>{E+=h.slice(A,F)+M,A=z},$=[];return new w.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const z=$[0];if(!z)R(F.start,F.end,"\\r?\\n");else if(!$.some(c))if(z.type==="CharacterClass")if(z.negate){const M=h.slice(z.start+2,F.start)+h.slice(F.end,z.end-1);if(z.parent?.type==="Quantifier"){const W=z.parent;R(W.start,W.end,(M?`[^${M}]`:".")+(W.greedy?"+":"*"))}else R(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=h.slice(z.start+1,F.start)+h.slice(F.end,z.end-1);R(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){$.unshift(F)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(F){$.unshift(F)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(F){$.unshift(F)},onCharacterClassLeave(){$.shift()},onAssertionEnter(F){c(F)&&$.push(F)},onAssertionLeave(F){$[0]===F&&$.shift()}}).visit(u),E+=h.slice(A),E}e.fixRegexNewline=d;function s(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=s}),define(me[281],ge([0,1,21,136,117,10]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class n{constructor(y){this.outputChannel=y,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(y,T,I,a){const w=new L.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===C.Schemas.userData){const f={...T,folder:T.folder.with({scheme:C.Schemas.file})},v=new D.Progress(_=>I.report({..._,uri:_.uri.with({scheme:T.folder.scheme})}));return this.withToken(a,_=>w.provideTextSearchResults(y,f,v,_))}else return this.withToken(a,f=>w.provideTextSearchResults(y,T,I,f))}async withToken(y,T){const I=k(y);this.inProgress.add(I);const a=await T(I.token);return this.inProgress.delete(I),a}dispose(){this.inProgress.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=n;function k(S){const y=new m.CancellationTokenSource;return S.onCancellationRequested(()=>y.cancel()),y}}),define(me[282],ge([0,1,28,136,135]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,y,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(w){T({message:w})}},a=new D.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),m);return new Promise((w,f)=>a.search(v=>{y(v.map(n))},S).then(v=>w({limitHit:v.limitHit,type:"success",stats:v.stats}),f))}}e.TextSearchEngineAdapter=C;function n(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,y)=>{if(y.ranges){const T=y;return S+(Array.isArray(T.ranges)?T.ranges.length:1)}else return S+1},0)}}}),define(me[283],ge([0,1,17,18,15,3,101,9,47,2,42,33,280,282]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class f{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let g;const o=P(r),b=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(i=>this.doFileSearchWithEngine(a.Engine,o,t=>b.fire(t),i)),g.then(i=>b.fire(i),i=>b.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return b.event}textSearch(r){let g;const o=P(r),b=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(i=>this.ripgrepTextSearch(o,t=>b.fire(t),i)),g.then(i=>b.fire(i),i=>b.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return b.event}ripgrepTextSearch(r,g,o){return r.maxFileSize=(0,T.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(r).search(o,g,g)}doFileSearch(r,g,o){return this.doFileSearchWithEngine(a.Engine,r,g,o)}doFileSearchWithEngine(r,g,o,b,i=f.BATCH_SIZE){let t=0;const c=s=>{Array.isArray(s)?(t+=s.length,o(s.map(h=>this.rawMatchToSearchItem(h)))):s.relativePath?(t++,o(this.rawMatchToSearchItem(s))):o(s)};if(g.sortByScore){let s=this.trySortedSearchFromCache(g,c,b);if(!s){const h=g.maxResults?Object.assign({},g,{maxResults:null}):g,u=new r(h);s=this.doSortedSearch(u,g,o,c,b)}return new Promise((h,u)=>{s.then(([E,A])=>{const R=A.map($=>this.rawMatchToSearchItem($));this.sendProgress(R,o,i),h(E)},u)})}const d=new r(g);return this.doSearch(d,c,i,b).then(s=>({limitHit:s.limitHit,type:"success",stats:{detailStats:s.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,g,o,b,i){const t=new C.Emitter;let c=(0,L.createCancelablePromise)(s=>{let h=[];const u=E=>{Array.isArray(E)?h=E:(b(E),t.fire(E))};return this.doSearch(r,u,-1,s).then(E=>[E,h])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const s={promise:c,event:t.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=s,c.then(()=>{s.resolved=!0},h=>{delete d.resultsToSearchCache[g.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([s,h])=>{const u=d?d.scorerCache:Object.create(null),E=(typeof g.maxResults!="number"||g.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(g,h,u,i).then(A=>{const R=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:s.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:A.length},messages:s.messages,limitHit:s.limitHit||typeof g.maxResults=="number"&&h.length>g.maxResults},A]})})}getOrCreateCache(r){const g=this.caches[r];return g||(this.caches[r]=new v)}trySortedSearchFromCache(r,g,o){const b=r.cacheKey&&this.caches[r.cacheKey];if(!b)return;const i=this.getResultsFromCache(b,r.filePattern||"",g,o);if(i)return i.then(([t,c,d])=>{const s=S.StopWatch.create(!1);return this.sortResults(r,c,b.scorerCache,o).then(h=>{const u=s.elapsed(),E={fromCache:!0,detailStats:d,type:this.processType,resultCount:c.length,sortingTime:u};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:E},h]})})}sortResults(r,g,o,b){const i=(0,n.prepareQuery)(r.filePattern||""),t=(d,s)=>(0,n.compareItemsByFuzzyScore)(d,s,i,!0,_,o),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,c,1e4,b)}sendProgress(r,g,o){if(o&&o>0)for(let b=0;b<r.length;b+=o)g(r.slice(b,b+o));else g(r)}getResultsFromCache(r,g,o,b){const i=S.StopWatch.create(!1),t=g.indexOf(k.sep)>=0;let c;for(const u in r.resultsToSearchCache)if(g.startsWith(u)){if(t&&u.indexOf(k.sep)<0&&u!=="")continue;const E=r.resultsToSearchCache[u];c={promise:this.preventCancellation(E.promise),event:E.event,resolved:E.resolved};break}if(!c)return null;const d=i.elapsed(),s=S.StopWatch.create(!1),h=c.event(o);return b&&b.onCancellationRequested(()=>{h.dispose()}),c.promise.then(([u,E])=>{if(b&&b.isCancellationRequested)throw(0,D.canceled)();const A=[],R=(0,n.prepareQuery)(g).normalizedLowercase;for(const $ of E)!(0,I.isFilePatternMatch)($,R)||A.push($);return[u,A,{cacheWasResolved:c.resolved,cacheLookupTime:d,cacheFilterTime:s.elapsed(),cacheEntryCount:E.length}]})}doSearch(r,g,o,b){return new Promise((i,t)=>{let c=[];b&&b.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(o?(c.push(d),o>0&&c.length>=o&&(g(c),c=[])):g(d))},d=>{g(d)},(d,s)=>{c.length&&g(c),d?t(d):i(s)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,o){return r.then(g,o)}catch(g){return this.then(void 0,g)}finally(g){return r.finally(g)}}}}e.SearchService=f,f.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(l){return(0,k.basename)(l.relativePath)}getItemDescription(l){return(0,k.dirname)(l.relativePath)}getItemPath(l){return l.relativePath}};function P(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(p),extraFileResources:l.extraFileResources&&l.extraFileResources.map(r=>y.URI.revive(r))}}function p(l){return{...l,folder:y.URI.revive(l.folder)}}}),define(me[284],ge([0,1,6,10,2,28,12,26,14,72,64,33,283,281,93,135]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends y.ExtHostSearch{constructor(p,l,r,g){super(p,r,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new f.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new w.RipgrepSearchProvider(o)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new f.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new w.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(L.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,l){const r=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(p,l,r,g){const o=(0,y.reviveQuery)(r);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,l,o,g):super.$provideFileSearchResults(p,l,r,g)}doInternalFileSearch(p,l,r,g){const o=b=>{if((0,I.isSerializedFileMatch)(b)&&(b=[b]),Array.isArray(b)){this._proxy.$handleFileMatch(p,l,b.map(i=>D.URI.file(i.path)));return}b.message&&this._logService.debug("ExtHostSearch",b.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,o,g)}$clearCache(p){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,l){return new v.NativeTextSearchManager(p,l,void 0,"textSearchProvider")}};_=Ve([We(0,S.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,T.IURITransformerService),We(3,n.ILogService)],_),e.NativeExtHostSearch=_}),define(me[137],ge([0,1,296,124,81,22,15,3,6,9,11,32,106,107,297]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(s){this.socket=s,this._errorListener=h=>{if(h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(s){const h=u=>s(C.VSBuffer.wrap(u));return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(s){const h=u=>{s({type:0,hadError:u,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(s){return this.socket.on("end",s),{dispose:()=>this.socket.off("end",s)}}write(s){if(!this.socket.destroyed)try{this.socket.write(s.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}}end(){this.socket.end()}drain(){return new Promise((s,h)=>{if(this.socket.bufferSize===0){s();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),s()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=v;var _;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var P;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(P||(P={}));class p extends S.Disposable{constructor(s,h,u,E){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=h,this._recordInflateBytes=E,h?(this._zlibInflate=f.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,n.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,n.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this._onData.event(s)}onClose(s){return this._onClose.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this._totalOutgoingDataBytes+=s.byteLength,this._zlibDeflate?(this._zlibDeflate.write(s.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let h=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.length-4),this._isEnded||this._write(C.VSBuffer.wrap(h),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(s,!1)}_write(s,h){let u=2;s.byteLength<126?u+=0:s.byteLength<2**16?u+=2:u+=8;const E=C.VSBuffer.alloc(u);if(h?E.writeUInt8(194,0):E.writeUInt8(130,0),s.byteLength<126)E.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){E.writeUInt8(126,1);let A=1;E.writeUInt8(s.byteLength>>>8&255,++A),E.writeUInt8(s.byteLength>>>0&255,++A)}else{E.writeUInt8(127,1);let A=1;E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(s.byteLength>>>24&255,++A),E.writeUInt8(s.byteLength>>>16&255,++A),E.writeUInt8(s.byteLength>>>8&255,++A),E.writeUInt8(s.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=E.byteLength+s.byteLength,this.socket.write(C.VSBuffer.concat([E,s]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(s){if(s.byteLength!==0){for(this._totalIncomingWireBytes+=s.byteLength,this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),u=h.readUInt8(0),E=(u&128)>>>7,A=(u&64)>>>6,R=h.readUInt8(1),$=(R&128)>>>7,N=R&127;this._state.state=2,this._state.readLen=2+($?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(A)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),u=h.readUInt8(1),E=(u&128)>>>7;let A=u&127,R=1;A===126?A=h.readUInt8(++R)*2**8+h.readUInt8(++R):A===127&&(A=h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*2**24+h.readUInt8(++R)*2**16+h.readUInt8(++R)*2**8+h.readUInt8(++R));let $=0;E&&($=h.readUInt8(++R)*2**24+h.readUInt8(++R)*2**16+h.readUInt8(++R)*2**8+h.readUInt8(++R)),this._state.state=3,this._state.readLen=A,this._state.mask=$}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);l(h,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(h.buffer)),this._zlibInflate.write(h.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(C.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=h.byteLength,this._onData.fire(h))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=p;function l(d,s){if(s===0)return;let h=d.byteLength>>>2;for(let N=0;N<h;N++){const F=d.readUInt32BE(N*4);d.writeUInt32BE(F^s,N*4)}let u=h*4,E=d.byteLength-u;const A=s>>>24&255,R=s>>>16&255,$=s>>>8&255;E>=1&&d.writeUInt8(d.readUInt8(u)^A,u),E>=2&&d.writeUInt8(d.readUInt8(u+1)^R,u+1),E>=3&&d.writeUInt8(d.readUInt8(u+2)^$,u+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function g(){const d=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):s=(0,y.join)((0,D.tmpdir)(),`vscode-ipc-${d}.sock`),b(s),s}e.createRandomIPCHandle=g;function o(d,s,h){const u=(0,m.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${h}-${s}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${h}-${s}.sock`):E=(0,y.join)(d,`${h}-${s}.sock`),b(E),E}e.createStaticIPCHandle=o;function b(d){const s=r[T.platform];typeof s=="number"&&d.length>=s&&console.warn(`WARNING: IPC handle "${d}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends a.IPCServer{constructor(s){super(i.toClientConnectionEvent(s));this.server=s}static toClientConnectionEvent(s){const h=k.Event.fromNodeEventEmitter(s,"connection");return k.Event.map(h,u=>({protocol:new w.Protocol(new v(u)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function t(d){return new Promise((s,h)=>{const u=(0,L.createServer)();u.on("error",h),u.listen(d,()=>{u.removeListener("error",h),s(new i(u))})})}e.serve=t;function c(d,s){return new Promise((h,u)=>{const E=(0,L.createConnection)(d,()=>{E.removeListener("error",u),h(w.Client.fromSocket(new v(E),s))});E.once("error",u)})}e.connect=c}),define(me[285],ge([0,1,137,277,60,38,2,197,12]),function(Y,e,m,L,D,C,n,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(a,w,f){this._commands=a,this.logService=w,this._ipcHandlePath=f,this._server=L.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(w.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,w){const f=[];a.setEncoding("utf8"),a.on("data",v=>f.push(v)),a.on("end",()=>{const v=JSON.parse(f.join(""));switch(v.type){case"open":this.open(v,w);break;case"openExternal":this.openExternal(v,w);break;case"status":this.getStatus(v,w);break;case"extensionManagement":this.manageExtensions(v,w).catch(this.logService.error);break;default:w.writeHead(404),w.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),w.end();break}})}open(a,w){const{fileURIs:f,folderURIs:v,forceNewWindow:_,diffMode:P,addMode:p,forceReuseWindow:l,gotoLineMode:r,waitMarkerFilePath:g,remoteAuthority:o}=a,b=[];if(Array.isArray(v))for(const d of v)try{b.push({folderUri:n.URI.parse(d)})}catch(s){}if(Array.isArray(f))for(const d of f)try{(0,k.hasWorkspaceFileExtension)(d)?b.push({workspaceUri:n.URI.parse(d)}):b.push({fileUri:n.URI.parse(d)})}catch(s){}const i=g?n.URI.file(g):void 0,c={forceNewWindow:_,diffMode:P,addMode:p,gotoLineMode:r,forceReuseWindow:l,preferNewWindow:!l&&!i&&!p,waitMarkerFileURI:i,remoteAuthority:o};this._commands.executeCommand("_remoteCLI.windowOpen",b,c),w.writeHead(200),w.end()}async openExternal(a,w){for(const f of a.uris){const v=n.URI.parse(f),_=v.scheme==="file"?v:f;await this._commands.executeCommand("_remoteCLI.openExternal",_)}w.writeHead(200),w.end()}async manageExtensions(a,w){try{const f=P=>P?.map(p=>/\.vsix$/i.test(p)?n.URI.parse(p):p),v={list:a.list,install:f(a.install),uninstall:f(a.uninstall),force:a.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);w.writeHead(200),w.write(_)}catch(f){w.writeHead(500),w.write(String(f),v=>{v&&this.logService.error(v)})}w.end()}async getStatus(a,w){try{const f=await this._commands.executeCommand("_remoteCLI.getSystemStatus");w.writeHead(200),w.write(f),w.end()}catch(f){w.writeHead(500),w.write(String(f),v=>{v&&this.logService.error(v)}),w.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=y;let T=class extends y{constructor(a,w){super(a,w,(0,m.createRandomIPCHandle)())}};T=Ve([We(0,C.IExtHostCommands),We(1,S.ILogService)],T),e.CLIServer=T}),define(me[286],ge([0,1,71,273,268,5,276,39,258,2,10,7,285,105]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends D.RequireInterceptor{_installInterceptor(){const P=this,p=Y.__$__nodeRequire("module"),l=p._load;p._load=function(g,o,b){for(let i of P._alternatives){let t=i(g);if(t){g=t;break}}return P._factories.has(g)?P._factories.get(g).load(g,y.URI.file((0,w.realpathSync)(o.filename)),i=>l.apply(this,[i,o,b])):l.apply(this,arguments)}}}class v extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(f,P,this._registry).install(),m.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,n.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const r=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?r.apply(process,o):(g.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,p,l){if(p.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let r=null;l.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{P&&m.mark(`code/extHost/willLoadExtensionCode/${P.value}`),r=Y.__$__nodeRequire(p.fsPath)}catch(g){return Promise.reject(g)}finally{P&&m.mark(`code/extHost/didLoadExtensionCode/${P.value}`),l.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const p in P){const l=P[p];l===null?delete process.env[p]:process.env[p]=l}}}e.ExtHostExtensionService=v}),define(me[287],ge([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,12]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(T.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(p.ILoggerService,P.ExtHostLoggerService),(0,m.registerSingleton)(v.IExtensionStoragePaths,_.ExtensionStoragePaths),(0,m.registerSingleton)(y.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(I.IExtHostSearch,n.NativeExtHostSearch),(0,m.registerSingleton)(a.IExtHostTask,D.ExtHostTask),(0,m.registerSingleton)(w.IExtHostTerminalService,L.ExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,S.ExtHostTunnelService)}),define(me[288],ge([0,1,124,298,71,15,107,137,190,224,271,22,103,28,105,18,114,274,287]),function(Y,e,m,L,D,C,n,k,S,y,T,I,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),c=t._load;t._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return c.apply(this,arguments)}})();const p=process.exit.bind(process);function l(t){process.exit=function(c){if(t)p(c);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)}}let r=function(t){p()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,c)=>{let d=null,s=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,u=3e5,E=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),h),A=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),u);process.on("message",($,N)=>{if($&&$.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from($.initialDataChunk,"base64"));let z;if($.skipWebSocketFrames)z=new k.NodeSocket(N);else{const M=I.VSBuffer.wrap(Buffer.from($.inflateBytes,"base64"));z=new k.WebSocketNodeSocket(new k.NodeSocket(N),$.permessageDeflate,M,!1)}d?(E.cancel(),A.cancel(),d.beginAcceptReconnection(z,F),d.endAcceptReconnection()):(clearTimeout(s),d=new n.PersistentProtocol(z,F),d.onDidDispose(()=>r("renderer disconnected")),t(d),d.onSocketClose(()=>{E.schedule()}))}if($&&$.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;E.isScheduled()&&A.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((c,d)=>{const s=m.createConnection(t,()=>{s.removeListener("error",d),c(new n.PersistentProtocol(new k.NodeSocket(s)))});s.once("error",d),s.on("close",()=>{r("renderer closed the socket")})})}}async function o(){const t=await g();return new class{constructor(){this._onMessage=new n.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(c=>{(0,y.isMessageOfType)(c,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(c)})}send(c){this._terminating||t.send(c)}drain(){return t.drain()}}}function b(t){return new Promise(c=>{const d=t.onMessage(s=>{d.dispose();const h=JSON.parse(s.toString()),u=h.commit,E=S.default.commit;u&&E&&u!==E&&p(55);let A=0;setInterval(function(){try{process.kill(h.parentPid,0),A=0}catch($){$&&$.code==="EPERM"?(A++,A>=3&&r(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):r(`parent process ${h.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let R;try{R=Y.__$__nodeRequire("native-watchdog"),R.start(h.parentPid)}catch($){(0,C.onUnexpectedError)($)}t.send((0,y.createMessageOfType)(0)),c({protocol:t,initData:h})});t.send((0,y.createMessageOfType)(1))})}async function i(){const t=[];process.on("unhandledRejection",(A,R)=>{t.push(R),setTimeout(()=>{const $=t.indexOf(R);$>=0&&R.catch(N=>{t.splice($,1),(0,C.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),A&&(0,C.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const R=t.indexOf(A);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(A){(0,C.onUnexpectedError)(A)}),D.mark("code/extHost/willConnectToRenderer");const c=await o();D.mark("code/extHost/didConnectToRenderer");const d=await b(c);D.mark("code/extHost/didWaitForInitData");const{initData:s}=d;l(!!s.environment.extensionTestsLocationURI),s.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,s.environment.skipWorkspaceStorageLock=(0,_.boolean)(P.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(R){p(R)}exists(R){return w.Promises.exists(R)}realpath(R){return(0,f.realpath)(R)}};let u=null;if(s.remote.authority&&P.uriTransformerPath)try{const R=Y.__$__nodeRequire(P.uriTransformerPath)(s.remote.authority);u=new a.URITransformer(R)}catch(A){console.error(A)}const E=new T.ExtensionHostMain(d.protocol,s,h,u);r=A=>E.terminate(A)}e.startExtensionHostProcess=i}),define(me[299],ge([0,1,288]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ed3018f4310e906daa0a9119d997e75b8a38b879/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
